Imports System.Resources
Imports System.Globalization
Imports System.Threading

Public Class BaseClassUC
    Inherits System.Web.UI.UserControl

    Private objRm As New ResourceManager("CRAVDataBaseAccess.crav", System.Reflection.Assembly.GetExecutingAssembly)

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        Dim strLanguage As String = Session("language")
        Thread.CurrentThread.CurrentUICulture = GetCultureInfo()
    End Sub

    Public Function GetCultureInfo() As System.Globalization.CultureInfo
        Dim strLanguage As String = Me.Session("language")
        If IsNothing(Session("language")) Then
            strLanguage = ConfigurationSettings.AppSettings("DefaultLanguage")
        End If
        Return New CultureInfo(strLanguage)
    End Function


    '   get the session culture name
    Public Function GetCulture() As String
        Return Me.GetCultureInfo.Name
    End Function


    Public Function GetLabel(ByVal strLabel As String) As String
        Try
            Return objRm.GetString(strLabel)
        Catch ex As Exception
            Response.Write("<script language=javascript>window.alert('" & strLabel & " no traduzido!');</script>")
        End Try
    End Function


    Public Sub GetThread()
        Thread.CurrentThread.CurrentUICulture = GetCultureInfo()
    End Sub


    Public Function GetConfig(ByVal strKey As String) As String
        Return ConfigurationSettings.AppSettings(strKey)
    End Function


    Public Function TruncateUrl(ByVal url As String) As String
        Dim index As Integer = url.IndexOfAny("&")
        If index > 0 Then
            url = url.Remove(index, url.Length - index)
        End If
        Return url
    End Function

    Public Function RemoveQueryString(ByVal url As String, ByVal str As String, ByVal len As Integer) As String
        Dim index As Integer = url.IndexOf(str)
        If index > 0 Then
            url = url.Remove(index, len)
        End If
        Return url
    End Function

    '============= PROPERTIES =========================================
    Public Property ConsultationRequest() As ConsultationRequest
        Get
            Return Session("ConsultationRequest")
        End Get
        Set(ByVal Value As ConsultationRequest)
            Session("ConsultationRequest") = Value
        End Set
    End Property

    Public Property ReservationRequest() As ReservationRequest
        Get
            Return Session("ReservationRequest")
        End Get
        Set(ByVal Value As ReservationRequest)
            Session("ReservationRequest") = Value
        End Set
    End Property

    Public Property ReproductionRequest() As ReproductionRequest
        Get
            Return Session("ReproductionRequest")
        End Get
        Set(ByVal Value As ReproductionRequest)
            Session("ReproductionRequest") = Value
        End Set
    End Property


    'Public Property DigitarqInfo() As DigitarqInfo
    '    Get
    '        Return Session("DigitarqInfo")
    '    End Get
    '    Set(ByVal Value As DigitarqInfo)
    '        Session("DigitarqInfo") = Value
    '    End Set
    'End Property


    Public Property ListDocs() As DataTable
        Get
            Return Session("ListDocs")
        End Get
        Set(ByVal Value As DataTable)
            Session("ListDocs") = Value
        End Set
    End Property


    Public Property ListServices() As DataTable
        Get
            Return Session("ListServices")
        End Get
        Set(ByVal Value As DataTable)
            Session("ListServices") = Value
        End Set
    End Property


    Public Property ErrorDetails() As String
        Get
            Return Session("ErrorDetails")
        End Get
        Set(ByVal Value As String)
            Session("ErrorDetails") = Value
        End Set
    End Property


    Public Property Path() As Path
        Get
            If Not Session("Path") Is Nothing Then
                Return Session("Path")
            Else
                Response.Write("<script language=javascript>window.alert('A sua sesso expirou...');</script>")
                Response.Redirect(GetConfig("LogoutUrl"))
            End If
        End Get
        Set(ByVal Value As Path)
            Session("Path") = Value
        End Set
    End Property

End Class
