Imports System.Collections
Imports System.Collections.Specialized
Imports CRAVDataBaseAccess
Imports DigitArq.Utility

Public Module mShowItems

    Private objI As New SQLDataBase

    '*************************************************************************************************
    ' Function: strWriteTextLine
    ' Purpose:  It returns the Html tags which shows, on a line, the description of a db field and 
    '           filed database respective value.
    '           It is used to make the matriz image Metadata description page (used in ImageGOD.aspx)
    '***************************************************************************************************
    Public Function strWriteTextLine(ByVal strDescription As String, ByVal strSqlValue As String, ByVal strDimension As String) As String

        If strSqlValue.Trim = "" Then Return ""
        If strSqlValue = "0" Then Return ""
        strSqlValue = strSqlValue.Replace(ControlChars.NewLine, "</br>")
        Return "<font face=""Verdana, Arial, Helvetica, sans-serif"" color=""#000066"" size=""1"" >" & strDescription & ":  </font>" & _
               "<font face=""Verdana, Arial, Helvetica, sans-serif"" color=""#6666666"" size=""1"">" & strSqlValue & " " & strDimension & " </font></br>"
    End Function

    '*************************************************************************************************
    ' Function: strDraw3ColumnRow
    ' Purpose:  It returns the Html tags that draws a row with 3 columns.It is used for to list the search 
    '           results information.
    '           It is used in : ListShow.aspx; OrderByDate.aspx; OderByOtherLevel.aspx; OrderByTitle.aspx
    '***************************************************************************************************
    Public Function strDraw3ColumnRow(ByVal strExtra As String, ByVal strDescription As String, ByVal strSqlValue As String) As String
        If strSqlValue.Trim = "" Then Return ""
        Return "<tr width='450px'><td valign=top><font face='Verdana, Arial, Helvetica, sans-serif' color='#000066' size='1'><strong> " & strExtra & "</strong></font></td>" & _
               "<td align='left'width='140px' valign=top><font face='Verdana, Arial, Helvetica, sans-serif' color='#000066' size='1' >" & strDescription & "</font></td>" & _
               "<td align='left' colspan='3'valign=center><font face='Verdana, Arial, Helvetica, sans-serif' color='#666666' size='1'>" & strSqlValue & "</font></td></tr>"
    End Function

    Public Function strDraw3ColumnRowTitles(ByVal strExtra As String, ByVal strDescription As String, ByVal strValue As String, ByVal strSqlValue As String) As String
        If strSqlValue Is Nothing Or strSqlValue = "" Or strSqlValue = "-1" Then Return ""
        Return "<tr>" & _
                    "<td valign=top width='20px'>" & strExtra & "</td>" & _
                    "<td align='left'width='180px' valign=top class='TextBlack'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center class='TextDarkGray'>" & strValue & "</td>" & _
               "</tr>"
    End Function

    Public Function strDraw3ColumnRowTitles(ByVal strExtra As String, ByVal strDescription As String, ByVal strSqlValue As String) As String
        If strSqlValue Is Nothing Or strSqlValue = "" Or strSqlValue = "-1" Then Return ""
        Return "<tr>" & _
                    "<td valign=top width='20px'>" & strExtra & "</td>" & _
                    "<td align='left'width='180px' valign=top class='TextBlack'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center class='TextDarkGray'>" & strSqlValue & "</td>" & _
               "</tr>"
    End Function

    Public Function strDraw3ColumnRowTitles(ByVal strDescription As String, ByVal strSqlValue As String) As String
        If strSqlValue Is Nothing Then Return ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextBlack'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center class='TextDarkGray'>" & strSqlValue & "</td>" & _
               "</tr>"
    End Function

    Public Function strDrawRequestDetail(ByVal strDescription As String, ByVal strValue As String, ByVal strAux As String, Optional ByVal boolVisible As Boolean = True) As String
        If Not boolVisible Then Return ""
        If strValue Is Nothing Or strValue = "" Then strValue = strAux
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextBlack'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center class='TextDarkGray'>" & strValue & "</td>" & _
               "</tr>"
    End Function

    Public Function strDrawDate(ByVal strDescription As String, ByVal di As String, ByVal df As String, ByVal sep As String, ByVal strAux As String, Optional ByVal boolVisible As Boolean = True) As String
        Dim strValue As String
        If Not boolVisible Then Return ""
        If (di Is Nothing Or di = "") And (df Is Nothing Or df = "") Then
            strValue = strAux
        ElseIf (df Is Nothing Or df = "") Then
            strValue = di
        Else
            strValue = di + " " + sep + " " + df
        End If
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextBlack'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center class='TextDarkGray'>" & strValue & "</td>" & _
               "</tr>"
    End Function

    Public Function strSeparator(ByVal strSqlValue As String) As String
        If strSqlValue Is Nothing Then Return ""
        Return "<TR>" & _
                    "<TD class='vertical_spacer2' colSpan='3'></TD>" & _
               "</TR>"
    End Function

    Public Function strHeaderTable() As String
        Return "<table width=100% CellPadding=0 CellSpacing=0 border=0>"
    End Function

    Public Function strFooterTable() As String
        Return "</table>"
    End Function

    Public Function strCloseLine() As String
        Return "</td></tr>"
    End Function

    Public Function strHeaderDigitalObjectsLoc() As String
        Return "<tr><td colspan=3>" & _
                    "<table cellpadding=0 cellspacing=0 border=0 align=left>" & _
               "<tr valign=top align=center>"
    End Function

    Public Function strFooterDigitalObjectsLoc() As String
        Return "</tr>" & _
               "</table>" & _
               "</td></tr>"
    End Function

    '*************************************************************************************************
    ' Function: strDraw3ColumnRowForRA
    ' Purpose:  It returns the Html tag that draws a row with 3 columns. It is used for to add the 
    '           authority register link to the registers that have it.
    '           It is used in : ListShow.aspx; OrderByDate.aspx; OderByOtherLevel.aspx; OrderByTitle.aspx
    '***************************************************************************************************
    Public Function strDraw3ColumnRowForRA(ByVal strLink As String, ByVal blnEac As Boolean) As String
        If blnEac Then
            Return "<tr width='450px'><td valign=top></td>" & _
               "<td align='left'width='140px' valign=top><font face='Verdana, Arial, Helvetica, sans-serif' color='#666666' size='1'>" & strLink & "</font></td>" & _
               "<td align='left' colspan='3'valign=center></td></tr>"
        End If
        Return ""
    End Function

    Public Function strDraw3ColumnRowForRA(ByVal strDescription As String, ByVal strLink As String, ByVal blnEac As Boolean) As String
        If blnEac Then
            Return "<tr width='450px'><td valign=top></td>" & _
               "<td align='left'width='140px' valign=top><font face='Verdana, Arial, Helvetica, sans-serif' color='#000066' size='1'>" & strDescription & "</font></td>" & _
               "<td align='left' colspan='3'valign=center><font face='Verdana, Arial, Helvetica, sans-serif' color='#666666' size='1'>" & strLink & "</font></td></tr>"
        End If
        Return ""
    End Function

    '*************************************************************************************************
    ' Function: strDraw2ColumnRow
    ' Purpose:  It returns the Html tag that draws a row with 2 columns. It is used for to show all 
    '           the information related with the chosen register (unit).
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strDraw2ColumnRow(ByVal description As String, ByVal value As String) As String

        If value.Trim = "" Then Return ""
        If value = "0" Then Return ""
        value = value.Replace(ControlChars.NewLine, "</br>")
        Return "<tr width='450px'><td  width='140px' align='left' valign=top width='148'><font face='Verdana, Arial, Helvetica, sans-serif' color='#000066' size='1' >" & description & "</font></td>" & _
               "<td align='left'><p align='justify'> <font face='Verdana, Arial, Helvetica, sans-serif' color='#6666666' size='1'>" & value & "</font></p></td></tr>"
    End Function

    '*************************************************************************************************
    ' Function: strDraw2ColumnRowChangeLine
    ' Purpose:  It returns the Html 2 tags that draws a row with 2 columns each. It is used for to show
    '           the description and the bd value in separated lines.
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strDraw2ColumnRowChangeLine(ByVal strDescription As String, ByVal strSqlValue As String) As String
        If strSqlValue.Trim = "" Then Return ""
        If strSqlValue = "0" Then Return ""
        strSqlValue = strSqlValue.Replace(ControlChars.NewLine, "</br>")
        Return "<tr width='450px'><td align='left' colspan='2' valign='bottom'><font class='TextBlueBottom' >" & strDescription & "</font></td></tr>" & _
               "<tr width='450px'><td align='left' colspan='2' valign='top'><p align='justify'><font class='TextGrayTop'>" & strSqlValue & "<br></font></p></td></tr>"
    End Function

    '*************************************************************************************************
    ' Function: strAlert
    ' Purpose:  It returns the Html tag that draws a row with 3 columns. It is used for to show the
    '           image alert and description. 
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strAlert(ByVal strImageTag As String, ByVal blnValid As Boolean) As String

        If blnValid Then Return ""
        Return "<tr width='450px'><td colspan='2' align='left' valign=top><font face='Verdana, Arial, Helvetica, sans-serif' color='#000066' size='1' >" & strImageTag & "</font>" & _
               " <font face='Verdana, Arial, Helvetica, sans-serif' color='#cc3300' size='1'>Informao no tratada arquivisticamente</font></td></tr>"
    End Function

    Public Function strMsgError(ByVal strImageTag As String, ByVal blnValid As Boolean) As String

        If Not blnValid Then Return ""
        Return "<tr width='450px'><td colspan='3' align='center' valign=top><font face='Verdana, Arial, Helvetica, sans-serif' color='red' size='1' >" & strImageTag & "</font></td></tr>"
    End Function

    '*************************************************************************************************
    ' Function: strDimensions
    ' Purpose:  It returns the Html tag that draws a row with 2 columns. It is used to show the deminsions
    '           db value only for registers that are UI, D, DC. In other Levels this unit characteristics  
    '           doesnt make sence.
    '           It is used in : RegShow.aspx
    '***************************************************************************************************

    Public Function strDimensions(ByVal strOtherLevel As String, ByVal strDescription As String, ByVal strSqlValue As String) As String

        If strSqlValue.Trim = "" Then Return ""
        If strSqlValue = "0" Then Return ""
        If strOtherLevel.Equals("UI") Or strOtherLevel.Equals("D") Or strOtherLevel.Equals("DC") Then
            strSqlValue = strSqlValue.Replace(ControlChars.NewLine, "</br>")
            Return "<tr width='450px'><td  width='140px' align='left' valign=top width='148'><font face='Verdana, Arial, Helvetica, sans-serif' color='#000066' size='1' >" & strDescription & "</font></td>" & _
                   "<td align='left'><p align='justify'> <font face='Verdana, Arial, Helvetica, sans-serif' color='#6666666' size='1'>" & strSqlValue & "</font></p></td></tr>"
        Else : Return ""
        End If

    End Function


    Public Function strProfiles(ByVal colProfiles As Collection) As String
        Dim strRet As System.Text.StringBuilder
        strRet.Append("<table width=100%>")
        For i As Integer = 0 To colProfiles.Count - 1
            strRet.Append("<tr>")
            strRet.Append("<td width=20%><asp:</td>")
        Next
    End Function

    Public Function getProfile(ByVal strSqlValue As String) As String
        If strSqlValue Is Nothing Then Return "<i>No atribuido</i>"
        Return strSqlValue
    End Function


    Public Function GetDates(ByVal objDigitarqinfo As DigitarqInfo) As String
        If Not objDigitarqinfo Is Nothing Then
            If objDigitarqinfo.DigitalObjectExists Then
                Return strWriteDate(objDigitarqinfo.UnitDateInitialCertainty, objDigitarqinfo.UnitDateInitial, _
                    objDigitarqinfo.UnitDateFinalCertainty, objDigitarqinfo.UnitDateFinal)
            Else : Return ""
            End If
        End If
    End Function

    Public Function GetDaoGrp(ByVal DigitalObjectName As String, ByVal FileName As String, ByVal ArchiveID As String, ByVal TopographicalQuota As String) As String
        Return DigitalObjectName & " @ " & FileName & " @ " & ArchiveID & " @ " & TopographicalQuota
    End Function

    Public Function GetNotificationHeader(ByVal lblFrom As String, ByVal strFrom As String, ByVal lblDate As String, ByVal strDate As String, ByVal strNotification As String) As String
        If strNotification Is Nothing Or strNotification.Equals("") Then
            Return ""
        Else
            Return lblFrom & strFrom & vbNewLine & _
            lblDate & strDate & vbNewLine & vbNewLine & _
            strNotification
        End If
    End Function

    '*****************************************************************************************************
    ' Function: strAllFunctionsProfiles
    ' Purpose:  It returns the Html tag that draws a list of the all functions in the backoffice
    '           It is used in : 
    '*****************************************************************************************************

    'Public Function strAllProfileFunctions(Optional ByVal profileID As Integer = 0) As String
    '    Dim hshFunctions As New Hashtable
    '    hshFunctions = objI.getAllProfileFunctions(profileID, 0)
    '    Dim bool As Boolean
    '    Dim strRet As New System.Text.StringBuilder
    '    Dim functionName As String
    '    Dim exists As Boolean
    '    'Dim array(2) As String

    '    strRet.Append("<ul Class=""ontology"">")
    '    For Each key As Integer In hshFunctions.Keys
    '        functionName = hshFunctions(key)(0)
    '        bool = CBool(hshFunctions(key)(1))
    '        If bool Then
    '            strRet.Append("<li>")
    '            strRet.Append("<input type=""checkbox"" name=""functions"" checked value=""" & key & """ Class=""PFSelected"" onClick=""ec(this);"">" & functionName)
    '            strRet.Append("<ul class=""ontologyS"">")
    '        Else
    '            strRet.Append("<li>")
    '            strRet.Append("<input type=""checkbox"" name=""functions"" value=""" & key & """ Class=""PFUnselected"" onClick=""ec(this);"">" & functionName)
    '            strRet.Append("<ul class=""ontologySU"">")
    '        End If

    '        Dim hshSubFunctions As New Hashtable
    '        hshSubFunctions = objI.getAllProfileFunctions(profileID, key)
    '        For Each keySF As Integer In hshSubFunctions.Keys
    '            functionName = hshSubFunctions(keySF)(0)
    '            bool = CBool(hshSubFunctions(keySF)(1))
    '            If bool Then
    '                strRet.Append("<li>")
    '                strRet.Append("<input type=""checkbox"" name=""subFunctions"" checked value=""" & keySF & """ Class=""PFSelected"" onClick=""ec(this);"">" & functionName)
    '                strRet.Append("<ul class=""ontologyS"">")
    '            Else
    '                strRet.Append("<li>")
    '                strRet.Append("<input type=""checkbox"" name=""subFunctions"" value=""" & keySF & """ Class=""PFUnselected"" onClick=""ec(this);"">" & functionName)
    '                strRet.Append("<ul class=""ontologySU"">")
    '            End If
    '            Dim hshSubSubFunctions As New Hashtable
    '            hshSubSubFunctions = objI.getAllProfileFunctions(profileID, keySF)
    '            For Each keySSF As Integer In hshSubSubFunctions.Keys
    '                functionName = hshSubSubFunctions(keySSF)(0)
    '                bool = CBool(hshSubSubFunctions(keySSF)(1))
    '                strRet.Append("<li>")
    '                If bool Then
    '                    strRet.Append("<input type=""checkbox"" name=""subSubFunctions"" checked value=""" & keySSF & """ Class=""PSFSelected"">" & functionName)
    '                Else
    '                    strRet.Append("<input type=""checkbox"" name=""subSubFunctions"" value=""" & keySSF & """ Class=""PSFUnselected"">" & functionName)
    '                End If
    '                strRet.Append("</li>")
    '            Next
    '            strRet.Append("</ul>")
    '            strRet.Append("</li>")
    '        Next
    '        strRet.Append("</ul>")
    '        strRet.Append("</li>")
    '    Next
    '    strRet.Append("</ul>")
    '    Dim strReturn As String = strRet.ToString
    '    Return strReturn
    'End Function


    ''*****************************************************************************************************
    '' Function: strFunctionsMenu
    '' Purpose:  It returns the Html tag that draws a menu with the functions of the one profile
    ''           It is used in : 
    ''*****************************************************************************************************

    'Public Function strFunctionsMenu(Optional ByVal profileID As Integer = 0) As String

    '    Dim hshFunctions As New Hashtable
    '    Dim objFunction As New _Function
    '    hshFunctions = objI.getProfileFunctions(profileID, 0)

    '    Dim strRet As New System.Text.StringBuilder
    '    Dim top As Boolean = True
    '    Try
    '        For Each key As Integer In hshFunctions.Keys
    '            objFunction = hshFunctions(key)
    '            If top Then
    '                strRet.Append("<span class=""title"" id=""top"">")
    '            Else
    '                strRet.Append("<span class=""title"">")
    '            End If
    '            strRet.Append("<img src=""../Images/expanded.gif"" class=""arrow"" alt=""-"">")
    '            strRet.Append(objFunction.FunctionName)
    '            strRet.Append("</span>")
    '            strRet.Append("<div class=""submenu"">")

    '            Dim hshSubFunctions As New Hashtable
    '            hshSubFunctions = objI.getProfileFunctions(profileID, key)

    '            For Each keySF As Integer In hshSubFunctions.Keys
    '                objFunction = hshSubFunctions(keySF)
    '                strRet.Append("<a href=")
    '                strRet.Append(objFunction.Reference)
    '                strRet.Append(">")
    '                strRet.Append(objFunction.FunctionName)
    '                strRet.Append("</a>")
    '                strRet.Append(" ")
    '            Next
    '            strRet.Append("</div>")
    '            top = False
    '        Next
    '        Return strRet.ToString
    '    Catch ex As Exception
    '        Dim erro As String = ex.ToString
    '        Dim erro1 As String = "a"

    '    Finally

    '    End Try
    'End Function


    'Public Function strFunctionsHorizontalMenu(ByVal hash As Hashtable, ByVal qsMenu As String, Optional ByVal profileID As Integer = 0) As String

    '    Dim hshSubSubFunctions As Hashtable = hash
    '    Dim objFunction As New _Function
    '    Dim top As Boolean = True

    '    If hshSubSubFunctions.Count <= 1 Then
    '        Return ""
    '    End If
    '    Dim strRet As New System.Text.StringBuilder

    '    Try
    '        strRet.Append("<ul class=""basictab"">")
    '        For Each keySSF As Integer In hshSubSubFunctions.Keys
    '            objFunction = hshSubSubFunctions(keySSF)
    '            If objFunction.UserControl = qsMenu Then
    '                strRet.Append("<li class=""selected"">")
    '            Else
    '                strRet.Append("<li>")
    '            End If
    '            strRet.Append("<a href=")
    '            strRet.Append(objFunction.Reference)
    '            strRet.Append(">")
    '            strRet.Append(objFunction.FunctionName)
    '            strRet.Append("</a>")
    '            strRet.Append("</li>")
    '        Next
    '        Return strRet.ToString
    '    Catch ex As Exception
    '        Dim erro As String = ex.ToString
    '        Dim erro1 As String = "a"
    '    Finally

    '    End Try
    'End Function

    'Public Function strFooterMenu(ByVal alstEvents As ArrayList) As String
    '    Dim strRet As New System.Text.StringBuilder
    '    Dim hshReference As Hashtable = ConfigurationSettings.GetConfig("references")
    '    strRet.Append("<div class=""hovermenu"">")
    '    strRet.Append("<ul>")
    '    For i As Integer = 0 To alstEvents.Count - 1
    '        strRet.Append("<a href=""")
    '        strRet.Append("../OtherWindows/windowDetails.aspx")
    '        strRet.Append("?page=correspondence")
    '        strRet.Append(Array(i)(1))
    '        strRet.Append("&ID=")
    '        strRet.Append(Array(i)(0))
    '        strRet.Append(""">")
    '        strRet.Append(Array(i)(0))
    '        strRet.Append("</a>")
    '        strRet.Append(" ")
    '    Next
    '    strRet.Append("</ul>")
    '    strRet.Append("</div>")

    '    Return strRet.ToString
    'End Function


    Public Function strCorrespondencePath(ByVal array As ArrayList) As String
        Dim strRet As New System.Text.StringBuilder
        strRet.Append("<p class=""breadcrumb"">")
        For i As Integer = 0 To array.Count - 2
            strRet.Append("<a href=""")
            strRet.Append("../OtherWindows/windowDetails.aspx")
            strRet.Append("?page=correspondence")
            strRet.Append(array(i)(1))
            strRet.Append("&ID=")
            strRet.Append(array(i)(0))
            strRet.Append(""">")
            strRet.Append(array(i)(0))
            strRet.Append("</a>")
            strRet.Append(" ")
        Next
        strRet.Append(array(array.Count - 1)(0))
        strRet.Append("</p>")

        Return strRet.ToString
    End Function

    'Public Function strListSteps(ByVal NumberSteps As Integer, ByVal StepNumber As String) As String
    '    Dim strRet As New System.Text.StringBuilder
    '    Dim strBgColor As String
    '    Dim strTxtColor As String
    '    strRet.Append("<TABLE cellSpacing=""1"" cellPadding=""0"" border=""0"">")
    '    strRet.Append("<TR>")
    '    For i As Integer = 0 To NumberSteps - 1
    '        If i = StepNumber - 1 Then
    '            strBgColor = "bgColorCinzaEscuro"
    '            strTxtColor = "txtColorCinzaEscuro"
    '        Else
    '            strBgColor = "bgColorCinza"
    '            strTxtColor = "txtColorCinza"
    '        End If

    '        strRet.Append("<TD class=" & strBgColor & " vAlign=""bottom"" width=""40"">")
    '        strRet.Append("<DIV class=""supTitleWhite"" align=""right"">")
    '        strRet.Append(CStr(i + 1))
    '        strRet.Append("</DIV>")
    '        strRet.Append("</TD>")
    '    Next
    '    strRet.Append("</TR>")
    '    strRet.Append("</TABLE>")
    '    Return strRet.ToString
    'End Function


    Public Function strListSteps(ByVal NumberSteps As Integer, ByVal StepNumber As String) As String
        Dim strRet As New System.Text.StringBuilder
        Dim strImageName As String
        strRet.Append("<TABLE cellSpacing=""0"" cellPadding=""0"" border=""0"">")
        strRet.Append("<TR>")
        For i As Integer = 1 To NumberSteps
            If i <= StepNumber Then
                strImageName = "./Images/step" + CStr(i)
            Else
                strImageName = "./Images/step" + CStr(i) + "_light"
            End If
            If i = NumberSteps Then
                strImageName = strImageName + "_end"
            End If
            strImageName = strImageName + ".png"

            strRet.Append("<TD vAlign='bottom'>")
            strRet.Append("<img src=")
            strRet.Append(strImageName)
            strRet.Append(" border='0'>")
            strRet.Append("</TD>")
        Next
        strRet.Append("</TR>")
        strRet.Append("</TABLE>")
        Return strRet.ToString
    End Function


    'Public Function strListSteps(ByVal array As ArrayList, ByVal stepNumber As String) As String
    '    Dim strRet As New System.Text.StringBuilder
    '    Dim strBgColor As String
    '    Dim strTxtColor As String
    '    strRet.Append("<TABLE cellSpacing=""1"" cellPadding=""0"" border=""0"">")

    '    For i As Integer = 0 To array.Count - 1
    '        If i = stepNumber - 1 Then
    '            strBgColor = "bgColorCinzaEscuro"
    '            strTxtColor = "txtColorCinzaEscuro"
    '        Else
    '            strBgColor = "bgColorCinza"
    '            strTxtColor = "txtColorCinza"
    '        End If
    '        strRet.Append("<TR>")
    '        strRet.Append("<TD class=" & strBgColor & " vAlign=""bottom"" width=""40"">")
    '        strRet.Append("<DIV class=""supTitleWhite"" align=""right"">")
    '        strRet.Append(CStr(i + 1))
    '        strRet.Append("</DIV>")
    '        strRet.Append("</TD>")
    '        strRet.Append("<TD width=""15"">")
    '        strRet.Append("</TD>")
    '        strRet.Append("<TD vAlign=""bottom""" & "class=" & strTxtColor & ">")
    '        strRet.Append(array(i))
    '        strRet.Append("</TD>")
    '        strRet.Append("</TR>")
    '    Next
    '    strRet.Append("</TABLE>")
    '    Return strRet.ToString
    'End Function

    Public Function BitToStr(ByVal v As Boolean) As String
        If v Then Return "True" Else Return "False"
    End Function

    'Public Function inputDraw3ColumnsRow(ByVal strExtra As String, ByVal strDescription As String, ByVal strName As String, ByVal strSqlValue As String) As String
    '    'If strSqlValue Is Nothing Or strSqlValue = "" Then Return ""
    '    Return "<tr>" & _
    '                "<td valign=top width='20px'>" & strExtra & "</td>" & _
    '                "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
    '                "<td align='left' width='300px' valign=center class='TextGray'><input type='text' size='50' name='" & strName & "' value='" & strSqlValue & "'></td>" & _
    '           "</tr>"
    'End Function

    'Public Function inputSmallDraw3ColumnsRow(ByVal strExtra As String, ByVal strDescription As String, ByVal strName As String, ByVal strSqlValue As String) As String
    '    'If strSqlValue Is Nothing Or strSqlValue = "" Then Return ""
    '    Return "<tr>" & _
    '                "<td valign=top width='20px'>" & strExtra & "</td>" & _
    '                "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
    '                "<td align='left' width='300px' valign=center class='TextGray'><input type='text' size='20' name='" & strName & "' value='" & strSqlValue & "'></td>" & _
    '           "</tr>"
    'End Function

    Public Function strDrawTitle(ByVal strTitle As String, Optional ByVal strMyRT As String = "") As String
        If strMyRT Is Nothing Then Return ""
        Return "<tr><td class='vertical_spacer1'></td></tr>" & _
               "<tr width='450px'><td valign=top class='TextTitleNavy' colspan='3'>" & strTitle & "</td></tr>"
    End Function

    Public Function strGetEmployeeName(ByVal strStatus As Event_.eStatus, ByVal strEmployeeName As String) As String
        If strStatus = Event_.eStatus.Pendent Then Return "" Else Return "(" & strEmployeeName & ")"
    End Function

    Public Function GetUsernameEmployee(ByVal strEmployeeName As Object, ByVal status As Event_.eStatus) As String
        If strEmployeeName Is System.DBNull.Value Or status = Event_.eStatus.Pendent Then Return "" Else Return "(" & strEmployeeName & ")"
    End Function

    Public Function inputDraw3ColumnsRow(ByVal strDescription As String, ByVal strName As String, _
    ByVal strSqlValue As Object, Optional ByVal strMyRT As String = "", Optional ByVal strRT As String = "") As String
        If strMyRT Is Nothing Then Return ""
        If Not strMyRT.Equals(strRT) Then Return ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center class='TextGray'><input type='text' size='50' name='" & strName & "' value='" & DBToStr(strSqlValue) & "'></td>" & _
               "</tr>"
    End Function

    Public Function inputDraw3Columns3Row(ByVal strDescription As String, ByVal strName As String, _
    ByVal strSqlValue As Object, Optional ByVal strMyRT As String = "", Optional ByVal strRT As String = "") As String
        If strMyRT Is Nothing Then Return ""
        If Not strMyRT.Equals(strRT) Then Return ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center><textarea class='TextGray' rows='3' cols='50' name='" & strName & "' value='" & strSqlValue & "'></textarea></td>" & _
               "</tr>"
    End Function

    Public Function inputSmallDraw3ColumnsRow(ByVal strDescription As String, ByVal strName As String, _
    ByVal strSqlValue As Object, Optional ByVal strMyRT As String = "", Optional ByVal strRT As String = "") As String
        If strMyRT Is Nothing Then Return ""
        If Not strMyRT.Equals(strRT) Then Return ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center><input type='text' class='TextGray' size='20' name='" & strName & "' value='" & strSqlValue & "'></td>" & _
               "</tr>"
    End Function

    Public Function cbxDraw(ByVal strDescription As String, ByVal strName As String, _
            ByVal strSqlValue As Boolean, Optional ByVal strSqlText As String = "") As String
        Dim strChecked As String
        If strSqlValue Then strChecked = "checked" Else strChecked = ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center><input type='checkbox' class='TextGray' size='20' name='" & strName & "' value='" & strSqlValue & "' " & strChecked & ">" & strSqlText & "</td>" & _
               "</tr>"
    End Function

    Public Function rbtnDraw(ByVal strDescription As String, ByVal strName As String, _
            ByVal strSqlValue As Boolean, Optional ByVal strSqlText As String = "") As String
        Dim strChecked As String
        If strSqlValue Then strChecked = "checked" Else strChecked = ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center><input type='radio' class='TextGray' size='20' name='" & strName & "' value='" & strSqlValue & "' " & strChecked & ">" & strSqlText & "</td>" & _
               "</tr>"
    End Function

    Public Function ddlDrawKindActionNot(ByVal strDescription As String, ByVal strName As String, _
            ByVal strSqlValue As Boolean, Optional ByVal strSqlText As String = "") As String
        Dim strChecked As String
        If strSqlValue Then strChecked = "checked" Else strChecked = ""
        Return "<tr>" & _
                    "<td valign=top width='20px'></td>" & _
                    "<td align='left'width='180px' valign=top class='TextNavy'>" & strDescription & "</td>" & _
                    "<td align='left' width='300px' valign=center><input type='radio' class='TextGray' size='20' name='" & strName & "' value='" & strSqlValue & "' " & strChecked & ">" & strSqlText & "</td>" & _
               "</tr>"
    End Function


    '********************************************************************************
    ' Function: strGetHTMLTagAlertImg
    ' Purpose: It returns the HMTL Tag For the Image Alert show, for the untreated
    '           Units.
    '*********************************************************************************
    Public Function strGetHTMLTagAlertImg(ByVal blnValid As Boolean) As String

        Dim image As String

        If Not blnValid Then
            Return "<img alt='Informao no tratada arquivisticamente' align ='middle' src='Images/Alert.gif'/>"
        End If
    End Function

    '**********************************************************************************
    ' Function: strGetImgPth
    ' Purpose:  it returns link corresponding to the read value from the OtherLevel field
    '***********************************************************************************

    Public Function strGetImgPth(ByVal strLevel As String) As String
        strLevel = strLevel.ToLower.Trim
        Return "Images/" & strLevel & ".jpg"
    End Function

    '*********************************************************************************
    ' Function: strWriteDate
    ' Purpose:  It returns the complete date (final to Initial) in the correct way
    '*********************************************************************************

    Public Function strWriteDate(ByVal blnCAInitial As Boolean, ByVal strDateInitial As String, ByVal blnCAFinal As Boolean, ByVal strDateFinal As String) As String

        'For date Initial and Final
        strDateInitial = strGetDate(strDateInitial)
        strDateFinal = strGetDate(strDateFinal)

        If strDateInitial = strDateInitial.Empty And strDateFinal = strDateFinal.Empty Then
            Return ""
        End If

        If strDateInitial = strDateInitial.Empty Then
            If Not blnCAFinal Then
                Return "c.a." & strDateFinal
            Else
                Return strDateFinal
            End If
        End If

        If strDateFinal = strDateFinal.Empty Then
            If Not blnCAInitial Then
                Return "c.a." & strDateInitial
            Else
                Return strDateInitial
            End If
        End If

        If strDateInitial = strDateFinal Then
            If Not blnCAInitial And Not blnCAFinal Then
                Return "c.a." & strDateInitial
            Else
                Return strDateInitial
            End If
        End If

        If Not blnCAInitial And Not blnCAFinal Then
            Return "c.a. " & strDateInitial & "/" & " c.a. " & strDateFinal

        ElseIf Not blnCAFinal Then
            Return strDateInitial & "/" & " c.a. " & strDateFinal

        ElseIf Not blnCAInitial Then
            Return "c.a. " & strDateInitial & " a " & strDateFinal

        End If
        Return strDateInitial & "/" & strDateFinal
    End Function

    '*************************************************************************************************
    ' Function: strGetDate
    ' Purpose:  It returns the date, final or initial, in a correct way. It is year, day , 
    '           month if have a valid value. If the register have only year and all others with 0, 
    '           day- 00, month- 00, the user then only see year data, otherwise 
    '           it will return the date with "?" instead of "0" (db value for an inexistence information).
    '***************************************************************************************************
    Public Function strGetDate(ByVal strDate As String) As String
        Dim strDateParts() As String = strDate.Split("-")
        Dim i As Integer


        For i = 0 To strDateParts.Length - 1

            Select Case strDateParts(i)
                Case "0000"
                    strDateParts(i) = ""
                Case "00"
                    strDateParts(i) = ""
            End Select

        Next

        If strDateParts(0) = "" Then
            Return strDate.Empty
        End If

        strDate = Join(strDateParts, "-")

        'If we have only the year
        If strDate.EndsWith("--") Then
            strDate = strDate.TrimEnd("-")
        End If

        'If we have the year and month
        If strDate.EndsWith("-") Then
            strDate &= "??"
        End If

        ' If we have year and day
        strDate = strDate.Replace("--", "-??-")

        Return strDate
    End Function

End Module
