Imports System.Data.SqlClient
Imports DigitArq.Utility


Public Class SQLDataBase
    Inherits SQLInterface

    Dim hshDatabase As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

    Private ServerAddress As String = hshDatabase("ServerAddress")
    Private Database As String = hshDatabase("Database")
    Private SA_Username As String = hshDatabase("SA_Username")
    Private SA_Password As String = hshDatabase("SA_Password")
    Private Username As String = hshDatabase("Username")
    Private Password As String = hshDatabase("Password")

    Private myConnStringCRAV As String = String.Format("Data Source={0}; Initial Catalog={1}; User ID={2}; password={3}", ServerAddress, Database, Username, Password)

    Private myReturn As eReturn

    Public Enum eReturn
        Sucess
        ErrorDB
        ErrorNotProfile
        ErrorUsernamePass
        ErrorRepeatUsername
        ErrorNotActive
    End Enum


    Property Return_() As eReturn
        Get
            Return myReturn
        End Get
        Set(ByVal Value As eReturn)
            myReturn = Value
        End Set
    End Property

    Private myErrorDetails As String

#Region "Digitarq Info"

    Public Overloads Function loadDigitarqInfo(ByVal strReference As String) As DigitarqInfo
        Return loadDigitarqInfo(Me.getIDFromCompleteUnitID(strReference))
    End Function

    Public Overloads Overrides Function loadDigitarqInfo(ByVal intID As Int64) As DigitarqInfo
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim dr As SqlDataReader
        Dim objDigitarqInfo As New DigitarqInfo
        Try
            Dim parent As Int64
            Dim otherlevel As String

            cn.Open()
            Dim cm As New SqlCommand
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure
            cm.CommandText = "sp_loadDigitarqInfoFromID"
            cm.Parameters.Add("@ID", intID)
            dr = cm.ExecuteReader

            'objDigitarqInfo.Reference = strReference
            If Not dr.HasRows Then
                objDigitarqInfo.NoExistsRef = True
            Else
                objDigitarqInfo.NoExistsRef = False
                While dr.Read
                    parent = dr.Item("ID")
                    objDigitarqInfo.ID = dr.Item("ID")
                    objDigitarqInfo.OtherLevel = dr.Item("OtherLevel")
                    objDigitarqInfo.Reference = dr.Item("CompleteUnitID").ToString.ToUpper
                    objDigitarqInfo.PhysLoc = dr.Item("PhysLoc")
                    objDigitarqInfo.UnitDateInitial = dr.Item("UnitDateInitial")
                    objDigitarqInfo.UnitDateInitialCertainty = dr.Item("UnitDateInitialCertainty")
                    objDigitarqInfo.UnitDateFinal = dr.Item("UnitDateFinal")
                    objDigitarqInfo.UnitDateFinalCertainty = dr.Item("UnitDateFinalCertainty")
                    objDigitarqInfo.AltFormAvail = dr.Item("AltFormAvail")
                End While
            End If
            dr.Close()

            cm.Parameters.Clear()
            cm.CommandText = "sp_loadDaoGrpFromID"
            cm.Parameters.Add("@ID", intID)
            dr = cm.ExecuteReader
            If dr.HasRows Then
                objDigitarqInfo.DigitalObjectExists = True
                While dr.Read()
                    If dr.Item("Active") Then
                        Dim DaoGrpItem As New DigitalObject
                        DaoGrpItem.ComponentID = dr.Item("ComponentID")
                        DaoGrpItem.DigitalObjectID = dr.Item("DigitalObjectID")
                        DaoGrpItem.DigitalObjectName = dr.Item("DOName")
                        DaoGrpItem.FileID = dr.Item("FileID")
                        DaoGrpItem.FileName = dr.Item("DOFileName")
                        DaoGrpItem.Type = dr.Item("Type")
                        DaoGrpItem.ArchiveID = dr.Item("ArchiveID")
                        DaoGrpItem.TopographicalQuota = dr.Item("TopographicalQuota")

                        objDigitarqInfo.DaoGrp.Add(DaoGrpItem)
                    End If
                End While
            Else
                objDigitarqInfo.DigitalObjectExists = False
            End If
            dr.Close()

            While parent
                cm.Parameters.Clear()
                cm.Parameters.Add("@ID", parent)
                cm.CommandText = "sp_loadDigitarqInfoFromID"
                dr = cm.ExecuteReader
                While dr.Read
                    otherlevel = dr.Item("OtherLevel")

                    If otherlevel = "F" Then
                        objDigitarqInfo.UnitTitleF = dr.Item("UnitTitle")

                    ElseIf otherlevel = "SF" Then
                        objDigitarqInfo.UnitTitleSF = dr.Item("UnitTitle")

                    ElseIf otherlevel = "SC" Then
                        objDigitarqInfo.UnitTitleSC = dr.Item("UnitTitle")

                    ElseIf otherlevel = "SSC" Then
                        objDigitarqInfo.UnitTitleSSC = dr.Item("UnitTitle")

                    ElseIf otherlevel = "SSSC" Then
                        objDigitarqInfo.UnitTitleSSSC = dr.Item("UnitTitle")

                    ElseIf otherlevel = "SR" Then
                        objDigitarqInfo.UnitTitleSR = dr.Item("UnitTitle")

                    ElseIf otherlevel = "SSR" Then
                        objDigitarqInfo.UnitTitleSSR = dr.Item("UnitTitle")

                    ElseIf otherlevel = "UI" Then
                        objDigitarqInfo.UnitTitleUI = dr.Item("UnitTitle")

                    ElseIf otherlevel = "DC" Then
                        objDigitarqInfo.UnitTitleDC = dr.Item("UnitTitle")

                    ElseIf otherlevel = "D" Then
                        objDigitarqInfo.UnitTitleD = dr.Item("UnitTitle")

                    End If
                    If Not IsDBNull(dr.Item("ParentID")) Then
                        parent = dr.Item("ParentID")
                    Else
                        parent = 0
                    End If
                End While

                dr.Close()

            End While
            Return objDigitarqInfo
        Catch ex As Exception
            Dim erro As String = ex.ToString
            Dim aa As String = "aa"
        Finally
            cn.Close()
        End Try
        'str.Append("<A href=""javascript:Warm2Insert('" + Me.GetTranslation("BLabel067", Me.InterfaceCultureName) + "');""><IMG src=""Images/BBtnNew.gif"" border=""0"" align=""absmiddle"" alt=""" + Me.GetTranslation("BLabel026", Me.InterfaceCultureName) + """></A>")
    End Function

    Public Overrides Function getCompleteUnitIDFromID(ByVal intID As Int64) As String
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getCompleteUnitIDFromID", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@ID", intID)

            Dim strCompleteUnitID As String = cm.ExecuteScalar

            myReturn = eReturn.Sucess
            Return strCompleteUnitID
        Catch ex As Exception
            myReturn = eReturn.ErrorDB
        Finally
            cn.Close()
        End Try
    End Function

    Public Overrides Function getIDFromCompleteUnitID(ByVal strReference As String) As Int64
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getIDFromCompleteUnitID", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@CompleteUnitID", strReference)

            Dim intID As Int64 = cm.ExecuteScalar

            myReturn = eReturn.Sucess
            Return intID
        Catch ex As Exception
            myReturn = eReturn.ErrorDB
        Finally
            cn.Close()
        End Try
    End Function

    Public Overrides Function getOtherLevel(ByVal strCompleteUnitID As String) As String
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getOtherLevel", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@CompleteUnitID", strCompleteUnitID)
            Dim ret As String = cm.ExecuteScalar()
            Return ret
        Catch ex As Exception
            Dim erro As String = ex.ToString
            myReturn = eReturn.ErrorDB
        Finally
            cn.Close()
        End Try
    End Function

#End Region


#Region "Employees"

    
#End Region


#Region "Users"

    Public Overrides Function validateUser(ByVal strUserName As String, ByVal strPassword As String) As User
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_validateUser", cn)
        Dim dr As SqlDataReader
        Dim objUser As New User
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@UserName", strUserName)
            cm.Parameters.Add("@Password", Encrypt.GenerateHash(strPassword))
            dr = cm.ExecuteReader
            If Not dr.HasRows Then
                objUser.UserExists = False
                Return objUser
            Else
                While dr.Read
                    objUser.UserExists = True
                    objUser.UserID = dr.Item("UserID")
                    objUser.UserName = DBToStr(dr.Item("UserName"))
                    objUser.FullName = DBToStr(dr.Item("FullName"))
                    'objUser.Institution = DBToStr(dr.Item("Institution"))
                    objUser.Type = DBToInt(dr.Item("Type"))
                    Return objUser
                End While
            End If
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function validateUserByID(ByVal intUserID As Integer, ByVal strPassword As String) As User
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_validateUserByID", cn)
        Dim dr As SqlDataReader
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@UserID", intUserID)
            cm.Parameters.Add("@Password", Encrypt.GenerateHash(strPassword))
            dr = cm.ExecuteReader
            Dim objUser As New User
            If Not dr.HasRows Then
                objUser.UserExists = False
                Return objUser
            Else
                While dr.Read
                    objUser.UserExists = True
                    objUser.UserID = dr.Item("UserID")
                    objUser.UserName = dr.Item("UserName")
                    objUser.FullName = dr.Item("FullName")
                    Return objUser
                End While
            End If
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function storeUser(ByVal objUser As User) As Integer

        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            If Not validateStoreUser(objUser.UserName) Then
                myReturn = eReturn.ErrorRepeatUsername
                Return 0
            End If
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn

            cm.Parameters.Add("@Type", CInt(objUser.Type))
            cm.Parameters.Add("@FullName", StrToDB(objUser.FullName))
            cm.Parameters.Add("@UserName", StrToDB(objUser.UserName))
            cm.Parameters.Add("@Password", StrToDB(objUser.Password))
            cm.Parameters.Add("@HomePhone", StrToDB(objUser.HomePhone))
            cm.Parameters.Add("@MobilePhone", StrToDB(objUser.MobilePhone))
            cm.Parameters.Add("@Fax", StrToDB(objUser.Fax))
            cm.Parameters.Add("@Email", StrToDB(objUser.Email))
            cm.Parameters.Add("@Address", StrToDB(objUser.Address))
            cm.Parameters.Add("@Locality", StrToDB(objUser.Locality))
            cm.Parameters.Add("@PostalCode", StrToDB(objUser.PostalCode))
            cm.Parameters.Add("@CountryCode", StrToDB(objUser.CountryCode))
            cm.Parameters.Add("@ContributorNumber", StrToDB(objUser.ContributorNumber))

            Select Case objUser.Type
                Case 0
                    cm.Parameters.Add("@Sex", StrToDB(objUser.Sex))
                    cm.Parameters.Add("@BirthDate", StrToDB(objUser.BirthDate))
                    cm.Parameters.Add("@Nationality", StrToDB(objUser.Nationality))
                    cm.Parameters.Add("@IdentityCard", StrToDB(objUser.IdentityCard))
                    cm.Parameters.Add("@Institution", StrToDB(objUser.Institution))
                    cm.Parameters.Add("@AcademicsHabID", IntToDB(objUser.AcademicsHabID))
                    cm.Parameters.Add("@WorkAreaID", IntToDB(objUser.WorkAreaID))
                    cm.Parameters.Add("@ProfessionID", IntToDB(objUser.ProfessionID))

                    cm.CommandText = "sp_storeIndividualUser"

                Case 1
                    cm.Parameters.Add("@ContactName", StrToDB(objUser.ContactName))
                    cm.Parameters.Add("@ActivityAreaID", IntToDB(objUser.ActivityAreaID))

                    cm.CommandText = "sp_storeInstitutionalUser"
            End Select

            cm.Parameters.Add("@UserID", SqlDbType.BigInt)
            cm.Parameters("@UserID").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess

            tran.Commit()
            Return cm.Parameters("@UserID").Value
        Catch ex As Exception
            Dim erro As String = ex.ToString
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function


    Public Overrides Sub updateUser(ByVal objUser As User)

        Dim cn As New SqlConnection

        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Connection = cn

            cm.Parameters.Add("@UserID", objUser.UserID)
            cm.Parameters.Add("@FullName", StrToDB(objUser.FullName))
            cm.Parameters.Add("@UserName", StrToDB(objUser.UserName))
            cm.Parameters.Add("@Password", StrToDB(objUser.Password))
            cm.Parameters.Add("@HomePhone", StrToDB(objUser.HomePhone))
            cm.Parameters.Add("@MobilePhone", StrToDB(objUser.MobilePhone))
            cm.Parameters.Add("@Fax", StrToDB(objUser.Fax))
            cm.Parameters.Add("@Email", StrToDB(objUser.Email))
            cm.Parameters.Add("@Address", StrToDB(objUser.Address))
            cm.Parameters.Add("@Locality", StrToDB(objUser.Locality))
            cm.Parameters.Add("@PostalCode", StrToDB(objUser.PostalCode))
            cm.Parameters.Add("@CountryCode", StrToDB(objUser.CountryCode))
            cm.Parameters.Add("@ContributorNumber", StrToDB(objUser.ContributorNumber))
            
            Select Case objUser.Type
                Case 0
                    cm.Parameters.Add("@Sex", StrToDB(objUser.Sex))
                    cm.Parameters.Add("@BirthDate", StrToDB(objUser.BirthDate))
                    cm.Parameters.Add("@Nationality", StrToDB(objUser.Nationality))
                    cm.Parameters.Add("@IdentityCard", StrToDB(objUser.IdentityCard))
                    cm.Parameters.Add("@Institution", StrToDB(objUser.Institution))
                    cm.Parameters.Add("@AcademicsHabID", IntToDB(objUser.AcademicsHabID))
                    cm.Parameters.Add("@ProfessionID", IntToDB(objUser.ProfessionID))
                    cm.Parameters.Add("@WorkAreaID", IntToDB(objUser.WorkAreaID))

                    cm.CommandText = "sp_updateIndividualUser"
                Case 1
                    cm.Parameters.Add("@ContactName", StrToDB(objUser.ContactName))
                    cm.Parameters.Add("@ActivityAreaID", IntToDB(objUser.ActivityAreaID))

                    cm.CommandText = "sp_updateInstitutionalUser"
            End Select

            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess

        Catch ex As Exception
            Dim erro As String = ex.ToString
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Sub

    Public Overrides Sub updateUserPassword(ByVal intUserID As Integer, ByVal strPassword As String)

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateUserPassword", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@UserID", intUserID)
            cm.Parameters.Add("@Password", Encrypt.GenerateHash(strPassword))

            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess

        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function validateStoreUser(ByVal strUserName As String) As Boolean
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_validateStoreUser", cn)
        Dim dr As SqlDataReader
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@UserName", strUserName)
            dr = cm.ExecuteReader
            If Not dr.HasRows Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Overrides Function loadUser(ByVal strUserName As String) As User
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadUser", cn)
        Dim dr As SqlDataReader
        Dim objUser As New User
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@UserID", strUserName)

            dr = cm.ExecuteReader
            If Not dr.HasRows Then
                objUser.UserExists = False
                Return objUser
            Else
                objUser.UserExists = True
            End If
            While dr.Read
                objUser.UserID = DBToInt(dr.Item("UserID"))
                objUser.Type = DBToInt(dr.Item("Type"))
                objUser.UserName = DBToStr(dr.Item("UserName"))
                objUser.FullName = DBToStr(dr.Item("FullName"))
                objUser.HomePhone = DBToStr(dr.Item("HomePhone"))
                objUser.MobilePhone = DBToStr(dr.Item("MobilePhone"))
                objUser.Fax = DBToStr(dr.Item("Fax"))
                objUser.Email = DBToStr(dr.Item("Email"))
                objUser.Address = DBToStr(dr.Item("Address"))
                objUser.Locality = DBToStr(dr.Item("Locality"))
                objUser.PostalCode = DBToStr(dr.Item("PostalCode"))
                objUser.CountryCode = DBToInt(dr.Item("CountryCode"))
                objUser.Country = DBToStr(dr.Item("Country"))
                objUser.ContributorNumber = DBToStr(dr.Item("ContributorNumber"))

                objUser.Sex = DBToStr(dr.Item("Sex"))
                objUser.BirthDate = DBToStr(dr.Item("BirthDate"))
                objUser.Nationality = DBToStr(dr.Item("Nationality"))
                objUser.IdentityCard = DBToStr(dr.Item("IdentityCard"))
                objUser.Institution = DBToStr(dr.Item("Institution"))
                objUser.ProfessionID = DBToInt(dr.Item("ProfessionID"))
                objUser.Profession = DBToStr(dr.Item("Profession"))
                objUser.WorkAreaID = DBToInt(dr.Item("WorkAreaID"))
                objUser.WorkArea = DBToStr(dr.Item("WorkArea"))
                objUser.AcademicsHabID = DBToInt(dr.Item("AcademicsHabID"))
                objUser.AcademicsHab = DBToStr(dr.Item("AcademicsHab"))

                objUser.ContactName = DBToStr(dr.Item("ContactName"))
                objUser.ActivityAreaID = DBToInt(dr.Item("ActivityAreaID"))
                objUser.ActivityArea = DBToStr(dr.Item("ActivityArea"))
            End While

            myReturn = eReturn.Sucess
            Return objUser
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getFullNameUser(ByVal intUserID As Integer) As String
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadUser", cn)
        Dim dr As SqlDataReader
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@UserID", intUserID)

            dr = cm.ExecuteReader
            If Not dr.HasRows Then
                Return ""
            End If
            dr.Read()
            Return DBToStr(dr.Item("FullName"))
        Catch ex As Exception
            Throw (ex)
            Return ""
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function loadUsers(ByVal userType As String, ByVal field As String, ByVal term As String, Optional ByVal wildChar As String = "") As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()

            Dim CommandText As String = "SELECT UserID, Type, Fullname FROM Users " & _
                                        "WHERE " & field & " LIKE " & "'" & wildChar & term & wildChar & "'"
            If userType <> "" Then
                CommandText += " AND Type='" & userType & "'"
            End If
            da = New SqlDataAdapter(CommandText, cn)
            da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Profiles"

    Public Overrides Sub storeProfile(ByVal strProfileName As String)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeProfile", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProfileName", strProfileName)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overloads Overrides Function loadProfiles(ByVal rdbl As RadioButtonList)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadProfiles", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            rdbl.DataValueField = "ProfileID"
            rdbl.DataTextField = "Profile"
            rdbl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            rdbl.DataBind()

        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Overrides Function loadProfiles(ByVal ddl As DropDownList)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadProfiles", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            ddl.DataValueField = "ProfileID"
            ddl.DataTextField = "Profile"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadDsProfiles() As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim ds As New DataSet
        Dim da As New SqlDataAdapter("sp_loadProfiles", cn)
        Try
            cn.Open()
            da.Fill(ds, "profiles")
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            ds.Dispose()
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function


    Public Overrides Function loadDdlProfiles() As DropDownList
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadProfiles", cn)
        Dim ddl As New DropDownList
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            ddl.DataValueField = "ProfileID"
            ddl.DataTextField = "Profile"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()
            Return ddl
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function


    Public Overrides Sub deleteProfile(ByVal intProfileID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteProfile", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProfileID", intProfileID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub


    Public Overrides Sub updateProfile(ByVal intProfileID As Integer, ByVal strProfileName As String)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateProfile", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProfileID", intProfileID)
            cm.Parameters.Add("@ProfileName", strProfileName)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub


#End Region


#Region "Profile Functions"


#End Region


#Region "Correspondence"

    Public Overrides Function storeCorrespondence(ByVal objC As Correspondence) As Int64()
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim Ret(2) As Int64

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_storeEvent"
            cm.Parameters.Add("@DerivedFrom", IntToDB(objC.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", StrToDB(objC.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objC.EntryExit))
            cm.Parameters.Add("@EventCode", StrToDB(objC.EventCode))
            cm.Parameters.Add("@SourceEventCode", StrToDB(objC.SourceEventCode))
            cm.Parameters.Add("@Status", StrToDB(objC.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objC.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objC.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objC.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objC.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objC.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objC.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objC.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", IntToDB(objC.Process.ProcessID))
            cm.Parameters.Add("@EventID", SqlDbType.BigInt)
            cm.Parameters("@EventID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@EntryExitIDOUT", SqlDbType.BigInt)
            cm.Parameters("@EntryExitIDOUT").Direction = ParameterDirection.Output
            cm.ExecuteNonQuery()
            objC.EventID = cm.Parameters("@EventID").Value

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeCorrespondence"
            cm.Parameters.Add("@EventID", objC.EventID)
            cm.Parameters.Add("@TypeEntryExitCode", StrToDB(objC.TypeEntryExitCode))
            cm.Parameters.Add("@DocumentDate", StrToDB(objC.DocumentDate))
            cm.Parameters.Add("@ProvDest", StrToDB(objC.ProvDest))
            cm.Parameters.Add("@Reference", StrToDB(objC.Reference))
            cm.Parameters.Add("@Subject", StrToDB(objC.Subject))
            cm.Parameters.Add("@Note", StrToDB(objC.Note))
            cm.Parameters.Add("@ManualEntryExitID", SqlDbType.BigInt)
            cm.Parameters("@ManualEntryExitID").Direction = ParameterDirection.Output
            cm.ExecuteNonQuery()
            objC.ManualEntryExitID = cm.Parameters("@ManualEntryExitID").Value

            If Not objC.Attacheds Is Nothing Then
                For i As Integer = 0 To objC.Attacheds.Count - 1
                    cm.Parameters.Clear()
                    cm.CommandText = "sp_storeAttached"
                    cm.Parameters.Add("@Attached", objC.Attacheds(i).Attached)
                    cm.Parameters.Add("@FileName", objC.Attacheds(i).FileName)
                    cm.Parameters.Add("@ContentType", objC.Attacheds(i).ContentType)
                    cm.Parameters.Add("@ContentLength", objC.Attacheds(i).ContentLength)
                    cm.Parameters.Add("@CorrespondenceID", objC.EventID)
                    cm.ExecuteNonQuery()
                Next
            End If

            Ret(0) = objC.EventID
            Ret(1) = objC.ManualEntryExitID
            myReturn = eReturn.Sucess
            tran.Commit()
            Return Ret
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function updateCorrespondence(ByVal objC As Correspondence) As Int64
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeCorrespondenceIn", cn)

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", IntToDB(objC.EventID))
            cm.Parameters.Add("@DerivedFrom", IntToDB(objC.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", StrToDB(objC.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objC.EntryExit))
            cm.Parameters.Add("@EventCode", StrToDB(objC.EventCode))
            cm.Parameters.Add("@SourceEventCode", StrToDB(objC.SourceEventCode))
            cm.Parameters.Add("@Status", StrToDB(objC.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objC.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objC.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objC.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objC.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objC.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objC.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objC.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", IntToDB(objC.Process.ProcessID))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateCorrespondence"
            cm.Parameters.Add("@CorrespondenceID", objC.EventID)
            cm.Parameters.Add("@TypeEntryExitCode", StrToDB(objC.TypeEntryExitCode))
            cm.Parameters.Add("@DocumentDate", StrToDB(objC.DocumentDate))
            cm.Parameters.Add("@ProvDest", StrToDB(objC.ProvDest))
            cm.Parameters.Add("@Reference", StrToDB(objC.Reference))
            cm.Parameters.Add("@Subject", StrToDB(objC.Subject))
            cm.Parameters.Add("@Note", StrToDB(objC.Note))
            cm.ExecuteNonQuery()

            If Not objC.Attacheds Is Nothing Then
                For i As Integer = 0 To objC.Attacheds.Count - 1
                    cm.Parameters.Clear()
                    cm.CommandText = "sp_storeAttached"
                    cm.Parameters.Add("@Attached", objC.Attacheds(i).Attached)
                    cm.Parameters.Add("@FileName", objC.Attacheds(i).FileName)
                    cm.Parameters.Add("@ContentType", objC.Attacheds(i).ContentType)
                    cm.Parameters.Add("@ContentLength", objC.Attacheds(i).ContentLength)
                    cm.Parameters.Add("@CorrespondenceID", objC.EventID)
                    cm.ExecuteNonQuery()
                Next
            End If

            myReturn = eReturn.Sucess
            tran.Commit()
            Return objC.EventID
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Sub loadCorrespondenceOutIn(ByVal dg As DataGrid, ByVal intCorrespondenceOutID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadCorrespondenceOutIn", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@CorrespondenceOutID", intCorrespondenceOutID)
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet, "correspondenceIn")

            dg.DataSource = objDataSet.Tables("correspondenceIn").DefaultView
            dg.DataBind()
        Catch ex As Exception
            Throw (ex)
        Finally
            objDataAdapter.Dispose()
            objDataSet.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub


    Public Overrides Function loadCorrespondenceRelated(ByVal intCorrespondenceID As Integer) As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadCorrespondenceRelated", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@CorrespondenceID", intCorrespondenceID)
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet)
            cn.Close()

            Return objDataSet
        Catch ex As Exception
            Throw (ex)
        Finally
            objDataSet.Dispose()
            objDataAdapter.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    'Public Overloads Overrides Function searchCorrespondence(ByVal intColumnNumber As Integer, ByVal strTerm As String, ByVal intEventType As Integer) As DataSet
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim da As New SqlDataAdapter("sp_searchCorrespondence", cn)
    '    Dim ds As New DataSet

    '    Try
    '        cn.Open()
    '        da.SelectCommand.CommandType = CommandType.StoredProcedure
    '        da.SelectCommand.Parameters.Add("@ColumnNumber", intColumnNumber)
    '        da.SelectCommand.Parameters.Add("@Term", strTerm)

    '        da.Fill(ds)
    '        Return ds

    '    Catch ex As Exception
    '        Dim erro As String = ex.ToString
    '    Finally
    '        cn.Close()
    '    End Try

    'End Function

    Public Overrides Function loadFullCorrespondence(ByVal intCorrespondenceID As Int64) As Correspondence
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objCorrespondence As New Correspondence
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@EventID", intCorrespondenceID)
            cm.CommandText = "sp_loadEvent"
            dr = cm.ExecuteReader
            dr.Read()
            objCorrespondence.EventID = DBToInt64(dr.Item("EventID"))
            objCorrespondence.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
            objCorrespondence.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
            objCorrespondence.EventDate = CompleteDateToStr(dr.Item("EventDate"))
            objCorrespondence.EventCode = DBToInt(dr.Item("EventCode"))
            objCorrespondence.Status = DBToInt(dr.Item("Status"))
            objCorrespondence.Classification = DBToStr(dr.Item("Classification"))
            objCorrespondence.UserInfo.UserID = DBToInt(dr.Item("UserID"))
            objCorrespondence.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
            objCorrespondence.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
            objCorrespondence.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
            objCorrespondence.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))

            dr.Close()
            cm.CommandText = "sp_loadCorrespondence"
            dr = cm.ExecuteReader
            dr.Read()
            objCorrespondence.ManualEntryExitID = DBToInt(dr.Item("ManualEntryExitID"))
            objCorrespondence.TypeEntryExitCode = DBToStr(dr.Item("TypeEntryExitCode"))
            objCorrespondence.DocumentDate = DBToStr(dr.Item("DocumentDate"))
            objCorrespondence.ProvDest = DBToStr(dr.Item("ProvDest"))
            objCorrespondence.Reference = DBToStr(dr.Item("Reference"))
            objCorrespondence.Subject = DBToStr(dr.Item("Subject"))
            objCorrespondence.Note = DBToStr(dr.Item("Note"))

            dr.Close()
            cm.CommandText = "sp_loadAttacheds"
            dr = cm.ExecuteReader
            While dr.Read
                Dim objAttached As New Attached
                objAttached.AttachedID = dr.Item("AttachedID")
                objAttached.FileName = DBToStr(dr.Item("FileName"))
                objAttached.Attached = CType(dr.Item("Attached"), Byte())
                objAttached.ContentType = DBToStr(dr.Item("ContentType"))
                objAttached.ContentLength = DBToInt(dr.Item("ContentLength"))
                objCorrespondence.Attacheds.Add(objAttached)
            End While
            myReturn = eReturn.Sucess
            Return objCorrespondence
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadCorrespondence(ByVal intCorrespondenceID As Int64) As Correspondence
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objCorrespondence As New Correspondence
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@EventID", intCorrespondenceID)
            cm.CommandText = "sp_loadEvent"
            dr = cm.ExecuteReader
            dr.Read()
            objCorrespondence.EventID = DBToInt64(dr.Item("EventID"))
            objCorrespondence.EventDate = CompleteDateToStr(dr.Item("EventDate"))
            objCorrespondence.EventCode = DBToInt(dr.Item("EventCode"))
            objCorrespondence.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
            objCorrespondence.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
            objCorrespondence.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))

            dr.Close()
            cm.CommandText = "sp_loadCorrespondence"
            dr = cm.ExecuteReader
            dr.Read()
            objCorrespondence.CorrespondenceID = DBToInt64(dr.Item("CorrespondenceID"))
            objCorrespondence.ManualEntryExitID = DBToInt(dr.Item("ManualEntryExitID"))
            objCorrespondence.ParentID = DBToInt64(dr.Item("ParentID"))
            objCorrespondence.TypeEntryExitCode = DBToStr(dr.Item("TypeEntryExitCode"))
            objCorrespondence.DocumentDate = DBToStr(dr.Item("DocumentDate"))
            objCorrespondence.ProvDest = DBToStr(dr.Item("ProvDest"))
            objCorrespondence.Reference = DBToStr(dr.Item("Reference"))
            objCorrespondence.Subject = DBToStr(dr.Item("Subject"))
            objCorrespondence.Note = DBToStr(dr.Item("Note"))

            myReturn = eReturn.Sucess
            Return objCorrespondence
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadAttached(ByVal AttachedID As Integer) As Attached
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objAttached As New Attached
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@AttachedID", AttachedID)
            cm.CommandText = "sp_loadAttached"
            dr = cm.ExecuteReader
            dr.Read()

            objAttached.AttachedID = AttachedID
            objAttached.Attached = CType(dr.Item("Attached"), Byte())
            objAttached.ContentType = DBToStr(dr.Item("ContentType"))
            objAttached.ContentLength = DBToInt(dr.Item("ContentLength"))

            Return objAttached
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Sub deleteAttached(ByVal intAttachedID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteAttached", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@AttachedID", intAttachedID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Function searchCorrespondence(ByVal type As Event_.eEventType, ByVal field As String, ByVal term As String, Optional ByVal wildChar As String = "") As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        'Dim cm As New SqlCommand
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()
            'cm.Connection = cn

            Dim CommandText As String = "SELECT DISTINCT E.EventID, E.EventCode, C.ManualEntryExitID, C.Subject, C.ProvDest, P.OtherProcessID FROM Events E " & _
                                        "INNER JOIN Correspondence C ON E.EventID=C.CorrespondenceID " & _
                                        "LEFT JOIN Attacheds A ON C.CorrespondenceID=A.CorrespondenceID " & _
                                        "LEFT JOIN Processes P ON E.ProcessID=P.ProcessID " & _
                                        "WHERE " & field & " LIKE " & "'" & wildChar & term & wildChar & "' "

            If type <> -1 Then
                CommandText += "AND E.EventCode=" & type
            End If
            da = New SqlDataAdapter(CommandText, cn)
            da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function searchFullCorrespondence(ByVal type As Event_.eEventType, ByVal field As String, ByVal term As String) As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        'Dim cm As New SqlCommand
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()
            'cm.Connection = cn

            Dim CommandText As String = "SELECT DISTINCT E.EventID, E.EventCode, E.Classification, E.ProcessID," & _
                                        "TEE.TypeEntryExit, C.DocumentDate, C.ProvDest, C.Reference, C.Subject, C.Note " & _
                                        "FROM Events E " & _
                                        "INNER JOIN Correspondence C ON E.EventID=C.CorrespondenceID " & _
                                        "INNER JOIN TypesEntryExit TEE ON C.TypeEntryExitCode=TEE.TypeEntryExitCode " & _
                                        "LEFT JOIN Attacheds A ON C.CorrespondenceID=A.CorrespondenceID " & _
                                        "WHERE " & field & " LIKE " & "'%" & term & "%' "
            If type <> -1 Then
                CommandText += "AND E.EventCode=" & type
            End If
            da = New SqlDataAdapter(CommandText, cn)
            da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            'cm = Nothing
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getAscendantCorrespondence(ByVal intCorrespondenceID As Integer) As CorrespondenceCollection
        Dim objCorrespondenceCollection As New CorrespondenceCollection

        Try
            While intCorrespondenceID <> 0
                Dim objCorrespondence As Correspondence = loadCorrespondence(intCorrespondenceID)
                objCorrespondenceCollection.Add(objCorrespondence)
                intCorrespondenceID = CInt(objCorrespondence.ParentID)
            End While

            myReturn = eReturn.Sucess
            Return objCorrespondenceCollection
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
        End Try
    End Function

#End Region


#Region "TypesEntryExit"

    Public Overrides Sub loadTypesEntryExit(ByVal ddl As DropDownList)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadTypesEntryExit", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            ddl.DataValueField = "TypeEntryExitCode"
            ddl.DataTextField = "TypeEntryExit"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()
            Dim li As New ListItem
            li.Value = "0"
            li.Text = "Selecionar"
            ddl.Items.Insert(0, li)
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

#End Region


#Region "RelationshipInOut"

    Public Overrides Sub insertRelationship(ByVal intCorrespondenceID As Integer, ByVal intParentID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_insertRelationship", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@CorrespondenceID", intCorrespondenceID)
            cm.Parameters.Add("@ParentID", intParentID)
            cm.ExecuteNonQuery()
            cm.Parameters.Clear()

            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub storeRelationshipInOut(ByVal intInID As Integer, ByVal alstOut As ArrayList)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeRelationshipInOut", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            For i As Integer = 0 To alstOut.Count - 1
                cm.Parameters.Add("@CorrespondenceInID", intInID)
                cm.Parameters.Add("@CorrespondenceOutID", alstOut.Item(i))
                cm.ExecuteNonQuery()
                cm.Parameters.Clear()
            Next
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub storeRelationshipOutIn(ByVal intOutID As Integer, ByVal alstIn As ArrayList)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeRelationshipInOut", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            For i As Integer = 0 To alstIn.Count - 1
                cm.Parameters.Add("@CorrespondenceInID", alstIn.Item(i))
                cm.Parameters.Add("@CorrespondenceOutID", intOutID)
                cm.ExecuteNonQuery()
                cm.Parameters.Clear()
            Next
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub loadRelationshipInOut(ByVal dg As DataGrid, ByVal intCorrespondenceInID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadRelationshipInOut", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@CorrespondenceInID", intCorrespondenceInID)
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet, "correspondenceOut")

            dg.DataSource = objDataSet.Tables("correspondenceOut").DefaultView
            dg.DataBind()
        Catch ex As Exception
            Throw (ex)
        Finally
            objDataSet.Dispose()
            objDataAdapter.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub loadRelationshipOutIn(ByVal dg As DataGrid, ByVal intCorrespondenceOutID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadRelationshipOutIn", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@CorrespondenceOutID", intCorrespondenceOutID)
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet, "correspondenceIn")

            dg.DataSource = objDataSet.Tables("correspondenceIn").DefaultView
            dg.DataBind()
        Catch ex As Exception
            Throw (ex)
        Finally
            objDataSet.Dispose()
            objDataAdapter.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

#End Region


#Region "RequestTypes"

    Public Overrides Sub loadRequestTypes(ByVal ddl As DropDownList, Optional ByVal SelectedValue As String = "0")
        Dim l0 As New ListItem("Todos", 0)
        Dim l1 As New ListItem("Consulta", Event_.eEventType.consultationRequest)
        Dim l2 As New ListItem("Reserva", Event_.eEventType.reservationRequest)
        Dim l3 As New ListItem("Pesquisa/Reproduo", Event_.eEventType.reproductionRequest)
        ddl.Items.Insert(0, l0)
        ddl.Items.Insert(1, l1)
        ddl.Items.Insert(2, l2)
        ddl.Items.Insert(3, l3)
        ddl.SelectedValue = SelectedValue
    End Sub

    'Public Overrides Sub loadRequestTypes(ByVal ddl As DropDownList)
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim cm As New SqlCommand("sp_loadEventTypes", cn)
    '    Try
    '        cn.Open()
    '        cm.CommandType = CommandType.StoredProcedure
    '        ddl.DataValueField = "EventTypeCode"
    '        ddl.DataTextField = "EventType"
    '        ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
    '        ddl.DataBind()
    '        Dim li As New ListItem
    '        li.Value = "0"
    '        li.Text = "Todos"
    '        ddl.Items.Insert(0, li)

    '    Catch ex As Exception
    '        Dim erro As String = ex.ToString
    '        Dim a As String = "a"
    '    Finally
    '        cn.Close()
    '    End Try
    'End Sub

#End Region


#Region "Requests"

    Public Overrides Function storeConsultationRequest(ByVal objConReq As ConsultationRequest) As Int64()
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim Ret(2) As Int64

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_storeEvent"
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objConReq.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objConReq.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objConReq.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objConReq.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objConReq.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objConReq.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objConReq.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objConReq.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objConReq.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objConReq.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objConReq.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objConReq.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objConReq.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objConReq.Process.ProcessID))

            cm.Parameters.Add("@EventID", SqlDbType.BigInt)
            cm.Parameters("@EventID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@EntryExitIDOUT", SqlDbType.BigInt)
            cm.Parameters("@EntryExitIDOUT").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objConReq.EventID = cm.Parameters("@EventID").Value
            objConReq.EntryExitID = cm.Parameters("@EntryExitIDOUT").Value

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateSourceEventID"
            cm.Parameters.Add("@EventID", objConReq.EventID)
            cm.Parameters.Add("@SourceEventID", objConReq.EntryExitID)
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeEventProfile"
            cm.Parameters.Add("@EventID", objConReq.EventID)
            cm.Parameters.Add("@UserGroup", "Utilizador")
            cm.Parameters.Add("@ApplicationCode", ConfigurationSettings.AppSettings("CRAVApplicationCode"))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeConsultationRequest"
            cm.Parameters.Add("@EventID", objConReq.EventID)
            cm.Parameters.Add("@ReferenceDigitarq", objConReq.DigitarqInfo.Reference)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            Ret(0) = objConReq.EventID
            Ret(1) = objConReq.EntryExitID
            tran.Commit()
        Catch ex As Exception
            Dim erro As String = ex.ToString
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
        Return Ret
    End Function

    Public Overrides Function storeReservationRequest(ByVal objResReq As ReservationRequest) As Int64()
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim Ret(2) As Int64

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_storeEvent"
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objResReq.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objResReq.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objResReq.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objResReq.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objResReq.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objResReq.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objResReq.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objResReq.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objResReq.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objResReq.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objResReq.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objResReq.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objResReq.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objResReq.Process.ProcessID))

            cm.Parameters.Add("@EventID", SqlDbType.BigInt)
            cm.Parameters("@EventID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@EntryExitIDOUT", SqlDbType.BigInt)
            cm.Parameters("@EntryExitIDOUT").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objResReq.EventID = cm.Parameters("@EventID").Value
            objResReq.EntryExitID = cm.Parameters("@EntryExitIDOUT").Value

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateSourceEventID"
            cm.Parameters.Add("@EventID", objResReq.EventID)
            cm.Parameters.Add("@SourceEventID", objResReq.EntryExitID)
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeEventProfile"
            cm.Parameters.Add("@EventID", objResReq.EventID)
            cm.Parameters.Add("@UserGroup", "Utilizador")
            cm.Parameters.Add("@ApplicationCode", ConfigurationSettings.AppSettings("CRAVApplicationCode"))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeReservationRequest"
            cm.Parameters.Add("@EventID", objResReq.EventID)
            cm.Parameters.Add("@ReferenceDigitarq", objResReq.DigitarqInfo.Reference)
            cm.Parameters.Add("@ReserveDate", objResReq.ReserveDate)
            cm.Parameters.Add("@PartDay", objResReq.PartDay)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            Ret(0) = objResReq.EventID
            Ret(1) = objResReq.EntryExitID

            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
        Return Ret
    End Function

    Public Overrides Function storeReproductionRequest(ByVal objRepReq As ReproductionRequest) As Int64()
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim Ret(2) As Int64

        Try
            cn.Open()
            tran = cn.BeginTransaction

            'objRepReq.Process.ProcessID = storeProcess(objRepReq.Process)

            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_storeEvent"
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objRepReq.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objRepReq.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objRepReq.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objRepReq.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objRepReq.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objRepReq.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objRepReq.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objRepReq.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objRepReq.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objRepReq.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objRepReq.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objRepReq.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objRepReq.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", StrToDB(objRepReq.Process.ProcessID))

            cm.Parameters.Add("@EventID", SqlDbType.BigInt)
            cm.Parameters("@EventID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@EntryExitIDOUT", SqlDbType.BigInt)
            cm.Parameters("@EntryExitIDOUT").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objRepReq.EventID = cm.Parameters("@EventID").Value
            objRepReq.EntryExitID = cm.Parameters("@EntryExitIDOUT").Value

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateSourceEventID"
            cm.Parameters.Add("@EventID", objRepReq.EventID)
            cm.Parameters.Add("@SourceEventID", objRepReq.EntryExitID)
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeEventProfile"
            'For Each userGroup As String In objEvent.UserGroups
            cm.Parameters.Add("@EventID", objRepReq.EventID)
            cm.Parameters.Add("@UserGroup", "Utilizador")
            cm.Parameters.Add("@ApplicationCode", ConfigurationSettings.AppSettings("CRAVApplicationCode"))
            cm.ExecuteNonQuery()
            cm.Parameters.Clear()
            'Next      

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeReproductionRequest"
            cm.Parameters.Add("@EventID", objRepReq.EventID)
            If Not objRepReq.DigitarqInfo Is Nothing Then
                cm.Parameters.Add("@ReferenceDigitarq", StrToDB(objRepReq.DigitarqInfo.Reference))
            Else
                cm.Parameters.Add("@ReferenceDigitarq", StrToDB(""))
            End If
            cm.Parameters.Add("@Search", BoolToDB(objRepReq.SearchValue))
            cm.Parameters.Add("@Reproduction", BoolToDB(objRepReq.ReproductionValue))
            cm.Parameters.Add("@TypeReproductionCode", IntToDB(objRepReq.TypeReproductionCode))
            cm.Parameters.Add("@Certificate", BoolToDB(objRepReq.CertificateValue))
            cm.Parameters.Add("@TypeCertificateCode", IntToDB(objRepReq.TypeCertificateCode))
            cm.Parameters.Add("@Destination", StrToDB(objRepReq.Destination))
            cm.Parameters.Add("@RedutionsCosts", StrToDB(objRepReq.RedutionsCosts))
            cm.Parameters.Add("@NumberCopies", StrToDB(objRepReq.NumberCopies))
            cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))
            cm.Parameters.Add("@RequestSubTypeCode", IntToDB(objRepReq.RequestSubTypeCode))
            cm.ExecuteNonQuery()
            cm.Parameters.Clear()

            Select Case objRepReq.RequestSubTypeCode
                Case ReproductionRequest.eRequestSubType.parochial
                    cm.CommandText = "sp_storeParochialRequest"

                    cm.Parameters.Add("@EventID", objRepReq.EventID)
                    cm.Parameters.Add("@KindActionPrcCode", IntToDB(objRepReq.KindActionPrcCode))
                    cm.Parameters.Add("@Address", StrToDB(objRepReq.Address))
                    cm.Parameters.Add("@Region", StrToDB(objRepReq.Region))
                    cm.Parameters.Add("@Name", StrToDB(objRepReq.Name))
                    cm.Parameters.Add("@FiliationFather", StrToDB(objRepReq.FiliationFather))
                    cm.Parameters.Add("@FiliationMather", StrToDB(objRepReq.FiliationMather))
                    cm.Parameters.Add("@Spouse", StrToDB(objRepReq.Spouse))
                    cm.Parameters.Add("@SeatNumber", StrToDB(objRepReq.SeatNumber))
                    cm.Parameters.Add("@SeatYear", StrToDB(objRepReq.SeatYear))
                    cm.Parameters.Add("@PageNumber", StrToDB(objRepReq.PageNumberPrc))
                    cm.Parameters.Add("@InitialDate", StrToDB(objRepReq.InitialDate))
                    cm.Parameters.Add("@FinalDate", StrToDB(objRepReq.FinalDate))
                    'cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))

                    cm.ExecuteNonQuery()
                Case ReproductionRequest.eRequestSubType.notarial

                    cm.CommandText = "sp_storeNotaryRequest"

                    cm.Parameters.Add("@EventID", objRepReq.EventID)
                    cm.Parameters.Add("@KindActionNotCode", IntToDB(objRepReq.KindActionNotCode))
                    cm.Parameters.Add("@Notary", StrToDB(objRepReq.Notary))
                    cm.Parameters.Add("@CartoryNumber", StrToDB(objRepReq.CartoryNumber))
                    cm.Parameters.Add("@Locality", StrToDB(objRepReq.Locality))
                    cm.Parameters.Add("@ParticipantsAction", StrToDB(objRepReq.ParticipantsAction))
                    cm.Parameters.Add("@PageNumber", StrToDB(objRepReq.PageNumberNot))
                    cm.Parameters.Add("@InitialDate", StrToDB(objRepReq.InitialDate))
                    cm.Parameters.Add("@FinalDate", StrToDB(objRepReq.FinalDate))
                    'cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))

                    cm.ExecuteNonQuery()
                Case ReproductionRequest.eRequestSubType.other

                    cm.CommandText = "sp_storeOtherRequest"

                    cm.Parameters.Add("@EventID", objRepReq.EventID)
                    cm.Parameters.Add("@Fonds", StrToDB(objRepReq.Fonds))
                    cm.Parameters.Add("@Name", StrToDB(objRepReq.NamesOther))
                    cm.Parameters.Add("@TermsWords", StrToDB(objRepReq.TermsWords))
                    cm.Parameters.Add("@Document", StrToDB(objRepReq.Document))
                    cm.Parameters.Add("@Localities", StrToDB(objRepReq.Localities))
                    cm.Parameters.Add("@InitialDate", StrToDB(objRepReq.InitialDate))
                    cm.Parameters.Add("@FinalDate", StrToDB(objRepReq.FinalDate))
                    'cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))

                    cm.ExecuteNonQuery()
            End Select

            Ret(0) = objRepReq.EventID
            Ret(1) = objRepReq.EntryExitID
            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
        Return Ret
    End Function

    Public Overrides Sub updateConsultationRequest(ByVal objRepReq As ConsultationRequest)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction

            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", Int64ToDB(objRepReq.EventID))
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objRepReq.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objRepReq.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objRepReq.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objRepReq.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objRepReq.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objRepReq.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objRepReq.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objRepReq.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objRepReq.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objRepReq.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objRepReq.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objRepReq.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objRepReq.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objRepReq.Process.ProcessID))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateConsultationRequest"
            cm.Parameters.Add("@EventID", objRepReq.EventID)
            cm.Parameters.Add("@ReferenceDigitarq", StrToDB(objRepReq.ReferenceDigitarq))
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub updateReservationRequest(ByVal objRepReq As ReservationRequest)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction

            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", Int64ToDB(objRepReq.EventID))
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objRepReq.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objRepReq.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objRepReq.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objRepReq.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objRepReq.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objRepReq.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objRepReq.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objRepReq.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objRepReq.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objRepReq.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objRepReq.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objRepReq.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objRepReq.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objRepReq.Process.ProcessID))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateReservationRequest"
            cm.Parameters.Add("@EventID", objRepReq.EventID)
            cm.Parameters.Add("@ReferenceDigitarq", StrToDB(objRepReq.ReferenceDigitarq))
            cm.Parameters.Add("@PartDay", objRepReq.PartDay)
            cm.Parameters.Add("@ReserveDate", objRepReq.ReserveDate)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub updateReproductionRequest(ByVal objRepReq As ReproductionRequest)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction

            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", Int64ToDB(objRepReq.EventID))
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objRepReq.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objRepReq.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objRepReq.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objRepReq.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objRepReq.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objRepReq.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objRepReq.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objRepReq.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objRepReq.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objRepReq.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objRepReq.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objRepReq.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objRepReq.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objRepReq.Process.ProcessID))
            cm.ExecuteNonQuery()

            'cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateReproductionRequest"
            cm.Parameters.Add("@EventID", objRepReq.EventID)
            cm.Parameters.Add("@ReferenceDigitarq", StrToDB(objRepReq.ReferenceDigitarq))
            cm.Parameters.Add("@Search", BoolToDB(objRepReq.SearchValue))
            cm.Parameters.Add("@Reproduction", BoolToDB(objRepReq.ReproductionValue))
            cm.Parameters.Add("@TypeReproductionCode", IntToDB(objRepReq.TypeReproductionCode))
            cm.Parameters.Add("@Certificate", BoolToDB(objRepReq.CertificateValue))
            cm.Parameters.Add("@TypeCertificateCode", IntToDB(objRepReq.TypeCertificateCode))
            cm.Parameters.Add("@Destination", StrToDB(objRepReq.Destination))
            cm.Parameters.Add("@RedutionsCosts", StrToDB(objRepReq.RedutionsCosts))
            cm.Parameters.Add("@NumberCopies", StrToDB(objRepReq.NumberCopies))
            'cm.Parameters.Add("@RequestPrice", StrToDB(objRepReq.RequestPrice))
            'cm.Parameters.Add("@FormPaymentCode", StrToDB(objRepReq.FormPaymentCode))
            'cm.Parameters.Add("@FormDeliveryCode", StrToDB(objRepReq.FormDeliveryCode))
            cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))
            cm.Parameters.Add("@RequestSubTypeCode", IntToDB(objRepReq.RequestSubTypeCode))
            cm.ExecuteNonQuery()
            cm.Parameters.Clear()

            Select Case objRepReq.RequestSubTypeCode
                Case ReproductionRequest.eRequestSubType.parochial
                    cm.CommandText = "sp_updateParochialRequest"

                    cm.Parameters.Add("@EventID", objRepReq.EventID)
                    cm.Parameters.Add("@KindActionPrcCode", IntToDB(objRepReq.KindActionPrcCode))
                    cm.Parameters.Add("@Address", StrToDB(objRepReq.Address))
                    cm.Parameters.Add("@Region", StrToDB(objRepReq.Region))
                    cm.Parameters.Add("@Name", StrToDB(objRepReq.Name))
                    cm.Parameters.Add("@FiliationFather", StrToDB(objRepReq.FiliationFather))
                    cm.Parameters.Add("@FiliationMather", StrToDB(objRepReq.FiliationMather))
                    cm.Parameters.Add("@Spouse", StrToDB(objRepReq.Spouse))
                    cm.Parameters.Add("@SeatNumber", StrToDB(objRepReq.SeatNumber))
                    cm.Parameters.Add("@SeatYear", StrToDB(objRepReq.SeatYear))
                    cm.Parameters.Add("@PageNumber", StrToDB(objRepReq.PageNumberPrc))
                    cm.Parameters.Add("@InitialDate", StrToDB(objRepReq.InitialDate))
                    cm.Parameters.Add("@FinalDate", StrToDB(objRepReq.FinalDate))
                    'cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))

                    cm.ExecuteNonQuery()
                Case ReproductionRequest.eRequestSubType.notarial

                    cm.CommandText = "sp_updateNotaryRequest"

                    cm.Parameters.Add("@EventID", objRepReq.EventID)
                    cm.Parameters.Add("@KindActionNotCode", IntToDB(objRepReq.KindActionNotCode))
                    cm.Parameters.Add("@Notary", StrToDB(objRepReq.Notary))
                    cm.Parameters.Add("@CartoryNumber", StrToDB(objRepReq.CartoryNumber))
                    cm.Parameters.Add("@Locality", StrToDB(objRepReq.Locality))
                    cm.Parameters.Add("@ParticipantsAction", StrToDB(objRepReq.ParticipantsAction))
                    cm.Parameters.Add("@PageNumber", StrToDB(objRepReq.PageNumberNot))
                    cm.Parameters.Add("@InitialDate", StrToDB(objRepReq.InitialDate))
                    cm.Parameters.Add("@FinalDate", StrToDB(objRepReq.FinalDate))
                    'cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))

                    cm.ExecuteNonQuery()
                Case ReproductionRequest.eRequestSubType.other

                    cm.CommandText = "sp_updateOtherRequest"

                    cm.Parameters.Add("@EventID", objRepReq.EventID)
                    cm.Parameters.Add("@Fonds", StrToDB(objRepReq.Fonds))
                    cm.Parameters.Add("@Name", StrToDB(objRepReq.NamesOther))
                    cm.Parameters.Add("@TermsWords", StrToDB(objRepReq.TermsWords))
                    cm.Parameters.Add("@Document", StrToDB(objRepReq.Document))
                    cm.Parameters.Add("@Localities", StrToDB(objRepReq.Localities))
                    cm.Parameters.Add("@InitialDate", StrToDB(objRepReq.InitialDate))
                    cm.Parameters.Add("@FinalDate", StrToDB(objRepReq.FinalDate))
                    'cm.Parameters.Add("@AdditionalInformation", StrToDB(objRepReq.AdditionalInformation))

                    cm.ExecuteNonQuery()
            End Select

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overloads Overrides Sub updateEvent(ByVal objEvent As Event_)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", Int64ToDB(objEvent.EventID))
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objEvent.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objEvent.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objEvent.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objEvent.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objEvent.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objEvent.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objEvent.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objEvent.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objEvent.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objEvent.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objEvent.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objEvent.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objEvent.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objEvent.Process.ProcessID))
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overloads Overrides Sub updateEvent(ByVal eid As Int64, ByVal status As Event_.eStatus, ByVal strEmployeeID As String)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", Int64ToDB(eid))
            cm.Parameters.Add("@Status", IntToDB(status))
            cm.Parameters.Add("@EmployeeID", StrToDB(strEmployeeID))

            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub changeStatus(ByVal eid As Int64, ByVal status As Event_.eStatus)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_changeStatus"
            cm.Parameters.Add("@EventID", Int64ToDB(eid))
            cm.Parameters.Add("@Status", IntToDB(status))

            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Sub changeStatusTakenToPendent(ByVal eid As Int64, ByVal employeeID As String)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "changeStatusTakenToPendent"
            cm.Parameters.Add("@EventID", Int64ToDB(eid))
            cm.Parameters.Add("@EmployeeID", StrToDB(employeeID))
            cm.Parameters.Add("@Taken", IntToDB(Event_.eStatus.Taken))
            cm.Parameters.Add("@Pendent", IntToDB(Event_.eStatus.Pendent))

            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub storeNextEvent(ByVal objEvent As Event_, ByVal alNextUserGroups As ArrayList)
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand

        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            'storeProcess(objEvent.Process)

            cm.CommandText = "sp_storeEvent"
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objEvent.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objEvent.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objEvent.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objEvent.EventCode))
            cm.Parameters.Add("@SourceEventCode", IntToDB(objEvent.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objEvent.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objEvent.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objEvent.Classification))
            cm.Parameters.Add("@NoteToNext", IntToDB(objEvent.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objEvent.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objEvent.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objEvent.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objEvent.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objEvent.Process.ProcessID))

            cm.Parameters.Add("@EventID", SqlDbType.BigInt)
            cm.Parameters("@EventID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@EntryExitIDOUT", SqlDbType.BigInt)
            cm.Parameters("@EntryExitIDOUT").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objEvent.EventID = cm.Parameters("@EventID").Value

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeEventProfile"
            For Each userGroup As String In alNextUserGroups '??objEvent.NextUserGroups
                If alNextUserGroups.Contains(userGroup) Then
                    cm.Parameters.Add("@EventID", objEvent.EventID)
                    cm.Parameters.Add("@UserGroup", userGroup)
                    cm.Parameters.Add("@ApplicationCode", GetConfig("CRAVApplicationCode"))
                    cm.ExecuteNonQuery()
                    cm.Parameters.Clear()
                End If
            Next
            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
            tran.Rollback()
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function loadEvent(ByVal intRequestID As Int64) As Event_
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objEvent As New Event_
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@EventID", intRequestID)
            cm.CommandText = "sp_loadEvent"
            dr = cm.ExecuteReader
            dr.Read()
            objEvent.EventID = DBToInt64(dr.Item("EventID"))
            objEvent.EntryExitID = DBToInt64(dr.Item("EntryExitID"))
            objEvent.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
            objEvent.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
            objEvent.EntryExit = DBToBool(dr.Item("EntryExit"))
            objEvent.SourceEventCode = DBToInt(dr.Item("SourceEventCode"))
            objEvent.EventDate = CompleteDateToStr(dr.Item("EventDate"))
            objEvent.EventCode = DBToInt(dr.Item("EventCode"))
            objEvent.Status = DBToInt(dr.Item("Status"))
            objEvent.Seen = DBToBool(dr.Item("Seen"))
            objEvent.Classification = DBToStr(dr.Item("Classification"))
            objEvent.NoteToNext = DBToStr(dr.Item("NoteToNext"))
            objEvent.Notification = DBToStr(dr.Item("Notification"))
            objEvent.PaymentID = DBToInt(dr.Item("PaymentID"))
            objEvent.UserInfo.UserID = DBToInt(dr.Item("UserID"))
            objEvent.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
            objEvent.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
            objEvent.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
            objEvent.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))

            myReturn = eReturn.Sucess
            Return objEvent
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Overrides Function loadRequests(ByVal strRequestTypeCode As String) As EventCollection
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim dr As SqlDataReader
        Dim cm As New SqlCommand("sp_loadRequests", cn)
        Dim ecRequests As New EventCollection

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@RequestTypeCode", strRequestTypeCode)
            dr = cm.ExecuteReader
            While dr.Read
                Dim objRequest As New Event_
                objRequest.EventID = DBToInt64(dr.Item("EventID"))
                objRequest.EventCode = DBToInt(dr.Item("EventCode"))
                objRequest.Status = DBToInt(dr.Item("Status"))
                objRequest.UserInfo.UserID = DBToInt64(dr.Item("UserID"))
                objRequest.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
                ecRequests.Add(objRequest)
            End While

            myReturn = eReturn.Sucess
            Return ecRequests
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Overrides Function loadRequests(ByVal strRequestTypeCode As String, ByVal intProfileID As Integer) As EventCollection
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim dr As SqlDataReader
        Dim cm As New SqlCommand("sp_loadRequestsPendentsByProfile", cn)
        Dim ecRequests As New EventCollection

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@RequestTypeCode", strRequestTypeCode)
            cm.Parameters.Add("@ProfileID", intProfileID)

            dr = cm.ExecuteReader
            While dr.Read
                Dim objRequest As New Event_
                objRequest.EventID = DBToInt64(dr.Item("EventID"))
                objRequest.EventCode = DBToInt(dr.Item("EventCode"))
                objRequest.Status = DBToInt(dr.Item("Status"))
                objRequest.UserInfo.UserID = DBToInt64(dr.Item("UserID"))
                objRequest.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
                objRequest.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
                objRequest.Process.ProcessID = DBToInt64(dr.Item("ProcessID"))
                ecRequests.Add(objRequest)
            End While

            myReturn = eReturn.Sucess
            Return ecRequests
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadUserRequests(ByVal strRequestTypeCode As String, ByVal intUserID As Integer) As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet

        Try
            cn.Open()
            da = New SqlDataAdapter("sp_loadUserRequests", cn)
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            da.SelectCommand.Parameters.Add("@RequestTypeCode", strRequestTypeCode)
            da.SelectCommand.Parameters.Add("@UserID", intUserID)

            da.Fill(ds)
            myReturn = eReturn.Sucess
            Return ds
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadRequestsPendentsByProfile(ByVal eEventType As Event_.eEventType, ByVal intProfileID As Integer) As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        'Dim dr As SqlDataReader
        Dim da As SqlDataAdapter
        Dim ds As New DataSet

        Try
            Select Case eEventType
                Case Event_.eEventType.reproductionRequest
                    da = New SqlDataAdapter("sp_loadReproductionRequestsPendentsByProfile", cn)
                Case Event_.eEventType.reservationRequest
                    da = New SqlDataAdapter("sp_loadReservationRequestsPendentsByProfile", cn)
                Case Event_.eEventType.consultationRequest
                    da = New SqlDataAdapter("sp_loadConsultationRequestsPendentsByProfile", cn)
                Case Else
                    da = New SqlDataAdapter("sp_loadAllRequestsPendentsByProfile", cn)
            End Select
            cn.Open()
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            'da.SelectCommand.Parameters.Add("@EventCode", eEventType)
            da.SelectCommand.Parameters.Add("@ProfileID", intProfileID)

            da.Fill(ds)
            'Return ds

            myReturn = eReturn.Sucess
            Return ds
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Overrides Sub loadRequests(ByVal dg As DataGrid, ByVal strRequestTypeCode As String)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadRequests", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@RequestTypeCode", strRequestTypeCode)
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet, "requests")

            dg.DataSource = objDataSet.Tables("requests").DefaultView
            dg.DataBind()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            objDataAdapter = Nothing
            objDataSet = Nothing
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function loadConsultationRequest(ByVal intRequestID As Int64) As ConsultationRequest
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objConReq As New ConsultationRequest
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@EventID", intRequestID)

            cm.CommandText = "sp_loadConsultationRequest"
            dr = cm.ExecuteReader
            dr.Read()
            objConReq.EventID = DBToInt64(dr.Item("EventID"))
            objConReq.EntryExitID = DBToInt64(dr.Item("EntryExitID"))
            objConReq.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
            objConReq.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
            objConReq.EntryExit = DBToBool(dr.Item("EntryExit"))
            objConReq.EventDate = CompleteDateToStr(dr.Item("EventDate"))
            objConReq.EventCode = DBToInt(dr.Item("EventCode"))
            objConReq.SourceEventCode = DBToInt(dr.Item("SourceEventCode"))
            objConReq.Status = DBToInt(dr.Item("Status"))
            objConReq.NoteToNext = DBToStr(dr.Item("NoteToNext"))
            objConReq.Classification = DBToStr(dr.Item("Classification"))
            objConReq.UserInfo.UserID = DBToInt(dr.Item("UserID"))
            objConReq.UserInfo.FullName = DBToStr(dr.Item("FullName"))
            objConReq.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
            objConReq.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
            objConReq.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))
            objConReq.ReferenceDigitarq = DBToStr(dr.Item("ReferenceDigitarq"))

            myReturn = eReturn.Sucess
            Return objConReq
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadReservationRequest(ByVal intRequestID As Int64) As ReservationRequest
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objResReq As New ReservationRequest
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@EventID", intRequestID)

            cm.CommandText = "sp_loadReservationRequest"
            dr = cm.ExecuteReader
            dr.Read()
            objResReq.EventID = DBToInt64(dr.Item("EventID"))
            objResReq.EntryExitID = DBToInt64(dr.Item("EntryExitID"))
            objResReq.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
            objResReq.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
            objResReq.EntryExit = DBToBool(dr.Item("EntryExit"))
            objResReq.EventDate = CompleteDateToStr(dr.Item("EventDate"))
            objResReq.EventCode = DBToInt(dr.Item("EventCode"))
            objResReq.SourceEventCode = DBToInt(dr.Item("SourceEventCode"))
            objResReq.Status = DBToInt(dr.Item("Status"))
            objResReq.NoteToNext = DBToStr(dr.Item("NoteToNext"))
            objResReq.Classification = DBToStr(dr.Item("Classification"))
            objResReq.UserInfo.UserID = DBToInt(dr.Item("UserID"))
            objResReq.UserInfo.FullName = DBToStr(dr.Item("FullName"))
            objResReq.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
            objResReq.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
            objResReq.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))

            objResReq.ReferenceDigitarq = DBToStr(dr.Item("ReferenceDigitarq"))
            objResReq.PartDay = DBToStr(dr.Item("PartDay"))
            objResReq.ReserveDate = DBToStr(dr.Item("ReserveDate"))

            myReturn = eReturn.Sucess
            Return objResReq
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadReproductionRequest(ByVal intRequestID As Int64) As ReproductionRequest
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objRepReq As New ReproductionRequest
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@EventID", intRequestID)
            cm.CommandText = "sp_loadEvent"
            dr = cm.ExecuteReader

            dr.Read()
            objRepReq.EventID = DBToInt64(dr.Item("EventID"))
            objRepReq.EntryExitID = DBToInt64(dr.Item("EntryExitID"))
            objRepReq.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
            objRepReq.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
            objRepReq.EntryExit = DBToBool(dr.Item("EntryExit"))
            objRepReq.EventDate = CompleteDateToStr(dr.Item("EventDate"))
            objRepReq.EventCode = DBToInt(dr.Item("EventCode"))
            objRepReq.SourceEventCode = DBToInt(dr.Item("SourceEventCode"))
            objRepReq.Status = DBToInt(dr.Item("Status"))
            objRepReq.Classification = DBToStr(dr.Item("Classification"))
            objRepReq.NoteToNext = DBToStr(dr.Item("NoteToNext"))
            objRepReq.Notification = DBToStr(dr.Item("Notification"))
            objRepReq.UserInfo.UserID = DBToInt(dr.Item("UserID"))
            objRepReq.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
            objRepReq.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
            objRepReq.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
            objRepReq.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))

            dr.Close()
            cm.CommandText = "sp_loadReproductionRequest"
            dr = cm.ExecuteReader

            While dr.Read
                objRepReq.ReferenceDigitarq = DBToStr(dr.Item("ReferenceDigitarq"))
                objRepReq.SearchValue = DBToBool(dr.Item("Search"))
                objRepReq.ReproductionValue = DBToBool(dr.Item("Reproduction"))
                objRepReq.TypeReproductionCode = DBToInt(dr.Item("TypeReproductionCode"))
                objRepReq.TypeReproduction = DBToStr(dr.Item("TypeReproduction"))
                objRepReq.CertificateValue = DBToBool(dr.Item("Certificate"))
                objRepReq.TypeCertificateCode = DBToInt(dr.Item("TypeCertificateCode"))
                objRepReq.TypeCertificate = DBToStr(dr.Item("TypeCertificate"))
                objRepReq.Destination = DBToStr(dr.Item("Destination"))
                objRepReq.RedutionsCosts = DBToStr(dr.Item("RedutionsCosts"))
                objRepReq.NumberCopies = DBToStr(dr.Item("NumberCopies"))
                'objRepReq.RequestPrice = DBToStr(dr.Item("RequestPrice"))
                'objRepReq.FormPaymentCode = DBToStr(dr.Item("FormPaymentCode"))
                'objRepReq.FormPayment = DBToStr(dr.Item("FormPayment"))
                'objRepReq.FormDeliveryCode = DBToStr(dr.Item("FormDeliveryCode"))
                'objRepReq.FormDelivery = DBToStr(dr.Item("FormDelivery"))
                objRepReq.AdditionalInformation = DBToStr(dr.Item("AdditionalInformation"))
                objRepReq.RequestSubTypeCode = DBToInt(dr.Item("RequestSubTypeCode"))
            End While

            dr.Close()
            Select Case objRepReq.RequestSubTypeCode
                Case ReproductionRequest.eRequestSubType.parochial
                    cm.CommandText = "sp_loadParochialRequest"
                    dr = cm.ExecuteReader
                    While dr.Read()
                        objRepReq.KindActionPrcCode = DBToStr(dr.Item("KindActionPrcCode"))
                        objRepReq.KindActionPrc = DBToStr(dr.Item("KindActionPrc"))
                        objRepReq.Address = DBToStr(dr.Item("Address"))
                        objRepReq.Region = DBToStr(dr.Item("Region"))
                        objRepReq.Name = DBToStr(dr.Item("Name"))
                        objRepReq.FiliationFather = DBToStr(dr.Item("FiliationFather"))
                        objRepReq.FiliationMather = DBToStr(dr.Item("FiliationMather"))
                        objRepReq.Spouse = DBToStr(dr.Item("Spouse"))
                        objRepReq.SeatNumber = DBToStr(dr.Item("SeatNumber"))
                        objRepReq.SeatYear = DBToStr(dr.Item("SeatYear"))
                        objRepReq.PageNumberPrc = DBToStr(dr.Item("PageNumber"))
                        objRepReq.InitialDate = DBToStr(dr.Item("InitialDate"))
                        objRepReq.FinalDate = DBToStr(dr.Item("FinalDate"))
                        'objRepReq.AdditionalInformation = DBToStr(dr.Item("AdditionalInformation"))
                    End While

                Case ReproductionRequest.eRequestSubType.notarial
                    cm.CommandText = "sp_loadNotaryRequest"
                    dr = cm.ExecuteReader
                    While dr.Read()
                        objRepReq.KindActionNotCode = DBToStr(dr.Item("KindActionNotCode"))
                        objRepReq.KindActionNot = DBToStr(dr.Item("KindActionNot"))
                        objRepReq.Notary = DBToStr(dr.Item("Notary"))
                        objRepReq.CartoryNumber = DBToStr(dr.Item("CartoryNumber"))
                        objRepReq.Locality = DBToStr(dr.Item("Locality"))
                        objRepReq.ParticipantsAction = DBToStr(dr.Item("ParticipantsAction"))
                        objRepReq.PageNumberNot = DBToStr(dr.Item("PageNumber"))
                        objRepReq.InitialDate = DBToStr(dr.Item("InitialDate"))
                        objRepReq.FinalDate = DBToStr(dr.Item("FinalDate"))
                        'objRepReq.AdditionalInformation = DBToStr(dr.Item("AdditionalInformation"))
                    End While

                Case ReproductionRequest.eRequestSubType.other
                    cm.CommandText = "sp_loadOtherRequest"
                    dr = cm.ExecuteReader
                    While dr.Read()
                        objRepReq.Fonds = DBToStr(dr.Item("Fonds"))
                        objRepReq.NamesOther = DBToStr(dr.Item("Name"))
                        objRepReq.TermsWords = DBToStr(dr.Item("TermsWords"))
                        objRepReq.Document = DBToStr(dr.Item("Document"))
                        objRepReq.Localities = DBToStr(dr.Item("Localities"))
                        objRepReq.InitialDate = DBToStr(dr.Item("InitialDate"))
                        objRepReq.FinalDate = DBToStr(dr.Item("FinalDate"))
                        'objRepReq.AdditionalInformation = DBToStr(dr.Item("AdditionalInformation"))
                    End While
            End Select

            myReturn = eReturn.Sucess
            Return objRepReq
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            dr.Close()
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getRequestType(ByVal intRequestID As Int64) As Event_.eEventType
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getRequestType", cn)
        cm.CommandType = CommandType.StoredProcedure
        Try
            cn.Open()
            cm.Parameters.Add("@RequestID", intRequestID)
            Dim ret As String = cm.ExecuteScalar
            myReturn = eReturn.Sucess
            Return ret
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getValidateRequestID(ByVal intCurrentID As Int64, ByVal intValidateRequestCode As Integer) As Int64
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getValidateRequestID", cn)
        cm.CommandType = CommandType.StoredProcedure
        Try
            cn.Open()
            cm.Parameters.Add("@CurrentID", intCurrentID)
            cm.Parameters.Add("@ValidateRequestCode", intValidateRequestCode)
            cm.Parameters.Add("@ValidateRequestID", SqlDbType.BigInt)
            cm.Parameters("@ValidateRequestID").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            Return DBToInt64(cm.Parameters("@ValidateRequestID").Value)
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getLastEventID(ByVal intEventID As Int64) As Int64
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getLastEventID", cn)
        cm.CommandType = CommandType.StoredProcedure
        Try
            cn.Open()
            cm.Parameters.Add("@EventID", intEventID)
            cm.Parameters.Add("@LastEventID", SqlDbType.BigInt)
            cm.Parameters("@LastEventID").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            Return DBToInt64(cm.Parameters("@LastEventID").Value)
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getAscendantEvents(ByVal intEventID As Integer) As EventCollection
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim ecAscendantEvents As New EventCollection

        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_loadEvent"

            While intEventID <> 0
                cm.Parameters.Add("@EventID", intEventID)
                dr = cm.ExecuteReader
                Dim objEvent As New Event_
                While dr.Read
                    objEvent.EventID = DBToInt64(dr.Item("EventID"))
                    objEvent.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
                    objEvent.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
                    objEvent.EventDate = DBToStr(dr.Item("EventDate"))
                    objEvent.EventCode = DBToInt(dr.Item("EventCode"))
                    objEvent.Status = DBToInt(dr.Item("Status"))
                    objEvent.Classification = DBToStr(dr.Item("Classification"))
                    objEvent.NoteToNext = DBToStr(dr.Item("NoteToNext"))
                    objEvent.UserInfo.UserID = DBToInt(dr.Item("UserID"))
                    objEvent.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
                    objEvent.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
                    objEvent.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
                    objEvent.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))
                End While
                cm.Parameters.Clear()
                dr.Close()
                ecAscendantEvents.Add(objEvent)
                intEventID = CInt(objEvent.DerivedFrom)
            End While

            myReturn = eReturn.Sucess
            Return ecAscendantEvents
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function IsAvailable(ByVal strReference As String, _
    ByVal strDate As String, ByVal strPartDay As String) As Boolean
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_IsUnavailableResReq", cn)
        Dim dr As SqlDataReader
        Dim objUser As New User
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ReferenceDigitarq", strReference)
            cm.Parameters.Add("@ReserveDate", strDate)
            cm.Parameters.Add("@PartDay", strPartDay)
            dr = cm.ExecuteReader
            If Not dr.HasRows Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function IsAvailableComponent(ByVal strReference As String) As Boolean
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_isAvailable", cn)
        cm.CommandType = CommandType.StoredProcedure
        Try
            cn.Open()
            cm.Parameters.Add("@Reference", strReference)
            cm.Parameters.Add("@Available", SqlDbType.Bit)
            cm.Parameters("@Available").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            Return DBToBool(cm.Parameters("@Available").Value)
        Catch ex As Exception
            Dim erro As String = ex.ToString
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Function loadRequests(ByVal eventType As String, ByVal field As String, ByVal term As String, Optional ByVal wildchar As String = "%") As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()

            Dim CommandText As String
            If field = "EventDate" Then
                CommandText = "SELECT E.*, U.Fullname AS FullName FROM Events E " & _
                              "INNER JOIN Users U ON E.UserID=U.UserID " & _
                              "WHERE EntryExitID IS NOT NULL AND CONVERT(varchar(10),E.EventDate,126) LIKE " & "'" & wildchar & term & wildchar & "'"
            Else
                CommandText = "SELECT E.*, U.Fullname AS FullName FROM Events E " & _
                              "INNER JOIN Users U ON E.UserID=U.UserID " & _
                              "WHERE EntryExitID IS NOT NULL AND " & field & " LIKE " & "'" & wildchar & term & wildchar & "'"
            End If

            If eventType <> "" Then
                CommandText += " AND EventCode=" & eventType
            End If

            da = New SqlDataAdapter(CommandText, cn)
            da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Processes"

    Public Overrides Function storeProcess(ByVal objProcess As Process) As Integer()
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim Ret(2) As Integer

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Connection = cn

            cm.CommandText = "sp_storeProcess"

            cm.Parameters.Add("@ProcessType", StrToDB(objProcess.ProcessType))
            cm.Parameters.Add("@Classification", StrToDB(objProcess.Classification))
            cm.Parameters.Add("@Subject", StrToDB(objProcess.Subject))
            cm.Parameters.Add("@FolderID", StrToDB(objProcess.FolderID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objProcess.Employee.UserName))
            cm.Parameters.Add("@InitialDate", StrToDB(objProcess.InitialDate))
            cm.Parameters.Add("@FinalDate", StrToDB(objProcess.FinalDate))
            cm.Parameters.Add("@UserID", IntToDB(objProcess.UserInfo.UserID))

            cm.Parameters.Add("@ProcessID", SqlDbType.BigInt)
            cm.Parameters("@ProcessID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@OtherProcessID", SqlDbType.Int)
            cm.Parameters("@OtherProcessID").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objProcess.ProcessID = cm.Parameters("@ProcessID").Value
            objProcess.OtherProcessID = cm.Parameters("@OtherProcessID").Value

            myReturn = eReturn.Sucess
            Ret(0) = objProcess.ProcessID
            Ret(1) = objProcess.OtherProcessID
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
        Return Ret
    End Function

    Public Overrides Function loadProcess(ByVal intProcessID As Integer) As Process
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadProcess", cn)
        Dim dr As SqlDataReader
        Dim objProcess As New Process
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProcessID", intProcessID)

            dr = cm.ExecuteReader()
            dr.Read()
            objProcess.ProcessID = DBToInt(dr.Item("ProcessID"))
            objProcess.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))
            objProcess.ProcessType = DBToInt(dr.Item("ProcessType"))
            objProcess.Classification = DBToStr(dr.Item("Classification"))
            objProcess.Subject = DBToStr(dr.Item("Subject"))
            objProcess.FolderID = DBToStr(dr.Item("FolderID"))
            objProcess.Employee.UserName = DBToStr(dr.Item("EmployeeID"))
            objProcess.Employee.FullName = DBToStr(dr.Item("Employee"))
            objProcess.InitialDate = DBToStr(dr.Item("InitialDate"))
            objProcess.FinalDate = DBToStr(dr.Item("FinalDate"))
            objProcess.UserInfo.UserID = DBToInt(dr.Item("UserID"))
            objProcess.UserInfo.FullName = DBToStr(dr.Item("FullName"))

            myReturn = eReturn.Sucess
            Return objProcess
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function updateProcess(ByVal objProcess As Process) As Boolean
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateProcess", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProcessID", IntToDB(objProcess.ProcessID))
            cm.Parameters.Add("@ProcessType", StrToDB(objProcess.ProcessType))
            cm.Parameters.Add("@Classification", StrToDB(objProcess.Classification))
            cm.Parameters.Add("@Subject", StrToDB(objProcess.Subject))
            cm.Parameters.Add("@FolderID", StrToDB(objProcess.FolderID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objProcess.Employee.UserName))
            cm.Parameters.Add("@InitialDate", StrToDB(objProcess.InitialDate))
            cm.Parameters.Add("@FinalDate", StrToDB(objProcess.FinalDate))
            cm.Parameters.Add("@UserID", IntToDB(objProcess.UserInfo.UserID))
            cm.ExecuteNonQuery()
            Return True
        Catch ex As Exception
            Throw (ex)
            Return False
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Sub deleteProcess(ByVal intProcessID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteProcess", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProcessID", intProcessID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function loadProcessEvents(ByVal intProcessID As Integer) As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadProcessEvents", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@ProcessID", intProcessID)
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet)

            myReturn = eReturn.Sucess
            Return objDataSet
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            objDataSet.Dispose()
            objDataAdapter.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getProcessID(ByVal intOtherProcessID As Int64) As Int64
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getProcessID", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@OtherProcessID", IntToDB(intOtherProcessID))
            cm.Parameters.Add("@ProcessID", SqlDbType.BigInt)
            cm.Parameters("@ProcessID").Direction = ParameterDirection.Output
            cm.ExecuteNonQuery()
            Return DBToInt64(cm.Parameters("@ProcessID").Value)
        Catch ex As Exception
            Throw (ex)
            Return -1
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function loadProcesses(ByVal processType As String, ByVal field As String, ByVal term As String, Optional ByVal wildchar As String = "%") As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()

            Dim CommandText As String = "SELECT P.*, E.FirstName + ' ' + E.LastName AS Employee, U.FullName FROM Processes P " & _
                                        "LEFT JOIN Employees E ON P.EmployeeID=E.Username " & _
                                        "LEFT JOIN Users U ON P.UserID=U.UserID " & _
                                        "WHERE " & field & " LIKE " & "'" & wildchar & term & wildchar & "'"
            If processType <> "" Then
                CommandText += " AND ProcessType=" & processType
            End If

            da = New SqlDataAdapter(CommandText, cn)
            da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Emoluments"

    Public Overrides Function storeEmolument(ByVal objEmolument As Emolument) As Integer
        Dim cn As New SqlConnection
        Dim tran As SqlTransaction
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim Ret(2) As Integer

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Connection = cn

            cm.CommandText = "sp_storeEmolument"

            cm.Parameters.Add("@EmolumentDate", StrToDB(objEmolument.EmolumentDate))
            cm.Parameters.Add("@ReceiptNumber", StrToDB(objEmolument.ReceiptNumber))
            cm.Parameters.Add("@IVA", StrToDB(objEmolument.IVA))
            cm.Parameters.Add("@Cost", StrToDB(objEmolument.Cost))
            'cm.Parameters.Add("@CertificateNumber", StrToDB(objEmolument.CertificateNumber))
            cm.Parameters.Add("@Exemption", StrToDB(objEmolument.Exemption))
            cm.Parameters.Add("@Note", StrToDB(objEmolument.Note))
            cm.Parameters.Add("@CategoryID", StrToDB(objEmolument.CategoryID))

            cm.Parameters.Add("@EmolumentID", SqlDbType.BigInt)
            cm.Parameters("@EmolumentID").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objEmolument.EmolumentID = cm.Parameters("@EmolumentID").Value

            myReturn = eReturn.Sucess
            Return objEmolument.EmolumentID
        Catch ex As Exception
            Throw (ex)
            Return 0
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Function loadEmolument(ByVal intEmolumentID As Integer) As Emolument
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadProcess", cn)
        Dim dr As SqlDataReader
        Dim objEmolument As New Emolument
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ProcessID", intEmolumentID)

            dr = cm.ExecuteReader()
            dr.Read()
            'objProcess.ProcessID = DBToInt(dr.Item("ProcessID"))
            'objProcess.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))
            'objProcess.ProcessType = DBToInt(dr.Item("ProcessType"))
            'objProcess.Classification = DBToStr(dr.Item("Classification"))
            'objProcess.Subject = DBToStr(dr.Item("Subject"))
            'objProcess.FolderID = DBToStr(dr.Item("FolderID"))
            'objProcess.Employee.UserName = DBToStr(dr.Item("EmployeeID"))
            'objProcess.Employee.FullName = DBToStr(dr.Item("Employee"))
            'objProcess.InitialDate = DBToStr(dr.Item("InitialDate"))
            'objProcess.FinalDate = DBToStr(dr.Item("FinalDate"))

            myReturn = eReturn.Sucess
            Return objEmolument
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    'Public Overrides Sub updateProcess(ByVal objProcess As Process)
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim cm As New SqlCommand("sp_updateProcess", cn)

    '    Try
    '        cn.Open()
    '        cm.CommandType = CommandType.StoredProcedure
    '        cm.Parameters.Add("@ProcessID", objProcess.ProcessID)
    '        cm.Parameters.Add("@ProcessType", objProcess.ProcessType)
    '        cm.Parameters.Add("@Classification", StrToDB(objProcess.Classification))
    '        cm.Parameters.Add("@Subject", StrToDB(objProcess.Subject))
    '        cm.Parameters.Add("@FolderID", StrToDB(objProcess.FolderID))
    '        cm.Parameters.Add("@EmployeeID", StrToDB(objProcess.Employee.UserName))
    '        cm.Parameters.Add("@InitialDate", StrToDB(objProcess.InitialDate))
    '        cm.Parameters.Add("@FinalDate", StrToDB(objProcess.FinalDate))
    '        cm.ExecuteNonQuery()
    '        myReturn = eReturn.Sucess
    '    Catch ex As Exception
    '        Dim erro As String = ex.ToString
    '        myReturn = eReturn.ErrorDB
    '    Finally
    '        cn.Close()
    '    End Try
    'End Sub

    'Public Overrides Function getCertificateNumber() As Int64
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim cm As New SqlCommand("sp_getCertificateNumber", cn)

    '    Try
    '        cn.Open()
    '        cm.CommandType = CommandType.StoredProcedure
    '        cm.Parameters.Add("@Count", SqlDbType.Int)
    '        cm.Parameters("@Count").Direction = ParameterDirection.Output
    '        cm.ExecuteNonQuery()
    '        Return cm.Parameters("@Count").Value
    '    Catch ex As Exception
    '        myReturn = eReturn.ErrorDB
    '    Finally
    '        cn.Close()
    '    End Try

    'End Function

    Public Function loadEmoluments() As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()
            da = New SqlDataAdapter("sp_loadEmoluments", cn)
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            'da.SelectCommand.Parameters.Add("@CategoryID", intCategoryID)
            da.Fill(ds)

            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            ds.Dispose()
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function loadEmoluments(ByVal categoryID As String, ByVal year As String, ByVal month As String) As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()

            If month = "" Then
                month = "%"
            End If
            Dim CommandText As String = String.Format("SELECT  EmolumentID, EmolumentDate, ReceiptNumber, " & _
                                        "C.CategoryID, Category, CertificateNumber, Exemption, IVA, Cost, Note " & _
                                        "FROM Emoluments AS E " & _
                                        "INNER JOIN Categories AS C ON E.CategoryID=C.CategoryID " & _
                                        "WHERE E.EmolumentDate LIKE '{0}-{1}-%'", year, month)

            If categoryID <> "" Then
                CommandText += " AND E.CategoryID='" & categoryID & "'"
            End If

            da = New SqlDataAdapter(CommandText, cn)
            Dim num As Integer = da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            da.Dispose()
            ds.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function loadEmolumentsGroupByReceiptNumber(ByVal categoryID As String, ByVal year As String, ByVal month As String) As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()

            Dim CommandText As String = "SELECT ReceiptNumber AS ""Nmero recibo"", " & _
                                        "CAST(SUM(Cost)-(IVA*SUM(Cost)/(100+IVA)) AS DECIMAL(4,2)) AS ""Valor Lquido"", " & _
                                        "CAST(IVA AS NVARCHAR(5)) + '%' AS IVA, " & _
                                        "CAST(IVA*SUM(Cost)/(100+IVA) AS DECIMAL(4,2)) AS ""Valor IVA"", " & _
                                        "CAST(SUM(Cost) AS DECIMAL(4,2)) AS ""Valor Total"" " & _
                                        "FROM Emoluments " & _
                                        "WHERE SUBSTRING(EmolumentDate,0,5)='" & year & "'"
            If month <> "" Then
                CommandText += " AND EmolumentDate LIKE '%-" & month & "-%'"
            End If
            If categoryID <> "" Then
                CommandText += " AND CategoryID='" & categoryID & "'"
            End If
            CommandText += " GROUP BY ReceiptNumber, IVA"

            da = New SqlDataAdapter(CommandText, cn)
            Dim num As Integer = da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            ds.Dispose()
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function loadEmolumentsGroupByReceiptNumber() As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()
            da = New SqlDataAdapter("sp_loadEmolumentsGroupByReceiptNumber", cn)
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            'da.SelectCommand.Parameters.Add("@CategoryID", intCategoryID)
            da.Fill(ds)

            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            ds.Dispose()
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Sub deleteEmolument(ByVal intEmolumentID As Int64)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteEmolument", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@EmolumentID", intEmolumentID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function getTotalCostEmoluments() As Double
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_getTotalCostEmoluments", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            Return cm.ExecuteScalar
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function getEmolumentsYears() As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()
            da = New SqlDataAdapter("sp_getEmolumentsYears", cn)
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            da.Fill(ds)
            Return ds
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            ds.Dispose()
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Services"

    Public Overrides Sub storeService(ByVal objService As Service)

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeService", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@Service", objService.Service)
            cm.Parameters.Add("@UnitPrice", objService.UnitPrice)
            cm.Parameters.Add("@CategoryID", objService.CategoryID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Sub

    Public Overloads Overrides Function loadServices(ByVal ddl As DropDownList, ByVal intCategoryID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadServices", cn)
        'Dim dr As SqlDataReader
        'Dim colProfiles As New Collection
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@CategoryID", intCategoryID)
            ddl.DataValueField = "UnitPrice"
            ddl.DataTextField = "Service"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()

        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overloads Overrides Function loadServices(ByVal dg As DataGrid, ByVal intCategoryID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As New DataSet
        'Dim objServiceCollection As ServiceCollection

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadServices", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataAdapter.SelectCommand.Parameters.Add("@CategoryID", intCategoryID)
            'objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet)
            'objDataAdapter.Fill(objServiceCollection)

            dg.DataSource = objDataSet
            dg.DataBind()
        Catch ex As Exception
            Throw (ex)
        Finally
            objDataAdapter.Dispose()
            objDataSet.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Function

    Public Overloads Overrides Function loadServices(ByVal intCategoryID As Integer) As DataTable
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim da As New SqlDataAdapter("sp_loadServices", cn)
        Dim dt As New DataTable
        Try
            cn.Open()
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            da.SelectCommand.Parameters.Add("@CategoryID", intCategoryID)
            dt.Constraints.Add("pk", dt.Columns.Add("ServiceID", GetType(String)), True)
            da.Fill(dt)

            myReturn = eReturn.Sucess
            Return dt
        Catch ex As Exception
            Throw (ex)
        Finally
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function


    Public Overrides Sub deleteService(ByVal intServiceID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteService", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ServiceID", intServiceID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overloads Overrides Sub updateService(ByVal objService As Service)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateService", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@ServiceID", objService.ServiceID)
            cm.Parameters.Add("@Service", objService.Service)
            cm.Parameters.Add("@UnitPrice", objService.UnitPrice)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

#End Region


#Region "Categories"

    Public Overrides Sub storeCategory(ByVal strCategoryName As String)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeCategory", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@CategoryName", strCategoryName)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overloads Overrides Function loadCategories() As DataSet
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim objDataAdapter As SqlDataAdapter
        Dim objDataSet As DataSet

        Try
            cn.Open()
            objDataAdapter = New SqlDataAdapter("sp_loadCategories", cn)
            objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
            objDataSet = New DataSet
            objDataAdapter.Fill(objDataSet)

            Return objDataSet
        Catch ex As Exception
            Throw (ex)
        Finally
            objDataAdapter.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Function

    Public Overloads Overrides Sub loadCategories(ByVal ddl As DropDownList)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadCategories", cn)
        'Dim dr As SqlDataReader
        'Dim colProfiles As New Collection
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            ddl.DataValueField = "CategoryID"
            ddl.DataTextField = "Category"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()

        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Sub

    Public Overloads Overrides Sub updateCategory(ByVal intCategoryID As Integer, ByVal strCategoryName As String)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateCategory", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@CategoryID", intCategoryID)
            cm.Parameters.Add("@CategoryName", strCategoryName)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Sub

    Public Overrides Sub deleteCategory(ByVal intCategoryID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteCategory", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@CategoryID", intCategoryID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function countCategories() As Integer
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_countCategories", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@Count", SqlDbType.Int)
            cm.Parameters("@Count").Direction = ParameterDirection.Output
            cm.ExecuteNonQuery()
            Return cm.Parameters("@Count").Value
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Function

    'Public Overrides Function countCats() As Integer
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim cm As New SqlCommand("sp_countCategories", cn)

    '    Try
    '        cn.Open()
    '        cm.CommandType = CommandType.StoredProcedure
    '        cm.Parameters.Add("@Count", SqlDbType.Int)
    '        cm.Parameters("@Count").Direction = ParameterDirection.Output
    '        cm.ExecuteNonQuery()
    '        Return cm.Parameters("@Count").Value
    '    Catch ex As Exception
    '        myReturn = eReturn.ErrorDB
    '    Finally
    '        cn.Close()
    '    End Try

    'End Function


#End Region


#Region "Tasks"

    Public Overrides Sub storeTask(ByVal objTask As Task)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim tran As SqlTransaction
        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_storeEvent"
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objTask.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objTask.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objTask.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objTask.EventCode))
            cm.Parameters.Add("@SourceEventCode", Int64ToDB(objTask.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objTask.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objTask.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objTask.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objTask.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objTask.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objTask.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objTask.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objTask.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objTask.Process.ProcessID))
            cm.Parameters.Add("@EventID", SqlDbType.BigInt)
            cm.Parameters("@EventID").Direction = ParameterDirection.Output
            cm.Parameters.Add("@EntryExitIDOUT", SqlDbType.BigInt)
            cm.Parameters("@EntryExitIDOUT").Direction = ParameterDirection.Output

            cm.ExecuteNonQuery()
            objTask.EventID = cm.Parameters("@EventID").Value

            cm.Parameters.Clear()
            cm.CommandText = "sp_storeTask"
            cm.Parameters.Add("@EventID", objTask.EventID)
            cm.Parameters.Add("@Type", StrToDB(objTask.Type))
            cm.Parameters.Add("@Note", StrToDB(objTask.Note))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            For i As Integer = 0 To objTask.ListServices.Rows.Count - 1
                cm.CommandText = "sp_storeTaskDetails"
                cm.Parameters.Add("@TaskID", objTask.EventID)
                cm.Parameters.Add("@ServiceID", objTask.ListServices.Rows(i).Item("ServiceID"))
                cm.Parameters.Add("@UnitPrice", objTask.ListServices.Rows(i).Item("UnitPrice"))
                cm.Parameters.Add("@Quantity", objTask.ListServices.Rows(i).Item("Quantity"))
                cm.Parameters.Add("@Attached", objTask.ListServices.Rows(i).Item("Attached"))
                cm.Parameters.Add("@AttachedName", objTask.ListServices.Rows(i).Item("AttachedName"))
                cm.Parameters.Add("@AttachedType", objTask.ListServices.Rows(i).Item("AttachedType"))
                cm.Parameters.Add("@AttachedLength", objTask.ListServices.Rows(i).Item("AttachedLength"))
                cm.ExecuteNonQuery()
                cm.Parameters.Clear()
            Next

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub updateTask(ByVal objTask As Task)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim tran As SqlTransaction
        Try
            cn.Open()
            tran = cn.BeginTransaction
            cm.Transaction = tran
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.CommandText = "sp_updateEvent"
            cm.Parameters.Add("@EventID", Int64ToDB(objTask.EventID))
            cm.Parameters.Add("@DerivedFrom", Int64ToDB(objTask.DerivedFrom))
            cm.Parameters.Add("@SourceEventID", Int64ToDB(objTask.SourceEventID))
            cm.Parameters.Add("@EntryExit", BoolToDB(objTask.EntryExit))
            cm.Parameters.Add("@EventCode", IntToDB(objTask.EventCode))
            cm.Parameters.Add("@SourceEventCode", Int64ToDB(objTask.SourceEventCode))
            cm.Parameters.Add("@Status", IntToDB(objTask.Status))
            cm.Parameters.Add("@Seen", BoolToDB(objTask.Seen))
            cm.Parameters.Add("@Classification", StrToDB(objTask.Classification))
            cm.Parameters.Add("@NoteToNext", StrToDB(objTask.NoteToNext))
            cm.Parameters.Add("@Notification", StrToDB(objTask.Notification))
            cm.Parameters.Add("@PaymentID", IntToDB(objTask.PaymentID))
            cm.Parameters.Add("@UserID", IntToDB(objTask.UserInfo.UserID))
            cm.Parameters.Add("@EmployeeID", StrToDB(objTask.EmployeeInfo.UserName))
            cm.Parameters.Add("@ProcessID", Int64ToDB(objTask.Process.ProcessID))

            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_updateTask"
            cm.Parameters.Add("@EventID", objTask.EventID)
            cm.Parameters.Add("@Type", IntToDB(objTask.Type))
            cm.Parameters.Add("@Note", StrToDB(objTask.Note))
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            cm.CommandText = "sp_deleteTaskDetails"
            cm.Parameters.Add("@TaskID", objTask.EventID)
            cm.ExecuteNonQuery()

            cm.Parameters.Clear()
            For i As Integer = 0 To objTask.ListServices.Rows.Count - 1
                cm.CommandText = "sp_storeTaskDetails"
                cm.Parameters.Add("@TaskID", objTask.EventID)
                cm.Parameters.Add("@ServiceID", objTask.ListServices.Rows(i).Item("ServiceID"))
                cm.Parameters.Add("@UnitPrice", objTask.ListServices.Rows(i).Item("UnitPrice"))
                cm.Parameters.Add("@Quantity", objTask.ListServices.Rows(i).Item("Quantity"))
                cm.Parameters.Add("@Attached", objTask.ListServices.Rows(i).Item("Attached"))
                cm.Parameters.Add("@AttachedName", objTask.ListServices.Rows(i).Item("AttachedName"))
                cm.Parameters.Add("@AttachedType", objTask.ListServices.Rows(i).Item("AttachedType"))
                cm.Parameters.Add("@AttachedLength", objTask.ListServices.Rows(i).Item("AttachedLength"))
                cm.ExecuteNonQuery()
                cm.Parameters.Clear()
            Next

            myReturn = eReturn.Sucess
            tran.Commit()
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function loadTask(ByVal intTaskID As Int64) As Task
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Dim objTask As New Task
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandType = CommandType.StoredProcedure

            cm.Parameters.Add("@EventID", intTaskID)
            cm.CommandText = "sp_loadEvent"
            dr = cm.ExecuteReader
            While dr.Read
                objTask.EventID = DBToInt64(dr.Item("EventID"))
                objTask.DerivedFrom = DBToInt64(dr.Item("DerivedFrom"))
                objTask.SourceEventID = DBToInt64(dr.Item("SourceEventID"))
                objTask.EntryExit = DBToBool(dr.Item("EntryExit"))
                objTask.EventDate = CompleteDateToStr(dr.Item("EventDate"))
                objTask.EventCode = DBToInt(dr.Item("EventCode"))
                objTask.SourceEventCode = DBToInt(dr.Item("SourceEventCode"))
                objTask.Status = DBToInt(dr.Item("Status"))
                objTask.Classification = DBToStr(dr.Item("Classification"))
                objTask.NoteToNext = DBToStr(dr.Item("NoteToNext"))
                objTask.Notification = DBToStr(dr.Item("Notification"))
                objTask.PaymentID = DBToInt(dr.Item("PaymentID"))
                objTask.UserInfo.UserID = DBToInt(dr.Item("UserID"))
                objTask.UserInfo.FullName = DBToStr(dr.Item("FullNameUser"))
                objTask.EmployeeInfo.UserName = DBToStr(dr.Item("EmployeeID"))
                objTask.Process.ProcessID = DBToInt(dr.Item("ProcessID"))
                objTask.Process.OtherProcessID = DBToInt(dr.Item("OtherProcessID"))
            End While
            dr.Close()
            cm.CommandText = "sp_loadTask"
            dr = cm.ExecuteReader
            While dr.Read
                objTask.Type = DBToInt(dr.Item("Type"))
                objTask.Note = DBToStr(dr.Item("Note"))
            End While
            dr.Close()

            Dim objLS As New DataTable
            Dim da As New SqlDataAdapter("sp_loadTaskDetails", cn)
            da.SelectCommand.CommandType = CommandType.StoredProcedure
            da.SelectCommand.Parameters.Add("@EventID", objTask.EventID)
            da.Fill(objLS)
            objTask.ListServices = objLS
            myReturn = eReturn.Sucess
            Return objTask
        Catch ex As Exception
            Throw (ex)
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            dr.Close()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Messages"

    Public Overloads Overrides Function loadMessages(ByVal ddl As DropDownList, ByVal intCategoryID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadMessages", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@CategoryID", intCategoryID)
            ddl.DataValueField = "Message"
            ddl.DataTextField = "MessageTitle"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()

        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Utils"

    Public Overrides Sub loadDdl(ByVal ddl As DropDownList, ByVal strDataValueField As String, _
    ByVal strDataTextField As String, ByVal strTable As String, Optional ByVal strStartItem As String = "Selecionar")

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand '("sp_loadEmployeeByID", cn)
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandText = "SELECT " & strDataValueField & " AS dataValueField ," & strDataTextField & " AS dataTextField FROM " & strTable & " ORDER BY dataTextField"
            ddl.DataValueField = "dataValueField"
            ddl.DataTextField = "dataTextField"
            ddl.DataSource = cm.ExecuteReader(CommandBehavior.CloseConnection)
            ddl.DataBind()
            Dim si As New ListItem
            si.Value = "0"
            si.Text = strStartItem
            ddl.Items.Insert(0, si)
        Catch ex As Exception
            Dim erro As String = ex.ToString
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Sub

#End Region


#Region "Updates"

    Public Function selectAll(ByVal table As String) As DataSet

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Dim da As SqlDataAdapter
        Dim ds As New DataSet
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandText = "SELECT COL_NAME(OBJECT_ID('" & table & "'), 1)"
            Dim FieldCodeName As String = cm.ExecuteScalar
            cm.CommandText = "SELECT COL_NAME(OBJECT_ID('" & table & "'), 2)"
            Dim FieldDescriptionName As String = cm.ExecuteScalar

            Dim CommandText As String = "SELECT " & FieldCodeName & " AS Code," & FieldDescriptionName & " AS Description FROM " & table
            da = New SqlDataAdapter(CommandText, cn)
            da.Fill(ds)
            Return ds
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            da.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function IdentitySeed(ByVal table As String) As String

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandText = "SELECT IDENT_SEED ('" & table & "')"
            Dim strIdentity As String = DBToStr(cm.ExecuteScalar)

            Return strIdentity
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function delete(ByVal table As String, ByVal strCodeValue As String) As Boolean

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Try
            cn.Open()
            cm.Connection = cn

            cm.CommandText = "SELECT COL_NAME(OBJECT_ID('" & table & "'), 1)"
            Dim strFieldCodeName As String = cm.ExecuteScalar
            cm.CommandText = "DELETE FROM " & table & " WHERE " & strFieldCodeName & " = " & strCodeValue
            cm.ExecuteNonQuery()
            Return True
        Catch ex As Exception
            Throw (ex)
            Return False
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try

    End Function

    Public Function insert(ByVal table As String, ByVal strDescriptionValue As String, Optional ByVal strCodeValue As String = Nothing) As Boolean

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Try
            cn.Open()
            cm.Connection = cn
            If strCodeValue = "" Then
                cm.CommandText = "INSERT INTO " & table & " VALUES ('" & strDescriptionValue & "')"
            Else
                cm.CommandText = "INSERT INTO " & table & " VALUES ('" & strCodeValue & "','" & strDescriptionValue & "')"
            End If
            cm.ExecuteNonQuery()
            Return True
        Catch ex As Exception
            Return False
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Function update(ByVal table As String, ByVal strDescriptionValue As String, ByVal strCodeValue As String) As Boolean

        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand
        Try
            cn.Open()
            cm.Connection = cn
            cm.CommandText = "SELECT COL_NAME(OBJECT_ID('" & table & "'), 1)"
            Dim strFieldCodeName As String = cm.ExecuteScalar
            cm.CommandText = "SELECT COL_NAME(OBJECT_ID('" & table & "'), 2)"
            Dim strFieldDescriptionName As String = cm.ExecuteScalar

            cm.CommandText = "UPDATE " & table & " SET " & strFieldDescriptionName & " = '" & strDescriptionValue & "'" & _
                             " WHERE " & strFieldCodeName & " = '" & strCodeValue & "'"
            cm.ExecuteNonQuery()
            Return True
        Catch ex As Exception
            Return False
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

#End Region


#Region "Notes"

    Public Overrides Sub storeNote(ByVal objNote As Note)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeNote", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@NoteTitle", objNote.NoteTitle)
            cm.Parameters.Add("@NoteDate", objNote.NoteDate)
            cm.Parameters.Add("@Note", objNote.Note)
            cm.Parameters.Add("@UserID", objNote.UserID)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Function loadNotes(ByVal intUserID As Integer) As NoteCollection
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadNotes", cn)
        Dim dr As SqlDataReader
        Dim objNoteCollection As New NoteCollection
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@UserID", intUserID)

            dr = cm.ExecuteReader()
            While dr.Read
                Dim objNote As New Note
                objNote.NoteID = dr.Item("NoteID")
                objNote.NoteTitle = DBToStr(dr.Item("NoteTitle"))
                objNote.NoteDate = DBToStr(dr.Item("NoteDate"))
                objNote.Note = DBToStr(dr.Item("Note"))
                objNoteCollection.Add(objNote)
            End While
            myReturn = eReturn.Sucess
            Return objNoteCollection
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Sub updateNote(ByVal objNote As Note)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateNote", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@NoteID", objNote.NoteID)
            cm.Parameters.Add("@NoteTitle", objNote.NoteTitle)
            cm.Parameters.Add("@NoteDate", objNote.NoteDate)
            cm.Parameters.Add("@Note", objNote.Note)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub deleteNote(ByVal intNoteID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteNote", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@NoteID", intNoteID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

#End Region

#Region "Messages"

    Public Overrides Sub storeMessage(ByVal objMessage As Message)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_storeMessage", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@MessageTitle", objMessage.MessageTitle)
            cm.Parameters.Add("@Message", objMessage.Message)
            cm.ExecuteNonQuery()

            myReturn = eReturn.Sucess
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overloads Overrides Function loadMessages() As MessageCollection
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_loadMessages", cn)
        Dim dr As SqlDataReader
        Dim objMessageCollection As New MessageCollection
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure

            dr = cm.ExecuteReader()
            While dr.Read
                Dim objMessage As New Message
                objMessage.MessageID = dr.Item("MessageID")
                objMessage.MessageTitle = DBToStr(dr.Item("MessageTitle"))
                objMessage.Message = DBToStr(dr.Item("Message"))
                objMessageCollection.Add(objMessage)
            End While
            myReturn = eReturn.Sucess
            Return objMessageCollection
        Catch ex As Exception
            Throw (ex)
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Function

    Public Overrides Sub updateMessage(ByVal objMessage As Message)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_updateMessage", cn)

        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@MessageID", objMessage.MessageID)
            cm.Parameters.Add("@MessageTitle", objMessage.MessageTitle)
            cm.Parameters.Add("@Message", objMessage.Message)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

    Public Overrides Sub deleteMessage(ByVal intMessageID As Integer)
        Dim cn As New SqlConnection
        cn.ConnectionString = myConnStringCRAV
        Dim cm As New SqlCommand("sp_deleteMessage", cn)
        Try
            cn.Open()
            cm.CommandType = CommandType.StoredProcedure
            cm.Parameters.Add("@MessageID", intMessageID)
            cm.ExecuteNonQuery()
            myReturn = eReturn.Sucess
        Catch ex As Exception
            myReturn = eReturn.ErrorDB
        Finally
            cm.Dispose()
            cn.Close()
            cn.Dispose()
        End Try
    End Sub

#End Region

End Class
