Imports System
Imports System.Collections
Imports System.String
Imports System.xml
Imports System.IO
Imports DigitArq.Data.Entities.MGUP



Public Class Event_
    Inherits BaseClassP


#Region "Internal Properties (private)"

    Private myEventID As Int64
    Private myEntryExitID As Int64
    Private myDerivedFrom As Int64
    Private mySourceEventID As Int64
    Private mySourceEventCode As eEventType
    Private myEventDate As String
    Private myEntryExit As Boolean
    Private mySeen As Boolean

    Private myEventCode As eEventType
    Private myEventName As String
    Private myEventDesignation As String

    Private myInputEvents As New Hashtable
    Private myPossibleNextEvents As New Hashtable

    Private myNextEvents As New EventCollection

    Private myStatus As eStatus
    Private myStatusName As String
    Private myStatusDesignation As String

    Private myClassification As String
    Private myNoteToNext As String
    Private myNotification As String

    Private myPayment As ePayment

    Private myUser As New User
    Private myEmployee As New Employee
    Private myNextEmployee As New Employee
    Private myProcess As New Process

    Private myUserGroups As New ArrayList
    Private myNextUserGroups As New ArrayList

    Private mySelectNextTasks As Boolean

    Private myJoinCode As String
    Private mySplitCode As String

    Private mySubmitStatus As eSubmitStatus

    Private WF_XML_FILENAME As String

    Public Enum eEventType
        none
        consultationRequest
        reservationRequest
        reproductionRequest
        correspondenceIn
        correspondenceOut
        validateRequest
        budget
        validateBudget
        correctBudget
        reproduction
        validateReproduction
        search
        validateSearch
        certification
        payment
        checkPayment
        notification
        consultation
        reservation
        sendReproductionToUser
        sendSearchToUser
        validateRequestNotification
        output
    End Enum

    Public Enum eStatus
        None
        Submited
        Pendent
        Attended
        Taken
        PendentTaken
        Assigned
    End Enum

    Public Enum eSubmitStatus
        None
        ExitWithoutSave
        SaveExit
        Submit
        SendUser
    End Enum

    Public Enum ePayment
        None
        ATM
        CreditCard
        Postal
        Transfer
    End Enum

#End Region

#Region "Inicializations"

    Public Sub New()
    End Sub

    Public Sub New(ByVal strEventTypeCode As String, ByVal eSourceEventType As eEventType)
        EventCode = getEnumEventCode(strEventTypeCode)
        XMLToEvent(strEventTypeCode, eSourceEventType)
    End Sub

#End Region

#Region "Gets and Sets of Public Properties"

    Public Property EventID() As Int64
        Get
            Return myEventID
        End Get
        Set(ByVal Value As Int64)
            myEventID = Value
        End Set
    End Property

    Public Property EntryExitID() As Int64
        Get
            Return myEntryExitID
        End Get
        Set(ByVal Value As Int64)
            myEntryExitID = Value
        End Set
    End Property

    Public Property DerivedFrom() As Int64
        Get
            Return myDerivedFrom
        End Get
        Set(ByVal Value As Int64)
            myDerivedFrom = Value
        End Set
    End Property

    Public Property SourceEventID() As Int64
        Get
            Return mySourceEventID
        End Get
        Set(ByVal Value As Int64)
            mySourceEventID = Value
        End Set
    End Property

    Public Property EventDate() As String
        Get
            Return myEventDate
        End Get
        Set(ByVal Value As String)
            myEventDate = Value
        End Set
    End Property

    Public Property EntryExit() As Boolean
        Get
            Return myEntryExit
        End Get
        Set(ByVal Value As Boolean)
            myEntryExit = Value
        End Set
    End Property

    Public Property Seen() As Boolean
        Get
            Return mySeen
        End Get
        Set(ByVal Value As Boolean)
            mySeen = Value
        End Set
    End Property

    Public Property SourceEventCode() As eEventType
        Get
            Return mySourceEventCode
        End Get
        Set(ByVal Value As eEventType)
            mySourceEventCode = Value
        End Set
    End Property

    Public Property EventCode() As eEventType
        Get
            Return myEventCode
        End Get
        Set(ByVal Value As eEventType)
            myEventCode = Value
        End Set
    End Property

    Public Property EventName() As String
        Get
            Return Me.getStrEventCode(myEventCode)
        End Get
        Set(ByVal Value As String)
            myEventName = Value
        End Set
    End Property

    Public Property EventDesignation() As String
        Get
            Return GetLabel("event." & myEventCode)
        End Get
        Set(ByVal value As String)
            myEventDesignation = value
        End Set
    End Property

    Public Property Status() As eStatus
        Get
            Return myStatus
        End Get
        Set(ByVal Value As eStatus)
            myStatus = Value
        End Set
    End Property

    Public Property StatusDesignation() As String
        Get
            Return GetLabel("status." & myStatus)
        End Get
        Set(ByVal Value As String)
            myStatusDesignation = Value
        End Set
    End Property

    Public Property Classification() As String
        Get
            Return myClassification
        End Get
        Set(ByVal Value As String)
            myClassification = Value
        End Set
    End Property

    Public Property NoteToNext() As String
        Get
            Return myNoteToNext
        End Get
        Set(ByVal Value As String)
            myNoteToNext = Value
        End Set
    End Property

    Public Property Notification() As String
        Get
            Return myNotification
        End Get
        Set(ByVal Value As String)
            myNotification = Value
        End Set
    End Property

    Public Property PaymentID() As ePayment
        Get
            Return myPayment
        End Get
        Set(ByVal Value As ePayment)
            myPayment = Value
        End Set
    End Property

    Public Property PaymentDesignation() As String
        Get
            Return GetLabel("payment." & myPayment)
        End Get
        Set(ByVal Value As String)
            myStatusDesignation = Value
        End Set
    End Property

    Public Property UserInfo() As User
        Get
            Return myUser
        End Get
        Set(ByVal Value As User)
            myUser = Value
        End Set
    End Property

    Public Property EmployeeInfo() As Employee
        Get
            Return myEmployee
        End Get
        Set(ByVal Value As Employee)
            myEmployee = Value
        End Set
    End Property

    Public Property NextEmployeeInfo() As Employee
        Get
            Return myNextEmployee
        End Get
        Set(ByVal Value As Employee)
            myNextEmployee = Value
        End Set
    End Property

    Public Property Process() As Process
        Get
            Return myProcess
        End Get
        Set(ByVal Value As Process)
            myProcess = Value
        End Set
    End Property

    Public Property InputEvents() As Hashtable
        Get
            Return myInputEvents
        End Get
        Set(ByVal Value As Hashtable)
            myInputEvents = Value
        End Set
    End Property

    Public Property PossibleNextEvents() As Hashtable
        Get
            Return myPossibleNextEvents
        End Get
        Set(ByVal Value As Hashtable)
            myPossibleNextEvents = Value
        End Set
    End Property

    Public Property NextEvents() As EventCollection
        Get
            Return myNextEvents
        End Get
        Set(ByVal Value As EventCollection)
            myNextEvents = Value
        End Set
    End Property

    Public Property UserGroups() As ArrayList
        Get
            Return myUserGroups
        End Get
        Set(ByVal Value As ArrayList)
            myUserGroups = Value
        End Set
    End Property

    Public Property NextUserGroups() As ArrayList
        Get
            Return myNextUserGroups
        End Get
        Set(ByVal Value As ArrayList)
            myNextUserGroups = Value
        End Set
    End Property

    Public Property SelectNextTasks() As Boolean
        Get
            Return mySelectNextTasks
        End Get
        Set(ByVal Value As Boolean)
            mySelectNextTasks = Value
        End Set
    End Property

    Public Property JoinCode() As String
        Get
            Return myJoinCode
        End Get
        Set(ByVal Value As String)
            myJoinCode = Value
        End Set
    End Property

    Public Property SplitCode() As String
        Get
            Return mySplitCode
        End Get
        Set(ByVal Value As String)
            mySplitCode = Value
        End Set
    End Property

    Public Property SubmitStatus() As eSubmitStatus
        Get
            Return mySubmitStatus
        End Get
        Set(ByVal Value As eSubmitStatus)
            mySubmitStatus = Value
        End Set
    End Property

#End Region

#Region "Functions"

    Public Function GetFileWF(ByVal eWF As eEventType) As String
        Select Case eWF
            Case eWF.consultationRequest
                WF_XML_FILENAME = Me.Server.MapPath("\CRAVDataBaseAccess") & "\Workflow\" & "wfConReq.xml"
            Case eWF.reservationRequest
                WF_XML_FILENAME = Me.Server.MapPath("\CRAVDataBaseAccess") & "\Workflow\" & "wfResReq.xml"
            Case eWF.reproductionRequest
                WF_XML_FILENAME = Me.Server.MapPath("\CRAVDataBaseAccess") & "\Workflow\" & "wfRepReq.xml"
        End Select
        Return WF_XML_FILENAME
    End Function

    Public Sub getInputEvent(ByVal eWF As eEventType)
        Dim htNextEvents As New Hashtable

        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(GetFileWF(eWF))

        Dim xeEvent As XmlElement = xmlDoc.GetElementById("Input")
        Dim xnlNextElementRef As XmlNodeList = xeEvent.GetElementsByTagName("nextElementRef")
        For Each xnNextElementRef As XmlNode In xnlNextElementRef
            htNextEvents.Add(xnNextElementRef.Attributes("nid").Value, xnNextElementRef.InnerText)
        Next
        myInputEvents = htNextEvents
    End Sub

    Public Sub XMLToEvent(ByVal strEventCode As String, ByVal eSourceEventType As eEventType)
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(GetFileWF(eSourceEventType))

        Dim xeEvent As XmlElement = xmlDoc.GetElementById(strEventCode)
        Dim xnlNextElementRef As XmlNodeList = xeEvent.GetElementsByTagName("nextElementRef")
        Dim xnlUserGroup As XmlNodeList = xeEvent.GetElementsByTagName("userGroup")
        Dim xeSelectNextTasks As XmlElement = xeEvent.Item("selectNextTasks")
        Dim xeSelectUserGroups As XmlElement = xeEvent.Item("selectUserGroups")
        Dim xeJoinCode As XmlElement = xeEvent.Item("join")
        Dim xeSplitCode As XmlElement = xeEvent.Item("split")

        For Each xnNextElementRef As XmlNode In xnlNextElementRef
            myPossibleNextEvents.Add(xnNextElementRef.Attributes("nid").Value, xnNextElementRef.InnerText)
        Next

        For Each xnUserGroup As XmlNode In xnlUserGroup
            myUserGroups.Add(xnUserGroup.InnerText)
        Next

        mySelectNextTasks = xeSelectNextTasks.Attributes("value").Value

        myJoinCode = xeJoinCode.Attributes("code").Value
        mySplitCode = xeSplitCode.Attributes("code").Value
    End Sub

    Public Function getSelectNextTasks() As Boolean
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(WF_XML_FILENAME)

        Dim xeEvent As XmlElement = xmlDoc.GetElementById(EventCode)
        Dim xeSelectNextTasks As XmlElement = xeEvent.Item("selectNextTasks")

        Return xeSelectNextTasks.Attributes("value").Value
    End Function

    Public Function getSplitCode() As Boolean
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(WF_XML_FILENAME)

        Dim xeEvent As XmlElement = xmlDoc.GetElementById(EventCode)
        Dim xeSplitCode As XmlElement = xeEvent.Item("split")

        Return xeSplitCode.Attributes("value").Value
    End Function

    Public Function getPossibleNextEvents() As Hashtable
        Dim htPossibleNextEvents As New Hashtable
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(WF_XML_FILENAME)

        Dim xeEvent As XmlElement = xmlDoc.GetElementById(getStrEventCode(EventCode))
        Dim xnlNextElementRef As XmlNodeList = xeEvent.GetElementsByTagName("nextElementRef")

        For Each xnNextElementRef As XmlNode In xnlNextElementRef
            htPossibleNextEvents.Add(xnNextElementRef.Attributes("nid").Value, xnNextElementRef.InnerText)
        Next
        Return htPossibleNextEvents
    End Function

    Public Function getUserGroups(ByVal strEventCode As String) As ArrayList
        Dim alUserGroups As New ArrayList
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(WF_XML_FILENAME)

        Dim xeEvent As XmlElement = xmlDoc.GetElementById(strEventCode)
        Dim xnlUserGroup As XmlNodeList = xeEvent.GetElementsByTagName("userGroup")

        For Each xnUserGroup As XmlNode In xnlUserGroup
            alUserGroups.Add(xnUserGroup.InnerText)
        Next
        Return alUserGroups
    End Function


    Public Sub getNextEvents(ByVal htNextEvents As Hashtable, ByVal eSourceEventCode As eEventType)
        For Each task As String In htNextEvents.Keys
            Dim objNextEvent As New Event_(task, eSourceEventCode)

            objNextEvent.DerivedFrom = myEventID
            objNextEvent.SourceEventID = mySourceEventID
            objNextEvent.SourceEventCode = mySourceEventCode
            objNextEvent.EventCode = getEnumEventCode(task)
            If Not myNextEmployee.UserName Is Nothing Then
                If Not myNextEmployee.UserName.Equals("") Then
                    objNextEvent.Status = eStatus.Assigned
                Else
                    objNextEvent.Status = eStatus.Pendent
                End If
            Else
                objNextEvent.Status = eStatus.Pendent
            End If
            objNextEvent.UserInfo.UserID = myUser.UserID
            objNextEvent.EmployeeInfo.UserName = myNextEmployee.UserName
            objNextEvent.Process.ProcessID = myProcess.ProcessID
            NextEvents.Add(objNextEvent)
        Next
    End Sub

    Public Function getStrEventCode(ByVal eEventCode As eEventType) As String
        Dim eType As Type = GetType(eEventType)
        Return eEventType.GetName(eType, eEventCode)
    End Function

    Public Function getEnumEventCode(ByVal strEventCode As String) As eEventType
        Dim eEventCode As eEventType
        Return System.Enum.Parse(GetType(eEventType), strEventCode)
    End Function

#End Region

End Class


Public Class EventCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Event_
        Get
            Return CType(List(index), Event_)
        End Get
        Set(ByVal Value As Event_)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Event_) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Event_) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Event_)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Event_)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Event_) As Boolean
        Return List.Contains(value)
    End Function

End Class
