Imports DigitArq.Data.Entities.MGUP

Public Class Process
    Inherits BaseClassP

#Region "Internal Properties (private)"

    Private myProcessID As Int64
    Private myOtherProcessID As Integer
    Private myProcessType As eProcessType
    Private myProcessTypeDesignation As String
    Private myClassification As String
    Private mySubject As String
    Private myFolderID As String
    Private myEmployee As New Employee
    Private myInitialDate As String
    Private myFinalDate As String
    Private myUser As New User


    Public Enum eProcessType
        CRAV
        Other
    End Enum

#End Region


#Region "Gets and Sets of Public Properties"

    Public Property ProcessID() As Int64
        Get
            Return myProcessID
        End Get
        Set(ByVal Value As Int64)
            myProcessID = Value
        End Set
    End Property

    Public Property OtherProcessID() As Integer
        Get
            Return myOtherProcessID
        End Get
        Set(ByVal Value As Integer)
            myOtherProcessID = Value
        End Set
    End Property

    Public Property ProcessType() As eProcessType
        Get
            Return myProcessType
        End Get
        Set(ByVal Value As eProcessType)
            myProcessType = Value
        End Set
    End Property

    Public Property ProcessTypeDesignation() As String
        Get
            Return GetLabel("Process.ProcessType." & myProcessType)
        End Get
        Set(ByVal Value As String)
            myProcessTypeDesignation = Value
        End Set
    End Property

    Public Property Classification() As String
        Get
            Return myClassification
        End Get
        Set(ByVal Value As String)
            myClassification = Value
        End Set
    End Property

    Public Property Subject() As String
        Get
            Return mySubject
        End Get
        Set(ByVal Value As String)
            mySubject = Value
        End Set
    End Property

    Public Property FolderID() As String
        Get
            Return myFolderID
        End Get
        Set(ByVal Value As String)
            myFolderID = Value
        End Set
    End Property

    Public Property Employee() As Employee
        Get
            Return myEmployee
        End Get
        Set(ByVal Value As Employee)
            myEmployee = Value
        End Set
    End Property

    Public Property InitialDate() As String
        Get
            Return myInitialDate
        End Get
        Set(ByVal Value As String)
            myInitialDate = Value
        End Set
    End Property

    Public Property FinalDate() As String
        Get
            Return myFinalDate
        End Get
        Set(ByVal Value As String)
            myFinalDate = Value
        End Set
    End Property

    Public Property UserInfo() As User
        Get
            Return myUser
        End Get
        Set(ByVal Value As User)
            myUser = Value
        End Set
    End Property

#End Region

End Class


Public Class ProcessCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Process
        Get
            Return CType(List(index), Process)
        End Get
        Set(ByVal Value As Process)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Process) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Process) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Process)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Process)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Process) As Boolean
        Return List.Contains(value)
    End Function

End Class