Imports DigitArq.Utility

Public Class ReproductionRequest
    Inherits Event_

#Region "Internal Properties (private)"

    Private myReferenceDigitarq As String
    Private myDigitarqInfo As DigitarqInfo

    Private mySearchValue As Boolean
    Private mySearchText As String
    Private myReproductionValue As Boolean
    Private myReproductionText As String
    Private myTypeReproductionCode As Integer
    Private myTypeReproduction As String
    Private myCertificateValue As Boolean
    Private myCertificateText As String
    Private myTypeCertificateCode As Integer
    Private myTypeCertificate As String
    Private myDestination As String
    Private myRedutionsCosts As String
    Private myNumberCopies As String
    'Private myRequestPrice As String
    'Private myFormPaymentCode As String
    'Private myFormPayment As String
    'Private myFormDeliveryCode As String
    'Private myFormDelivery As String
    'Private myAdditionalInformationRep As String

    Private myRequestSubTypeCode As eRequestSubType
    Private myRequestSubTypeName As String
    Private myRequestSubTypeDesignation As String

    Private myKindActionPrcCode As String
    Private myKindActionPrc As String
    Private myAddress As String
    Private myRegion As String
    Private myName As String
    Private myFiliationFather As String
    Private myFiliationMather As String
    Private mySpouse As String
    Private mySeatNumber As String
    Private mySeatYear As String
    Private myPageNumberPrc As String

    Private myKindActionNotCode As String
    Private myKindActionNot As String
    Private myNotary As String
    Private myCartoryNumber As String
    Private myLocality As String
    Private myParticipantsAction As String
    Private myPageNumberNot As String

    Private myFonds As String
    Private myNamesOther As String
    Private myTermsWords As String
    Private myDocument As String
    Private myLocalities As String

    Private myInitialDate As String
    Private myFinalDate As String
    Private myAdditionalInformation As String

    Public Enum eRequestSubType
        none
        parochial
        notarial
        other
    End Enum

#End Region

#Region "Inicializations"

    Public Sub New()
        Me.getInputEvent(Event_.eEventType.reproductionRequest)
    End Sub

#End Region

#Region "Gets and Sets of Public Properties"


    Public Property ReferenceDigitarq() As String
        Get
            Return myReferenceDigitarq
        End Get
        Set(ByVal Value As String)
            myReferenceDigitarq = Value
        End Set
    End Property

    Public Property DigitarqInfo() As DigitarqInfo
        Get
            Return myDigitarqInfo
        End Get
        Set(ByVal Value As DigitarqInfo)
            myDigitarqInfo = Value
        End Set
    End Property

    Property SearchValue() As Boolean
        Get
            Return mySearchValue
        End Get
        Set(ByVal Value As Boolean)
            mySearchValue = Value
        End Set
    End Property

    Property SearchText() As String
        Get
            Return GetLabel("repReq.search." & mySearchValue)
        End Get
        Set(ByVal Value As String)
            mySearchText = Value
        End Set
    End Property

    Property ReproductionValue() As Boolean
        Get
            Return myReproductionValue
        End Get
        Set(ByVal Value As Boolean)
            myReproductionValue = Value
        End Set
    End Property

    Property ReproductionText() As String
        Get
            Return GetLabel("repReq.reproduction." & myReproductionValue)
        End Get
        Set(ByVal Value As String)
            myReproductionText = Value
        End Set
    End Property

    Property TypeReproductionCode() As Integer
        Get
            Return myTypeReproductionCode
        End Get
        Set(ByVal Value As Integer)
            myTypeReproductionCode = Value
        End Set
    End Property

    Property TypeReproduction() As String
        Get
            Return myTypeReproduction
        End Get
        Set(ByVal Value As String)
            myTypeReproduction = Value
        End Set
    End Property

    Property CertificateValue() As Boolean
        Get
            Return myCertificateValue
        End Get
        Set(ByVal Value As Boolean)
            myCertificateValue = Value
        End Set
    End Property

    Property CertificateText() As String
        Get
            Return GetLabel("repReq.certificate." & myCertificateValue)
        End Get
        Set(ByVal Value As String)
            myCertificateText = Value
        End Set
    End Property

    Property TypeCertificateCode() As Integer
        Get
            Return myTypeCertificateCode
        End Get
        Set(ByVal Value As Integer)
            myTypeCertificateCode = Value
        End Set
    End Property

    Property TypeCertificate() As String
        Get
            Return myTypeCertificate
        End Get
        Set(ByVal Value As String)
            myTypeCertificate = Value
        End Set
    End Property

    Property Destination() As String
        Get
            Return myDestination
        End Get
        Set(ByVal Value As String)
            myDestination = Value
        End Set
    End Property

    Property RedutionsCosts() As String
        Get
            Return myRedutionsCosts
        End Get
        Set(ByVal Value As String)
            myRedutionsCosts = Value
        End Set
    End Property

    Property NumberCopies() As String
        Get
            Return myNumberCopies
        End Get
        Set(ByVal Value As String)
            myNumberCopies = Value
        End Set
    End Property

    'Property RequestPrice() As String
    '    Get
    '        Return myRequestPrice
    '    End Get
    '    Set(ByVal Value As String)
    '        myRequestPrice = Value
    '    End Set
    'End Property

    'Property FormPaymentCode() As String
    '    Get
    '        Return myFormPaymentCode
    '    End Get
    '    Set(ByVal Value As String)
    '        myFormPaymentCode = Value
    '    End Set
    'End Property

    'Property FormPayment() As String
    '    Get
    '        Return myFormPayment
    '    End Get
    '    Set(ByVal Value As String)
    '        myFormPayment = Value
    '    End Set
    'End Property

    'Property FormDeliveryCode() As String
    '    Get
    '        Return myFormDeliveryCode
    '    End Get
    '    Set(ByVal Value As String)
    '        myFormDeliveryCode = Value
    '    End Set
    'End Property

    'Property FormDelivery() As String
    '    Get
    '        Return myFormDelivery
    '    End Get
    '    Set(ByVal Value As String)
    '        myFormDelivery = Value
    '    End Set
    'End Property

    'Property AdditionalInformationRep() As String
    '    Get
    '        Return myAdditionalInformationRep
    '    End Get
    '    Set(ByVal Value As String)
    '        myAdditionalInformationRep = Value
    '    End Set
    'End Property

    Public Property RequestSubTypeCode() As eRequestSubType
        Get
            Return myRequestSubTypeCode
        End Get
        Set(ByVal Value As eRequestSubType)
            myRequestSubTypeCode = Value
        End Set
    End Property

    Public Property RequestSubTypeName() As String
        Get
            Return Me.getStrEventCode(myRequestSubTypeCode)
        End Get
        Set(ByVal Value As String)
            myRequestSubTypeName = Value
        End Set
    End Property

    Public Property RequestSubTypeDesignation() As String
        Get
            Return GetLabel("requestSubType." & myRequestSubTypeCode)
        End Get
        Set(ByVal value As String)
            myRequestSubTypeDesignation = value
        End Set
    End Property

    Property KindActionPrcCode() As String
        Get
            Return myKindActionPrcCode
        End Get
        Set(ByVal Value As String)
            myKindActionPrcCode = Value
        End Set
    End Property

    Property KindActionPrc() As String
        Get
            Return myKindActionPrc
        End Get
        Set(ByVal Value As String)
            myKindActionPrc = Value
        End Set
    End Property

    Property Address() As String
        Get
            Return myAddress
        End Get
        Set(ByVal Value As String)
            myAddress = Value
        End Set
    End Property

    Property Region() As String
        Get
            Return myRegion
        End Get
        Set(ByVal Value As String)
            myRegion = Value
        End Set
    End Property

    Property Name() As String
        Get
            Return myName
        End Get
        Set(ByVal Value As String)
            myName = Value
        End Set
    End Property

    Property FiliationFather() As String
        Get
            Return myFiliationFather
        End Get
        Set(ByVal Value As String)
            myFiliationFather = Value
        End Set
    End Property

    Property FiliationMather() As String
        Get
            Return myFiliationMather
        End Get
        Set(ByVal Value As String)
            myFiliationMather = Value
        End Set
    End Property

    Property Spouse() As String
        Get
            Return mySpouse
        End Get
        Set(ByVal Value As String)
            mySpouse = Value
        End Set
    End Property

    Property SeatNumber() As String
        Get
            Return mySeatNumber
        End Get
        Set(ByVal Value As String)
            mySeatNumber = Value
        End Set
    End Property

    Property SeatYear() As String
        Get
            Return mySeatYear
        End Get
        Set(ByVal Value As String)
            mySeatYear = Value
        End Set
    End Property

    Property PageNumberPrc() As String
        Get
            Return myPageNumberPrc
        End Get
        Set(ByVal Value As String)
            myPageNumberPrc = Value
        End Set
    End Property

    Property KindActionNotCode() As String
        Get
            Return myKindActionNotCode
        End Get
        Set(ByVal Value As String)
            myKindActionNotCode = Value
        End Set
    End Property

    Property KindActionNot() As String
        Get
            Return myKindActionNot
        End Get
        Set(ByVal Value As String)
            myKindActionNot = Value
        End Set
    End Property

    Property Notary() As String
        Get
            Return myNotary
        End Get
        Set(ByVal Value As String)
            myNotary = Value
        End Set
    End Property

    Property CartoryNumber() As String
        Get
            Return myCartoryNumber
        End Get
        Set(ByVal Value As String)
            myCartoryNumber = Value
        End Set
    End Property

    Property Locality() As String
        Get
            Return myLocality
        End Get
        Set(ByVal Value As String)
            myLocality = Value
        End Set
    End Property

    Property ParticipantsAction() As String
        Get
            Return myParticipantsAction
        End Get
        Set(ByVal Value As String)
            myParticipantsAction = Value
        End Set
    End Property

    Property PageNumberNot() As String
        Get
            Return myPageNumberNot
        End Get
        Set(ByVal Value As String)
            myPageNumberNot = Value
        End Set
    End Property

    Property Fonds() As String
        Get
            Return myFonds
        End Get
        Set(ByVal Value As String)
            myFonds = Value
        End Set
    End Property

    Property NamesOther() As String
        Get
            Return myNamesOther
        End Get
        Set(ByVal Value As String)
            myNamesOther = Value
        End Set
    End Property

    Property TermsWords() As String
        Get
            Return myTermsWords
        End Get
        Set(ByVal Value As String)
            myTermsWords = Value
        End Set
    End Property

    Property Document() As String
        Get
            Return myDocument
        End Get
        Set(ByVal Value As String)
            myDocument = Value
        End Set
    End Property

    Property Localities() As String
        Get
            Return myLocalities
        End Get
        Set(ByVal Value As String)
            myLocalities = Value
        End Set
    End Property

    Property InitialDate() As String
        Get
            Return myInitialDate
        End Get
        Set(ByVal Value As String)
            myInitialDate = Value
        End Set
    End Property

    Property FinalDate() As String
        Get
            Return myFinalDate
        End Get
        Set(ByVal Value As String)
            myFinalDate = Value
        End Set
    End Property

    Property Dates() As String
        Get
            Return DateToInterface(myInitialDate, myFinalDate, GetLabel("separator.to"))
        End Get
        Set(ByVal Value As String)
            myFinalDate = Value
        End Set
    End Property

    Property AdditionalInformation() As String
        Get
            Return myAdditionalInformation
        End Get
        Set(ByVal Value As String)
            myAdditionalInformation = Value
        End Set
    End Property

#End Region


End Class
