Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data.SqlClient


Module mAdvancedSearch


    '******************************************************************************
    ' Function: strBdyQry
    ' Purpose: Returns the Str(ing) B(o)dy Q(ue)ry a part of the db query
    '******************************************************************************

    Public Function strBdyQryAS(ByVal objAS As AdvancedSearch) As String

        Dim strQry As String

        Dim sclCurQry As New StringCollection 'S(tring) C(o)l(lection) to Cur(rent) Q(ue)ry
        Dim strCtlAccessSubQry As String = "" ' Initial value for the sub query to the control access table
        Dim strkeyCur, strFinalQry, strTemp, strValid As String
        Dim strContent As String

        sclCurQry = sclOtherLevel(objAS.OtherLevel, sclCurQry)
        
        If Not objAS.UnitTitle.IsEmpty Then
            Dim FieldName() As String = {"UnitTitle"}
            sclCurQry = strByColnSearchCondition(sclCurQry, objAS.UnitTitle, FieldName)
        End If
        If Not objAS.AuthorDestination.IsEmpty Then
            Dim FieldName() As String = {"OriginationAuthor", "OriginationDestination", "OriginationScrivener", "OriginationNotary"}
            sclCurQry = strByColnSearchCondition(sclCurQry, objAS.AuthorDestination, FieldName)
        End If
        If Not objAS.GeogLocal.IsEmpty Then
            Dim FieldName() As String = {"OriginationAuthorAddress", "OriginationDestinationAddress", "GeogName", "OriginalsLoc", "ScopeContent", "BiogHist"}
            sclCurQry = strByColnSearchCondition(sclCurQry, objAS.GeogLocal, FieldName)
        End If
        If Not objAS.KeyWord.IsEmpty Then
            Dim FieldName() As String = {"ScopeContent", "BiogHist", "Note", "Abstract"}
            sclCurQry = strByColnSearchCondition(sclCurQry, objAS.UnitTitle, FieldName)
        End If
        If Not objAS.CompleteUnitID.Equals("") Then
            sclCurQry = sclCompleteUnitId(sclCurQry, objAS.CompleteUnitID, "CompleteUnitId", "")
        End If
        If Not objAS.PartUnitID.Equals("") Then
            sclCurQry = sclCompleteUnitId(sclCurQry, objAS.PartUnitID, "CompleteUnitId", "%")
        End If

        sclCurQry = objAS.IntervalDates.sclQryDate(sclCurQry)


        Dim strWhereQry As String

        Dim myArr2(sclCurQry.Count - 1) As String ' alterei  pois  wordf.count
        sclCurQry.CopyTo(myArr2, 0)
        strWhereQry = Join(myArr2, " AND ")
        'If strTempx <> "" Then
        'If strTemp <> "" And strTempx.Equals(strTemp) And strCtlAccessSubQry = "" Then
        'Return ""

        If Not objAS.ControlAccessItem.IsEmpty And objAS.SearchImages Then
            strQry = String.Format("SELECT ID, OtherLevel FROM Components C" & _
                " INNER JOIN ControlAccess CA ON C.ID=CA.ComponentID" & _
                " INNER JOIN DaoGrp DG ON C.ID=DG.ComponentID" & _
                " WHERE {0} AND CA.ItemID={1} AND Visible=1", strWhereQry, objAS.ControlAccessItem.ID)
        ElseIf Not objAS.ControlAccessItem.IsEmpty Then
            strQry = String.Format("SELECT ID, OtherLevel FROM Components C" & _
                " INNER JOIN ControlAccess CA ON C.ID=CA.ComponentID" & _
                " WHERE {0} AND CA.ItemID={1} AND Visible=1", strWhereQry, objAS.ControlAccessItem.ID)
        ElseIf objAS.SearchImages Then
            strQry = String.Format("SELECT ID, OtherLevel FROM Components C" & _
                " INNER JOIN DaoGrp DG ON C.ID=DG.ComponentID" & _
                " WHERE {0} AND Visible=1", strWhereQry)
        Else
            strQry = String.Format("SELECT ID, OtherLevel FROM Components C" & _
                " WHERE {0} AND Visible=1", strWhereQry)
        End If

        'End If
        'If strCtlAccessSubQry = "" Then
        '    strFinalQry = "where visible='1' and " & strTempx
        'Else
        '    strFinalQry = "where visible='1' and " & strCtlAccessSubQry & " and " & strTempx
        'End If
        ''End If
        Return strQry

    End Function


    '**************************************************************************************
    ' Function: strCompleteUnitId
    ' Purpose: Returns the Str(ing) Complete unit id condition search data asked by 
    '       the user for the complete unit id components db field 
    '       This function is necessary once i have to put in the completeUnit Id the
    '       "PT/ADPRT/" when I show it, because the CompleteUnitId db Field doesn't have it
    '       but it can be avoid if the missing string (PT/ADPRT/)will be introduced on the 
    '       completeUnitId create (update) action for each unit.
    '       So if "PT/ADPRT" was in the Complete Unit ID i wouldn't need this function.
    '***************************************************************************************
    Private Function sclCompleteUnitId(ByVal sclCurQry As StringCollection, ByVal strRef As String, ByVal strField As String, ByVal strPref As String) As StringCollection
        Dim i As Integer
        Dim strTemp As String
        Dim strPrefRef = ConfigurationSettings.AppSettings("PrefRef")
        If strPref = "" Then
            'If Not (strRef.StartsWith(strPrefRef)) Then
            'strRef = strRef.TrimStart("/".ToCharArray)
            'strRef = strPrefRef & strRef
            strTemp = (strField & " LIKE '" & strRef & "%'")
            'Else
            'strRef = strRef.Replace(strPrefRef, "")
            'strRef = strRef.TrimStart("/".ToCharArray)
            'strTemp = (strField & " LIKE '" & strRef & "%'")
            'End If
        Else
        strTemp = (strField & " LIKE '" & strPref & strRef & "%'")
        End If
        sclCurQry.Add("(" & strTemp & ")")
        Return sclCurQry
    End Function


    '*************************************************************************************
    ' Function: strByColnSearchCondition
    ' Purpose: Returns the Str(ing) by col(um)n Search Condition For an array of a given
    ' Column Names (filedsName parameter).
    '*************************************************************************************

    Private Function strByColnSearchCondition(ByVal sclCurQry As StringCollection, ByVal Obj As BlnSearchFields, ByVal ParamArray strFieldName() As String) As StringCollection

        Dim strSearchCondition As String = ""

        If Obj.AndField.Trim <> "" Then
            Dim strAnd() As String = strRemoveWords(Obj.AndField)
            If strAnd.Length > 0 Then
                strSearchCondition &= "(" & strBoolSearchCondition(strAnd, strFieldName, " AND ") & ")" & " AND "
            End If
        End If
        If Obj.OrField.Trim <> "" Then
            Dim strOr() As String = strRemoveWords(Obj.OrField)
            If strOr.Length > 0 Then
                strSearchCondition &= "(" & strBoolSearchCondition(strOr, strFieldName, " OR ") & ")" & " AND "
            End If
        End If
        If Obj.NotField.Trim <> "" Then
            Dim strNot() As String = strRemoveWords(Obj.NotField)
            If strNot.Length > 0 Then
                strSearchCondition &= "(" & strNotSearchCondition(strNot, strFieldName) & ")" & " AND "
            End If
        End If

        If Obj.ExactPhraseField.Trim <> "" Then
            Dim strExactPhrase As String = Obj.ExactPhraseField
            strSearchCondition &= "(" & strExactSearchCondition(strExactPhrase, strFieldName) & ")" & " AND "
        End If
        If strSearchCondition <> "" Then
            strSearchCondition = strSearchCondition.TrimEnd(" AND ".ToCharArray)
            sclCurQry.Add("(" & strSearchCondition & ")")
        End If
        Return sclCurQry
    End Function


    '*************************************************************************************
    ' Function: strOrSearchCondition
    ' Purpose: Returns the Str(ing) for Or Search Condition that compose the db query for
    ' a Column Names (fields  parameter). The Search condition string is build word by
    ' word from all words that are inputed by the user in the or textbox.
    '*************************************************************************************

    Public Function strBoolSearchCondition(ByVal str() As String, ByVal strFields() As String, ByVal Bool As String) As String
        Dim strWord As String
        Dim strBoolStatment As String = ""
        Dim i As Integer
        Dim strTemp(strFields.Length - 1) As String

        For i = 0 To strFields.Length - 1
            For Each strWord In str
                strWord.Trim()
                strTemp(i) &= (" CONTAINS(" & strFields(i) & ", '" & strWord & "')" & Bool)
            Next
            strTemp(i) = "(" & strTemp(i).TrimEnd(Bool.ToCharArray) & ")"
        Next
        strBoolStatment &= ("(" & Join(strTemp, " OR ").TrimEnd(" OR ".ToCharArray) & ")")

        Return strBoolStatment
    End Function


    '*************************************************************************************
    ' Function: strNotSearchCondition
    ' Purpose: Returns the Str(ing) for Not Search Condition that compose the db query for
    ' a Column Names (fields  parameter). The Search condition string is build word by
    ' word from all words that are inputed by the user in the given Not textbox.
    '*************************************************************************************

    Public Function strNotSearchCondition(ByVal str() As String, ByVal strFields() As String) As String
        Dim strWord, strNotStatment, strTemp As String
        Dim i As Integer

        For i = 0 To strFields.Length - 1
            For Each strWord In str
                strWord.Trim()
                If Not strWord.Equals("") Then
                    strTemp &= (" NOT CONTAINS(" & strFields(i) & ", '" & strWord & "') AND ")
                End If
            Next
        Next

        strNotStatment = ("(" & strTemp.TrimEnd(" AND ".ToCharArray) & ")")

        Return strNotStatment
    End Function


    '*********************************************************************************************
    ' Function: strExactPhraseSearchCondition
    ' Purpose: Returns the Str(ing) for ExactPhrase Search Condition that compose the db query for
    ' a Column Names (fields  parameter). The Search condition string is build 
    ' with the exact phrase  inputed by the user in the given ExactPhrase textbox.
    '**********************************************************************************************

    Public Function strExactSearchCondition(ByVal strExactPhrase As String, ByVal strFields() As String) As String
        Dim strExactPhraseCondition As String

        For i As Integer = 0 To strFields.Length - 1
            strExactPhraseCondition &= (" CONTAINS(" & strFields(i) & ", '""" & strExactPhrase & """') OR ")
        Next
        strExactPhraseCondition = strExactPhraseCondition.TrimEnd(" OR ".ToCharArray)
        Return strExactPhraseCondition
    End Function


    '*************************************************************************************
    ' Function: strExactPhraseUnitId
    ' Purpose: Returns the Str(ing) for ExactPhrase Unit Id Search Condition 
    '          that compose the db query for a Column Names (fields  parameter). 
    '          The Search condition string is build with the exact phrase  inputed by the 
    '          user in the given ExactPhrase in the UnitId textbox.
    '       This function is dependent of strCompleteUnitId function existence.  
    '*************************************************************************************

    Private Function strExactPhraseUnitId(ByVal str As String, ByVal strFields() As String) As String
        Dim strExactPhrase As String
        Dim i As Integer

        For i = 0 To strFields.Length - 1
            strExactPhrase &= ("" & strFields(i) & " LIKE '" & str & "') OR ")
        Next
        strExactPhrase = strExactPhrase.TrimEnd(" OR ".ToCharArray)
        Return strExactPhrase
    End Function


    '*************************************************************************************
    ' Function: StrSubQryControlAccess
    ' Purpose: Returns the Str(ing) for ExactPhrase Unit Id Search Condition 
    '          that compose the db query to the ControlAccess Table
    '*************************************************************************************

    Private Function StrSubQryControlAccess(ByVal hash As Hashtable, ByVal key As String) As String

        Dim intItemID As Integer = CInt(hash(key))
        Dim strQry As String

        'strQry = "(select ComponentID from ControlAccess where ItemID= '" & intItemID & "') as CA"
        strQry = String.Format("(ID in(select ComponentID from ControlAccessItemsFonds where ItemID='{0}')" & _
        "or ID in(select ComponentID from ControlAccess where ItemID='{0}') )", intItemID)
        Return strQry
    End Function


    '*************************************************************************************
    ' Function: sclOtherLevel
    ' Purpose: Returns s(tringcollecton element that is the query to the OtherLevel 
    '          column of components table.
    '*************************************************************************************

    Private Function sclOtherLevel(ByVal strSubStrInpCkb As ArrayList, ByVal sclQry As StringCollection) As StringCollection
        'Dim strSubStrInpChk() As String = Split(hshControls(strkey)) ' Array of substrings that points out the selected checkboxs
        Dim strTempQry As String
        Dim i As Integer

        For i = 0 To (strSubStrInpCkb.Count - 1)
            If i <> 0 Then
                strTempQry &= " or "
            End If

            If strSubStrInpCkb(i) = "F" Then
                strTempQry &= "OtherLevel = 'F' or  OtherLevel = 'SF'"

            ElseIf strSubStrInpCkb(i) = "SC" Then
                strTempQry &= "OtherLevel = 'SC' or OtherLevel = 'SSC' or OtherLevel = 'SSSC'"

            ElseIf strSubStrInpCkb(i) = "SR" Then
                strTempQry &= "OtherLevel = 'SR' or OtherLevel = 'SSR'"

            Else
                strTempQry &= "OtherLevel = '" & strSubStrInpCkb(i) & "'"
            End If
        Next

        sclQry.Add("(" & strTempQry & ")")
        Return sclQry
    End Function

    'Private Function sclImage(ByVal sclQry As StringCollection) As StringCollection
    '    Dim strTempQry As String
    '    strTempQry &= "ComponentID = ID"
    '    sclQry.Add("(" & strTempQry & ")")
    '    Return sclQry
    'End Function

End Module
