Imports DigitArq.Utility
Imports DigitArq.Data.Entities.MDA
Imports CRAVDataBaseAccess


Public Class HtmlEAC
    Inherits BaseClassUC

    Private myEAC As EAC

    Public Sub New(ByVal FondsID As Integer)
        myEAC = New EAC(FondsID)
    End Sub

    Public Sub New(ByVal ServerAddress As String, ByVal Database As String, ByVal Username As String, ByVal Password As String, ByVal FondsID As Integer)
        myEAC = New EAC(ServerAddress, Database, Username, Password, FondsID)
    End Sub

    Public Function ToHtml() As String
        Dim EacHtml As String
        Dim EacHeader As String
        Dim EacConDesc As String
        Dim EacMainHist As String
        Dim EacBiogHist As String
        Dim EacId As String
        Dim EacLanguageDecl As String
        Dim EacRuleDecl As String
        Dim EacIdentity As String
        Dim EacDesc As String
        Dim EacRels As String
        Dim EacLocation As String
        Dim EacLegalStatus As String
        Dim EacFunActDesc As String
        Dim EacAssetStruct As String
        Dim EacEnv As String
        Dim EacLegalId As String
        Dim EacParallelOrOtherFormsName As String
        Dim EacControl As String
        Dim EacType As String
        Dim EacOwnerCode As String
        Dim EacStatus As String
        Dim EacDetailLevel As String
        Dim EacArchRels As String

        Dim EacAuthorizedName As String

        '------------------------------ ZONA DE IDENTIFICAO ------------------------------------------
        EacType = CreateHTMLTag(GetLabel("WS.authorityRecord.EacType"), myEAC.Type)
        EacAuthorizedName = CreateHTMLTag(GetLabel("WS.authorityRecord.EacAuthorizedName"), myEAC.Part & " " & myEAC.UseDate)
        EacParallelOrOtherFormsName = EacIdentityToHtml()

        EacIdentity = CreateHTMLTag("<p><font class='SubTitle07'>" & GetLabel("WS.authorityRecord.EacIdentity") & "</font></p>", EacType & EacAuthorizedName & EacParallelOrOtherFormsName)


        '------------------------------ ZONA DE DESCRIO ----------------------------------------------
        EacBiogHist = CreateHTMLTag(GetLabel("WS.authorityRecord.EacBiogHist"), myEAC.BiogHist)
        EacLocation = CreateHTMLTag(GetLabel("WS.authorityRecord.EacLocation"), myEAC.Place)
        EacLegalStatus = CreateHTMLTag(GetLabel("WS.authorityRecord.EacLegalStatus"), myEAC.LegalStatus)
        EacFunActDesc = CreateHTMLTag(GetLabel("WS.authorityRecord.EacFunActDesc"), myEAC.FunActDesc)
        EacLegalId = CreateHTMLTag(GetLabel("WS.authorityRecord.EacLegalId"), myEAC.LegalId)
        EacAssetStruct = CreateHTMLTag(GetLabel("WS.authorityRecord.EacAssetStruct"), myEAC.AssetStruct)
        EacEnv = CreateHTMLTag(GetLabel("WS.authorityRecord.EacEnv"), myEAC.Env)

        EacDesc = CreateHTMLTag("<p><font class='SubTitle07'>" & GetLabel("WS.authorityRecord.EacDesc") & "</font></p>", EacBiogHist & EacLocation & EacLegalStatus & EacFunActDesc & EacAssetStruct & EacEnv)


        '------------------------------ ZONA DAS RELAES ----------------------------------------------
        EacRels = CreateHTMLTag("<p><font class='SubTitle07'>" & GetLabel("WS.authorityRecord.EacRels") & "</font></p>", EacRelationshipsToHtml)


        '------------------------------ ZONA DE CONTROLO ----------------------------------------------
        'ISAAR 5.4.1:
        EacId = CreateHTMLTag(GetLabel("WS.authorityRecord.EacId"), myEAC.SysKey)
        ' ISAAR 5.4.2 :
        EacOwnerCode = CreateHTMLTag(GetLabel("WS.authorityRecord.EacOwnerCode"), myEAC.OwnerCode)
        'ISAAR 5.4.3:
        EacRuleDecl = CreateHTMLTag(GetLabel("WS.authorityRecord.EacRuleDecl"), String.Join("</br>", myEAC.Rules.Split(";")))
        'ISAAR 5.4.4 -> status
        EacStatus = CreateHTMLTag(GetLabel("WS.authorityRecord.EacStatus"), myEAC.Status)
        'ISAAR 5.4.5 -> DetailLevel
        EacDetailLevel = CreateHTMLTag(GetLabel("WS.authorityRecord.EacDetailLevel"), myEAC.DetailLevel)
        'ISAAR 5.3.6 :
        EacLanguageDecl = EacLanguageDeclarationToHtml()
        'ISAAR 5.4.7, 5.4.8
        EacMainHist = EacMaintenanceHistoryToHtml()

        EacControl = CreateHTMLTag("<p><font class='SubTitle07'>" & GetLabel("WS.authorityRecord.EacControl") & "</font></p>", EacId & EacOwnerCode & EacRuleDecl & EacStatus & EacDetailLevel & EacLanguageDecl & EacMainHist)


        '------------------------------ LIGAES ------------------------------------------------------
        EacArchRels = CreateHTMLTag("<p><font class='SubTitle07'>" & GetLabel("WS.authorityRecord.EacArchRels") & "</font></p>", EacArchRelationshipsToHtml() & EacResourceRelationshipsToHtml())


        '------------------------------ RETURN --------------------------------------------------------
        EacHtml = EacIdentity & EacDesc & EacRels & EacControl & EacArchRels

        Return EacHtml
    End Function

    Private Function EacArchRelationshipsToHtml() As String
        Dim EacArchRelationships As EacArchRelationships = myEAC.ArchRelationships
        If EacArchRelationships.Count = 0 Then Return ""

        Dim Html As String = ""
        For i As Integer = 0 To EacArchRelationships.Count - 1
            Html &= CreateHTMLTag(" Identificador do recurso relacionado: ", WriteIfNotEmpty("", EacArchRelationships.Item(i).UnitTitle) & WriteIfNotEmpty("<font class='TextBlueBottom'> Cdigo: </font> ", EacArchRelationships.Item(i).UnitId) & DateToHtml(EacArchRelationships.Item(i).UnitDateInitial, EacArchRelationships.Item(i).UnitDateFinal)) & _
                    CreateHTMLTag(" Tipo de recurso relacionado: ", WriteIfNotEmpty("Documento do arquivo ", EacArchRelationships.Item(i).Repository)) & _
                    CreateHTMLTag(" Natureza da relao: ", EacArchRelationships.Item(i).Note) & CreateHTMLTag("Datas do recurso: ", EacArchRelationships.Item(i).DateStr)
        Next
        Return Html
    End Function

    Private Function EacIdentityToHtml() As String
        Dim EacIdentity As EacIdentity = myEAC.Identity
        If EacIdentity.Count = 0 Then Return ""

        Dim Html As String = ""
        For i As Integer = 0 To EacIdentity.Count - 1
            Html &= CreateHTMLTag(EacIdentity.Item(i).Type, EacIdentity.Item(i).Part & " <b>" & EacIdentity.Item(i).UseDate & "</b>")
        Next
        Return Html
    End Function

    Public Function EacLanguageDeclarationToHtml() As String
        Dim EacLanguageDeclaration As EacLanguageDeclaration = myEAC.LanguageDeclaration
        If EacLanguageDeclaration.Count = 0 Then Return ""

        Dim Html As String = ""
        For i As Integer = 0 To EacLanguageDeclaration.Count - 1
            Html &= CreateHTMLTag(" Lingua(s) e escrita(s) do registo: ", EacLanguageDeclaration.Item(i).Language)
        Next
        Return Html
    End Function

    Public Function EacMaintenanceHistoryToHtml() As String
        Dim EacMaintenanceHistory As EacMaintenanceHistory = myEAC.MaintenanceHistory
        If EacMaintenanceHistory.Count = 0 Then Return ""

        Dim Html As String = ""
        For i As Integer = 0 To EacMaintenanceHistory.Count - 1
            Html &= CreateHTMLTag(" Datas de criao e reviso: ", EacMaintenanceHistory.Item(i).DateStr) & CreateHTMLTag("Notas: ", EacMaintenanceHistory.Item(i).Description)
        Next
        Return Html
    End Function

    Public Function EacRelationshipsToHtml() As String
        Dim EacRelationships As EacRelationships = myEAC.EacRelationships
        If EacRelationships.Count = 0 Then Return ""
        Dim PrefixName As String
        Dim html As String

        For i As Integer = 0 To EacRelationships.Count - 1
            html &= CreateHTMLTag("Nome/identificador da entidade relacionada:", EacRelationships.Item(i).Name & "<font class='TextBlueBottom'> Tipo de entidade: </font> " & EacRelationships.Item(i).EacType) & CreateHTMLTag("Tipo de relao:", EacRelationships.Item(i).Type) & _
            CreateHTMLTag(" Descrio da relao: ", EacRelationships.Item(i).Note) & CreateHTMLTag("Datas da relao:", EacRelationships.Item(i).DateStr) & CreateHTMLTag("Localidade(s):", EacRelationships.Item(i).Place)
        Next

        Return html
    End Function

    Public Function EacResourceRelationshipsToHtml() As String
        Dim EacResourceRelationships As EacResourceRelationships = myEAC.ResourceRelationships
        If EacResourceRelationships.Count = 0 Then Return ""

        Dim Html As String = ""
        For i As Integer = 0 To EacResourceRelationships.Count - 1
            Html &= CreateHTMLTag("Identificador do recurso relacionado: ", EacResourceRelationships.Item(i).Unit) & _
              CreateHTMLTag(" Tipo de recurso relacionado: ", EacResourceRelationships.Item(i).ResourceType) & _
              CreateHTMLTag(" Datas do recurso: ", EacResourceRelationships.Item(i).DateStr)
        Next
        Return Html
    End Function

    Private Function DateToHtml(ByVal InitialDate As String, ByVal datefin As String) As String

        InitialDate = strGetDate(InitialDate)
        datefin = strGetDate(datefin)
        If InitialDate = "" And datefin = "" Then

            Return ""

        ElseIf datefin = "" Then

            Return " <font class='TextNavy'>Datas: </font> " & InitialDate
        ElseIf InitialDate = "" Then
            Return " <font class='TextNavy'>Datas: </font> " & datefin
        Else
            Return " <font class='TextNavy'>Datas: </font>" & InitialDate & " a " & datefin

        End If
        Return ""
    End Function

End Class






