
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Threading
Imports System.IO
Imports System.Data.SqlClient

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls



Public Class Exporter

    Private myServerAddress As String
    Private myDatabase As String
    Private myUsername As String
    Private myPassword As String
    Private myFilename As String
    Private myProcessInfoName As String = "admin"
    Private myProgressDialog As ProgressDialog.ProgressDialog
    Private myFondsID As Integer
    Private myOperationCancelled As Boolean = False
    Private myOnlyExportVisibles As Boolean = False
    Private myCompleteUnitID As String = ""


    Public Sub New(ByVal ServerAddress As String, _
                   ByVal Database As String, _
                   ByVal Username As String, _
                   ByVal Password As String, _
                   ByVal Filename As String, _
                   ByVal CompleteUnitID As String)
        myServerAddress = ServerAddress
        myDatabase = Database
        myUsername = Username
        myPassword = Password
        myFilename = Filename
        myCompleteUnitID = CompleteUnitID
    End Sub


    Public Sub New(ByVal ServerAddress As String, _
                    ByVal Database As String, _
                    ByVal Username As String, _
                    ByVal Password As String, _
                    ByVal Filename As String, _
                    ByVal FondsID As Integer, _
                    Optional ByVal OnlyExportVisibles As Boolean = False)
        myServerAddress = ServerAddress
        myDatabase = Database
        myUsername = Username
        myPassword = Password
        myFilename = Filename
        myFondsID = FondsID
        myOnlyExportVisibles = OnlyExportVisibles
    End Sub

    Public Sub New(ByVal ServerAddress As String, _
                   ByVal Database As String, _
                   ByVal Username As String, _
                   ByVal Password As String, _
                   ByVal FondsID As Integer, _
                   ByVal processInfoName As String)
        myServerAddress = ServerAddress
        myDatabase = Database
        myUsername = Username
        myPassword = Password
        myFondsID = FondsID
        myProcessInfoName = processInfoName
    End Sub



    Public Sub Export()
        Cursor.Current = Cursors.WaitCursor
        Dim startTime As Date = Date.Now
        myProgressDialog = New ProgressDialog.ProgressDialog(True)
        myProgressDialog.MinimumValue = 0
        myProgressDialog.Text = String.Format(InfoMessage("Exporter.Title"), Path.GetFileName(myFilename))
        myProgressDialog.Show()

        Dim t As Thread = New Thread(New ThreadStart(AddressOf ExportFonds))
        t.Start()

        While t.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While



        myProgressDialog.Hide()
        myProgressDialog.Close()
        myProgressDialog.Dispose()

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)
        Debug.WriteLine(Path.GetFileName(myFilename) & ": " & timeSpan.Minutes.ToString.PadLeft(2, "0") & ":" & timeSpan.Seconds.ToString.PadLeft(2, "0") & " minutos")

        Cursor.Current = Cursors.Default
    End Sub




    Private Sub ExportFonds()
        Dim EADNode As LazyNode
        Dim SQLNode As LazyNode
        Try
            myProgressDialog.Message = ErrorMessage("ExportEAD.OpeningFile") & " " & Path.GetFileName(myFilename) & "..."
            EADNode = New EADLazyNode
            SQLNode = New SQLLazyNode(myServerAddress, myDatabase, myUsername, myPassword, myFondsID)
            myProgressDialog.MaximumValue = SQLNode.DescendantsCount
            myProgressDialog.ShowTimeToEnd = True

            EADNode.ImportFields(SQLNode)
            EADNode.Upload()
            MergeTrees(EADNode, SQLNode, myOnlyExportVisibles)

            If Not myOperationCancelled Then CType(EADNode, EADLazyNode).SaveXML(myFilename)
        Catch ex As Exception
            MsgBoxException(ex)
            'MsgBox(String.Format(ErrorMessage("ExportEAD.Cancelation"), Path.GetFileName(myFilename)), MsgBoxStyle.Critical)
            'Debug.WriteLine(ex.Message & ControlChars.NewLine & ex.StackTrace)
        End Try

    End Sub


    Public Sub PromoteToFonds()
        Cursor.Current = Cursors.WaitCursor
        Dim startTime As Date = Date.Now
        myProgressDialog = New ProgressDialog.ProgressDialog(True)
        myProgressDialog.MinimumValue = 0
        myProgressDialog.MaximumValue = 10
        myProgressDialog.Text = String.Format(InfoMessage("Exporter.Title"), Path.GetFileName(myFilename))
        myProgressDialog.Show()

        Dim t As Thread = New Thread(New ThreadStart(AddressOf PromoteToFondsThreaded))
        t.Start()

        While t.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While

        myProgressDialog.Hide()
        myProgressDialog.Close()
        myProgressDialog.Dispose()

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)
        Debug.WriteLine(Path.GetFileName(myFilename) & ": " & timeSpan.Minutes.ToString.PadLeft(2, "0") & ":" & timeSpan.Seconds.ToString.PadLeft(2, "0") & " minutos")

        Cursor.Current = Cursors.Default
    End Sub


    Private Sub PromoteToFondsThreaded()
        Try
            myProgressDialog.Message = "A criar fundo..."

            Dim OldSQLNode As New SQLLazyNode(myServerAddress, myDatabase, myUsername, myPassword, myFondsID)
            Dim NewSQLNode As LazyNode = SQLLazyNode.CreateNewFonds(myServerAddress, _
                                                         myDatabase, myUsername, myPassword, OldSQLNode.UnitId, _
                                                         OldSQLNode.UnitTitle, myProcessInfoName)

            NewSQLNode.ImportFields(OldSQLNode)
            NewSQLNode.OtherLevel = OTHERLEVEL_FONDS
            NewSQLNode.Upload()
            MergeTrees(NewSQLNode, OldSQLNode, False)
        Catch ex As Exception
            MsgBoxException(ex)
            'MsgBox(String.Format(ErrorMessage("ExportEAD.Cancelation"), Path.GetFileName(myFilename)), MsgBoxStyle.Critical)
            'Debug.WriteLine(ex.Message & ControlChars.NewLine & ex.StackTrace)
        End Try

    End Sub


    Private Sub MergeTrees(ByVal DstNode As LazyNode, ByVal SrcNode As LazyNode, Optional ByVal FilterByVisibility As Boolean = True)
        Dim Index As Integer
        Dim ChildSrcNode As LazyNode
        Dim Children As LazyNodeCollection

        For Each ChildSrcNode In SrcNode.Children
            myProgressDialog.Message = String.Format(InfoMessage("Importer.Progression"), ChildSrcNode.UnitId)
            myProgressDialog.Increment()
            If myProgressDialog.Cancel Then
                myOperationCancelled = True
                Exit Sub
            End If

            If Not FilterByVisibility Or ChildSrcNode.Visible Then
                Children = DstNode.Children
                Dim NewDstNode As LazyNode = DstNode.CreateNode()
                NewDstNode.ImportFields(ChildSrcNode) ' Copy all the stuff into the node
                NewDstNode.Upload()
                DstNode.AppendChild(NewDstNode)
                MergeTrees(NewDstNode, ChildSrcNode, FilterByVisibility)
            End If
        Next

    End Sub

    Public ReadOnly Property OperationCancelled() As Boolean
        Get
            Return myOperationCancelled
        End Get
    End Property


#Region "Export to DigitArq Interoperability Format"


    Public Sub ExportDIF()
        Cursor.Current = Cursors.WaitCursor
        Dim startTime As Date = Date.Now

        Try
            SQLLazyNode.DumpFondsRecords(myServerAddress, myDatabase, myUsername, myPassword, myFondsID, myFilename, 60 * 60)
        Catch ex As Exception
            MsgBoxException(ex)
        End Try

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)
        Debug.WriteLine(Path.GetFileName(myFilename) & ": " & timeSpan.Minutes.ToString.PadLeft(2, "0") & ":" & timeSpan.Seconds.ToString.PadLeft(2, "0") & " minutos")

        Cursor.Current = Cursors.Default
    End Sub



    Public Sub ExportPartialDIF()
        Cursor.Current = Cursors.WaitCursor
        Dim startTime As Date = Date.Now

        Try
            SQLLazyNode.DumpFondsRecords(myServerAddress, myDatabase, myUsername, myPassword, myCompleteUnitID, myFilename, 60 * 60)
        Catch ex As Exception
            MsgBoxException(ex)
        End Try

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)
        Debug.WriteLine(Path.GetFileName(myFilename) & ": " & timeSpan.Minutes.ToString.PadLeft(2, "0") & ":" & timeSpan.Seconds.ToString.PadLeft(2, "0") & " minutos")

        Cursor.Current = Cursors.Default
    End Sub

#End Region


End Class

