
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Text.RegularExpressions
Imports System.Threading

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls



Public Class Iterator

#Region "Properties"

    Private myProgressDialog As ProgressDialog.ProgressDialog
    Private myRootLazyNode As LazyNode
    Private myResult As Object
    Private myArgument As Object
    Private AllowCancel As Boolean
    Private ProgressDialogMaximumValue As Integer = 10


    '
    Private myLazyNodes As LazyNodeCollection


    Public Enum Action

        ' New actions, since version 3.0.2
        MakeSelectedNodesVisible
        MakeSelectedNodesInvisible
        MakeSelectedNodesValid
        MakeSelectedNodesInvalid
        MakeSelectedNodesAvailable
        MakeSelectedNodesUnavailable

        MakeVisible
        MakeInvisible
        MakeValid
        MakeInvalid
        MakeAvailable
        MakeUnavailable

        CollectFondsGuideData
        CollectInventoryData
        CollectUIInventoryData
        CollectCatalogData
        CollectSeriesListData
        CollectInstalationUnitsListData
        CollectInstalationUnitsBySeriesListData
        CollectClassificationPlanData
        CollectAuthorsListData

        UpdateCompleteUnitId
        CountNodesByOtherLevel

        SearchReplace
        Search
    End Enum


    Public ReadOnly Property Result()
        Get
            Return myResult
        End Get
    End Property

    Public WriteOnly Property Argument() As Object
        Set(ByVal Value As Object)
            myArgument = Value
        End Set
    End Property

#End Region

#Region "Contructors"


    Public Sub New(ByVal LazyNodes As LazyNodeCollection)
        myLazyNodes = LazyNodes
        AllowCancel = True
    End Sub


    Public Sub New(ByVal RootLazyNode As LazyNode)
        myRootLazyNode = RootLazyNode
        AllowCancel = True
    End Sub


    Public Sub New(ByVal RootLazyNode As LazyNode, ByVal AllowCancel As Boolean)
        myRootLazyNode = RootLazyNode
        Me.AllowCancel = AllowCancel
    End Sub

    Public Sub New(ByVal RootLazyNode As LazyNode, ByVal AllowCancel As Boolean, ByVal ProgressDialogMaximumValue As Integer)
        myRootLazyNode = RootLazyNode
        Me.AllowCancel = AllowCancel
        'Me.ProgressDialogMaximumValue = ProgressDialogMaximumValue
        Me.ProgressDialogMaximumValue = myRootLazyNode.DescendantsCount
    End Sub




#End Region


    Public Function Start(ByVal Action As Action) As Object
        Cursor.Current = Cursors.WaitCursor

        myProgressDialog = New ProgressDialog.ProgressDialog(AllowCancel)
        'myProgressDialog.MaximumValue = Me.ProgressDialogMaximumValue
        If Not myRootLazyNode Is Nothing Then myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount
        myProgressDialog.ShowTimeToEnd = True

        Dim thread As thread
        Select Case Action
            Case Action.MakeSelectedNodesInvalid : thread = New thread(New ThreadStart(AddressOf MakeSelectedNodesInvalid))
            Case Action.MakeSelectedNodesValid : thread = New thread(New ThreadStart(AddressOf MakeSelectedNodesValid))
            Case Action.MakeSelectedNodesVisible : thread = New thread(New ThreadStart(AddressOf MakeSelectedNodesVisible))
            Case Action.MakeSelectedNodesInvisible : thread = New thread(New ThreadStart(AddressOf MakeSelectedNodesInvisible))
            Case Action.MakeSelectedNodesAvailable : thread = New thread(New ThreadStart(AddressOf MakeSelectedNodesAvailable))
            Case Action.MakeSelectedNodesUnavailable : thread = New thread(New ThreadStart(AddressOf MakeSelectedNodesUnavailable))

            Case Action.MakeInvalid : thread = New thread(New ThreadStart(AddressOf MakeInvalid))
            Case Action.MakeValid : thread = New thread(New ThreadStart(AddressOf MakeValid))
            Case Action.MakeVisible : thread = New thread(New ThreadStart(AddressOf MakeVisible))
            Case Action.MakeInvisible : thread = New thread(New ThreadStart(AddressOf MakeInvisible))
            Case Action.MakeAvailable : thread = New thread(New ThreadStart(AddressOf MakeAvailable))
            Case Action.MakeUnavailable : thread = New thread(New ThreadStart(AddressOf MakeUnavailable))
            Case Action.CollectFondsGuideData : thread = New thread(New ThreadStart(AddressOf CollectFondsGuideData))
            Case Action.CollectInventoryData : thread = New thread(New ThreadStart(AddressOf CollectInventoryData))
            Case Action.CollectUIInventoryData : thread = New thread(New ThreadStart(AddressOf CollectUIInventoryData))
            Case Action.CollectCatalogData : thread = New thread(New ThreadStart(AddressOf CollectCatalogData))
            Case Action.CollectSeriesListData : thread = New thread(New ThreadStart(AddressOf CollectSeriesListData))
            Case Action.CollectInstalationUnitsListData : thread = New thread(New ThreadStart(AddressOf CollectInstalationUnitsListData))
            Case Action.CollectInstalationUnitsBySeriesListData : thread = New thread(New ThreadStart(AddressOf CollectInstalationUnitsBySeriesListData))
            Case Action.CollectClassificationPlanData : thread = New thread(New ThreadStart(AddressOf CollectClassificationPlanData))
            Case Action.CollectAuthorsListData : thread = New thread(New ThreadStart(AddressOf CollectAuthorsListData))
            Case Action.CountNodesByOtherLevel : thread = New thread(New ThreadStart(AddressOf CountNodesByOtherLevel))
            Case Action.SearchReplace : thread = New thread(New ThreadStart(AddressOf SearchReplace))
            Case Action.Search : thread = New thread(New ThreadStart(AddressOf Search))
            Case Action.UpdateCompleteUnitId : thread = New thread(New ThreadStart(AddressOf UpdateCompleteUnitID))
            Case Else : Exit Function
        End Select


        thread.Start()

        myProgressDialog.Show()

        While thread.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While

        myProgressDialog.Hide()
        myProgressDialog.Close()
        myProgressDialog.Dispose()

        Cursor.Current = Cursors.Default
        Return Result
    End Function




#Region "Action code"
#Region "New methods since version 3.0.2"

    Private Sub MakeSelectedNodesVisible()
        If myLazyNodes Is Nothing Then Exit Sub

        Cursor.Current = Cursors.WaitCursor
        For Each LazyNode As LazyNode In myLazyNodes
            myProgressDialog.Text = String.Format(InfoMessage("ChangeVisibility.Title"), LazyNode.UnitTitle)
            myProgressDialog.MaximumValue = LazyNode.DescendantsCount
            LazyNode.StopableCatamorphism(New GeneChangeVisiblility(True, myProgressDialog))
        Next
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub MakeSelectedNodesInvisible()
        If myLazyNodes Is Nothing Then Exit Sub

        Cursor.Current = Cursors.WaitCursor
        For Each LazyNode As LazyNode In myLazyNodes
            myProgressDialog.Text = String.Format(InfoMessage("ChangeVisibility.Title"), LazyNode.UnitTitle)
            myProgressDialog.MaximumValue = LazyNode.DescendantsCount
            LazyNode.StopableCatamorphism(New GeneChangeVisiblility(False, myProgressDialog))
        Next
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub MakeSelectedNodesValid()
        If myLazyNodes Is Nothing Then Exit Sub

        Cursor.Current = Cursors.WaitCursor
        For Each LazyNode As LazyNode In myLazyNodes
            myProgressDialog.MaximumValue = LazyNode.DescendantsCount
            myProgressDialog.Text = String.Format(InfoMessage("ChangeValidation.Title"), LazyNode.UnitTitle)
            LazyNode.StopableCatamorphism(New GeneChangeValidation(True, myProgressDialog))
        Next
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MakeSelectedNodesInvalid()
        If myLazyNodes Is Nothing Then Exit Sub

        Cursor.Current = Cursors.WaitCursor
        For Each LazyNode As LazyNode In myLazyNodes
            myProgressDialog.MaximumValue = LazyNode.DescendantsCount
            myProgressDialog.Text = String.Format(InfoMessage("ChangeValidation.Title"), LazyNode.UnitTitle)
            LazyNode.StopableCatamorphism(New GeneChangeValidation(False, myProgressDialog))
        Next
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub MakeSelectedNodesAvailable()
        If myLazyNodes Is Nothing Then Exit Sub

        Cursor.Current = Cursors.WaitCursor
        For Each LazyNode As LazyNode In myLazyNodes
            myProgressDialog.MaximumValue = LazyNode.DescendantsCount
            myProgressDialog.Text = String.Format(InfoMessage("ChangeAvailability.Title"), LazyNode.UnitTitle)
            LazyNode.StopableCatamorphism(New GeneChangeAvailability(True, myProgressDialog))
        Next
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub MakeSelectedNodesUnavailable()
        If myLazyNodes Is Nothing Then Exit Sub

        Cursor.Current = Cursors.WaitCursor
        For Each LazyNode As LazyNode In myLazyNodes
            myProgressDialog.MaximumValue = LazyNode.DescendantsCount
            myProgressDialog.Text = String.Format(InfoMessage("ChangeAvailability.Title"), LazyNode.UnitTitle)
            LazyNode.StopableCatamorphism(New GeneChangeAvailability(False, myProgressDialog))
        Next
        Cursor.Current = Cursors.Default
    End Sub


#End Region


    Private Sub MakeVisible()
        Cursor.Current = Cursors.WaitCursor
        myProgressDialog.Text = String.Format(InfoMessage("ChangeVisibility.Title"), myRootLazyNode.UnitTitle)
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount
        myRootLazyNode.StopableCatamorphism(New GeneChangeVisiblility(False, myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MakeInvisible()
        myProgressDialog.Text = String.Format(InfoMessage("ChangeVisibility.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount
        myRootLazyNode.StopableCatamorphism(New GeneChangeVisiblility(False, myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MakeValid()
        Cursor.Current = Cursors.WaitCursor
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount
        myProgressDialog.Text = String.Format(InfoMessage("ChangeValidation.Title"), myRootLazyNode.UnitTitle)
        myRootLazyNode.StopableCatamorphism(New GeneChangeValidation(True, myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MakeInvalid()
        Cursor.Current = Cursors.WaitCursor
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount
        myProgressDialog.Text = String.Format(InfoMessage("ChangeValidation.Title"), myRootLazyNode.UnitTitle)
        myRootLazyNode.StopableCatamorphism(New GeneChangeValidation(False, myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MakeAvailable()
        Cursor.Current = Cursors.WaitCursor
        myProgressDialog.Text = String.Format(InfoMessage("ChangeAvailability.Title"), myRootLazyNode.UnitTitle)
        myRootLazyNode.StopableCatamorphism(New GeneChangeAvailability(True, myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MakeUnavailable()
        myProgressDialog.Text = String.Format(InfoMessage("ChangeAvailability.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myRootLazyNode.StopableCatamorphism(New GeneChangeAvailability(False, myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub CollectFondsGuideData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneFondsGuide(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub CollectInventoryData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneInventory(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub CollectUIInventoryData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneUIInventory(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub CollectCatalogData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneCatalog(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub CollectSeriesListData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneSeriesList(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub CollectAuthorsListData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneAuthorsList(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub CollectInstalationUnitsListData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneInstalationUnitsList(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub CollectInstalationUnitsBySeriesListData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneInstalationUnitsBySeriesList(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub CollectClassificationPlanData()
        myProgressDialog.Text = String.Format(InfoMessage("CollectingData.ProgressBar.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneInventory(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub





    Private Sub CountNodesByOtherLevel()
        myProgressDialog.Text = String.Format(InfoMessage("GeneNodeCounter.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        myResult = myRootLazyNode.StopableCatamorphism(New GeneNodeCounterPro(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub SearchReplace()
        myProgressDialog.Text = String.Format(InfoMessage("SearchReplace.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        Dim Args As Hashtable = CType(myArgument, Hashtable)
        myResult = myRootLazyNode.StopableCatamorphism(New GeneSearchReplace(myProgressDialog, Args("FieldName"), Args("SearchString"), Args("ReplaceBy"), Args("CaseSensitive"), Args("RegExp"), Args("ProcessInfoName")))
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub Search()
        myProgressDialog.Text = String.Format(InfoMessage("Search.Title"), myRootLazyNode.UnitTitle)
        Cursor.Current = Cursors.WaitCursor
        Dim Args As Hashtable = CType(myArgument, Hashtable)
        myResult = myRootLazyNode.StopableCatamorphism(New GeneSearch(myProgressDialog, Args("FieldName"), Args("SearchString"), Args("CaseSensitive"), Args("RegExp")))
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub UpdateCompleteUnitID()
        myProgressDialog.Text = String.Format(InfoMessage("MustUpdateCompleteUnitIdDescendants.Title"))
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount
        myProgressDialog.ShowTimeToEnd = True

        Cursor.Current = Cursors.WaitCursor
        Me.myRootLazyNode.TopDownStopableCatamorphism(New GeneUpdateCompleteUnitId(myProgressDialog))
        Cursor.Current = Cursors.Default
    End Sub






#End Region


End Class
