
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Text.RegularExpressions
Imports System.Threading
Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls
Imports DigitArq.UserControls.CustomUserControls


Public Class Validator


#Region "Properties definition"

    'Public Enum ExtremeDateTypes
    '    Initial
    '    Final
    'End Enum

    'Private Const IncompleteDate As String = "^\d*-\d*-\d*$"
    'Private Const DayMonthYear As String = "^\d\d-\d\d-\d\d\d\d$"
    'Private Const YearMonthDay As String = "^\d\d\d\d-\d\d-\d\d$"
    'Private Const YearMonth As String = "^\d\d\d\d-\d\d-$"
    'Private Const YearDay As String = "^\d\d\d\d--\d\d$"
    'Private Const Year As String = "^\d\d\d\d--$"
    'Private Const JustYear As String = "^\d\d\d\d$"


    Private myProgressDialog As ProgressDialog.ProgressDialog
    Private myRootLazyNode As LazyNode
    Private myValidationResults As ValidationErrorCollection = Nothing
    Private myLazyTree As LazyTree
    Private myNodeCount As Integer = 10
    Private myOtherLevelIcons As ImageList


#End Region

#Region "Constructor"

    Public Sub New(ByVal RootLazyNode As LazyNode, ByVal LazyTree As LazyTree, ByVal OtherLevelIcons As ImageList)
        myRootLazyNode = RootLazyNode
        myLazyTree = LazyTree
        myOtherLevelIcons = OtherLevelIcons

    End Sub


    Public Sub New(ByVal RootLazyNode As LazyNode, ByVal LazyTree As LazyTree, ByVal NodeCount As Integer, ByVal OtherLevelIcons As ImageList)
        myRootLazyNode = RootLazyNode
        myLazyTree = LazyTree
        myNodeCount = NodeCount
        myOtherLevelIcons = OtherLevelIcons
    End Sub

#End Region


#Region "Validation Algorithms"



    Public Function Validate(ByVal ShowResultsWindow As Boolean) As Boolean
        Cursor.Current = Cursors.WaitCursor
        Dim startTime As Date = Date.Now

        myProgressDialog = New ProgressDialog.ProgressDialog(True)
        myProgressDialog.MinimumValue = 0
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount + 1
        myProgressDialog.ShowTimeToEnd = True

        myProgressDialog.Text = String.Format(InfoMessage("Validator.Title"), myRootLazyNode.UnitTitle)
        '"A importar " & Path.GetFileName(myFilename) & "..."
        myProgressDialog.Show()


        Dim t As Thread = New Thread(New ThreadStart(AddressOf ValidateLazyNode))
        t.Start()

        While t.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While


        myProgressDialog.Hide()
        myProgressDialog.Close()
        myProgressDialog.Dispose()

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)

        If ShowResultsWindow Then
            OpenValidationResults()
        ElseIf myValidationResults.Count > 0 Then
            OpenValidationResults()
        End If


        Cursor.Current = Cursors.Default
        Return myValidationResults.Count = 0
    End Function


    Public Function InferenceValidation(ByVal ShowResultsWindow As Boolean) As Boolean
        Cursor.Current = Cursors.WaitCursor
        Dim startTime As Date = Date.Now

        myProgressDialog = New ProgressDialog.ProgressDialog(True)
        myProgressDialog.MinimumValue = 0
        myProgressDialog.MaximumValue = myRootLazyNode.DescendantsCount + 1
        myProgressDialog.ShowTimeToEnd = True
        myProgressDialog.Text = String.Format(InfoMessage("Validator.Title"), myRootLazyNode.UnitTitle)
        '"A importar " & Path.GetFileName(myFilename) & "..."
        myProgressDialog.Show()


        Dim t As Thread = New Thread(New ThreadStart(AddressOf InferenceValidateLazyNode))
        t.Start()

        While t.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While


        myProgressDialog.Hide()
        myProgressDialog.Close()
        myProgressDialog.Dispose()

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)

        If ShowResultsWindow Then
            OpenValidationResults()
        ElseIf myValidationResults.Count > 0 Then
            OpenValidationResults()
        End If


        Cursor.Current = Cursors.Default
        Return myValidationResults.Count = 0
    End Function


    Private Sub OpenValidationResults()
        If myValidationResults Is Nothing Then Exit Sub
        Dim frmValidationResults As New ValidationResultsForm(myValidationResults, myLazyTree, myOtherLevelIcons)
        'frmValidationResults.TopMost = True
        frmValidationResults.Show()
    End Sub


    Private Sub ValidateLazyNode()
        myValidationResults = myRootLazyNode.StopableCatamorphism(New GeneValidator(myProgressDialog))
    End Sub


    Private Sub InferenceValidateLazyNode()
        myValidationResults = myRootLazyNode.StopableCatamorphism(New GeneInferenceValidator(myProgressDialog))
    End Sub




    ' function that evaluates a LazyNode
    Public Shared Function GetLazyNodeErrors(ByVal Node As LazyNode) As ValidationErrorCollection
        Dim Errors As New ValidationErrorCollection

        If Not IsReferenceValid(Node.UnitId, Node.OtherLevel) Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.InvalidReference")))
        End If

        If Node.OtherLevelIndex <= GetOtherLevelIndex(EAD.OTHERLEVEL_SUBSUBFONDS) AndAlso _
           Not hasRepository(Node.Repository) Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.InvalidRepository")))
        End If


        If (Node.isLeaf) AndAlso Not AreExtremeDatesValid(Node.UnitDateInitial, Node.UnitDateFinal) Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.MissingDatesInLeaf")))
        End If

        If Node.OtherLevel = OTHERLEVEL_INSTALATIONUNIT Then
            ' Temporarily disabled

            'If Not IsValidContainerType(Node.ContainerType) Then
            '    Errors.Add(New ValidationError(Node, General.ErrorMessage("Validation.ContainerTypeNotDefined")))
            'End If

            If Node.ContainerType = VisualFieldLabel("ContainerType.Other") AndAlso _
               Node.ContainerCustomType.Length = 0 Then
                Errors.Add(New ValidationError(Node, ErrorMessage("Validation.ContainerTypeNotDefined")))
            End If

            If Node.PhysLoc.Length = 0 Then
                Errors.Add(New ValidationError(Node, ErrorMessage("Validation.PhysLocNotDefined")))
            End If

        End If

        If Node.UnitTitle.Length = 0 Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.UnitTitleNotDefined")))
        End If

        If (Not Node.Parent Is Nothing) Then
            If Node.Parent.OtherLevelIndex >= Node.OtherLevelIndex Then Errors.Add(New ValidationError(Node, ErrorMessage("Validation.HierarquicalInconsistency")))
        End If

        If (Not IsValidDate(Node.ProcessInfoDate)) Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.InvalidDatesInProcessInfo")))
        End If

        Return Errors
    End Function


    Public Shared Function GetLazyNodeInferenceErrors(ByVal Node As LazyNode) As ValidationErrorCollection
        Dim Errors As New ValidationErrorCollection

        If (Node.isLeaf) AndAlso Not AreExtremeDatesValid(Node.UnitDateInitial, Node.UnitDateFinal) Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.MissingDatesInLeaf")))
        End If

        If Node.OtherLevel = OTHERLEVEL_INSTALATIONUNIT AndAlso Not IsValidContainerType(Node.ContainerType) Then
            Errors.Add(New ValidationError(Node, ErrorMessage("Validation.ContainerTypeNotDefined")))
        End If

        Return Errors
    End Function


#End Region


End Class

