Imports System.Xml
Imports System.IO

#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports Digitarq.Utility

Public Class ProgramState
    Private myConfigXml As XmlDocument


    Public Sub New()
        myConfigXml = New XmlDocument
        If Not File.Exists(STATECONFIG_FILENAME) Then
            myConfigXml.LoadXml("<?xml version='1.0' encoding='utf-8'?><configuration> <appSettings> <LastLoginUsername></LastLoginUsername> <LastOpenedFonds></LastOpenedFonds> <LastUsedNode></LastUsedNode> <AskBeforeSave>True</AskBeforeSave> <AskBeforeRemove>True</AskBeforeRemove><LastFondsSearched></LastFondsSearched> <SortBy></SortBy></appSettings></configuration>")
        Else
            myConfigXml.Load(STATECONFIG_FILENAME)
        End If
    End Sub


#Region "Digitarq properties"

    Property OpenChangeLongOnLoad() As Boolean
        Get
            Dim storedValue As String = GetConfigValue("OpenChangeLongOnLoad")
            If storedValue = "" Then
                Return True
            Else
                Return StrToBool(storedValue)
            End If
        End Get
        Set(ByVal Value As Boolean)
            SetConfigValue("OpenChangeLongOnLoad", Value.ToString)
        End Set
    End Property

    Property AskBeforeSave() As Boolean
        Get
            Return StrToBool(GetConfigValue("AskBeforeSave"))
        End Get
        Set(ByVal Value As Boolean)
            SetConfigValue("AskBeforeSave", Value.ToString)
        End Set
    End Property


    Property AskBeforeRemove() As Boolean
        Get
            Return StrToBool(GetConfigValue("AskBeforeRemove"))
        End Get
        Set(ByVal Value As Boolean)
            SetConfigValue("AskBeforeRemove", Value.ToString)
        End Set
    End Property



    Property AutoUpdateCompleteUnitID() As Boolean
        Get
            Return StrToBool(GetConfigValue("AutoUpdateCompleteUnitID"))
        End Get
        Set(ByVal Value As Boolean)
            SetConfigValue("AutoUpdateCompleteUnitID", Value.ToString)
        End Set
    End Property


    Property LastFondsSearched() As String
        Get
            Return GetConfigValue("LastFondsSearched")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastFondsSearched", Value)
        End Set
    End Property


    Property LastUsedNode() As Integer
        Get
            Return StrToInt(GetConfigValue("LastUsedNode"))
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("LastUsedNode", Value)
        End Set
    End Property


    Property SortBy() As Integer
        Get
            Try

                Return StrToInt(GetConfigValue("SortBy"))
            Catch ex As Exception
                Return 0
            End Try
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("SortBy", Value)
        End Set
    End Property


    Property LastOpenedFonds() As Integer
        Get
            Return StrToInt(GetConfigValue("LastOpenedFonds"))
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("LastOpenedFonds", Value)
        End Set
    End Property


    Property LastLoginUsername() As String
        Get
            Return GetConfigValue("LastLoginUsername")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastLoginUsername", Value)
        End Set
    End Property


    Property TextSize() As Integer
        Get
            Return StrToInt(GetConfigValue("TextSize"))
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("TextSize", Value)
        End Set
    End Property


    Property ViewMode() As Integer
        Get
            Try

                Return StrToInt(GetConfigValue("ViewMode"))
            Catch ex As Exception
                Return 0
            End Try
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("ViewMode", Value)
        End Set
    End Property

#End Region

#Region "Mini-Digitarq properties"

    Property IncorporationNumber() As String
        Get
            Return State("IncorporationNumber")
        End Get
        Set(ByVal Value As String)
            State("IncorporationNumber") = Value
        End Set
    End Property

    Property IncorporationDate() As String
        Get
            Return State("IncorporationDate")
        End Get
        Set(ByVal Value As String)
            State("IncorporationDate") = Value
        End Set
    End Property

    Property ProcessReference() As String
        Get
            Return State("ProcessReference")
        End Get
        Set(ByVal Value As String)
            State("ProcessReference") = Value
        End Set
    End Property

    Property ReceiverResponsible() As String
        Get
            Return State("ReceiverResponsible")
        End Get
        Set(ByVal Value As String)
            State("ReceiverResponsible") = Value
        End Set
    End Property

    Property SenderName() As String
        Get
            Return State("SenderName")
        End Get
        Set(ByVal Value As String)
            State("SenderName") = Value
        End Set
    End Property

    Property SenderAddress() As String
        Get
            Return State("SenderAddress")
        End Get
        Set(ByVal Value As String)
            State("SenderAddress") = Value
        End Set
    End Property

    Property SenderResponsible() As String
        Get
            Return State("SenderResponsible")
        End Get
        Set(ByVal Value As String)
            State("SenderResponsible") = Value
        End Set
    End Property

    Property TransportationUnit(ByVal Key As String) As String
        Get
            Return State("TransportationUnit", Key)
        End Get
        Set(ByVal Value As String)
            State("TransportationUnit", Key) = Value
        End Set
    End Property

    Public ReadOnly Property TransportationUnits() As Collection
        Get
            Dim keyCol As New Collection
            Dim nodeList As XmlNodeList = myConfigXml.SelectNodes(String.Format("/configuration/data[@name='{0}']/@key", "TransportationUnit"))
            Dim node As XmlNode
            For Each node In nodeList
                keyCol.Add(node.InnerText)
            Next
            Return keyCol
        End Get
    End Property

    Public Sub ClearTransportationUnits()
        Dim nodes As XmlNodeList = myConfigXml.SelectNodes(String.Format("/configuration/data[@name='{0}']", "TransportationUnit"))
        Dim node As XmlNode
        For Each node In nodes
            myConfigXml.Item("configuration").RemoveChild(node)
        Next
    End Sub

#End Region

#Region "Generic access methods"

    Public Sub Save()
        myConfigXml.Save(STATECONFIG_FILENAME)
    End Sub


    Private Function GetConfigValue(ByVal NodeName As String) As String
        Dim Node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/appSettings/{0}", NodeName))
        If Not Node Is Nothing Then
            Return Node.InnerText
        Else
            Return ""
        End If
    End Function


    Private Sub SetConfigValue(ByVal NodeName As String, ByVal Value As String)
        Dim Node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/appSettings/{0}", NodeName))
        If Not Node Is Nothing Then
            Node.InnerText = Value
        Else
            Node = myConfigXml.SelectSingleNode("/configuration/appSettings")
            Dim NewNode As XmlNode = myConfigXml.CreateNode(XmlNodeType.Element, NodeName, "")
            NewNode.InnerText = Value
            Node.AppendChild(NewNode)
        End If
    End Sub

    Private Property State(ByVal NodeName As String) As String
        Get
            Dim Node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/appSettings/{0}", NodeName))
            If Not Node Is Nothing Then
                Return Node.InnerText
            Else
                Return ""
            End If
        End Get
        Set(ByVal Value As String)
            Dim Node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/appSettings/{0}", NodeName))
            If Not Node Is Nothing Then
                Node.InnerText = Value
            Else
                Node = myConfigXml.SelectSingleNode("/configuration/appSettings")
                Dim NewNode As XmlNode = myConfigXml.CreateNode(XmlNodeType.Element, NodeName, "")
                NewNode.InnerText = Value
                Node.AppendChild(NewNode)
            End If
        End Set
    End Property

    Private Property State(ByVal name As String, ByVal key As String) As String
        Get
            Dim node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/data[@name='{0}' and @key='{1}']/@value", name, key))
            If node Is Nothing Then Return "" Else Return node.InnerText()
        End Get
        Set(ByVal value As String)
            Dim node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/data[@name='{0}' and @key='{1}']", name, key))
            If Not node Is Nothing Then myConfigXml.Item("configuration").RemoveChild(node)
            myConfigXml.Item("configuration").InnerXml &= String.Format("<data name='{0}' key='{1}' value='{2}'/>", name, key, value)
        End Set
    End Property

#End Region

End Class
