Imports System.Threading
Imports Digitarq.Data.Entities.MDA
Imports DigitArq.UserControls.CustomUserControls



Public Class LazyTreeNodesLoader
    Private Const DummyNodeText As String = "__#DUMMY#__"

    Private myLazyTree As LazyTree
    Private myThread As Thread = New Thread(New ThreadStart(AddressOf TreeNodesLoader))

    Private myParentTreeNode As TreeNode
    Private myParentLazyNode As LazyNode




    Public Sub New(ByVal LazyTree As LazyTree, _
                   ByRef ParentTreeNode As TreeNode, _
                   ByVal ParentLazyNode As LazyNode)

        myLazyTree = LazyTree
        myParentTreeNode = ParentTreeNode
        myParentLazyNode = ParentLazyNode

    End Sub




    Public Sub LoadNodes()
        'myThread.Priority = ThreadPriority.Lowest
        myThread.Start()

        While myThread.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While

    End Sub


    Private Sub TreeNodesLoader()
        Try

            AddNodes(myParentTreeNode, myParentLazyNode)
        Catch ex As Exception
            Debug.WriteLine("TreeNodesLoader: " & ex.Message)
        End Try
    End Sub



    Private Delegate Sub AddNodeDelegate(ByRef ParentTreeNode As TreeNode, ByVal ParentLazyNode As LazyNode)


    Private Sub AddNodes(ByRef ParentTreeNode As TreeNode, ByVal ParentLazyNode As LazyNode)

        For Each LazyNode As LazyNode In ParentLazyNode.LiteChildren
            myLazyTree.Invoke(New AddNodeDelegate(AddressOf AddNode), New Object() {myParentTreeNode, LazyNode})
        Next
    End Sub



    Private Sub AddNode(ByRef ParentTreeNode As TreeNode, ByVal LazyNode As LazyNode)
        Dim NewNode As TreeNode
        NewNode = New TreeNode(LazyNode.UnitId, LazyNode.OtherLevelIndex, LazyNode.OtherLevelIndex)
        NewNode.Tag = LazyNode

        LazyNode.TreeNode = NewNode

        SetupTreeNodeColor(NewNode)

        If (LazyNode.HasChildren) Then ' nao adiciona filhos para os elementos folha
            NewNode.Nodes.Add(DummyNodeText)
        End If

        ParentTreeNode.Nodes.Add(NewNode)
    End Sub


    Private Sub SetupTreeNodeColor(ByVal Node As TreeNode)
        If Node Is Nothing Then Exit Sub
        Dim LazyNode As LazyNode = CType(Node.Tag, LazyNode)


        If LazyNode.Valid Then
            If LazyNode.Visible Then Node.ForeColor = Color.DarkGreen Else Node.ForeColor = Color.DarkRed
        Else
            If LazyNode.Visible Then Node.ForeColor = Color.DarkGreen Else Node.ForeColor = Color.DarkRed
            Node.Text = LazyNode.UnitId & "*"
        End If

    End Sub



    Public Function Thread() As Thread
        Return myThread
    End Function


    Public Sub Suspend()
        If myThread.IsAlive Then
            myThread.Suspend()
        End If
    End Sub


    Public ReadOnly Property TreeNode() As TreeNode
        Get
            Return myParentTreeNode
        End Get
    End Property


End Class
