
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MDA

    Public Class EacLanguageDeclaration
        Inherits CollectionBase


        Public Function Add(ByVal Language As String) As Integer
            Return List.Add(New EacLanguageDeclarationItem(Language))
        End Function


        Public Function Add(ByVal ID As Integer, ByVal Language As String) As Integer
            Return List.Add(New EacLanguageDeclarationItem(ID, Language))
        End Function


        Public Sub Remove(ByVal Item As EacLanguageDeclarationItem)
            List.Remove(Item)
        End Sub

        Public Function Item(ByVal index As Integer) As EacLanguageDeclarationItem
            Return List.Item(index)
        End Function


        Public Function toXml() As String
            If Count = 0 Then Return ""

            Dim xml As String = "<languagedecl>"
            For i As Integer = 0 To Count - 1
                xml &= String.Format("<language>{0}</language>", Item(i).Language)
            Next
            xml &= "</languagedecl>"
            Return xml
        End Function



    End Class



    Public Class EacLanguageDeclarationItem
        Private myID As Integer
        Private myLanguage As String


        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
            If Not TypeOf obj Is EacLanguageDeclarationItem Then
                Return False
            Else
                Return ID = CType(obj, EacLanguageDeclarationItem).ID
            End If
        End Function




        Public Sub New(ByVal Language As String)
            myID = 0
            myLanguage = Language
        End Sub

        Public Sub New(ByVal ID As Integer, ByVal Language As String)
            myID = ID
            myLanguage = Language
        End Sub

        Public Sub New(ByVal ID As Integer)
            myID = ID
        End Sub


        Property Language() As String
            Get
                Return myLanguage
            End Get
            Set(ByVal Value As String)
                myLanguage = Value
            End Set
        End Property


        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property


        Public Function Clone() As Object
            Return New EacLanguageDeclarationItem(myID, myLanguage)
        End Function




    End Class
End Namespace
