
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MDA

    Public Class EacRelationships
        Inherits CollectionBase


        Public Function Add(ByVal Type As String, ByVal Name As String, ByVal Place As String, ByVal DateStr As String, ByVal Note As String, ByVal EacType As String) As Integer
            Return List.Add(New EacRelationshipsItem(Type, Name, Place, DateStr, Note, EacType))
        End Function


        Public Function Add(ByVal ID As Integer, ByVal Type As String, ByVal Name As String, ByVal Place As String, ByVal DateStr As String, ByVal Note As String, ByVal EacType As String) As Integer
            Return List.Add(New EacRelationshipsItem(ID, Type, Name, Place, DateStr, Note, EacType))
        End Function


        Public Sub Remove(ByVal Item As EacRelationshipsItem)
            List.Remove(Item)
        End Sub

        Public Function Item(ByVal index As Integer) As EacRelationshipsItem
            Return List.Item(index)
        End Function




        Public Function toXml() As String
            If Count = 0 Then Return ""
            Dim PrefixName As String

            Dim xml As String = "<eacrels>"
            For i As Integer = 0 To Count - 1
                xml &= String.Format("<eacrel reltype='{0}'><{5}name>{1}</{5}name><date>{3}</date><place>{2}</place><descnote>{4}</descnote></eacrel>", RelTypeToEac(Item(i).Type), Item(i).Name, Item(i).Place, Item(i).DateStr, Item(i).Note, EAC.EacPrefix(Item(i).EacType))
            Next
            xml &= "</eacrels>"
            Return xml
        End Function

        Private Function RelTypeToEac(ByVal RelType As String)
            Select Case RelType
                Case (VisualFieldLabel("Authorities.Associative")) : Return "associative"
                Case (VisualFieldLabel("Authorities.Child")) : Return "child"
                Case (VisualFieldLabel("Authorities.Earlier")) : Return "earlier"
                Case (VisualFieldLabel("Authorities.Identity")) : Return "identity"
                Case (VisualFieldLabel("Authorities.Later")) : Return "later"
                Case (VisualFieldLabel("Authorities.Parent")) : Return "parent"
                Case (VisualFieldLabel("Authorities.Subordinate")) : Return "subordinate"
                Case (VisualFieldLabel("Authorities.Superior")) : Return "superior"
                Case Else : Return ""
            End Select
        End Function

    End Class



    Public Class EacRelationshipsItem
        Private myID As Integer
        Private myType As String
        Private myName As String
        Private myPlace As String
        Private myDate As String
        Private myNote As String
        Private myEacType As String



        Public Sub New(ByVal Type As String, ByVal Name As String, ByVal Place As String, ByVal DateStr As String, ByVal Note As String, ByVal EacType As String)
            myID = 0
            myType = Type
            myName = Name
            myPlace = Place
            myDate = DateStr
            myNote = Note
            myEacType = EacType
        End Sub

        Public Sub New(ByVal ID As Integer, ByVal Type As String, ByVal Name As String, ByVal Place As String, ByVal DateStr As String, ByVal Note As String, ByVal EacType As String)
            myID = ID
            myType = Type
            myName = Name
            myPlace = Place
            myDate = DateStr
            myNote = Note
            myEacType = EacType
        End Sub



        Public Sub New(ByVal ID As Integer)
            myID = ID
        End Sub


        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
            If Not TypeOf obj Is EacRelationshipsItem Then
                Return False
            Else
                Return ID = CType(obj, EacRelationshipsItem).ID
            End If
        End Function


        Property Type() As String
            Get
                Return myType
            End Get
            Set(ByVal Value As String)
                myType = Value
            End Set
        End Property


        Property EacType() As String
            Get
                Return myEacType
            End Get
            Set(ByVal Value As String)
                myEacType = Value
            End Set
        End Property



        Property Place() As String
            Get
                Return myPlace
            End Get
            Set(ByVal Value As String)
                myPlace = Value
            End Set
        End Property

        Property DateStr() As String
            Get
                Return myDate
            End Get
            Set(ByVal Value As String)
                myDate = Value
            End Set
        End Property


        Property Note() As String
            Get
                Return myNote
            End Get
            Set(ByVal Value As String)
                myNote = Value
            End Set
        End Property


        Property Name() As String
            Get
                Return myName
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property


        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property


        Public Function Clone() As Object
            Return New EacRelationshipsItem(myID, myType, myName, myPlace, myDate, myNote)
        End Function




    End Class
End Namespace
