
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MDA

    Module EADDefinitions
        Public Const OTHERLEVEL_FONDS As String = "F"
        Public Const OTHERLEVEL_SUBFONDS As String = "SF"
        Public Const OTHERLEVEL_SUBSUBFONDS As String = "SSF"
        Public Const OTHERLEVEL_SECTION As String = "SC"
        Public Const OTHERLEVEL_SUBSECTION As String = "SSC"
        Public Const OTHERLEVEL_SUBSUBSECTION As String = "SSSC"
        Public Const OTHERLEVEL_SERIES As String = "SR"
        Public Const OTHERLEVEL_SUBSERIES As String = "SSR"
        Public Const OTHERLEVEL_SUBSUBSERIES As String = "SSSR"
        Public Const OTHERLEVEL_INSTALATIONUNIT As String = "UI"
        Public Const OTHERLEVEL_COMPOSEDDOCUMENT As String = "DC"
        Public Const OTHERLEVEL_DOCUMENT As String = "D"

        Public OtherLevels() As String = { _
                        OTHERLEVEL_FONDS, _
                        OTHERLEVEL_SUBFONDS, _
                        OTHERLEVEL_SUBSUBFONDS, _
                        OTHERLEVEL_SECTION, _
                        OTHERLEVEL_SUBSECTION, _
                        OTHERLEVEL_SUBSUBSECTION, _
                        OTHERLEVEL_SERIES, _
                        OTHERLEVEL_SUBSERIES, _
                        OTHERLEVEL_SUBSUBSERIES, _
                        OTHERLEVEL_INSTALATIONUNIT, _
                        OTHERLEVEL_COMPOSEDDOCUMENT, _
                        OTHERLEVEL_DOCUMENT}

        Public Const UNITID_NEW As String = "[novo]"

        Public Const XML_EADHEADER As String = "<eadheader> <eadid countrycode='pt' mainagencycode='adprt' url='http://www.adporto.org'/>" & _
            "<filedesc> <titlestmt> <titleproper/> <author>Arquivo Distrital do Porto</author> </titlestmt> <publicationstmt> " & _
            "<publisher>Arquivo Distrital do Porto</publisher> <date> 2003</date> </publicationstmt> </filedesc> <profiledesc> " & _
            "<langusage>A descrio deste fundo encontra-se em <language>portugus</language>.</langusage>" & _
            "</profiledesc> </eadheader>"

        Public Const XML_EAD_NEW As String = "<ead>" & XML_EADHEADER & "<archdesc/> </ead>"


        Public Function GetOtherLevelIndex(ByVal OtherLevel As String) As Integer
            Select Case OtherLevel
                Case OTHERLEVEL_FONDS : Return 1
                Case OTHERLEVEL_SUBFONDS : Return 2
                Case OTHERLEVEL_SUBSUBFONDS : Return 3
                Case OTHERLEVEL_SECTION : Return 4
                Case OTHERLEVEL_SUBSECTION : Return 5
                Case OTHERLEVEL_SUBSUBSECTION : Return 6
                Case OTHERLEVEL_SERIES : Return 7
                Case OTHERLEVEL_SUBSERIES : Return 8
                Case OTHERLEVEL_SUBSUBSERIES : Return 9
                Case OTHERLEVEL_INSTALATIONUNIT : Return 10
                Case OTHERLEVEL_COMPOSEDDOCUMENT : Return 11
                Case OTHERLEVEL_DOCUMENT : Return 12
                Case Else : Return 0
            End Select
        End Function

        Public Function OtherLevelIndexToOtherLevel(ByVal OtherLevelIndex As Integer) As String
            Select Case OtherLevelIndex
                Case 1 : Return OTHERLEVEL_FONDS
                Case 2 : Return OTHERLEVEL_SUBFONDS
                Case 3 : Return OTHERLEVEL_SUBSUBFONDS
                Case 4 : Return OTHERLEVEL_SECTION
                Case 5 : Return OTHERLEVEL_SUBSECTION
                Case 6 : Return OTHERLEVEL_SUBSUBSECTION
                Case 7 : Return OTHERLEVEL_SERIES
                Case 8 : Return OTHERLEVEL_SUBSERIES
                Case 9 : Return OTHERLEVEL_SUBSUBSERIES
                Case 10 : Return OTHERLEVEL_INSTALATIONUNIT
                Case 11 : Return OTHERLEVEL_COMPOSEDDOCUMENT
                Case 12 : Return OTHERLEVEL_DOCUMENT
                Case Else : Return "Unknown"
            End Select
        End Function




    End Module
End Namespace
