
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.ComponentModel
Imports System.Configuration.Install
Imports System.IO
Imports System.Reflection
Imports System.Data.SqlClient
Imports System.Runtime.InteropServices
Imports System.Xml
Imports System.Reflection.Assembly
Imports System.Configuration.ConfigurationSettings
Imports DigitArq.Utility


<RunInstaller(True)> Public Class DigitarqInstaller
    Inherits System.Configuration.Install.Installer

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub

    'Installer overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

#End Region

    Public Overrides Sub Install(ByVal stateSaver As System.Collections.IDictionary)

        MyBase.Install(stateSaver)

        Dim ConfigFullName As String

        Try
            Dim ServerAddress As String = Me.Context.Parameters.Item("ServerAddress")
            Dim Database As String = Me.Context.Parameters.Item("Database")
            Dim InstitutionName As String = Me.Context.Parameters.Item("InstitutionName")
            Dim InstitutionCode As String = Me.Context.Parameters.Item("InstitutionCode")
            Dim EmailFrom As String = Me.Context.Parameters.Item("EmailFrom")
            Dim SMTPEmail As String = Me.Context.Parameters.Item("SMTPEmail")

            Dim AssemblyPath As String = Me.Context.Parameters("assemblypath")
            Dim MainDirectory As String = AssemblyPath.Substring(0, AssemblyPath.LastIndexOf("\"))
            ConfigFullName = MainDirectory + "\MDA.exe.config"
            Dim XmlDocument As New System.Xml.XmlDocument
            XmlDocument.Load(ConfigFullName)

            ' Throw New InstallException(XmlDocument.OuterXml)
            ' Finds the right node and change it to the new value.
            Dim Node As System.Xml.XmlNode

            For Each Node In XmlDocument.Item("configuration").Item("sqlServerSettings")
                If Node.Name = "add" Then ' skip any comments
                    Select Case Node.Attributes.GetNamedItem("key").Value
                        Case "ServerAddress"
                            Node.Attributes.GetNamedItem("value").Value = ServerAddress
                        Case "Database"
                            Node.Attributes.GetNamedItem("value").Value = Database
                    End Select
                End If
            Next Node

            For Each Node In XmlDocument.Item("configuration").Item("InstitutionSettings")
                If Node.Name = "add" Then ' skip any comments
                    Select Case Node.Attributes.GetNamedItem("key").Value
                        Case "Institution.Code"
                            Node.Attributes.GetNamedItem("value").Value = InstitutionCode
                        Case "Institution.Name"
                            Node.Attributes.GetNamedItem("value").Value = InstitutionName
                    End Select
                End If
            Next Node

            For Each Node In XmlDocument.Item("configuration").Item("visualFieldsLabelSettings")
                If Node.Name = "add" Then ' skip any comments
                    Select Case Node.Attributes.GetNamedItem("key").Value
                        Case "RepositoryCode.DefaultValue"
                            Node.Attributes.GetNamedItem("value").Value = InstitutionCode
                        Case "Repository.DefaultValue"
                            Node.Attributes.GetNamedItem("value").Value = InstitutionName
                    End Select
                End If
            Next Node

            For Each Node In XmlDocument.Item("configuration").Item("EmailSettings")
                If Node.Name = "add" Then ' skip any comments
                    Select Case Node.Attributes.GetNamedItem("key").Value
                        Case "Email.From"
                            Node.Attributes.GetNamedItem("value").Value = EmailFrom
                        Case "SmtpMail.SmtpServer"
                            Node.Attributes.GetNamedItem("value").Value = SMTPEmail
                    End Select
                End If
            Next Node

            XmlDocument.Save(ConfigFullName)

        Catch ex As Exception
            Throw New InstallException(ConfigFullName)
        End Try
    End Sub


    'Private Sub DigitarqInstaller_BeforeInstall(ByVal sender As Object, ByVal e As System.Configuration.Install.InstallEventArgs) Handles MyBase.BeforeInstall
    '    callinifile()
    'End Sub

    'Private Sub CallINIFile()

    '    Dim sValue As String
    '    'Dim sPath As String
    '    Dim sPath As String = Me.Context.Parameters.Item("SourceDir") + "Setup.ini" 'Path.Combine(Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly.Location), "Setup.ini")

    '    'sPath = AppIniPath + "\\" + "temp.ini"

    '    'sPath = "<application name>.ini"

    '    INIWrite(sPath, "Section1", "Key1-1", "Value1-1") ' build INI file
    '    INIWrite(sPath, "Section1", "Key1-2", "Value1-2")
    '    INIWrite(sPath, "Section1", "Key1-3", "Value1-3")
    '    INIWrite(sPath, "Section2", "Key2-1", "Value2-1")
    '    INIWrite(sPath, "Section2", "Key2-2", "Value2-2")

    '    MessageBox.Show(sPath)

    '    sValue = INIRead(sPath, "section2", "key2-1", "Unknown") ' specify all
    '    MessageBox.Show(sValue, "section2/key2-1/unknown", MessageBoxButtons.OK)

    '    sValue = INIRead(sPath, "section2", "XYZ", "Unknown") ' specify all
    '    MessageBox.Show(sValue, "section2/xyz/unknown", MessageBoxButtons.OK)

    '    sValue = INIRead(sPath, "section2", "XYZ") ' use zero-length string as default
    '    MessageBox.Show(sValue, "section2/XYZ", MessageBoxButtons.OK)

    '    sValue = INIRead(sPath, "section1") ' get all keys in section
    '    sValue = sValue.Replace(ControlChars.NullChar, "|"c) ' change embedded NULLs to pipe chars
    '    MessageBox.Show(sValue, "section1 pre delete", MessageBoxButtons.OK)

    '    INIDelete(sPath, "section1", "key1-2") ' delete middle entry in section 1
    '    sValue = INIRead(sPath, "section1") ' get all keys in section again
    '    sValue = sValue.Replace(ControlChars.NullChar, "|"c) ' change embedded NULLs to pipe chars
    '    MessageBox.Show(sValue, "section1 post delete", MessageBoxButtons.OK)

    '    sValue = INIRead(sPath) ' get all section names
    '    sValue = sValue.Replace(ControlChars.NullChar, "|"c) ' change embedded NULLs to pipe chars
    '    MessageBox.Show(sValue, "All sections pre delete", MessageBoxButtons.OK)

    '    INIDelete(sPath, "section1") ' delete section
    '    sValue = INIRead(sPath) ' get all section names
    '    sValue = sValue.Replace(ControlChars.NullChar, "|"c) ' change embedded NULLs to pipe chars
    '    MessageBox.Show(sValue, "All sections post delete", MessageBoxButtons.OK)
    'End Sub

End Class
