
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient ' SQL Server Data Provider
Imports System.Configuration
Imports System.IO
Imports System.Xml.Xsl
Imports System.Xml
Imports System.Xml.XPath
Imports DigitArq.Utility
Imports DigitArq.Data.Entities.MDA
Imports DigitArq.Data.Entities.MGUP
Imports DigitArq.Core.Logging
Imports DigitArq.UserControls.ImageButton
Imports DigitArq.Definitions.MDA
Imports DigitArq.Definitions.EAD



Public Class FondsManagerForm
    Inherits System.Windows.Forms.Form

#Region "Private Properties"
    Private mySelectedFonds As LazyNode = Nothing
    Private mySelectedLazyNode As LazyNode = Nothing

    Private myProcessInfoName As String = "admin"
    Private myHideButtons As Boolean = False
    Private myProgramState As ProgramState


    Dim WithEvents mySearchForm As SearchForm = Nothing



    ReadOnly Property SelectedFonds() As LazyNode
        Get
            Return mySelectedFonds
        End Get
    End Property



    ReadOnly Property SelectedLazyNode() As LazyNode
        Get
            If mySelectedLazyNode Is Nothing Then
                Return mySelectedFonds
            Else
                Return mySelectedLazyNode
            End If
        End Get
    End Property

#End Region


#Region " Windows Form Designer generated code "

    Private Sub New(ByVal ProcessInfoName As String)
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        myProcessInfoName = ProcessInfoName
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents btnCloseFondsManagerForm As System.Windows.Forms.Button
    Friend WithEvents btnOpenFonds As System.Windows.Forms.Button
    Friend WithEvents btnNewFonds As System.Windows.Forms.Button
    Friend WithEvents ListView As System.Windows.Forms.ListView
    Friend WithEvents chUnitId As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitTitle As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitDateInitial As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitDateFinal As System.Windows.Forms.ColumnHeader
    Friend WithEvents chOtherLevel As System.Windows.Forms.ColumnHeader
    Friend WithEvents FondsIcon As System.Windows.Forms.ImageList
    Friend WithEvents chVisible As System.Windows.Forms.ColumnHeader
    Friend WithEvents btnRemoveFonds As System.Windows.Forms.Button
    Friend WithEvents MainMenuFonds As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItemReports As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemFondsGuide As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemInventory As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemUIInventory As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemCatalogue As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemUIList As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSeriesList As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImportExport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImportEAD As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExportEAD As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExportCALM As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImport As System.Windows.Forms.MenuItem
    Friend WithEvents txtFindFonds As System.Windows.Forms.TextBox
    Friend WithEvents lblSearch As System.Windows.Forms.Label
    Friend WithEvents MenuItemClassificationPlanReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemPhysLocReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemControlAccessReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAllControlAccess As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTools As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMustUpdateCompleteUnitId As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemInstalationUnitsBySeriesReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAuthorsList As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemElementCounter As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemCountElements As System.Windows.Forms.MenuItem
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItemImportCALM As System.Windows.Forms.MenuItem
    Friend WithEvents chSize As System.Windows.Forms.ColumnHeader
    'Friend WithEvents btnFindFonds As ImageButton
    Friend WithEvents SearchTimer As System.Windows.Forms.Timer
    Friend WithEvents MenuItemExportDIF As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImportDIF As System.Windows.Forms.MenuItem
    Friend WithEvents FolderBrowserDialog As System.Windows.Forms.FolderBrowserDialog
    Friend WithEvents btnSearch As DigitArq.UserControls.ImageButton.ImageButton
    Friend WithEvents MenuItemSearch As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(FondsManagerForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.btnSearch = New DigitArq.UserControls.ImageButton.ImageButton
        Me.lblSearch = New System.Windows.Forms.Label
        Me.txtFindFonds = New System.Windows.Forms.TextBox
        Me.btnRemoveFonds = New System.Windows.Forms.Button
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.btnCloseFondsManagerForm = New System.Windows.Forms.Button
        Me.btnOpenFonds = New System.Windows.Forms.Button
        Me.btnNewFonds = New System.Windows.Forms.Button
        Me.ListView = New System.Windows.Forms.ListView
        Me.chOtherLevel = New System.Windows.Forms.ColumnHeader
        Me.chUnitId = New System.Windows.Forms.ColumnHeader
        Me.chUnitTitle = New System.Windows.Forms.ColumnHeader
        Me.chUnitDateInitial = New System.Windows.Forms.ColumnHeader
        Me.chUnitDateFinal = New System.Windows.Forms.ColumnHeader
        Me.chVisible = New System.Windows.Forms.ColumnHeader
        Me.chSize = New System.Windows.Forms.ColumnHeader
        Me.FondsIcon = New System.Windows.Forms.ImageList(Me.components)
        Me.MainMenuFonds = New System.Windows.Forms.MainMenu
        Me.MenuItemImportExport = New System.Windows.Forms.MenuItem
        Me.MenuItemImport = New System.Windows.Forms.MenuItem
        Me.MenuItemImportEAD = New System.Windows.Forms.MenuItem
        Me.MenuItemImportCALM = New System.Windows.Forms.MenuItem
        Me.MenuItemImportDIF = New System.Windows.Forms.MenuItem
        Me.MenuItemExport = New System.Windows.Forms.MenuItem
        Me.MenuItemExportEAD = New System.Windows.Forms.MenuItem
        Me.MenuItemExportCALM = New System.Windows.Forms.MenuItem
        Me.MenuItemExportDIF = New System.Windows.Forms.MenuItem
        Me.MenuItemTools = New System.Windows.Forms.MenuItem
        Me.MenuItemMustUpdateCompleteUnitId = New System.Windows.Forms.MenuItem
        Me.MenuItemElementCounter = New System.Windows.Forms.MenuItem
        Me.MenuItemSearch = New System.Windows.Forms.MenuItem
        Me.MenuItemReports = New System.Windows.Forms.MenuItem
        Me.MenuItemFondsGuide = New System.Windows.Forms.MenuItem
        Me.MenuItemInventory = New System.Windows.Forms.MenuItem
        Me.MenuItemUIInventory = New System.Windows.Forms.MenuItem
        Me.MenuItemCatalogue = New System.Windows.Forms.MenuItem
        Me.MenuItemInstalationUnitsBySeriesReport = New System.Windows.Forms.MenuItem
        Me.MenuItemUIList = New System.Windows.Forms.MenuItem
        Me.MenuItemSeriesList = New System.Windows.Forms.MenuItem
        Me.MenuItemClassificationPlanReport = New System.Windows.Forms.MenuItem
        Me.MenuItemControlAccessReport = New System.Windows.Forms.MenuItem
        Me.MenuItemAllControlAccess = New System.Windows.Forms.MenuItem
        Me.MenuItemPhysLocReport = New System.Windows.Forms.MenuItem
        Me.MenuItemAuthorsList = New System.Windows.Forms.MenuItem
        Me.MenuItemCountElements = New System.Windows.Forms.MenuItem
        Me.SearchTimer = New System.Windows.Forms.Timer(Me.components)
        Me.FolderBrowserDialog = New System.Windows.Forms.FolderBrowserDialog
        Me.Panel2.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel2
        '
        Me.Panel2.Controls.Add(Me.btnSearch)
        Me.Panel2.Controls.Add(Me.lblSearch)
        Me.Panel2.Controls.Add(Me.txtFindFonds)
        Me.Panel2.Controls.Add(Me.btnRemoveFonds)
        Me.Panel2.Controls.Add(Me.btnCloseFondsManagerForm)
        Me.Panel2.Controls.Add(Me.btnOpenFonds)
        Me.Panel2.Controls.Add(Me.btnNewFonds)
        Me.Panel2.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Panel2.Location = New System.Drawing.Point(0, 255)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(762, 40)
        Me.Panel2.TabIndex = 4
        '
        'btnSearch
        '
        Me.btnSearch.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnSearch.BorderColor = System.Drawing.Color.Transparent
        Me.btnSearch.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnSearch.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnSearch.ButtonImage = CType(resources.GetObject("btnSearch.ButtonImage"), System.Drawing.Image)
        Me.btnSearch.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnSearch.ButtonShowShadow = True
        Me.btnSearch.ButtonText = ""
        Me.btnSearch.ButtonTextAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.btnSearch.ButtonTransparentColor = System.Drawing.Color.Transparent
        Me.btnSearch.HighlightBackgroundColor = System.Drawing.Color.Transparent
        Me.btnSearch.Location = New System.Drawing.Point(560, 10)
        Me.btnSearch.Name = "btnSearch"
        Me.btnSearch.Size = New System.Drawing.Size(18, 20)
        Me.btnSearch.TabIndex = 9
        Me.btnSearch.ToolTip = CType(configurationAppSettings.GetValue("btnSearch.ToolTip", GetType(System.String)), String)
        '
        'lblSearch
        '
        Me.lblSearch.Location = New System.Drawing.Point(184, 10)
        Me.lblSearch.Name = "lblSearch"
        Me.lblSearch.Size = New System.Drawing.Size(62, 20)
        Me.lblSearch.TabIndex = 8
        Me.lblSearch.Text = CType(configurationAppSettings.GetValue("FondsManager.lblSearch.Text", GetType(System.String)), String)
        Me.lblSearch.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtFindFonds
        '
        Me.txtFindFonds.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtFindFonds.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtFindFonds.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper
        Me.txtFindFonds.Location = New System.Drawing.Point(248, 10)
        Me.txtFindFonds.Name = "txtFindFonds"
        Me.txtFindFonds.Size = New System.Drawing.Size(296, 20)
        Me.txtFindFonds.TabIndex = 1
        Me.txtFindFonds.Text = ""
        '
        'btnRemoveFonds
        '
        Me.btnRemoveFonds.BackColor = System.Drawing.Color.White
        Me.btnRemoveFonds.Enabled = False
        Me.btnRemoveFonds.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnRemoveFonds.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnRemoveFonds.ImageIndex = 1
        Me.btnRemoveFonds.ImageList = Me.imglButtons
        Me.btnRemoveFonds.Location = New System.Drawing.Point(95, 8)
        Me.btnRemoveFonds.Name = "btnRemoveFonds"
        Me.btnRemoveFonds.Size = New System.Drawing.Size(80, 25)
        Me.btnRemoveFonds.TabIndex = 3
        Me.btnRemoveFonds.Text = CType(configurationAppSettings.GetValue("btnRemoveFonds.Text", GetType(System.String)), String)
        Me.btnRemoveFonds.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnCloseFondsManagerForm
        '
        Me.btnCloseFondsManagerForm.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnCloseFondsManagerForm.BackColor = System.Drawing.Color.White
        Me.btnCloseFondsManagerForm.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCloseFondsManagerForm.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnCloseFondsManagerForm.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCloseFondsManagerForm.ImageIndex = 5
        Me.btnCloseFondsManagerForm.ImageList = Me.imglButtons
        Me.btnCloseFondsManagerForm.Location = New System.Drawing.Point(680, 8)
        Me.btnCloseFondsManagerForm.Name = "btnCloseFondsManagerForm"
        Me.btnCloseFondsManagerForm.Size = New System.Drawing.Size(72, 25)
        Me.btnCloseFondsManagerForm.TabIndex = 5
        Me.btnCloseFondsManagerForm.Text = CType(configurationAppSettings.GetValue("btnCloseFondsManagerForm.Text", GetType(System.String)), String)
        Me.btnCloseFondsManagerForm.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnOpenFonds
        '
        Me.btnOpenFonds.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnOpenFonds.BackColor = System.Drawing.Color.White
        Me.btnOpenFonds.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.btnOpenFonds.Enabled = False
        Me.btnOpenFonds.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnOpenFonds.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOpenFonds.ImageIndex = 7
        Me.btnOpenFonds.ImageList = Me.imglButtons
        Me.btnOpenFonds.Location = New System.Drawing.Point(600, 8)
        Me.btnOpenFonds.Name = "btnOpenFonds"
        Me.btnOpenFonds.Size = New System.Drawing.Size(72, 25)
        Me.btnOpenFonds.TabIndex = 4
        Me.btnOpenFonds.Text = CType(configurationAppSettings.GetValue("btnOpenFonds.Text", GetType(System.String)), String)
        Me.btnOpenFonds.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnNewFonds
        '
        Me.btnNewFonds.BackColor = System.Drawing.Color.White
        Me.btnNewFonds.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnNewFonds.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnNewFonds.ImageIndex = 0
        Me.btnNewFonds.ImageList = Me.imglButtons
        Me.btnNewFonds.Location = New System.Drawing.Point(8, 8)
        Me.btnNewFonds.Name = "btnNewFonds"
        Me.btnNewFonds.Size = New System.Drawing.Size(80, 25)
        Me.btnNewFonds.TabIndex = 2
        Me.btnNewFonds.Text = CType(configurationAppSettings.GetValue("btnNewFonds.Text", GetType(System.String)), String)
        Me.btnNewFonds.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ListView
        '
        Me.ListView.Alignment = System.Windows.Forms.ListViewAlignment.Default
        Me.ListView.AllowColumnReorder = True
        Me.ListView.AutoArrange = False
        Me.ListView.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.ListView.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chOtherLevel, Me.chUnitId, Me.chUnitTitle, Me.chUnitDateInitial, Me.chUnitDateFinal, Me.chVisible, Me.chSize})
        Me.ListView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ListView.FullRowSelect = True
        Me.ListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.ListView.LabelWrap = False
        Me.ListView.Location = New System.Drawing.Point(0, 0)
        Me.ListView.Name = "ListView"
        Me.ListView.Size = New System.Drawing.Size(762, 255)
        Me.ListView.SmallImageList = Me.FondsIcon
        Me.ListView.Sorting = System.Windows.Forms.SortOrder.Ascending
        Me.ListView.TabIndex = 0
        Me.ListView.View = System.Windows.Forms.View.Details
        '
        'chOtherLevel
        '
        Me.chOtherLevel.Text = ""
        Me.chOtherLevel.Width = 20
        '
        'chUnitId
        '
        Me.chUnitId.Text = "Referncia"
        Me.chUnitId.Width = 127
        '
        'chUnitTitle
        '
        Me.chUnitTitle.Text = "Ttulo"
        Me.chUnitTitle.Width = 280
        '
        'chUnitDateInitial
        '
        Me.chUnitDateInitial.Text = "Data inicial"
        Me.chUnitDateInitial.Width = 87
        '
        'chUnitDateFinal
        '
        Me.chUnitDateFinal.Text = "Data final"
        Me.chUnitDateFinal.Width = 84
        '
        'chVisible
        '
        Me.chVisible.Text = "Visvel"
        Me.chVisible.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.chVisible.Width = 50
        '
        'chSize
        '
        Me.chSize.Text = CType(configurationAppSettings.GetValue("chSize.Text", GetType(System.String)), String)
        Me.chSize.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.chSize.Width = 76
        '
        'FondsIcon
        '
        Me.FondsIcon.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.FondsIcon.ImageSize = New System.Drawing.Size(16, 16)
        Me.FondsIcon.ImageStream = CType(resources.GetObject("FondsIcon.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.FondsIcon.TransparentColor = System.Drawing.Color.White
        '
        'MainMenuFonds
        '
        Me.MainMenuFonds.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemImportExport, Me.MenuItemTools, Me.MenuItemReports})
        '
        'MenuItemImportExport
        '
        Me.MenuItemImportExport.Index = 0
        Me.MenuItemImportExport.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemImport, Me.MenuItemExport})
        Me.MenuItemImportExport.Text = CType(configurationAppSettings.GetValue("MenuItemImportExport.Text", GetType(System.String)), String)
        '
        'MenuItemImport
        '
        Me.MenuItemImport.Index = 0
        Me.MenuItemImport.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemImportEAD, Me.MenuItemImportCALM, Me.MenuItemImportDIF})
        Me.MenuItemImport.Text = CType(configurationAppSettings.GetValue("MenuItemImport.Text", GetType(System.String)), String)
        '
        'MenuItemImportEAD
        '
        Me.MenuItemImportEAD.Index = 0
        Me.MenuItemImportEAD.Text = CType(configurationAppSettings.GetValue("MenuItemImportEAD.Text", GetType(System.String)), String)
        '
        'MenuItemImportCALM
        '
        Me.MenuItemImportCALM.Index = 1
        Me.MenuItemImportCALM.Text = CType(configurationAppSettings.GetValue("MenuItemImportCALM.Text", GetType(System.String)), String)
        '
        'MenuItemImportDIF
        '
        Me.MenuItemImportDIF.Index = 2
        Me.MenuItemImportDIF.Text = CType(configurationAppSettings.GetValue("MenuItemImportDIF.Text", GetType(System.String)), String)
        '
        'MenuItemExport
        '
        Me.MenuItemExport.Enabled = False
        Me.MenuItemExport.Index = 1
        Me.MenuItemExport.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemExportEAD, Me.MenuItemExportCALM, Me.MenuItemExportDIF})
        Me.MenuItemExport.Text = CType(configurationAppSettings.GetValue("MenuItemExport.Text", GetType(System.String)), String)
        '
        'MenuItemExportEAD
        '
        Me.MenuItemExportEAD.Index = 0
        Me.MenuItemExportEAD.Text = CType(configurationAppSettings.GetValue("MenuItemExportEAD.Text", GetType(System.String)), String)
        '
        'MenuItemExportCALM
        '
        Me.MenuItemExportCALM.Index = 1
        Me.MenuItemExportCALM.Text = CType(configurationAppSettings.GetValue("MenuItemExportCALM.Text", GetType(System.String)), String)
        '
        'MenuItemExportDIF
        '
        Me.MenuItemExportDIF.Index = 2
        Me.MenuItemExportDIF.Text = CType(configurationAppSettings.GetValue("MenuItemExportDIF.Text", GetType(System.String)), String)
        '
        'MenuItemTools
        '
        Me.MenuItemTools.Index = 1
        Me.MenuItemTools.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemMustUpdateCompleteUnitId, Me.MenuItemElementCounter, Me.MenuItemSearch})
        Me.MenuItemTools.Text = CType(configurationAppSettings.GetValue("FondsManagerMenuItemTools.Text", GetType(System.String)), String)
        '
        'MenuItemMustUpdateCompleteUnitId
        '
        Me.MenuItemMustUpdateCompleteUnitId.Index = 0
        Me.MenuItemMustUpdateCompleteUnitId.Text = CType(configurationAppSettings.GetValue("MenuItemMustUpdateCompleteUnitId.Text", GetType(System.String)), String)
        '
        'MenuItemElementCounter
        '
        Me.MenuItemElementCounter.Index = 1
        Me.MenuItemElementCounter.Text = CType(configurationAppSettings.GetValue("MenuItemElementCounter.Text", GetType(System.String)), String)
        '
        'MenuItemSearch
        '
        Me.MenuItemSearch.Index = 2
        Me.MenuItemSearch.Text = CType(configurationAppSettings.GetValue("MenuItemSearch.Text", GetType(System.String)), String)
        '
        'MenuItemReports
        '
        Me.MenuItemReports.Enabled = False
        Me.MenuItemReports.Index = 2
        Me.MenuItemReports.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemFondsGuide, Me.MenuItemInventory, Me.MenuItemUIInventory, Me.MenuItemCatalogue, Me.MenuItemInstalationUnitsBySeriesReport, Me.MenuItemUIList, Me.MenuItemSeriesList, Me.MenuItemClassificationPlanReport, Me.MenuItemControlAccessReport, Me.MenuItemAllControlAccess, Me.MenuItemPhysLocReport, Me.MenuItemAuthorsList, Me.MenuItemCountElements})
        Me.MenuItemReports.Text = CType(configurationAppSettings.GetValue("MenuItemReports.Text", GetType(System.String)), String)
        '
        'MenuItemFondsGuide
        '
        Me.MenuItemFondsGuide.Index = 0
        Me.MenuItemFondsGuide.Text = CType(configurationAppSettings.GetValue("MenuItemFondsGuide.Text", GetType(System.String)), String)
        '
        'MenuItemInventory
        '
        Me.MenuItemInventory.Index = 1
        Me.MenuItemInventory.Text = CType(configurationAppSettings.GetValue("MenuItemInventory.Text", GetType(System.String)), String)
        '
        'MenuItemUIInventory
        '
        Me.MenuItemUIInventory.Index = 2
        Me.MenuItemUIInventory.Text = CType(configurationAppSettings.GetValue("MenuItemUIInventory.Text", GetType(System.String)), String)
        '
        'MenuItemCatalogue
        '
        Me.MenuItemCatalogue.Index = 3
        Me.MenuItemCatalogue.Text = CType(configurationAppSettings.GetValue("MenuItemCatalogue.Text", GetType(System.String)), String)
        '
        'MenuItemInstalationUnitsBySeriesReport
        '
        Me.MenuItemInstalationUnitsBySeriesReport.Index = 4
        Me.MenuItemInstalationUnitsBySeriesReport.Text = CType(configurationAppSettings.GetValue("MenuItemInstalationUnitsBySeriesReport.Text", GetType(System.String)), String)
        '
        'MenuItemUIList
        '
        Me.MenuItemUIList.Index = 5
        Me.MenuItemUIList.Text = CType(configurationAppSettings.GetValue("MenuItemUIList.Text", GetType(System.String)), String)
        '
        'MenuItemSeriesList
        '
        Me.MenuItemSeriesList.Index = 6
        Me.MenuItemSeriesList.Text = CType(configurationAppSettings.GetValue("MenuItemSeriesList.Text", GetType(System.String)), String)
        '
        'MenuItemClassificationPlanReport
        '
        Me.MenuItemClassificationPlanReport.Index = 7
        Me.MenuItemClassificationPlanReport.Text = CType(configurationAppSettings.GetValue("MenuItemClassificationPlanReport.Text", GetType(System.String)), String)
        '
        'MenuItemControlAccessReport
        '
        Me.MenuItemControlAccessReport.Index = 8
        Me.MenuItemControlAccessReport.Text = CType(configurationAppSettings.GetValue("MenuItemControlAccessReport.Text", GetType(System.String)), String)
        '
        'MenuItemAllControlAccess
        '
        Me.MenuItemAllControlAccess.Index = 9
        Me.MenuItemAllControlAccess.Text = CType(configurationAppSettings.GetValue("MenuItemAllControlAccess.Text", GetType(System.String)), String)
        '
        'MenuItemPhysLocReport
        '
        Me.MenuItemPhysLocReport.Index = 10
        Me.MenuItemPhysLocReport.Text = CType(configurationAppSettings.GetValue("MenuItemPhysLocReport.Text", GetType(System.String)), String)
        '
        'MenuItemAuthorsList
        '
        Me.MenuItemAuthorsList.Index = 11
        Me.MenuItemAuthorsList.Text = CType(configurationAppSettings.GetValue("MenuItemAuthorsList.Text", GetType(System.String)), String)
        '
        'MenuItemCountElements
        '
        Me.MenuItemCountElements.Index = 12
        Me.MenuItemCountElements.Text = "N total de registos..."
        '
        'SearchTimer
        '
        Me.SearchTimer.Interval = 2000
        '
        'FolderBrowserDialog
        '
        Me.FolderBrowserDialog.Description = "Seleccione a pasta onde pretende gravar os ficheiros..."
        '
        'FondsManagerForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(762, 295)
        Me.Controls.Add(Me.ListView)
        Me.Controls.Add(Me.Panel2)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Menu = Me.MainMenuFonds
        Me.MinimumSize = New System.Drawing.Size(752, 200)
        Me.Name = "FondsManagerForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = CType(configurationAppSettings.GetValue("FondsManagerForm.Text", GetType(System.String)), String)
        Me.Panel2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Public Sub New(ByVal ProcessInfoName As String, ByVal HideButtons As Boolean, ByRef ProgramState As ProgramState)
        Me.New(ProcessInfoName)
        myHideButtons = HideButtons
        myProgramState = ProgramState
        If HideButtons Then
            btnNewFonds.Visible = False
            btnRemoveFonds.Visible = False
            MenuItemReports.Visible = False
            MenuItemImportExport.Visible = False
            MenuItemTools.Visible = False
        End If
    End Sub


    Private Sub FondsManagerForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim UserProfile As String = (New SQLDataBase).getProfile(myProcessInfoName, ConfigurationSettings.AppSettings("Application.Code")).Profile
        Dim AdminProfile As String = ConfigurationSettings.AppSettings("Profile.Administrator")
        Dim RevisorProfile As String = ConfigurationSettings.AppSettings("Profile.Revisor")

        btnRemoveFonds.Visible = (UserProfile = AdminProfile OrElse UserProfile = RevisorProfile) And Not myHideButtons
        Me.MenuItemImport.Visible = (UserProfile = AdminProfile OrElse UserProfile = RevisorProfile)
        Me.MenuItemTools.Visible = (UserProfile = AdminProfile OrElse UserProfile = RevisorProfile)
        Me.MenuItemReports.Visible = GetApplicationType() <> ApplicationType.MiniDigitArq
        If Not myProgramState Is Nothing AndAlso myProgramState.LastFondsSearched.Length > 0 Then
            Me.txtFindFonds.Text = myProgramState.LastFondsSearched
        Else
            'LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
            LoadFondsList()
        End If
    End Sub


#Region "Auxiliary Functions "

    Private Sub LoadFondsList()
        txtFindFonds.Text = ""
        LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
    End Sub


    Private Sub LoadFondsList(ByVal FondsFilter As String)
        Dim Item As FondsListItem

        Cursor.Current = Cursors.WaitCursor
        ListView.Items.Clear()

        Try
            Dim LanguageSettings As Hashtable = ConfigurationSettings.GetConfig("langSettings")
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

            Dim RepositoryCode As String = Nothing

            Dim UserProfile As String = (New SQLDataBase).getProfile(myProcessInfoName, ConfigurationSettings.AppSettings("Application.Code")).Profile
            Dim AdminProfile As String = ConfigurationSettings.AppSettings("Profile.Administrator")

            If UserProfile <> AdminProfile Then
                RepositoryCode = VisualFieldLabel("RepositoryCode.DefaultValue")
            End If

            Dim FondsList As FondsListCollection = SQLLazyNode.GetFondsList( _
                                                        SQLServerSettings.Item("ServerAddress"), _
                                                        SQLServerSettings.Item("Database"), _
                                                        SQLServerSettings.Item("Username"), _
                                                        SQLServerSettings.Item("Password"), _
                                                        FondsFilter, RepositoryCode _
                                                    )
            For Each Item In FondsList
                Dim Row As New ListViewItem("", 0)
                Row.UseItemStyleForSubItems = False
                Dim Icon As New ListViewItem.ListViewSubItem(Row, "")
                Dim UnitId As New ListViewItem.ListViewSubItem(Row, Item.UnitId)
                Dim UnitTitle As New ListViewItem.ListViewSubItem(Row, Item.UnitTitle)
                Dim UnitDateInitial As New ListViewItem.ListViewSubItem(Row, Item.UnitDateInitial)
                Dim UnitDateFinal As New ListViewItem.ListViewSubItem(Row, Item.UnitDateFinal)
                Dim FondsSize As New ListViewItem.ListViewSubItem(Row, Item.Size)
                Dim ID As New ListViewItem.ListViewSubItem(Row, IntToStr(Item.ID))

                Dim Visible As New ListViewItem.ListViewSubItem

                If Item.Visible Then
                    Visible.ForeColor = Color.Green
                    Visible.Text = LanguageSettings.Item("yes")
                Else
                    Visible.ForeColor = Color.Red
                    Visible.Text = LanguageSettings.Item("no")
                End If


                Row.SubItems.Add(UnitId)
                Row.SubItems.Add(UnitTitle)
                Row.SubItems.Add(UnitDateInitial)
                Row.SubItems.Add(UnitDateFinal)
                Row.SubItems.Add(Visible)
                Row.SubItems.Add(FondsSize)

                Row.SubItems.Add(ID)
                ListView.Items.Add(Row)
            Next
            Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
            Dim Title As String = CType(configurationAppSettings.GetValue("FondsManagerForm.Text", GetType(System.String)), String)
            Me.Text = String.Format("{0} [{1}]", Title, ListView.Items.Count)
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        End Try
        Cursor.Current = Cursors.Default
    End Sub




    Private Sub ListView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView.SelectedIndexChanged
        Me.btnOpenFonds.Enabled = (ListView.SelectedItems.Count = 1)
        Me.btnRemoveFonds.Enabled = (ListView.SelectedItems.Count > 0)
        Me.MenuItemExport.Enabled = (ListView.SelectedItems.Count > 0)
        Me.MenuItemReports.Enabled = (ListView.SelectedItems.Count > 0)
        Me.MenuItemTools.Enabled = (ListView.SelectedItems.Count > 0)
    End Sub

#End Region


#Region "Button Event Handlers"


    Private Sub Search()
        If txtFindFonds.Text.Length = 0 Then
            LoadFondsList()
        Else
            LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
        End If
    End Sub



    'Private Sub btnFindFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFindFonds.Click
    '    Dim Item As ListViewItem
    '    Dim ItemToSelect As ListViewItem = Nothing
    '    For Each Item In ListView.Items
    '        If Item.SubItems(1).Text.ToUpper.IndexOf(txtFindFonds.Text.ToUpper) >= 0 Then
    '            ItemToSelect = Item
    '            Exit For
    '        End If
    '    Next

    '    If Not ItemToSelect Is Nothing Then
    '        ListView.Focus()
    '        ListView.MultiSelect = False
    '        ItemToSelect.Selected = True
    '        ItemToSelect.Focused = True
    '        ItemToSelect.EnsureVisible()
    '        ListView.MultiSelect = True

    '        If Not myProgramState Is Nothing Then myProgramState.LastFondsSearched = txtFindFonds.Text
    '    End If

    'End Sub

    'Private Sub txtFindFonds_KeyPress(ByVal sender As System.Object, ByVal e As KeyEventArgs) Handles txtFindFonds.KeyDown
    '    If e.KeyCode <> Keys.Enter Then Exit Sub
    '    btnFindFonds_Click(Me, e)
    'End Sub

    Private Sub btnNewFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewFonds.Click
        Dim ApplicationType As ApplicationType = GetApplicationType()
        Select Case ApplicationType
            Case ApplicationType.Client
                CreateNewFonds()
            Case ApplicationType.Standalone
                CreateNewFonds()
            Case ApplicationType.MiniDigitArq
                CreateNewFondsByTemplate()
        End Select
    End Sub

    Private Sub CreateNewFonds()
        Dim frmNewFonds As New NewFondsForm

        If frmNewFonds.ShowDialog() = DialogResult.OK Then
            Try
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")


                Dim NewFondsReference As String = frmNewFonds.GetCompleteUnitID()
                Dim FondsExist As Boolean = SQLLazyNode.GetFondsList(SQLServerSettings.Item("ServerAddress"), _
                                                            SQLServerSettings.Item("Database"), _
                                                            SQLServerSettings.Item("Username"), _
                                                            SQLServerSettings.Item("Password"), _
                                                            NewFondsReference).Count > 0


                If (Not FondsExist) OrElse _
                   (FondsExist AndAlso _
                        MsgBox(ErrorMessage("NewFonds.FondsAlreadyExists"), MsgBoxStyle.YesNo + MsgBoxStyle.Question, _
                        ErrorMessage("NewFonds.FondsAlreadyExistsTitle")) = MsgBoxResult.Yes) Then


                    Dim Node As LazyNode = SQLLazyNode.CreateNewFonds( _
                                                                SQLServerSettings.Item("ServerAddress"), _
                                                                SQLServerSettings.Item("Database"), _
                                                                SQLServerSettings.Item("Username"), _
                                                                SQLServerSettings.Item("Password"), _
                                                                frmNewFonds.GetUnitId(), _
                                                                frmNewFonds.GetUnitTitle(), _
                                                                myProcessInfoName, _
                                                                frmNewFonds.GetCountryCode, _
                                                                frmNewFonds.GetRepositoryCode, _
                                                                frmNewFonds.GetRepository())

                    LoadFondsList()
                End If
            Catch ex As SqlException
                MessageBoxes.MsgBoxSqlException(ex)
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)

            End Try
        End If
    End Sub

    Private Sub CreateNewFondsByTemplate()
        Dim frmNewFonds As New NewFondsForm

        Dim Filename As String = FONDSTEMPLATE_FILENAME
        If Not File.Exists(Filename) Then Exit Sub

        Cursor.Current = Cursors.WaitCursor

        Dim SourceFonds As LazyNode = New EADLazyNode(Filename)

        Try
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
            Dim Node As LazyNode = SQLLazyNode.CreateNewFonds( _
                                                        SQLServerSettings.Item("ServerAddress"), _
                                                        SQLServerSettings.Item("Database"), _
                                                        SQLServerSettings.Item("Username"), _
                                                        SQLServerSettings.Item("Password"), _
                                                        SourceFonds.UnitId, _
                                                        SourceFonds.UnitTitle, _
                                                        myProcessInfoName _
                                                    )

            Dim DestinationFonds As LazyNode = Node
            Dim Importer As New Importer(DestinationFonds, SourceFonds)
            Importer.Import()

            ' Calls iterator to calculate complete unit ids
            Dim iterator As New iterator(DestinationFonds)
            iterator.Start(iterator.Action.UpdateCompleteUnitId)

            LoadFondsList()
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        End Try
    End Sub

    Private Sub btnOpenFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenFonds.Click
        If ListView.SelectedItems.Count <> 1 Then Exit Sub
        Dim ID As Integer = StrToInt(ListView.SelectedItems(0).SubItems(7).Text)

        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
        Try
            Dim RootNode As LazyNode = New SQLLazyNode(SQLServerSettings.Item("ServerAddress"), _
                                                       SQLServerSettings.Item("Database"), _
                                                       SQLServerSettings.Item("Username"), _
                                                       SQLServerSettings.Item("Password"), _
                                                       ID)

            mySelectedFonds = RootNode
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
            mySelectedFonds = Nothing
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
            mySelectedFonds = Nothing
        End Try
        myProgramState.LastFondsSearched = txtFindFonds.Text
        myProgramState.Save()
        DialogResult = DialogResult.OK
        'Debug.WriteLine(RootNode.Catamorphism(New GeneNodeCounter))
    End Sub

    Private Sub ListView_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView.DoubleClick
        btnOpenFonds_Click(Me, e)
    End Sub

    Private Sub btnRemoveFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveFonds.Click
        If ListView.SelectedItems.Count = 0 Then Exit Sub


        If MessageBox.Show(InfoMessage("RemoveSelectedFonds.Confirm"), _
                InfoMessage("RemoveFonds.ConfirmTitle"), MessageBoxButtons.YesNo, _
                MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.No Then
            Exit Sub
        End If

        Dim Row As ListViewItem
        For Each Row In ListView.SelectedItems
            Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
            Dim UnitID As String = Row.SubItems(1).Text
            Dim UnitTitle As String = Row.SubItems(2).Text


            ' confimar para cada fundo
            If MessageBox.Show(String.Format(InfoMessage("RemoveFonds.Confirm"), UnitID, UnitTitle), InfoMessage("RemoveFonds.ConfirmTitle"), MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.Yes Then
                Cursor.Current = Cursors.WaitCursor
                Me.Enabled = False
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                Try
                    SQLLazyNode.RemoveFonds(SQLServerSettings.Item("ServerAddress"), _
                                            SQLServerSettings.Item("Database"), _
                                            SQLServerSettings.Item("Username"), _
                                            SQLServerSettings.Item("Password"), _
                                            ID)
                    Logger.Append(myProcessInfoName, Logger.LogActions.RemoveFonds, String.Format(LogMessage("Log.RemoveFonds"), UnitID))
                Catch ex As Exception
                    MessageBoxes.MsgBoxException(ex)
                End Try
                Me.Enabled = True
            End If
        Next

        LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))

        ListView_SelectedIndexChanged(sender, Nothing) ' disable buttons if necessary
        Cursor.Current = Cursors.Default
    End Sub
#End Region


#Region "Menu Event Handlers"


    Private Sub MenuItemImportDIF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemImportDIF.Click
        Dim OpenFileDialog As New OpenFileDialog
        OpenFileDialog.Multiselect = True
        OpenFileDialog.Filter = "DigitArq Interoperability Format (*.dif)|*.dif"
        OpenFileDialog.Title = InfoMessage("OpenFileDialog.Title.ExternalEAD")


        Try
            Dim Result As DialogResult = MsgBox(InfoMessage("ImportExport.DIFWarning"), MsgBoxStyle.Question + MsgBoxStyle.YesNo)
            If Result = DialogResult.No Then Exit Sub

            If OpenFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

                For Each Filename In OpenFileDialog.FileNames
                    Dim Importer As New Importer(SQLServerSettings.Item("ServerAddress"), _
                                                 SQLServerSettings.Item("Database"), _
                                                 SQLServerSettings.Item("Username"), _
                                                 SQLServerSettings.Item("Password"), _
                                                 Filename, _
                                                 myProcessInfoName)


                    Me.Enabled = False
                    Importer.Import(Importer.ImportType.DigitArqIntoroperabilityFormat)
                    Me.Enabled = True
                Next
                LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            If ex.Message = "Too many files selected. Please select fewer files and try again." Then
                MsgBox(ErrorMessage("OpenFileDialog.TooManyFilesSelected"), MsgBoxStyle.Exclamation)
            Else
                MessageBoxes.MsgBoxException(ex)
            End If
        End Try
    End Sub


    Private Sub MenuItemImportCALM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemImportCALM.Click
        Dim OpenFileDialog As New OpenFileDialog
        OpenFileDialog.Multiselect = True
        'OpenFileDialog.InitialDirectory() = Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        OpenFileDialog.Filter = "EAD files (*.ead)|*.ead"
        OpenFileDialog.Title = InfoMessage("OpenFileDialog.Title.ExternalEAD")


        Try
            If OpenFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

                For Each Filename In OpenFileDialog.FileNames
                    Dim Importer As New Importer(SQLServerSettings.Item("ServerAddress"), _
                                                 SQLServerSettings.Item("Database"), _
                                                 SQLServerSettings.Item("Username"), _
                                                 SQLServerSettings.Item("Password"), Filename, _
                                                 myProcessInfoName)


                    Me.Enabled = False
                    Importer.Import(Importer.ImportType.CALMRecords)
                    Me.Enabled = True
                Next
                LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception

            If ex.Message = "Too many files selected. Please select fewer files and try again." Then
                MsgBox(ErrorMessage("OpenFileDialog.TooManyFilesSelected"), MsgBoxStyle.Exclamation)
            Else
                MessageBoxes.MsgBoxException(ex)
            End If
        End Try
    End Sub


    Private Sub MenuItemImportEAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemImportEAD.Click
        Dim OpenFileDialog As New OpenFileDialog
        OpenFileDialog.Multiselect = True
        'OpenFileDialog.InitialDirectory() = Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        OpenFileDialog.Filter = "EAD files (*.ead)|*.ead"
        OpenFileDialog.Title = InfoMessage("OpenFileDialog.Title.DIF")

        Try
            If OpenFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

                For Each Filename In OpenFileDialog.FileNames
                    Dim Importer As New Importer(SQLServerSettings.Item("ServerAddress"), _
                                                 SQLServerSettings.Item("Database"), _
                                                 SQLServerSettings.Item("Username"), _
                                                 SQLServerSettings.Item("Password"), _
                                                 Filename, _
                                                 myProcessInfoName)
                    Me.Enabled = False
                    Importer.Import(Importer.ImportType.ExternalEAD)
                    Me.Enabled = True
                    LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
                Next
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            If ex.Message = "" Then
                MsgBox(ErrorMessage("OpenFileDialog.TooManyFilesSelected"), MsgBoxStyle.Exclamation)
            Else
                MessageBoxes.MsgBoxException(ex)
            End If
        End Try
    End Sub

    Private Sub MenuItemExportEAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportEAD.Click
        Try
            Dim OnlyExportVisibles As Boolean = MsgBox(InfoMessage("SaveFileDialog.EAD.Question"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question, InfoMessage("SaveFileDialog.Title.EAD")) = MsgBoxResult.Yes

            If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
                Dim SelectedPath As String = Me.FolderBrowserDialog.SelectedPath
                Dim Row As ListViewItem
                For Each Row In ListView.SelectedItems
                    Dim FileName As String = Row.SubItems(1).Text.Replace("/", "-")
                    Dim OutputFilename As String = SelectedPath & Path.DirectorySeparatorChar & FileName & ".ead"

                    Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                    Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
                    Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
                                                 SQLServerSettings.Item("Database"), _
                                                 SQLServerSettings.Item("Username"), _
                                                 SQLServerSettings.Item("Password"), OutputFilename, _
                                                 ID, OnlyExportVisibles)
                    Me.Enabled = False
                    Exporter.Export()
                Next
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try
    End Sub

    'Private Sub MenuItemExportEAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportEAD.Click
    '    Dim SaveFileDialog As New SaveFileDialog
    '    SaveFileDialog.Filter = "EAD files (*.ead)|*.ead"
    '    SaveFileDialog.Title = InfoMessage("SaveFileDialog.Title.EAD")


    '    Try
    '        Dim Row As ListViewItem
    '        For Each Row In ListView.SelectedItems
    '            SaveFileDialog.FileName = Row.SubItems(1).Text.Replace("/", "-")
    '            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
    '                Dim Filename As String = SaveFileDialog.FileName
    '                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
    '                Dim ID As Integer = StrToInt(Row.SubItems(6).Text)
    '                Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
    '                                             SQLServerSettings.Item("Database"), _
    '                                             SQLServerSettings.Item("Username"), _
    '                                             SQLServerSettings.Item("Password"), Filename, _
    '                                             ID)
    '                Me.Enabled = False
    '                Exporter.Export()
    '            End If
    '        Next
    '    Catch ex As SqlException
    '        MessageBoxes.MsgBoxSqlException(ex)
    '    Catch ex As Exception
    '        MessageBoxes.MsgBoxException(ex)
    '    Finally
    '        Me.Enabled = True
    '    End Try
    'End Sub

    Private Sub MenuItemMustUpdateCompleteUnitId_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMustUpdateCompleteUnitId.Click
        Dim Row As ListViewItem
        For Each Row In ListView.SelectedItems
            Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
            Try
                Dim RootNode As LazyNode = New SQLLazyNode(SQLServerSettings.Item("ServerAddress"), _
                                                           SQLServerSettings.Item("Database"), _
                                                           SQLServerSettings.Item("Username"), _
                                                           SQLServerSettings.Item("Password"), _
                                                           ID)
                Dim iterator As New iterator(RootNode)
                Me.Enabled = False
                iterator.Start(iterator.Action.UpdateCompleteUnitId)
            Catch ex As SqlException
                MessageBoxes.MsgBoxSqlException(ex)
                mySelectedFonds = Nothing
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)
                mySelectedFonds = Nothing
            End Try
            Me.Enabled = True
        Next
        LoadFondsList(String.Format("%{0}%", txtFindFonds.Text))
    End Sub

    Private Function GetSelectedLazyNodes()
        Dim Row As ListViewItem
        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
        Dim LazyNodes As New LazyNodeCollection
        For Each Row In ListView.SelectedItems
            Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
            Try
                Dim SQLLazyNode As LazyNode = New SQLLazyNode(SQLServerSettings.Item("ServerAddress"), SQLServerSettings.Item("Database"), _
                                                              SQLServerSettings.Item("Username"), SQLServerSettings.Item("Password"), ID)
                LazyNodes.Add(SQLLazyNode)
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)
            End Try
        Next
        Return LazyNodes
    End Function

    Private Sub MenuItemExportCALM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportCALM.Click
        Try
            Dim SelectedPath As String = Me.FolderBrowserDialog.SelectedPath
            If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
                Dim Row As ListViewItem
                For Each Row In ListView.SelectedItems
                    Dim FileName As String = Row.SubItems(1).Text.Replace("/", "-")
                    Dim EADFilename As String = SelectedPath & Path.DirectorySeparatorChar & FileName & ".ead"

                    Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                    Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
                    Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
                                                     SQLServerSettings.Item("Database"), _
                                                     SQLServerSettings.Item("Username"), _
                                                     SQLServerSettings.Item("Password"), EADFilename, _
                                                     ID)
                    Me.Enabled = False
                    Exporter.Export()

                    Dim xslt As XslTransform = New XslTransform
                    xslt.Load(EAD2CNF_XSLT_FILENAME)

                    Dim resolver As XmlUrlResolver = New XmlUrlResolver
                    resolver.Credentials = System.Net.CredentialCache.DefaultCredentials
                    xslt.Transform(EADFilename, FileName & ".txt", resolver)
                    xslt = Nothing
                    File.Delete(EADFilename)
                Next
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try
    End Sub

    'Private Sub MenuItemExportCALM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportCALM.Click
    '    Dim SaveFileDialog As New SaveFileDialog
    '    SaveFileDialog.Filter = "CALM Natural Format (*.txt)|*.txt"
    '    SaveFileDialog.Title = InfoMessage("SaveFileDialog.Title.CALM")


    '    Try
    '        Dim Row As ListViewItem
    '        For Each Row In ListView.SelectedItems
    '            SaveFileDialog.FileName = Row.SubItems(1).Text.Replace("/", "-")
    '            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
    '                Dim Filename As String = SaveFileDialog.FileName
    '                Dim EADFilename As String = Path.GetFileNameWithoutExtension(Filename) & ".ead"
    '                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
    '                Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
    '                Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
    '                                             SQLServerSettings.Item("Database"), _
    '                                             SQLServerSettings.Item("Username"), _
    '                                             SQLServerSettings.Item("Password"), EADFilename, _
    '                                             ID)
    '                Me.Enabled = False
    '                Exporter.Export()

    '                Dim xslt As XslTransform = New XslTransform
    '                xslt.Load(EAD2CNF_XSLT_FILENAME)

    '                Dim resolver As XmlUrlResolver = New XmlUrlResolver
    '                resolver.Credentials = System.Net.CredentialCache.DefaultCredentials
    '                xslt.Transform(EADFilename, Filename, resolver)
    '                xslt = Nothing
    '            End If
    '        Next
    '    Catch ex As SqlException
    '        MessageBoxes.MsgBoxSqlException(ex)
    '    Catch ex As Exception
    '        MessageBoxes.MsgBoxException(ex)
    '    Finally
    '        Me.Enabled = True
    '    End Try
    'End Sub


    Private Sub MenuItemExportDIF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportDIF.Click
        Try
            Dim Result As DialogResult = MsgBox(InfoMessage("ImportExport.DIFWarning"), MsgBoxStyle.Question + MsgBoxStyle.YesNo)
            If Result = DialogResult.No Then Exit Sub

            If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
                Dim Row As ListViewItem
                Dim SelectedPath As String = Me.FolderBrowserDialog.SelectedPath
                For Each Row In ListView.SelectedItems
                    Dim FileName As String = Row.SubItems(1).Text.Replace("/", "-")
                    Dim OutputFilename As String = SelectedPath & Path.DirectorySeparatorChar & FileName & ".dif"
                    Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                    Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
                    Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
                                                 SQLServerSettings.Item("Database"), _
                                                 SQLServerSettings.Item("Username"), _
                                                 SQLServerSettings.Item("Password"), _
                                                 OutputFilename, _
                                                 ID)
                    Me.Enabled = False
                    Exporter.ExportDIF()
                Next
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try
    End Sub

    'Private Sub MenuItemExportDIF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportDIF.Click
    '    Dim SaveFileDialog As New SaveFileDialog
    '    SaveFileDialog.Filter = "DigitArq Interoperability Format (*.dif)|*.dif"
    '    SaveFileDialog.Title = InfoMessage("SaveFileDialog.Title.DigitArq")

    '    Try
    '        Dim Row As ListViewItem
    '        For Each Row In ListView.SelectedItems
    '            SaveFileDialog.FileName = Row.SubItems(1).Text.Replace("/", "-")
    '            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
    '                Dim Filename As String = SaveFileDialog.FileName
    '                Dim OutputFilename As String = Path.GetFileNameWithoutExtension(Filename) & ".dif"
    '                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
    '                Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
    '                Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
    '                                             SQLServerSettings.Item("Database"), _
    '                                             SQLServerSettings.Item("Username"), _
    '                                             SQLServerSettings.Item("Password"), _
    '                                             OutputFilename, _
    '                                             ID)
    '                Me.Enabled = False
    '                Exporter.ExportDIF()
    '            End If
    '        Next
    '    Catch ex As SqlException
    '        MessageBoxes.MsgBoxSqlException(ex)
    '    Catch ex As Exception
    '        MessageBoxes.MsgBoxException(ex)
    '    Finally
    '        Me.Enabled = True
    '    End Try
    'End Sub

#End Region


#Region "Reporting Stuff"

    Private Sub MenuItemFondsGuide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemFondsGuide.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As FondsGuideDataSet = ReportDataSetBuilder.GenerateFondsGuideReportData(SelectedLazyNodes)

        Dim Report As New FondsGuideReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemInventory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemInventory.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As InventoryDataSet = ReportDataSetBuilder.GenerateInventoryReportData(SelectedLazyNodes)

        Dim Report As New InventoryReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemUIInventory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemUIInventory.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As CatalogDataSet = ReportDataSetBuilder.GenerateIUInventoryReportData(SelectedLazyNodes)

        Dim Report As New IUInventoryReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub



    Private Sub MenuItemCatalogue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemCatalogue.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As CatalogDataSet = ReportDataSetBuilder.GenerateCatalogReportData(SelectedLazyNodes)

        Dim Report As New CatalogReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemSeriesList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSeriesList.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateSeriesListData(SelectedLazyNodes)

        Dim Report As New SeriesListReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()

    End Sub

    Private Sub MenuItemUIList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemUIList.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateInstalationUnitsListData(SelectedLazyNodes)

        Dim Report As New IUListReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub



    Private Sub MenuItemClassificationPlanReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemClassificationPlanReport.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As InventoryDataSet = ReportDataSetBuilder.GenerateClassificationPlanData(SelectedLazyNodes)

        Dim Report As New ClassificationPlanReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub


    Private Sub MenuItemPhysLocReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemPhysLocReport.Click
        Cursor.Current = Cursors.WaitCursor
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As PhysLocDataSet = ReportDataSetBuilder.GeneratePhysLocData(SelectedLazyNodes)

        Dim Report As New PhysLocReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor.Current = Cursors.Default
        frmReportPreview.Show()
    End Sub


    Private Sub MenuItemControlAccessReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemControlAccessReport.Click
        Cursor.Current = Cursors.WaitCursor
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As ControlAccessDataSet = ReportDataSetBuilder.GenerateControlAccessData(SelectedLazyNodes)

        Dim Report As New ControlAccessReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor.Current = Cursors.Default
        frmReportPreview.Show()
    End Sub


    Private Sub MenuItemAllControlAccess_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAllControlAccess.Click
        Cursor.Current = Cursors.WaitCursor
        Dim ReportDataSet As ControlAccessDataSet = ReportDataSetBuilder.GenerateAllControlAccessData()

        Dim Report As New AllControlAccessReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor.Current = Cursors.Default
        frmReportPreview.Show()

    End Sub

    Private Sub MenuItemInstalationUnitsBySeriesReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemInstalationUnitsBySeriesReport.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateInstalationUnitsBySeriesListData(SelectedLazyNodes)

        Dim Report As New IUBySeriesReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()

    End Sub

    Private Sub MenuItemAuthorsList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAuthorsList.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Cursor = Cursors.WaitCursor
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateAuthorsListData(SelectedLazyNodes)

        Dim Report As New AuthorsListReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor = Cursors.Default
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemCountElements_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemCountElements.Click
        Dim SelectedLazyNodes As LazyNodeCollection = GetSelectedLazyNodes()
        Cursor = Cursors.WaitCursor
        Dim ReportDataSet As CountElements = ReportDataSetBuilder.GenerateCountElementsData(SelectedLazyNodes)

        Dim Report As New CountElementsReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor = Cursors.Default
        frmReportPreview.Show()
    End Sub


#End Region



    Private Sub MenuItemElementCounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemElementCounter.Click
        Dim Row As ListViewItem
        Dim result As New Hashtable

        Dim startTime As Date = Date.Now

        For Each Row In ListView.SelectedItems
            Dim ID As Integer = StrToInt(Row.SubItems(7).Text)
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
            Try

                For Each OtherLevel As String In OtherLevels
                    Dim Count As Integer = SQLLazyNode.CountByOtherLevel( _
                                                              SQLServerSettings.Item("ServerAddress"), _
                                                              SQLServerSettings.Item("Database"), _
                                                              SQLServerSettings.Item("Username"), _
                                                              SQLServerSettings.Item("Password"), ID, _
                                                              OtherLevel)
                    If result.ContainsKey(OtherLevel) Then
                        result.Item(OtherLevel) += Count
                    Else
                        result.Add(OtherLevel, Count)
                    End If
                Next


            Catch ex As SqlException
                MessageBoxes.MsgBoxSqlException(ex)
                mySelectedFonds = Nothing
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)
                mySelectedFonds = Nothing
            End Try
            Me.Enabled = True
        Next

        Dim msg As String = ""
        Dim total As Integer

        For i As Integer = 0 To OtherLevels.Length - 1
            If result.ContainsKey(OtherLevels(i)) Then
                msg &= VisualFieldLabel(OtherLevels(i)) & ": " & result(OtherLevels(i)) & Chr(13)
                total += result(OtherLevels(i))
            End If
        Next

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)
        Dim timeStr As String = timeSpan.Minutes.ToString.PadLeft(2, "0") & "m" & timeSpan.Seconds.ToString.PadLeft(2, "0") & "s"
        msg &= ControlChars.NewLine & "Total: " & total & ControlChars.NewLine & ControlChars.NewLine
        msg &= "[Tempo: " & timeStr & "]"
        MsgBox(msg)

    End Sub




    Private Sub SearchTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchTimer.Tick
        Search()
        SearchTimer.Enabled = False
        SearchTimer.Stop()
    End Sub

    Private Sub txtFindFonds_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFindFonds.TextChanged
        SearchTimer.Enabled = True
        SearchTimer.Start()
    End Sub

    Private Sub btnCloseFondsManagerForm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCloseFondsManagerForm.Click
        myProgramState.LastFondsSearched = txtFindFonds.Text
        myProgramState.Save()
        DialogResult = DialogResult.Cancel
    End Sub


    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        If mySearchForm Is Nothing Then
            mySearchForm = New SearchForm
        End If

        Me.Enabled = False
        mySearchForm.Show()

    End Sub


    Private Sub GotoRecordEvent(ByVal GotoNodeID As Integer) Handles mySearchForm.GotoRecord
        Me.Enabled = True
        Me.Focus()

        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        Dim ID As Integer = mySearchForm.SelectedNodeID

        Dim SelectedLazyNode As SQLLazyNode = New SQLLazyNode( _
                                                SQLServerSettings.Item("ServerAddress"), _
                                                SQLServerSettings.Item("Database"), _
                                                SQLServerSettings.Item("Username"), _
                                                SQLServerSettings.Item("Password"), _
                                                ID)


        mySelectedLazyNode = SelectedLazyNode

        Dim RootNode As LazyNode = New SQLLazyNode(SQLServerSettings.Item("ServerAddress"), _
                                                       SQLServerSettings.Item("Database"), _
                                                       SQLServerSettings.Item("Username"), _
                                                       SQLServerSettings.Item("Password"), _
                                                       SelectedLazyNode.ParentFondsID)

        mySelectedFonds = RootNode
        DialogResult = DialogResult.OK
    End Sub


    Private Sub SearchForm_Close(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mySearchForm.FormClose
        Me.Enabled = True
        Me.Focus()
    End Sub

    Private Sub MenuItemSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSearch.Click
        btnSearch_Click(Me, Nothing)
    End Sub
End Class


