Imports System.Configuration
Imports DigitArq.UserControls.SearchControls
Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls
Imports Digitarq.UserControls.ErrorHandling


Public Class SearchForm
    Inherits System.Windows.Forms.Form

    Public Const MAX_RESULTS As Integer = 2000

    Private SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
    Private WithEvents MetadataViewer As New MetadataViewer
    Private FondsID As Integer = -1
    Private myFormResult As DialogResult = DialogResult.ok

    Public Event GotoRecord(ByVal SelectedNodeID As Integer)
    Public Event FormClose(ByVal sender As System.Object, ByVal e As System.EventArgs)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GroupBoxSearchBox As System.Windows.Forms.GroupBox
    Friend WithEvents SearchResults As DigitArq.UserControls.SearchControls.SearchResults
    Friend WithEvents StatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents Splitter1 As System.Windows.Forms.Splitter
    Friend WithEvents SearchBox As DigitArq.UserControls.SearchControls.SearchBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(SearchForm))
        Me.SearchBox = New DigitArq.UserControls.SearchControls.SearchBox
        Me.GroupBoxSearchBox = New System.Windows.Forms.GroupBox
        Me.SearchResults = New DigitArq.UserControls.SearchControls.SearchResults
        Me.StatusBar = New System.Windows.Forms.StatusBar
        Me.Splitter1 = New System.Windows.Forms.Splitter
        Me.GroupBoxSearchBox.SuspendLayout()
        Me.SuspendLayout()
        '
        'SearchBox
        '
        Me.SearchBox.AllFieldsSearchText = ""
        Me.SearchBox.AutoScroll = True
        Me.SearchBox.Dock = System.Windows.Forms.DockStyle.Top
        Me.SearchBox.Location = New System.Drawing.Point(0, 0)
        Me.SearchBox.Name = "SearchBox"
        Me.SearchBox.Size = New System.Drawing.Size(682, 324)
        Me.SearchBox.TabIndex = 18
        '
        'GroupBoxSearchBox
        '
        Me.GroupBoxSearchBox.Controls.Add(Me.SearchResults)
        Me.GroupBoxSearchBox.Controls.Add(Me.StatusBar)
        Me.GroupBoxSearchBox.Dock = System.Windows.Forms.DockStyle.Fill
        Me.GroupBoxSearchBox.Location = New System.Drawing.Point(0, 324)
        Me.GroupBoxSearchBox.Name = "GroupBoxSearchBox"
        Me.GroupBoxSearchBox.Size = New System.Drawing.Size(682, 298)
        Me.GroupBoxSearchBox.TabIndex = 16
        Me.GroupBoxSearchBox.TabStop = False
        Me.GroupBoxSearchBox.Text = CType(configurationAppSettings.GetValue("GroupBoxSearchBox.Text", GetType(System.String)), String)
        '
        'SearchResults
        '
        Me.SearchResults.Dock = System.Windows.Forms.DockStyle.Fill
        Me.SearchResults.Location = New System.Drawing.Point(3, 16)
        Me.SearchResults.Name = "SearchResults"
        Me.SearchResults.Size = New System.Drawing.Size(676, 255)
        Me.SearchResults.TabIndex = 15
        '
        'StatusBar
        '
        Me.StatusBar.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.StatusBar.Location = New System.Drawing.Point(3, 271)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Size = New System.Drawing.Size(676, 24)
        Me.StatusBar.TabIndex = 14
        '
        'Splitter1
        '
        Me.Splitter1.Dock = System.Windows.Forms.DockStyle.Top
        Me.Splitter1.Location = New System.Drawing.Point(0, 324)
        Me.Splitter1.Name = "Splitter1"
        Me.Splitter1.Size = New System.Drawing.Size(682, 3)
        Me.Splitter1.TabIndex = 17
        Me.Splitter1.TabStop = False
        '
        'SearchForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(682, 622)
        Me.Controls.Add(Me.Splitter1)
        Me.Controls.Add(Me.GroupBoxSearchBox)
        Me.Controls.Add(Me.SearchBox)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MaximumSize = New System.Drawing.Size(800, 700)
        Me.MinimumSize = New System.Drawing.Size(690, 500)
        Me.Name = "SearchForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = CType(configurationAppSettings.GetValue("SearchForm.Text", GetType(System.String)), String)
        Me.GroupBoxSearchBox.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region



    Public Sub New(ByVal FondsIdToSearch As Integer)
        Me.New()
        Me.FondsID = FondsIdToSearch
    End Sub

    Public Sub New(ByVal TextToSearch As String)
        Me.New()
        Me.FondsID = -1
        SearchBox.AllFieldsSearchText = TextToSearch
        If (TextToSearch.Length > 0) Then SearchBox_SearchClick(Me, Nothing)
    End Sub



    Public Sub New(ByVal FondsIdToSearch As Integer, ByVal TextToSearch As String)
        Me.New()
        Me.FondsID = FondsIdToSearch
        SearchBox.AllFieldsSearchText = TextToSearch
        If (TextToSearch.Length > 0) Then SearchBox_SearchClick(Me, Nothing)
    End Sub


    Private Sub SearchBox_SearchClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchBox.SearchClick
        Dim Filter As String = Nothing

        SearchBox.EnableSearchButton(False)

        Filter = SearchBox.SQLWhereClause

        Debug.WriteLine("SQL = " & Filter)

        If Filter.Length > 0 Then

            If FondsID >= 0 Then
                ' fonds id is defined, so filter only withing a fonds
                Filter = String.Format("(ParentFondsId = {0}) AND ({1})", FondsID, Filter)
            End If

            Me.Cursor = Cursors.WaitCursor
            Try
                Dim LazyNodeCollection As LazyNodeCollection = SQLLazyNode.SearchRetrieve( _
                                                SQLServerSettings.Item("ServerAddress"), _
                                                SQLServerSettings.Item("Database"), _
                                                SQLServerSettings.Item("Username"), _
                                                SQLServerSettings.Item("Password"), _
                                                Filter, MAX_RESULTS)

                StatusBar.Text = String.Format(InfoMessage("FindResults.ResultsCount"), LazyNodeCollection.Count)
                If (MAX_RESULTS = LazyNodeCollection.Count) Then StatusBar.Text &= " " & InfoMessage("FindResults.TooManyResults")

                SearchResults.SearchResultItems = LazyNodeCollection
                SearchResults.LoadResults()
            Catch ex As Exception
                MsgBoxException(ex)
            End Try

            SearchBox.EnableSearchButton(True)
            Me.DialogResult = DialogResult.None
            Me.Cursor = Cursors.Default
        End If
    End Sub



    Private Sub SearchResults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchResults.Preview

        Try
            Dim ID As Integer = SearchResults.SelectedItemID

            Dim LazyNode As LazyNode = New SQLLazyNode( _
                                            SQLServerSettings.Item("ServerAddress"), _
                                            SQLServerSettings.Item("Database"), _
                                            SQLServerSettings.Item("Username"), _
                                            SQLServerSettings.Item("Password"), _
                                            ID)
            MetadataViewer.Location = New Point(Me.Location.X + Me.Width, Me.Location.Y + 30)
            MetadataViewer.Height = Me.Height - 60
            MetadataViewer.LoadLazyNode(LazyNode)
            MetadataViewer.Show()
        Catch ex As Exception
            MsgBoxException(ex)
        End Try

    End Sub


    Private Sub EditButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MetadataViewer.EditClicked, SearchResults.EditClicked
        MetadataViewer.Hide()
        Me.Hide()
        RaiseEvent GotoRecord(SelectedNodeID)
    End Sub



    Public Function FormResult() As DialogResult
        Debug.WriteLine(myFormResult)
        Return myFormResult
    End Function


    Private Sub DockMetadataViewer()
        MetadataViewer.Location = New Point(Me.Location.X + Me.Width, Me.Location.Y + 30)
    End Sub

    Private Sub SearchForm_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Move
        DockMetadataViewer()
    End Sub

    Private Sub SearchForm_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        DockMetadataViewer()
    End Sub

    Private Sub SearchForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        e.Cancel = True

        MetadataViewer.Hide()
        Me.Hide()

        RaiseEvent FormClose(Me, e)
    End Sub


    Public Function SelectedNodeID() As Integer
        Return SearchResults.SelectedItemID
    End Function



    Public Sub SearchText(ByVal TextToSearch As String)
        SearchBox.AllFieldsSearchText = TextToSearch
        If (TextToSearch.Length > 0) Then SearchBox_SearchClick(Me, Nothing)
    End Sub

End Class

