Imports System.Collections
Imports System.Collections.Specialized
Imports System.Web.UI.UserControl

'********************************************************************************
' Module: mShowItems
' Purpose: This module treats all data in order to present all items (records)
'           given by the sql query constructed in the mDataBaseModule
'*********************************************************************************
Public Module mShowItems

    '********************************************************************************
    ' Purpose: This Enum saves the type of search to be able to show to the user the 
    '          correct page menu Header.
    '*********************************************************************************
    Public Enum SearchMode
        Basics
        Advanceds
    End Enum

    '********************************************************************************
    ' Function: strGetHTMLTagAlertImg
    ' Purpose: It returns the HMTL Tag For the Image Alert show, for the untreated
    '           Units.
    '*********************************************************************************

    Public Function strGetHTMLTagAlertImg(ByVal blnValid As Boolean) As String
        If Not blnValid Then
            Return "<img alt='Informao no tratada arquivisticamente' align ='top' src='Images/Alert.gif'/>"
        End If
    End Function


    '**********************************************************************************
    ' Function: strGetImgPth
    ' Purpose:  it returns link corresponding to the read value from the OtherLevel field
    '***********************************************************************************

    Public Function strGetImgPth(ByVal strLevel As String) As String
        strLevel = strLevel.ToLower.Trim
        Return "Images/" & strLevel & ".jpg"
    End Function


    '*********************************************************************************
    ' Function: strWriteDate
    ' Purpose:  It returns the complete date (final to Initial) in the correct way
    '*********************************************************************************

    Public Function strWriteDate(ByVal blnCAInitial As Boolean, ByVal strDateInitial As String, ByVal blnCAFinal As Boolean, ByVal strDateFinal As String) As String

        'For date Initial and Final
        strDateInitial = strGetDate(strDateInitial)
        strDateFinal = strGetDate(strDateFinal)

        If strDateInitial = strDateInitial.Empty And strDateFinal = strDateFinal.Empty Then
            Return ""
        End If

        If strDateInitial = strDateInitial.Empty Then
            If Not blnCAFinal Then
                Return String.Format("c.a.{0}", strDateFinal)
            Else
                Return strDateFinal
            End If
        End If

        If strDateFinal = strDateFinal.Empty Then
            If Not blnCAInitial Then
                Return String.Format("c.a.{0}", strDateInitial)
            Else
                Return strDateInitial
            End If
        End If

        If strDateInitial = strDateFinal Then
            If Not blnCAInitial And Not blnCAFinal Then
                Return String.Format("c.a.{0}", strDateInitial)
            Else
                Return strDateInitial
            End If
        End If

        If Not blnCAInitial And Not blnCAFinal Then
            Return String.Format("c.a.{0}/c.a.{1}", strDateInitial, strDateFinal)

        ElseIf Not blnCAFinal Then
            Return String.Format("{0}/c.a.{1}", strDateInitial, strDateFinal)

        ElseIf Not blnCAInitial Then
            Return String.Format("c.a.{0}/{1}", strDateInitial, strDateFinal)

        End If
        Return String.Format("{0}/{1}", strDateInitial, strDateFinal)
    End Function


    '*************************************************************************************************
    ' Function: strGetDate
    ' Purpose:  It returns the date, final or initial, in a correct way. It is year, day , 
    '           month if have a valid value. If the register have only year and all others with 0, 
    '           day- 00, month- 00, the user then only see year data, otherwise 
    '           it will return the date with "?" instead of "0" (db value for an inexistence information).
    '***************************************************************************************************

    Public Function strGetDate(ByVal strDate As String) As String
        If strDate.Equals("") Then Return ""
        Dim strDateParts() As String = strDate.Split("-")
        Dim i As Integer

        For i = 0 To strDateParts.Length - 1
            Select Case strDateParts(i)
                Case "0000"
                    strDateParts(i) = ""
                Case "00"
                    strDateParts(i) = ""
            End Select
        Next

        If strDateParts(0) = "" Then
            Return strDate.Empty
        End If

        strDate = Join(strDateParts, "-")

        'If we have only the year
        If strDate.EndsWith("--") Then
            strDate = strDate.TrimEnd("-")
        End If

        'If we have the year and month
        If strDate.EndsWith("-") Then
            strDate &= "??"
        End If

        ' If we have year and day
        strDate = strDate.Replace("--", "-??-")

        Return strDate
    End Function

    Public Function strWriteTreeNodeName(ByVal IsVisible As Boolean, ByVal strUnitID As String, ByVal strUnitTitle As String, ByVal strUnitTitleType As String, Optional ByVal strDate As String = "")
        Dim strUnitTitleTrunc As String
        If strUnitTitle.Length > 35 Then
            strUnitTitleTrunc = strUnitTitle.Substring(0, 35)
            strUnitTitleTrunc = strUnitTitleTrunc & "..."
        Else
            strUnitTitleTrunc = strUnitTitle
        End If
        strUnitTitleTrunc = strWriteTitle(strUnitTitleTrunc, strUnitTitleType)
        If IsVisible Then
            Return "<span title='" & strUnitTitle & "'>" & _
                        "<font size='1'>" & _
                            "<nobr><b>" & strUnitID & "</b> " & strUnitTitleTrunc & " <font color='orange'>" & strDate & "</font></nobr>" & _
                        "</font>" & _
                   "</span>"
        Else
            Return "<span>" & _
                        "<font size='1'>" & _
                            "<nobr><b>" & strUnitID & "</b><font style='color:red'> Informao no disponvel</font></nobr>" & _
                        "</font>" & _
                   "</span>"
        End If
        
    End Function

    Public Function strWriteTitle(ByVal strUnitTitle As String, ByVal strUnitTitleType As String) As String
        If strUnitTitleType = ConfigurationSettings.AppSettings("UnitTitleType2") Then
            Return "[" & strUnitTitle & "]"
        Else
            Return strUnitTitle
        End If
    End Function

    Public Function strHeaderDigitalObjects() As String
        Return "<tr><td colspan=3>" & _
                    "<table cellpadding=0 cellspacing=5 border=0 align=center>" & _
               "<tr valign=top align=center>"
    End Function

    Public Function strFooterDigitalObjects() As String
        Return "</tr>" & _
               "</table>" & _
               "</td></tr>"
    End Function

    Public Function strHeaderDigitalObjectsLoc() As String
        Return "<tr><td colspan=3>" & _
                    "<table cellpadding=0 cellspacing=0 border=0 align=left>" & _
               "<tr valign=top align=center>"
    End Function

    Public Function strHeaderDigitalObjectsLoc2() As String
        Return "<tr><td colspan=2>" & _
                    "<table cellpadding=0 cellspacing=0 border=0 align=left>" & _
               "<tr valign=top align=center>"
    End Function

    Public Function strFooterDigitalObjectsLoc() As String
        Return "</tr>" & _
               "</table>" & _
               "</td></tr>"
    End Function

    Public Function strHeaderTable() As String
        Return "<table width=100% CellPadding=1 CellSpacing=0 border=0>"
    End Function

    Public Function strFooterTable() As String
        Return "</table>"
    End Function

    Public Function strSeparator(ByVal intColspan As Integer)
        Return "<tr>" & _
                    "<td align='left' colspan='" & intColspan & "'><br/></td>" & _
                "</tr>"
    End Function


    '*************************************************************************************************
    ' Function: strWriteTextLine
    ' Purpose:  It returns the Html tags which shows, on a line, the description of a db field and 
    '           filed database respective value.
    '           It is used to make the matriz image Metadata description page (used in ImageGOD.aspx)
    '***************************************************************************************************
    Public Function strWriteTextLine(ByVal strDescription As String, ByVal strSqlValue As String, ByVal strDimension As String) As String
        If strSqlValue.Trim = "" Or strSqlValue = "=" Then Return ""
        strSqlValue = strSqlValue.Replace(ControlChars.NewLine, "</br>")
        Return "<font class='TextNavy'>" & strDescription & ": </font>" & _
               "<font class='TextGray'>" & strSqlValue & " " & strDimension & " </font></br>"
    End Function


    '*************************************************************************************************
    ' Function: strDraw3ColumnRow
    ' Purpose:  It returns the Html tags that draws a row with 3 columns.It is used for to list the search 
    '           results information.
    '           It is used in : ListShow.aspx; OrderByDate.aspx; OderByOtherLevel.aspx; OrderByTitle.aspx
    '***************************************************************************************************
    Public Function strDraw3ColumnRow(ByVal strExtra As String, ByVal strDescription As String, ByVal strValue As String) As String
        If strValue.Trim = "" Then Return ""
        Return String.Format("<tr>" & _
                             "<td class='listShowB' width='40px'><b><nobr>{0}</nobr></b></td>" & _
                             "<td class='listShowB' width='150px'>{1}</td>" & _
                             "<td class='listShow'>{2}</td></tr>", _
                             strExtra, strDescription, strValue)

    End Function


    Public Function strDrawSponsorship(ByVal strExtra As String, ByVal strDescription As String, ByVal strValue As String) As String
        Dim strSponsoredReference As String = ConfigurationSettings.AppSettings("SponsoredReference")
        If Not strValue.StartsWith(strSponsoredReference) Then Return ""
        Return String.Format("<tr>" & _
                             "<td class='listShowB' width='40px'><b><nobr>{0}</nobr></b></td>" & _
                             "<td class='listShowB' width='150px'>{1}</td>" & _
                             "<td class='listShow'><img src='Images/Sponsorship.jpg'</td></tr>", _
                             strExtra, strDescription)

    End Function


    '*************************************************************************************************
    ' Function: strDraw3ColumnRowForRA
    ' Purpose:  It returns the Html tag that draws a row with 3 columns. It is used for to add the 
    '           authority register link to the registers that have it.
    '           It is used in : ListShow.aspx; OrderByDate.aspx; OderByOtherLevel.aspx; OrderByTitle.aspx
    '***************************************************************************************************
    Public Function strDraw3ColumnRowForRA(ByVal strLink As String, ByVal blnEac As Boolean) As String
        If Not blnEac Then Return ""
        Return String.Format("<tr>" & _
                             "<td valign='top'></td>" & _
                             "<td class='listShow'>{0}</td>" & _
                             "<td></td>" & _
                             "</tr>", strLink)
    End Function

    Public Function strDraw3ColumnRowForRA(ByVal strDescription As String, ByVal strLink As String, ByVal blnEac As Boolean) As String
        If Not blnEac Then Return ""
        Return String.Format("<tr>" & _
                             "<td></td>" & _
                             "<td class='listShowB'>{0}</td>" & _
                             "<td class='listShow'>{1}</td>" & _
                             "</tr>", strDescription, strLink)
    End Function


    '*************************************************************************************************
    ' Function: strDraw2ColumnRow
    ' Purpose:  It returns the Html tag that draws a row with 2 columns. It is used for to show all 
    '           the information related with the chosen register (unit).
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strDraw2ColumnRow(ByVal strDescription As String, ByVal strValue As String) As String
        If strValue.Trim.Equals("") Or strValue.Equals("0") Then Return ""
        strValue = strValue.Replace(ControlChars.NewLine, "</br>")
        Return String.Format("<tr>" & _
                             "<td class='TextNavy' width='25%'>{0}</td>" & _
                             "<td class='TextGray' width='75%'>{1}</td>" & _
                             "</tr>", strDescription, strValue)
    End Function

    Public Function strDraw2ColumnRowTitle(ByVal strDescription As String) As String
        Return String.Format("<tr>" & _
                             "<td class='TextNavy'>{0}</td>" & _
                             "<td></td>" & _
                             "</tr>", strDescription)
    End Function


    '*************************************************************************************************
    ' Function: strDraw2ColumnRowChangeLine
    ' Purpose:  It returns the Html 2 tags that draws a row with 2 columns each. It is used for to show
    '           the description and the bd value in separated lines.
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strDraw2ColumnRowChangeLine(ByVal strDescription As String, ByVal strValue As String) As String
        If strValue.Trim.Equals("") Or strValue.Equals("0") Then Return ""
        strValue = strValue.Replace(ControlChars.NewLine, "</br>")
        Return String.Format("<tr><td colspan='2' class='TextNavy'>{0}</td></tr>" & _
                             "<tr><td colspan='2' class='TextGrayChangeLine'>{1}<br></td></tr>", _
                             strDescription, strValue)
    End Function


    '*************************************************************************************************
    ' Function: strAlert
    ' Purpose:  It returns the Html tag that draws a row with 3 columns. It is used for to show the
    '           image alert and description. 
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strAlert(ByVal strImageTag As String, ByVal blnValid As Boolean) As String
        If blnValid Then Return ""
        Return String.Format("<tr><td colspan='2' align='left' valign='top' class='TextRed'>{0} {1}</td></tr>", strImageTag, "Informao no tratada arquivisticamente")
    End Function


    '*************************************************************************************************
    ' Function: strDimensions
    ' Purpose:  It returns the Html tag that draws a row with 2 columns. It is used to show the deminsions
    '           db value only for registers that are UI, D, DC. In other Levels this unit characteristics  
    '           doesnt make sence.
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strDimensions(ByVal strOtherLevel As String, ByVal strDescription As String, ByVal strValue As String) As String
        If strValue.Trim.Equals("") Or strValue.Equals("0") Then Return ""
        If strOtherLevel.Equals("UI") Or strOtherLevel.Equals("D") Or strOtherLevel.Equals("DC") Then
            strValue = strValue.Replace(ControlChars.NewLine, "</br>")
            Return String.Format("<tr>" & _
                                 "<td class='TextNavy'>{0}</td>" & _
                                 "<td class='TextGray'>{1}</td></tr>", _
                                 strDescription, strValue)
        Else : Return ""
        End If
    End Function


    '*************************************************************************************************
    ' Function: strExtent
    ' Purpose:  It returns the Html tag that draws a row with 2 columns. It is used to show the extension 
    '           deminsion db value. 
    '           It is used in : RegShow.aspx
    '***************************************************************************************************
    Public Function strExtent(ByVal OtherLevel As String, ByVal ExtentLeaf As Integer, ByVal ExtentPage As Integer, _
        ByVal ExtentBook As Integer, ByVal ExtentMaco As Integer, ByVal ExtentMacete As Integer, ByVal ExtentFolder As Integer, _
        ByVal ExtentCover As Integer, ByVal ExtentCapilha As Integer, ByVal ExtentRoll As Integer, _
        ByVal ExtentBox As Integer, ByVal ExtentEnvelope As Integer, ByVal ExtentAlbum As Integer, ByVal ExtentOther As Integer) As String
        ' in this function i didn't use the Notation for the function parameter once they are named like in the db.
        ' It was more easier to construct the function

        Dim sclOutput As New StringCollection

        If (OtherLevel = "D" Or OtherLevel = "DC" Or OtherLevel = "UI") Then
            If ExtentLeaf = 1 Then
                sclOutput.Add(String.Format("{0} {1}", ExtentLeaf, "folha"))
            ElseIf ExtentLeaf > 1 Then
                sclOutput.Add(String.Format("{0} {1}", ExtentLeaf, "folhas"))
            End If
            If ExtentPage = 1 Then
                sclOutput.Add(String.Format("{0} {1}", ExtentPage, "pgina"))
            ElseIf ExtentPage > 1 Then
                sclOutput.Add(String.Format("{0} {1}", ExtentPage, "pginas"))
            End If
        End If
        If ExtentBook = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentBook, "livro"))
        ElseIf ExtentBook > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentBook, "livros"))
        End If
        If ExtentMaco = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentMaco, "mao"))
        ElseIf ExtentMaco > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentMaco, "maos"))
        End If
        If ExtentMacete = 1 Then
            sclOutput.Add(ExtentMacete & " macete")
        ElseIf ExtentMacete > 1 Then
            sclOutput.Add(ExtentMacete & " macetes")
        End If
        If ExtentFolder = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentFolder, "pasta"))
        ElseIf ExtentFolder > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentFolder, "pastas"))
        End If
        If ExtentCover = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentCover, "capa"))
        ElseIf ExtentCover > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentCover, "capas"))
        End If
        If ExtentCapilha = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentCapilha, "capilha"))
        ElseIf ExtentCapilha > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentCapilha, "capilhas"))
        End If
        If ExtentRoll = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentRoll, "rolo"))
        ElseIf ExtentRoll > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentRoll, "rolos"))
        End If
        If ExtentBox = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentBox, "caixa"))
        ElseIf ExtentBox > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentBox, "caixas"))
        End If
        If ExtentEnvelope = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentEnvelope, "envelope"))
        ElseIf ExtentEnvelope > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentEnvelope, "envelopes"))
        End If
        If ExtentAlbum = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentAlbum, "lbum"))
        ElseIf ExtentAlbum > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentAlbum, "lbuns"))
        End If
        If ExtentOther = 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentOther, "outro "))
        ElseIf ExtentOther > 1 Then
            sclOutput.Add(String.Format("{0} {1}", ExtentOther, "outros "))
        End If
        If sclOutput.Count <> 0 Then
            Dim strReturns As String
            Dim strTempArr(sclOutput.Count - 1) As String
            sclOutput.CopyTo(strTempArr, 0)
            strReturns = Join(strTempArr, "; ")
            Return String.Format("<tr>" & _
                "<td class='TextNavy'>{0}</td>" & _
                "<td class='TextGray'>{1}</td>" & _
                "</tr>", "Dimenso", strReturns)
        Else : Return ""
        End If
    End Function


    '*************************************************************************************************
    ' Function: strLevelName
    ' Purpose:  It returns the level name according to de db OtherLevel read from the table components.
    '           It is used in : RegShow.aspx, ListShow.aspx, OrderByDate.aspx, OrderByTitle.aspx
    '           and OrderByOtherLevel.aspx
    '***************************************************************************************************
    Public Function strLevelName(ByVal strOtherLevel As String) As String
        Select Case strOtherLevel
            Case "F"
                Return "Fundo"
            Case "SF"
                Return "Subfundo"
            Case "SSF"
                Return "Subsubfundo"
            Case "SC"
                Return "Seco"
            Case "SSC"
                Return "Subseco"
            Case "SSSC"
                Return "Subsubseco"
            Case "SR"
                Return "Srie"
            Case "SSR"
                Return "Subsrie"
            Case "SSSR"
                Return "Subsubsrie"
            Case "UI"
                Return "Unidade de instalao"
            Case "D"
                Return "Documento simples"
            Case "DC"
                Return "Documento composto"
        End Select
    End Function

End Module
