
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Configuration
Imports System.Globalization
Imports System.IO
Imports DigitArq.Definitions.MGOD

Public Class FileProcessing

#Region "Properties"

    Public Enum Dimension
        Resolution
        Width
        Height
    End Enum

    Public Shared myFormats As String() = {"TIFF", "TIF", "JPEG", "JPG", "PNG", "GIF"}

    Shared ReadOnly Property Formats() As ArrayList
        Get
            Return New ArrayList(myFormats)
        End Get
    End Property

#End Region

#Region "Generate dissemination"

    Public Shared Function CanGeneDissemination(ByVal Format As String) As Boolean
        Return Formats.Contains(Format)
    End Function

    Public Shared Sub GenerateDisseminationImage(ByVal OriginalStream As Stream, ByVal OutputStream As Stream, ByVal Quality As Integer, ByVal Dimension As Dimension, ByVal DimensionValue As Integer)
        Dim SourceBitmap As Bitmap = New Bitmap(OriginalStream)
        Dim DestBitmap As Bitmap
        Select Case Dimension
            Case Dimension.Width
                DestBitmap = ResizeImageToWidth(SourceBitmap, DimensionValue)
            Case Dimension.Height
                DestBitmap = ResizeImageToHeight(SourceBitmap, DimensionValue)
            Case Dimension.Resolution
                DestBitmap = ChangeImageResolution(SourceBitmap, DimensionValue)
        End Select

        DestBitmap.Save(OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg)

        InsertWaterMark(OutputStream, OutputStream, Quality)
    End Sub

    Private Shared Sub InsertWaterMark(ByVal InputStream As Stream, ByVal OutputStream As Stream, ByVal Quality As Integer)
        Dim Image As System.Drawing.Image = System.Drawing.Image.FromStream(InputStream)
        Dim BaseMap As System.Drawing.Bitmap = New System.Drawing.Bitmap(Image.Width, Image.Height)
        Dim MyGraphic As Graphics = Graphics.FromImage(BaseMap)
        MyGraphic.DrawImage(Image, 0, 0, Image.Width, Image.Height)


        'TAKE WATER MARK
        If Not WATER_MARK_PATH.Equals("") Then
            Dim WaterMarkImage As System.Drawing.Image = WaterMarkImage.FromFile(Application.StartupPath + WATER_MARK_PATH)

            Dim WaterMarkWidth As Integer = Image.Width * WATER_MARK_PERCENT_WIDTH / 100
            Dim WaterMarkHeight As Integer = WaterMarkWidth * WaterMarkImage.Height / WaterMarkImage.Width

            Dim WaterMarkXPosition As Integer = Image.Width / 2 - WaterMarkWidth / 2
            Dim WaterMarkYPosition As Integer = Image.Height * WATER_MARK_PERCENT_YPOSITION / 100 - WaterMarkHeight / 2

            MyGraphic.DrawImage(WaterMarkImage, WaterMarkXPosition, WaterMarkYPosition, WaterMarkWidth, WaterMarkHeight)

            WaterMarkImage.Dispose()
            WaterMarkImage = Nothing
        End If

        Image.Dispose()
        Image = Nothing

        Dim Encoder As Encoder = Encoder.Quality
        Dim EncoderParameters As New EncoderParameters(1)
        Dim EncoderParameter As New EncoderParameter(Encoder, Quality)
        EncoderParameters.Param(0) = EncoderParameter

        Dim ImageCodecInfo As ImageCodecInfo
        ImageCodecInfo = GetEncoderInfo("image/jpeg")

        OutputStream.Seek(0, SeekOrigin.Begin)
        BaseMap.Save(OutputStream, ImageCodecInfo, EncoderParameters)

        BaseMap.Dispose()
        BaseMap = Nothing
    End Sub

#End Region

#Region "Generate thumbnail"

    Public Shared Sub GenerateThumbnailImage(ByVal InputStream As Stream, ByVal OutputStream As Stream, ByVal MaxSide As Integer)
        Dim SourceBitmap As Bitmap = New Bitmap(InputStream)
        Dim DestBitMap As Bitmap

        If IsLandscapeImage(SourceBitmap) Then
            DestBitMap = ResizeImageToWidth(SourceBitmap, MaxSide)
        Else
            DestBitMap = ResizeImageToHeight(SourceBitmap, MaxSide)
        End If

        DestBitMap.Save(OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg)

        SourceBitmap.Dispose()
        DestBitMap.Dispose()
    End Sub

#End Region

#Region "Resize image"

    Private Shared Function ResizeImageToWidth(ByVal SourceBitmap As Bitmap, ByVal Width As Integer) As Bitmap
        Dim Height As Integer
        If SourceBitmap.Width > Width Then
            Height = Width * SourceBitmap.Height / SourceBitmap.Width
        Else
            Width = SourceBitmap.Width
            Height = SourceBitmap.Height
        End If

        Dim DestBitmap As System.Drawing.Bitmap = New System.Drawing.Bitmap(Width, Height)
        Dim Graphic As Graphics = Graphics.FromImage(DestBitmap)
        Graphic.DrawImage(SourceBitmap, 0, 0, DestBitmap.Width, DestBitmap.Height)

        Return DestBitmap
    End Function

    Private Shared Function ResizeImageToHeight(ByVal SourceBitmap As Bitmap, ByVal Height As Integer) As Bitmap
        Dim Width As Integer
        If SourceBitmap.Height > Height Then
            Width = Height * SourceBitmap.Width / SourceBitmap.Height
        Else
            Width = SourceBitmap.Width
            Height = SourceBitmap.Height
        End If

        Dim DestBitmap As System.Drawing.Bitmap = New System.Drawing.Bitmap(Width, Height)
        Dim Graphic As Graphics = Graphics.FromImage(DestBitmap)
        Graphic.DrawImage(SourceBitmap, 0, 0, DestBitmap.Width, DestBitmap.Height)

        Return DestBitmap
    End Function

#End Region

#Region "Change image resolution"

    Friend Shared Function ChangeImageResolution(ByVal SourceBitmap As Bitmap, ByVal Resolution As Integer) As Bitmap
        Try
            Dim reduction As Double = Resolution / CInt(SourceBitmap.HorizontalResolution)
            Dim NewBitmap As New Bitmap(SourceBitmap.Width, SourceBitmap.Height, SourceBitmap.PixelFormat)
            NewBitmap.SetResolution(Resolution, Resolution)
            Dim OutImage As New Bitmap(SourceBitmap, CInt(SourceBitmap.Width * reduction), CInt(SourceBitmap.Height * reduction))
            Dim g As Graphics = Graphics.FromImage(SourceBitmap)
            g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic
            g.DrawImage(OutImage, 0, 0)
            Return OutImage
        Catch ex As Exception
            Return SourceBitmap
        End Try
    End Function

#End Region

#Region "Some auxiliary functions"

    Private Shared Function IsLandscapeImage(ByVal Image As System.Drawing.Image) As Boolean
        Return Image.Width > Image.Height
    End Function

    Private Shared Function GetEncoderInfo(ByVal mimeType As String) As ImageCodecInfo
        Dim j As Integer
        Dim codecs() As ImageCodecInfo
        codecs = ImageCodecInfo.GetImageEncoders()

        For Each codec As ImageCodecInfo In codecs
            If codec.MimeType = mimeType Then
                Return codec
            End If
        Next
        Return Nothing
    End Function

    Public Shared Function ReadBinaryFile(ByVal FileName As String) As Byte()
        Try
            Dim FileStream As New FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read)
            Dim BinaryReader As New BinaryReader(FileStream)
            Dim Ret() As Byte = BinaryReader.ReadBytes(FileStream.Length)
            FileStream.Close()
            BinaryReader.Close()

            Return Ret
        Catch ex As Exception
            Throw (ex)
        End Try
    End Function

    Public Shared Function WriteBinaryFile(ByVal FileName As String, ByVal Data As Byte()) As Boolean
        Dim WrittenFile As Boolean = True
        Try
            Dim FileStream As New FileStream(FileName, FileMode.Create)
            Dim BinaryWriter As BinaryWriter = New BinaryWriter(FileStream)
            BinaryWriter.Write(Data, 0, Data.Length)
            FileStream.Close()
            BinaryWriter.Close()
        Catch ex As Exception
            WrittenFile = False
        End Try
        Return WrittenFile
    End Function

    Public Shared Function WriteBinaryToStream(ByVal Data As Byte()) As Stream
        Try
            Dim Stream As New MemoryStream
            Stream.Write(Data, 0, Data.Length)
            Return Stream
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

    Public Shared Function WriteStreamToBynary(ByVal Stream As Stream) As Byte()
        Try
            Dim StreamLength As Integer = Convert.ToInt32(Stream.Length)
            Dim FileData As Byte() = New Byte(StreamLength) {}

            Stream.Read(FileData, 0, StreamLength)
            Return FileData
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

#End Region

End Class
