Imports System.Collections.ArrayList
Imports System.IO
Imports System.Xml
Imports System.Xml.Schema
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.UserControls.MetadataDataGrid
Imports DigitArq.Definitions.MGOD

Public Class Metadata

#Region "Private properties"

    Private database As New SqlCommands(USER_LOGON)
    Private myFormat As String
    Private myProperties As PropertyCollection
    Private myXMLMetadata As XmlDocument
    Const METADATA_XML_FILENAME As String = "\..\Metadata\metadata.xml"
    Const METADATA_XSD_FILENAME As String = "\..\Metadata\metadata.xsd"
    Const SINGLE_VALUE_PROPERTY As String = "Textbox"
    Const MULTIPLE_VALUE_PROPERTY As String = "Combobox"

#End Region

#Region "Constructors"

    Public Sub New(ByVal MetadataDataGrid As MetadataDataGrid, ByVal Properties As Hashtable, ByVal Format As String, ByVal ProjectID As Int64)
        myFormat = Format
        LoadProperties(MetadataDataGrid, Properties, ProjectID)
    End Sub

    Public Sub LoadProperties(ByVal MetadataDataGrid As MetadataDataGrid, ByVal Properties As Hashtable, ByVal ProjectID As Int64) 'As PropertyCollection
        myProperties = New PropertyCollection
        myXMLMetadata = New XmlDocument
        myXMLMetadata.Load(Application.StartupPath & METADATA_XML_FILENAME)

        Dim xnlProperties As XmlNodeList = myXMLMetadata.SelectNodes(String.Format("//DocType[@ID=""{0}""]/Property", myFormat))
        For Each xnProperty As XmlNode In xnlProperties
            Dim PropertyID As String = xnProperty.Attributes("PID").Value
            Dim PropertyName As String = xnProperty.Item("Name").InnerText
            Dim PropertyValue As String = Properties.Item(PropertyName)
            Dim PropertyNameReadOnly As Boolean = xnProperty.Attributes("PropertyNameReadOnly").Value
            Dim PropertyValueReadOnly As Boolean = xnProperty.Attributes("PropertyValueReadOnly").Value

            Select Case xnProperty.Item("ControlType").InnerText
                Case SINGLE_VALUE_PROPERTY
                    MetadataDataGrid.AddSingleValueProperty(PropertyName, PropertyValue, PropertyNameReadOnly, PropertyValueReadOnly)

                Case MULTIPLE_VALUE_PROPERTY
                    Dim Collection As Collection
                    Select Case PropertyName
                        Case "Perfil digitalizao"
                            Collection = database.SelectDigitalizationProfileNames
                        Case "Plataforma tecnolgica"
                            Collection = database.SelectTechnologicalPlatformNames
                        Case Else
                            Collection = database.SelectControlledVocabularyValues(PropertyName)
                    End Select
                    MetadataDataGrid.AddMultipleValueProperty(PropertyName, PropertyValue, Collection, PropertyNameReadOnly, PropertyValueReadOnly)
            End Select
            Properties.Remove(PropertyName)
        Next
        For Each PropertyName As String In Properties.Keys
            MetadataDataGrid.AddNewSingleValueProperty(propertyname, Properties.Item(PropertyName))
        Next
    End Sub

    Public Function GetProperties(ByVal MetadataDataGrid As MetadataDataGrid) As Hashtable
        Dim hash As New Hashtable
        For Each PropertyItem As PropertyItem In MetadataDataGrid.PropertyCollection
            hash.Add(PropertyItem.ID, PropertyItem.ValueControl.Text)
        Next
    End Function

#End Region

#Region "Properties"

    Property ID() As String
        Get
            Return myFormat
        End Get
        Set(ByVal Value As String)
            myFormat = Value
        End Set
    End Property

    Property Properties() As PropertyCollection
        Get
            Return myProperties
        End Get
        Set(ByVal Value As PropertyCollection)
            myProperties = Value
        End Set
    End Property

#End Region

End Class

