
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

'************************************************************************************************
' Module: General
' Purpose: This code general functions that are used in a DB access and in AEC class
'          This is a copy of general from digitarq application with some changes.
' The Notation isn't used here.
'***************************************************************************************************
Imports System.Configuration

Public Module General

#Region "Database to interface"

    Public Function StrToInterface(ByVal v As String) As String
        If (v = "" Or v Is Nothing) Then Return "<i>(Campo no preenchido)</i>" Else Return v
    End Function

    Public Function DateToInterface(ByVal di As String, ByVal df As String, ByVal sep As String) As String
        If (df = "" Or df Is Nothing) Then Return di Else Return di + " " + sep + " " + df
    End Function

#End Region

#Region "Database to Type"

    Public Function DBToDate(ByVal obj As Object) As Date
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return Date.Parse("0001-01-01")
        Else
            Try
                Dim d As Date = CDate(obj)
                Return d
            Catch ex As Exception
                Return Date.Parse("0001-01-01")
            End Try
        End If
    End Function

    Public Function DBToInt(ByVal obj As Object) As Integer
        If obj Is System.DBNull.Value Then Return -1 Else Return CInt(obj)
    End Function

    Public Function DBToStr(ByVal obj As Object) As String
        If obj Is System.DBNull.Value Then Return "" Else Return obj
    End Function

    Public Function DBToBool(ByVal obj As Object) As Boolean
        If obj Is System.DBNull.Value Then Return False Else Return CBool(obj)
    End Function

    Public Function DBToByte(ByVal obj As Object) As Byte()
        If obj Is System.DBNull.Value Then
            Dim bytDataNull(0) As Byte
            bytDataNull(0) = CType(0, Byte)
            Return bytDataNull
        Else
            Dim DataByte() As Byte = CType(obj, Byte())
            Return DataByte
        End If
    End Function

    Public Function BoolToDB(ByVal v As Boolean) As Integer
        If v Then Return 1 Else Return 0
    End Function

#End Region

#Region "Type to String"

    Public Function DateToStr(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2}", (v.Year & "").PadLeft(4, "0"), (v.Month & "").PadLeft(2, "0"), (v.Day & "").PadLeft(2, "0"))
    End Function

    Public Function IntToStr(ByVal v As Integer) As String
        Return CStr(v)
    End Function

    Public Function DblToStr(ByVal v As Integer) As String
        Return CDbl(v)
    End Function

    Public Function BitToStr(ByVal v As Boolean) As String
        If v Then Return "True" Else Return "False"
    End Function

    Public Function DBToInt64(ByVal obj As Object) As Int64
        If obj Is System.DBNull.Value Then Return -1 Else Return CType(obj, Int64)
    End Function

#End Region

#Region "Type to Database"

    Public Function IntToDB(ByVal v As Integer) As Object
        If v = 0 Then Return System.DBNull.Value Else Return v
    End Function

    Public Function Int64ToDB(ByVal v As Int64) As Object
        If v = 0 Then Return System.DBNull.Value Else Return v
    End Function

    Public Function StrToDB(ByVal v As String) As Object
        If (v = "" Or v Is Nothing) Then Return System.DBNull.Value Else Return v
    End Function

    Public Function StrToDate(ByVal v As String) As Object
        If (v = "" Or v Is Nothing) Then Return System.DBNull.Value Else Return Date.Parse(v)
    End Function


    'Public Function DateToDB(ByVal v As Date) As String
    '    Return String.Format("{0}-{1}-{2}", (v.Year & "").PadLeft(4, "0"), (v.Month & "").PadLeft(2, "0"), (v.Day & "").PadLeft(2, "0"))
    'End Function

    'Public Function StrToDB(ByVal v As String) As String
    '    If v Is Nothing Then Return "" Else Return v.Replace("'", "")
    'End Function

#End Region

#Region "String To Type"

    Public Function StrToDbl(ByVal v As String) As Double
        Try
            Dim i As Double = Double.Parse(v)
            Return i
        Catch ex As Exception
            Return 0.0
        End Try
    End Function



    Public Function StrToInt(ByVal v As String) As Integer
        Try
            Dim i As Integer = CInt(v)
            Return i
        Catch ex As Exception
            Return 0
        End Try
    End Function


    'Public Function StrToDate(ByVal v As String) As Date
    '    Try
    '        Dim d As Date = Date.Parse(v)
    '        Return d
    '    Catch ex As Exception
    '        Return Date.Parse("0001-01-01")
    '    End Try
    'End Function


    Public Function StrToBool(ByVal v As String) As Boolean
        Return v = "1" Or v = "yes"
    End Function

#End Region

#Region "Create  Html Tag"
    Public Function CreateTag(ByVal desc As String, ByVal value As String) As String
        Select Case value
            Case "" : Return ""
            Case Else : Return "<p> <font class='TextBlueBottom'>" & desc & "</font> <font class='TextGrayTop'> " & value & " </font> </p>"
        End Select
    End Function
#End Region

#Region " Write in Html the description and the BD value if the value exists"
    Public Function WriteIfNotEmpty(ByVal desc As String, ByVal value As String) As String

        If value <> "" Then
            Return desc & value
        End If
        Return ""
    End Function
#End Region

End Module
