
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Configuration
Imports System.IO


Module General

#Region "Globaly assigned variables"

    Public Constants As Hashtable = ConfigurationSettings.GetConfig("constants")
    Public templateSettings As Hashtable = ConfigurationSettings.GetConfig("templateSettings")
    Public objectVaultSettings As Hashtable = ConfigurationSettings.GetConfig("objectVaultSettings")

    Public USER_LOGON As String

    Public OBJECT_VAULT_SERVER_ADDRESS = objectVaultSettings("ServerAddress")

    Public LOGO_PATH As String = templateSettings("LogoPath")
    Public IMAGE_NOT_AVAILABLE_PATH As String = templateSettings("ImageNotAvailablePath")

    Public ADMIN_USERNAME As String = "admin"
    Public ADMIN_PASSWORD As String = "admin"

    Public STATECONFIG_FILENAME As String = Application.UserAppDataPath & "\" & "MPOD.config"
    Public DATABASE_SQL_FILENAME As String = Application.StartupPath & "\sql\" & "Database.sql"

    Public SQLSERVER_STORAGE As String = "sqlserver://"
    Public FILE_STORAGE As String = "file://"
    Public OBJECTVAULT_STORAGE As String = "vault://"

    Public Enum ImageIndex
        PUBLISHED_DIGITALOBJECT
        UNPUBLISHED_DIGITALOBJECT
        WARNING_DIGITALOBJECT
        NODE
        FILE_WITH_DISSEMINATION
        FILE_WITHOUT_DISSEMINATION
        TEMP_FILE
        CORRUPTED_FILE
    End Enum

#End Region

#Region "Configuration File APIs"

    Public Function Constant(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("constants"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function ErrorMessage(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("errMessages"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function InfoMessage(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("infoMessages"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function LogMessage(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("logMessages"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function



    Public Function ContextMenuLabel(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("contextMenu"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function

    Public Function VisualFieldLabel(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("visualFieldsLabelSettings"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function

#End Region

#Region "Database to Type"

    Public Function DBToDate(ByVal obj As Object) As Date
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return Date.Parse("0001-01-01")
        Else
            Try
                Dim d As Date = CDate(obj)
                Return d
            Catch ex As Exception
                Return Date.Parse("0001-01-01")
            End Try
        End If
    End Function


    Public Function DBToInt(ByVal obj As Object) As Integer
        If obj Is System.DBNull.Value Then Return 0 Else Return CInt(obj)
    End Function

    Public Function DBToDbl(ByVal obj As Object) As Double
        If obj Is System.DBNull.Value Then Return 0.0 Else Return Double.Parse(DBToStr(obj).Replace(".", ","))
    End Function


    Public Function DBToStr(ByVal obj As Object) As String
        If obj Is System.DBNull.Value Then Return "" Else Return obj
    End Function

    Public Function DBToBool(ByVal obj As Object) As Boolean
        If obj Is System.DBNull.Value Then Return False Else Return CBool(obj)
    End Function
#End Region

#Region "Type to String"

    Public Function DateToStr(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2}", (v.Year & "").PadLeft(4, "0"), (v.Month & "").PadLeft(2, "0"), (v.Day & "").PadLeft(2, "0"))
    End Function

    Public Function IntToStr(ByVal v As Integer) As String
        Return CStr(v)
    End Function

    Public Function DblToStr(ByVal v As Double) As String
        Return v.ToString
    End Function

    Public Function BoolToStr(ByVal v As Boolean) As String
        Return v.ToString
    End Function


#End Region

#Region "Type to Database"

    Public Function BoolToDB(ByVal v As Boolean) As Integer
        If v Then Return 1 Else Return 0
    End Function


    Public Function DateToDB(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2}", (v.Year & "").PadLeft(4, "0"), (v.Month & "").PadLeft(2, "0"), (v.Day & "").PadLeft(2, "0"))
    End Function

    Public Function StrToDB(ByVal v As String) As String
        If v Is Nothing Then Return "" Else Return v.Replace("'", "''")
    End Function


    Public Function DblToDB(ByVal v As Double) As String
        Return v.ToString().Replace(",", ".")
    End Function


#End Region

#Region "String To Type"

    Public Function StrToDbl(ByVal v As String) As Double
        Try
            Dim i As Double = Double.Parse(v)
            Return i
        Catch ex As Exception
            Debug.WriteLine("StrToDbl Exception = " & v)
            Return 0.0
        End Try
    End Function



    Public Function StrToInt(ByVal v As String) As Integer
        Try
            Dim i As Integer = Integer.Parse(v)
            Return i
        Catch ex As Exception
            Return 0
        End Try
    End Function


    Public Function StrToDate(ByVal v As String) As Date
        Try
            Dim d As Date = Date.Parse(v)
            Return d
        Catch ex As Exception
            Return Date.Parse("0001-01-01")
        End Try
    End Function


    Public Function StrToBool(ByVal v As String) As Boolean
        v = v.ToLower
        Return v = "1" OrElse v = "yes" OrElse v = "true"
    End Function


#End Region

#Region "Other functions"

    Public Function GetImageIndex(ByVal level As String) As Integer
        If level = "F" Then
            Return 1
        End If
        If level = "SF" Then
            Return 2
        End If
        If level = "SSF" Then
            Return 3
        End If
        If level = "SC" Then
            Return 4
        End If
        If level = "SSC" Then
            Return 5
        End If
        If level = "SSSC" Then
            Return 6
        End If
        If level = "SR" Then
            Return 7
        End If
        If level = "SSR" Then
            Return 8
        End If
        If level = "SSSR" Then
            Return 9
        End If
        If level = "UI" Then
            Return 10
        End If
        If level = "DC" Then
            Return 11
        End If
        If level = "D" Then
            Return 12
        End If
    End Function

    Public Function GetFormTitle(ByVal Title As String) As String
        Return GetStandardFormTitle() & " " & Title
    End Function

    Private Function GetStandardFormTitle() As String
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Return String.Format(CStr(configurationAppSettings.GetValue("Application.FullName", GetType(System.String))), CStr(configurationAppSettings.GetValue("Application.Version", GetType(System.String))))
    End Function

    Public Function ICollectionToCollection(ByVal col As ICollection) As Collection
        Dim Result As New Collection

        Dim e As IEnumerator = col.GetEnumerator
        While e.MoveNext
            Result.Add(e.Current)
        End While
        Return Result
    End Function

    Public Function SortICollection(ByVal col As ICollection, ByVal SortPropertyName As String, Optional ByVal Ascending As Boolean = True) As ICollection
        Return SortCollection(ICollectionToCollection(col), SortPropertyName, Ascending)
    End Function

    Public Function SortCollection(ByVal col As Collection, ByVal psSortPropertyName As String, Optional ByVal pbAscending As Boolean = True, Optional ByVal psKeyPropertyName As String = "") As Collection

        ' The Objects were originally declared as Variants. VB.Net has 
        'eliminated the
        ' Variant type so they must be declared as type Object. 
        'Also Objects cannot be
        'used with the Set keyword, so I had to remove the set 
        'keyword. Other than that
        'I did not have to make hardly any changes.

        Dim obj As Object
        Dim i As Integer
        Dim j As Integer
        Dim iMinMaxIndex As Integer
        Dim vMinMax As Object
        Dim vValue As Object
        Dim bSortCondition As Boolean
        Dim bUseKey As Boolean
        Dim sKey As String

        bUseKey = (psKeyPropertyName <> "")

        For i = 1 To col.Count - 1
            obj = col(i)
            ' the vbGet can be replaced with a 
            'CallType.Get if you
            ' want. See VB Language reference for CallByName

            vMinMax = CallByName(obj, psSortPropertyName, vbGet)
            iMinMaxIndex = i

            For j = i + 1 To col.Count
                obj = col(j)
                vValue = CallByName(obj, _
                    psSortPropertyName, vbGet)

                If (pbAscending) Then
                    bSortCondition = (vValue < vMinMax)
                Else
                    bSortCondition = (vValue > vMinMax)
                End If

                If (bSortCondition) Then
                    vMinMax = vValue
                    iMinMaxIndex = j
                End If

                obj = Nothing
            Next j

            If (iMinMaxIndex <> i) Then
                obj = col(iMinMaxIndex)

                col.Remove(iMinMaxIndex)
                If (bUseKey) Then
                    sKey = CStr(CallByName(obj, _
                       psKeyPropertyName, vbGet))
                    col.Add(obj, sKey, i)
                Else
                    col.Add(obj, , i)
                End If

                obj = Nothing
            End If

            obj = Nothing
        Next i
        Return col
    End Function

    Public Function ReadBinaryFile(ByVal FileName As String) As Byte()
        Try
            Dim FileStream As New FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read)
            Dim BinaryReader As New BinaryReader(FileStream)
            Dim Ret() As Byte = BinaryReader.ReadBytes(FileStream.Length)
            FileStream.Close()
            BinaryReader.Close()

            Return Ret
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Function

#End Region

#Region "XML Functions"

    Function CreateTag(ByVal Name As String, ByVal Value As String)
        Return String.Format("<{0}>{1}</{0}>", Name, Value)
    End Function

    Function CreateTag(ByVal Name As String, ByVal Value As String, ByVal Attributes As String)
        Return String.Format("<{0} {2}>{1}</{0}>", Name, Value, Attributes)
    End Function

    Function CreateTag(ByVal Name As String, ByVal Value As String, ByVal Attributes As String())
        Return String.Format("<{0} {2}>{1}</{0}>", Name, Value, String.Join(" ", Attributes))
    End Function


#End Region

#Region "Text Files"

    Public Function ReadTextFile(ByVal filename As String) As String
        Try
            ' Create an instance of StreamReader to read from a file.
            Dim sr As StreamReader = New StreamReader(filename, System.Text.Encoding.Default)
            Dim str As String = sr.ReadToEnd
            sr.Close()
            Return str
        Catch E As Exception
            Debug.WriteLine(E.Message & ControlChars.NewLine & E.StackTrace)
            Return ""
        End Try
    End Function


#End Region

End Module
