
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Xml
Imports System.IO
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Utility

Public Class ProgramState
    Private myConfigXml As XmlDocument

    Public Enum StorageForm
        Database
        FileSystem
        ObjectVault
    End Enum

    Public Enum DisseminationDimension
        Resolution
        Width
        Height
    End Enum

    Private STATECONFIG_FILENAME As String = Application.UserAppDataPath & "\" & "MPOD.config"

    Public Sub New()
        myConfigXml = New XmlDocument
        If Not File.Exists(STATECONFIG_FILENAME) Then
            myConfigXml.LoadXml("<?xml version='1.0' encoding='utf-8'?><configuration><appSettings></appSettings></configuration>")
        Else
            myConfigXml.Load(STATECONFIG_FILENAME)
        End If
    End Sub

    Property LastFondsSearched() As String
        Get
            Return GetConfigValue("LastFondsSearched")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastFondsSearched", Value)
        End Set
    End Property


    Property LastUsedNode() As Integer
        Get
            Return StrToInt(GetConfigValue("LastUsedNode"))
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("LastUsedNode", Value)
        End Set
    End Property


    Property LastOpenedFonds() As Integer
        Get
            Return StrToInt(GetConfigValue("LastOpenedFonds"))
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("LastOpenedFonds", Value)
        End Set
    End Property


    Property LastLoginUsername() As String
        Get
            Return GetConfigValue("LastLoginUsername")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastLoginUsername", Value)
        End Set
    End Property


    Property LastResponsabilityEntity() As String
        Get
            Return GetConfigValue("LastResponsabilityEntity")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastResponsabilityEntity", Value)
        End Set
    End Property


    Property LastCaptureEntityCorporate() As String
        Get
            Return GetConfigValue("LastCaptureEntityCorporate")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastCaptureEntityCorporate", Value)
        End Set
    End Property


    Property LastCaptureEntityIndividual() As String
        Get
            Return GetConfigValue("LastCaptureEntityIndividual")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastCaptureEntityIndividual", Value)
        End Set
    End Property


    Property LastTopographicalQuota() As String
        Get
            Return GetConfigValue("LastTopographicalQuota")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastTopographicalQuota", Value)
        End Set
    End Property


    Property LastArchiveID() As String
        Get
            Return GetConfigValue("LastArchiveID")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("LastArchiveID", Value)
        End Set
    End Property

    Property AskBeforeSave() As Integer
        Get
            Return GetConfigValue("AskBeforeSave")
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("AskBeforeSave", Value)
        End Set
    End Property

    Property MetadataPanelVisible() As Integer
        Get
            Return GetConfigValue("MetadataPanelVisible")
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("MetadataPanelVisible", Value)
        End Set
    End Property

    Property FileView() As DOFile.Type
        Get
            Return GetConfigValue("FileView")
        End Get
        Set(ByVal Value As DOFile.Type)
            SetConfigValue("FileView", Value)
        End Set
    End Property

    Property LastNumberOfProjectsShowed() As Integer
        Get
            Return GetConfigValue("LastNumberOfProjectsShowed")
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("LastNumberOfProjectsShowed", Value)
        End Set
    End Property

    Property NumberOfProjectsChecked() As Boolean
        Get
            Return DBToBool(GetConfigValue("NumberOfProjectsChecked"))
        End Get
        Set(ByVal Value As Boolean)
            SetConfigValue("NumberOfProjectsChecked", Value)
        End Set
    End Property


    Property LastDerivativeQuality() As String
        Get
            Return GetConfigValue("DerivativeQuality")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("DerivativeQuality", Value)
        End Set
    End Property

    Property OriginalStorage() As StorageForm
        Get
            Return GetConfigValue("OriginalStorage")
        End Get
        Set(ByVal Value As StorageForm)
            SetConfigValue("OriginalStorage", Value)
        End Set
    End Property

    Property DisseminationStorage() As StorageForm
        Get
            Return GetConfigValue("DisseminationStorage")
        End Get
        Set(ByVal Value As StorageForm)
            SetConfigValue("DisseminationStorage", Value)
        End Set
    End Property

    Property GeneDissemination() As Integer
        Get
            Return GetConfigValue("GeneDissemination")
        End Get
        Set(ByVal Value As Integer)
            SetConfigValue("GeneDissemination", Value)
        End Set
    End Property

    Property DisseminationDim() As DisseminationDimension
        Get
            Return GetConfigValue("DisseminationDim")
        End Get
        Set(ByVal Value As DisseminationDimension)
            SetConfigValue("DisseminationDim", Value)
        End Set
    End Property

    Property DisseminationResolution() As String
        Get
            Return GetConfigValue("DisseminationResolution")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("DisseminationResolution", Value)
        End Set
    End Property

    Property DisseminationHeight() As String
        Get
            Return GetConfigValue("DisseminationHeight")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("DisseminationHeight", Value)
        End Set
    End Property

    Property DisseminationWidth() As String
        Get
            Return GetConfigValue("DisseminationWidth")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("DisseminationWidth", Value)
        End Set
    End Property

    Property DisseminationQuality() As String
        Get
            Return GetConfigValue("DisseminationQuality")
        End Get
        Set(ByVal Value As String)
            SetConfigValue("DisseminationQuality", Value)
        End Set
    End Property

    Public Function GetConfig(ByVal ConfigProperty As String) As String
        Return GetConfigValue(ConfigProperty)
    End Function

    Public Function SetConfig(ByVal ConfigProperty As String, ByVal Value As String) As String
        SetConfigValue(ConfigProperty, Value)
    End Function

    Public Sub Save()
        myConfigXml.Save(STATECONFIG_FILENAME)
    End Sub

    Private Function GetConfigValue(ByVal NodeName As String) As String
        Dim Node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/appSettings/{0}", NodeName))
        If Not Node Is Nothing Then
            Return Node.InnerText
        Else
            Return Nothing
        End If
    End Function


    Private Sub SetConfigValue(ByVal NodeName As String, ByVal Value As String)
        Dim Node As XmlNode = myConfigXml.SelectSingleNode(String.Format("/configuration/appSettings/{0}", NodeName))
        If Not Node Is Nothing Then
            Node.InnerText = Value
        Else
            Node = myConfigXml.SelectSingleNode("/configuration/appSettings")
            Dim NewNode As XmlNode = myConfigXml.CreateNode(XmlNodeType.Element, NodeName, "")
            NewNode.InnerText = Value
            Node.AppendChild(NewNode)
        End If
    End Sub

End Class
