
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Configuration
Imports System.Threading
Imports DigitArq.Data.Entities
Imports DigitArq.UserControls.Authentication
Imports DigitArq.UserControls.ErrorHandling
Imports DigitArq.Core.Logging
Imports DigitArq.Definitions.MPOD
Imports DigitArq.Utility

Module Main

    Private auth As New MGUP.SQLDataBase
    Private SQLCommands As New MGOD.SqlCommands(USER_LOGON)

    Sub Main(ByVal CmdArgs() As String)

        AddHandler Application.ThreadException, AddressOf ThreadExceptionHandler

        Dim frmSplash As New SplashScreenForm(ConfigurationSettings.AppSettings("Application.Code"))
        frmSplash.Show()

        If frmSplash.CheckPrerequisites() Then
            frmSplash.TopMost = False

            Dim authresult As MGUP.SQLDataBase.eReturn = auth.validateEmployee(ConfigurationSettings.AppSettings("Application.Code"), ADMIN_USERNAME, ADMIN_PASSWORD)
            Dim count As Integer = auth.countEmployees
            If count = 1 AndAlso authresult = MGUP.SQLInterface.eReturn.Sucess Then
                USER_LOGON = ADMIN_USERNAME
                Logger.Append(USER_LOGON, Logger.LogInOut, String.Format(LogMessage("Log.Login"), USER_LOGON, Date.Now.ToString))
                Dim frmMain As New AssociationForm
                frmSplash.Close()
                frmSplash.Dispose()
                Try
                    Application.Run(frmMain)
                Catch ex As Exception
                    MsgBoxException(ex)
                End Try
            Else
                Dim frmLogin As New LoginForm(ConfigurationSettings.AppSettings("Application.Code"))
                If frmLogin.ShowDialog() = DialogResult.OK Then
                    USER_LOGON = frmLogin.Username
                    Logger.Append(USER_LOGON, Logger.LogInOut, String.Format(LogMessage("Log.Login"), USER_LOGON, Date.Now.ToString))
                    Dim frmMain As New AssociationForm
                    frmLogin.Dispose()
                    frmSplash.Close()
                    frmSplash.Dispose()
                    Try
                        Application.Run(frmMain)
                    Catch ex As Exception
                        MsgBoxException(ex)
                    End Try
                End If
            End If
        Else
            frmSplash.Hide()
            frmSplash.ShowDialog()
        End If
    End Sub

    Private Sub ThreadExceptionHandler(ByVal sender As Object, ByVal e As System.Threading.ThreadExceptionEventArgs)
        MsgBoxException(e.Exception)
        Application.Exit()
    End Sub

End Module
