
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MDA

    Public Class EacIdentity
        Inherits CollectionBase

        Public Shared AuthoritiesAlternativeName As String = "Nome paralelo"
        Public Shared AuthoritiesOtherFormName As String = "Outra forma de nome"



        Public Function Add(ByVal Part As String, ByVal UseDate As String, ByVal Type As String) As Integer
            Return List.Add(New EacIdentityItem(Part, UseDate, Type))
        End Function


        Public Function Add(ByVal ID As Integer, ByVal Part As String, ByVal UseDate As String, ByVal Type As String) As Integer
            Return List.Add(New EacIdentityItem(ID, Part, UseDate, Type))
        End Function


        Public Sub Remove(ByVal Item As EacIdentityItem)
            List.Remove(Item)
        End Sub

        Public Function Item(ByVal index As Integer) As EacIdentityItem
            Return List.Item(index)
        End Function

        Private Function TypeToEac(ByVal Type As String) As String
            ' changed by mferreira. This should be in a properties file
            'Case VisualFieldLabel("Authorities.AlternativeName") : Return "alternative"
            'Case VisualFieldLabel("Authorities.OtherFormName") : Return "otherform"

            Select Case Type
                Case AuthoritiesAlternativeName : Return "alternative"
                Case AuthoritiesOtherFormName : Return "otherform"
                Case Else : Return ""
            End Select
        End Function



        Public Function toXml(ByVal TypePrefix As String) As String
            If Count = 0 Then Return ""

            Dim xml As String = ""
            For i As Integer = 0 To Count - 1
                xml &= String.Format("<{2}head><part type='{3}'>{0}</part><usedate>{1}</usedate></{2}head>", Item(i).Part, Item(i).UseDate, TypePrefix, TypeToEac(Item(i).Type))
            Next
            Return xml
        End Function

    End Class



    Public Class EacIdentityItem
        Private myID As Integer
        Private myUseDate As String
        Private myPart As String
        Private myType As String


        Public Sub New(ByVal Part As String, ByVal UseDate As String, ByVal Type As String)
            myUseDate = UseDate
            myPart = Part
            myType = Type
            myID = 0
        End Sub

        Public Sub New(ByVal ID As Integer, ByVal Part As String, ByVal UseDate As String, ByVal Type As String)
            myUseDate = UseDate
            myPart = Part
            myType = Type
            myID = ID
        End Sub


        Public Sub New(ByVal ID As Integer)
            myID = ID
        End Sub

        Property Type() As String
            Get
                Return myType
            End Get
            Set(ByVal Value As String)
                myType = Value
            End Set
        End Property


        Property UseDate() As String
            Get
                Return myUseDate
            End Get
            Set(ByVal Value As String)
                myUseDate = Value
            End Set
        End Property

        Property Part() As String
            Get
                Return myPart
            End Get
            Set(ByVal Value As String)
                myPart = Value
            End Set
        End Property

        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property


        Public Function Clone() As Object
            Return New EacIdentityItem(myID, myPart, myUseDate, myType)
        End Function


        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
            If Not TypeOf obj Is EacIdentityItem Then
                Return False
            Else
                Return ID = CType(obj, EacIdentityItem).ID
            End If
        End Function

    End Class
End Namespace
