
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Namespace MDA

    Public Class EacResourceRelationships
        Inherits CollectionBase


        Public Shared AuthoritiesOther As String = "Outra"
        Public Shared AuthoritiesBibliographic As String = "Biblioteca"
        Public Shared AuthoritiesMuseologic As String = "Museu"


        Public Function Add(ByVal Type As String, ByVal Unit As String, ByVal DateStr As String, ByVal ResourceType As String) As Integer
            Return List.Add(New EacResourceRelationshipsItem(Type, Unit, DateStr, ResourceType))
        End Function


        Public Function Add(ByVal ID As Integer, ByVal Type As String, ByVal Unit As String, ByVal DateStr As String, ByVal ResourceType As String) As Integer
            Return List.Add(New EacResourceRelationshipsItem(ID, Type, Unit, DateStr, ResourceType))
        End Function


        Public Sub Remove(ByVal Item As EacResourceRelationshipsItem)
            List.Remove(Item)
        End Sub

        Public Function Item(ByVal index As Integer) As EacResourceRelationshipsItem
            Return List.Item(index)
        End Function

        Private Function TypeToEac(ByVal Type As String) As String
            'Case VisualFieldLabel("Authorities.Other") : Return "other"
            Select Case Type
                Case AuthoritiesOther : Return "other"
                Case Else : Return ""
            End Select
        End Function

        Public Function toXml() As String
            If Count = 0 Then Return ""

            Dim xml As String = ""
            For i As Integer = 0 To Count - 1
                xml &= String.Format("<resourcerel reltype='{0}'><{3}unit>{1}</{3}unit><date>{2}</date></resourcerel>", TypeToEac(Item(i).Type), Item(i).Unit, Item(i).DateStr, UnitPrefix(Item(i).ResourceType))
            Next
            Return xml
        End Function

        Private Function UnitPrefix(ByVal ResourceType As String)
            'Case (VisualFieldLabel("Authorities.Bibliographic")) : Return "bib"
            'Case (VisualFieldLabel("Authorities.Museologic")) : Return "mus"

            Select Case ResourceType
                Case AuthoritiesBibliographic : Return "bib"
                Case AuthoritiesMuseologic : Return "mus"
                Case Else : Return ""
            End Select
        End Function



    End Class



    Public Class EacResourceRelationshipsItem
        Private myID As Integer
        Private myType As String
        Private myUnit As String
        Private myDate As String
        Private myResourceType As String


        Public Sub New(ByVal Type As String, ByVal Unit As String, ByVal DateStr As String, ByVal ResourceType As String)
            myID = 0
            myType = Type
            myUnit = Unit
            myDate = DateStr
            myResourceType = ResourceType
        End Sub

        Public Sub New(ByVal ID As Integer, ByVal Type As String, ByVal Unit As String, ByVal DateStr As String, ByVal ResourceType As String)
            myID = ID
            myType = Type
            myUnit = Unit
            myDate = DateStr
            myResourceType = ResourceType
        End Sub


        Public Sub New(ByVal ID As Integer)
            myID = ID
        End Sub



        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
            If Not TypeOf obj Is EacResourceRelationshipsItem Then
                Return False
            Else
                Return ID = CType(obj, EacResourceRelationshipsItem).ID
            End If
        End Function

        Property ResourceType() As String
            Get
                Return myResourceType
            End Get
            Set(ByVal Value As String)
                myResourceType = Value
            End Set
        End Property


        Property Type() As String
            Get
                Return myType
            End Get
            Set(ByVal Value As String)
                myType = Value
            End Set
        End Property


        Property Unit() As String
            Get
                Return myUnit
            End Get
            Set(ByVal Value As String)
                myUnit = Value
            End Set
        End Property


        Property DateStr() As String
            Get
                Return myDate
            End Get
            Set(ByVal Value As String)
                myDate = Value
            End Set
        End Property


        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property


        Public Function Clone() As Object
            Return New EacResourceRelationshipsItem(myID, myType, myUnit, myDate, myResourceType)
        End Function




    End Class

End Namespace
