
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System
Imports System.Collections

Namespace MDA

    Public Class Bibliography
        Inherits CollectionBase


        Default Public Property Item(ByVal index As Integer) As BibRefItem
            Get
                Return CType(List(index), BibRefItem)
            End Get
            Set(ByVal Value As BibRefItem)
                List(index) = Value
            End Set
        End Property


        Public Function Add(ByVal ID As Integer, ByVal BibRef As String) As Integer
            Return List.Add(New BibRefItem(ID, BibRef))
        End Function 'Add


        Public Function Add(ByVal BibRef As String) As Integer
            Return List.Add(New BibRefItem(BibRef))
        End Function 'Add

        Public Function IndexOf(ByVal value As BibRefItem) As Integer
            Return List.IndexOf(value)
        End Function 'IndexOf


        Public Sub Insert(ByVal index As Integer, ByVal value As BibRefItem)
            List.Insert(index, value)
        End Sub 'Insert


        Public Sub Remove(ByVal value As BibRefItem)
            List.Remove(value)
        End Sub 'Remove


        Public Function Contains(ByVal value As BibRefItem) As Boolean
            Return List.Contains(value)
        End Function 'Contains


        Public Overrides Function ToString() As String
            Dim BibRef As BibRefItem
            Dim Ret As String = ""
            For Each BibRef In MyBase.List
                Ret = BibRef.ToString & Chr(13)
            Next
            If Ret.Length > 2 Then Ret = Ret.Remove(Ret.Length - 2, 1)
            Return Ret
        End Function

    End Class





    Public Class BibRefItem
        Private myID As Integer
        Private myBibRef As String


        Public Sub New(ByVal BibRef As String)
            myBibRef = BibRef
            myID = 0
        End Sub

        Public Sub New(ByVal ID As Integer, ByVal BibRef As String)
            myBibRef = BibRef
            myID = ID
        End Sub

        Property BibRef() As String
            Get
                Return myBibRef
            End Get
            Set(ByVal Value As String)
                myBibRef = Value
            End Set
        End Property


        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property

        Public Function Clone() As Object
            Return New BibRefItem(myID, myBibRef)
        End Function

        Public Overrides Function ToString() As String
            Return myBibRef
        End Function



    End Class
End Namespace
