Imports DigitArq.Utility
Imports DigitArq.Data.Entities.MGOD

Namespace MDA

    Public Class DigitalAcquisitionProject

        Dim myProject As MGOD.Project
        Private myDigitalObjects As Collection



        Public Sub New(ByVal Name As String, ByVal Username As String)
            myProject = New MGOD.Project
            myDigitalObjects = New Collection

            myProject.Name = DBToStr(Name)
            myProject.Username = DBToStr(Username)
            myProject.CreationDateTime = DateToStr(Date.Today)
            myProject.LastUpdateDateTime = DateToStr(Date.Today)
        End Sub



        Public Sub Add(ByVal DigitalObject As MDA.DigitalObject)
            If Not DigitalObject Is Nothing Then myDigitalObjects.Add(DigitalObject)
        End Sub



        ' Saves everything to the Database using Ferros methods
        Public Sub Upload()

            ' don't save if there are no objects
            If myDigitalObjects.Count = 0 Then Exit Sub

            Dim MGODDataLayer As New SqlCommands(myProject.Username)
            Dim ProjectID As Long = MGODDataLayer.InsertProject(myProject)


            For Each DigitalObject As MDA.DigitalObject In myDigitalObjects
                If Not DigitalObject Is Nothing Then

                    Dim SQLDigitalObject As New MGOD.DigitalObject
                    SQLDigitalObject.CreationDateTime = DateToDB(Now)
                    SQLDigitalObject.ArchiveDateTime = DateToDB(Now)
                    SQLDigitalObject.RevisionDateTime = DateToDB(Now.AddYears(5))
                    SQLDigitalObject.ProjectID = ProjectID
                    SQLDigitalObject.UserName = myProject.Username
                    SQLDigitalObject.Name = DigitalObject.Name

                    ' Insert OD
                    Dim DigitalObjectID As Long = MGODDataLayer.InsertDigitalObject(SQLDigitalObject)
                    For Each DOFile As DOFile In DigitalObject.Files
                        DOFile.UserName = SQLDigitalObject.UserName
                        DOFile.DigitalObjectID = DigitalObjectID

                        ' Insert File
                        DOFile.ID = MGODDataLayer.InsertFile(DOFile)

                        ' Insert Properties
                        MGODDataLayer.InsertProperties(DOFile.ID, DOFile.Properties)
                    Next

                    MGODDataLayer.UpdateDOStructure(DigitalObjectID, DigitalObject.DOStructure)
                    MGODDataLayer.InsertDaoGrp(DigitalObject.ComponentID, DigitalObjectID)
                End If
            Next
        End Sub

    End Class


End Namespace
