Namespace MDA

    Public Class DigitalObject

        Private myFiles As Collection
        Private myName As String
        Private myComponentID As Long


        Public Sub New(ByVal Name As String)

            Me.Name = Name
            myFiles = New Collection
        End Sub


        Public Sub Add(ByVal File As DOFile)
            myFiles.Add(File)
        End Sub



        Property Name() As String
            Get
                Return myName
            End Get
            Set(ByVal Value As String)
                myName = Value.Replace("/", "-")
            End Set
        End Property


        ReadOnly Property Files() As Collection
            Get
                Return myFiles
            End Get
        End Property

        Property ComponentID() As Long
            Get
                Return myComponentID
            End Get
            Set(ByVal Value As Long)
                myComponentID = Value
            End Set
        End Property


        ReadOnly Property DOStructure() As String
            Get
                Dim RootNode As String = "<TREENODES>{0}</TREENODES>"
                Dim Body As String = "<treenode Text='{0}' Type='{1}'>{2}</treenode>"
                Dim FileNodeTemplate As String = "<treenode Text='{0}' Type='{1}' ID='{2}'></treenode>"

                'Dim FileNodes As String = ""
                Dim FileNodes As New System.Text.StringBuilder

                For Each DOFile As DOFile In Files
                    'FileNodes &= String.Format(FileNodeTemplate, DOFile.Name, 5, DOFile.ID)
                    FileNodes.Append(String.Format(FileNodeTemplate, DOFile.Name, 5, DOFile.ID))
                Next
                Return String.Format(RootNode, String.Format(Body, Name, 1, FileNodes.ToString))
            End Get
        End Property


    End Class

End Namespace
