
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System
Imports System.Collections

Namespace MGOD

    Public Class Components

        Private myID As Int64
        Private myParentID As Int64
        Private myOtherLevel As String
        Private myUnitID As String
        Private myCompleteUnitID As String
        Private myUnitTitle As String
        Private myHasChildren As Boolean
        Private myAssociated As Boolean


#Region "Constructors"

        Public Sub New(ByVal ID As Int64, ByVal CompleteUnitID As String, ByVal OtherLevel As String)
            myID = ID
            myCompleteUnitID = CompleteUnitID
            myOtherLevel = OtherLevel
        End Sub

        Public Sub New(ByVal ID As Int64, ByVal UnitID As String, ByVal UnitTitle As String, ByVal OtherLevel As String)
            myID = ID
            myUnitID = UnitID
            myUnitTitle = UnitTitle
            myOtherLevel = OtherLevel
        End Sub

        Public Sub New(ByVal ID As Int64, ByVal ParentID As Int64, ByVal OtherLevel As String, _
            ByVal UnitID As String, ByVal UnitTitle As String, ByVal HasChildren As Boolean)
            myID = ID
            myParentID = ParentID
            myOtherLevel = OtherLevel
            myUnitID = UnitID
            myUnitTitle = UnitTitle
            myHasChildren = HasChildren
        End Sub

#End Region


#Region "Properties"

        Property ID() As Int64
            Get
                Return myID
            End Get
            Set(ByVal Value As Int64)
                myID = Value
            End Set
        End Property

        Property ParentID() As Int64
            Get
                Return myParentID
            End Get
            Set(ByVal Value As Int64)
                myParentID = Value
            End Set
        End Property

        Property OtherLevel() As String
            Get
                Return myOtherLevel
            End Get
            Set(ByVal Value As String)
                myOtherLevel = Value
            End Set
        End Property

        Property UnitID() As String
            Get
                Return myUnitID
            End Get
            Set(ByVal Value As String)
                myUnitID = Value
            End Set
        End Property

        Property CompleteUnitID() As String
            Get
                Return myCompleteUnitID
            End Get
            Set(ByVal Value As String)
                myCompleteUnitID = Value
            End Set
        End Property

        Property UnitTitle() As String
            Get
                Return myUnitTitle
            End Get
            Set(ByVal Value As String)
                myUnitTitle = Value
            End Set
        End Property

        Property HasChildren() As Boolean
            Get
                Return myHasChildren
            End Get
            Set(ByVal Value As Boolean)
                myHasChildren = Value
            End Set
        End Property

        Property Associated() As Boolean
            Get
                Return myAssociated
            End Get
            Set(ByVal Value As Boolean)
                myAssociated = Value
            End Set
        End Property

#End Region

    End Class

    Public Class ComponentCollection
        Inherits CollectionBase

        Default Public Property Item(ByVal index As Integer) As Components
            Get
                Return CType(List(index), Components)
            End Get
            Set(ByVal Value As Components)
                List(index) = Value
            End Set
        End Property

        Public Function Add(ByVal value As Components) As Integer
            Return List.Add(value)
        End Function

        Public Function IndexOf(ByVal value As Components) As Integer
            Return List.IndexOf(value)
        End Function

        Public Sub Insert(ByVal index As Integer, ByVal value As Components)
            List.Insert(index, value)
        End Sub

        Public Sub Remove(ByVal value As Components)
            List.Remove(value)
        End Sub

        Public Function Contains(ByVal value As Components) As Boolean
            Return List.Contains(value)
        End Function

    End Class
End Namespace
