
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.IO
Imports DigitArq.Utility
Imports DigitArq.Utility.Cryptography

Namespace MGOD

    Public Class DOFile

        Private myID As Int64
        Private myName As String
        Private myLength As String
        Private myFormat As String
        Private myMD5 As String
        Private myCreationDatetime As String
        Private myHasDissemination As Boolean
        Private myOriginalURL As String
        Private myDisseminationURL As String
        Private myThumbnailURL As String
        Private myOriginalFile As Byte()
        Private myDisseminationFile As Byte()
        Private myThumbnailFile As Byte()
        Private myOriginalFileStream As FileStream
        Private myDisseminationFileStream As FileStream
        Private myThumbnailFileStream As FileStream
        Private myDigitalObjectID As Int64
        Private myUserName As String

        Public Enum Type
            Original
            Dissemination
            Thumbnail
        End Enum

#Region "Constructors"

        Public Sub New()
        End Sub

        Public Sub New(ByVal Name As String, ByVal Length As String, _
            ByVal Format As String, ByVal OriginalURL As String, _
            ByVal DigitalObjectID As Int64, ByVal Username As String)

        End Sub

        Public Sub New(ByVal FilePath As String, ByVal DigitalObjectID As String, ByVal User As String)
            Me.Name = Path.GetFileName(FilePath)
            Me.Format = FilePath.Substring(FilePath.LastIndexOf(".") + 1).ToUpper()
            Me.Length = CStr(Math.Round(FileLen(FilePath)))
            Me.MD5 = GenerateHashFromFile(FilePath)
            Me.CreationDateTime = CompleteDateToDB(Now)
            Me.DigitalObjectID = DigitalObjectID
            Me.UserName = User
        End Sub

#End Region

#Region "Properties"

        Property ID() As Int64
            Get
                Return myID
            End Get
            Set(ByVal Value As Int64)
                myID = Value
            End Set
        End Property

        Property Name() As String
            Get
                Return myName
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property

        Property Length() As String
            Get
                Return myLength
            End Get
            Set(ByVal Value As String)
                myLength = Value
            End Set
        End Property

        Property Format() As String
            Get
                Return myFormat
            End Get
            Set(ByVal Value As String)
                myFormat = Value
            End Set
        End Property

        Property MD5() As String
            Get
                Return myMD5
            End Get
            Set(ByVal Value As String)
                myMD5 = Value
            End Set
        End Property

        Property CreationDateTime() As String
            Get
                Return myCreationDatetime
            End Get
            Set(ByVal Value As String)
                myCreationDatetime = Value
            End Set
        End Property

        Property HasDissemination() As Boolean
            Get
                Return myHasDissemination
            End Get
            Set(ByVal Value As Boolean)
                myHasDissemination = Value
            End Set
        End Property

        Property OriginalURL() As String
            Get
                Return myOriginalURL
            End Get
            Set(ByVal Value As String)
                myOriginalURL = Value
            End Set
        End Property

        Property DisseminationURL() As String
            Get
                Return myDisseminationURL
            End Get
            Set(ByVal Value As String)
                myDisseminationURL = Value
            End Set
        End Property

        Property ThumbnailURL() As String
            Get
                Return myThumbnailURL
            End Get
            Set(ByVal Value As String)
                myThumbnailURL = Value
            End Set
        End Property

        Property OriginalFile() As Byte()
            Get
                Return myOriginalFile
            End Get
            Set(ByVal Value As Byte())
                myOriginalFile = Value
            End Set
        End Property

        Property DisseminationFile() As Byte()
            Get
                Return myDisseminationFile
            End Get
            Set(ByVal Value As Byte())
                myDisseminationFile = Value
            End Set
        End Property

        Property ThumbnailFile() As Byte()
            Get
                Return myThumbnailFile
            End Get
            Set(ByVal Value As Byte())
                myThumbnailFile = Value
            End Set
        End Property

        Property OriginalFileStream() As FileStream
            Get
                Return myOriginalFileStream
            End Get
            Set(ByVal Value As FileStream)
                myOriginalFileStream = Value
            End Set
        End Property

        Property DisseminationFileStream() As FileStream
            Get
                Return myDisseminationFileStream
            End Get
            Set(ByVal Value As FileStream)
                myDisseminationFileStream = Value
            End Set
        End Property

        Property ThumbnailFileStream() As FileStream
            Get
                Return myThumbnailFileStream
            End Get
            Set(ByVal Value As FileStream)
                myThumbnailFileStream = Value
            End Set
        End Property

        Property DigitalObjectID() As Int64
            Get
                Return myDigitalObjectID
            End Get
            Set(ByVal Value As Int64)
                myDigitalObjectID = Value
            End Set
        End Property

        Property UserName() As String
            Get
                Return myUserName
            End Get
            Set(ByVal Value As String)
                myUserName = Value
            End Set
        End Property

#End Region

    End Class

Public Class DOFileCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As DOFile
        Get
            Return CType(List(index), DOFile)
        End Get
        Set(ByVal Value As DOFile)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal DOFile As DOFile) As Integer
        Return List.Add(DOFile)
    End Function

    Public Function IndexOf(ByVal value As DOFile) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As DOFile)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As DOFile)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As DOFile) As Boolean
        Return List.Contains(value)
    End Function

End Class

End Namespace