Namespace MGOD

    Public Class DaoGrp

        Private myComponentID As Int64
        Private myDigitalObjectID As Int64
        Private myFileID As Int64
        Private myType As AssociationType
        Private myParentFondsID As Int64
        Private myCompleteUnitID As String
        Private myUnitTitle As String
        Private myOtherLevel As String
        Private myProjectName As String
        Private myDigitalObjectName As String
        Private myFileName As String

        Public Enum AssociationType
            DigitalObject
            DOFile
        End Enum


        Public Sub New(ByVal ComponentID As Int64, ByVal DigitalObjectID As Int64, ByVal FileID As Int64, Optional ByVal Type As AssociationType = AssociationType.DigitalObject)
            myComponentID = ComponentID
            myDigitalObjectID = DigitalObjectID
            myFileID = FileID
            myType = Type
        End Sub

        Property ComponentID() As Int64
            Get
                Return myComponentID
            End Get
            Set(ByVal Value As Int64)
                myComponentID = Value
            End Set
        End Property

        Property DigitalObjectID() As Int64
            Get
                Return myDigitalObjectID
            End Get
            Set(ByVal Value As Int64)
                myDigitalObjectID = Value
            End Set
        End Property

        Property FileID() As Int64
            Get
                Return myFileID
            End Get
            Set(ByVal Value As Int64)
                myFileID = Value
            End Set
        End Property

        Property Type() As AssociationType
            Get
                Return myType
            End Get
            Set(ByVal Value As AssociationType)
                myType = Value
            End Set
        End Property

        Property ParentFondsID() As Int64
            Get
                Return myParentFondsID
            End Get
            Set(ByVal Value As Int64)
                myParentFondsID = Value
            End Set
        End Property

        Property CompleteUnitID() As String
            Get
                Return myCompleteUnitID
            End Get
            Set(ByVal Value As String)
                myCompleteUnitID = Value
            End Set
        End Property

        Property UnitTitle() As String
            Get
                Return myUnitTitle
            End Get
            Set(ByVal Value As String)
                myUnitTitle = Value
            End Set
        End Property

        Property OtherLevel() As String
            Get
                Return myOtherLevel
            End Get
            Set(ByVal Value As String)
                myOtherLevel = Value
            End Set
        End Property

        Property ProjectName() As String
            Get
                Return myProjectName
            End Get
            Set(ByVal Value As String)
                myProjectName = Value
            End Set
        End Property

        Property DigitalObjectName() As String
            Get
                Return myDigitalObjectName
            End Get
            Set(ByVal Value As String)
                myDigitalObjectName = Value
            End Set
        End Property

        Property FileName() As String
            Get
                Return myFileName
            End Get
            Set(ByVal Value As String)
                myFileName = Value
            End Set
        End Property

    End Class


    Public Class DaoGrpCollection
        Inherits CollectionBase

        Default Public Property Item(ByVal index As Integer) As DaoGrp
            Get
                Return CType(List(index), DaoGrp)
            End Get
            Set(ByVal Value As DaoGrp)
                List(index) = Value
            End Set
        End Property

        Public Function Add(ByVal value As DaoGrp) As Integer
            Return List.Add(value)
        End Function

        Public Function IndexOf(ByVal value As DaoGrp) As Integer
            Return List.IndexOf(value)
        End Function

        Public Sub Insert(ByVal index As Integer, ByVal value As DaoGrp)
            List.Insert(index, value)
        End Sub

        Public Sub Remove(ByVal value As DaoGrp)
            List.Remove(value)
        End Sub

        Public Function Contains(ByVal value As DaoGrp) As Boolean
            Return List.Contains(value)
        End Function

    End Class


End Namespace
