
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Namespace MGOD

    Public Class DigitalizationProfile

        Private myID As Integer
        Private myName As String
        Private myCompleteName As String
        Private myDescription As String
        Private myResolution As String
        Private myBitDepth As String
        Private myFormat As String
        Private myCompression As String
        Private myOrientation As String
        Private myBrightness As String
        Private myContrast As String
        Private mySharpness As String
        Private myBlur As String

#Region "Constructors"

        Public Sub New()
        End Sub

        Public Sub New(ByVal Name As String, ByVal ID As Integer)
            myID = ID
            myName = Name
        End Sub

        Public Sub New(ByVal Name As String, ByVal ID As Integer, _
            ByVal Description As String, ByVal Resolution As Integer, _
            ByVal BitDepth As String, ByVal Format As Integer, _
            ByVal Compression As String, ByVal Orientation As String, _
            ByVal Brightness As String, ByVal Contrast As Integer, _
            ByVal Sharpness As String, ByVal Blur As Integer)

            myID = ID
            myName = Name
            myDescription = Description
            myResolution = Resolution
            myBitDepth = BitDepth
            myFormat = Format
            myCompression = Compression
            myOrientation = Orientation
            myBrightness = Brightness
            myContrast = Contrast
            mySharpness = Sharpness
            myBlur = Blur
        End Sub

#End Region

        Public Overrides Function tostring() As String
            Return Me.myName
        End Function

#Region "Properties"

        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property

        Property Name() As String
            Get
                Return myName
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property

        Property CompleteName() As String
            Get
                If myDescription.Equals("") Then
                    Return String.Format("{0}", myName)
                Else
                    Return String.Format("{0} ({1})", myName, myDescription)
                End If
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property

        Property Description() As String
            Get
                Return myDescription
            End Get
            Set(ByVal Value As String)
                myDescription = Value
            End Set
        End Property

        Property Resolution() As String
            Get
                Return myResolution
            End Get
            Set(ByVal Value As String)
                myResolution = Value
            End Set
        End Property

        Property BitDepth() As String
            Get
                Return myBitDepth
            End Get
            Set(ByVal Value As String)
                myBitDepth = Value
            End Set
        End Property

        Property Format() As String
            Get
                Return myFormat
            End Get
            Set(ByVal Value As String)
                myFormat = Value
            End Set
        End Property

        Property Compression() As String
            Get
                Return myCompression
            End Get
            Set(ByVal Value As String)
                myCompression = Value
            End Set
        End Property

        Property Orientation() As String
            Get
                Return myOrientation
            End Get
            Set(ByVal Value As String)
                myOrientation = Value
            End Set
        End Property

        Property Brightness() As String
            Get
                Return myBrightness
            End Get
            Set(ByVal Value As String)
                myBrightness = Value
            End Set
        End Property

        Property Contrast() As String
            Get
                Return myContrast
            End Get
            Set(ByVal Value As String)
                myContrast = Value
            End Set
        End Property

        Property Sharpness() As String
            Get
                Return mySharpness
            End Get
            Set(ByVal Value As String)
                mySharpness = Value
            End Set
        End Property

        Property Blur() As String
            Get
                Return myBlur
            End Get
            Set(ByVal Value As String)
                myBlur = Value
            End Set
        End Property

#End Region

    End Class

    Public Class DigitalizationProfileCollection
        Inherits CollectionBase


        Default Public Property Item(ByVal index As Integer) As DigitalizationProfileCollection
            Get
                Return CType(List(index), DigitalizationProfileCollection)
            End Get
            Set(ByVal Value As DigitalizationProfileCollection)
                List(index) = Value
            End Set
        End Property

        Public Function Add(ByVal Name As String, ByVal ID As Integer) As Integer
            Return List.Add(New DigitalizationProfile(Name, ID))
        End Function

        Public Function Add(ByVal value As DigitalizationProfile) As Integer
            Return List.Add(value)
        End Function

        Public Function IndexOf(ByVal value As DigitalizationProfile) As Integer
            Return List.IndexOf(value)
        End Function

        Public Sub Insert(ByVal index As Integer, ByVal value As DigitalizationProfile)
            List.Insert(index, value)
        End Sub

        Public Sub Remove(ByVal value As DigitalizationProfile)
            List.Remove(value)
        End Sub

        Public Function Contains(ByVal value As DigitalizationProfile) As Boolean
            Return List.Contains(value)
        End Function

    End Class


End Namespace