
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MGOD

    Public Class Project

        Private myProjectID As Int64
        Private myName As String
        Private myDescription As String
        Private myCreationDateTime As String
        Private myLastUpdateDateTime As String
        Private myUsername As String
        Private myDigitalizationProfileID As Integer
        Private myTechnologicalPlatformID As Integer
        Private myDigitalObjectsCount As Integer

#Region "Constructors"

        Public Sub New()
        End Sub

        Public Sub New(ByVal ProjectID As Integer, ByVal Name As String, ByVal Description As String, _
        ByVal CreationDateTime As String, ByVal LastUpdateDateTime As String, ByVal Username As String, _
        ByVal DigitalizationprofileID As Integer, ByVal TechnologicalPlatformID As Integer)
            myProjectID = ProjectID
            myName = Name
            myDescription = Description
            myCreationDateTime = CreationDateTime
            myLastUpdateDateTime = LastUpdateDateTime
            myUsername = Username
            myDigitalizationProfileID = DigitalizationprofileID
            myTechnologicalPlatformID = TechnologicalPlatformID
        End Sub

#End Region

        Public Overrides Function ToString() As String
            Return Me.myName
        End Function

#Region "Properties"

        Property ProjectID() As Int64
            Get
                Return myProjectID
            End Get
            Set(ByVal Value As Int64)
                myProjectID = Value
            End Set
        End Property

        Property Name() As String
            Get
                Return myName
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property

        Property Description() As String
            Get
                Return myDescription
            End Get
            Set(ByVal Value As String)
                myDescription = Value
            End Set
        End Property

        Property CreationDateTime() As String
            Get
                Return myCreationDateTime
            End Get
            Set(ByVal Value As String)
                myCreationDateTime = Value
            End Set
        End Property

        Property LastUpdateDateTime() As String
            Get
                Return myLastUpdateDateTime
            End Get
            Set(ByVal Value As String)
                myLastUpdateDateTime = Value
            End Set
        End Property

        Property Username() As String
            Get
                Return myUsername
            End Get
            Set(ByVal Value As String)
                myUsername = Value
            End Set
        End Property

        Property DigitalizationProfileID() As Integer
            Get
                Return myDigitalizationProfileID
            End Get
            Set(ByVal Value As Integer)
                myDigitalizationProfileID = Value
            End Set
        End Property

        Property TechnologicalPlatformID() As Integer
            Get
                Return myTechnologicalPlatformID
            End Get
            Set(ByVal Value As Integer)
                myTechnologicalPlatformID = Value
            End Set
        End Property

        Property DigitalObjectsCount() As Integer
            Get
                Return myDigitalObjectsCount
            End Get
            Set(ByVal Value As Integer)
                myDigitalObjectsCount = Value
            End Set
        End Property

#End Region

    End Class


    Public Class ProjectCollection
        Inherits CollectionBase


        Default Public Property Item(ByVal index As Integer) As Project
            Get
                Return CType(List(index), Project)
            End Get
            Set(ByVal Value As Project)
                List(index) = Value
            End Set
        End Property

        Public Function Add(ByVal ProjectID As Integer, ByVal Name As String, ByVal Description As String, _
            ByVal CreationDateTime As String, ByVal LastUpdateDateTime As String, ByVal Username As String, _
            ByVal DigitalizationProfileID As Integer, ByVal TechnologicalPlatformID As Integer) As Integer
            Return List.Add(New Project(ProjectID, Name, Description, CreationDateTime, LastUpdateDateTime, _
            DigitalizationProfileID, TechnologicalPlatformID, Username))
        End Function

        Public Function Add(ByVal Project As Project) As Integer
            Return List.Add(Project)
        End Function

        Public Function IndexOf(ByVal value As Project) As Integer
            Return List.IndexOf(value)
        End Function

        Public Sub Insert(ByVal index As Integer, ByVal value As Project)
            List.Insert(index, value)
        End Sub

        Public Sub Remove(ByVal value As Project)
            List.Remove(value)
        End Sub

        Public Function Contains(ByVal value As Project) As Boolean
            Return List.Contains(value)
        End Function

    End Class

End Namespace
