
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

'Imports System.Data.SqlClient

Namespace MGOD

    Public Class TechnologicalPlatform

        Private myID As Integer
        Private myDesignation As String
        Private myName As String
        Private myCompleteName As String
        Private myDeviceSource As String
        Private myManufacturer As String
        Private mySoftware As String
        Private mySoftwareVersion As String
        Private myOperatingSystem As String
        Private myOperatingSystemVersion As String
        Private myIlluminance As String
        Private myFontType As String
        Private myProcessingActions As String
        Private myProcessingSoftwareName As String
        Private myProcessingSoftwareVersion As String
        Private myProcessingOSName As String
        Private myProcessingOSVersion As String
        Private myColorManager As String


#Region "Constructors"

        Public Sub New()
        End Sub

        Public Sub New(ByVal Name As String, ByVal ID As Integer)
            myID = ID
            myName = Name
        End Sub

        Public Sub New(ByVal ID As Integer, ByVal Name As String, _
            ByVal DeviceSource As String, ByVal Manufacturer As String, ByVal Software As String, _
            ByVal SoftwareVersion As String, ByVal OperatingSystem As String, _
            ByVal OperatingSystemVersion As String, ByVal Illuminance As String, ByVal FontType As String)

            myID = ID
            myName = Name
            myDeviceSource = DeviceSource
            myIlluminance = Illuminance
            myManufacturer = Manufacturer
            mySoftware = Software
            mySoftwareVersion = SoftwareVersion
            myOperatingSystem = OperatingSystem
            myOperatingSystemVersion = OperatingSystemVersion
        End Sub

#End Region

        Public Overrides Function tostring() As String
            Return Me.myDesignation
        End Function

#Region "Properties"

        Property ID() As Integer
            Get
                Return myID
            End Get
            Set(ByVal Value As Integer)
                myID = Value
            End Set
        End Property

        Property Designation() As String
            Get
                Return myDesignation
            End Get
            Set(ByVal Value As String)
                myDesignation = Value
            End Set
        End Property

        Property CompleteName() As String
            Get
                If myName.Equals("") Then
                    Return String.Format("{0}", myDesignation)
                Else
                    Return String.Format("{0}, ({1})", myDesignation, myName)
                End If
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property

        Property Name() As String
            Get
                Return myName
            End Get
            Set(ByVal Value As String)
                myName = Value
            End Set
        End Property

        Property DeviceSource() As String
            Get
                Return myDeviceSource
            End Get
            Set(ByVal Value As String)
                myDeviceSource = Value
            End Set
        End Property

        Property Manufacturer() As String
            Get
                Return myManufacturer
            End Get
            Set(ByVal Value As String)
                myManufacturer = Value
            End Set
        End Property

        Property Software() As String
            Get
                Return mySoftware
            End Get
            Set(ByVal Value As String)
                mySoftware = Value
            End Set
        End Property

        Property SoftwareVersion() As String
            Get
                Return mySoftwareVersion
            End Get
            Set(ByVal Value As String)
                mySoftwareVersion = Value
            End Set
        End Property

        Property OperatingSystem() As String
            Get
                Return myOperatingSystem
            End Get
            Set(ByVal Value As String)
                myOperatingSystem = Value
            End Set
        End Property

        Property OperatingSystemVersion() As String
            Get
                Return myOperatingSystemVersion
            End Get
            Set(ByVal Value As String)
                myOperatingSystemVersion = Value
            End Set
        End Property

        Property Illuminance() As String
            Get
                Return myIlluminance
            End Get
            Set(ByVal Value As String)
                myIlluminance = Value
            End Set
        End Property

        Property FontType() As String
            Get
                Return myFontType
            End Get
            Set(ByVal Value As String)
                myFontType = Value
            End Set
        End Property

        Property ProcessingActions() As String
            Get
                Return myProcessingActions
            End Get
            Set(ByVal Value As String)
                myProcessingActions = Value
            End Set
        End Property

        Property ProcessingSoftwareName() As String
            Get
                Return myProcessingSoftwareName
            End Get
            Set(ByVal Value As String)
                myProcessingSoftwareName = Value
            End Set
        End Property

        Property ProcessingSoftwareVersion() As String
            Get
                Return myProcessingSoftwareVersion
            End Get
            Set(ByVal Value As String)
                myProcessingSoftwareVersion = Value
            End Set
        End Property

        Property ProcessingOSName() As String
            Get
                Return myProcessingOSName
            End Get
            Set(ByVal Value As String)
                myProcessingOSName = Value
            End Set
        End Property

        Property ProcessingOSVersion() As String
            Get
                Return myProcessingOSVersion
            End Get
            Set(ByVal Value As String)
                myProcessingOSVersion = Value
            End Set
        End Property

        Property ColorManager() As String
            Get
                Return myColorManager
            End Get
            Set(ByVal Value As String)
                myColorManager = Value
            End Set
        End Property

#End Region

    End Class


    Public Class TechnologicalPlatformCollection
        Inherits CollectionBase


        Default Public Property Item(ByVal index As Integer) As TechnologicalPlatformCollection
            Get
                Return CType(List(index), TechnologicalPlatformCollection)
            End Get
            Set(ByVal Value As TechnologicalPlatformCollection)
                List(index) = Value
            End Set
        End Property

        Public Function Add(ByVal Name As String, ByVal ID As Integer) As Integer
            Return List.Add(New TechnologicalPlatform(Name, ID))
        End Function

        Public Function Add(ByVal TechnologicalPlatform As TechnologicalPlatform) As Integer
            Return List.Add(TechnologicalPlatform)
        End Function

        Public Function IndexOf(ByVal value As TechnologicalPlatform) As Integer
            Return List.IndexOf(value)
        End Function

        Public Sub Insert(ByVal index As Integer, ByVal value As TechnologicalPlatform)
            List.Insert(index, value)
        End Sub

        Public Sub Remove(ByVal value As TechnologicalPlatform)
            List.Remove(value)
        End Sub

        Public Function Contains(ByVal value As TechnologicalPlatform) As Boolean
            Return List.Contains(value)
        End Function

    End Class

End Namespace
