Imports System.Threading
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.String
Imports System.Text
Imports System.IO
Imports DigitArq.Utility.TypeConversion

#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tSqlConnectionica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MGOD
    Public Class SqlCommands

#Region "Private properties"

        Private myEmployee As String

        Public Enum AssociationType As Integer
            DigitalObject = 0
            File = 1
        End Enum

#End Region

#Region "Constructors"

        Public Sub New(Optional ByVal Employee As String = "")
            myEmployee = Employee
        End Sub

#End Region

#Region "Data base connection"

        Private SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
        Private ServerAddress As String = SQLServerSettings("ServerAddress")
        Private Database As String = SQLServerSettings("Database")
        Private Username As String = SQLServerSettings("Username")
        Private Password As String = SQLServerSettings("Password")
        Private ConnectTimeout As String = SQLServerSettings("ConnectTimeout")

        Private ConnectionString As String = String.Format("Data Source={0}; Initial Catalog={1}; User ID={2}; password={3}; Connect Timeout={4};", ServerAddress, Database, Username, Password, ConnectTimeout)

#End Region


#Region "Functions/Procedures to SELECT information from tables"

#Region "SELECT Projects"

        Public Function SelectProject(ByVal ProjectID As Integer) As Project
            Dim Project As New Project
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT * FROM Projects " & _
                            "WHERE ProjectID = {0}", ProjectID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                If Not SqlDataReader.HasRows Then
                    Return Nothing
                Else
                    Project.ProjectID = SqlDataReader.Item("ProjectID")
                    Project.Name = DBToStr(SqlDataReader.Item("Name"))
                    Project.Description = DBToStr(SqlDataReader.Item("Description"))
                    Project.CreationDateTime = DBToStr(SqlDataReader.Item("CreationDateTime"))
                    Project.LastUpdateDateTime = DBToStr(SqlDataReader.Item("LastUpdateDateTime"))
                    Project.Username = DBToStr(SqlDataReader.Item("Username"))

                    Return Project
                End If
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectProjects(ByVal TopValue As Integer, ByVal OrderBy As String, Optional ByVal Order As String = "ASC") As ProjectCollection
            Dim ProjectCollection As New ProjectCollection
            Dim TopStatement As String
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                If TopValue <> 0 Then TopStatement = String.Format("TOP {0}", TopValue) Else TopStatement = ""
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT {0} P.ProjectID, Name, Description, CreationDateTime, " & _
                             "LastUpdateDateTime, Username, ISNULL(DO.DOCount,0) AS DOCount " & _
                             "FROM Projects P " & _
                             "LEFT JOIN (SELECT ProjectID, COUNT(ProjectID) AS DOCount FROM DigitalObjects " & _
                             "GROUP BY ProjectID) AS DO " & _
                             "ON DO.ProjectID=P.ProjectID " & _
                             "ORDER BY P.{1} {2}", TopStatement, OrderBy, Order), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim Project As New Project
                    Project.ProjectID = SqlDataReader.Item("ProjectID")
                    Project.Name = DBToStr(SqlDataReader.Item("Name"))
                    Project.Description = DBToStr(SqlDataReader.Item("Description"))
                    Project.CreationDateTime = DBToStr(SqlDataReader.Item("CreationDateTime"))
                    Project.LastUpdateDateTime = DBToStr(SqlDataReader.Item("LastUpdateDateTime"))
                    Project.Username = DBToStr(SqlDataReader.Item("Username"))
                    Project.DigitalObjectsCount = DBToInt(SqlDataReader.Item("DOCount"))
                    ProjectCollection.Add(Project)
                End While

                Return ProjectCollection
            Catch e As SqlException
                MsgBox(e.ToString)
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectProjects(ByVal StrCommand As String) As ProjectCollection
            Dim ProjectCollection As New ProjectCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(StrCommand, SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim Project As New Project
                    Project.ProjectID = SqlDataReader.Item("ProjectID")
                    Project.Name = DBToStr(SqlDataReader.Item("Name"))
                    Project.Description = DBToStr(SqlDataReader.Item("Description"))
                    Project.CreationDateTime = DBToStr(SqlDataReader.Item("CreationDateTime"))
                    Project.LastUpdateDateTime = DBToStr(SqlDataReader.Item("LastUpdateDateTime"))
                    Project.Username = DBToStr(SqlDataReader.Item("Username"))
                    Project.DigitalObjectsCount = DBToInt(SqlDataReader.Item("DOCount"))
                    ProjectCollection.Add(Project)
                End While

                Return ProjectCollection
            Catch e As SqlException
                MsgBox(e.ToString)
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT DigitalObjects"

        Public Function SelectDigitalObjects(ByVal ProjectID As Int64, ByVal Published As Boolean, ByVal OrderBy As String) As DigitalObjectCollection
            Dim DigitalObjectCollection As New DigitalObjectCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT DigitalObjectID, Name, RevisionDateTime, Structure, Active FROM DigitalObjects WHERE ProjectID = {0} AND Active = {1} " & _
                                        "ORDER BY {2} ASC", ProjectID, BoolToDB(Published), OrderBy), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim DigitalObject As New DigitalObject
                    DigitalObject.DigitalObjectID = SqlDataReader.Item("DigitalObjectID")
                    DigitalObject.Name = DBToStr(SqlDataReader.Item("Name"))
                    DigitalObject.RevisionDateTime = DBToStr(SqlDataReader.Item("RevisionDateTime"))
                    DigitalObject.DOStructure = DBToStr(SqlDataReader.Item("Structure"))
                    DigitalObject.Active = DBToBool(SqlDataReader.Item("Active"))
                    DigitalObjectCollection.Add(DigitalObject)
                End While
                Return DigitalObjectCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDigitalObjects(ByVal Query As String, ByVal Published As Boolean) As DigitalObjectCollection
            Dim DigitalObjectCollection As New DigitalObjectCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(Query, SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    If DBToBool(SqlDataReader.Item("Active")) = Published Then
                        Dim DigitalObject As New DigitalObject
                        DigitalObject.DigitalObjectID = SqlDataReader.Item("DigitalObjectID")
                        DigitalObject.Name = DBToStr(SqlDataReader.Item("Name"))
                        DigitalObject.RevisionDateTime = DBToStr(SqlDataReader.Item("RevisionDateTime"))
                        DigitalObject.DOStructure = DBToStr(SqlDataReader.Item("Structure"))
                        DigitalObject.Active = DBToBool(SqlDataReader.Item("Active"))
                        DigitalObjectCollection.Add(DigitalObject)
                    End If
                End While
                Return DigitalObjectCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDigitalObjects(ByVal ProjectID As Int64, ByVal OrderBy As String) As DigitalObjectCollection
            Dim DigitalObjectCollection As New DigitalObjectCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT DISTINCT DO.DigitalObjectID, DO.Name, " & _
                                            "DO.OriginalName, DO.Active, DG.DigitalObjectID as DaoGrpDOID " & _
                                            "FROM DigitalObjects DO " & _
                                            "LEFT JOIN DaoGrp DG ON DO.DigitalObjectID = DG.DigitalObjectID " & _
                                            "WHERE ProjectID={0}" & _
                                            "ORDER BY {1};", ProjectID, OrderBy), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim DigitalObject As New DigitalObject
                    DigitalObject.DigitalObjectID = SqlDataReader.Item("DigitalObjectID")
                    DigitalObject.Name = DBToStr(SqlDataReader.Item("Name"))
                    DigitalObject.OriginalName = DBToStr(SqlDataReader.Item("OriginalName"))
                    DigitalObject.Active = DBToBool(SqlDataReader.Item("Active"))
                    DigitalObject.Associated = DBToBool(SqlDataReader.Item("DaoGrpDOID"))
                    DigitalObjectCollection.Add(DigitalObject)
                End While
                Return DigitalObjectCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDigitalObjects(ByVal Name As String) As DigitalObjectCollection
            Dim DigitalObjectCollection As New DigitalObjectCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT DISTINCT DigitalObjectID, Name, " & _
                                            "OriginalName, Active " & _
                                            "FROM DigitalObjects " & _
                                            "WHERE Name='{0}'", Name), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim DigitalObject As New DigitalObject
                    DigitalObject.DigitalObjectID = SqlDataReader.Item("DigitalObjectID")
                    DigitalObject.Name = DBToStr(SqlDataReader.Item("Name"))
                    DigitalObject.OriginalName = DBToStr(SqlDataReader.Item("OriginalName"))
                    DigitalObject.Active = DBToBool(SqlDataReader.Item("Active"))
                    DigitalObjectCollection.Add(DigitalObject)
                End While
                Return DigitalObjectCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDigitalObject(ByVal DigitalObjectID As Int64) As DigitalObject
            Dim DigitalObject As New DigitalObject
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT * FROM DigitalObjects " & _
                            "WHERE DigitalObjectID = {0}", DigitalObjectID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    DigitalObject.ProjectID = SqlDataReader.Item("ProjectID")
                    DigitalObject.DigitalObjectID = DigitalObjectID
                    DigitalObject.Name = DBToStr(SqlDataReader.Item("Name"))
                    DigitalObject.OriginalName = DBToStr(SqlDataReader.Item("OriginalName"))
                    DigitalObject.ArchiveID = DBToStr(SqlDataReader.Item("ArchiveID"))
                    DigitalObject.ArchivingProfile = DBToStr(SqlDataReader.Item("ArchivingProfile"))
                    DigitalObject.ResponsabilityEntity = DBToStr(SqlDataReader.Item("ResponsabilityEntity"))
                    DigitalObject.CaptureEntityCorporate = DBToStr(SqlDataReader.Item("CaptureEntityCorporate"))
                    DigitalObject.CaptureEntityIndividual = DBToStr(SqlDataReader.Item("CaptureEntityIndividual"))
                    DigitalObject.CreationDateTime = DBToStr(SqlDataReader.Item("CreationDateTime"))
                    DigitalObject.ArchiveDateTime = DBToStr(SqlDataReader.Item("ArchiveDateTime"))
                    DigitalObject.DepositDateTime = DBToStr(SqlDataReader.Item("DepositDateTime"))
                    DigitalObject.RevisionDateTime = DBToStr(SqlDataReader.Item("RevisionDateTime"))
                    DigitalObject.ExternalDescriptiveInformation = DBToStr(SqlDataReader.Item("ExternalDescriptiveInformation"))
                    DigitalObject.PreservationOriginalInformation = DBToStr(SqlDataReader.Item("PreservationOriginalInformation"))
                    DigitalObject.TopographicalQuota = DBToStr(SqlDataReader.Item("TopographicalQuota"))
                    DigitalObject.DOStructure = DBToStr(SqlDataReader.Item("Structure"))
                    DigitalObject.UserName = DBToStr(SqlDataReader.Item("UserName"))
                    DigitalObject.Active = DBToBool(SqlDataReader.Item("Active"))
                End While

                Return DigitalObject
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectCountDigitalObjects(ByVal ProjectID As Int64) As Integer
            Dim SqlCommand As New SqlCommand
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT COUNT(DigitalObjectID) " & _
                                        "FROM DigitalObjects WHERE ProjectID={0};", ProjectID)
                Return SqlCommand.ExecuteScalar
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        'Public Function SelectDOToCheck() As ArrayList
        '    Dim myData As New DataSet
        '    Dim SqlDataReader As SqlDataAdapter
        '    Dim command As String
        '    Dim array As New ArrayList
        '    Dim i, count As Integer

        '    Try
        '        command = "SELECT DigitalObjectID " & _
        '        "FROM DigitalObjects WHERE RevisionDateTime < CONVERT(NVARCHAR(11), GETDATE(), 126)"
        '        SqlDataReader = New SqlDataAdapter(command, ConnectionString)
        '        SqlDataReader.Fill(myData)

        '        count = myData.Tables(0).Rows.Count - 1
        '        For i = 0 To count
        '            array.Add(myData.Tables(0).Rows(i).Item(0))
        '        Next i
        '    Catch e As SqlException
        '        throw(e)
        '    End Try
        '    Return array
        'End Function

        Public Function SelectProjectsToCheck() As ArrayList
            Dim myData As New DataSet
            Dim SqlDataReader As SqlDataAdapter
            Dim command As String
            Dim i, count As Integer
            Dim array As New ArrayList

            Try
                command = "SELECT DISTINCT ProjectID " & _
                    "FROM DigitalObjects WHERE RevisionDateTime < CONVERT(NVARCHAR(11), GETDATE(), 126)"

                SqlDataReader = New SqlDataAdapter(command, ConnectionString)
                SqlDataReader.Fill(myData)

                count = myData.Tables(0).Rows.Count - 1
                For i = 0 To count
                    array.Add(myData.Tables(0).Rows(i).Item(0))
                Next i
            Catch e As SqlException
                Throw (e)
            End Try
            Return array
        End Function

        Public Function GetDOStructure(ByVal DigitalObjectID As Int64) As String
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Dim XML As String
            Try
                SqlCommand.Connection = SqlConnection
                SqlConnection.Open()
                SqlCommand.CommandText = String.Format("SELECT Structure FROM DigitalObjects " & _
                                        "WHERE DigitalObjectID={0};", DigitalObjectID)
                XML = CStr(SqlCommand.ExecuteScalar)
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return XML
        End Function

        Function GetLastDOName(ByVal ProjectID As Int64) As String
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT TOP 1 Name " & _
                                        "FROM DigitalObjects " & _
                                        "WHERE ProjectID = {0} " & _
                                        "ORDER BY DigitalObjectID DESC", ProjectID)
                Return SqlCommand.ExecuteScalar
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Function SelectCountFiles(ByVal DigitalObjectID As Int64) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT Count(ID) FROM Files " & _
                                        "WHERE DigitalObjectID = {0};", DigitalObjectID)
                Return SqlCommand.ExecuteScalar
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Function SelectCountProjectFiles(ByVal ProjectID As Int64) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT COUNT(ID) FROM Files " & _
                                         "WHERE DigitalObjectID IN (SELECT DigitalObjectID FROM DigitalObjects WHERE ProjectID = {0});", ProjectID)
                Return SqlCommand.ExecuteScalar
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function FileIsAssociated(ByVal FileID As Int64) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT FileID FROM DaoGrp " & _
                                        "WHERE FileID={0};", FileID)
                SqlDataReader = SqlCommand.ExecuteReader()
                If SqlDataReader.HasRows Then
                    Return True
                Else
                    Return False
                End If
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT ControlledVocabularies"

        Public Function SelectControlledVocabularies() As ControlledVocabularyCollection
            Dim ControlledVocabularyCollection As New ControlledVocabularyCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT ID, [Name] FROM ControlledVocabularies", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    ControlledVocabularyCollection.Add(SqlDataReader.Item("Name"), SqlDataReader.Item("ID"))
                End While
                Return ControlledVocabularyCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectControlledVocabularyValues(ByVal VocabularyID As Integer) As VocabularyValueCollection
            Dim VocabularyValueCollection As New VocabularyValueCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT ID, Value FROM [Values] WHERE VocabularyID={0};", VocabularyID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim VocabularyValue As New VocabularyValue
                    VocabularyValue.ID = SqlDataReader.Item("ID")
                    VocabularyValue.Value = DBToStr(SqlDataReader.Item("Value"))
                    VocabularyValueCollection.Add(VocabularyValue)
                End While
                Return VocabularyValueCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectControlledVocabularyValues(ByVal VocabularyName As String) As Collection
            Dim Collection As New Collection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT V.ID, V.Value FROM [Values] V " & _
                                                        "INNER JOIN ControlledVocabularies CV ON V.VocabularyID=CV.ID " & _
                                                        "WHERE CV.Name='{0}';", VocabularyName), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Collection.Add(DBToStr(SqlDataReader.Item("Value")))
                End While
                Return Collection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectVocabularyValue(ByVal ProjectID As Int64, ByVal VocabularyID As Integer) As String
            Dim VocabularyValueCollection As New VocabularyValueCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT Value FROM [Values] V " & _
                                                        "INNER JOIN VocabulariesConfig VC ON V.ID=VC.ValueID " & _
                                                        "WHERE VC.ProjectID={0} AND V.VocabularyID={1};", ProjectID, VocabularyID), SqlConnection)
                Return DBToStr(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectVocabularyValue(ByVal ProjectID As Int64, ByVal VocabularyName As String) As String
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT Value FROM [Values] V " & _
                                            "INNER JOIN VocabulariesConfig VC ON V.ID=VC.ValueID " & _
                                            "INNER JOIN ControlledVocabularies CV ON V.VocabularyID=CV.ID " & _
                                            "WHERE VC.ProjectID={0} AND CV.Name='{1}'", ProjectID, VocabularyName), SqlConnection)
                Return DBToStr(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlCommand.Dispose()
            End Try
        End Function

        Public Function UpdateVocabulariesConfig(ByVal ProjectID As Int64, ByVal Values As ArrayList) As Boolean
            Dim VocabularyValueCollection As New VocabularyValueCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("DELETE FROM VocabulariesConfig " & _
                                            "WHERE ProjectID={0};", ProjectID), SqlConnection)
                SqlCommand.ExecuteNonQuery()

                For Each Value As String In Values
                    SqlCommand = New SqlCommand(String.Format("SELECT ID FROM [Values] " & _
                                                "WHERE Value='{0}';", Value), SqlConnection)
                    Dim ValueID As Integer = SqlCommand.ExecuteScalar

                    SqlCommand = New SqlCommand(String.Format("INSERT INTO VocabulariesConfig " & _
                                                "VALUES ({0},{1});", ProjectID, ValueID), SqlConnection)
                    SqlCommand.ExecuteNonQuery()
                Next
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT File"

        Public Function SelectProjectFiles(ByVal ProjectID As Int64) As DOFileCollection
            Dim DOFileCollection As New DOFileCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT F.* FROM FILES F " & _
                                            "INNER JOIN DigitalObjects DO ON F.DigitalObjectID=DO.DigitalObjectID " & _
                                            "INNER JOIN Projects P ON DO.ProjectID=P.ProjectID " & _
                                            "WHERE P.ProjectID={0}", ProjectID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim File As New DOFile
                    File.ID = DBToInt64(SqlDataReader.Item("ID"))
                    File.Name = DBToStr(SqlDataReader.Item("Name"))
                    File.Length = DBToInt64(SqlDataReader.Item("Length"))
                    File.Format = DBToStr(SqlDataReader.Item("Format")).ToUpper
                    File.MD5 = DBToStr(SqlDataReader.Item("MD5"))
                    File.HasDissemination = DBToBool(SqlDataReader.Item("HasDissemination"))
                    File.OriginalURL = DBToStr(SqlDataReader.Item("OriginalURL"))
                    File.DisseminationURL = DBToStr(SqlDataReader.Item("DisseminationURL"))
                    File.ThumbnailURL = DBToStr(SqlDataReader.Item("ThumbnailURL"))
                    File.DigitalObjectID = DBToInt(SqlDataReader.Item("DigitalObjectID"))
                    File.UserName = DBToStr(SqlDataReader.Item("UserName"))
                    DOFileCollection.Add(File)
                End While
                Return DOFileCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectFiles(ByVal DigitalObjectID As Int64) As DOFileCollection
            Dim DOFileCollection As New DOFileCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT * FROM Files WHERE DigitalObjectID={0}", DigitalObjectID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim File As New DOFile
                    File.ID = DBToInt64(SqlDataReader.Item("ID"))
                    File.Name = DBToStr(SqlDataReader.Item("Name"))
                    File.Length = DBToInt64(SqlDataReader.Item("Length"))
                    File.Format = DBToStr(SqlDataReader.Item("Format")).ToUpper
                    File.MD5 = DBToStr(SqlDataReader.Item("MD5"))
                    File.HasDissemination = DBToBool(SqlDataReader.Item("HasDissemination"))
                    File.OriginalURL = DBToStr(SqlDataReader.Item("OriginalURL"))
                    File.DisseminationURL = DBToStr(SqlDataReader.Item("DisseminationURL"))
                    File.ThumbnailURL = DBToStr(SqlDataReader.Item("ThumbnailURL"))
                    File.DigitalObjectID = DBToInt(SqlDataReader.Item("DigitalObjectID"))
                    File.UserName = DBToStr(SqlDataReader.Item("UserName"))
                    DOFileCollection.Add(File)
                End While
                Return DOFileCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDOFile(ByVal FileID As Int64) As DOFile
            Dim File As New DOFile
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT * FROM Files " & _
                                            "WHERE ID={0}", FileID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    File.ID = FileID
                    File.Name = DBToStr(SqlDataReader.Item("Name"))
                    File.Length = DBToInt64(SqlDataReader.Item("Length"))
                    File.Format = DBToStr(SqlDataReader.Item("Format")).ToUpper
                    File.CreationDateTime = DBToStr(SqlDataReader.Item("CreationDateTime"))
                    File.MD5 = DBToStr(SqlDataReader.Item("MD5"))
                    File.HasDissemination = DBToBool(SqlDataReader.Item("HasDissemination"))
                    File.OriginalURL = DBToStr(SqlDataReader.Item("OriginalURL"))
                    File.DisseminationURL = DBToStr(SqlDataReader.Item("DisseminationURL"))
                    File.ThumbnailURL = DBToStr(SqlDataReader.Item("ThumbnailURL"))
                    File.DigitalObjectID = DBToInt(SqlDataReader.Item("DigitalObjectID"))
                    File.UserName = DBToStr(SqlDataReader.Item("UserName"))
                End While
                Return File
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function HasDissemination(ByVal FileID As Int64) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT HasDissemination FROM Files " & _
                                            "WHERE ID={0}", FileID), SqlConnection)
                Return DBToBool(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountFilesWithSameDisseminationURL(ByVal DisseminationURL As String) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT COUNT(*) FROM Files " & _
                                            "WHERE DisseminationURL='{0}'", DisseminationURL), SqlConnection)
                Return DBToInt(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountFilesWithSameOriginalURL(ByVal OriginalURL As String) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT COUNT(*) FROM Files " & _
                                            "WHERE OriginalURL='{0}'", OriginalURL), SqlConnection)
                Return DBToInt(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT RevisionInterval"

        Public Function SelectRevisionInterval() As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = "SELECT TOP 1 [Value] FROM RevisionInterval"

                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT DigitalizationProfiles"

        Public Function SelectDigitalizationProfiles() As DigitalizationProfileCollection
            Dim DigitalizationProfileCollection As New DigitalizationProfileCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT * FROM DigitalizationProfile ORDER BY ID DESC", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim DigitalizationProfile As New DigitalizationProfile
                    DigitalizationProfile.ID = SqlDataReader.Item("ID")
                    DigitalizationProfile.Name = SqlDataReader.Item("Name")
                    DigitalizationProfile.Description = DBToStr(SqlDataReader.Item("Description"))
                    DigitalizationProfile.Resolution = DBToStr(SqlDataReader.Item("Resolution"))
                    DigitalizationProfile.BitDepth = DBToStr(SqlDataReader.Item("BitDepth"))
                    DigitalizationProfile.Format = DBToStr(SqlDataReader.Item("Format"))
                    DigitalizationProfile.Compression = DBToStr(SqlDataReader.Item("Compression"))
                    DigitalizationProfile.Orientation = DBToStr(SqlDataReader.Item("Orientation"))
                    DigitalizationProfile.Brightness = DBToStr(SqlDataReader.Item("Brightness"))
                    DigitalizationProfile.Contrast = DBToStr(SqlDataReader.Item("Contrast"))
                    DigitalizationProfile.Sharpness = DBToStr(SqlDataReader.Item("Sharpness"))
                    DigitalizationProfile.Blur = DBToStr(SqlDataReader.Item("Blur"))

                    DigitalizationProfileCollection.Add(DigitalizationProfile)
                End While
                Return DigitalizationProfileCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDigitalizationProfileNames() As Collection
            Dim Collection As New Collection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT Name FROM DigitalizationProfile ORDER BY ID DESC", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Collection.Add(SqlDataReader.Item("Name"))
                End While
                Return Collection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectDigitalizationProfile(ByVal ID As Integer) As DigitalizationProfile
            Dim Profile As New DigitalizationProfile
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT * FROM DigitalizationProfile WHERE ID = {0};", ID)
                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Profile.Name = DBToStr(SqlDataReader.Item("Name"))
                Profile.Description = DBToStr(SqlDataReader.Item("Description"))
                Profile.Orientation = DBToStr(SqlDataReader.Item("Orientation"))
                Profile.Brightness = DBToStr(SqlDataReader.Item("Brightness"))
                Profile.Contrast = DBToStr(SqlDataReader.Item("Contrast"))
                Profile.Sharpness = DBToStr(SqlDataReader.Item("Sharpness"))
                Profile.Blur = DBToStr(SqlDataReader.Item("Blur"))
                Profile.Resolution = DBToStr(SqlDataReader.Item("Resolution"))
                Profile.BitDepth = DBToStr(SqlDataReader.Item("BitDepth"))
                Profile.Format = DBToStr(SqlDataReader.Item("Format"))
                Profile.Compression = DBToStr(SqlDataReader.Item("Compression"))
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return Profile
        End Function

        Public Function SelectProjectDigitalizationProfile(ByVal ProjectID As Integer) As DigitalizationProfile
            Dim Profile As New DigitalizationProfile
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT * FROM DigitalizationProfile DP " & _
                                         "INNER JOIN Projects P ON DP.ID=P.DigitalizationProfileID " & _
                                         "WHERE ProjectID={0}", ProjectID)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Profile.Name = DBToStr(SqlDataReader.Item("Name"))
                    Profile.Description = DBToStr(SqlDataReader.Item("Description"))
                    Profile.Orientation = DBToStr(SqlDataReader.Item("Orientation"))
                    Profile.Brightness = DBToStr(SqlDataReader.Item("Brightness"))
                    Profile.Contrast = DBToStr(SqlDataReader.Item("Contrast"))
                    Profile.Sharpness = DBToStr(SqlDataReader.Item("Sharpness"))
                    Profile.Blur = DBToStr(SqlDataReader.Item("Blur"))
                    Profile.Resolution = DBToStr(SqlDataReader.Item("Resolution"))
                    Profile.BitDepth = DBToStr(SqlDataReader.Item("BitDepth"))
                    Profile.Format = DBToStr(SqlDataReader.Item("Format"))
                    Profile.Compression = DBToStr(SqlDataReader.Item("Compression"))
                End While
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return Profile
        End Function

        Public Function SelectDigitalizationProfileID(ByVal ProjectID As Integer) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT DigitalizationProfileID FROM Projects " & _
                                         "WHERE ProjectID={0}", ProjectID)
                Return DBToInt(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT TechnologicalPlatform"

        Public Function SelectTechnologicalPlatforms() As TechnologicalPlatformCollection
            Dim TechnologicalPlatformCollection As New TechnologicalPlatformCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT * FROM TechnologicalPlatform ORDER BY ID DESC", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim TechnologicalPlatform As New TechnologicalPlatform
                    TechnologicalPlatform.ID = SqlDataReader.Item("ID")
                    TechnologicalPlatform.Designation = DBToStr(SqlDataReader.Item("Designation"))
                    TechnologicalPlatform.Name = DBToStr(SqlDataReader.Item("Name"))
                    TechnologicalPlatform.DeviceSource = DBToStr(SqlDataReader.Item("DeviceSource"))
                    TechnologicalPlatform.Manufacturer = DBToStr(SqlDataReader.Item("Manufacturer"))
                    TechnologicalPlatform.Software = DBToStr(SqlDataReader.Item("Software"))
                    TechnologicalPlatform.SoftwareVersion = DBToStr(SqlDataReader.Item("SoftwareVersion"))
                    TechnologicalPlatform.OperatingSystem = DBToStr(SqlDataReader.Item("OperatingSystem"))
                    TechnologicalPlatform.OperatingSystemVersion = DBToStr(SqlDataReader.Item("OperatingSystemVersion"))
                    TechnologicalPlatform.Illuminance = DBToStr(SqlDataReader.Item("Illuminance"))
                    TechnologicalPlatform.FontType = DBToStr(SqlDataReader.Item("FontType"))
                    TechnologicalPlatform.ProcessingActions = DBToStr(SqlDataReader.Item("ProcessingActions"))
                    TechnologicalPlatform.ProcessingSoftwareName = DBToStr(SqlDataReader.Item("ProcessingSoftwareName"))
                    TechnologicalPlatform.ProcessingSoftwareVersion = DBToStr(SqlDataReader.Item("ProcessingSoftwareVersion"))
                    TechnologicalPlatform.ProcessingOSName = DBToStr(SqlDataReader.Item("ProcessingOSName"))
                    TechnologicalPlatform.ProcessingOSVersion = DBToStr(SqlDataReader.Item("ProcessingOSVersion"))
                    TechnologicalPlatform.ColorManager = DBToStr(SqlDataReader.Item("ColorManager"))
                    TechnologicalPlatformCollection.Add(TechnologicalPlatform)
                End While
                Return TechnologicalPlatformCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectTechnologicalPlatformNames() As Collection
            Dim Collection As New Collection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT [Name] FROM TechnologicalPlatform ORDER BY ID DESC", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Collection.Add(SqlDataReader.Item("Name"))
                End While
                Return Collection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectTechnologicalPlatform(ByVal ID As Integer) As TechnologicalPlatform
            Dim TechnologicalPlatform As New TechnologicalPlatform
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT * FROM TechnologicalPlatform WHERE ID = {0};", ID)
                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                TechnologicalPlatform.ID = SqlDataReader.Item("ID")
                TechnologicalPlatform.Designation = DBToStr(SqlDataReader.Item("Designation"))
                TechnologicalPlatform.Name = DBToStr(SqlDataReader.Item("Name"))
                TechnologicalPlatform.DeviceSource = DBToStr(SqlDataReader.Item("DeviceSource"))
                TechnologicalPlatform.Manufacturer = DBToStr(SqlDataReader.Item("Manufacturer"))
                TechnologicalPlatform.Software = DBToStr(SqlDataReader.Item("Software"))
                TechnologicalPlatform.SoftwareVersion = DBToStr(SqlDataReader.Item("SoftwareVersion"))
                TechnologicalPlatform.OperatingSystem = DBToStr(SqlDataReader.Item("OperatingSystem"))
                TechnologicalPlatform.OperatingSystemVersion = DBToStr(SqlDataReader.Item("OperatingSystemVersion"))
                TechnologicalPlatform.Illuminance = DBToStr(SqlDataReader.Item("Illuminance"))
                TechnologicalPlatform.FontType = DBToStr(SqlDataReader.Item("FontType"))
                TechnologicalPlatform.ProcessingActions = DBToStr(SqlDataReader.Item("ProcessingActions"))
                TechnologicalPlatform.ProcessingSoftwareName = DBToStr(SqlDataReader.Item("ProcessingSoftwareName"))
                TechnologicalPlatform.ProcessingSoftwareVersion = DBToStr(SqlDataReader.Item("ProcessingSoftwareVersion"))
                TechnologicalPlatform.ProcessingOSName = DBToStr(SqlDataReader.Item("ProcessingOSName"))
                TechnologicalPlatform.ProcessingOSVersion = DBToStr(SqlDataReader.Item("ProcessingOSVersion"))
                TechnologicalPlatform.ColorManager = DBToStr(SqlDataReader.Item("ColorManager"))
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return TechnologicalPlatform
        End Function

        Public Function SelectProjectTechnologicalPlatform(ByVal ProjectID As Int64) As TechnologicalPlatform
            Dim TechnologicalPlatform As New TechnologicalPlatform
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT * FROM TechnologicalPlatform TP " & _
                                         "INNER JOIN Projects P ON TP.ID=P.TechnologicalPlatformID " & _
                                         "WHERE ProjectID={0}", ProjectID)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    TechnologicalPlatform.ID = SqlDataReader.Item("ID")
                    TechnologicalPlatform.Designation = DBToStr(SqlDataReader.Item("Designation"))
                    TechnologicalPlatform.Name = DBToStr(SqlDataReader.Item("Name"))
                    TechnologicalPlatform.DeviceSource = DBToStr(SqlDataReader.Item("DeviceSource"))
                    TechnologicalPlatform.Manufacturer = DBToStr(SqlDataReader.Item("Manufacturer"))
                    TechnologicalPlatform.Software = DBToStr(SqlDataReader.Item("Software"))
                    TechnologicalPlatform.SoftwareVersion = DBToStr(SqlDataReader.Item("SoftwareVersion"))
                    TechnologicalPlatform.OperatingSystem = DBToStr(SqlDataReader.Item("OperatingSystem"))
                    TechnologicalPlatform.OperatingSystemVersion = DBToStr(SqlDataReader.Item("OperatingSystemVersion"))
                    TechnologicalPlatform.Illuminance = DBToStr(SqlDataReader.Item("Illuminance"))
                    TechnologicalPlatform.FontType = DBToStr(SqlDataReader.Item("FontType"))
                    TechnologicalPlatform.ProcessingActions = DBToStr(SqlDataReader.Item("ProcessingActions"))
                    TechnologicalPlatform.ProcessingSoftwareName = DBToStr(SqlDataReader.Item("ProcessingSoftwareName"))
                    TechnologicalPlatform.ProcessingSoftwareVersion = DBToStr(SqlDataReader.Item("ProcessingSoftwareVersion"))
                    TechnologicalPlatform.ProcessingOSName = DBToStr(SqlDataReader.Item("ProcessingOSName"))
                    TechnologicalPlatform.ProcessingOSVersion = DBToStr(SqlDataReader.Item("ProcessingOSVersion"))
                    TechnologicalPlatform.ColorManager = DBToStr(SqlDataReader.Item("ColorManager"))
                End While
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return TechnologicalPlatform
        End Function

        Public Function SelectTechnologicalPlatformID(ByVal ProjectID As Integer) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT TechnologicalPlatformID FROM Projects WHERE ProjectID={0}", ProjectID)

                Return DBToInt(SqlCommand.ExecuteScalar)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectProjectTechnologicalPlatform(ByVal ProjectID As Integer) As String
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT TP.Name FROM TechnologicalPlatform TP " & _
                                        "INNER JOIN Projects P ON TP.ID=P.TechnologicalPlatformID " & _
                                        "WHERE ProjectID={0}", ProjectID)

                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function
#End Region

#Region "SELECT ReformattingNorms"

        Public Function SelectReformattingNorms() As ReformattingNormCollection
            Dim ReformattingNormCollection As New ReformattingNormCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT * FROM ReformattingNorms", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    ReformattingNormCollection.Add(SqlDataReader.Item("ReformattingNormID"), DBToStr(SqlDataReader.Item("ReformattingNorm")), DBToStr(SqlDataReader.Item("Description")))
                End While
                Return ReformattingNormCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectReformattingNorms(ByVal PreservationActionID As Integer) As ReformattingNormCollection
            Dim ReformattingNormCollection As New ReformattingNormCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT RN.ReformattingNormID, RN.ReformattingNorm, Description " & _
                                            "FROM ReformattingNorms RN " & _
                                            "INNER JOIN PreservationNorms PN ON RN.ReformattingNormID=PN.ReformattingNormID " & _
                                            "WHERE PreservationActionID={0}", PreservationActionID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    ReformattingNormCollection.Add(SqlDataReader.Item("ReformattingNormID"), DBToStr(SqlDataReader.Item("ReformattingNorm")), DBToStr(SqlDataReader.Item("Description")))
                End While
                Return ReformattingNormCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT ReformattingMethods"

        Public Function SelectReformattingMethods() As ReformattingMethodCollection
            Dim ReformattingMethodCollection As New ReformattingMethodCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand("SELECT * FROM ReformattingMethods", SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    ReformattingMethodCollection.Add(SqlDataReader.Item("ReformattingMethodID"), DBToStr(SqlDataReader.Item("ReformattingMethod")), DBToStr(SqlDataReader.Item("Description")))
                End While
                Return ReformattingMethodCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT Preservation actions"

        Public Function SelectHistoricalPresevation(ByVal intDigitalObjectID As Integer) As DataSet
            Dim myData As New DataSet
            Dim SqlDataReader As SqlDataAdapter
            Dim command As String
            Try
                command = "SELECT * FROM PreservationAction PA " & _
                        "LEFT JOIN ReformattingMethods RM ON PA.ReformattingMethodID=RM.ReformattingMethodID " & _
                        "WHERE DigitalObjectID = " & intDigitalObjectID
                SqlDataReader = New SqlDataAdapter(command, ConnectionString)
                SqlDataReader.Fill(myData)
            Catch e As SqlException
                Throw (e)
            End Try
            Return myData
        End Function

#End Region

#Region "SELECT BLOBS"

        Function SelectBLOB(ByVal ID As Int64) As Byte()
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT Data FROM BLOBS WHERE ID = {0}", ID), SqlConnection)
                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()

                Dim BLOB(SqlDataReader.GetBytes(0, 0, Nothing, 0, Integer.MaxValue) - 1) As Byte
                SqlDataReader.GetBytes(0, 0, BLOB, 0, BLOB.Length)

                Return BLOB
            Catch e As Exception
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "SELECT file properties"

        Public Function SelectProperties(ByVal FileID As Int64) As Hashtable
            Dim myData As New Hashtable
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("SELECT Property, Value FROM Properties " & _
                                        "WHERE FileID={0}", FileID)
                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read
                    myData.Add(SqlDataReader.Item("Property"), SqlDataReader.Item("Value"))
                End While
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return myData
        End Function

#End Region

#Region "SELECT all fonds"

        'Public Function SelectAllFonds() As DataSet
        '    Dim myData As New DataSet
        '    Dim SqlDataAdapter As SqlDataAdapter
        '    Dim StrCommand As String
        '    Try
        '        StrCommand = "SELECT ID, UnitID, UnitTitle FROM Components " & _
        '                     "WHERE OtherLevel='F' " & _
        '                     "ORDER BY UnitID"

        '        SqlDataAdapter = New SqlDataAdapter(StrCommand, ConnectionString)
        '        SqlDataAdapter.Fill(myData)
        '    Catch e As SqlException
        '        MsgBox(e.Message, MsgBoxStyle.Critical)
        '    Finally
        '        SqlDataAdapter.Dispose()
        '    End Try
        '    Return myData
        'End Function

        Public Function SelectAllFonds() As ComponentCollection
            Dim ComponentCollection As New ComponentCollection
            Dim SQLCommand As New SQLCommand
            Dim SqlConnection As New SqlConnection
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.ConnectionString = ConnectionString
                SQLCommand.Connection = SqlConnection
                SQLCommand.CommandTimeout = ConnectTimeout
                SqlConnection.Open()
                SQLCommand.CommandText = "SELECT ID, UnitID, UnitTitle, OtherLevel FROM Components " & _
                                         "WHERE OtherLevel='F' " & _
                                         "ORDER BY UnitID"
                SqlDataReader = SQLCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim Component As New Components(SqlDataReader.Item("ID"), _
                                                   DBToStr(SqlDataReader.Item("UnitID")), _
                                                   DBToStr(SqlDataReader.Item("UnitTitle")), _
                                                   DBToStr(SqlDataReader.Item("OtherLevel")))

                    ComponentCollection.Add(Component)
                End While
                Return ComponentCollection
            Catch e As Exception
                MsgBox(e.Message)
            Finally
                SqlDataReader.Close()
                SqlDataReader = Nothing
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Count fond elements"

        Public Function SelectComponentsCount(ByVal FondID As Int64) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SQLCommand As New SQLCommand
            Try
                SqlConnection.Open()
                SQLCommand.Connection = SqlConnection
                SQLCommand.CommandText = String.Format("SELECT Count(ID) FROM Components " & _
                                        "WHERE ParentFondsID={0}", FondID)

                Return SQLCommand.ExecuteScalar
            Catch e As SqlException
                MsgBox(e.Message, MsgBoxStyle.Critical)
            Finally
                SQLCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Get ParentFondsID"

        Public Function SelectParentFondsID(ByVal ComponentID As Int64) As Int64
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SQLCommand As New SQLCommand
            Try
                SqlConnection.Open()
                SQLCommand.Connection = SqlConnection
                SQLCommand.CommandText = String.Format("SELECT ParentFondsID FROM Components " & _
                                        "WHERE ID={0}", ComponentID)

                Return SQLCommand.ExecuteScalar
            Catch e As SqlException
                MsgBox(e.Message, MsgBoxStyle.Critical)
            Finally
                SQLCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Find ComponentID From Reference"

        Public Function FindComponentID(ByVal Reference As String, ByVal ParentFondsID As Int64) As Components
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SQLCommand As New SQLCommand
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SQLCommand.Connection = SqlConnection
                Dim Filter As String
                If ParentFondsID Then Filter = String.Format("AND ParentFondsID={0}", ParentFondsID)
                SQLCommand.CommandText = String.Format("SELECT ID, CompleteUnitID, OtherLevel FROM Components " & _
                                         "WHERE REPLACE(CompleteUnitID,'/','-') LIKE '%{0}' {1}", Reference, Filter)

                SqlDataReader = SQLCommand.ExecuteReader
                While SqlDataReader.Read
                    Return New Components(DBToInt(SqlDataReader.Item("ID")), DBToStr(SqlDataReader.Item("CompleteUnitID")), DBToStr(SqlDataReader.Item("OtherLevel")))
                End While
            Catch e As SqlException
                MsgBox(e.Message, MsgBoxStyle.Critical)
            Finally
                SqlDataReader.Close()
                SQLCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Select Components info"

        Public Function SqlCommandSelectDigitArqToTree(ByVal FondID As Int64) As Components
            Dim SQLCommand As New SQLCommand
            Dim SqlConnection As New SqlConnection
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.ConnectionString = ConnectionString
                SQLCommand.Connection = SqlConnection
                SqlConnection.Open()
                SQLCommand.CommandText = String.Format("SELECT DISTINCT ID, ParentID, HasChildren, UnitID, OtherLevel, UnitTitle, DG.ComponentID " & _
                                        "FROM Components C " & _
                                        "LEFT JOIN DaoGrp DG ON C.ID = DG.ComponentID " & _
                                        "WHERE ID={0} AND OtherLevel = 'F' " & _
                                        "ORDER BY UnitID", FondID)
                SqlDataReader = SQLCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim Component As New Components(SqlDataReader.Item("ID"), _
                                                   DBToInt(SqlDataReader.Item("ParentID")), _
                                                   DBToStr(SqlDataReader.Item("OtherLevel")), _
                                                   DBToStr(SqlDataReader.Item("UnitID")), _
                                                   DBToStr(SqlDataReader.Item("UnitTitle")), _
                                                   DBToBool(SqlDataReader.Item("HasChildren")))

                    If DBToStr(SqlDataReader.Item("ComponentID")).Equals("") Then
                        Component.Associated = False
                    Else
                        Component.Associated = True
                    End If
                    Return Component
                End While
            Catch e As Exception
                MsgBox(e.Message)
            Finally
                SqlDataReader.Close()
                SqlDataReader = Nothing
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function Children(ByVal myID As Integer) As ComponentCollection
            Dim SqlConnection As New SqlConnection
            Dim SQLCommand As New SQLCommand
            Dim SqlDataReader As SqlDataReader
            Dim ComponentCollection As New ComponentCollection

            Try
                SqlConnection.ConnectionString = ConnectionString
                SQLCommand.Connection = SqlConnection
                SqlConnection.Open()
                SQLCommand.CommandText = String.Format("SELECT DISTINCT ID, ParentID, HasChildren, UnitID, OtherLevel, UnitTitle, DG.ComponentID " & _
                                                    "FROM Components C " & _
                                                    "LEFT JOIN DaoGrp DG ON C.ID=DG.ComponentID " & _
                                                    "WHERE ParentID = '{0}' ORDER BY UnitID", myID)
                SqlDataReader = SQLCommand.ExecuteReader()
                While SqlDataReader.Read
                    Dim Component As New Components(SqlDataReader.Item("ID"), _
                                                   DBToInt(SqlDataReader.Item("ParentID")), _
                                                   DBToStr(SqlDataReader.Item("OtherLevel")), _
                                                   DBToStr(SqlDataReader.Item("UnitID")), _
                                                   DBToStr(SqlDataReader.Item("UnitTitle")), _
                                                   DBToBool(SqlDataReader.Item("HasChildren")))

                    If DBToStr(SqlDataReader.Item("ComponentID")).Equals("") Then
                        Component.Associated = False
                    Else
                        Component.Associated = True
                    End If
                    ComponentCollection.Add(Component)
                End While

            Catch ex As Exception
                MsgBox(ex)
            Finally
                SqlDataReader.Close()
                SQLCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return ComponentCollection
        End Function

#End Region

#Region "Associonations"

        Public Function SelectDigitalObjectAssociations(ByVal DigitalObjectID As Int64, Optional ByVal FileID As Int64 = -1) As DaoGrpCollection
            Dim DaoGrpCollection As New DaoGrpCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT C.ID, C.ParentFondsID, C.CompleteUnitID, C.OtherLevel, C.UnitTitle " & _
                            "FROM DaoGrp DG " & _
                            "INNER JOIN Components C ON DG.ComponentID=C.ID " & _
                            "WHERE DG.DigitalObjectID ={0} AND DG.FileID={1}", DigitalObjectID, FileID), SqlConnection)

                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim DaoGrp As New DaoGrp(SqlDataReader("ID"), DigitalObjectID, FileID)
                    DaoGrp.ParentFondsID = SqlDataReader("ParentFondsID")
                    DaoGrp.CompleteUnitID = DBToStr(SqlDataReader("CompleteUnitID"))
                    DaoGrp.OtherLevel = DBToStr(SqlDataReader("OtherLevel"))
                    DaoGrp.UnitTitle = DBToStr(SqlDataReader("UnitTitle"))
                    DaoGrpCollection.Add(DaoGrp)
                End While
                Return DaoGrpCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectComponentAssociations(ByVal ComponentID As Int64) As DaoGrpCollection
            Dim DaoGrpCollection As New DaoGrpCollection
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("SELECT DG.ComponentID, DG.DigitalObjectID, DG.FileID, DG.Type, P.Name AS ProjectName, DO.Name AS DigitalObjectName, DOF.Name AS FileName " & _
                            "FROM DaoGrp DG " & _
                            "INNER JOIN DigitalObjects DO ON DG.DigitalObjectID=DO.DigitalObjectID " & _
                            "INNER JOIN Projects P ON DO.ProjectID=P.ProjectID " & _
                            "INNER JOIN Files DOF ON DG.FileID=DOF.ID " & _
                            "WHERE ComponentID={0} " & _
                            "ORDER BY DG.Type, DG.DigitalObjectID", ComponentID), SqlConnection)

                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read()
                    Dim DaoGrp As New DaoGrp(ComponentID, SqlDataReader("DigitalObjectID"), SqlDataReader("FileID"))
                    DaoGrp.ProjectName = DBToStr(SqlDataReader("ProjectName"))
                    DaoGrp.DigitalObjectName = DBToStr(SqlDataReader("DigitalObjectName"))
                    DaoGrp.FileName = DBToStr(SqlDataReader("FileName"))
                    DaoGrpCollection.Add(DaoGrp)
                End While
                Return DaoGrpCollection
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader = Nothing
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "General SELECT"

        Public Function SelectByCommand(ByVal strCommand As String) As DataSet
            Dim myData As New DataSet
            Dim SqlDataReader As SqlDataAdapter
            Dim SqlCommand As String
            Try
                SqlCommand = strCommand
                SqlDataReader = New SqlDataAdapter(SqlCommand, ConnectionString)
                SqlDataReader.Fill(myData)
            Catch e As SqlException
                Throw (e)
            Finally
                SqlDataReader.Dispose()
            End Try
            Return myData
        End Function

#End Region

#End Region

#Region "Functions/Procedures to INSERT information into tables"

#Region "INSERT Project"

        Public Function InsertProject(ByVal Project As MGOD.Project) As Int64
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            SqlCommand.Connection = SqlConnection
            Try
                SqlCommand.Connection.Open()
                SqlCommand.CommandText = String.Format("INSERT INTO Projects(Name, Description, " & _
                                        "CreationDateTime, LastUpdateDateTime, Username) " & _
                                        "VALUES ('{0}','{1}','{2}','{3}','{4}')", _
                                        Project.Name, Project.Description, _
                                        Project.CreationDateTime, Project.LastUpdateDateTime, Project.Username)
                SqlCommand.ExecuteNonQuery()

                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT DigitalObject"

        Public Function InsertDigitalObject(ByVal DigitalObject As DigitalObject) As Int64
            If DigitalObject Is Nothing Then Return 0

            Dim SqlCommand As New SqlCommand
            Dim SqlConnection As New SqlConnection

            SqlConnection.ConnectionString = ConnectionString
            SqlCommand.Connection = SqlConnection
            Try
                SqlCommand.Connection.Open()
                SqlCommand.CommandText = String.Format("INSERT INTO DigitalObjects(ProjectID, Name, " & _
                        "OriginalName, ArchiveID, ArchivingProfile, ResponsabilityEntity, " & _
                        "CaptureEntityCorporate, CaptureEntityIndividual, " & _
                        "CreationDateTime, ArchiveDateTime, DepositDateTime, " & _
                        "RevisionDateTime, ExternalDescriptiveInformation, PreservationOriginalInformation, " & _
                        "TopographicalQuota, UserName, Active) " & _
                        "VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}')", _
                        DigitalObject.ProjectID, DigitalObject.Name, DigitalObject.OriginalName, _
                        DigitalObject.ArchiveID, DigitalObject.ArchivingProfile, DigitalObject.ResponsabilityEntity, _
                        DigitalObject.CaptureEntityCorporate, DigitalObject.CaptureEntityIndividual, _
                        DigitalObject.CreationDateTime, DigitalObject.ArchiveDateTime, _
                        DigitalObject.DepositDateTime, DigitalObject.RevisionDateTime, DigitalObject.ExternalDescriptiveInformation, _
                        DigitalObject.PreservationOriginalInformation, DigitalObject.TopographicalQuota, _
                        DigitalObject.UserName, BoolToDB(DigitalObject.Active))

                If SqlCommand.ExecuteNonQuery() Then
                    SqlCommand.CommandText = "SELECT @@IDENTITY"
                    Return SqlCommand.ExecuteScalar
                Else
                    Return 0
                End If
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT ControlledVocabularies"

        Public Function InsertControlledVocabulary(ByVal Name As String) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO ControlledVocabularies VALUES ('{0}');", Name)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = String.Format("SELECT @@IDENTITY")
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function InsertControlledVocabularyValue(ByVal Name As String, ByVal VocabularyID As Integer) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO [Values] VALUES ('{0}',{1});", Name, VocabularyID)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = String.Format("SELECT @@IDENTITY")
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function UpdateControlledVocabularyValues(ByVal VocabularyID As Integer, ByVal Values As Hashtable) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM [Values] WHERE VocabularyID={0};", VocabularyID)
                SqlCommand.ExecuteNonQuery()
                For Each Key As Int64 In Values.Keys
                    SqlCommand.CommandText = String.Format("INSERT INTO [Values] VALUES ('{0}',{1});", Values(Key), VocabularyID)
                    SqlCommand.ExecuteNonQuery()
                Next
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT RevisionInterval"

        Public Function InsertRevisionInterval(ByVal Value As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = "DELETE FROM RevisionInterval;"
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = String.Format("INSERT INTO RevisionInterval VALUES('{0}');", Value)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT DigitalizationProfiles"

        Public Function InsertDigitalizationProfile(ByVal Profile As DigitalizationProfile) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO DigitalizationProfile(Name, Description, " & _
                                        "Resolution, BitDepth, Format, Compression, Orientation, Brightness, Contrast, Sharpness, Blur) " & _
                                        "VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}')", _
                                        Profile.Name, Profile.Description, Profile.Resolution, _
                                        Profile.BitDepth, Profile.Format, Profile.Compression, _
                                        Profile.Orientation, Profile.Brightness, Profile.Contrast, _
                                        Profile.Sharpness, Profile.Blur)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT TechnologicalPlatform"

        Public Function InsertTechnologicalPlatform(ByVal TechnologicalPlatform As TechnologicalPlatform) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO TechnologicalPlatform (Designation, Name, DeviceSource, Manufacturer, " & _
                                        "Software, SoftwareVersion, OperatingSystem, OperatingSystemVersion, Illuminance, FontType) " & _
                                        "VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}')", TechnologicalPlatform.Designation, _
                                        TechnologicalPlatform.Name, TechnologicalPlatform.DeviceSource, TechnologicalPlatform.Manufacturer, _
                                        TechnologicalPlatform.Software, TechnologicalPlatform.SoftwareVersion, _
                                        TechnologicalPlatform.OperatingSystem, TechnologicalPlatform.OperatingSystemVersion, _
                                        TechnologicalPlatform.Illuminance, TechnologicalPlatform.FontType)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT DOFiles"

        Public Function InsertFile(ByVal DOFile As DOFile) As Int64
            If DOFile Is Nothing Then Return 0

            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO Files(Name, Format, Length, MD5, CreationDateTime, HasDissemination, " & _
                                        "OriginalURL, DisseminationURL, ThumbnailURL, DigitalObjectID, Username) " & _
                                        "VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}', '{7}', '{8}', '{9}', '{10}')", _
                                        DOFile.Name, DOFile.Format, DOFile.Length, DOFile.MD5, DOFile.CreationDateTime, _
                                        BoolToDB(DOFile.HasDissemination), DOFile.OriginalURL, DOFile.DisseminationURL, _
                                        DOFile.ThumbnailURL, DOFile.DigitalObjectID, DOFile.UserName)

                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT Properties"

        Public Function InsertProperties(ByVal FileID As Int64, ByVal Properties As Hashtable) As Boolean
            If FileID = 0 Then Return False
            If Properties Is Nothing Then Return True

            Dim SqlConnection As New SqlConnection
            Dim SqlCommand As New SqlCommand
            SqlConnection.ConnectionString = ConnectionString
            SqlCommand.Connection = SqlConnection

            Try
                SqlCommand.Connection.Open()
                SqlCommand.CommandText = String.Format("DELETE FROM Properties WHERE FileID={0};", FileID)
                SqlCommand.ExecuteNonQuery()
                For Each PropertyName As String In Properties.Keys
                    SqlCommand.CommandText = String.Format("INSERT INTO Properties(FileID, Property, Value) " & _
                                            "VALUES ('{0}','{1}','{2}')", FileID, PropertyName, Properties(PropertyName))
                    SqlCommand.ExecuteNonQuery()
                Next
                Return True
            Catch e As SqlException
                'throw(e)
                Debug.Write(e.ToString)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT ReformattingNorm"

        Public Function InsertReformattingNorm(ByVal ReformattingNorm As ReformattingNorm) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO ReformattingNorms(ReformattingNorm, Description) " & _
                                        "VALUES ('{0}','{1}')", ReformattingNorm.ReformattingNorm, ReformattingNorm.Description)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT ReformattingMethod"

        Public Function InsertReformattingMethod(ByVal ReformattingMethod As ReformattingMethod) As Integer
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO ReformattingMethods(ReformattingMethod, Description) " & _
                                        "VALUES ('{0}','{1}')", ReformattingMethod.ReformattingMethod, ReformattingMethod.Description)

                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Return SqlCommand.ExecuteScalar
            Catch e As SqlException
                Throw (e)
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT PreservationAction"

        Public Function InsertPrervationAction(ByVal ArchiveNextDateTime As String, ByVal RevisionDateTime As String, _
            ByVal Transformer As String, ByVal Platform As String, ByVal RenderEngine As String, _
            ByVal InputFormat As String, ByVal Parameters As String, ByVal ReformattingMethodID As Integer, _
            ByVal ReformattingNorms As ArrayList, ByVal DigitalObjectID As Integer) As Boolean

            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("INSERT INTO PreservationAction" & _
                    " VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}',{7},{8})", _
                    StrToDB(ArchiveNextDateTime), StrToDB(RevisionDateTime), StrToDB(Transformer), _
                    StrToDB(Platform), StrToDB(RenderEngine), StrToDB(InputFormat), StrToDB(Parameters), _
                    IntToQry(ReformattingMethodID), Int64ToDB(DigitalObjectID))
                SqlCommand.ExecuteNonQuery()

                SqlCommand.CommandText = "SELECT @@IDENTITY"
                Dim PreservationActionID As Integer = SqlCommand.ExecuteScalar

                For i As Integer = 0 To ReformattingNorms.Count - 1
                    SqlCommand.CommandText = String.Format("INSERT INTO PreservationNorms" & _
                                        " VALUES ('{0}','{1}')", _
                                        PreservationActionID, ReformattingNorms(i))
                    SqlCommand.ExecuteNonQuery()
                Next
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "INSERT DaoGrp"

        ' Associates a description object to a digital object
        Public Function InsertDaoGrp(ByVal ComponentID As Int64, _
                                  ByVal DigitalObjectID As Int64) As Boolean

            Return InsertDaoGrp(ComponentID, DigitalObjectID, -1, AssociationType.DigitalObject)
        End Function


        ' Associates a description object to a file within a digital object 
        Public Function InsertDaoGrp(ByVal ComponentID As Int64, _
                                     ByVal DigitalObjectID As Int64, _
                                     ByVal FileID As Int64) As Boolean

            Return InsertDaoGrp(ComponentID, DigitalObjectID, FileID, AssociationType.File)
        End Function


        Public Function InsertDaoGrp(ByVal ComponentID As Int64, _
                                     ByVal DigitalObjectID As Int64, _
                                     ByVal FileID As Int64, _
                                     ByVal Type As AssociationType) As Boolean

            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SQLCommand As New SQLCommand
            Try
                SqlConnection.Open()
                SQLCommand.Connection = SqlConnection
                SQLCommand.CommandText = String.Format("INSERT INTO DaoGrp(ComponentID, DigitalObjectID, FileID, Type) " & _
                                        "VALUES ({0},{1},{2},{3})", ComponentID, DigitalObjectID, FileID, CInt(Type))
                SQLCommand.ExecuteNonQuery()
                Return True
            Catch ex As Exception
                'throw(ex)
                Return False
            Finally
                SQLCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#End Region

#Region "Functions/Procedures to UPDATE information into tables"

#Region "UPDATE Project"

        Public Function UpdateProject(ByVal Project As Project) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("UPDATE Projects SET Name='{0}', " & _
                                        "Description='{1}', LastUpdateDateTime='{2}', Username='{3}', " & _
                                        "DigitalizationProfileID={4}, TechnologicalPlatformID={5} " & _
                                        "WHERE ProjectID={6};", _
                                        Project.Name, Project.Description, Project.LastUpdateDateTime, Project.Username, _
                                        IntToQry(Project.DigitalizationProfileID), IntToQry(Project.TechnologicalPlatformID), Project.ProjectID)
                SqlCommand.ExecuteNonQuery()
                SqlConnection.Close()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        'Public Function UpdateProject(ByVal ProjectID As Int64, ByVal ProjectName As String, _
        '    ByVal Description As String, ByVal LastUpdateDateTime As String, _
        '    ByVal DigitalizationProfileID As Integer, ByVal TechnologicalPlatformID As Integer) As Boolean

        '    Dim SqlCommand As New SqlCommand
        '    Dim SqlConnection As New SqlConnection

        '    SqlConnection.ConnectionString = ConnectionString
        '    SqlCommand.Connection = SqlConnection
        '    Try
        '        SqlCommand.Connection.Open()
        '        SqlCommand.CommandText = String.Format("UPDATE Projects SET Name='{0}', " & _
        '            "Description='{1}', LastUpdateDateTime='{2}', DigitalizationProfileID={3}, TechnologicalPlatformID={4} " & _
        '            "WHERE ProjectID = {5}", _
        '            ProjectName, Description, LastUpdateDateTime, IntToDB(DigitalizationProfileID), IntToDB(TechnologicalPlatformID), ProjectID)

        '        SqlCommand.ExecuteNonQuery()
        '        Return True
        '    Catch e As SqlException
        '        throw(e)
        '        Return False
        '    Finally
        '        SqlCommand.Dispose()
        '        SqlConnection.Close()
        '        SqlConnection.Dispose()
        '    End Try
        'End Function

#End Region

#Region "UPDATE DigitalObject"

        Public Function UpdateDigitalObject(ByVal DigitalObject As DigitalObject) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("UPDATE DigitalObjects SET " & _
                    "Name='{0}', OriginalName='{1}', ArchiveId='{2}', ArchivingProfile='{3}', " & _
                    "ResponsabilityEntity='{4}', CaptureEntityCorporate='{5}', CaptureEntityIndividual='{6}', ArchiveDateTime='{7}', " & _
                    "DepositDateTime='{8}', ExternalDescriptiveInformation='{9}', PreservationOriginalInformation='{10}', " & _
                    "TopographicalQuota='{11}', Active='{12}' " & _
                    "WHERE DigitalObjectID = '{13}'", DigitalObject.Name, DigitalObject.OriginalName, _
                    DigitalObject.ArchiveID, DigitalObject.ArchivingProfile, DigitalObject.ResponsabilityEntity, _
                    DigitalObject.CaptureEntityCorporate, DigitalObject.CaptureEntityIndividual, _
                    DigitalObject.ArchiveDateTime, DigitalObject.DepositDateTime, _
                    DigitalObject.ExternalDescriptiveInformation, DigitalObject.PreservationOriginalInformation, _
                    DigitalObject.TopographicalQuota, BoolToDB(DigitalObject.Active), DigitalObject.DigitalObjectID)

                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function UpdateRevisionDateTime(ByVal DigitalObjectID As Int64, ByVal RevisionDateTime As String) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("UPDATE DigitalObjects SET RevisionDateTime='{0}' " & _
                                            "WHERE DigitalObjectID = {1}", RevisionDateTime, DigitalObjectID), SqlConnection)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch ex As Exception
                Throw (ex)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function UpdateDOStructure(ByVal DigitalObjectID As Int64, ByVal XML As String) As Boolean
            If DigitalObjectID = 0 Then Return False
            If XML Is Nothing Then Return False

            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Dim Query As String
            Try
                SqlConnection.Open()
                Query = String.Format("UPDATE DigitalObjects SET Structure='{0}' WHERE DigitalObjectID={1}", XML.Replace("'", """"), DigitalObjectID)
                SqlCommand = New SqlCommand(Query, SqlConnection)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch ex As Exception
                Throw (ex)
                Debug.WriteLine(Query)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Function SetActive(ByVal DigitalObjectID As Integer, ByVal Active As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("UPDATE DigitalObjects SET Active={0} " & _
                                            "WHERE DigitalObjectID={1};", Active, DigitalObjectID), SqlConnection)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch ex As Exception
                Throw (ex)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "UPDATE File"

        Public Function UpdateDOFile(ByVal DOFile As DOFile) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("UPDATE Files SET Name='{0}', Length='{1}', " & _
                                            "Format='{2}', MD5='{3}', HasDissemination='{4}', " & _
                                            "OriginalURL='{5}', DisseminationURL='{6}', ThumbnailURL='{7}', " & _
                                            "DigitalObjectID='{8}', Username='{9}' " & _
                                            "WHERE ID={10}", DOFile.Name, DOFile.Length, DOFile.Format, DOFile.MD5, _
                                            BoolToDB(DOFile.HasDissemination), DOFile.OriginalURL, DOFile.DisseminationURL, _
                                            DOFile.ThumbnailURL, DOFile.DigitalObjectID, DOFile.UserName, DOFile.ID), SqlConnection)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch ex As Exception
                Throw (ex)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function InsertBLOB(ByVal FileID As Int64, ByVal BLOB As Byte()) As Int64
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("INSERT INTO BLOBS (FileID, Data) VALUES({0}, @BLOBData)", FileID), SqlConnection)

                Dim prm As New SqlParameter("@BLOBData", SqlDbType.VarBinary, BLOB.Length, _
                    ParameterDirection.Input, False, 0, 0, "Data", DataRowVersion.Current, BLOB)

                SqlCommand.Parameters.Add(prm)
                SqlCommand.ExecuteNonQuery()

                SqlCommand = New SqlCommand("SELECT @@IDENTITY", SqlConnection)
                Return SqlCommand.ExecuteScalar

            Catch ex As Exception
                Throw (ex)
                Return 0
            Finally
                SqlConnection.Close()
                SqlConnection.Dispose()
                GC.Collect()
            End Try
        End Function

        Public Function UpdateURLFile(ByVal FileID As Int64, ByVal URLField As String, ByVal URLValue As String) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand = New SqlCommand(String.Format("UPDATE Files SET {0}='{1}' WHERE ID={2}", URLField, URLValue, FileID), SqlConnection)
                SqlCommand.ExecuteNonQuery()

            Catch ex As Exception
                Throw (ex)
                Return False
            Finally
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return True
        End Function

#End Region

#Region "UPDATE Controlled Vocabularies"

        Public Function UpdateControlledVocabularies(ByVal Vocabularies As Hashtable) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As SqlCommand
            Try
                SqlConnection.Open()
                For Each Key As Int64 In Vocabularies.Keys
                    SqlCommand = New SqlCommand(String.Format("UPDATE ControlledVocabularies SET Name='{0}' " & _
                                                "WHERE ID = '{1}'", Vocabularies.Item(Key), Key), SqlConnection)
                    SqlCommand.ExecuteNonQuery()
                Next
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "UPDATE DigitalizationProfiles"

        Public Function UpdateDigitalizationProfile(ByVal Profile As DigitalizationProfile) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("UPDATE DigitalizationProfile SET Name='{0}', " & _
                    "Description='{1}', Orientation='{2}', Resolution='{3}', BitDepth='{4}', Format='{5}', " & _
                    "Compression='{6}', Brightness='{7}', Contrast='{8}', Sharpness='{9}', Blur='{10}' " & _
                    "WHERE ID = '{11}'", Profile.Name, Profile.Description, Profile.Orientation, _
                    Profile.Resolution, Profile.BitDepth, Profile.Format, Profile.Compression, Profile.Brightness, _
                    Profile.Contrast, Profile.Sharpness, Profile.Blur, Profile.ID)

                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "UPDATE TechnologicalPlatform"

        Public Function UpdateTechnologicalPlatform(ByVal TechnologicalPlatform As TechnologicalPlatform) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("UPDATE TechnologicalPlatform SET Designation='{0}', Name = '{1}', " & _
                    "DeviceSource = '{2}', Manufacturer = '{3}', Software = '{4}', SoftwareVersion = '{5}', " & _
                    "OperatingSystem = '{6}', OperatingSystemVersion = '{7}', Illuminance='{8}', FontType='{9}', " & _
                    "ProcessingActions = '{10}', ProcessingSoftwareName = '{11}', ProcessingSoftwareVersion='{12}', " & _
                    "ProcessingOSName = '{13}', ProcessingOSVersion = '{14}', ColorManager='{15}' " & _
                    "WHERE ID = '{16}'", TechnologicalPlatform.Designation, TechnologicalPlatform.Name, TechnologicalPlatform.DeviceSource, _
                    TechnologicalPlatform.Manufacturer, TechnologicalPlatform.Software, TechnologicalPlatform.SoftwareVersion, _
                    TechnologicalPlatform.OperatingSystem, TechnologicalPlatform.OperatingSystemVersion, _
                    TechnologicalPlatform.Illuminance, TechnologicalPlatform.FontType, _
                    TechnologicalPlatform.ProcessingActions, TechnologicalPlatform.ProcessingSoftwareName, _
                    TechnologicalPlatform.ProcessingSoftwareVersion, TechnologicalPlatform.ProcessingOSName, _
                    TechnologicalPlatform.ProcessingOSVersion, TechnologicalPlatform.ColorManager, TechnologicalPlatform.ID)

                SqlCommand.ExecuteNonQuery()
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return True
        End Function

#End Region

#Region "UPDATE CheckSum of a file"

        Public Function UpdateCheckSumDOFile(ByVal FileID As Int64, ByVal CheckSum As String) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim Command As String
            Try
                Command = String.Format("UPDATE Files SET MD5 = '{0}' WHERE FileID = {1}", CheckSum, FileID)
                Dim SqlCommand As New SqlCommand(Command, SqlConnection)
                SqlConnection.Open()
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch ex As Exception
                Throw (ex)
                Return False
            Finally
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "UPDATE ReformattingNorm"

        Public Function UpdateReformattingNorm(ByVal ReformattingNorm As ReformattingNorm) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("UPDATE ReformattingNorms SET ReformattingNorm='{0}', Description='{1}' " & _
                                         "WHERE ReformattingNormID={2}", _
                                         ReformattingNorm.ReformattingNorm, ReformattingNorm.Description, ReformattingNorm.ReformattingNormID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "UPDATE ReformattingMethod"

        Public Function UpdateReformattingMethod(ByVal ReformattingMethod As ReformattingMethod) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("UPDATE ReformattingMethods SET ReformattingMethod='{0}', Description='{1}' " & _
                                         "WHERE ReformattingMethodID='{2}'", _
                                         ReformattingMethod.ReformattingMethod, ReformattingMethod.Description, ReformattingMethod.ReformattingMethodID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#End Region

#Region "Functions/Procedures to DELETE information from tables"

#Region "DELETE Project"

        Public Function DeleteProject(ByVal ProjectID As Int64) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandTimeout = ConnectTimeout
                SqlCommand.CommandText = String.Format("DELETE FROM DaoGrp WHERE DigitalObjectID IN (SELECT DigitalObjectID FROM DigitalObjects WHERE ProjectID='{0}')", ProjectID)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.CommandText = String.Format("DELETE FROM Projects WHERE ProjectID='{0}'", ProjectID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE DigitalObject"

        Public Function DeleteDigitalObject(ByVal DigitalObjectID As Int64) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandTimeout = ConnectTimeout
                SqlCommand.CommandText = String.Format("DELETE FROM DaoGrp WHERE DigitalObjectID='{0}'; " & _
                                         "DELETE FROM PreservationAction WHERE DigitalObjectID='{0}'; " & _
                                         "DELETE FROM DigitalObjects WHERE DigitalObjectID='{0}'", DigitalObjectID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE File"

        Public Function DeleteFile(ByVal FileID As Int64) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM Files WHERE ID={0};", FileID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE BLOB"

        Public Function DeleteBLOB(ByVal ID As Int64) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM BLOBS WHERE ID={0};", ID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE DigitalizationProfile"

        Public Function DeleteDigitalizationProfile(ByVal ID As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM DigitalizationProfile WHERE ID='{0}'", ID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE TechnologicalPlatform"

        Public Function DeleteTechnologicalPlatform(ByVal ID As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM TechnologicalPlatform WHERE ID='{0}'", ID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE Controlled Vocabulary"

        Public Function DeleteControlledVocabulary(ByVal ID As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM ControlledVocabularies WHERE ID={0}", ID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE ReformattingNorm"

        Public Function DeleteReformattingNorm(ByVal ReformattingNormID As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM ReformattingNorms " & _
                                         "WHERE ReformattingNormID = {0};", ReformattingNormID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE ReformattingMethod"

        Public Function DeleteReformattingMethod(ByVal ReformattingMethodID As Integer) As Boolean
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = String.Format("DELETE FROM ReformattingMethods " & _
                                         "WHERE ReformattingMethodID = '{0}'", ReformattingMethodID)
                SqlCommand.ExecuteNonQuery()
                Return True
            Catch e As SqlException
                Throw (e)
                Return False
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "DELETE Association"

        Public Function DeleteAssociation(ByVal ComponentID As Int64, ByVal DigitalObjectID As Int64, ByVal FileID As Int64) As DataSet
            Dim myData As New DataSet
            Dim SqlConnection As New SqlConnection(ConnectionString)
            Dim SQLCommand As New SQLCommand
            Try
                SQLCommand.Connection = SqlConnection
                SqlConnection.Open()
                SQLCommand.CommandText = String.Format("DELETE FROM DaoGrp " & _
                                         "WHERE ComponentID={0} " & _
                                         "AND DigitalObjectID={1} " & _
                                         "AND FileID={2};", ComponentID, DigitalObjectID, FileID)

                SQLCommand.ExecuteNonQuery()
            Catch e As SqlException
                MsgBox(e.Message, MsgBoxStyle.Critical)
            Finally
                SQLCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
            Return myData
        End Function

#End Region

#End Region

    End Class
End Namespace
