
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System

Namespace MGUP

    Public MustInherit Class SQLInterface

        Private myReturn As eReturn

        Public Enum eReturn
            Sucess
            ErrorDB
            ErrorNotProfile
            ErrorUsernamePass
            ErrorRepeatUsername
            ErrorNotActive
            ApplicationAccessDenied
        End Enum

        Property Return_() As eReturn
            Get
                Return myReturn
            End Get
            Set(ByVal Value As eReturn)
                myReturn = Value
            End Set
        End Property

#Region "Employee"

        Public MustOverride Function validateEmployee(ByVal strApplicationCode As String, ByVal strUserName As String, ByVal strPassword As String) As eReturn

        Public MustOverride Function storeEmployee(ByVal objEmployee As Employee)

        Public MustOverride Function validateStoreEmployee(ByVal strUserName As String) As Boolean

        Public MustOverride Function loadEmployee(ByVal strUserName As String) As Employee

        Public MustOverride Function loadEmployees(ByVal ListType As String, ByVal ApplicationCode As String) As DataSet

        Public MustOverride Function loadEmployees(ByVal intProfile As Integer, ByVal strApplicationCode As String) As DataSet

        Public MustOverride Function loadEmployees(ByVal strApplicationCode As String) As DataSet

        Public MustOverride Function loadFullEmployees() As DataSet

        Public MustOverride Sub updateEmployee(ByVal strUserName As String, ByVal intProfileID As Integer, ByVal strApplicationCode As String, ByVal bolActive As Boolean)

        Public MustOverride Sub updateEmployee(ByVal objEmployee As Employee)

        Public MustOverride Function countEmployees() As Integer

#End Region

#Region "Profiles"

        Public MustOverride Sub storeProfile(ByVal strProfileName As String, ByVal strApplicationCode As String)

        'Public MustOverride Function loadProfiles(ByVal rdbl As RadioButtonList, ByVal strApplicationCode As String)

        'Public MustOverride Function loadProfiles(ByVal ddl As DropDownList, ByVal strApplicationCode As String)

        'Public MustOverride Function loadProfiles(ByVal dg As DataGrid, ByVal strApplicationCode As String)

        Public MustOverride Function loadProfiles(ByVal strApplicationCode As String) As DataSet

        Public MustOverride Function getProfile(ByVal strUserName As String, ByVal strApplicationCode As String) As Profile

        Public MustOverride Sub deleteProfile(ByVal strProfileID As Integer)

        Public MustOverride Sub updateProfile(ByVal strProfileID As Integer, ByVal strProfileName As String)

#End Region

#Region "Profile functions"

        Public MustOverride Function getProfileFunctions(ByVal intProfile As Integer, ByVal intParentID As String) As FunctionCollection

        Public MustOverride Function getAllProfileFunctions(ByVal strApplicationCode As String, ByVal intProfile As Integer, ByVal intParentID As String) As FunctionCollection

        Public MustOverride Sub updateProfileFunctions(ByVal intPtofileID As Integer, ByVal alstFunctionsID As ArrayList)

#End Region

#Region "Functions"

        Public MustOverride Function getApplicationFunctions(ByVal strApplicationCode As String, ByVal strParentCode As String) As FunctionCollection

        Public MustOverride Function loadFunction(ByVal strFunctionCode As String) As _Function

        Public MustOverride Sub storeFunction(ByVal objFunction As _Function)

        Public MustOverride Sub updateFunction(ByVal objFunction As _Function)

        Public MustOverride Sub deleteFunction(ByVal strFunctionCode As String, ByVal strApplicationCode As String)

        Public MustOverride Function hasFunctionsChildren(ByVal strFunctionCode As String) As Boolean

        Public MustOverride Function accessFunction(ByVal strUserName As String, ByVal strFunctionCode As String) As Boolean

#End Region

#Region "Applications"

        Public MustOverride Function loadApplications() As DataSet

        'Public MustOverride Function loadApplications(ByVal ddl As DropDownList)

        'Public MustOverride Function loadApplications(ByVal rbl As RadioButtonList)

        'Public MustOverride Function loadApplications(ByVal cbl As CheckBoxList)

        'Public MustOverride Function loadApplications(ByVal dg As DataGrid)

        Public MustOverride Function getAllApplications() As Hashtable

        Public MustOverride Function loadApplication(ByVal strApplicationCode As String) As Application

        Public MustOverride Sub storeApplication(ByVal objApplication As Application)

        Public MustOverride Sub updateApplication(ByVal objApplication As Application)

        Public MustOverride Sub deleteApplication(ByVal strApplicationCode As String)

        Public MustOverride Function accessApplication(ByVal strUsername As String, ByVal strApplicationCode As String) As Boolean

#End Region

#Region "ApplicationEmployee"

        Public MustOverride Function loadApplicationsEmployee(ByVal strUserName As String) As ArrayList

        Public MustOverride Sub updateApplicationsEmployee(ByVal strUserName As String, ByVal hshApplicationsID As Hashtable)

#End Region

#Region "Utils"

        'MustOverride Sub loadDdl(ByVal ddl As DropDownList, ByVal strDataValueField As String, _
        'ByVal strDataTextField As String, ByVal strTable As String, Optional ByVal strStratItem As String = "Selecionar")

#End Region

    End Class




End Namespace
