#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient
Imports System.Threading
Imports System.Text
Imports System.Configuration
Imports System.String
Imports System.IO
Imports DigitArq.Utility.TypeConversion
Imports DigitArq.Utility.Cryptography

Namespace MGUP

    Public Class SQLDataBase
        Inherits SQLInterface


#Region "Properties connection"

        Private myReturn As eReturn
        Private hshDatabase As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        Private ServerAddress As String = hshDatabase("ServerAddress")
        Private GPUDatabase As String = hshDatabase("Database")
        Private Username As String = hshDatabase("Username")
        Private Password As String = hshDatabase("Password")
        Private ConnectTimeout As String = hshDatabase("ConnectTimeout")

        Private myConnectionString As String = String.Format("Data Source={0}; Initial Catalog={1}; User ID={2}; password={3}; Connect Timeout={4};", ServerAddress, GPUDatabase, Username, Password, ConnectTimeout)

#End Region


#Region "Employees"

        Public Overrides Function ValidateStoreEmployee(ByVal UserName As String) As Boolean
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_validateStoreEmployee", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlDataReader = SqlCommand.ExecuteReader
                If Not SqlDataReader.HasRows Then
                    Return True
                Else
                    Return False
                End If
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function StoreEmployee(ByVal Employee As Employee)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_storeEmployee", SqlConnection)

            Try
                If Not validateStoreEmployee(Employee.UserName) Then
                    myReturn = eReturn.ErrorRepeatUsername
                    Return 0
                End If
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", Employee.UserName)
                SqlCommand.Parameters.Add("@FirstName", Employee.FirstName)
                SqlCommand.Parameters.Add("@LastName", Employee.LastName)
                SqlCommand.Parameters.Add("@Password", Employee.Password)
                SqlCommand.Parameters.Add("@Obs", Employee.Obs)

                SqlCommand.ExecuteNonQuery()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function ValidateEmployee(ByVal ApplicationCode As String, ByVal UserName As String, ByVal Password As String) As eReturn
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_validateEmployee", SqlConnection)
            Dim SqlDataReader As SqlDataReader

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@Password", GenerateHash(Password))
                SqlDataReader = SqlCommand.ExecuteReader
                If Not SqlDataReader.HasRows Then
                    Return eReturn.ErrorUsernamePass
                ElseIf SqlDataReader.HasRows Then
                    While SqlDataReader.Read
                        If Not Me.accessApplication(UserName, ApplicationCode) Then
                            Return eReturn.ApplicationAccessDenied
                        ElseIf Not Me.getProfile(UserName, ApplicationCode).ProfileExists Then
                            Return eReturn.ErrorNotProfile
                        ElseIf IsDBNull(SqlDataReader.Item("Active")) Or SqlDataReader.Item("Active") = 0 Then
                            Return eReturn.ErrorNotActive
                        Else
                            Return eReturn.Sucess
                        End If
                    End While
                End If
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overloads Overrides Function LoadEmployee(ByVal UserName As String) As Employee
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadEmployeeByUN", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Dim objEmployee As New Employee
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)

                SqlDataReader = SqlCommand.ExecuteReader
                If Not SqlDataReader.HasRows Then
                    objEmployee.EmployeeExists = False
                    Return objEmployee
                Else
                    objEmployee.EmployeeExists = True
                End If
                While SqlDataReader.Read
                    objEmployee.UserName = SqlDataReader.Item("UserName")
                    objEmployee.FirstName = DBToStr(SqlDataReader.Item("FirstName"))
                    objEmployee.LastName = DBToStr(SqlDataReader.Item("LastName"))
                    objEmployee.Obs = DBToStr(SqlDataReader.Item("Obs"))
                End While
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
                Return objEmployee
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overloads Overrides Function LoadEmployees(ByVal ApplicationCode As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim SqlDataAdapter As SqlDataAdapter
            Dim DataSet As DataSet

            Try
                SqlConnection.Open()
                SqlDataAdapter = New SqlDataAdapter("sp_loadEmployees", SqlConnection)
                SqlDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                SqlDataAdapter.SelectCommand.Parameters.Add("@ListType", "0")
                SqlDataAdapter.SelectCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                DataSet = New DataSet
                SqlDataAdapter.Fill(DataSet)

                Return DataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
                SqlDataAdapter = Nothing
                SqlConnection = Nothing
            End Try
        End Function

        Public Overloads Overrides Function LoadEmployees(ByVal ListType As String, ByVal ApplicationCode As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim SqlDataAdapter As SqlDataAdapter
            Dim DataSet As DataSet

            Try
                SqlConnection.Open()
                SqlDataAdapter = New SqlDataAdapter("sp_loadEmployees", SqlConnection)
                SqlDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                SqlDataAdapter.SelectCommand.Parameters.Add("@ListType", ListType)
                SqlDataAdapter.SelectCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                DataSet = New DataSet
                SqlDataAdapter.Fill(DataSet)

                Return DataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overloads Overrides Function LoadEmployees(ByVal ProfileID As Integer, ByVal ApplicationCode As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_loadEmployeesByProfile", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                objDataAdapter.SelectCommand.Parameters.Add("@ProfileID", ProfileID)
                objDataAdapter.SelectCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function LoadFullEmployees() As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet
            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_loadFullEmployees", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                myReturn = eReturn.Sucess
                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function SelectAllEmployees() As EmployeeCollection
            Dim myData As New EmployeeCollection
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim myReader As SqlDataReader
            Dim myCommand As New SqlCommand
            Try
                SqlConnection.Open()
                myCommand.Connection = SqlConnection
                myCommand.CommandType = CommandType.StoredProcedure
                myCommand.CommandText = "sp_loadFullEmployees"
                myReader = myCommand.ExecuteReader
                While myReader.Read
                    myData.Add(myReader.Item("Username"))
                End While
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
                SqlConnection.Dispose()
                myCommand.Dispose()
                myReader.Close()
            End Try
            Return myData
        End Function

        Public Overloads Overrides Sub UpdateEmployee(ByVal UserName As String, ByVal ProfileID As Integer, ByVal ApplicationCode As String, ByVal Active As Boolean)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand
            Try
                SqlConnection.Open()
                SqlCommand.Connection = SqlConnection
                SqlCommand.CommandText = "sp_updateEmployee"
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@ProfileID", ProfileID)
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                SqlCommand.Parameters.Add("@Active", Active)
                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overloads Overrides Sub UpdateEmployee(ByVal Employee As Employee)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_updatePDEmployee", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", Employee.UserName)
                SqlCommand.Parameters.Add("@FirstName", Employee.FirstName)
                SqlCommand.Parameters.Add("@LastName", Employee.LastName)
                SqlCommand.Parameters.Add("@Obs", Employee.Obs)
                SqlCommand.Parameters.Add("@Password", Employee.Password)

                SqlCommand.ExecuteNonQuery()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Function CountEmployees() As Integer
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_countEmployees", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@Count", SqlDbType.Int)
                SqlCommand.Parameters("@Count").Direction = ParameterDirection.Output
                SqlCommand.ExecuteNonQuery()
                Return SqlCommand.Parameters("@Count").Value
            Catch ex As Exception
                Dim erro As String = ex.ToString
                Dim erro1 As String = ex.ToString
                Return 0
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Profiles"

        Public Overrides Sub StoreProfile(ByVal ProfileName As String, ByVal ApplicationCode As String)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_storeProfile", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ProfileName", ProfileName)
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overloads Overrides Function LoadProfiles(ByVal ApplicationCode As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim DataSet As New DataSet
            Dim da As New SqlDataAdapter("sp_loadProfiles", SqlConnection)
            Try
                SqlConnection.Open()
                da.SelectCommand.CommandType = CommandType.StoredProcedure
                da.SelectCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                da.Fill(DataSet)

                Return DataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                da.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overloads Overrides Function GetProfile(ByVal UserName As String, ByVal ApplicationCode As String) As Profile
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getProfile", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Dim objProfile As New Profile
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)

                SqlDataReader = SqlCommand.ExecuteReader
                If Not SqlDataReader.HasRows Then
                    objProfile.ProfileExists = False
                    Return objProfile
                Else
                    objProfile.ProfileExists = True
                End If
                While SqlDataReader.Read
                    objProfile.ProfileID = SqlDataReader.Item("ProfileID")
                    objProfile.Profile = SqlDataReader.Item("Profile")
                End While
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
                Return objProfile
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Sub DeleteProfile(ByVal ProfileID As Integer)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_deleteProfile", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ProfileID", ProfileID)
                SqlCommand.ExecuteNonQuery()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Sub UpdateProfile(ByVal ProfileID As Integer, ByVal ProfileName As String)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_updateProfile", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ProfileID", ProfileID)
                SqlCommand.Parameters.Add("@ProfileName", ProfileName)
                SqlCommand.ExecuteNonQuery()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

#End Region

#Region "Profile Functions"

        Public Overrides Function GetProfileFunctions(ByVal Profile As Integer, ByVal ParentID As String) As FunctionCollection
            Dim FunctionCollection As New FunctionCollection
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getProfileFunctions", SqlConnection)
            Dim SqlDataReader As SqlDataReader

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ProfileID", Profile)
                SqlCommand.Parameters.Add("@ParentCode", ParentID)
                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    Dim objFunction As New _Function
                    objFunction.FunctionCode = DBToStr(SqlDataReader.Item("FunctionCode"))
                    objFunction.FunctionName = DBToStr(SqlDataReader.Item("FunctionName"))

                    FunctionCollection.Add(objFunction)
                End While
                Return FunctionCollection

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function


        Public Overrides Function GetAllProfileFunctions(ByVal ApplicationCode As String, ByVal Profile As Integer, ByVal ParentID As String) As FunctionCollection
            Dim FunctionCollection As New FunctionCollection
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getAllProfileFunctions", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                SqlCommand.Parameters.Add("@ProfileID", Profile)
                SqlCommand.Parameters.Add("@ParentCode", ParentID)

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    Dim objFunction As New _Function
                    objFunction.FunctionCode = SqlDataReader.Item("FunctionCode")
                    objFunction.FunctionName = SqlDataReader.Item("FunctionName")
                    objFunction.IsInProfile = SqlDataReader.Item("Exist")
                    FunctionCollection.Add(objFunction)
                End While
                Return FunctionCollection

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Sub UpdateProfileFunctions(ByVal ProfileID As Integer, ByVal FunctionsID As ArrayList)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_deleteProfileFunctions", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ProfileID", ProfileID)
                SqlCommand.ExecuteNonQuery()
                SqlCommand.Parameters.Clear()

                SqlCommand.CommandText = "sp_insertProfileFunction"
                For i As Integer = 0 To FunctionsID.Count - 1
                    SqlCommand.Parameters.Add("@ProfileID", ProfileID)
                    SqlCommand.Parameters.Add("@FunctionCode", FunctionsID.Item(i))
                    SqlCommand.ExecuteNonQuery()
                    SqlCommand.Parameters.Clear()
                Next
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

#End Region

#Region "Functions"

        Public Overrides Function GetApplicationFunctions(ByVal ApplicationCode As String, ByVal ParentCode As String) As FunctionCollection
            Dim FunctionCollection As New FunctionCollection
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getApplicationFunctions", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                SqlCommand.Parameters.Add("@ParentCode", ParentCode)

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    Dim objFunction As New _Function
                    objFunction.FunctionCode = DBToStr(SqlDataReader.Item("FunctionCode"))
                    objFunction.ParentCode = DBToStr(SqlDataReader.Item("ParentCode"))
                    objFunction.FunctionName = DBToStr(SqlDataReader.Item("FunctionName"))
                    FunctionCollection.Add(objFunction)
                End While
                Return FunctionCollection

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlDataReader.Close()
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function LoadFunction(ByVal FunctionCode As String) As _Function
            Dim objFunction As New _Function
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getFunction", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    objFunction.FunctionCode = DBToStr(SqlDataReader.Item("FunctionCode"))
                    objFunction.ParentCode = DBToStr(SqlDataReader.Item("ParentCode"))
                    objFunction.FunctionName = DBToStr(SqlDataReader.Item("FunctionName"))
                End While
                Return objFunction

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Sub StoreFunction(ByVal _Function As _Function)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_storeFunction", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@FunctionCode", _Function.FunctionCode)
                SqlCommand.Parameters.Add("@ParentCode", _Function.ParentCode)
                SqlCommand.Parameters.Add("@FunctionName", _Function.FunctionName)
                SqlCommand.Parameters.Add("@ApplicationCode", _Function.ApplicationCode)

                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Sub UpdateFunction(ByVal _Function As _Function)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_updateFunction", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@FunctionCode", _Function.FunctionCode)
                SqlCommand.Parameters.Add("@ParentCode", _Function.ParentCode)
                SqlCommand.Parameters.Add("@FunctionName", _Function.FunctionName)

                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try

        End Sub

        Public Overrides Sub DeleteFunction(ByVal FunctionCode As String, ByVal ApplicationCode As String)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_deleteFunction", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)

                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Function HasFunctionsChildren(ByVal FunctionCode As String) As Boolean
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_functionsChildren", SqlConnection)
            Dim SqlDataReader As SqlDataReader

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlDataReader = SqlCommand.ExecuteReader
                If Not SqlDataReader.HasRows Then
                    Return False
                Else
                    Return True
                End If
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlDataReader.Close()
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function AccessFunction(ByVal UserName As String, ByVal FunctionCode As String) As Boolean
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_accessFunction", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlDataReader = SqlCommand.ExecuteReader
                If SqlDataReader.HasRows Then
                    Return True
                Else
                    Return False
                End If
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlDataReader.Close()
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Applications"

        Public Overloads Overrides Function LoadApplications() As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim DataSet As New DataSet
            Dim da As New SqlDataAdapter("sp_loadApplications", SqlConnection)
            Try
                SqlConnection.Open()
                da.SelectCommand.CommandType = CommandType.StoredProcedure
                da.Fill(DataSet)

                Return DataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                da.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Sub StoreApplication(ByVal Application As Application)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_storeApplication", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ApplicationCode", Application.ApplicationCode)
                SqlCommand.Parameters.Add("@ApplicationName", Application.ApplicationName)
                SqlCommand.Parameters.Add("@Version", Application.Version)

                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Sub UpdateApplication(ByVal Application As Application)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_updateApplication", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ApplicationCode", Application.ApplicationCode)
                SqlCommand.Parameters.Add("@ApplicationName", Application.ApplicationName)
                SqlCommand.Parameters.Add("@Version", Application.Version)

                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Sub DeleteApplication(ByVal ApplicationCode As String)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_deleteApplication", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)

                SqlCommand.ExecuteNonQuery()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Function GetAllApplications() As Hashtable
            Dim hash As New Hashtable
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadApplications", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    hash.Add(SqlDataReader.Item("ApplicationID"), SqlDataReader.Item("ApplicationName"))
                End While
                Return hash

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function LoadApplication(ByVal ApplicationCode As String) As Application
            Dim objApplication As New Application(ApplicationCode)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadApplication", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    objApplication.ApplicationName = DBToStr(SqlDataReader.Item("ApplicationName"))
                    objApplication.Version = DBToStr(SqlDataReader.Item("Version"))
                End While
                Return objApplication

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlDataReader.Close()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Overrides Function AccessApplication(ByVal UserName As String, ByVal ApplicationCode As String) As Boolean
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_accessApplication", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@ApplicationCode", ApplicationCode)
                SqlDataReader = SqlCommand.ExecuteReader
                If SqlDataReader.HasRows Then
                    Return True
                Else
                    Return False
                End If
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlDataReader.Close()
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "ApplicationEmployee"

        Public Overrides Sub UpdateApplicationsEmployee(ByVal UserName As String, ByVal ApplicationsID As Hashtable)
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_insertApplicationEmployee", SqlConnection)
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                For Each key As String In ApplicationsID.Keys
                    SqlCommand.Parameters.Add("@UserName", UserName)
                    SqlCommand.Parameters.Add("@ApplicationCode", key)
                    SqlCommand.Parameters.Add("@Checked", ApplicationsID(key))
                    Dim vkey As Integer = ApplicationsID(key)
                    SqlCommand.ExecuteNonQuery()
                    SqlCommand.Parameters.Clear()
                Next
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Sub

        Public Overrides Function LoadApplicationsEmployee(ByVal UserName As String) As ArrayList
            Dim alst As New ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadApplicationsEmployee", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@UserName", UserName)

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    alst.Add(CStr(SqlDataReader.Item("ApplicationCode")))
                End While
                Return alst

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlDataReader.Close()
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Statistics DigitArq"

        Public Function stLoadEmployeesNames() As Hashtable
            Dim hsh As New Hashtable
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadEmployees", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@ListType", 2)
                SqlCommand.Parameters.Add("@ApplicationCode", ConfigurationSettings.AppSettings("Application.MDA.Code"))

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    hsh.Add(DBToStr(SqlDataReader.Item("UserName")), DBToStr(SqlDataReader.Item("FullName")))
                End While
                Return hsh

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stGetYears() As ArrayList
            Dim alst As New ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getYears", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    alst.Add(CStr(SqlDataReader.Item("y")))
                End While
                alst.Sort()
                Return alst

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotDay(ByVal UserName As String, ByVal descr As String, ByVal FunctionCode As Int16, ByVal d As String, ByVal m As String, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotDay", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@d", Convert.ToInt16(d))
                SqlCommand.Parameters.Add("@m", Convert.ToInt16(m))
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotDayAl(ByVal UserName As String, ByVal descr As String, ByVal d As String, ByVal m As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotDayAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@d", Convert.ToInt16(d))
                SqlCommand.Parameters.Add("@m", Convert.ToInt16(m))
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMon(ByVal UserName As String, ByVal descr As String, ByVal FunctionCode As Int16, ByVal m As String, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMon", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@m", m)
                SqlCommand.Parameters.Add("@y", y)

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMon(ByVal UserName As String, ByVal FunctionCode As Int16, ByVal m As String, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMon2", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@m", m)
                SqlCommand.Parameters.Add("@y", y)

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMonAl(ByVal UserName As String, ByVal descr As String, ByVal m As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMonAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@m", m)
                SqlCommand.Parameters.Add("@y", y)

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMonAl(ByVal UserName As String, ByVal m As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMon2Al", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@m", m)
                SqlCommand.Parameters.Add("@y", y)

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMonAll(ByVal descr As String, ByVal FunctionCode As Int16, ByVal m As String, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMonAll", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@m", Convert.ToInt16(m))
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMonAll(ByVal FunctionCode As Int16, ByVal m As String, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMonAll2", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@m", Convert.ToInt16(m))
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMonAllAl(ByVal m As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMonAll2Al", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@m", Convert.ToInt16(m))
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotMonAllAl(ByVal descr As String, ByVal m As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotMonAllAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@m", Convert.ToInt16(m))
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotYear(ByVal UserName As String, ByVal descr As String, ByVal FunctionCode As Int16, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotYear", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotYearAl(ByVal UserName As String, ByVal descr As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotYearAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotYearAll(ByVal descr As String, ByVal FunctionCode As Int16, ByVal y As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotYearAll", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotYearAllAl(ByVal descr As String, ByVal y As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotYearAllAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stGetOpsPerUser(ByVal y As String, ByVal op As Int16) As Hashtable
            Dim hash As New Hashtable
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcNumOpsPerUser", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@y", Convert.ToInt16(y))
                SqlCommand.Parameters.Add("@op", op)

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    hash.Add(SqlDataReader.Item("UserName"), SqlDataReader.Item("Num"))
                End While
                Return hash
                SqlDataReader.Close()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try

        End Function

        Public Function stCalcNumOps(ByVal y As String, ByVal op As Int16) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotLog", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@y", y)
                SqlCommand.Parameters.Add("@op", op)

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stLoadCUIDF() As Hashtable
            Dim hash As New Hashtable
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadCUIDF", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Dim temp As String = ""
            Dim tmp As ArquiveGroup
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader()

                While SqlDataReader.Read
                    If Not IsDBNull(SqlDataReader.Item("CompleteUnitID")) Then
                        Dim CompleteUnitID As String = SqlDataReader.Item("CompleteUnitID")
                        Dim CompleteUnitIDArray As String() = CompleteUnitID.Split("/")
                        If CompleteUnitIDArray.Length >= 3 Then
                            temp = CompleteUnitIDArray.GetValue(2)
                            If (hash.Contains(temp)) Then
                                tmp = hash(temp)
                                hash.Remove(temp)
                                tmp.addExtentMl(SqlDataReader.Item("ExtentMl"))
                                hash.Add(temp, tmp)
                            Else : hash.Add(temp, New ArquiveGroup(temp, SqlDataReader.Item("ExtentMl")))
                            End If
                        End If
                    End If
                End While
                Return hash
                SqlDataReader.Close()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stLoadIDFunds() As ArrayList
            Dim alst As New ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadIDFunds", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader()
                While SqlDataReader.Read
                    alst.Add(CStr(SqlDataReader.Item("ID")))
                End While

                Return alst
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcNumFundRev() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcNumFundRev", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcNumFundVis() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcNumFundVis", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcWarn() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcWarn", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotReg() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotReg", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotRegRev() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotRegRev", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotRegVis() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotRegVis", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stLoadIDUID() As Hashtable
            Dim hash As New Hashtable
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadIDUID", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Dim temp As String = ""
            Dim tmp As Integer = 0
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader()

                While SqlDataReader.Read
                    If Not IsDBNull(SqlDataReader.Item("UnitID")) Then
                        hash.Add(SqlDataReader.Item("ID"), SqlDataReader.Item("UnitID"))
                    End If
                End While
                Return hash
                SqlDataReader.Close()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stChkRegC() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadUIDandCUID", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.CommandTimeout = ConnectTimeout

                SqlDataReader = SqlCommand.ExecuteReader
                Dim count As Int32 = 0
                While SqlDataReader.Read
                    If Not IsDBNull(SqlDataReader.Item("UnitID")) And Not IsDBNull(SqlDataReader.Item("CompleteUnitID")) Then
                        Dim str As String = SqlDataReader.Item("CompleteUnitID")
                        If str.EndsWith(SqlDataReader.Item("UnitID")) Then
                            count += 1
                        End If
                    End If
                End While
                Return count
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stLoadUIDandUIT(ByVal id As String) As ArrayList
            Dim arLst As New ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_loadUIDandUITbyID", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@id", id)

                SqlDataReader = SqlCommand.ExecuteReader()

                While SqlDataReader.Read
                    If Not IsDBNull(SqlDataReader.Item("UnitID")) And Not IsDBNull(SqlDataReader.Item("UnitTitle")) Then
                        arLst.Add(DBToStr(SqlDataReader.Item("UnitID")))
                        arLst.Add(DBToStr(SqlDataReader.Item("UnitTitle")))
                    End If
                End While
                Return arLst
                SqlDataReader.Close()

                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stGetDescr(ByVal op As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                If op = "F" Then
                    objDataAdapter = New SqlDataAdapter("sp_getDescrF", SqlConnection)
                ElseIf op = "SC" Then
                    objDataAdapter = New SqlDataAdapter("sp_getDescrSC", SqlConnection)
                ElseIf op = "SR" Then
                    objDataAdapter = New SqlDataAdapter("sp_getDescrSR", SqlConnection)
                ElseIf op = "UI" Then
                    objDataAdapter = New SqlDataAdapter("sp_getDescrUI", SqlConnection)
                ElseIf op = "D" Then
                    objDataAdapter = New SqlDataAdapter("sp_getDescrD", SqlConnection)
                End If

                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stGetNDescr(ByVal op As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As SqlCommand
            If op = "F" Then
                SqlCommand = New SqlCommand("sp_getNdescrF", SqlConnection)
            ElseIf op = "SC" Then
                SqlCommand = New SqlCommand("sp_getNdescrSC", SqlConnection)
            ElseIf op = "SR" Then
                SqlCommand = New SqlCommand("sp_getNdescrSR", SqlConnection)
            ElseIf op = "UI" Then
                SqlCommand = New SqlCommand("sp_getNdescrUI", SqlConnection)
            ElseIf op = "D" Then
                SqlCommand = New SqlCommand("sp_getNdescrD", SqlConnection)
            End If

            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotFunds() As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotFunds", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotPeriodAll(ByVal descr As String, ByVal FunctionCode As Int16, ByVal from As String, ByVal t As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotPeriodAll", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@from", from)
                SqlCommand.Parameters.Add("@to", t)

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotPeriodAllAl(ByVal descr As String, ByVal from As String, ByVal t As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotPeriodAllAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@from", from)
                SqlCommand.Parameters.Add("@to", t)

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotPeriod(ByVal UserName As String, ByVal descr As String, ByVal FunctionCode As Int16, ByVal from As String, ByVal t As String) As Int32
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotPeriod", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@FunctionCode", FunctionCode)
                SqlCommand.Parameters.Add("@from", from)
                SqlCommand.Parameters.Add("@to", t)

                SqlDataReader = SqlCommand.ExecuteReader
                SqlDataReader.Read()
                Return Convert.ToInt32(SqlDataReader.Item("Num"))
                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

        Public Function stCalcTotPeriodAl(ByVal UserName As String, ByVal descr As String, ByVal from As String, ByVal t As String) As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_calcTotPeriodAl", SqlConnection)
            Dim SqlDataReader As SqlDataReader
            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlCommand.Parameters.Add("@UserName", UserName)
                SqlCommand.Parameters.Add("@descr", descr)
                SqlCommand.Parameters.Add("@from", from)
                SqlCommand.Parameters.Add("@to", t)

                SqlDataReader = SqlCommand.ExecuteReader
                Dim temp As New ArrayList
                Dim less As Int32 = 0
                Dim more As Int32 = 0
                Dim hash As New Hashtable
                Dim at() As String
                Dim node As String
                Dim num As Int32 = 0
                While SqlDataReader.Read
                    at = SqlDataReader.Item("Description").Split(" ")
                    node = at(0) & " " & at(1) & " " & at(2)
                    If hash.ContainsKey(node) Then
                        num = hash(node) + SqlDataReader.Item("Num")
                        hash.Remove(node)
                    Else
                        num = SqlDataReader.Item("Num")
                    End If
                    hash.Add(node, num)
                End While

                Dim i As Int32
                For Each i In hash.Values
                    If (i > 2) Then
                        more += 1
                    Else : less += 1
                    End If
                Next
                temp.Add(less)
                temp.Add(more)
                Return temp

                SqlDataReader.Close()
                myReturn = eReturn.Sucess
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlConnection.Close()
            End Try
        End Function

#End Region

#Region "System resources"

        Public Function CountLogsByYear() As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_countLogsByYear", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountLogsByUsername() As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_countLogsByUsername", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function GetDBLocation() As String
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_getDBLocation", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.Parameters.Add("@DBLocation", SqlDbType.NVarChar)
                SqlCommand.Parameters("@DBLocation").Direction = ParameterDirection.Output
                SqlCommand.ExecuteNonQuery()
                Return SqlCommand.Parameters("@DBLocation").Value
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function GetDBFilesLocation() As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_getDBFilesLocation", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

#Region "Statistics GOD"

        Public Function LoadTotalImagesByOtherLevel() As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_loadTotalImagesByOtherLevel", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                objDataAdapter.SelectCommand.CommandTimeout = hshDatabase("ConnectTimeout")

                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountProjects() As Integer
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_countProjects", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.CommandTimeout = hshDatabase("ConnectTimeout")
                SqlCommand.Parameters.Add("@Count", SqlDbType.Int)
                SqlCommand.Parameters("@Count").Direction = ParameterDirection.Output
                SqlCommand.ExecuteNonQuery()
                Return SqlCommand.Parameters("@Count").Value
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountDigitalObjects() As Integer
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_countDigitalObjects", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.CommandTimeout = hshDatabase("ConnectTimeout")
                SqlCommand.Parameters.Add("@Count", SqlDbType.Int)
                SqlCommand.Parameters("@Count").Direction = ParameterDirection.Output
                SqlCommand.ExecuteNonQuery()
                Return SqlCommand.Parameters("@Count").Value
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountImages() As Integer
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_countImages", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.CommandTimeout = hshDatabase("ConnectTimeout")
                SqlCommand.Parameters.Add("@Count", SqlDbType.Int)
                SqlCommand.Parameters("@Count").Direction = ParameterDirection.Output
                SqlCommand.ExecuteNonQuery()
                Return SqlCommand.Parameters("@Count").Value
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function CountDerivatives() As Integer
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlCommand As New SqlCommand("sp_countDerivatives", SqlConnection)

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure
                SqlCommand.CommandTimeout = hshDatabase("ConnectTimeout")
                SqlCommand.Parameters.Add("@Count", SqlDbType.Int)
                SqlCommand.Parameters("@Count").Direction = ParameterDirection.Output
                SqlCommand.ExecuteNonQuery()
                Return SqlCommand.Parameters("@Count").Value
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function GetDOFilesYears() As ArrayList
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString
            Dim SqlDataReader As SqlDataReader
            Dim SqlCommand As New SqlCommand("sp_getDOFilesYears", SqlConnection)
            Dim myData As New ArrayList

            Try
                SqlConnection.Open()
                SqlCommand.CommandType = CommandType.StoredProcedure

                SqlDataReader = SqlCommand.ExecuteReader
                While SqlDataReader.Read
                    myData.Add(SqlDataReader.Item(0))
                End While

                Return myData
            Catch ex As Exception
                Throw (ex)
            Finally
                SqlCommand.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function LoadArchiveProduction(ByVal strYear As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet
            Dim myCommand As String

            Try
                SqlConnection.Open()

                objDataAdapter = New SqlDataAdapter("sp_loadArchiveProduction", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                objDataAdapter.SelectCommand.Parameters.Add("@Year", strYear)

                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

        Public Function LoadEmployeesProduction(ByVal strYear As String) As DataSet
            Dim SqlConnection As New SqlConnection
            SqlConnection.ConnectionString = myConnectionString

            Dim objDataAdapter As SqlDataAdapter
            Dim objDataSet As DataSet

            Try
                SqlConnection.Open()
                objDataAdapter = New SqlDataAdapter("sp_loadEmployeesProduction", SqlConnection)
                objDataAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
                objDataAdapter.SelectCommand.Parameters.Add("@Year", strYear)

                objDataSet = New DataSet
                objDataAdapter.Fill(objDataSet)

                Return objDataSet
            Catch ex As Exception
                Throw (ex)
            Finally
                objDataAdapter.Dispose()
                SqlConnection.Close()
                SqlConnection.Dispose()
            End Try
        End Function

#End Region

    End Class
End Namespace
