Imports System.IO

Public Class ByteArrayStream
    Inherits Stream

    Private myBuffer As Byte()
    Private myPosition As Long

    Public Sub New(ByVal buffer As Byte())
        myBuffer = buffer
        myPosition = 0
    End Sub



    Public Overrides ReadOnly Property CanRead() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property CanSeek() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property CanWrite() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides Sub Flush()

    End Sub

    Public Overrides ReadOnly Property Length() As Long
        Get
            Return myBuffer.Length
        End Get
    End Property

    Public Overrides Property Position() As Long
        Get
            Return myPosition
        End Get
        Set(ByVal Value As Long)
            myPosition = Value
        End Set
    End Property

    Public Overrides Function Read(ByVal buffer() As Byte, ByVal offset As Integer, ByVal count As Integer) As Integer
        If (Position >= Length) Then Return 0
        Dim counter As Long = 0
        For i As Integer = Position To Position + count - 1
            If (i >= Length) Then
                Position += counter
                Return counter
            End If
            buffer(counter + offset) = myBuffer(i)
            counter += 1
        Next
        Position += counter
        Return counter
    End Function

    Public Overrides Function Seek(ByVal offset As Long, ByVal origin As System.IO.SeekOrigin) As Long
        Position = origin + offset
    End Function

    Public Overrides Sub SetLength(ByVal value As Long)
        Throw New NotSupportedException("Cannot change stream contents")
    End Sub

    Public Overrides Sub Write(ByVal buffer() As Byte, ByVal offset As Integer, ByVal count As Integer)
        Throw New NotSupportedException("Cannot change stream contents")
    End Sub
End Class
