
Public Module Defaults

    ' Vault file settings
    Public Const DATA_FILENAME_SUFFIX As String = ".DATA"
    Public Const CUSTOM_METADATA_FILENAME_SUFFIX As String = ".CUSTOM"
    Public Const VAULT_METADATA_FILENAME_SUFFIX As String = ".VAULT"

    Public Const CUSTOM_METADATA_ROOT_ELEMENT As String = "custom-metadata"
    Public Const VAULT_METADATA_ROOT_ELEMENT As String = "vault-metadata"

    Public Const VAULT_METADATA_SECRET As String = "Secret"
    Public Const VAULT_METADATA_DOWNLOAD_LIMIT As String = "DownloadLimit"

    ' Maximum supported file size
    Public Const MAXIMUM_FILE_SIZE As Integer = 1024 * 1024 * 1024



    ' HTTP methods
    Public Const HTTP_METHOD_POST As String = "POST"
    Public Const HTTP_METHOD_PUT As String = "PUT"
    Public Const HTTP_METHOD_GET As String = "GET"
    Public Const HTTP_METHOD_DELETE As String = "DELETE"
    Public Const HTTP_METHOD_HEAD As String = "HEAD"


    ' HTTP error codes
    Public Const HTTP_STATUS_OK As Integer = 200
    Public Const HTTP_STATUS_BAD_REQUEST As Integer = 400
    Public Const HTTP_STATUS_NOT_FOUND As Integer = 404
    Public Const HTTP_STATUS_FORBIDDEN As Integer = 403
    Public Const HTTP_STATUS_INTERNAL_SERVER_ERROR As Integer = 500


    ' Special commands
    Public Const COMMAND_SECRET As String = "SECRET"
    Public Const COMMAND_DELETE As String = "DEL"
    Public Const COMMAND_RETRIEVE As String = "GET"
    Public Const COMMAND_METADATA As String = "MD"
    Public Const COMMAND_DOWNLOAD_LIMIT As String = "DOWNLOAD_LIMIT"





End Module
