Imports ObjectVaultClient
Imports System.Text.Encoding
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebControl
Imports System.Web.UI.HtmlControls





Public Class _Default
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents File As System.Web.UI.HtmlControls.HtmlInputFile
    Protected WithEvents ObjectIDTextBox As System.Web.UI.WebControls.TextBox
    Protected WithEvents Retrieve As System.Web.UI.WebControls.Button
    Protected WithEvents Store As System.Web.UI.WebControls.Button
    Protected WithEvents StoreResultLabel As System.Web.UI.WebControls.Label
    Protected WithEvents RetrieveResultLabel As System.Web.UI.WebControls.Label
    Protected WithEvents URLsTable As System.Web.UI.WebControls.Table
    Protected WithEvents SecretTextBox As System.Web.UI.WebControls.TextBox
    Protected WithEvents DownloadLimitTextbox As System.Web.UI.WebControls.TextBox
    Protected WithEvents SecretRetrieveTextbox As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region


    'Const OBJECT_VAULT_SERVER_ADDRESS As String = "http://vaultserver.keep.pt/Default.aspx"
    Const OBJECT_VAULT_SERVER_ADDRESS As String = "http://localhost/ObjectVaultServer/Default.aspx"
    Const MAX_FILE_SIZE As Integer = 100 * 1024 * 1024
    Const SIZE_LIMIT As Boolean = False

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
    End Sub



    Private Sub Store_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Store.Click
        Dim vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
        Try
            URLsTable.Rows.Clear()
            If SIZE_LIMIT > 0 AndAlso File.PostedFile.ContentLength > MAX_FILE_SIZE Then
                StoreResultLabel.Text = "Sorry, we only support storage of files smaller than 100Mb!"

            Else
                StoreResultLabel.Text = "Upload in progress. This make take a while..."

                Dim Secret As String = Me.SecretTextBox.Text
                Dim DownloadLimit As String = Me.DownloadLimitTextbox.Text

                StoreResultLabel.Text = "Uploading file..."
                Dim CustomMetadata As New Hashtable
                CustomMetadata.Add("Date", Now.ToShortDateString)

                If Secret.Equals("") Then Secret = Nothing
                If DownloadLimit.Equals("") Then DownloadLimit = -1

                Dim Result As Byte() = vault.Store(File.PostedFile.InputStream, File.PostedFile.FileName, CustomMetadata, Secret, DownloadLimit)
                Dim ObjectID As String = ASCII.GetString(Result)
                OutputStoreResult(ObjectID)
                StoreResultLabel.Text = "Done"
            End If
        Catch ex As VaultException
            StoreResultLabel.Text = ex.ErrorCode & " " & ex.Message
        Catch ex As Exception
            StoreResultLabel.Text = ex.Message
        End Try
        vault = Nothing
    End Sub

    Private Sub Retrieve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Retrieve.Click
        Dim vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
        Try
            RetrieveResultLabel.Text = ""
            Dim SecretRetrieve As String = Me.SecretRetrieveTextbox.Text
            Dim ID As String = Me.ObjectIDTextBox.Text
            'If SecretRetrieve.Length > 0 Then
            Response.Redirect(OBJECT_VAULT_SERVER_ADDRESS & "?GET=" & ID & "&SECRET=" & SecretRetrieve)
            'Else
            'Response.Redirect(OBJECT_VAULT_SERVER_ADDRESS & "?GET=" & ID)
            'End If

        Catch ex As Exception
            RetrieveResultLabel.Text = ex.Message
        End Try

        vault = Nothing
    End Sub


    Private Sub OutputStoreResult(ByVal ObjectID As String)
        URLsTable.Rows.Clear()

        '*********************
        Dim NewRow As TableRow
        Dim LabelCell As TableCell
        Dim ValueCell As TableCell

        NewRow = New TableRow
        LabelCell = New TableCell
        ValueCell = New TableCell

        LabelCell.Text = "<strong>ID</strong>"
        ValueCell.Text = ObjectID
        NewRow.Controls.Add(LabelCell)
        NewRow.Controls.Add(ValueCell)
        URLsTable.Rows.Add(NewRow)

        '*********************

        NewRow = New TableRow
        LabelCell = New TableCell
        ValueCell = New TableCell

        LabelCell.Text = "<strong>Retrieve</strong>"
        Dim GetURL As String = OBJECT_VAULT_SERVER_ADDRESS & "?GET=" & ObjectID
        ValueCell.Text = "<a href=" & GetURL & ">" & GetURL & "</a>"

        LabelCell.Width = New Unit(100, UnitType.Pixel)
        ValueCell.Width = New Unit(100, UnitType.Percentage)

        NewRow.Controls.Add(LabelCell)
        NewRow.Controls.Add(ValueCell)
        URLsTable.Rows.Add(NewRow)

        '*********************

        NewRow = New TableRow
        LabelCell = New TableCell
        ValueCell = New TableCell
        LabelCell.Text = "<strong>Delete</strong>"
        Dim DeleteURL As String = OBJECT_VAULT_SERVER_ADDRESS & "?DEL=" & ObjectID
        ValueCell.Text = "<a href=" & DeleteURL & ">" & DeleteURL & "</a>"

        LabelCell.Width = New Unit(100, UnitType.Pixel)
        ValueCell.Width = New Unit(100, UnitType.Percentage)

        NewRow.Controls.Add(LabelCell)
        NewRow.Controls.Add(ValueCell)
        URLsTable.Rows.Add(NewRow)

        '*********************
        NewRow = New TableRow
        LabelCell = New TableCell
        ValueCell = New TableCell
        LabelCell.Text = "<strong>Metadata</strong>"
        Dim MetadataURL As String = OBJECT_VAULT_SERVER_ADDRESS & "?MD=" & ObjectID
        ValueCell.Text = "<a href=" & MetadataURL & ">" & MetadataURL & "</a>"


        LabelCell.Width = New Unit(100, UnitType.Pixel)
        ValueCell.Width = New Unit(100, UnitType.Percentage)

        NewRow.Controls.Add(LabelCell)
        NewRow.Controls.Add(ValueCell)
        URLsTable.Rows.Add(NewRow)

    End Sub


End Class
