
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Option Strict Off

Imports System
Imports System.Text
Imports System.Collections
Imports System.Drawing.Imaging
Imports System.Drawing
Imports System.Reflection
Imports System.IO
Imports System.Web.UI
Imports System.Configuration
Imports System.Data.SqlClient


Public Class EXIFExtractor

#Region "Private properties"

    Private myFormats As String() = {"TIFF", "TIF", "JPEG", "JPG", "PNG", "GIF"}

#End Region

#Region "Methods and functions"

    Public Shared Function CanExtractProperties(ByVal Format As String) As Boolean
        Dim myFormats As String() = {"TIFF", "TIF", "JPEG", "JPG", "PNG", "GIF"}
        Dim Formats As New ArrayList(myFormats)
        Return Formats.Contains(Format)
    End Function

    Private Function CreatePropertyItem(ByVal type As Short, ByVal tag As Integer, ByVal len As Integer, ByVal value As Byte()) As PropertyItem
        Dim item As PropertyItem

        ' Loads a PropertyItem from a image stored in the assembly as a resource.
        Dim ass As System.Reflection.Assembly = System.Reflection.Assembly.GetExecutingAssembly()
        Dim emptyBitmapStream As Stream = ass.GetManifestResourceStream("EXIFextractor.decoy.jpg")
        Dim empty As System.Drawing.Image = System.Drawing.Image.FromStream(emptyBitmapStream)

        item = empty.PropertyItems(0)

        'Copies the data to the property item.
        item.Type = type
        item.Len = len
        item.Id = tag
        item.Value = New Byte(value.Length) {}
        value.CopyTo(item.Value, 0)

        Return item
    End Function

    Public Shared Function GetExifProperties(ByVal Image As Image) As Hashtable
        Dim Properties As New Hashtable
        Dim Attributes As New Translation

        Dim PropertyItems As PropertyItem() = Image.PropertyItems

        Dim ascii As Encoding = Encoding.ASCII

        For Each PropertyItem As System.Drawing.Imaging.PropertyItem In PropertyItems
            Dim Value As String
            Dim Name As String
            If Attributes.ContainsKey(PropertyItem.Id) Then
                Name = Attributes.Item(PropertyItem.Id).ToString
            End If
            'tag not found. skip it

            If Not Name Is Nothing Then

                If PropertyItem.Type = &H1 Then
                    '1 = BYTE An 8-bit unsigned integer.
                    Value = PropertyItem.Value(0).ToString()

                ElseIf PropertyItem.Type = &H2 Then
                    '2 = ASCII An 8-bit byte containing one 7-bit ASCII code. The final byte is terminated with NULL.
                    Value = ascii.GetString(PropertyItem.Value).ToString.Trim

                ElseIf PropertyItem.Type = &H3 Then
                    '3 = SHORT A 16-bit (2 -byte) unsigned integer,
                    'orientation // lookup table
                    Value = ExtractU16Value(PropertyItem)

                ElseIf PropertyItem.Type = &H4 Then
                    '4 = LONG A 32-bit (4 -byte) unsigned integer,
                    '// orientation // lookup table					
                    Value = convertToInt32U(PropertyItem.Value).ToString()

                ElseIf PropertyItem.Type = &H5 Then
                    '5 = RATIONAL Two LONGs. The first LONG is the numerator and the second LONG expresses the//denominator.,
                    '// rational

                    Dim n As Byte() = New Byte((PropertyItem.Len / 2) - 1) {}
                    Dim d As Byte() = New Byte((PropertyItem.Len / 2) - 1) {}

                    Array.Copy(PropertyItem.Value, 0, n, 0, CInt(PropertyItem.Len / 2))
                    Array.Copy(PropertyItem.Value, CInt(PropertyItem.Len / 2), d, 0, CInt(PropertyItem.Len / 2))

                    Dim a As UInt32 = convertToInt32U(n)
                    Dim b As UInt32 = convertToInt32U(d)
                    Dim r As Rational = New Rational(a, b)


                    '//convert here

                    Select Case (PropertyItem.Id)
                        Case &H9202 'aperture
                            Value = "F/" + Math.Round(Math.Pow(Math.Sqrt(2), r.ToDouble()), 2).ToString()
                        Case &H920A
                            Value = r.ToDouble().ToString()
                        Case &H829A
                            Value = r.ToDouble().ToString()
                        Case &H829D 'F-number
                            Value = "F/" + r.ToDouble().ToString()
                        Case Else
                            Value = r.ToStr("/")
                    End Select

                ElseIf PropertyItem.Type = &H7 Then
                    '7 = UNDEFINED An 8-bit byte that can take any value depending on the field definition,
                    Select Case PropertyItem.Id
                        Case &HA300
                            If PropertyItem.Value(0) = 3 Then
                                Value = "DSC"
                            Else
                                Value = "reserved"
                            End If

                        Case &HA301
                            If PropertyItem.Value(0) = 1 Then
                                Value = "A directly photographed image"
                            Else
                                Value = "Not a directly photographed image"
                            End If
                        Case Else
                            Value = "-"
                    End Select

                ElseIf PropertyItem.Type = &H9 Then
                    '9 = SLONG A 32-bit (4 -byte) signed integer (2's complement notation),
                    Value = convertToInt32(PropertyItem.Value).ToString()
                    '10 = SRATIONAL Two SLONGs. The first SLONG is the numerator and the second SLONG is the denominator.
                ElseIf PropertyItem.Type = &HA Then
                    '// rational						
                    Dim n As Byte() = New Byte((PropertyItem.Len / 2) - 1) {}
                    Dim d As Byte() = New Byte((PropertyItem.Len / 2) - 1) {}
                    Array.Copy(PropertyItem.Value, 0, n, 0, CInt(PropertyItem.Len / 2))
                    Array.Copy(PropertyItem.Value, CInt(PropertyItem.Len / 2), d, 0, CInt(PropertyItem.Len / 2))
                    Dim a As Integer = convertToInt32(n)
                    Dim b As Integer = convertToInt32(d)
                    Dim r As Rational = New Rational(a, b)

                    'convert here
                    Select Case (PropertyItem.Id)
                        Case &H9201 'shutter speed
                            Value = "1/" + Math.Round(Math.Pow(2, r.ToDouble()), 2).ToString()
                        Case &H9203
                            Value = Math.Round(r.ToDouble(), 4).ToString()
                        Case Else
                            Value = r.ToStr("/")
                            'add it to the list
                    End Select
                End If

                If Properties(Name) Is Nothing Then
                    Properties.Add(Name, Value)
                End If
            End If
        Next

        Return Properties
    End Function


    Private Shared Function ExtractU16Value(ByVal PropertyItem As PropertyItem) As String
        Dim Value As String
        Select Case PropertyItem.Id
            Case &H8827 'ISO
                Value = "ISO-" + convertToInt16U(PropertyItem.Value).ToString()
                Exit Select
            Case &HA217
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 1 : Value = "Not defined"
                        Exit Select
                    Case 2 : Value = "One-chip color area sensor"
                        Exit Select
                    Case 3 : Value = "Two-chip color area sensor"
                        Exit Select
                    Case 4 : Value = "Three-chip color area sensor"
                        Exit Select
                    Case 5 : Value = "Color sequential area sensor"
                        Exit Select
                    Case 7 : Value = "Trilinear sensor"
                        Exit Select
                    Case 8 : Value = "Color sequential linear sensor"
                        Exit Select
                    Case Else : Value = " reserved"
                        Exit Select
                End Select
                Exit Select
            Case &H8822 'aperture
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 0 : Value = "Not defined"
                        Exit Select
                    Case 1 : Value = "Manual"
                        Exit Select
                    Case 2 : Value = "Normal program"
                        Exit Select
                    Case 3 : Value = "Aperture priority"
                        Exit Select
                    Case 4 : Value = "Shutter priority"
                        Exit Select
                    Case 5 : Value = "Creative program (biased toward depth of field)"
                        Exit Select
                    Case 6 : Value = "Action program (biased toward fast shutter speed)"
                        Exit Select
                    Case 7 : Value = "Portrait mode (for closeup photos with the background out of focus)"
                        Exit Select
                    Case 8 : Value = "Landscape mode (for landscape photos with the background in focus)"
                        Exit Select
                    Case Else : Value = "reserved"
                        Exit Select
                End Select
                Exit Select
            Case &H9207 'metering mode
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 0 : Value = "unknown"
                        Exit Select
                    Case 1 : Value = "Average"
                        Exit Select
                    Case 2 : Value = "CenterWeightedAverage"
                        Exit Select
                    Case 3 : Value = "Spot"
                        Exit Select
                    Case 4 : Value = "MultiSpot"
                        Exit Select
                    Case 5 : Value = "Pattern"
                        Exit Select
                    Case 6 : Value = "Partial"
                        Exit Select
                    Case 255 : Value = "Other"
                        Exit Select
                    Case Else : Value = "reserved"
                        Exit Select
                End Select
                Exit Select
            Case &H9208 'light source
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 0 : Value = "unknown"
                        Exit Select
                    Case 1 : Value = "Daylight"
                        Exit Select
                    Case 2 : Value = "Fluorescent"
                        Exit Select
                    Case 3 : Value = "Tungsten"
                        Exit Select
                    Case 17 : Value = "Standard light A"
                        Exit Select
                    Case 18 : Value = "Standard light B"
                        Exit Select
                    Case 19 : Value = "Standard light C"
                        Exit Select
                    Case 20 : Value = "D55"
                        Exit Select
                    Case 21 : Value = "D65"
                        Exit Select
                    Case 22 : Value = "D75"
                        Exit Select
                    Case 255 : Value = "other"
                        Exit Select
                    Case Else : Value = "reserved"
                        Exit Select
                End Select
                Exit Select
            Case &H9209
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 0 : Value = "Flash did not fire"
                        Exit Select
                    Case 1 : Value = "Flash fired"
                        Exit Select
                    Case 5 : Value = "Strobe return light not detected"
                        Exit Select
                    Case 7 : Value = "Strobe return light detected"
                        Exit Select
                    Case Else : Value = "reserved"
                        Exit Select
                End Select
                Exit Select
            Case &H112 'Rotation
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 1 : Value = "Horizontal (normal)"
                        Exit Select
                    Case 2 : Value = "Mirror horizontal"
                        Exit Select
                    Case 3 : Value = "Rotate 180"
                        Exit Select
                    Case 4 : Value = "Mirror vertical"
                        Exit Select
                    Case 5 : Value = "Mirror horizontal and rotate 270 CW"
                        Exit Select
                    Case 6 : Value = "Rotate 90 CW"
                        Exit Select
                    Case 7 : Value = "Mirror horizontal and rotate 90 CW"
                        Exit Select
                    Case 8 : Value = "Rotate 270 CW"
                        Exit Select
                    Case Else : Value = "reserved"
                        Exit Select
                End Select
                Exit Select
            Case &H103 'Compression
                Select Case convertToInt16U(PropertyItem.Value)
                    Case 1 : Value = "Uncompressed"
                        Exit Select
                    Case 2 : Value = "CCITT 1D"
                        Exit Select
                    Case 3 : Value = "T4/Group 3 Fax"
                        Exit Select
                    Case 4 : Value = "T6/Group 4 Fax"
                        Exit Select
                    Case 5 : Value = "LZW"
                        Exit Select
                    Case 6 : Value = "JPEG (old-style)"
                        Exit Select
                    Case 7 : Value = "JPEG"
                        Exit Select
                    Case 8 : Value = "Adobe Deflate"
                        Exit Select
                    Case 9 : Value = "JBIG B&W"
                        Exit Select
                    Case 10 : Value = "JBIG Color"
                        Exit Select
                    Case 99 : Value = "JPEG"
                        Exit Select
                    Case 32946 : Value = "Deflate"
                        Exit Select
                    Case 34661 : Value = "JBIG"
                        Exit Select
                    Case Else
                        Value = "UNKNOWN"
                        Exit Select
                End Select
                Exit Select
            Case &HA001 'Color space
                Select Case Convert.ToInt16(convertToInt16U(PropertyItem.Value))
                    Case 1 : Value = "sRGB"
                        Exit Select
                    Case 2 : Value = "Adobe RGB"
                        Exit Select
                    Case Else
                        Value = "UNKNOWN"
                        Exit Select
                End Select
                Exit Select
            Case Else
                Value = convertToInt16U(PropertyItem.Value).ToString()
        End Select
        Return Value
    End Function

    Public Shared Function Format(ByVal Image As Image) As String
        Dim bmpFormat As ImageFormat = Image.RawFormat
        Dim strFormat As String = "unidentified format"

        If (bmpFormat.Equals(ImageFormat.Bmp)) Then
            strFormat = "BMP"
        ElseIf (bmpFormat.Equals(ImageFormat.Emf)) Then
            strFormat = "EMF"
        ElseIf (bmpFormat.Equals(ImageFormat.Exif)) Then
            strFormat = "EXIF"
        ElseIf (bmpFormat.Equals(ImageFormat.Gif)) Then
            strFormat = "GIF"
        ElseIf (bmpFormat.Equals(ImageFormat.Icon)) Then
            strFormat = "Icon"
        ElseIf (bmpFormat.Equals(ImageFormat.Jpeg)) Then
            strFormat = "JPEG"
        ElseIf (bmpFormat.Equals(ImageFormat.MemoryBmp)) Then
            strFormat = "MemoryBMP"
        ElseIf (bmpFormat.Equals(ImageFormat.Png)) Then
            strFormat = "PNG"
        ElseIf (bmpFormat.Equals(ImageFormat.Tiff)) Then
            strFormat = "TIFF"
        ElseIf (bmpFormat.Equals(ImageFormat.Wmf)) Then
            strFormat = "WMF"
        Else
            strFormat = "UNKNOWN"
        End If
        Return strFormat
    End Function

    Public Shared Function BitsPerPixel(ByVal Image As Image) As String
        Select Case Image.PixelFormat
            Case PixelFormat.Format16bppArgb1555, PixelFormat.Format16bppGrayScale, PixelFormat.Format16bppRgb555, PixelFormat.Format16bppRgb565 : Return "16"
            Case PixelFormat.Format1bppIndexed : Return "1"
            Case PixelFormat.Format24bppRgb : Return "24"
            Case PixelFormat.Format32bppArgb, PixelFormat.Format32bppPArgb, PixelFormat.Format32bppRgb : Return "32"
            Case PixelFormat.Format48bppRgb : Return "48"
            Case PixelFormat.Format8bppIndexed : Return "8"
            Case PixelFormat.Format4bppIndexed : Return "4"
            Case Else : Return ""
        End Select
    End Function

    Public Shared Function Compression(ByVal Image As Image, ByVal ExifCompression As String) As String
        If Format(Image).Equals("JPEG") Then
            Return "JPEG"
        Else
            Return ExifCompression
        End If
    End Function

    Public Shared Function ColorSpace(ByVal Image As Image) As String
        Select Case Image.PixelFormat
            Case PixelFormat.Format16bppArgb1555, PixelFormat.Format32bppArgb, _
                 PixelFormat.Format32bppPArgb : Return "ARGB"
            Case PixelFormat.Format16bppGrayScale : Return "Gray"
            Case PixelFormat.Format16bppRgb555, PixelFormat.Format24bppRgb, _
                 PixelFormat.Format16bppRgb565, PixelFormat.Format48bppRgb, _
                 PixelFormat.Format32bppRgb : Return "RGB"
            Case PixelFormat.Format8bppIndexed, _
                 PixelFormat.Format4bppIndexed : Return "Indexed"
            Case PixelFormat.Format1bppIndexed : Return "Black/White"
            Case Else : Return ""
        End Select
    End Function

    Public Shared Function GetPropertyValue(ByVal Properties As Hashtable, ByVal Key As String, ByVal DefaultValue As String) As String
        If Properties.ContainsKey(Key) Then
            Return Properties.Item(Key)
        Else
            Return DefaultValue
        End If
    End Function

#End Region

#Region "Conversion functions"

    'Public Function ToStr() As String
    '    Return data
    'End Function

    Private Shared Function convertToInt32(ByVal arr As Byte()) As Integer
        If arr.Length <> 4 Then
            Return 0
        Else
            Return arr(3) << 24 Or arr(2) << 16 Or arr(1) << 8 Or arr(0)
        End If
    End Function

    Private Function convertToInt16(ByVal arr As Byte()) As Integer
        If arr.Length <> 2 Then
            Return 0
        Else
            Return arr(1) << 8 Or arr(0)
        End If
    End Function

    Private Shared Function convertToInt32U(ByVal arr As Byte()) As UInt32
        If arr.Length <> 4 Then
            Return Convert.ToUInt32(0)
        Else
            Return Convert.ToUInt32(arr(3) << 24 Or arr(2) << 16 Or arr(1) << 8 Or arr(0))
        End If
    End Function

    Private Shared Function convertToInt16U(ByVal arr As Byte()) As Integer 'UInt16
        If arr.Length <> 2 Then
            Return Convert.ToInt32(Convert.ToUInt16(0))
        Else
            Return Convert.ToInt32(Convert.ToUInt16(arr(1) << 8 Or arr(0)))
        End If
    End Function

    'Public Overridable Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
    '    Return (New EXIFextractorEnumerator(Me.myPropertyItems))
    'End Function

    Public Shared Function CompleteDateToDB(ByVal v As String) As String
        If v Is Nothing Or v = "" Then Return ""
        If IsDate(v) Then
            Dim d As Date = CDate(v)
            Return String.Format("{0}-{1}-{2} {3}h{4}m{5}s", (d.Year & "").PadLeft(4, "0"), (d.Month & "").PadLeft(2, "0"), (d.Day & "").PadLeft(2, "0"), (d.Hour & "").PadLeft(2, "0"), (d.Minute & "").PadLeft(2, "0"), (d.Second & "").PadLeft(2, "0"))
        Else
            Return v
        End If
    End Function

#End Region

End Class

#Region "Classe EXIFextractorEnumerator"

Public Class EXIFextractorEnumerator : Implements System.Collections.IEnumerator

    Dim exifTable As Hashtable
    Dim index As IDictionaryEnumerator

    Public Sub New(ByVal exif As Hashtable)
        Me.exifTable = exif
        Me.Reset()
        index = exif.GetEnumerator()
    End Sub


#Region "IEnumerator Members"

    Public Overridable Sub Reset() Implements IEnumerator.Reset
        Me.index = Nothing
    End Sub


    Public Overridable ReadOnly Property Current() As Object Implements IEnumerator.Current
        Get
            Return (New System.Web.UI.Pair(Me.index.Key, Me.index.Value))
        End Get
    End Property

    Public Overridable Function MoveNext() As Boolean Implements IEnumerator.MoveNext
        If Not index Is Nothing And index.MoveNext() Then
            Return True
        Else
            Return False
        End If
    End Function

#End Region

End Class

#End Region

#Region "Class Rational"

Public Class Rational
    Private n As Integer
    Private d As Integer

    Public Sub New(ByVal n As Integer, ByVal d As Integer)
        Me.n = n
        Me.d = d
        simplify(Me.n, Me.d)
    End Sub

    Public Sub New(ByVal n As UInt32, ByVal d As UInt32)
        Me.n = Convert.ToInt32(n)
        Me.d = Convert.ToInt32(d)
        simplify(Me.n, Me.d)
    End Sub

    Public Sub New()
        Me.n = Me.d = 0
    End Sub

    Public Function ToStr(ByVal sp As String) As String
        If sp Is Nothing Then
            sp = "/"
        End If
        Return n.ToString() + sp + d.ToString()
    End Function

    Public Function ToDouble() As Double
        If d = 0 Then
            Return 0.0
        End If
        Return Math.Round(Convert.ToDouble(n) / Convert.ToDouble(d), 2)
    End Function

    Private Sub simplify(ByVal a As Integer, ByVal b As Integer)
        If (a = 0 Or b = 0) Then
            Return
        End If
        Dim gcd As Integer = euclid(a, b)
        a = a / gcd
        b = b / gcd
    End Sub

    Private Function euclid(ByVal a As Integer, ByVal b As Integer) As Integer
        If (b = 0) Then
            Return a
        Else
            Return euclid(b, a Mod b)
        End If
    End Function

End Class

#End Region

