Option Strict Off


Public Module CollectionUtils



    Public Function JoinCollection(ByVal col As Collection, ByVal Delimiter As String) As String
        Dim ret As String = ""

        Dim i As Integer = 1
        For Each c As Object In col
            ret &= c
            If (i < col.Count) Then
                ret &= Delimiter
            End If
            i += 1
        Next
        Return ret
    End Function


    Public Function JoinStringArray(ByVal col As String(), ByVal Delimiter As String) As String
        Dim ret As String = ""

        Dim i As Integer = 1
        For Each c As String In col
            ret &= c.Trim
            If (i < col.Length) Then
                ret &= Delimiter
            End If
            i += 1
        Next
        Return ret
    End Function




    Public Function SortCollection(ByVal col As Collection, ByVal psSortPropertyName As String, Optional ByVal pbAscending As Boolean = True, Optional ByVal psKeyPropertyName As String = "") As Collection

        ' The Objects were originally declared as Variants. VB.Net has 
        'eliminated the
        ' Variant type so they must be declared as type Object. 
        'Also Objects cannot be
        'used with the Set keyword, so I had to remove the set 
        'keyword. Other than that
        'I did not have to make hardly any changes.

        Dim obj As Object
        Dim i As Integer
        Dim j As Integer
        Dim iMinMaxIndex As Integer
        Dim vMinMax As Object
        Dim vValue As Object
        Dim bSortCondition As Boolean
        Dim bUseKey As Boolean
        Dim sKey As String

        bUseKey = (psKeyPropertyName <> "")

        For i = 1 To col.Count - 1
            obj = col(i)
            ' the vbGet can be replaced with a 
            'CallType.Get if you
            ' want. See VB Language reference for CallByName

            vMinMax = CallByName(obj, psSortPropertyName, vbGet)
            iMinMaxIndex = i

            For j = i + 1 To col.Count
                obj = col(j)
                vValue = CallByName(obj, _
                    psSortPropertyName, vbGet)

                If (pbAscending) Then
                    bSortCondition = (vValue < vMinMax)
                Else
                    bSortCondition = (vValue > vMinMax)
                End If

                If (bSortCondition) Then
                    vMinMax = vValue
                    iMinMaxIndex = j
                End If

                obj = Nothing
            Next j

            If (iMinMaxIndex <> i) Then
                obj = col(iMinMaxIndex)

                col.Remove(iMinMaxIndex)
                If (bUseKey) Then
                    sKey = CStr(CallByName(obj, _
                       psKeyPropertyName, vbGet))
                    col.Add(obj, sKey, i)
                Else
                    col.Add(obj, , i)
                End If

                obj = Nothing
            End If

            obj = Nothing
        Next i
        Return col
    End Function

End Module
