
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Option Strict Off

Imports System.Configuration
Imports System.IO


Public Module General

#Region "Other functions"

    Public Function GetFormTitle(ByVal Title As String) As String
        Return GetStandardFormTitle() & " " & Title
    End Function

    Private Function GetStandardFormTitle() As String
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Return String.Format(CStr(configurationAppSettings.GetValue("Application.FullName", GetType(System.String))), CStr(configurationAppSettings.GetValue("Application.Version", GetType(System.String))))
    End Function

    Public Function ICollectionToCollection(ByVal col As ICollection) As Collection
        Dim Result As New Collection

        Dim e As IEnumerator = col.GetEnumerator
        While e.MoveNext
            Result.Add(e.Current)
        End While
        Return Result
    End Function

    Public Function SortICollection(ByVal col As ICollection, ByVal SortPropertyName As String, Optional ByVal Ascending As Boolean = True) As ICollection
        Return SortCollection(ICollectionToCollection(col), SortPropertyName, Ascending)
    End Function

   

    'Public Function NormalizeDate(ByVal StrDate As String) As String
    '    If Validator.IsValidDate(StrDate) Then
    '        Return StrDate
    '    ElseIf Validator.IsReversedDate(StrDate) Then
    '        Return DateToStr(StrToDate(StrDate))
    '    ElseIf Validator.IsIncompleteDate(StrDate) Then
    '        Dim Components As String() = StrDate.Split("-")
    '        Try
    '            Dim Year As String = Components(0).PadLeft(4, "0")
    '            Dim Month As String = Components(1).PadLeft(2, "0")
    '            Dim Day As String = Components(2).PadLeft(2, "0")
    '            Return String.Format("{0}-{1}-{2}", Year, Month, Day)
    '        Catch ex As Exception
    '            Return "0000-00-00"
    '        End Try
    '    ElseIf Validator.IsJustYearDate(StrDate) Then
    '        Return String.Format("{0}-00-00", StrDate)
    '    Else
    '        Return "0000-00-00"
    '    End If
    'End Function



#End Region


#Region "Text Files"

    Public Function ReadTextFile(ByVal filename As String) As String
        Try
            ' Create an instance of StreamReader to read from a file.
            Dim sr As StreamReader = New StreamReader(filename, System.Text.Encoding.Default)
            Dim str As String = sr.ReadToEnd
            sr.Close()
            Return str
        Catch E As Exception
            Debug.WriteLine(E.Message & ControlChars.NewLine & E.StackTrace)
            Return ""
        End Try
    End Function


    Public Function ReadBinaryFile(ByVal FileName As String) As Byte()
        Try
            Dim FileStream As New FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read)
            Dim BinaryReader As New BinaryReader(FileStream)
            Dim Ret() As Byte = BinaryReader.ReadBytes(FileStream.Length)
            FileStream.Close()
            BinaryReader.Close()

            Return Ret
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Function


    Public Sub appendToTextFile(ByVal FileName As String, ByVal message As String)
        Try
            Dim sw As StreamWriter = New StreamWriter(FileName, True)
            sw.WriteLine(message)
            sw.Close()
        Catch E As Exception
            Debug.WriteLine(E.Message & ControlChars.NewLine & E.StackTrace)
            Throw E
        End Try
    End Sub

#End Region


#Region "Create  Html Tag"

    Public Function CreateHTMLTag(ByVal desc As String, ByVal value As String) As String
        Select Case value
            Case "" : Return ""
            Case Else : Return "<p class='Indent20'><font class='TextNavy'>" & desc & " " & "</font><font class='TextGray'>" & value & "</font></p>"
        End Select
    End Function

#End Region


#Region " Write in Html the description and the BD value if the value exists"

    Public Function WriteIfNotEmpty(ByVal desc As String, ByVal value As String) As String

        If value <> "" Then
            Return desc & value
        End If
        Return ""
    End Function

#End Region


End Module



