Public Module TypeConversion


#Region "Database to Type"

    Public Function DBToDate(ByVal obj As Object) As Date
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return Date.Parse("0001-01-01")
        Else
            Try
                Dim d As Date = CDate(obj)
                Return d
            Catch ex As Exception
                Return Date.Parse("0001-01-01")
            End Try
        End If
    End Function


    Public Function DBToInt(ByVal obj As Object) As Integer
        If obj Is System.DBNull.Value Or obj.Equals("") Then Return 0 Else Return CInt(obj)
    End Function

    Public Function DBToInt64(ByVal obj As Object) As Int64
        If obj Is System.DBNull.Value Or obj.Equals("") Then Return 0 Else Return CType(obj, Int64)
    End Function

    Public Function DBToDbl(ByVal obj As Object) As Double
        If obj Is System.DBNull.Value Then Return 0.0 Else Return Double.Parse(DBToStr(obj).Replace(".", ","))
    End Function


    Public Function DBToStr(ByVal obj As Object) As String
        If obj Is System.DBNull.Value Then Return "" Else Return CStr(obj)
    End Function

    Public Function DBToBool(ByVal obj As Object) As Boolean
        If obj Is System.DBNull.Value Then Return False Else Return CBool(obj)
    End Function

    Public Function DBToByte(ByVal obj As Object) As Byte()

        If obj Is System.DBNull.Value Then

            Dim bytDataNull(0) As Byte

            bytDataNull(0) = CType(0, Byte)

            Return bytDataNull
        Else
            Dim DataByte() As Byte = CType(obj, Byte())
            Return DataByte
        End If
    End Function

    Public Function DBToDate_YYYY(ByVal obj As Object) As String
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return ""
        Else
            Try
                Return CDate(obj).Year.ToString
            Catch ex As Exception
                Return ""
            End Try
        End If
    End Function

    Public Function DBToDate_MM(ByVal obj As Object) As String
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return ""
        Else
            Try
                Return CDate(obj).Month.ToString.PadLeft(2, CChar("0"))
            Catch ex As Exception
                Return ""
            End Try
        End If
    End Function

    Public Function DBToDate_DD(ByVal obj As Object) As String
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return ""
        Else
            Try
                Return CDate(obj).Day.ToString.PadLeft(2, CChar("0"))
            Catch ex As Exception
                Return ""
            End Try
        End If
    End Function

    Public Function DBToYYYY(ByVal obj As String) As String
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return ""
        Else
            Try
                Return obj.Substring(0, 4)
            Catch ex As Exception
                Return ""
            End Try
        End If
    End Function

    Public Function DBToMM(ByVal obj As String) As String
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return ""
        Else
            Try
                Return obj.Substring(5, 2)
            Catch ex As Exception
                Return ""
            End Try
        End If
    End Function

    Public Function DBToDD(ByVal obj As String) As String
        If obj Is Nothing OrElse obj Is System.DBNull.Value Then
            Return ""
        Else
            Try
                Return obj.Substring(8, 2)
            Catch ex As Exception
                Return ""
            End Try
        End If
    End Function


#End Region

#Region "Type to String"

    Public Function DateToStr(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2}", (v.Year & "").PadLeft(4, CChar("0")), (v.Month & "").PadLeft(2, CChar("0")), (v.Day & "").PadLeft(2, CChar("0")))
    End Function

    Public Function CompleteDateToStr(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2} {3}", (v.Year & "").PadLeft(4, CChar("0")), (v.Month & "").PadLeft(2, CChar("0")), (v.Day & "").PadLeft(2, CChar("0")), _
        v.Hour.ToString.PadLeft(2, CChar("0")) & "h" & v.Minute.ToString.PadLeft(2, CChar("0")))
    End Function

    Public Function IntToStr(ByVal v As Integer) As String
        Return CStr(v)
    End Function

    Public Function DblToStr(ByVal v As Double) As String
        Return v.ToString
    End Function

    Public Function BoolToStr(ByVal v As Boolean) As String
        Return v.ToString
    End Function

#End Region

#Region "Type to Database"

    Public Function DateToDB(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2}", (v.Year & "").PadLeft(4, CChar("0")), (v.Month & "").PadLeft(2, CChar("0")), (v.Day & "").PadLeft(2, CChar("0")))
    End Function

    Public Function CompleteDateToDB(ByVal v As Date) As String
        Return String.Format("{0}-{1}-{2} {3}:{4}:{5}", (v.Year & "").PadLeft(4, CChar("0")), (v.Month & "").PadLeft(2, CChar("0")), (v.Day & "").PadLeft(2, CChar("0")), (v.Hour & "").PadLeft(2, CChar("0")), (v.Minute & "").PadLeft(2, CChar("0")), (v.Second & "").PadLeft(2, CChar("0")))
    End Function

    Public Function IntToDB(ByVal v As Integer) As Object
        'If (v = 0 Or v = -1) Then Return "NULL" Else Return v
        If (v = 0 Or v = -1) Then Return System.DBNull.Value Else Return v
    End Function

    Public Function Int64ToDB(ByVal v As Int64) As Object
        If (v = 0 Or v = -1) Then Return System.DBNull.Value Else Return v
    End Function

    Public Function BoolToDB(ByVal v As Boolean) As Integer
        If v Then Return 1 Else Return 0
    End Function


    Public Function StrToDB(ByVal v As String) As String
        If v Is Nothing Then Return "" Else Return v.Replace("'", "''")
    End Function


    Public Function DblToDB(ByVal v As Double) As String
        Return v.ToString().Replace(",", ".")
    End Function

    Public Function IntToQry(ByVal v As Integer) As Object
        If (v = 0 Or v = -1) Then Return "NULL" Else Return v
    End Function

#End Region

#Region "String To Type"

    Public Function StrToDbl(ByVal v As String) As Double
        Try
            Dim i As Double = Double.Parse(v)
            Return i
        Catch ex As Exception
            Debug.WriteLine("StrToDbl Exception = " & v)
            Return 0.0
        End Try
    End Function



    Public Function StrToInt(ByVal v As String) As Integer
        Try
            Dim i As Integer = Integer.Parse(v)
            Return i
        Catch ex As Exception
            Return 0
        End Try
    End Function


    Public Function StrToDate(ByVal v As String) As Date
        Try
            Dim d As Date = Date.Parse(v)
            Return d
        Catch ex As Exception
            Return Date.Parse("0001-01-01")
        End Try
    End Function


    Public Function StrToBool(ByVal v As String) As Boolean
        v = v.ToLower
        Return v = "1" OrElse v = "yes" OrElse v = "true"
    End Function


#End Region

#Region "Database to interface"

    Public Function StrToInterface(ByVal v As String, ByVal strAux As String) As String
        If (v = "" Or v Is Nothing) Then Return "<i>(" & strAux & ")</i>" Else Return v
    End Function

    Public Function DateToInterface(ByVal di As String, ByVal df As String, ByVal sep As String) As String
        If (df = "" Or df Is Nothing) Then Return di Else Return di + " " + sep + " " + df
    End Function

#End Region

End Module
