Public Module DateValidation

    Public Enum ExtremeDateTypes
        Initial
        Final
    End Enum

    Public Const IncompleteDate As String = "^\d*-\d*-\d*$"
    Public Const DayMonthYear As String = "^\d\d-\d\d-\d\d\d\d$"
    Public Const YearMonthDay As String = "^\d\d\d\d-\d\d-\d\d$"
    Public Const YearMonth As String = "^\d\d\d\d-\d\d-$"
    Public Const YearDay As String = "^\d\d\d\d--\d\d$"
    Public Const Year As String = "^\d\d\d\d--$"
    Public Const JustYear As String = "^\d\d\d\d$"


    Public Function IsValidDate(ByVal v As String) As Boolean
        Return Matches(v, YearMonthDay)
    End Function

    Public Function IsReversedDate(ByVal v As String) As Boolean
        Return Matches(v, DayMonthYear)
    End Function

    Public Function IsIncompleteDate(ByVal v As String) As Boolean
        Return Matches(v, IncompleteDate)
    End Function

    Public Function IsJustYearDate(ByVal v As String) As Boolean
        Return Matches(v, JustYear)
    End Function



    Public Function AreExtremeDatesValid(ByRef InitialDate As String, ByRef FinalDate As String) As Boolean

        If Matches(InitialDate, YearMonthDay) AndAlso Matches(FinalDate, YearMonthDay) Then
            Dim FixedInitialDate As String = FixUnkownDate(InitialDate, ExtremeDateTypes.Initial)
            Dim FixedFinalDate As String = FixUnkownDate(FinalDate, ExtremeDateTypes.Final)
            Debug.WriteLine("FixedInitialDate=" & FixedInitialDate)
            Debug.WriteLine("FixedFinalDate=" & FixedFinalDate)
            Return FixedInitialDate.CompareTo(FixedFinalDate) <= 0
        Else
            Return False
        End If
    End Function


End Module
