Imports DigitArq.Definitions


Public Module EADValidation



    Public Function hasRepository(ByVal v As String) As Boolean
        Return (Not v Is Nothing) AndAlso v.Length > 0
    End Function


    Public Function IsFondsReference(ByVal v As String) As Boolean
        Return Matches(v, "^(\w+\/)?\w+$")
    End Function

    Public Function IsSubFondsReference(ByVal v As String) As Boolean
        Return Matches(v, "^\w+$")
    End Function

    Public Function IsSectionReference(ByVal v As String) As Boolean
        Return Matches(v, "^\w+$")
    End Function

    Public Function IsSeriesReference(ByVal v As String) As Boolean
        Return Matches(v, "^\d\d\d$")
    End Function

    Public Function IsInstalationUnitReference(ByVal v As String) As Boolean
        Return Matches(v, "^\d+([\.\:]\d+)*[A-Z]?$")
    End Function

    Public Function IsComposedDocumentReference(ByVal v As String) As Boolean
        Return Matches(v, "^\d+([\.\:]\d+)*[A-Z]?$")
    End Function


    Public Function IsDocumentReference(ByVal v As String) As Boolean
        Return Matches(v, "^\d+([\.\:]\d+)*[A-Z]?$")
    End Function




    Public Function IsValidContainerType(ByVal v As String) As Boolean

        Return v = VisualFieldLabel("ContainerType.Book") OrElse _
               v = VisualFieldLabel("ContainerType.Box") OrElse _
               v = VisualFieldLabel("ContainerType.Maco") OrElse _
               v = VisualFieldLabel("ContainerType.Macete") OrElse _
               v = VisualFieldLabel("ContainerType.Folder") OrElse _
               v = VisualFieldLabel("ContainerType.Cover") OrElse _
               v = VisualFieldLabel("ContainerType.Capilha") OrElse _
               v = VisualFieldLabel("ContainerType.Roll") OrElse _
               v = VisualFieldLabel("ContainerType.Envelope") OrElse _
               v = VisualFieldLabel("ContainerType.Album") OrElse _
               v = VisualFieldLabel("ContainerType.Other")
    End Function



    Public Function IsValidOtherLevel(ByRef v As String) As Boolean
        Select Case v
            Case EAD.OTHERLEVEL_FONDS, _
                 EAD.OTHERLEVEL_SUBFONDS, _
                 EAD.OTHERLEVEL_SECTION, _
                 EAD.OTHERLEVEL_SUBSECTION, _
                 EAD.OTHERLEVEL_SUBSUBSECTION, _
                 EAD.OTHERLEVEL_SERIES, _
                 EAD.OTHERLEVEL_SUBSERIES, _
                 EAD.OTHERLEVEL_INSTALATIONUNIT, _
                 EAD.OTHERLEVEL_COMPOSEDDOCUMENT, _
                 EAD.OTHERLEVEL_DOCUMENT
                Return True
            Case Else
                Return False
        End Select
    End Function



    Public Function IsReferenceValid(ByRef v As String, ByVal OtherLevel As String) As Boolean
        Select Case OtherLevel
            Case EAD.OTHERLEVEL_FONDS : Return IsFondsReference(v)
            Case EAD.OTHERLEVEL_SUBFONDS, _
                 EAD.OTHERLEVEL_SUBSUBFONDS : Return IsSubFondsReference(v)
            Case EAD.OTHERLEVEL_SECTION, _
                 EAD.OTHERLEVEL_SUBSECTION, _
                 EAD.OTHERLEVEL_SUBSUBSECTION : Return IsSectionReference(v)
            Case EAD.OTHERLEVEL_SERIES, _
                 EAD.OTHERLEVEL_SUBSERIES, _
                 EAD.OTHERLEVEL_SUBSUBSERIES : Return IsSeriesReference(v)
            Case EAD.OTHERLEVEL_INSTALATIONUNIT : Return IsInstalationUnitReference(v)
            Case EAD.OTHERLEVEL_COMPOSEDDOCUMENT : Return IsComposedDocumentReference(v)
            Case EAD.OTHERLEVEL_DOCUMENT : Return IsDocumentReference(v)
        End Select
    End Function


End Module
