
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Public Class ComboBoxImage
    Inherits ComboBox

    Private myImageList As ImageList


    Sub New()
        MyBase.new()
        DrawMode = DrawMode.OwnerDrawFixed
        DropDownStyle = ComboBoxStyle.DropDownList
        ImageList = Nothing
        MaxDropDownItems = 12
        Size = New Size(120, 20)
    End Sub


    Property ImageList() As ImageList
        Get
            Return myImageList
        End Get
        Set(ByVal Value As ImageList)
            myImageList = Value
        End Set
    End Property



    Protected Overrides Sub onDrawItem(ByVal ea As DrawItemEventArgs)
        ea.DrawBackground()
        ea.DrawFocusRectangle()
        Dim item As ComboBoxImageItem

        Dim imageSize As Size = New Size(0, 0)
        If Not ImageList Is Nothing Then
            imageSize = ImageList.ImageSize()
        End If


        Dim bounds As Rectangle = ea.Bounds
        Try
            item = CType(Items(ea.Index), ComboBoxImageItem)
            If (item.ImageIndex <> -1) Then
                ImageList.Draw(ea.Graphics, bounds.Left, bounds.Top, item.ImageIndex)
                ea.Graphics.DrawString(item.Label, ea.Font, New SolidBrush(ea.ForeColor), bounds.Left + imageSize.Width, bounds.Top)
            Else
                ea.Graphics.DrawString(item.Label, ea.Font, New SolidBrush(ea.ForeColor), bounds.Left, bounds.Top)
            End If
        Catch
            If (ea.Index <> -1) Then
                ea.Graphics.DrawString(Items(ea.Index).ToString(), ea.Font, New SolidBrush(ea.ForeColor), bounds.Left, bounds.Top)
            Else
                ea.Graphics.DrawString(Text, ea.Font, New SolidBrush(ea.ForeColor), bounds.Left, bounds.Top)
            End If
        End Try
        MyBase.OnDrawItem(ea)
    End Sub


    Public Function getValueIndex(ByVal value As String) As Integer
        Dim item As ComboBoxImageItem
        Dim index As Integer = 0
        Dim result As Integer = -1
        For Each item In Items
            If (item.Value() = value) Then
                result = index
                Exit For
            End If
            index += 1
        Next

        Return result
    End Function


    Public Function getLabelIndex(ByVal value As String) As Integer
        Dim item As ComboBoxImageItem
        Dim index As Integer = 0
        Dim result As Integer = -1
        For Each item In Items
            If (item.Label() = value) Then
                result = index
                Exit For
            End If
            index += 1
        Next

        Return result
    End Function



    Public Shadows Property SelectedValue() As String
        Get
            Return CType(SelectedItem, ComboBoxImageItem).Value
        End Get
        Set(ByVal Value As String)
            Me.SelectedIndex = getValueIndex(Value)
        End Set
    End Property


    Public Shadows Property SelectedText() As String
        Get
            Return CType(SelectedItem, ComboBoxImageItem).Label
        End Get
        Set(ByVal Value As String)
            Me.SelectedIndex = getLabelIndex(Value)
        End Set
    End Property


End Class


Public Class ComboBoxImageItem
    Private myLabel As String
    Private myValue As String
    Private myImageIndex As Integer



    Public Property Value() As String
        Get
            Return myValue
        End Get
        Set(ByVal Value As String)
            myValue = Value
        End Set
    End Property

    Public Property Label() As String
        Get
            Return myLabel
        End Get
        Set(ByVal Value As String)
            myLabel = Value
        End Set
    End Property



    Property ImageIndex() As Integer
        Get
            Return myImageIndex
        End Get
        Set(ByVal Value As Integer)
            myImageIndex = Value
        End Set
    End Property

    Public Sub New(ByVal text As String, Optional ByVal value As String = Nothing, Optional ByVal imageIndex As Integer = -1)
        myLabel = text
        myImageIndex = imageIndex
        myValue = value
    End Sub

    Public Overrides Function ToString() As String
        Return Label
    End Function
End Class

