
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Text.RegularExpressions
Imports System.ComponentModel


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.UserControls


Public Class ValidTextBox
    Inherits TextBox

    Private myFieldType As FieldTypes
    Private myAllowErrorMessage As Boolean
    Private myErrorMessageArguments As Collection

    Public Enum FieldTypes As Integer
        DefaultField
        DateField
        FondsReferenceField
        ReferenceField
        NotEmptyField
        FloatField
        IntegerField
    End Enum


    Public Sub New()
        MyBase.New()
        MyBase.MaxLength = 500000
        myFieldType = FieldTypes.NotEmptyField
        myAllowErrorMessage = True
        myErrorMessageArguments = New Collection
    End Sub



    Public Property ErrorMessageArguments() As Collection
        Get
            Return myErrorMessageArguments
        End Get
        Set(ByVal Value As Collection)
            myErrorMessageArguments = Value
        End Set
    End Property



    Public Property AllowErrorMessage() As Boolean
        Get
            Return myAllowErrorMessage
        End Get
        Set(ByVal Value As Boolean)
            myAllowErrorMessage = Value
        End Set
    End Property



    Public Property FieldType() As FieldTypes
        Get
            Return myFieldType
        End Get
        Set(ByVal Value As FieldTypes)
            myFieldType = Value
            If (myFieldType = FieldTypes.IntegerField Or myFieldType = FieldTypes.FloatField) Then
                Me.RightToLeft = RightToLeft.Yes
            Else
                Me.RightToLeft = RightToLeft.No
            End If


        End Set
    End Property



    Protected Overrides Sub OnValidating(ByVal e As CancelEventArgs)
        If isValid() Then
            Me.ForeColor = Color.Black
            MyBase.OnValidating(e) ' move on 
        ElseIf CBool(ContinueAnyway()) Then
            Me.ForeColor = Color.Red
            MyBase.OnValidating(e) ' move on 
        Else
            Me.ForeColor = Color.Red
            e.Cancel = True
        End If
    End Sub



    Public Function isValid() As Boolean
        Select Case FieldType
            Case FieldTypes.DefaultField : Return True
            Case FieldTypes.DateField : Return IsValidDate(Text)
            Case FieldTypes.FondsReferenceField : Return IsFondsReference(Text)
            Case FieldTypes.NotEmptyField : Return IsNotEmpty(Text)
            Case FieldTypes.IntegerField : Return IsInteger(Text)
            Case FieldTypes.FloatField : Return IsFloat(Text)
            Case FieldTypes.ReferenceField : Return IsNotEmpty(Text)
        End Select
    End Function


    Private Function ContinueAnyway() As Boolean
        If Not myAllowErrorMessage Then Return True
        Select Case FieldType
            Case FieldTypes.DateField : Return ShowErrorMessage(ErrorMessage("NotValidDate"))
            Case FieldTypes.FondsReferenceField : Return ShowErrorMessage(ErrorMessage("NotFondsReference"))
            Case FieldTypes.NotEmptyField : Return ShowErrorMessage(ErrorMessage("EmptyField"))
            Case FieldTypes.IntegerField : Return ShowErrorMessage(ErrorMessage("NotInteger"))
            Case FieldTypes.FloatField : Return ShowErrorMessage(ErrorMessage("NotFloat"))
            Case FieldTypes.ReferenceField : Return ShowErrorMessage(ErrorMessage("EmptyField"))
        End Select
    End Function



    Public Function ShowErrorMessage(ByVal Message As String) As Boolean
        Return DialogResult.Yes = MessageBox.Show(Message, ErrorMessage("ShowErrorMessage.Title"), MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
    End Function


    Private Sub ValidTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.GotFocus
        If Not Me.ReadOnly Then
            Me.BackColor = Color.FromArgb(255, 255, 210)
            Me.SelectAll()
        End If
    End Sub


    Private Sub ValidTextBox_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Leave
        If Not Me.ReadOnly Then
            BackColor = Color.White
        End If
    End Sub

End Class

