
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls.MaskedBox




Public Class VisualDateField
    Inherits Panel
    Implements VisualComponent

#Region "Properties and Events"

    Private WithEvents myDateBox As DateTextBox
    Public Event ValueChanged(ByVal EventCode As Integer, ByVal Value As Object) Implements VisualComponent.ValueChanged
    Private myToolTip As ToolTip

#End Region

#Region "Constants"
    Public Const DefaultTextBoxHeight As Integer = 20
    Public Const DefaultLabelWidth As Integer = 100
    Public Const DefaultLabelTextBoxGap As Integer = 5

    Public Const TextBoxWidthExtraSmall As Integer = 50
    Public Const TextBoxWidthSmall As Integer = 100
    Public Const TextBoxWidthMedium As Integer = 200
    Public Const TextBoxWidthLarge As Integer = 300

#End Region

    Public Sub New()
        myDateBox = New DateTextBox
        myToolTip = New ToolTip

        With myDateBox
            .Location = New Point(0, 0)
            .BorderStyle = BorderStyle.FixedSingle
            .Font = DigitarqFonts.StandardFont
            .Width = CInt(.Font.Size * 8)
        End With

        Me.Size = New Size(myDateBox.Width, myDateBox.Height)
        Me.Controls.Add(myDateBox)
    End Sub

    Public Property Tip() As String
        Get
            Return myToolTip.GetToolTip(myDateBox)
        End Get
        Set(ByVal Value As String)
            myToolTip.SetToolTip(myDateBox, Value)
        End Set
    End Property


    Public Property Value() As Object Implements VisualComponent.Value
        Get
            Return myDateBox.Text
        End Get
        Set(ByVal Value As Object)
            myDateBox.Text = CStr(Value)
        End Set
    End Property


    Public Property [ReadOnly]() As Boolean
        Get
            Return myDateBox.ReadOnly
        End Get
        Set(ByVal Value As Boolean)
            myDateBox.ReadOnly = Value
        End Set
    End Property


    Protected Sub StateChanged(ByVal sender As Object, ByVal e As EventArgs) Handles myDateBox.TextChanged
        RaiseEvent ValueChanged(0, myDateBox.Text)
    End Sub

End Class
