
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports DigitArq.UserControls.CustomUserControls
Imports DigitArq.Definitions

Public Class VisualLabelField
    Inherits Panel
    Implements VisualComponent


#Region "Properties and Events"

    Private myLabel As Label
    Private WithEvents myTextLabel As Label
    Private myMandatory As Boolean

    Private myToolTip As ToolTip
    Public Event ValueChanged(ByVal EventCode As Integer, ByVal Value As Object) Implements VisualComponent.ValueChanged

#End Region

#Region "Constants"
    Public Const DefaultTextBoxHeight As Integer = 15
    Public Const DefaultLabelWidth As Integer = 120
    Public Const DefaultLabelTextBoxGap As Integer = 5

    Public Const TextBoxWidthExtraSmall As Integer = 50
    Public Const TextBoxWidthSmall As Integer = 100
    Public Const TextBoxWidthMedium As Integer = 200
    Public Const TextBoxWidthLarge As Integer = 300
    Public Const TextBoxWidthExtraLarge As Integer = 360

    Public Const TextBoxHeightSmall As Integer = 1
    Public Const TextBoxHeightMedium As Integer = 5
    Public Const TextBoxHeightLarge As Integer = 20



#End Region


    Public Sub New(ByVal Label As String, ByVal Length As Integer, ByVal Lines As Integer)
        Me.New(Label, DefaultLabelWidth, Length, Lines, ValidTextBox.FieldTypes.DefaultField)
    End Sub

    Public Sub New(ByVal Label As String, ByVal Length As Integer, ByVal ValidationType As ValidTextBox.FieldTypes)
        Me.New(Label, DefaultLabelWidth, Length, 1, ValidationType)
    End Sub


    Public Sub New(ByVal Label As String, ByVal Length As Integer)
        Me.New(Label, DefaultLabelWidth, Length, 1, ValidTextBox.FieldTypes.DefaultField)
    End Sub



    Public Sub New(ByVal Label As String, ByVal LabelWidth As Integer, _
                   ByVal Length As Integer, _
                   ByVal ValidationType As ValidTextBox.FieldTypes)
        Me.New(Label, LabelWidth, Length, 1, ValidationType)
    End Sub





    Public Sub New(ByVal Label As String, ByVal LabelWidth As Integer, _
                   ByVal Length As Integer, ByVal Lines As Integer, _
                   ByVal ValidationType As ValidTextBox.FieldTypes)
        ' Visual Components
        myLabel = New Label
        myTextLabel = New Label

        myToolTip = New ToolTip

        With myLabel
            .Text = Label
            .Location = New Point(0, 0)
            .Size = New Size(LabelWidth, DefaultTextBoxHeight)
            .Font = DigitarqFonts.StandardFont
        End With


        With myTextLabel
            If myLabel.Width = 0 Then
                .Location = New Point(0, 0)
            Else
                .Location = New Point(myLabel.Width + DefaultLabelTextBoxGap, 0)
            End If

            .Size = New Size(Length, DefaultTextBoxHeight)

            If (ValidationType = ValidTextBox.FieldTypes.IntegerField Or ValidationType = ValidTextBox.FieldTypes.FloatField) Then
                .TextAlign = ContentAlignment.MiddleRight
            Else
                .TextAlign = ContentAlignment.MiddleLeft
            End If
            '.BorderStyle = BorderStyle.FixedSingle

            .Font = DigitarqFonts.StandardFont
        End With

        Me.Size = New Size(myTextLabel.Location.X + myTextLabel.Width, myTextLabel.Height)
        Me.Controls.Add(myLabel)
        Me.Controls.Add(myTextLabel)
    End Sub


    Public Property Tip() As String
        Get
            Return myToolTip.GetToolTip(myTextLabel)
        End Get
        Set(ByVal Value As String)
            myToolTip.SetToolTip(myTextLabel, Value)
            myToolTip.SetToolTip(myLabel, Value)
        End Set
    End Property




    Public Property Value() As Object Implements VisualComponent.Value
        Get
            Return myTextLabel.Text
        End Get
        Set(ByVal Value As Object)
            myTextLabel.Text = CStr(Value)
        End Set
    End Property



    Public Property Mandatory() As Boolean
        Get
            Return myMandatory
        End Get
        Set(ByVal Value As Boolean)
            myMandatory = Value

            If myMandatory Then
                myLabel.ForeColor = VisualField.MandatoryForeColor
                'myLabel.Font = New Font(myLabel.Font, FontStyle.Underline)
            Else
                myLabel.ForeColor = System.Drawing.Color.Black
                'myLabel.Font = New Font(myLabel.Font, FontStyle.Regular)
            End If

        End Set
    End Property





End Class
