
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports DigitArq.Definitions
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualTextField
    Inherits Panel
    Implements VisualComponent


#Region "Properties and Events"

    Private myLabel As Label
    Private WithEvents myTextBox As ValidTextBox
    Private myMandatory As Boolean
    Private myToolTip As ToolTip

    Public Event ValueChanged(ByVal EventCode As Integer, ByVal Value As Object) Implements VisualComponent.ValueChanged
    Public Event ShowContextBox(ByVal Sender As Object, ByVal e As MouseEventArgs)
#End Region

#Region "Constants"
    Public Const DefaultLabelWidth As Integer = 200
    Public Const DefaultLabelTextBoxGap As Integer = 5

    Public Const TextBoxWidthExtraExtraSmall As Integer = 75
    Public Const TextBoxWidthExtraSmall As Integer = 150
    Public Const TextBoxWidthSmall As Integer = 250
    Public Const TextBoxWidthMedium As Integer = 300
    Public Const TextBoxWidthMediumLarge As Integer = 420
    Public Const TextBoxWidthLarge As Integer = 500
    Public Const TextBoxWidthExtraLarge As Integer = 520

    Public Const DefaultTextBoxHeight As Integer = 20
    Public Const TextBoxHeightSmall As Integer = 1
    Public Const TextBoxHeightMediumSmall As Integer = 3
    Public Const TextBoxHeightMedium As Integer = 7
    Public Const TextBoxHeightLarge As Integer = 15

    Public Const TextBoxLongMaxLength As Integer = 1000000
    Public Const TextBoxShortMaxLength As Integer = 1000000



#End Region


    Public Sub New(ByVal Label As String, ByVal Width As Integer, Optional ByVal NoLines As Integer = 1)
        Me.New(Label, DefaultLabelWidth, Width - DefaultLabelWidth - DefaultLabelTextBoxGap, NoLines, ValidTextBox.FieldTypes.DefaultField)
    End Sub

    Public Sub New(ByVal Label As String, ByVal Width As Integer, ByVal ValidationType As ValidTextBox.FieldTypes)
        Me.New(Label, DefaultLabelWidth, Width - DefaultLabelWidth - DefaultLabelTextBoxGap, 1, ValidationType)
        'Me.New(Label, DefaultLabelWidth, Length, 1, ValidationType)
    End Sub


    'Public Sub New(ByVal Label As String, ByVal Width As Integer)
    '    Me.New(Label, DefaultLabelWidth, Width - DefaultLabelWidth - DefaultLabelTextBoxGap, 1, ValidTextBox.FieldTypes.DefaultField)
    'End Sub



    Public Sub New(ByVal Label As String, _
                   ByVal LabelWidth As Integer, _
                   ByVal TextBoxWidth As Integer, _
                   ByVal ValidationType As ValidTextBox.FieldTypes)
        Me.New(Label, LabelWidth, TextBoxWidth, 1, ValidationType)
    End Sub





    Public Sub New(ByVal Label As String, _
                   ByVal LabelWidth As Integer, _
                   ByVal TextBoxWidth As Integer, _
                   ByVal TextBoxNoLines As Integer, _
                   ByVal ValidationType As ValidTextBox.FieldTypes)
        Me.Width = LabelWidth + DefaultLabelTextBoxGap + TextBoxWidth

        myLabel = New Label
        myTextBox = New ValidTextBox
        myToolTip = New ToolTip

        With myLabel
            .Text = Label
            .Location = New Point(0, 0)
            .Width = LabelWidth
            .Height = DefaultTextBoxHeight * TextBoxNoLines
            .Font = DigitarqFonts.StandardFont
        End With


        With myTextBox
            If myLabel.Width = 0 Then
                .Location = New Point(0, 0)
            Else
                .Location = New Point(myLabel.Width + DefaultLabelTextBoxGap, 0)
            End If


            If TextBoxNoLines > 1 Then
                .Multiline = True
                .ScrollBars = ScrollBars.Vertical
                .MaxLength = TextBoxLongMaxLength
            Else
                .MaxLength = TextBoxShortMaxLength
            End If

            .Size = New Size(TextBoxWidth, DefaultTextBoxHeight * TextBoxNoLines)
            .BorderStyle = BorderStyle.FixedSingle
            .FieldType = ValidationType
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Right Or AnchorStyles.Left Or AnchorStyles.Top
        End With

        'Me.Size = New Size(myTextBox.Location.X + myTextBox.Width, myTextBox.Height)
        Me.Height = myTextBox.Height
        'Me.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top

        'Me.BackColor = Color.Blue
        Me.Controls.Add(myLabel)
        Me.Controls.Add(myTextBox)
    End Sub


    Public Property Tip() As String
        Get
            Return myToolTip.GetToolTip(myTextBox)
        End Get
        Set(ByVal Value As String)
            myToolTip.SetToolTip(myTextBox, Value)
            myToolTip.SetToolTip(myLabel, Value)
        End Set
    End Property



    Public Property ValidationType() As ValidTextBox.FieldTypes
        Get
            Return myTextBox.FieldType
        End Get
        Set(ByVal Value As ValidTextBox.FieldTypes)
            myTextBox.FieldType = Value
        End Set
    End Property




    Protected Sub StateChanged(ByVal sender As Object, ByVal e As EventArgs) Handles myTextBox.TextChanged 'Its better than Leave
        RaiseEvent ValueChanged(0, myTextBox.Text)
    End Sub




    Protected Sub myTextBox_ShowContextBox(ByVal Sender As Object, ByVal e As MouseEventArgs) Handles myTextBox.MouseUp
        If e.Button = MouseButtons.Right Then RaiseEvent ShowContextBox(myTextBox, e)
    End Sub

    'Protected Sub KeyPressed(ByVal sender As Object, ByVal e As KeyPressEventArgs) Handles myTextBox.KeyPress
    '    RaiseEvent KeyPress(Me, e)
    'End Sub



    Public Property Value() As Object Implements VisualComponent.Value
        Get
            Return myTextBox.Text
        End Get
        Set(ByVal Value As Object)
            myTextBox.Text = CStr(Value)
        End Set
    End Property



    Public Property Mandatory() As Boolean
        Get
            Return myMandatory
        End Get
        Set(ByVal Value As Boolean)
            myMandatory = Value

            If myMandatory Then
                myLabel.ForeColor = VisualField.MandatoryForeColor
                'myLabel.Font = New Font(myLabel.Font, FontStyle.Underline)
            Else
                myLabel.ForeColor = System.Drawing.Color.Black
                'myLabel.Font = New Font(myLabel.Font, FontStyle.Regular)
            End If

        End Set
    End Property



    Public Property [ReadOnly]() As Boolean
        Get
            Return myTextBox.ReadOnly
        End Get
        Set(ByVal Value As Boolean)
            myTextBox.ReadOnly = Value
        End Set
    End Property



    Public Property MaxLength() As Integer
        Get
            Return myTextBox.MaxLength
        End Get
        Set(ByVal Value As Integer)
            myTextBox.MaxLength = Value
        End Set
    End Property

    Public ReadOnly Property TextBox() As TextBox
        Get
            Return myTextBox
        End Get
    End Property



    Private Sub VisualTextField_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles myTextBox.GotFocus
        myTextBox.Select(myTextBox.Text.Length, 0)
    End Sub
End Class

