
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Configuration
Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton




Public Class VisualFieldAltFormAvail
    Inherits VisualField

    Private WithEvents myTextField As VisualTextField
    Private WithEvents myDOList As ListView

    Public Sub New(ByVal LazyNode As LazyNode, ByVal ButtonImages As ImageList, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode

        myTextField = New VisualTextField(VisualFieldLabel("AltFormAvail"), Width, VisualTextField.TextBoxHeightMedium)
        myTextField.Value = LazyNode.AltFormAvail
        myTextField.Anchor = AnchorStyles.Left Or AnchorStyles.Top Or AnchorStyles.Right

        Dim chDigitalObject As New ColumnHeader
        chDigitalObject.Text = VisualFieldLabel("DigitalObjectHeader")
        chDigitalObject.Width = CInt((VisualTextField.TextBoxWidthExtraLarge - 15) * 0.25)

        Dim chArchiveID As New ColumnHeader
        chArchiveID.Text = VisualFieldLabel("ArchiveIDHeader")
        chArchiveID.Width = CInt((VisualTextField.TextBoxWidthExtraLarge - 15) * 0.25)

        Dim chTopographicalQuota As New ColumnHeader
        chTopographicalQuota.Text = VisualFieldLabel("TopographicalQuotaHeader")
        chTopographicalQuota.Width = CInt((VisualTextField.TextBoxWidthExtraLarge - 15) * 0.3)

        Dim chImageName As New ColumnHeader
        chImageName.Text = VisualFieldLabel("ImageNameHeader")
        chImageName.Width = CInt((VisualTextField.TextBoxWidthExtraLarge - 15) * 0.2)

        myDOList = New ListView
        With myDOList
            .Location = New Point(VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap, myTextField.Location.Y + myTextField.Height + 5)
            .Width = Width - VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap - 10
            .Alignment = System.Windows.Forms.ListViewAlignment.Default
            .AllowColumnReorder = True
            .AutoArrange = False
            .BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            .Columns.AddRange(New System.Windows.Forms.ColumnHeader() {chDigitalObject, chArchiveID, chTopographicalQuota, chImageName})
            .FullRowSelect = True
            .HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
            .LabelWrap = False
            .MultiSelect = False
            .Sorting = System.Windows.Forms.SortOrder.Ascending
            .View = System.Windows.Forms.View.Details
            .Items.Clear()
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Top Or AnchorStyles.Right
        End With

        Me.Height = Me.myTextField.Height + 5 + Me.myDOList.Height
        Me.Controls.Add(myTextField)
        Me.Controls.Add(myDOList)

        LoadAssociations()
    End Sub


    Private Sub Upload(ByVal EventCode As Integer, ByVal Value As Object) Handles myTextField.ValueChanged
        LazyNode.AltFormAvail = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

    Private Sub LoadAssociations()
        Dim SQLServerSettings As Hashtable = CType(ConfigurationSettings.GetConfig("sqlServerSettings"), Hashtable)

        Dim myData As DataSet = SQLLazyNode.GetAssociations(CStr(SQLServerSettings.Item("ServerAddress")), _
                                                CStr(SQLServerSettings.Item("Database")), _
                                                CStr(SQLServerSettings.Item("Username")), _
                                                CStr(SQLServerSettings.Item("Password")), _
                                                CInt(LazyNode.ID))

        myDOList.Items.Clear()
        Dim myTable As DataTable = myData.Tables(0)
        For Each row As DataRow In myTable.Rows
            Dim lvi As ListViewItem = New ListViewItem(row.Item("DOName").ToString)
            lvi.SubItems.Add(row.Item("ArchiveID").ToString)
            lvi.SubItems.Add(row.Item("TopographicalQuota").ToString)
            lvi.SubItems.Add(row.Item("DOFileName").ToString)

            Me.myDOList.Items.Add(lvi)
        Next
    End Sub

End Class

