
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region



Imports System.Configuration
Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton

Imports DigitArq.UserControls.CustomUserControls


Public Class VisualFieldArchivistNotes
    Inherits VisualField


#Region "Private Properties"

    Private WithEvents myNoteTitle As VisualTextField
    Private WithEvents myNote As VisualTextField
    'Private myLabel As Label
    Private WithEvents myNoteList As ListView
    Private WithEvents myAddButton As ImageButton.ImageButton
    Private WithEvents myRemoveButton As ImageButton.ImageButton
    Private myProcessInfoName As String

#End Region


#Region "Constants"

    Private Const DefaultTextBoxHeight As Integer = 20
    Private Const DefaultLabelWidth As Integer = 100
    Private Const DefaultTextBoxGap As Integer = 25
    Private Const DefaultSeparatorHeight As Integer = 10

#End Region

    Public Sub New(ByVal LazyNode As LazyNode, ByVal ButtonImages As ImageList, ByVal ProcessInfoName As String, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode
        myProcessInfoName = ProcessInfoName

 
        myNoteTitle = New VisualTextField(VisualFieldLabel("ArchivistNoteTitle"), Width)

        With myNoteTitle
            .Location = New Point(0, 0)
            .Value = ""
            .MaxLength = 190
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With

        myNote = New VisualTextField(VisualFieldLabel("ArchivistNoteNote"), Width - 30, VisualTextField.TextBoxHeightMedium)
        With myNote
            .Location = New Point(0, myNoteTitle.Location.Y + myNoteTitle.Height + 5)
            .Value = ""
            .ReadOnly = False
            .Mandatory = False
            .MaxLength = 490
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With

        Dim chUsername As New ColumnHeader
        chUsername.Text = VisualFieldLabel("ArchivistNameHeader")
        chUsername.Width = VisualTextField.TextBoxWidthExtraSmall - 30

        Dim chDate As New ColumnHeader
        chDate.Text = VisualFieldLabel("DateHeader")
        chDate.Width = VisualTextField.TextBoxWidthExtraSmall - 50

        Dim chNoteTitle As New ColumnHeader
        chNoteTitle.Text = VisualFieldLabel("NoteTitleHeader")
        chNoteTitle.Width = CInt((Width - 235) / 1.7)

        myNoteList = New ListView
        With myNoteList
            .Location = New Point(VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap, myNote.Location.Y + myNote.Height + 5)
            '.Width = VisualTextField.TextBoxWidthExtraLarge - 15
            .Width = Width - 235
            .Alignment = System.Windows.Forms.ListViewAlignment.Default
            .AllowColumnReorder = True
            .AutoArrange = False
            .BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            .Columns.AddRange(New System.Windows.Forms.ColumnHeader() {chNoteTitle, chUsername, chDate})
            .FullRowSelect = True
            .HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
            .LabelWrap = False
            .MultiSelect = False
            .Sorting = System.Windows.Forms.SortOrder.Ascending
            .View = System.Windows.Forms.View.Details

            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right Or AnchorStyles.Left

        End With

        LoadNoteList()


        myAddButton = New ImageButton.ImageButton
        With myAddButton
            .Text = ""
            .ButtonText = ""
            .ButtonImage = ButtonImages.Images(0)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myNoteList.Location.X + myNoteList.Width + 3, myNote.Location.Y)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Enabled = False
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With

        myRemoveButton = New ImageButton.ImageButton
        With myRemoveButton
            .Text = ""
            .ButtonText = ""
            .ButtonImage = ButtonImages.Images(1)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myNoteList.Location.X + myNoteList.Width + 3, myNoteList.Location.Y + 3)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Enabled = False
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With

        'Me.Size = New Size(myAddButton.Location.X + myAddButton.Width, myNoteList.Location.Y + myNoteList.Height)
        Me.Height = myNoteList.Location.Y + myNoteList.Height

        Me.Controls.Add(myNoteTitle)
        Me.Controls.Add(myNote)
        Me.Controls.Add(myAddButton)
        Me.Controls.Add(myRemoveButton)
        Me.Controls.Add(myNoteList)



    End Sub


    ' load archivist notes
    Private Sub LoadNoteList()
        myNoteList.Items.Clear()

        For Each item As ArchivistNotesItem In LazyNode.ArchivistNotes
            Dim lvi As ListViewItem = New ListViewItem(item.NoteTitle)
            lvi.SubItems.Add(item.Username)
            lvi.SubItems.Add(item.NoteDate)
            lvi.Tag = item
            myNoteList.Items.Add(lvi)
        Next

    End Sub



    Private Sub myAddButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myAddButton.Click
        If CStr(myNoteTitle.Value).Trim <> "" Then
            Dim ArchivistNoteItem As New ArchivistNotesItem(CStr(Me.myNoteTitle.Value), CStr(Me.myNote.Value), DateToDB(Now), myProcessInfoName)

            myNoteTitle.Value = ""
            myNote.Value = ""
            myNoteTitle.Focus()

            LazyNode.ArchivistNotes.Add(ArchivistNoteItem)
            LoadNoteList()
            RaiseEventDataChanged(Me, LazyNode.ArchivistNotes)
        End If
    End Sub


    Private Sub myRemoveButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myRemoveButton.Click
        If myNoteList.SelectedIndices.Count > 0 Then
            LazyNode.ArchivistNotes.Remove(CType(myNoteList.SelectedItems.Item(0).Tag, ArchivistNotesItem))
            LoadNoteList()
            RaiseEventDataChanged(Me, LazyNode.ArchivistNotes)

        End If
    End Sub



    Private Sub myListBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles myNoteList.SelectedIndexChanged
        If myNoteList.SelectedIndices.Count > 0 Then
            SelectAndFillNote()
        End If
    End Sub

    Private Sub SelectAndFillNote()
        Dim SQLServerSettings As Hashtable = CType(ConfigurationSettings.GetConfig("sqlServerSettings"), Hashtable)

        Dim ArchivistNote As ArchivistNotesItem = CType(myNoteList.SelectedItems(0).Tag, ArchivistNotesItem)

        Me.myNoteTitle.Value = ArchivistNote.NoteTitle
        Me.myNote.Value = ArchivistNote.Note
        If myProcessInfoName <> ArchivistNote.Username Then
            Me.myRemoveButton.Enabled = False
        Else
            Me.myRemoveButton.Enabled = True
        End If
        Me.myAddButton.Enabled = False
    End Sub

#Region "Events"

    Private Sub myNoteTitle_ValueChanged(ByVal EventCode As Integer, ByVal Value As Object) Handles myNoteTitle.ValueChanged
        Me.myAddButton.Enabled = myNoteTitle.TextBox.TextLength > 0
        Me.myRemoveButton.Enabled = myNoteList.SelectedItems.Count > 0
    End Sub


    Private Sub myNote_ValueChanged(ByVal EventCode As Integer, ByVal Value As Object) Handles myNote.ValueChanged
        Me.myAddButton.Enabled = myNoteTitle.TextBox.TextLength > 0
        Me.myRemoveButton.Enabled = myNoteList.SelectedItems.Count > 0
    End Sub


    Private Sub myNoteList_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles myNoteList.SelectedIndexChanged
        Me.myAddButton.Enabled = myNoteTitle.TextBox.TextLength > 0
        Me.myRemoveButton.Enabled = myNoteList.SelectedItems.Count > 0
    End Sub


#End Region

End Class


