
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldBibliography
    Inherits VisualField


    'Private myLabel As Label
    Private WithEvents myTextBox As VisualTextField
    Private WithEvents myListBox As ListBox
    Private WithEvents myAddButton As ImageButton.ImageButton
    Private WithEvents myRemoveButton As ImageButton.ImageButton


    Public Sub New(ByVal LazyNode As LazyNode, ByVal ButtonImages As ImageList, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode


        'myLabel = New Label
        'With myLabel
        '    .Location = New Point(0, 0)
        '    .Text = VisualFieldLabel("Bibliography")
        '    .AutoSize = True
        '    .Font = DigitarqFonts.StandardFont
        'End With


        myTextBox = New VisualTextField(VisualFieldLabel("Bibliography"), Width - 30)
        With myTextBox
            .Location = New Point(0, 0)
            .Value = ""
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With



        myListBox = New ListBox
        With myListBox
            .Location = New Point(VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap, myTextBox.Location.Y + myTextBox.Height + 5)
            .Width = Width - VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap - 40
            .BorderStyle = BorderStyle.FixedSingle
            .Items.Clear()
            .HorizontalScrollbar = True
            .Font = DigitarqFonts.StandardFont
            .Height = VisualTextField.DefaultTextBoxHeight * 10
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
            .Sorted = True
        End With


        Dim Item As BibRefItem
        For Each Item In LazyNode.Bibliography
            myListBox.Items.Add(Item.BibRef)
        Next

        myAddButton = New ImageButton.ImageButton
        With myAddButton
            .Text = ""
            .ButtonImage = ButtonImages.Images(0)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .ButtonText = ""
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myListBox.Location.X + myListBox.Width + 3, myListBox.Location.Y)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With


        myRemoveButton = New ImageButton.ImageButton
        With myRemoveButton
            .Text = ""
            .ButtonImage = ButtonImages.Images(1)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .ButtonText = ""
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myAddButton.Location.X, myAddButton.Location.Y + myAddButton.Height + 3)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right

        End With



        'New VisualTextField(VisualFieldLabel("BiogHist"), VisualTextField.TextBoxWidthExtraLarge, VisualTextField.TextBoxHeightLarge)

        'Me.Size = New Size(myAddButton.Location.X + myAddButton.Width, myListBox.Location.Y + myListBox.Height)
        Me.Height = myListBox.Location.Y + myListBox.Height

        'Me.Controls.Add(myLabel)
        Me.Controls.Add(myTextBox)
        Me.Controls.Add(myListBox)
        Me.Controls.Add(myAddButton)
        Me.Controls.Add(myRemoveButton)
    End Sub



   
    Private Sub myAddButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myAddButton.Click
        myListBox.Items.Add(myTextBox.Value)
        myTextBox.Value = ""
        myTextBox.Focus()
        Upload()
    End Sub


    Private Sub myRemoveButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myRemoveButton.Click
        If myListBox.SelectedIndex >= 0 Then
            myTextBox.Value = myListBox.SelectedItem
            myListBox.Items.Remove(myListBox.SelectedItem)
            myTextBox.Focus()
            Upload()
        End If
    End Sub



    Private Sub Upload()
        Dim bibliography As New bibliography
        Dim item As String

        For Each item In myListBox.Items
            bibliography.Add(item)
        Next
        LazyNode.Bibliography = bibliography
        RaiseEventDataChanged(Me, bibliography)
    End Sub

End Class

