
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldChronList
    Inherits VisualField


    Private myLabel As Label
    Private WithEvents myDate As VisualTextField
    Private WithEvents myEvent As VisualTextField
    Private WithEvents myListView As ListView
    Private WithEvents myAddButton As ImageButton.ImageButton
    Private WithEvents myRemoveButton As ImageButton.ImageButton

    Public Sub New(ByVal LazyNode As LazyNode, ByVal ButtonImages As ImageList, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode

        myLabel = New Label
        With myLabel
            .Location = New Point(0, 0)
            .Text = VisualFieldLabel("ChronList")
            .AutoSize = True
            .Font = DigitarqFonts.StandardFont
        End With


        myDate = New VisualTextField("", 0, VisualTextField.TextBoxWidthSmall, 1, ValidTextBox.FieldTypes.DefaultField)
        With myDate
            .Location = New Point(VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap, 0)
            .Value = ""
            .Font = DigitarqFonts.StandardFont
        End With


        myEvent = New VisualTextField("", 0, VisualTextField.TextBoxWidthExtraLarge - 15 - myDate.Width - VisualTextField.DefaultLabelTextBoxGap, 1, ValidTextBox.FieldTypes.DefaultField)
        With myEvent
            .Location = New Point(myDate.Location.X + myDate.Width + VisualTextField.DefaultLabelTextBoxGap, 0)
            .Value = ""
        End With



        Dim chDate As New ColumnHeader
        chDate.Text = VisualFieldLabel("DateHeader")
        chDate.Width = VisualTextField.TextBoxWidthSmall + VisualTextField.DefaultLabelTextBoxGap


        Dim chEvent As New ColumnHeader
        chEvent.Text = VisualFieldLabel("EventHeader")
        chEvent.Width = VisualTextField.TextBoxWidthExtraLarge - 15 - myDate.Width - VisualTextField.DefaultLabelTextBoxGap


        myListView = New ListView
        With myListView
            .Location = New Point(VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap, myEvent.Location.Y + myEvent.Height + 5)
            .Width = Width - 15
            .Alignment = System.Windows.Forms.ListViewAlignment.Default
            .AllowColumnReorder = True
            .AutoArrange = False
            .BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            .Columns.AddRange(New System.Windows.Forms.ColumnHeader() {chDate, chEvent})
            .FullRowSelect = True
            .HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
            .LabelWrap = False
            .MultiSelect = False
            .Sorting = System.Windows.Forms.SortOrder.Ascending
            .View = System.Windows.Forms.View.Details
            .Items.Clear()
            .Font = DigitarqFonts.StandardFont
        End With


        Dim Item As ChronListItem
        For Each Item In LazyNode.ChronList
            Dim iDate As New ListViewItem(Item.EventDate)
            Dim iEvent As New ListViewItem.ListViewSubItem(iDate, Item.EventDescription)
            iDate.SubItems.Add(iEvent)

            myListView.Items.Add(iDate)
        Next


        myAddButton = New ImageButton.ImageButton
        With myAddButton
            .Text = ""
            .ButtonText = ""
            .ButtonImage = ButtonImages.Images(0)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myListView.Location.X + myListView.Width + 3, myListView.Location.Y)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With


        myRemoveButton = New ImageButton.ImageButton
        With myRemoveButton
            .Text = ""
            .ButtonText = ""
            .ButtonImage = ButtonImages.Images(1)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myAddButton.Location.X, myAddButton.Location.Y + myAddButton.Height + 3)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With



        'New VisualTextField(VisualFieldLabel("BiogHist"), VisualTextField.TextBoxWidthExtraLarge, VisualTextField.TextBoxHeightLarge)

        'Me.Size = New Size(myAddButton.Location.X + myAddButton.Width, myListView.Location.Y + myListView.Height)
        Me.Height = myListView.Location.Y + myListView.Height

        Me.Controls.Add(myLabel)
        Me.Controls.Add(myDate)
        Me.Controls.Add(myEvent)
        Me.Controls.Add(myListView)
        Me.Controls.Add(myAddButton)
        Me.Controls.Add(myRemoveButton)
    End Sub



    Private Sub myAddButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myAddButton.Click
        If CStr(myDate.Value) = "" Or CStr(myEvent.Value) = "" Then Exit Sub

        Dim iDate As New ListViewItem(CStr(myDate.Value))
        Dim iEvent As New ListViewItem.ListViewSubItem(iDate, CStr(myEvent.Value))
        iDate.SubItems.Add(iEvent)

        myListView.Items.Add(iDate)

        myDate.Value = ""
        myEvent.Value = ""

        myDate.Focus()
        Upload()
    End Sub



    Private Sub myRemoveButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myRemoveButton.Click
        If myListView.SelectedIndices.Count = 1 Then
            Dim iDate As ListViewItem = myListView.SelectedItems(0)
            myDate.Value = iDate.Text
            myEvent.Value = iDate.SubItems(1).Text
            myDate.Focus()
            myListView.Items.Remove(iDate)
            Upload()
        End If
    End Sub



    'Private Sub EnterPressed(ByVal sender As Object, ByVal e As KeyEventArgs) Handles myEvent.KeyDown
    '    MsgBox("ola")
    '    If e.KeyCode = Keys.Enter Then
    '        myRemoveButton_click(sender, Nothing)
    '    End If
    'End Sub

    Private Sub Upload()
        Dim Chronlist As New Chronlist
        Dim iDate As ListViewItem

        For Each iDate In myListView.Items
            Chronlist.Add(iDate.Text, iDate.SubItems(1).Text)
        Next
        LazyNode.ChronList = Chronlist
        RaiseEventDataChanged(Me, Chronlist)
    End Sub

End Class

