
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldContainerExtents
    Inherits VisualField


#Region "Private Properties"

    Private WithEvents myExtentBook As VisualTextField
    Private WithEvents myExtentBox As VisualTextField
    Private WithEvents myExtentMaco As VisualTextField

    Private WithEvents myExtentMacete As VisualTextField
    Private WithEvents myExtentFolder As VisualTextField
    Private WithEvents myExtentCover As VisualTextField

    Private WithEvents myExtentCapilha As VisualTextField
    Private WithEvents myExtentRoll As VisualTextField
    Private WithEvents myExtentAlbum As VisualTextField

    Private WithEvents myExtentEnvelope As VisualTextField
    Private WithEvents myExtentOther As VisualTextField

    Private myExtentBookLabel As VisualLabelField
    Private myExtentBoxLabel As VisualLabelField
    Private myExtentMacoLabel As VisualLabelField

    Private myExtentMaceteLabel As VisualLabelField
    Private myExtentFolderLabel As VisualLabelField
    Private myExtentCoverLabel As VisualLabelField

    Private myExtentCapilhaLabel As VisualLabelField
    Private myExtentRollLabel As VisualLabelField
    Private myExtentAlbumLabel As VisualLabelField

    Private myExtentEnvelopeLabel As VisualLabelField
    Private myExtentOtherLabel As VisualLabelField

#End Region


#Region "Constants"
    Private Const DefaultTextBoxHeight As Integer = 20
    Private Const DefaultLabelWidth As Integer = 100
    Private Const DefaultTextBoxGap As Integer = 25
#End Region

    Public Sub New(ByVal LazyNode As LazyNode, ByVal Width As Integer)
        Me.Width = Width

        Me.LazyNode = LazyNode

        If LazyNode.isLeaf Then LazyNode.AllowExtentsInference = False
        DrawVisualTextBoxes(Not LazyNode.isLeaf AndAlso LazyNode.AllowExtentsInference)

    End Sub




    ' Draws all extent fields with text boxes 
    Private Sub DrawVisualTextBoxes(ByVal [ReadOnly] As Boolean)
        myExtentBook = New VisualTextField(VisualFieldLabel("ExtentBook"), _
                           VisualTextField.DefaultLabelWidth, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        myExtentBox = New VisualTextField(VisualFieldLabel("ExtentBox"), _
                          VisualTextField.DefaultLabelWidth - 55, 50, _
                          ValidTextBox.FieldTypes.IntegerField)

        myExtentMaco = New VisualTextField(VisualFieldLabel("ExtentMaco"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)


        myExtentMacete = New VisualTextField(VisualFieldLabel("ExtentMacete"), _
                            VisualTextField.DefaultLabelWidth, 50, _
                            ValidTextBox.FieldTypes.IntegerField)

        myExtentFolder = New VisualTextField(VisualFieldLabel("ExtentFolder"), _
                             VisualTextField.DefaultLabelWidth - 55, 50, _
                             ValidTextBox.FieldTypes.IntegerField)

        myExtentCover = New VisualTextField(VisualFieldLabel("ExtentCover"), _
                            VisualTextField.DefaultLabelWidth - 55, 50, _
                            ValidTextBox.FieldTypes.IntegerField)


        myExtentCapilha = New VisualTextField(VisualFieldLabel("ExtentCapilha"), _
                              VisualTextField.DefaultLabelWidth, 50, _
                              ValidTextBox.FieldTypes.IntegerField)

        myExtentRoll = New VisualTextField(VisualFieldLabel("ExtentRoll"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        myExtentAlbum = New VisualTextField(VisualFieldLabel("ExtentAlbum"), _
                            VisualTextField.DefaultLabelWidth - 55, 50, _
                            ValidTextBox.FieldTypes.IntegerField)


        myExtentEnvelope = New VisualTextField(VisualFieldLabel("ExtentEnvelope"), _
                           VisualTextField.DefaultLabelWidth, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        myExtentOther = New VisualTextField(VisualFieldLabel("ExtentOther"), _
                    VisualTextField.DefaultLabelWidth - 55, 50, _
                    ValidTextBox.FieldTypes.IntegerField)


        Dim LineLocationY As Integer = 0

        With myExtentBook
            .Location = New Point(0, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentBook)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentBox
            .Location = New Point(myExtentBook.Location.X + myExtentBook.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentBox)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentMaco
            .Location = New Point(myExtentBox.Location.X + myExtentBox.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentMaco)
            .ReadOnly = [ReadOnly]
        End With

        LineLocationY += myExtentMaco.Height + 5

        With myExtentMacete
            .Location = New Point(0, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentMacete)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentFolder
            .Location = New Point(myExtentMacete.Location.X + myExtentMacete.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentFolder)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentCover
            .Location = New Point(myExtentFolder.Location.X + myExtentFolder.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentCover)
            .ReadOnly = [ReadOnly]
        End With

        LineLocationY += myExtentFolder.Height + 5
        With myExtentCapilha
            .Location = New Point(0, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentCapilha)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentRoll
            .Location = New Point(myExtentCapilha.Location.X + myExtentCapilha.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentRoll)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentAlbum
            .Location = New Point(myExtentRoll.Location.X + myExtentRoll.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentAlbum)
            .ReadOnly = [ReadOnly]
        End With


        LineLocationY += myExtentAlbum.Height + 5
        With myExtentEnvelope
            .Location = New Point(0, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentEnvelope)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentOther
            .Location = New Point(myExtentEnvelope.Location.X + myExtentEnvelope.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentOther)
            .ReadOnly = [ReadOnly]
        End With

        'Me.Size = New Size(myExtentAlbum.Location.X + myExtentAlbum.Width + 10, myExtentOther.Location.Y + myExtentOther.Height)
        Me.Height = myExtentOther.Location.Y + myExtentOther.Height

        Me.Controls.Add(myExtentBook)
        Me.Controls.Add(myExtentBox)
        Me.Controls.Add(myExtentMaco)

        Me.Controls.Add(myExtentMacete)
        Me.Controls.Add(myExtentFolder)
        Me.Controls.Add(myExtentCover)

        Me.Controls.Add(myExtentCapilha)
        Me.Controls.Add(myExtentRoll)
        Me.Controls.Add(myExtentAlbum)

        Me.Controls.Add(myExtentEnvelope)
        Me.Controls.Add(myExtentOther)

    End Sub


    Protected Sub UploadExtentBook(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentBook.ValueChanged
        LazyNode.ExtentBook = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentBox(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentBox.ValueChanged
        LazyNode.ExtentBox = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentMaco(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentMaco.ValueChanged
        LazyNode.ExtentMaco = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub


    Protected Sub UploadExtentMacete(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentMacete.ValueChanged
        LazyNode.ExtentMacete = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentFolder(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentFolder.ValueChanged
        LazyNode.ExtentFolder = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentCover(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentCover.ValueChanged
        LazyNode.ExtentCover = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub


    Protected Sub UploadExtentCapilha(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentCapilha.ValueChanged
        LazyNode.ExtentCapilha = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentRoll(ByVal EventCode As Integer, ByVal Value As Object) _
        Handles myExtentRoll.ValueChanged
        LazyNode.ExtentRoll = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentAlbum(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentAlbum.ValueChanged
        LazyNode.ExtentAlbum = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub


    Protected Sub UploadExtentEnvelope(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentEnvelope.ValueChanged
        LazyNode.ExtentEnvelope = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentOther(ByVal EventCode As Integer, ByVal Value As Object) _
            Handles myExtentOther.ValueChanged
        LazyNode.ExtentOther = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

End Class
