
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldContainerType
    Inherits VisualField


    Private myLabel As Label
    Private WithEvents myContainerType As VisualComboBoxImageField
    Private WithEvents myContainerCustomType As VisualTextField



    Public Sub New(ByVal LazyNode As LazyNode, ByVal Icons As ImageList, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode

        myLabel = New Label
        With myLabel
            .Width = VisualTextField.DefaultLabelWidth
            .Text = VisualFieldLabel("ContainerType")
            .Location = New Point(0, 0)
            .ForeColor = VisualField.MandatoryForeColor
            .Font = DigitarqFonts.StandardFont
        End With



        Dim Items(10) As ComboBoxImageItem
        Items(0) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Book"), VisualFieldLabel("ContainerType.Book"), 0)
        Items(1) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Box"), VisualFieldLabel("ContainerType.Box"), 1)
        Items(2) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Maco"), VisualFieldLabel("ContainerType.Maco"), 2)
        Items(3) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Macete"), VisualFieldLabel("ContainerType.Macete"), 3)
        Items(4) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Folder"), VisualFieldLabel("ContainerType.Folder"), 4)
        Items(5) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Cover"), VisualFieldLabel("ContainerType.Cover"), 5)
        Items(6) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Capilha"), VisualFieldLabel("ContainerType.Capilha"), 6)
        Items(7) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Roll"), VisualFieldLabel("ContainerType.Roll"), 7)
        Items(8) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Album"), VisualFieldLabel("ContainerType.Album"), 0)
        Items(9) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Envelope"), VisualFieldLabel("ContainerType.Envelope"), 1)
        Items(10) = New ComboBoxImageItem(VisualFieldLabel("ContainerType.Other"), VisualFieldLabel("ContainerType.Other"), 8)


        myContainerType = New VisualComboBoxImageField(Icons, Items)
        With myContainerType
            .Location = New Point(myLabel.Location.X + myLabel.Width + VisualTextField.DefaultLabelTextBoxGap, 0)
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Top Or AnchorStyles.Left
        End With

        myContainerCustomType = New VisualTextField("", VisualTextField.TextBoxWidthLarge, 1)
        With myContainerCustomType
            .Location = New Point(myContainerType.Width + 5, myContainerType.Location.Y)
            .Value = LazyNode.ContainerCustomType
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right Or AnchorStyles.Left
        End With


        Dim SelectedItem As ComboBoxImageItem
        For Each SelectedItem In Items
            If SelectedItem.Value = LazyNode.ContainerType Then Exit For
        Next
        myContainerType.Value = SelectedItem


        'Me.Size = New Size(myContainerCustomType.Location.X + myContainerCustomType.Width, myContainerCustomType.Height)
        Me.Height = myContainerCustomType.Height
        Me.Controls.Add(myLabel)
        Me.Controls.Add(myContainerType)
        Me.Controls.Add(myContainerCustomType)
    End Sub




    Private Sub SelectedItemChanged(ByVal EventCode As Integer, ByVal Value As Object) Handles myContainerType.ValueChanged
        Dim SelectedItem As ComboBoxImageItem = CType(Value, ComboBoxImageItem)
        If Not SelectedItem Is Nothing Then
            myContainerCustomType.Visible = SelectedItem.Value = VisualFieldLabel("ContainerType.Other")
        Else
            myContainerCustomType.Visible = False
        End If
    End Sub



    Private Sub UploadContainerType(ByVal EventCode As Integer, ByVal Value As Object) Handles myContainerType.ValueChanged
        LazyNode.ContainerType = CType(Value, ComboBoxImageItem).Value
        RaiseEventDataChanged(Me, Value)
    End Sub

    Private Sub UploadContainerCustomType(ByVal EventCode As Integer, ByVal Value As Object) Handles myContainerCustomType.ValueChanged
        LazyNode.ContainerCustomType = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub


End Class

