
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton


Public Class VisualFieldControlAccess
    Inherits VisualField


    Private myLabel As Label
    Private WithEvents myListView As ListView
    Private WithEvents myAddButton As ImageButton.ImageButton
    Private WithEvents myRemoveButton As ImageButton.ImageButton

    Private myFondsID As Integer


    Public Sub New(ByVal LazyNode As LazyNode, ByVal ButtonImages As ImageList, ByVal FondsID As Integer, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode
        myFondsID = FondsID ' used to make list of available items



        myLabel = New Label
        With myLabel
            .Location = New Point(0, 0)
            .Text = VisualFieldLabel("ControlAccess")
            .AutoSize = True
            .Font = DigitarqFonts.StandardFont
        End With


        Dim chID As New ColumnHeader
        chID.Text = VisualFieldLabel("ControlAccessIDHeader")
        chID.Width = 0

        Dim chItem As New ColumnHeader
        chItem.Text = VisualFieldLabel("ControlAccessItemHeader")
        chItem.Width = CInt((Width - VisualTextField.DefaultLabelWidth - VisualTextField.DefaultLabelTextBoxGap - 25) / 2.0)

        Dim chType As New ColumnHeader
        chType.Text = VisualFieldLabel("ControlAccessTypeHeader")
        chType.Width = CInt((Width - VisualTextField.DefaultLabelWidth - VisualTextField.DefaultLabelTextBoxGap - 25) / 2.2)


        myListView = New ListView
        With myListView
            .Location = New Point(VisualTextField.DefaultLabelWidth + VisualTextField.DefaultLabelTextBoxGap, 0)
            '.Width = VisualTextField.TextBoxWidthLarge
            .Width = Width - VisualTextField.DefaultLabelWidth - VisualTextField.DefaultLabelTextBoxGap - 25
            .Alignment = System.Windows.Forms.ListViewAlignment.Default
            .AllowColumnReorder = True
            .AutoArrange = False
            .BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            .Columns.AddRange(New System.Windows.Forms.ColumnHeader() {chID, chItem, chType})
            .FullRowSelect = True
            .HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
            .LabelWrap = False
            .MultiSelect = False
            .Sorting = System.Windows.Forms.SortOrder.Ascending
            .View = System.Windows.Forms.View.Details
            .Items.Clear()
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With


        LoadList()


        myAddButton = New ImageButton.ImageButton
        With myAddButton
            .Text = ""
            .ButtonText = ""
            .ButtonImage = ButtonImages.Images(0)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myListView.Location.X + myListView.Width + 3, myListView.Location.Y)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With


        myRemoveButton = New ImageButton.ImageButton
        With myRemoveButton
            .Text = ""
            .ButtonText = ""
            .ButtonImage = ButtonImages.Images(1)
            .ButtonImageAlignment = ContentAlignment.MiddleCenter
            .BorderColor = System.Drawing.Color.WhiteSmoke
            .BackColor = System.Drawing.Color.WhiteSmoke
            .HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
            .Size = New Size(ButtonImages.ImageSize.Width + 1, ButtonImages.ImageSize.Height + 1)
            .Location = New Point(myAddButton.Location.X, myAddButton.Location.Y + myAddButton.Height + 5)
            '.FlatStyle = FlatStyle.Flat
            .Cursor = Cursors.Hand
            .Anchor = AnchorStyles.Top Or AnchorStyles.Right
        End With



        'New VisualTextField(VisualFieldLabel("BiogHist"), VisualTextField.TextBoxWidthExtraLarge, VisualTextField.TextBoxHeightLarge)

        'Me.Size = New Size(myAddButton.Location.X + myAddButton.Width, myListView.Location.Y + myListView.Height)
        Me.Height = myListView.Location.Y + myListView.Height

        Me.Controls.Add(myLabel)
        Me.Controls.Add(myListView)
        Me.Controls.Add(myAddButton)
        Me.Controls.Add(myRemoveButton)
    End Sub




    Private Sub myAddButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myAddButton.Click
        Dim frmControlAccessAssociation As New ControlAccessItemsComponentForm(myFondsID, LazyNode.ControlAccess)
        If frmControlAccessAssociation.ShowDialog() = DialogResult.OK Then
            LoadList()
        End If
        RaiseEventDataChanged(Me, LazyNode.ControlAccess)

    End Sub

    Private Sub myRemoveButton_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myRemoveButton.Click
        If Me.myListView.SelectedItems.Count = 0 Then Exit Sub
        Dim SelectedItem As ListViewItem

        For Each SelectedItem In myListView.SelectedItems
            Dim ID As Integer = StrToInt(SelectedItem.SubItems(0).Text)
            LazyNode.ControlAccess.Remove(New ControlAccessItem(ID))
        Next
        LoadList()
        RaiseEventDataChanged(Me, LazyNode.ControlAccess)
    End Sub



    Private Sub LoadList()
        Dim Item As ControlAccessItem

        myListView.Items.Clear()
        For Each Item In LazyNode.ControlAccess
            Dim iID As New ListViewItem(CStr(Item.ID))
            Dim iItem As New ListViewItem.ListViewSubItem(iID, Item.Item)
            Dim iType As New ListViewItem.ListViewSubItem(iID, Item.Type)
            iID.SubItems.Add(iItem)
            iID.SubItems.Add(iType)

            myListView.Items.Add(iID)
        Next
    End Sub


End Class

