
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldExtents
    Inherits VisualField


#Region "Private Properties"
    Private WithEvents myExtentMl As VisualTextField
    Private WithEvents myExtentPage As VisualTextField
    Private WithEvents myExtentLeaf As VisualTextField
    Private WithEvents myAllowExtentsInference As VisualCheckField

#End Region

#Region "Events"
    Public Event InferenceButtonClicked()

#End Region

#Region "Constants"
    Private Const DefaultTextBoxHeight As Integer = 20
    Private Const DefaultLabelWidth As Integer = 100
    Private Const DefaultTextBoxGap As Integer = 25
#End Region


#Region "Constructor"

    Public Sub New(ByVal LazyNode As LazyNode, ByVal Width As Integer)
        Me.Size = New Size(Width, 20)
        Me.LazyNode = LazyNode


        If LazyNode.OtherLevel = OTHERLEVEL_SERIES OrElse _
               LazyNode.OtherLevel = OTHERLEVEL_SUBSERIES OrElse _
               LazyNode.OtherLevel = OTHERLEVEL_SUBSUBSERIES Then
            DrawSeries((Not LazyNode.isLeaf) AndAlso LazyNode.AllowExtentsInference)
        ElseIf ((LazyNode.OtherLevel = OTHERLEVEL_INSTALATIONUNIT OrElse _
                LazyNode.OtherLevel = OTHERLEVEL_COMPOSEDDOCUMENT OrElse _
                LazyNode.OtherLevel = OTHERLEVEL_DOCUMENT)) Then
            DrawBellowSeries(Not LazyNode.isLeaf AndAlso LazyNode.AllowExtentsInference)
        Else
            DrawDefaults((Not LazyNode.isLeaf) AndAlso LazyNode.AllowExtentsInference)
        End If


    End Sub

#End Region


#Region "Interfaces"


    Private Sub DrawSeries(ByVal [ReadOnly] As Boolean)

        myAllowExtentsInference = New VisualCheckField( _
                                  VisualFieldLabel("AllowExtentsInference"))

        myExtentMl = New VisualTextField(VisualFieldLabel("ExtentMl"), _
                         VisualTextField.DefaultLabelWidth, 50, _
                         ValidTextBox.FieldTypes.FloatField)

        myExtentPage = New VisualTextField(VisualFieldLabel("ExtentPage"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        myExtentLeaf = New VisualTextField(VisualFieldLabel("ExtentLeaf"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)


        Dim LineLocationY As Integer = 0

        With myAllowExtentsInference
            '.Location = New Point(Me.Width, LineLocationY)
            .Text = VisualFieldLabel("AllowExtentsInference")
            .Value = LazyNode.AllowExtentsInference
        End With

        LineLocationY += myAllowExtentsInference.Height + 10


        With myExtentMl
            .Location = New Point(0, LineLocationY)
            .Value = DblToStr(LazyNode.ExtentMl)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentPage
            .Location = New Point(myExtentMl.Width + myExtentMl.Location.X + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentPage)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentLeaf
            .Location = New Point(myExtentPage.Location.X + myExtentPage.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentLeaf)
            .ReadOnly = [ReadOnly]
        End With


        'Me.Size = New Size(myExtentLeaf.Location.X + myExtentLeaf.Width + 10, myExtentLeaf.Location.Y + myExtentLeaf.Height)
        Me.Height = myExtentLeaf.Location.Y + myExtentLeaf.Height

        'Me.myAllowExtentsInference.Location = New Point(Me.Width - Me.myAllowExtentsInference.Width - 10, 0)
        Me.myAllowExtentsInference.Location = New Point(myExtentLeaf.Left + myExtentLeaf.Width - Me.myAllowExtentsInference.Width, 0)


        Me.Controls.Add(myExtentMl)
        Me.Controls.Add(myExtentPage)
        Me.Controls.Add(myExtentLeaf)

        If (Not LazyNode.isLeaf) Then
            Me.Controls.Add(myAllowExtentsInference)
        End If

    End Sub



    Private Sub DrawDefaults(ByVal [ReadOnly] As Boolean)
        myAllowExtentsInference = New VisualCheckField( _
                                        VisualFieldLabel("AllowExtentsInference"))

        myExtentMl = New VisualTextField(VisualFieldLabel("ExtentMl"), _
                         VisualTextField.DefaultLabelWidth, 50, _
                         ValidTextBox.FieldTypes.FloatField)

        myExtentPage = New VisualTextField(VisualFieldLabel("ExtentPage"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        myExtentLeaf = New VisualTextField(VisualFieldLabel("ExtentLeaf"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        Dim LineLocationY As Integer = 0
        With myAllowExtentsInference
            '.Location = New Point(myExtentLeaf.Left, LineLocationY)
            .Text = VisualFieldLabel("AllowExtentsInference")
            .Value = LazyNode.AllowExtentsInference

        End With

        LineLocationY += myAllowExtentsInference.Height + 10

        With myExtentMl
            .Location = New Point(0, LineLocationY)
            .Value = DblToStr(LazyNode.ExtentMl)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentPage
            .Location = New Point(myExtentMl.Location.X + myExtentMl.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentPage)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentLeaf
            .Location = New Point(myExtentPage.Location.X + myExtentPage.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentLeaf)
            .ReadOnly = [ReadOnly]
        End With

        'Me.Size = New Size(myExtentLeaf.Location.X + myExtentLeaf.Width + 10, myExtentLeaf.Location.Y + myExtentLeaf.Height)
        Me.Height = myExtentLeaf.Location.Y + myExtentLeaf.Height

        Me.myAllowExtentsInference.Location = New Point(myExtentLeaf.Left + myExtentLeaf.Width - Me.myAllowExtentsInference.Width, 0)

        Me.Controls.Add(myExtentMl)
        Me.Controls.Add(myExtentPage)
        Me.Controls.Add(myExtentLeaf)


        If (Not LazyNode.isLeaf) Then
            Me.Controls.Add(myAllowExtentsInference)
        End If

    End Sub





    Sub DrawBellowSeries(ByVal [ReadOnly] As Boolean)
        myAllowExtentsInference = New VisualCheckField( _
                                          VisualFieldLabel("AllowExtentsInference"))


        myExtentPage = New VisualTextField(VisualFieldLabel("ExtentPage"), _
                           VisualTextField.DefaultLabelWidth, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        myExtentLeaf = New VisualTextField(VisualFieldLabel("ExtentLeaf"), _
                           VisualTextField.DefaultLabelWidth - 55, 50, _
                           ValidTextBox.FieldTypes.IntegerField)

        Dim LineLocationY As Integer = 0


        With myExtentPage
            .Location = New Point(0, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentPage)
            .ReadOnly = [ReadOnly]
        End With

        With myExtentLeaf
            .Location = New Point(myExtentPage.Location.X + myExtentPage.Width + DefaultTextBoxGap, LineLocationY)
            .Value = IntToStr(LazyNode.ExtentLeaf)
            .ReadOnly = [ReadOnly]
        End With

        With myAllowExtentsInference
            .Location = New Point(myExtentLeaf.Location.X + myExtentLeaf.Width + DefaultTextBoxGap, LineLocationY)
            .Text = VisualFieldLabel("AllowExtentsInference")
            .Value = LazyNode.AllowExtentsInference
        End With

        Me.Size = New Size(myAllowExtentsInference.Location.X + myAllowExtentsInference.Width + 10, myExtentLeaf.Location.Y + myExtentLeaf.Height)

        Me.Controls.Add(myExtentPage)
        Me.Controls.Add(myExtentLeaf)

        If (Not LazyNode.isLeaf) Then
            Me.Controls.Add(myAllowExtentsInference)
        End If

    End Sub

#End Region


#Region "Events"


    Protected Sub UploadExtentMl(ByVal EventCode As Integer, ByVal Value As Object) Handles myExtentMl.ValueChanged
        LazyNode.ExtentMl = StrToDbl(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentPage(ByVal EventCode As Integer, ByVal Value As Object) Handles myExtentPage.ValueChanged
        LazyNode.ExtentPage = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadExtentLeaf(ByVal EventCode As Integer, ByVal Value As Object) Handles myExtentLeaf.ValueChanged
        LazyNode.ExtentLeaf = StrToInt(CStr(Value))
        RaiseEventDataChanged(Me, Value)
    End Sub


    Protected Sub UploadAllowExtentsInference(ByVal EventCode As Integer, ByVal Value As Object) Handles myAllowExtentsInference.ValueChanged
        LazyNode.AllowExtentsInference = CBool(Value)
        RaiseEventDataChanged(Me, LazyNode.AllowExtentsInference)
        RaiseEvent InferenceButtonClicked()
    End Sub


    Protected Sub UploadAllowUnitDatesInference(ByVal EventCode As Integer, ByVal Value As Object) Handles myAllowExtentsInference.ValueChanged
        LazyNode.AllowExtentsInference = CBool(Value)
        RaiseEvent InferenceButtonClicked()
        RaiseEventDataChanged(Me, LazyNode.AllowExtentsInference)
    End Sub

#End Region


End Class


