
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports System.Configuration

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton



Public Class VisualFieldFooterButtons
    Inherits VisualField

    Public Event NewNode()
    Public Event ReplicateNode()
    Public Event SaveNode()

    Private WithEvents myReplicateButton As Button
    Private WithEvents myNewButton As Button
    Public WithEvents mySaveButton As Button

    Private Edited As Boolean = False

    Public Sub New(ByVal LazyNode As LazyNode, ByVal ImageList As ImageList)
        Me.LazyNode = LazyNode

        myNewButton = New Button
        myReplicateButton = New Button
        mySaveButton = New Button

        With myNewButton
            .Location = New Point(0, 0)
            .Text = VisualFieldLabel("NewButton")
            .TextAlign = ContentAlignment.MiddleRight
            .ImageList = ImageList
            .ImageIndex = 0
            .ImageAlign = ContentAlignment.MiddleLeft
            .FlatStyle = FlatStyle.Flat
            .Visible = LazyNode.OtherLevel <> EAD.OTHERLEVEL_FONDS
        End With

        With myReplicateButton
            .Location = New Point(myNewButton.Location.X + myNewButton.Width + 5, 0)
            .Text = VisualFieldLabel("NewButton")
            .TextAlign = ContentAlignment.MiddleRight
            .ImageList = ImageList
            .ImageIndex = 1
            .ImageAlign = ContentAlignment.MiddleLeft
            .Text = VisualFieldLabel("ReplicateButton")
            .FlatStyle = FlatStyle.Flat
            .Visible = LazyNode.OtherLevel <> EAD.OTHERLEVEL_FONDS
        End With

        With mySaveButton
            .Text = VisualFieldLabel("NewButton")
            .TextAlign = ContentAlignment.MiddleRight
            .ImageList = ImageList
            .ImageIndex = 2
            .ImageAlign = ContentAlignment.MiddleLeft
            .Text = VisualFieldLabel("SaveButton")
            .FlatStyle = FlatStyle.Flat
            .Location = New Point(800 - .Size.Width - 25, 0)
        End With


        Me.Size = New Size(mySaveButton.Location.X + mySaveButton.Width, mySaveButton.Height)
        Me.Controls.Add(myNewButton)
        Me.Controls.Add(myReplicateButton)
        Me.Controls.Add(mySaveButton)
    End Sub


    Private Sub NewButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles myNewButton.Click
        RaiseEvent NewNode()
    End Sub


    Private Sub ReplicateButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles myReplicateButton.Click
        RaiseEvent ReplicateNode()
    End Sub

    Private Sub SaveButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mySaveButton.Click
        RaiseEvent SaveNode()
    End Sub


    Public Sub EnableSaveButton(ByVal Enabled As Boolean)
        mySaveButton.Enabled = Enabled
        If Enabled Then
            Me.mySaveButton.BackColor = Color.FromArgb(255, 230, 255, 230)
            Me.mySaveButton.ForeColor = Color.Black
        Else
            Me.mySaveButton.BackColor = Color.FromArgb(255, 245, 220, 220)
            Me.mySaveButton.ForeColor = Color.Black
        End If
    End Sub


    Public Sub EnableReplicateButton(ByVal Enabled As Boolean)
        myReplicateButton.Enabled = Enabled
        If Enabled Then
            Me.myReplicateButton.BackColor = Color.FromArgb(255, 230, 255, 230)
            Me.myReplicateButton.ForeColor = Color.Black
        Else
            Me.myReplicateButton.BackColor = Color.FromArgb(255, 245, 220, 220)
            Me.myReplicateButton.ForeColor = Color.Black
        End If
    End Sub




End Class

