
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldOtherLevel
    Inherits VisualField


#Region "Private Properties"

    Private myLabel As Label
    Private WithEvents myOtherLevel As VisualComboBoxImageField

#End Region


    Public Sub New(ByVal LazyNode As LazyNode, _
                   ByVal OtherLevelIcons As ImageList, _
                   ByVal TopOtherLevelIndex As Integer, _
                   ByVal BottomOtherLevelIndex As Integer, _
                   ByVal Width As Integer)
        Me.Size = New Size(Width, 20)
        Me.LazyNode = LazyNode

        myLabel = New Label
        With myLabel
            .Width = VisualTextField.DefaultLabelWidth
            .Text = VisualFieldLabel("OtherLevel")
            .Location = New Point(0, 0)
            .ForeColor = VisualField.MandatoryForeColor
            .Font = DigitarqFonts.StandardFont
        End With


        ' Create items to pass to the combo box
        'Debug.WriteLine(BottonOtherLevelIndex & "-" & TopOtherLevelIndex)


        ' if level is somehow invalid show all possible levels so that the user can fix the problem
        If (BottomOtherLevelIndex - TopOtherLevelIndex) < 0 Then
            Dim Items(GetOtherLevelIndex("D") - GetOtherLevelIndex("SF")) As ComboBoxImageItem
            Dim i As Integer
            Dim index As Integer = 0
            Dim SelectItem As ComboBoxImageItem
            For i = GetOtherLevelIndex("SF") To GetOtherLevelIndex("D")
                Dim OtherLevel As String = OtherLevelIndexToOtherLevel(i)
                Items(index) = New ComboBoxImageItem(VisualFieldLabel(OtherLevel), OtherLevel, i)
                If OtherLevel = LazyNode.OtherLevel Then SelectItem = Items(index)
                index += 1
            Next
            myOtherLevel = New VisualComboBoxImageField(OtherLevelIcons, Items)

            With myOtherLevel
                .Location = New Point(myLabel.Location.X + myLabel.Width + VisualTextField.DefaultLabelTextBoxGap, 0)
                .Value = SelectItem
            End With
        Else
            ' calculate only the valid levels 
            Dim Items(BottomOtherLevelIndex - TopOtherLevelIndex) As ComboBoxImageItem
            Dim i As Integer
            Dim index As Integer = 0
            Dim SelectItem As ComboBoxImageItem
            For i = TopOtherLevelIndex To BottomOtherLevelIndex
                Dim OtherLevel As String = OtherLevelIndexToOtherLevel(i)
                Items(index) = New ComboBoxImageItem(VisualFieldLabel(OtherLevel), OtherLevel, i)
                If OtherLevel = LazyNode.OtherLevel Then SelectItem = Items(index)
                index += 1
            Next
            myOtherLevel = New VisualComboBoxImageField(OtherLevelIcons, Items)

            With myOtherLevel
                .Location = New Point(myLabel.Location.X + myLabel.Width + VisualTextField.DefaultLabelTextBoxGap, 0)
                .Value = SelectItem
            End With

        End If

        Me.Height = myOtherLevel.Height + 5
        Me.Controls.Add(myLabel)
        Me.Controls.Add(myOtherLevel)
    End Sub





    Public Sub Upload(ByVal EventCode As Integer, ByVal Value As Object) Handles myOtherLevel.ValueChanged
        LazyNode.OtherLevel = CType(Value, ComboBoxImageItem).Value
        RaiseEventDataChanged(Me, Value)
    End Sub



End Class



