
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton



Public Class VisualFieldPhysTech
    Inherits VisualField

    Private WithEvents myTextField As VisualTextField
    Private WithEvents myContextButton As Button

    Private WithEvents myContextMenu As ContextMenu
    Private WithEvents myContextNenuItemGood As MenuItem
    Private WithEvents myContextNenuItemOk As MenuItem
    Private WithEvents myContextNenuItemBad As MenuItem

    Public Sub New(ByVal LazyNode As LazyNode, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode
        CreateContextMenu()

        myTextField = New VisualTextField(VisualFieldLabel("PhysTech"), Width - 25, VisualTextField.TextBoxHeightMediumSmall)
        myTextField.Value = LazyNode.PhysTech
        myTextField.Anchor = AnchorStyles.Left Or AnchorStyles.Top Or AnchorStyles.Right

        myContextButton = New Button
        With myContextButton
            .Text = "<"
            .Location = New Point(myTextField.Location.X + myTextField.Width + 5, myTextField.Location.Y)
            .Height = 20
            .Width = 20
            .FlatStyle = FlatStyle.Flat
            .Anchor = AnchorStyles.Right
        End With

        'Me.Size = New Size(myContextButton.Location.X + myContextButton.Width, myTextField.Height)
        Me.Height = myTextField.Height

        Me.Controls.Add(myTextField)
        Me.Controls.Add(myContextButton)
    End Sub



    'Private Sub ShowContextMenu(ByVal sender As Object, ByVal e As MouseEventArgs) Handles myTextField.ShowContextBox
    '    myContextMenu.Show(Me, New Point(e.X, e.Y))
    'End Sub

    Private Sub myContextButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles myContextButton.Click
        myContextMenu.Show(Me, myContextButton.Location)
    End Sub

    Private Sub CreateContextMenu()
        myContextMenu = New ContextMenu
        myContextNenuItemGood = New MenuItem(ContextMenuLabel("menuItemPhystechGood"))
        myContextNenuItemOk = New MenuItem(ContextMenuLabel("menuItemPhystechOk"))
        myContextNenuItemBad = New MenuItem(ContextMenuLabel("menuItemPhystechBad"))

        myContextMenu.MenuItems.Add(myContextNenuItemGood)
        myContextMenu.MenuItems.Add(myContextNenuItemOk)
        myContextMenu.MenuItems.Add(myContextNenuItemBad)
    End Sub



    Private Sub InsertAutoText(ByVal sender As Object, ByVal e As System.EventArgs) Handles myContextNenuItemGood.Click, myContextNenuItemOk.Click, myContextNenuItemBad.Click
        myTextField.TextBox.Focus()
        SendKeys.SendWait(CType(sender, MenuItem).Text)

        'myTextField.Value = CType(sender, MenuItem).Text
        RaiseEventDataChanged(Me, myTextField.Value)
    End Sub




    Private Sub Upload(ByVal EventCode As Integer, ByVal Value As Object) Handles myTextField.ValueChanged
        LazyNode.PhysTech = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

End Class

