
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton

Imports DigitArq.UserControls.CustomUserControls

Public Class VisualFieldProcessInfo
    Inherits VisualField


#Region "Private Properties"
    Private WithEvents myName As VisualTextField
    Private WithEvents myDate As VisualDateField
    Private WithEvents myProcessInfo As VisualTextField
    Private WithEvents myDescRules As VisualTextField

#End Region


#Region "Constants"
    Private Const DefaultTextBoxHeight As Integer = 20
    Private Const DefaultLabelWidth As Integer = 100
    Private Const DefaultTextBoxGap As Integer = 25
    Private Const DefaultSeparatorHeight As Integer = 10
#End Region


    Public Sub New(ByVal LazyNode As LazyNode, ByVal Width As Integer)
        Me.Width = Width
        Me.LazyNode = LazyNode

        myDate = New VisualDateField
        myName = New VisualTextField(VisualFieldLabel("ProcessInfoName"), Width - myDate.Width - DefaultTextBoxGap)
        myProcessInfo = New VisualTextField(VisualFieldLabel("ProcessInfo"), Width, VisualTextField.TextBoxHeightMedium)
        myDescRules = New VisualTextField(VisualFieldLabel("DescRules"), Width, VisualTextField.TextBoxHeightMedium)


        With myName
            .Location = New Point(0, 0)
            .Value = CStr(LazyNode.ProcessInfoName)
            .ReadOnly = True
            .Mandatory = True
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With

        With myDate
            .Location = New Point(myName.Location.X + myName.Width + DefaultTextBoxGap, 0)
            .Value = CStr(LazyNode.ProcessInfoDate)
            .ReadOnly = True
            .Anchor = AnchorStyles.Right Or AnchorStyles.Top
        End With

        With myProcessInfo
            .Location = New Point(myName.Location.X, myName.Location.Y + myName.Height + DefaultSeparatorHeight)
            .Value = CStr(LazyNode.ProcessInfo)
            .ReadOnly = False
            .Mandatory = False
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With

        With myDescRules
            .Location = New Point(myName.Location.X, myProcessInfo.Location.Y + myProcessInfo.Height + DefaultSeparatorHeight)
            .Value = CStr(LazyNode.DescRules)
            .ReadOnly = False
            .Mandatory = False
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With

        Me.Height = myName.Height + myProcessInfo.Height + myDescRules.Height + 2 * DefaultSeparatorHeight

        Me.Controls.Add(myName)
        Me.Controls.Add(myDate)
        Me.Controls.Add(myProcessInfo)
        Me.Controls.Add(myDescRules)
    End Sub


    Protected Sub UploadName(ByVal EventCode As Integer, ByVal Value As Object) Handles myName.ValueChanged
        LazyNode.ProcessInfoName = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadDate(ByVal EventCode As Integer, ByVal Value As Object) Handles myDate.ValueChanged
        LazyNode.ProcessInfoDate = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadProcessInfo(ByVal EventCode As Integer, ByVal Value As Object) Handles myProcessInfo.ValueChanged
        LazyNode.ProcessInfo = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadDescRules(ByVal EventCode As Integer, ByVal Value As Object) Handles myDescRules.ValueChanged
        LazyNode.DescRules = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub


End Class


