
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton


Public Class VisualFieldUnitDates
    Inherits VisualField


#Region "Private Properties"

    Private myLabel As Label
    Private WithEvents myUnitDateInitial As VisualDateField
    Private WithEvents myUnitDateInitialCertainty As VisualCheckField
    Private WithEvents myUnitDateFinal As VisualDateField
    Private WithEvents myUnitDateFinalCertainty As VisualCheckField
    Private WithEvents myUnitDateBulk As VisualTextField
    Private WithEvents myAllowUnitDatesInference As VisualCheckField
    Private WithEvents myUnitDateNotes As VisualTextField

    Const CenterTop As Integer = 3
    Dim EventRaised As Boolean = False

#End Region

#Region "Events"
    Public Event InferenceButtonClicked()
#End Region


    Public Sub New(ByVal LazyNode As LazyNode, ByVal Width As Integer)
        Me.Size = New Size(Width, 10)

        Me.LazyNode = LazyNode

        myLabel = New Label

        With myLabel
            .Text = VisualFieldLabel("UnitDates")
            .Location = New Point(0, 0)
            .ForeColor = VisualField.MandatoryForeColor
            .Font = DigitarqFonts.StandardFont
            .Width = VisualTextField.DefaultLabelWidth
        End With
        Me.Controls.Add(myLabel)

        Dim AllowDatesChange As Boolean = LazyNode.isLeaf Or Not LazyNode.AllowUnitDatesInference

        DrawDates(Not AllowDatesChange)

        myUnitDateBulk = New VisualTextField(VisualFieldLabel("UnitDateBulk"), Width)
        With myUnitDateBulk
            .Location = New Point(0, myLabel.Location.Y + myLabel.Height + 10)
            .Value = LazyNode.UnitDateBulk
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With

        myUnitDateNotes = New VisualTextField(VisualFieldLabel("UnitDateNotes"), Width)
        With myUnitDateNotes
            .Location = New Point(0, myUnitDateBulk.Location.Y + myUnitDateBulk.Height + 5)
            .Value = LazyNode.UnitDateNotes
            .Font = DigitarqFonts.StandardFont
            .Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        End With


        Me.Controls.Add(myUnitDateBulk)
        Me.Controls.Add(myUnitDateNotes)
        'Me.BackColor = Color.Purple

        Me.Height = myUnitDateNotes.Location.Y + myUnitDateNotes.Height


        'Me.Dock = DockStyle.Fill
        'Me.Anchor = AnchorStyles.Right Or AnchorStyles.Left Or AnchorStyles.Top
    End Sub


    Private Sub DrawDates(ByVal [ReadOnly] As Boolean)
        myUnitDateInitial = New VisualDateField
        myUnitDateFinal = New VisualDateField
        myUnitDateInitialCertainty = New VisualCheckField(VisualFieldLabel("ca"))
        myUnitDateFinalCertainty = New VisualCheckField(VisualFieldLabel("ca"))
        myAllowUnitDatesInference = New VisualCheckField(VisualFieldLabel("AllowUnitDatesInference"))



        With myUnitDateInitialCertainty
            .Location = New Point(myLabel.Location.X + myLabel.Width + VisualTextField.DefaultLabelTextBoxGap, CenterTop)
            .Value = Not LazyNode.UnitDateInitialCertainty
            '.Enabled = EnableControls
            .Font = DigitarqFonts.StandardFont
        End With

        With myUnitDateInitial
            .Location = New Point(myUnitDateInitialCertainty.Location.X + myUnitDateInitialCertainty.Width + VisualTextField.DefaultLabelTextBoxGap, 0)
            .Value = LazyNode.UnitDateInitial

            .Font = DigitarqFonts.StandardFont
            .ReadOnly = [ReadOnly]
        End With

        Dim mySeparator As New Label

        With mySeparator
            .Text = VisualFieldLabel("to")
            .AutoSize = True
            .Location = New Point(myUnitDateInitial.Location.X + myUnitDateInitial.Width + VisualTextField.DefaultLabelTextBoxGap, CenterTop)
            .Font = DigitarqFonts.StandardFont
        End With


        With myUnitDateFinalCertainty
            .Text = VisualFieldLabel("ca")
            .Location = New Point(mySeparator.Location.X + mySeparator.Width + VisualTextField.DefaultLabelTextBoxGap, CenterTop)
            .Value = Not LazyNode.UnitDateFinalCertainty
            '.Enabled = EnableControls
            .Font = DigitarqFonts.StandardFont
        End With

        With myUnitDateFinal
            .Location = New Point(myUnitDateFinalCertainty.Location.X + myUnitDateFinalCertainty.Width + VisualTextField.DefaultLabelTextBoxGap, 0)
            .Value = LazyNode.UnitDateFinal
            .Font = DigitarqFonts.StandardFont
            .ReadOnly = [ReadOnly]
        End With

        With myAllowUnitDatesInference
            .Text = VisualFieldLabel("AllowUnitDatesInference")
            .Location = New Point(myUnitDateFinal.Location.X + myUnitDateFinal.Width + VisualTextField.DefaultLabelTextBoxGap, CenterTop)
            .Value = LazyNode.AllowUnitDatesInference
            .Font = DigitarqFonts.StandardFont
        End With

        Me.Controls.Add(myLabel)
        Me.Controls.Add(myUnitDateInitialCertainty)
        Me.Controls.Add(myUnitDateInitial)
        Me.Controls.Add(mySeparator)
        Me.Controls.Add(myUnitDateFinalCertainty)
        Me.Controls.Add(myUnitDateFinal)

        If (Not LazyNode.isLeaf) Then
            Me.Controls.Add(myAllowUnitDatesInference)
        End If

    End Sub



    Private Function FormatExtremeDates(ByVal LazyNode As LazyNode) As String
        Dim ret As String = ""
        Dim ValidInitialDate As Boolean = False
        Dim ValidFinalDate As Boolean = False

        If IsValidDate(LazyNode.UnitDateInitial) Then
            If Not LazyNode.UnitDateInitialCertainty Then ret &= VisualFieldLabel("ca")
            ret &= LazyNode.UnitDateInitial
            ValidInitialDate = True
        End If

        If IsValidDate(LazyNode.UnitDateFinal) Then
            If ValidInitialDate Then ret &= " " & VisualFieldLabel("to") & " "
            If Not LazyNode.UnitDateFinalCertainty Then ret &= VisualFieldLabel("ca")
            ret &= LazyNode.UnitDateFinal
            ValidFinalDate = True
        End If

        If (ValidFinalDate Or ValidInitialDate) Then
            Return ret
        Else
            Return VisualFieldLabel("UndefinedExtremeDates")
        End If
    End Function


    ' handle events
    Protected Sub UploadUnitDateInitial(ByVal EventCode As Integer, ByVal Value As Object) Handles myUnitDateInitial.ValueChanged
        LazyNode.UnitDateInitial = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadUnitDateFinal(ByVal EventCode As Integer, ByVal Value As Object) Handles myUnitDateFinal.ValueChanged
        LazyNode.UnitDateFinal = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub


    Protected Sub UploadUnitDateInitialCertainty(ByVal EventCode As Integer, ByVal Value As Object) Handles myUnitDateInitialCertainty.ValueChanged
        LazyNode.UnitDateInitialCertainty = Not CBool(Value)
        RaiseEventDataChanged(Me, LazyNode.UnitDateInitialCertainty)
    End Sub

    Protected Sub UploadUnitDateFinalCertainty(ByVal EventCode As Integer, ByVal Value As Object) Handles myUnitDateFinalCertainty.ValueChanged
        LazyNode.UnitDateFinalCertainty = Not CBool(Value)
        RaiseEventDataChanged(Me, LazyNode.UnitDateFinalCertainty)
    End Sub

    Protected Sub UploadUnitDateBulk(ByVal EventCode As Integer, ByVal Value As Object) Handles myUnitDateBulk.ValueChanged
        LazyNode.UnitDateBulk = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub

    Protected Sub UploadUnitDateNotes(ByVal EventCode As Integer, ByVal Value As Object) Handles myUnitDateNotes.ValueChanged
        LazyNode.UnitDateNotes = CStr(Value)
        RaiseEventDataChanged(Me, Value)
    End Sub



    Protected Sub UploadAllowUnitDatesInference(ByVal EventCode As Integer, ByVal Value As Object) Handles myAllowUnitDatesInference.ValueChanged
        LazyNode.AllowUnitDatesInference = CBool(Value)
        RaiseEvent InferenceButtonClicked()
        RaiseEventDataChanged(Me, LazyNode.AllowUnitDatesInference)
    End Sub

End Class


