
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls.CustomUserControls


Public Class VisualFieldUnitId
    Inherits VisualField

    Private WithEvents myCompleteUnitID As VisualTextField
    Private WithEvents myUnitID As ValidTextBox


    Public Sub New(ByVal LazyNode As LazyNode, Optional ByVal ContainerWidth As Integer = VisualTextField.TextBoxWidthMedium)
        Me.LazyNode = LazyNode

        If LazyNode.CompleteUnitId() Is Nothing Then LazyNode.CompleteUnitId = ""
        If LazyNode.UnitId() Is Nothing Then LazyNode.UnitId = ""
        Dim PartialCompleteUnitID As String = LazyNode.CompleteUnitId.Substring(0, Math.Max(0, Math.Max(LazyNode.CompleteUnitId.Length, 0) - Math.Max(0, LazyNode.UnitId.Length)))

        myCompleteUnitID = New VisualTextField(VisualFieldLabel("UnitID"), VisualTextField.TextBoxWidthSmall)

        With myCompleteUnitID
            .Mandatory = True
            .ReadOnly = True
            .Value = PartialCompleteUnitID

            Dim DynamicTextBoxWidth As Integer = MyBase.StringWidth(.TextBox.CreateGraphics, .TextBox.Font, PartialCompleteUnitID)
            If DynamicTextBoxWidth > VisualTextField.TextBoxWidthMediumLarge Then DynamicTextBoxWidth = VisualTextField.TextBoxWidthMediumLarge

            '.TextBox.Width = DynamicTextBoxWidth


            '.Width = .TextBox.Location.X + .TextBox.Width
            .Width = .TextBox.Location.X + DynamicTextBoxWidth
            .TextBox.SelectionStart = .TextBox.TextLength

        End With


        myUnitID = New ValidTextBox
        With myUnitID
            .Width = VisualTextField.TextBoxWidthExtraSmall + 7
            .Text = LazyNode.UnitId
            .Location = New Point(myCompleteUnitID.Location.X + myCompleteUnitID.Width + 1, myCompleteUnitID.Location.Y)
            .BorderStyle = BorderStyle.FixedSingle
            .FieldType = ValidTextBox.FieldTypes.ReferenceField
            .Font = DigitarqFonts.StandardFont
            .CharacterCasing = CharacterCasing.Upper
            .MaxLength = 12
        End With

        ' this is a hack. The event is raised when the value is written in the textbox
        LazyNode.MustUpdateCompleteUnitId = False

        Me.Size = New Size(myUnitID.Left + myUnitID.Width + 17, myCompleteUnitID.Location.Y + myCompleteUnitID.Height)
        Me.Controls.Add(myCompleteUnitID)
        Me.Controls.Add(myUnitID)

        myCompleteUnitID.Anchor = AnchorStyles.Left Or AnchorStyles.Top
        myUnitID.Anchor = AnchorStyles.Left Or AnchorStyles.Top
    End Sub


    Protected Sub StateChanged(ByVal sender As Object, ByVal e As EventArgs) Handles myUnitID.TextChanged 'Its better than Leave
        Upload(0, myUnitID.Text)
    End Sub


    Protected Sub Upload(ByVal EventCode As Integer, ByVal Value As Object)
        LazyNode.UnitId = CStr(Value)
        RaiseEventDataChanged(Me, Value)
        LazyNode.MustUpdateCompleteUnitId = True
    End Sub

    Private Sub VisualFieldUnitId_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles myUnitID.GotFocus
        myUnitID.Select(myUnitID.Text.Length, 0)
    End Sub

End Class



