Imports DigitArq.Utility.Config
Imports DigitArq.Data.Entities.MDA
Imports DigitArq.Definitions.MDA
Imports DigitArq.Definitions.EAD
Imports System.Configuration
Imports System.Collections.Specialized

Public Class EADEditor
    Inherits System.Windows.Forms.UserControl

    Public Event DataChanged(ByVal sender As System.Object, ByVal Data As LazyNode)
    Public Event NewButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event ReplicateButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event SaveButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event PrintButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs)

    Private myLazyNode As LazyNode = Nothing
    Private myApplicationType As ApplicationType = ApplicationType.Standalone
    Private myViewMode As ViewMode = ViewMode.All
    Private myUsername As String = "admin"

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TabControl As System.Windows.Forms.TabControl
    Friend WithEvents tpIndentityArea As System.Windows.Forms.TabPage
    Friend WithEvents tpContextArea As System.Windows.Forms.TabPage
    Friend WithEvents tpContentStructureArea As System.Windows.Forms.TabPage
    Friend WithEvents tpConditionsAccessUseArea As System.Windows.Forms.TabPage
    Friend WithEvents tpAlliedMaterialArea As System.Windows.Forms.TabPage
    Friend WithEvents tpNoteArea As System.Windows.Forms.TabPage
    Friend WithEvents tpAllArea As System.Windows.Forms.TabPage
    Friend WithEvents FooterButtonsGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents OtherLevelIcons As System.Windows.Forms.ImageList
    Friend WithEvents GenreFormIcons As System.Windows.Forms.ImageList
    Friend WithEvents UpDownArrowButtons As System.Windows.Forms.ImageList
    Friend WithEvents AltFormAvailIcons As System.Windows.Forms.ImageList
    Friend WithEvents ContainerTypeIcons As System.Windows.Forms.ImageList
    Friend WithEvents OtherFindAidIcons As System.Windows.Forms.ImageList
    Friend WithEvents FooterButtonIcons As System.Windows.Forms.ImageList
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents btnReplicate As System.Windows.Forms.Button
    Friend WithEvents btnNew As System.Windows.Forms.Button
    Friend WithEvents btnPrint As System.Windows.Forms.Button
    Friend WithEvents tpDescriptionControlArea As System.Windows.Forms.TabPage
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(EADEditor))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.FooterButtonsGroupBox = New System.Windows.Forms.GroupBox
        Me.btnPrint = New System.Windows.Forms.Button
        Me.btnSave = New System.Windows.Forms.Button
        Me.FooterButtonIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.btnReplicate = New System.Windows.Forms.Button
        Me.btnNew = New System.Windows.Forms.Button
        Me.TabControl = New System.Windows.Forms.TabControl
        Me.tpIndentityArea = New System.Windows.Forms.TabPage
        Me.tpDescriptionControlArea = New System.Windows.Forms.TabPage
        Me.tpContextArea = New System.Windows.Forms.TabPage
        Me.tpContentStructureArea = New System.Windows.Forms.TabPage
        Me.tpConditionsAccessUseArea = New System.Windows.Forms.TabPage
        Me.tpAlliedMaterialArea = New System.Windows.Forms.TabPage
        Me.tpNoteArea = New System.Windows.Forms.TabPage
        Me.tpAllArea = New System.Windows.Forms.TabPage
        Me.OtherLevelIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.GenreFormIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.UpDownArrowButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.AltFormAvailIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.ContainerTypeIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.OtherFindAidIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.FooterButtonsGroupBox.SuspendLayout()
        Me.TabControl.SuspendLayout()
        Me.SuspendLayout()
        '
        'FooterButtonsGroupBox
        '
        Me.FooterButtonsGroupBox.BackColor = System.Drawing.Color.White
        Me.FooterButtonsGroupBox.Controls.Add(Me.btnPrint)
        Me.FooterButtonsGroupBox.Controls.Add(Me.btnSave)
        Me.FooterButtonsGroupBox.Controls.Add(Me.btnReplicate)
        Me.FooterButtonsGroupBox.Controls.Add(Me.btnNew)
        Me.FooterButtonsGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterButtonsGroupBox.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.FooterButtonsGroupBox.Location = New System.Drawing.Point(0, 392)
        Me.FooterButtonsGroupBox.Name = "FooterButtonsGroupBox"
        Me.FooterButtonsGroupBox.Size = New System.Drawing.Size(656, 48)
        Me.FooterButtonsGroupBox.TabIndex = 0
        Me.FooterButtonsGroupBox.TabStop = False
        '
        'btnPrint
        '
        Me.btnPrint.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnPrint.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnPrint.Image = CType(resources.GetObject("btnPrint.Image"), System.Drawing.Image)
        Me.btnPrint.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnPrint.Location = New System.Drawing.Point(480, 15)
        Me.btnPrint.Name = "btnPrint"
        Me.btnPrint.TabIndex = 3
        Me.btnPrint.Text = "Imprimir"
        Me.btnPrint.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnSave
        '
        Me.btnSave.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSave.ImageIndex = 2
        Me.btnSave.ImageList = Me.FooterButtonIcons
        Me.btnSave.Location = New System.Drawing.Point(560, 15)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.TabIndex = 2
        Me.btnSave.Text = "Gravar"
        Me.btnSave.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'FooterButtonIcons
        '
        Me.FooterButtonIcons.ImageSize = New System.Drawing.Size(18, 18)
        Me.FooterButtonIcons.ImageStream = CType(resources.GetObject("FooterButtonIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.FooterButtonIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnReplicate
        '
        Me.btnReplicate.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnReplicate.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnReplicate.ImageIndex = 1
        Me.btnReplicate.ImageList = Me.FooterButtonIcons
        Me.btnReplicate.Location = New System.Drawing.Point(96, 15)
        Me.btnReplicate.Name = "btnReplicate"
        Me.btnReplicate.TabIndex = 1
        Me.btnReplicate.Text = "Replicar"
        Me.btnReplicate.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnNew
        '
        Me.btnNew.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnNew.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnNew.ImageIndex = 0
        Me.btnNew.ImageList = Me.FooterButtonIcons
        Me.btnNew.Location = New System.Drawing.Point(16, 15)
        Me.btnNew.Name = "btnNew"
        Me.btnNew.TabIndex = 0
        Me.btnNew.Text = "Novo"
        Me.btnNew.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'TabControl
        '
        Me.TabControl.Controls.Add(Me.tpIndentityArea)
        Me.TabControl.Controls.Add(Me.tpContextArea)
        Me.TabControl.Controls.Add(Me.tpContentStructureArea)
        Me.TabControl.Controls.Add(Me.tpConditionsAccessUseArea)
        Me.TabControl.Controls.Add(Me.tpAlliedMaterialArea)
        Me.TabControl.Controls.Add(Me.tpNoteArea)
        Me.TabControl.Controls.Add(Me.tpDescriptionControlArea)
        Me.TabControl.Controls.Add(Me.tpAllArea)
        Me.TabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TabControl.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TabControl.ItemSize = New System.Drawing.Size(79, 18)
        Me.TabControl.Location = New System.Drawing.Point(0, 0)
        Me.TabControl.Multiline = True
        Me.TabControl.Name = "TabControl"
        Me.TabControl.SelectedIndex = 0
        Me.TabControl.ShowToolTips = True
        Me.TabControl.Size = New System.Drawing.Size(656, 392)
        Me.TabControl.TabIndex = 9
        Me.TabControl.TabStop = False
        '
        'tpIndentityArea
        '
        Me.tpIndentityArea.AutoScroll = True
        Me.tpIndentityArea.BackColor = System.Drawing.Color.White
        Me.tpIndentityArea.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpIndentityArea.Location = New System.Drawing.Point(4, 40)
        Me.tpIndentityArea.Name = "tpIndentityArea"
        Me.tpIndentityArea.Size = New System.Drawing.Size(648, 348)
        Me.tpIndentityArea.TabIndex = 0
        Me.tpIndentityArea.Tag = ""
        Me.tpIndentityArea.Text = CType(configurationAppSettings.GetValue("tpIndentityArea.Text", GetType(System.String)), String)
        '
        'tpDescriptionControlArea
        '
        Me.tpDescriptionControlArea.AutoScroll = True
        Me.tpDescriptionControlArea.BackColor = System.Drawing.Color.White
        Me.tpDescriptionControlArea.Location = New System.Drawing.Point(4, 22)
        Me.tpDescriptionControlArea.Name = "tpDescriptionControlArea"
        Me.tpDescriptionControlArea.Size = New System.Drawing.Size(648, 366)
        Me.tpDescriptionControlArea.TabIndex = 7
        Me.tpDescriptionControlArea.Text = CType(configurationAppSettings.GetValue("tpDescriptionControl.Text", GetType(System.String)), String)
        Me.tpDescriptionControlArea.Visible = False
        '
        'tpContextArea
        '
        Me.tpContextArea.AutoScroll = True
        Me.tpContextArea.BackColor = System.Drawing.Color.White
        Me.tpContextArea.Location = New System.Drawing.Point(4, 22)
        Me.tpContextArea.Name = "tpContextArea"
        Me.tpContextArea.Size = New System.Drawing.Size(648, 366)
        Me.tpContextArea.TabIndex = 1
        Me.tpContextArea.Tag = ""
        Me.tpContextArea.Text = CType(configurationAppSettings.GetValue("tpContextArea.Text", GetType(System.String)), String)
        Me.tpContextArea.Visible = False
        '
        'tpContentStructureArea
        '
        Me.tpContentStructureArea.AutoScroll = True
        Me.tpContentStructureArea.BackColor = System.Drawing.Color.White
        Me.tpContentStructureArea.Location = New System.Drawing.Point(4, 22)
        Me.tpContentStructureArea.Name = "tpContentStructureArea"
        Me.tpContentStructureArea.Size = New System.Drawing.Size(648, 366)
        Me.tpContentStructureArea.TabIndex = 2
        Me.tpContentStructureArea.Text = CType(configurationAppSettings.GetValue("tpContentStructureArea.Text", GetType(System.String)), String)
        Me.tpContentStructureArea.Visible = False
        '
        'tpConditionsAccessUseArea
        '
        Me.tpConditionsAccessUseArea.AutoScroll = True
        Me.tpConditionsAccessUseArea.BackColor = System.Drawing.Color.White
        Me.tpConditionsAccessUseArea.Location = New System.Drawing.Point(4, 22)
        Me.tpConditionsAccessUseArea.Name = "tpConditionsAccessUseArea"
        Me.tpConditionsAccessUseArea.Size = New System.Drawing.Size(648, 366)
        Me.tpConditionsAccessUseArea.TabIndex = 3
        Me.tpConditionsAccessUseArea.Text = CType(configurationAppSettings.GetValue("tpConditionsAccessUseArea.Text", GetType(System.String)), String)
        Me.tpConditionsAccessUseArea.Visible = False
        '
        'tpAlliedMaterialArea
        '
        Me.tpAlliedMaterialArea.AutoScroll = True
        Me.tpAlliedMaterialArea.BackColor = System.Drawing.Color.White
        Me.tpAlliedMaterialArea.Location = New System.Drawing.Point(4, 22)
        Me.tpAlliedMaterialArea.Name = "tpAlliedMaterialArea"
        Me.tpAlliedMaterialArea.Size = New System.Drawing.Size(648, 366)
        Me.tpAlliedMaterialArea.TabIndex = 4
        Me.tpAlliedMaterialArea.Text = CType(configurationAppSettings.GetValue("tpAlliedMaterialArea.Text", GetType(System.String)), String)
        Me.tpAlliedMaterialArea.Visible = False
        '
        'tpNoteArea
        '
        Me.tpNoteArea.AutoScroll = True
        Me.tpNoteArea.BackColor = System.Drawing.Color.White
        Me.tpNoteArea.Location = New System.Drawing.Point(4, 22)
        Me.tpNoteArea.Name = "tpNoteArea"
        Me.tpNoteArea.Size = New System.Drawing.Size(648, 366)
        Me.tpNoteArea.TabIndex = 5
        Me.tpNoteArea.Text = CType(configurationAppSettings.GetValue("tpNoteArea.Text", GetType(System.String)), String)
        Me.tpNoteArea.Visible = False
        '
        'tpAllArea
        '
        Me.tpAllArea.AutoScroll = True
        Me.tpAllArea.BackColor = System.Drawing.Color.White
        Me.tpAllArea.Location = New System.Drawing.Point(4, 40)
        Me.tpAllArea.Name = "tpAllArea"
        Me.tpAllArea.Size = New System.Drawing.Size(648, 348)
        Me.tpAllArea.TabIndex = 6
        Me.tpAllArea.Text = "Todos os campos"
        Me.tpAllArea.Visible = False
        '
        'OtherLevelIcons
        '
        Me.OtherLevelIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.OtherLevelIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherLevelIcons.ImageStream = CType(resources.GetObject("OtherLevelIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherLevelIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'GenreFormIcons
        '
        Me.GenreFormIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.GenreFormIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.GenreFormIcons.ImageStream = CType(resources.GetObject("GenreFormIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.GenreFormIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'UpDownArrowButtons
        '
        Me.UpDownArrowButtons.ImageSize = New System.Drawing.Size(20, 20)
        Me.UpDownArrowButtons.ImageStream = CType(resources.GetObject("UpDownArrowButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.UpDownArrowButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'AltFormAvailIcons
        '
        Me.AltFormAvailIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.AltFormAvailIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.AltFormAvailIcons.ImageStream = CType(resources.GetObject("AltFormAvailIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.AltFormAvailIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'ContainerTypeIcons
        '
        Me.ContainerTypeIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.ContainerTypeIcons.ImageStream = CType(resources.GetObject("ContainerTypeIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ContainerTypeIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'OtherFindAidIcons
        '
        Me.OtherFindAidIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.OtherFindAidIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherFindAidIcons.ImageStream = CType(resources.GetObject("OtherFindAidIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherFindAidIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'EADEditor
        '
        Me.Controls.Add(Me.TabControl)
        Me.Controls.Add(Me.FooterButtonsGroupBox)
        Me.Name = "EADEditor"
        Me.Size = New System.Drawing.Size(656, 440)
        Me.FooterButtonsGroupBox.ResumeLayout(False)
        Me.TabControl.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region


#Region "Initializations"


    Public Sub New(ByVal LazyNode As LazyNode, _
                   ByVal ApplicationType As ApplicationType, _
                   ByVal ViewMode As ViewMode, ByVal Username As String)
        Me.New()
        myLazyNode = LazyNode
        myApplicationType = ApplicationType
        myViewMode = ViewMode
        myUsername = Username
    End Sub



    Private Sub EADEditor_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InitializeUserControl()
    End Sub


    Private Sub InitializeUserControl()
        FooterButtonsGroupBox.BackColor = Color.FromArgb(255, 255, 250, 250)

        btnSave.Enabled = False

        btnSave.Text = VisualFieldLabel("SaveButton")
        btnReplicate.Text = VisualFieldLabel("ReplicateButton")
        btnPrint.Text = VisualFieldLabel("PrintButton")
        btnNew.Text = VisualFieldLabel("NewButton")

    End Sub

#End Region


#Region "Properties"

    Public Property ViewMode() As ViewMode
        Get
            Return myViewMode
        End Get
        Set(ByVal Value As ViewMode)
            myViewMode = Value
        End Set
    End Property



    Public Property LazyNode() As LazyNode
        Get
            Return myLazyNode
        End Get
        Set(ByVal Value As LazyNode)
            myLazyNode = Value
        End Set
    End Property


#End Region


#Region "User interface"


    Public Sub Reload()
        DrawFieldsInSelectedTab()
    End Sub



    Private Sub DrawFieldsInSelectedTab()
        If LazyNode Is Nothing Then Exit Sub
        If Me.TabControl.SelectedTab Is Nothing Then Exit Sub

        Dim Panel As New Panel
        Panel.Width = Me.TabControl.SelectedTab.Width
        Panel.Dock = DockStyle.Fill

        Panel.SuspendLayout()
        TabControl.SuspendLayout()
        SuspendLayout()

        Select Case myApplicationType
            Case ApplicationType.Client, ApplicationType.Standalone
                If Me.TabControl.SelectedTab Is Me.tpIndentityArea Then
                    DrawVisualFieldsByArea(LazyNode, "identityArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpContextArea Then
                    DrawVisualFieldsByArea(LazyNode, "contextArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpContentStructureArea Then
                    DrawVisualFieldsByArea(LazyNode, "contentStructureArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpConditionsAccessUseArea Then
                    DrawVisualFieldsByArea(LazyNode, "useAccessArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpAlliedMaterialArea Then
                    DrawVisualFieldsByArea(LazyNode, "alliedMaterialArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpNoteArea Then
                    DrawVisualFieldsByArea(LazyNode, "noteArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpDescriptionControlArea Then
                    DrawVisualFieldsByArea(LazyNode, "descriptionControlArea", Panel, myApplicationType, myViewMode)
                ElseIf Me.TabControl.SelectedTab Is Me.tpAllArea Then
                    DrawVisualFieldsByArea(LazyNode, "allFieldsArea", Panel, myApplicationType, myViewMode)
                End If
            Case ApplicationType.MiniDigitArq
                DrawVisualFieldsByArea(LazyNode, "descriptionArea", Panel, myApplicationType, myViewMode)
        End Select


        ' clear all controls in selected tab
        For Each InnerControl As Control In Me.TabControl.SelectedTab.Controls
            InnerControl.Dispose()
        Next

        ' clear all controls in selected tab
        Me.TabControl.SelectedTab.Controls.Clear()
        Me.TabControl.SelectedTab.Controls.Add(Panel)

        Me.TabControl.ResumeLayout(False)
        Me.ResumeLayout(False)
        Panel.ResumeLayout(False)
        Panel.AutoScroll = True


    End Sub


    Public Function ViewModeToConfigSection(ByVal FieldPresentationMode As ViewMode) As String
        Select Case FieldPresentationMode
            Case ViewMode.All : Return "allFields"
            Case ViewMode.Frequent : Return "frequentFields"
            Case ViewMode.Mandatory : Return "mandatoryFields"
        End Select
    End Function



    Private Sub DrawVisualFieldsByArea(ByVal LazyNode As LazyNode, _
                                       ByVal ConfigurationGroup As String, _
                                       ByRef Panel As Panel, _
                                       ByVal ApplicationType As ApplicationType, _
                                       ByVal ViewMode As ViewMode)

        If LazyNode Is Nothing Then Exit Sub
        If Panel Is Nothing Then Exit Sub

        Dim AreaFields As NameValueCollection = _
            CType(ConfigurationSettings.GetConfig(ViewModeToConfigSection(ViewMode) & "/" & _
               ConfigurationGroup & "/" & LazyNode.OtherLevel), _
                  NameValueCollection)

        If AreaFields Is Nothing Then
            AreaFields = New NameValueCollection
            AreaFields.Add("group1", "OtherLevel")
            AreaFields.Add("group1", "UnitId")
            AreaFields.Add("group1", "UnitTitle")
        End If

        For Each GroupName As String In AreaFields.Keys()
            DrawVisualFieldGroup(GroupName, AreaFields.GetValues(GroupName), LazyNode, Panel)
        Next
    End Sub




    ' Draw groupboxes with Input fields on them
    Private Sub DrawVisualFieldGroup(ByVal GroupName As String, _
                                     ByVal VisualFieldNames() As String, _
                                     ByVal LazyNode As LazyNode, _
                                     ByRef Panel As Panel)


        If VisualFieldNames Is Nothing Then Exit Sub
        Dim VisualFieldName As String

        Dim GroupBoxSize As New Size(Panel.Width() - 30, 1)

        Dim GroupBox As New GroupBox
        GroupBox.Name = GroupName
        GroupBox.BackColor = Color.FromArgb(255, 240, 240, 240)
        GroupBox.Width = GroupBoxSize.Width - 5
        GroupBox.Height = GroupBoxSize.Height

        Dim PositionX As Integer = 15
        Dim PositionY As Integer = 15


        For Each VisualFieldName In VisualFieldNames
            Dim VisualField As VisualField = VisualFieldByName(VisualFieldName, LazyNode, GroupBoxSize.Width - 30)

            If Not VisualField Is Nothing Then
                VisualField.Location = New Point(PositionX, PositionY)
                VisualField.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
                PositionY = VisualField.Location.Y + VisualField.Height + 5
                AddHandler VisualField.DataChanged, AddressOf LazyNodeDataChanged
                GroupBoxSize = New Size(GroupBoxSize.Width, GroupBoxSize.Height + VisualField.Height + 5)
                GroupBox.Controls.Add(VisualField)
            End If
        Next


        ' if no controls were added to group box.. then.. do nothing
        If GroupBox.Controls.Count > 0 Then
            GroupBox.Height = GroupBoxSize.Height + 20

            ' Position groupbox after the last groupbox in the tab
            If Panel.Controls.Count = 0 Then
                GroupBox.Location = New Point(15, 15)
            Else
                Dim LastFieldGroup As GroupBox = CType(Panel.Controls.Item(Panel.Controls.Count - 1), GroupBox)
                GroupBox.Location = New Point(LastFieldGroup.Location.X, LastFieldGroup.Location.Y + LastFieldGroup.Height + 15)
            End If



            GroupBox.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
            Panel.Controls.Add(GroupBox)
        End If

    End Sub



    Private Sub LazyNodeDataChanged(ByVal Sender As Object, ByVal e As Object)
        btnSave.Enabled = True
        RaiseEvent DataChanged(Me, Me.LazyNode)
    End Sub


    Private Function VisualFieldByName(ByVal FieldName As String, _
                                       ByVal LazyNode As LazyNode, _
                                       ByVal Width As Integer) _
                                                As VisualField

        ' Get the right values here
        'Dim TopOtherLevelIndex As Integer = 1
        'Dim BottomOtherLevelIndex As Integer = 12


        Select Case FieldName
            Case "OtherLevel" : Return New VisualFieldOtherLevel(LazyNode, OtherLevelIcons, TopOtherLevelIndex, BottomOtherLevelIndex, Width)
            Case "UnitId" : Return New VisualFieldUnitId(LazyNode, Width)
            Case "UnitTitle" : Return New VisualFieldUnitTitle(LazyNode, Width)
            Case "UnitDates"
                Dim VisualFieldUnitDates As New VisualFieldUnitDates(LazyNode, Width)
                AddHandler VisualFieldUnitDates.InferenceButtonClicked, AddressOf Reload
                Return VisualFieldUnitDates
            Case "Separator" : Return New VisualFieldSeparator ' Do some kind of separation
            Case "Extents"
                Dim VisualFieldExtents As New VisualFieldExtents(LazyNode, Width)
                AddHandler VisualFieldExtents.InferenceButtonClicked, AddressOf Reload
                Return VisualFieldExtents
            Case "ContainerExtents" : Return New VisualFieldContainerExtents(LazyNode, Width)
            Case "Dimensions" : Return New VisualFieldDimensions(LazyNode, Width)
            Case "Repository" : Return New VisualFieldRepository(LazyNode, Width)
            Case "Abstract" : Return New VisualFieldAbstract(LazyNode, Width)
            Case "GenreForm" : Return New VisualFieldGenreForm(LazyNode, Width)
            Case "ContainerType" : Return New VisualFieldContainerType(LazyNode, ContainerTypeIcons, Width)

            Case "Author" : Return New VisualFieldAuthor(LazyNode, Width)
            Case "AuthorAddress" : Return New VisualFieldAuthorAddress(LazyNode, Width)
            Case "Destination" : Return New VisualFieldDestination(LazyNode, Width)
            Case "DestinationAddress" : Return New VisualFieldDestinationAddress(LazyNode, Width)

            Case "Notary" : Return New VisualFieldNotary(LazyNode, Width)
            Case "Scrivener" : Return New VisualFieldScrivener(LazyNode, Width)

            Case "BiogHist" : Return New VisualFieldBiogHist(LazyNode, Width)
            Case "CustodHist" : Return New VisualFieldCustodHist(LazyNode, Width)
            Case "AcqInfo" : Return New VisualFieldAcqInfo(LazyNode, Width)
            Case "OtherFindAid" : Return New VisualFieldOtherFindAid(LazyNode, Width)
            Case "ScopeContent" : Return New VisualFieldScopeContent(LazyNode, Width)
            Case "Appraisal" : Return New VisualFieldAppraisal(LazyNode, Width)
            Case "Accruals" : Return New VisualFieldAccruals(LazyNode, Width)
            Case "Arrangement" : Return New VisualFieldArrangement(LazyNode, Width)
            Case "FilePlan" : Return New VisualFieldFilePlan(LazyNode, Width)
            Case "AccessRestrict" : Return New VisualFieldAccessRestrict(LazyNode, Width)
            Case "UseRestrict" : Return New VisualFieldUseRestrict(LazyNode, Width)
            Case "LangMaterial" : Return New VisualFieldLangMaterial(LazyNode, Width)
            Case "PhysTech" : Return New VisualFieldPhysTech(LazyNode, Width)
            Case "MaterialSpec" : Return New VisualFieldMaterialSpec(LazyNode, Width)
            Case "PhysFacet" : Return New VisualFieldPhysFacet(LazyNode, Width)
            Case "PhysLoc" : Return New VisualFieldPhysLoc(LazyNode, Width)
            Case "OriginalsLoc" : Return New VisualFieldOriginalsLoc(LazyNode, Width)
            Case "RelatedMaterial" : Return New VisualFieldRelatedMaterial(LazyNode, Width)
            Case "SeparatedMaterial" : Return New VisualFieldSeparatedMaterial(LazyNode, Width)
            Case "Note" : Return New VisualFieldNote(LazyNode, Width)
            Case "ProcessInfo" : Return New VisualFieldProcessInfo(LazyNode, Width)
            Case "PreferCite" : Return New VisualFieldPreferCite(LazyNode, Width)
            Case "AltFormAvail" : Return New VisualFieldAltFormAvail(LazyNode, AltFormAvailIcons, Width)
            Case "OriginalNumbering" : Return New VisualFieldOriginalNumbering(LazyNode, Width)
            Case "LegalStatus" : Return New VisualFieldLegalStatus(LazyNode, Width)
            Case "GeogName" : Return New VisualFieldGeogName(LazyNode, Width)
            Case "Bibliography" : Return New VisualFieldBibliography(LazyNode, UpDownArrowButtons, Width)
            Case "ChronList" : Return New VisualFieldChronList(LazyNode, UpDownArrowButtons, Width)
            Case "ControlAccess" : Return New VisualFieldControlAccess(LazyNode, UpDownArrowButtons, CInt(LazyNode.ParentFondsID), Width)
                'new fields
            Case "ArchivistNotes" : Return New VisualFieldArchivistNotes(LazyNode, UpDownArrowButtons, myUsername, Width)
            Case "OtherDescriptiveData" : Return New VisualFieldOtherDescriptiveData(LazyNode, Width)
            Case "PreviousLoc" : Return New VisualFieldPreviousLoc(LazyNode, Width)
            Case Else
                Debug.WriteLine("VisualFieldByName: Unknown Field - " & FieldName)
                Return Nothing
        End Select
    End Function





    Private Function TopOtherLevelIndex() As Integer
        Dim FondsIndex As Integer = GetOtherLevelIndex(OTHERLEVEL_FONDS)

        If LazyNode Is Nothing Then Return FondsIndex

        If LazyNode.OtherLevelIndex = FondsIndex Then
            Return FondsIndex
        End If

        If LazyNode.OtherLevelIndex = 1 Then
            Return 1
        Else
            If (Not LazyNode.Parent Is Nothing) Then
                Return LazyNode.Parent.OtherLevelIndex + 1
            Else
                Return 1
            End If
        End If
    End Function


    Private Function BottomOtherLevelIndex() As Integer
        Dim FondsIndex As Integer = GetOtherLevelIndex(OTHERLEVEL_FONDS)
        If LazyNode Is Nothing Then Return FondsIndex

        If LazyNode.OtherLevelIndex = FondsIndex Then
            Return FondsIndex
        End If


        Dim min As Integer = GetOtherLevelIndex(OTHERLEVEL_DOCUMENT) + 1

        If LazyNode Is Nothing Then Return min

        For Each level As String In LazyNode.ChildrenLevels
            min = Math.Min(min, GetOtherLevelIndex(level))
            If min = LazyNode.OtherLevelIndex + 1 Then
                Return min - 1
            End If
        Next
        Return min - 1
    End Function



#End Region


#Region "Event handlers"


    Private Sub TabControl_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl.SelectedIndexChanged
        Reload()
    End Sub


    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        RaiseEvent PrintButtonClicked(Me, e)

    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        ' myLazyNode.Upload()
        'btnSave.Enabled = False
        RaiseEvent SaveButtonClicked(Me, e)
    End Sub


    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        RaiseEvent NewButtonClicked(Me, e)
    End Sub

    Private Sub btnReplicate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReplicate.Click
        RaiseEvent ReplicateButtonClicked(Me, e)
    End Sub

    Public Sub EnableReplicateButton(ByVal Enabled As Boolean)
        btnReplicate.Enabled = Enabled
    End Sub


    Public Sub EnableNewButton(ByVal Enabled As Boolean)
        btnNew.Enabled = Enabled
    End Sub

    Public Sub EnableSaveButton(ByVal Enabled As Boolean)
        btnSave.Enabled = Enabled
    End Sub




#End Region




End Class
