
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient
Imports System.Configuration


Module MessageExceptions

    Public Function ErrorMessage(ByVal key As String) As String
        Try
            Dim message As String = CType(ConfigurationSettings.GetConfig("errMessages"), Hashtable).Item(key)
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Sub MsgBoxNetworkError()
        MsgBox(ErrorMessage("DatabaseAccess.Error"), MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly)
    End Sub

    Public Sub MsgBoxCustomError(ByVal ErrorMessage As String)
        MsgBox(ErrorMessage, MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly)
    End Sub


    Public Function MsgSqlException(ByVal ex As SqlException) As String
        Dim strError As New System.Text.StringBuilder

        If ex.Number = 511 Then ' record overflow error. Record size is limited to 8060 chars
            strError.Append(ErrorMessage("MsgBoxCustomError.RecordOverflow"))
        Else ' Generic error message
            strError.Append(ErrorMessage("MsgBoxCustomError.SqlException"))
            strError.Append(ControlChars.NewLine)
            strError.Append(ControlChars.NewLine)
            strError.Append(ErrorMessage("MsgBoxCustomError.AdvancedErrorDescription"))
            strError.Append(ControlChars.NewLine)
            strError.Append("Description: " & ex.Message)
            strError.Append(ControlChars.NewLine)
            strError.Append("Error type: " & ex.Number)
            strError.Append(ControlChars.NewLine)
            strError.Append("Server: " & ex.Server)
            strError.Append(ControlChars.NewLine)
            strError.Append("Source: " & ex.Source)
            strError.Append(ControlChars.NewLine)
            strError.Append("State: " & ex.State)
            strError.Append(ControlChars.NewLine)
            strError.Append("Method: " & ex.TargetSite.Name)
            strError.Append(ControlChars.NewLine)
            strError.Append("Stack trace: " & ex.StackTrace)
            strError.Append(ControlChars.NewLine)
        End If
        Return strError.ToString
    End Function

    Public Function MsgException(ByVal ex As Exception) As String
        Dim strError As New System.Text.StringBuilder

        If TypeOf ex Is SqlException Then
            strError.Append(MsgSqlException(ex))
        Else
            strError.Append(ErrorMessage("MsgBoxCustomError.Exception"))
            strError.Append(ControlChars.NewLine)
            strError.Append(ControlChars.NewLine)
            strError.Append(ErrorMessage("MsgBoxCustomError.AdvancedErrorDescription"))
            strError.Append(ControlChars.NewLine)
            strError.Append("Description: " & ex.Message)
            strError.Append(ControlChars.NewLine)
            strError.Append("Source: " & ex.Source)
            strError.Append(ControlChars.NewLine)
            strError.Append("Method: " & ex.TargetSite.Name)
            strError.Append(ControlChars.NewLine)
            strError.Append("Stack trace: " & ex.StackTrace)
            strError.Append(ControlChars.NewLine)
        End If
        Return strError.ToString
    End Function

End Module
