Public Class ISADArea
    Inherits System.Windows.Forms.UserControl

    Private WithEvents HeaderLabel As Label
    Private LastLocationY As Integer = 25
    Private Fields As New Collection


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'ISADArea
        '
        Me.Name = "ISADArea"
        Me.Size = New System.Drawing.Size(528, 112)

    End Sub

#End Region


    Public Sub New(ByVal HeaderText As String)
        BuildHeader()
        Me.HeaderText = HeaderText
    End Sub

    Public Property HeaderText() As String
        Get
            Return Me.HeaderLabel.Text
        End Get
        Set(ByVal Value As String)
            Me.HeaderLabel.Text = Value
        End Set
    End Property


    Public Sub Clear()
        LastLocationY = 0
        Fields = New Collection
        For i As Integer = 1 To Controls.Count
            Controls.RemoveAt(i)
        Next
    End Sub


    Public Sub Add(ByVal Field As PropertyValueViewer)

        If Field.PropertyValue.Length = 0 OrElse Me.Controls.Contains(Field) Then Exit Sub
        Fields.Add(Field)
    End Sub


    Public Sub LoadControls()
        LastLocationY = 0

        '        Debug.WriteLine("HeaderLabel.text = " & HeaderLabel.Text)
        Me.Controls.Add(HeaderLabel)
        LastLocationY += HeaderLabel.Height + 2

        For Each Field As PropertyValueViewer In Fields
            Field.Location = New Point(0, LastLocationY)
            Field.Width = Me.Width
            Field.AutoSize()
            Field.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
            Me.Controls.Add(Field)
            LastLocationY += Field.Height
        Next
        Me.Height = LastLocationY + 5
    End Sub



    Private Sub ISADArea_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Me.Controls.Clear()
        LoadControls()
    End Sub

    Private Sub BuildHeader()
        Me.HeaderLabel = New Label
        Me.HeaderLabel.BackColor = System.Drawing.SystemColors.ControlDark
        Me.HeaderLabel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.HeaderLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.HeaderLabel.ForeColor = System.Drawing.SystemColors.ControlLightLight
        Me.HeaderLabel.Location = New System.Drawing.Point(0, 0)
        Me.HeaderLabel.Size = New System.Drawing.Size(Me.Width - 1, 24)
        Me.HeaderLabel.TabIndex = 2
        Me.HeaderLabel.Text = "undefined..."
        Me.HeaderLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.HeaderLabel.Width = Me.Width
        Me.HeaderLabel.Anchor = CType((System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right Or AnchorStyles.Top), System.Windows.Forms.AnchorStyles)

    End Sub
End Class
