Public Class PropertyValueViewer
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label As System.Windows.Forms.Label
    Friend WithEvents Value As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label = New System.Windows.Forms.Label
        Me.Value = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'Label
        '
        Me.Label.Location = New System.Drawing.Point(6, 2)
        Me.Label.Name = "Label"
        Me.Label.Size = New System.Drawing.Size(122, 16)
        Me.Label.TabIndex = 0
        Me.Label.Text = "Cdigo de Referncia:"
        '
        'Value
        '
        Me.Value.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Value.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Value.Location = New System.Drawing.Point(128, 0)
        Me.Value.Name = "Value"
        Me.Value.ReadOnly = True
        Me.Value.Size = New System.Drawing.Size(104, 20)
        Me.Value.TabIndex = 1
        Me.Value.Text = ""
        '
        'PropertyValueViewer
        '
        Me.Controls.Add(Me.Value)
        Me.Controls.Add(Me.Label)
        Me.Name = "PropertyValueViewer"
        Me.Size = New System.Drawing.Size(232, 21)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim STANDARD_TEXT_BOX_HEIGHT As Integer = 20

    Public Property PropertyLabel() As String
        Get
            Return Label.Text
        End Get
        Set(ByVal Value As String)
            Label.Text = Value
        End Set
    End Property


    Public Property PropertyValue() As String
        Get
            Return Value.Text
        End Get
        Set(ByVal Value As String)
            If Not Value Is Nothing Then
                Me.Value.Text = Value.Trim
            End If
        End Set
    End Property


    Private Function GetNumberOfLines(ByVal Text As String, ByVal Font As Font) As Integer
        If Text.Length = 0 Then Return 1

        Dim graphics As graphics = Me.CreateGraphics()
        Dim textSize As SizeF = graphics.MeasureString(Text, Font)

        Dim noLines As Integer = CInt(Math.Ceiling(0.4 + CDbl(textSize.Width) / CDbl(Value.Width)))
        If noLines = 0 Then noLines = 1

        Return noLines
    End Function



    Public Sub AutoSize()
        Dim ValueNoLines As Integer = GetNumberOfLines(Value.Text, Value.Font)
        Dim LabelNoLines As Integer = GetNumberOfLines(Label.Text, Label.Font)

        Dim NoLines As Integer = Math.Max(ValueNoLines, LabelNoLines)

        ' Debug.WriteLine("   > PropertyValueViewer: " & Label.Text & " [" & Value.Text & "]" & " - " & ValueNoLines & " lines")

        If NoLines > 1 Then
            Me.Value.Multiline = True
        Else
            Me.Value.Multiline = False
        End If

        Value.Height = NoLines * STANDARD_TEXT_BOX_HEIGHT
        Label.Height = NoLines * STANDARD_TEXT_BOX_HEIGHT
        Me.Height = Label.Height + 1
    End Sub


 
End Class
