

Public Class ScrollablePictureBox
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Public WithEvents BackPanel As System.Windows.Forms.Panel
    Public WithEvents PictureBox As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.BackPanel = New System.Windows.Forms.Panel
        Me.PictureBox = New System.Windows.Forms.PictureBox
        Me.BackPanel.SuspendLayout()
        Me.SuspendLayout()
        '
        'BackPanel
        '
        Me.BackPanel.AutoScroll = True
        Me.BackPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.BackPanel.Controls.Add(Me.PictureBox)
        Me.BackPanel.Location = New System.Drawing.Point(9, 10)
        Me.BackPanel.Name = "BackPanel"
        Me.BackPanel.Size = New System.Drawing.Size(330, 410)
        Me.BackPanel.TabIndex = 5
        '
        'PictureBox
        '
        Me.PictureBox.Location = New System.Drawing.Point(24, 32)
        Me.PictureBox.Name = "PictureBox"
        Me.PictureBox.Size = New System.Drawing.Size(292, 360)
        Me.PictureBox.TabIndex = 3
        Me.PictureBox.TabStop = False
        '
        'ScrollablePictureBox
        '
        Me.BackColor = System.Drawing.Color.White
        Me.Controls.Add(Me.BackPanel)
        Me.Name = "ScrollablePictureBox"
        Me.Size = New System.Drawing.Size(350, 430)
        Me.BackPanel.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Properties"

    'Public PictureBox As System.Windows.Forms.PictureBox
    'Public BackPanel System.Windows.Forms.Panel
    Private myComponents As System.ComponentModel.Container = Nothing
    Private myPicture As System.Drawing.Image = Nothing
    Private m_PanStartPoint As New Point


#End Region

#Region "Constants"

    Private ZOOMFACTOR As Double = 1.25   '= 25% smaller or larger
    Private MINMAX As Integer = 5    '5 times bigger or smaller than the ctrl

#End Region

#Region "Constructors"

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        InitCtrl()
    End Sub

#End Region

#Region "Properties"

    Property Image() As System.Drawing.Image
        Get
            Return myPicture
        End Get
        Set(ByVal Value As System.Drawing.Image)
            myPicture = Value
            Me.PictureBox.Image = Value
        End Set
    End Property

    Property BorderStyle() As BorderStyle
        Get
            Return Me.BackPanel.BorderStyle
        End Get
        Set(ByVal Value As BorderStyle)
            Me.BackPanel.BorderStyle = Value
        End Set
    End Property

    'Overloads Property BackColor() As Color
    '    Get
    '        Return Me.BackColor
    '    End Get
    '    Set(ByVal Value As Color)
    '        Me.BackColor = Value
    '    End Set
    'End Property

#End Region

#Region "Other Methods"

		
    Private Sub InitCtrl()
        Me.PictureBox.SizeMode = PictureBoxSizeMode.StretchImage
        Me.PictureBox.Location = Me.BackPanel.Location
        Me.BackPanel.Dock = DockStyle.Fill
        Me.BackPanel.AutoScroll = True

        'AddHandler BackPanel.MouseEnter, AddressOf PictureBox_MouseEnter
        AddHandler BackPanel.MouseWheel, AddressOf PictureBox_MouseWheel
        'AddHandler PictureBox.MouseEnter, AddressOf PictureBox_MouseEnter
    End Sub
		
    'private void RedCross ()
    '{
    '	Bitmap bmp = new Bitmap ( OuterPanel.Width, OuterPanel.Height, System.Drawing.Imaging.PixelFormat.Format16bppRgb555 );
    '	Graphics gr;
    '	gr = Graphics.FromImage ( bmp );
    '	Pen pencil = new Pen ( Color.Red, 5 );
    '	gr.DrawLine ( pencil, 0, 0, OuterPanel.Width, OuterPanel.Height );
    '	gr.DrawLine ( pencil, 0, OuterPanel.Height, OuterPanel.Width, 0  );
    '	PicBox.Image = bmp;
    '	gr.Dispose ();
    '}

#End Region

#Region "Zooming Methods"

    '/// <summary>
    '/// Make the PictureBox dimensions larger to effect the Zoom.
    '/// </summary>
    '/// <remarks>Maximum 5 times bigger</remarks>
    Public Sub ZoomIn()
        If (PictureBox.Width < (MINMAX * BackPanel.Width)) And (PictureBox.Height < (MINMAX * BackPanel.Height)) Then
            PictureBox.Width = Convert.ToInt32(PictureBox.Width * ZOOMFACTOR)
            PictureBox.Height = Convert.ToInt32(PictureBox.Height * ZOOMFACTOR)
            PictureBox.SizeMode = PictureBoxSizeMode.StretchImage
        End If
    End Sub


    '/// <summary>
    '/// Make the PictureBox dimensions smaller to effect the Zoom.
    '/// </summary>
    '/// <remarks>Minimum 5 times smaller</remarks>
    Public Sub ZoomOut()
        If ((PictureBox.Width > (BackPanel.Width / MINMAX)) And (PictureBox.Height > (BackPanel.Height / MINMAX))) Then
            PictureBox.SizeMode = PictureBoxSizeMode.StretchImage
            PictureBox.Width = Convert.ToInt32(PictureBox.Width / ZOOMFACTOR)
            PictureBox.Height = Convert.ToInt32(PictureBox.Height / ZOOMFACTOR)
        End If
    End Sub

    Public Sub AdjustImageSize()
        If Me.Image.Width > Me.BackPanel.Width - 30 Then
            Dim NewWidth As Integer = Me.BackPanel.Width - 30
            Dim NewHeight As Integer = NewWidth * Me.Image.Height / Me.Image.Width

            Me.PictureBox.Width = NewWidth
            Me.PictureBox.Height = NewHeight
        Else
            OriginalImageSize()
        End If
    End Sub

    Public Sub OriginalImageSize()
        Me.PictureBox.Size = Image.Size
    End Sub

#End Region

#Region "Mouse events"

    '/// <summary>
    '/// We use the mousewheel to zoom the picture in or out
    '/// </summary>
    '/// <param name="sender"></param>
    '/// <param name="e"></param>
    Private Sub PictureBox_MouseWheel(ByVal sender As Object, ByVal e As MouseEventArgs)
        If (e.Delta < 0) Then
            ZoomIn()
        Else
            ZoomOut()
        End If
    End Sub


    '/// <summary>
    '/// Make sure that the PicBox have the focus, otherwise it doesnt receive 
    '/// mousewheel events !.
    '/// </summary>
    '/// <param name="sender"></param>
    '/// <param name="e"></param>
    Private Sub PictureBox_MouseEnter(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.MouseEnter
        If PictureBox.Focused = False Then
            PictureBox.Focus()
        End If
    End Sub

#End Region

    Private Sub ScrollablePictureBox_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If Not Image Is Nothing Then
            Me.AdjustImageSize()
        End If
    End Sub


    Private Sub ScrollablePictureBox_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox.MouseDown
        m_PanStartPoint = New Point(e.X, e.Y)
    End Sub


    Private Sub ScrollablePictureBox_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox.MouseMove

        'Verify Left Button is pressed while the mouse is moving
        If e.Button = Windows.Forms.MouseButtons.Left Then

            'Here we get the change in coordinates.
            Dim DeltaX As Integer = (m_PanStartPoint.X - e.X)
            Dim DeltaY As Integer = (m_PanStartPoint.Y - e.Y)
            'Then we set the new autoscroll position.
            'ALWAYS pass positive integers to the panels autoScrollPosition method
            BackPanel.AutoScrollPosition = New Drawing.Point((DeltaX - BackPanel.AutoScrollPosition.X), (DeltaY - BackPanel.AutoScrollPosition.Y))
        End If

    End Sub

End Class
