Imports DigitArq.UserControls.CustomUserControls
Imports DigitArq.Utility
Imports DigitArq.Utility.DataCleansing


Public Class GenericSearchField
    Inherits System.Windows.Forms.UserControl

    Public Event AddButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event RemoveButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event EnterKeyPressed(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event InputDataChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    Public Shared QUERY_CONTAINS As String = "Contains"
    Public Shared QUERY_NOTCONTAINS As String = "NotContains"
    Public Shared QUERY_BEGINSWITH As String = "BeginsWith"
    Public Shared QUERY_ENDSWITH As String = "EndsWith"
    Public Shared QUERY_EQUALS As String = "Equals"


    Public Enum TypeOfButton
        Add
        Remove
    End Enum

    Private myButtonType As TypeOfButton = TypeOfButton.Add




#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents FieldNameComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents QueryTypeComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents txtSearchValue As System.Windows.Forms.TextBox
    Friend WithEvents AddRemoveButton As DigitArq.UserControls.ImageButton.ImageButton
    Friend WithEvents ButtonImageList As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(GenericSearchField))
        Me.FieldNameComboBox = New System.Windows.Forms.ComboBox
        Me.AddRemoveButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.txtSearchValue = New System.Windows.Forms.TextBox
        Me.QueryTypeComboBox = New System.Windows.Forms.ComboBox
        Me.ButtonImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.SuspendLayout()
        '
        'FieldNameComboBox
        '
        Me.FieldNameComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.FieldNameComboBox.Location = New System.Drawing.Point(12, 1)
        Me.FieldNameComboBox.Name = "FieldNameComboBox"
        Me.FieldNameComboBox.Size = New System.Drawing.Size(196, 21)
        Me.FieldNameComboBox.TabIndex = 0
        '
        'AddRemoveButton
        '
        Me.AddRemoveButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.AddRemoveButton.BorderColor = System.Drawing.Color.Transparent
        Me.AddRemoveButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AddRemoveButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AddRemoveButton.ButtonImage = CType(resources.GetObject("AddRemoveButton.ButtonImage"), System.Drawing.Image)
        Me.AddRemoveButton.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.AddRemoveButton.ButtonShowShadow = True
        Me.AddRemoveButton.ButtonText = ""
        Me.AddRemoveButton.ButtonTextAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AddRemoveButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AddRemoveButton.HighlightBackgroundColor = System.Drawing.Color.Transparent
        Me.AddRemoveButton.Location = New System.Drawing.Point(548, 0)
        Me.AddRemoveButton.Name = "AddRemoveButton"
        Me.AddRemoveButton.Size = New System.Drawing.Size(16, 22)
        Me.AddRemoveButton.TabIndex = 3
        Me.AddRemoveButton.ToolTip = ""
        '
        'txtSearchValue
        '
        Me.txtSearchValue.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtSearchValue.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSearchValue.Location = New System.Drawing.Point(304, 1)
        Me.txtSearchValue.Name = "txtSearchValue"
        Me.txtSearchValue.Size = New System.Drawing.Size(232, 20)
        Me.txtSearchValue.TabIndex = 2
        Me.txtSearchValue.Text = ""
        '
        'QueryTypeComboBox
        '
        Me.QueryTypeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.QueryTypeComboBox.Items.AddRange(New Object() {"Contm", "No contm", "Comea por", "Termina em", " igual a"})
        Me.QueryTypeComboBox.Location = New System.Drawing.Point(214, 1)
        Me.QueryTypeComboBox.Name = "QueryTypeComboBox"
        Me.QueryTypeComboBox.Size = New System.Drawing.Size(88, 21)
        Me.QueryTypeComboBox.TabIndex = 1
        '
        'ButtonImageList
        '
        Me.ButtonImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonImageList.ImageStream = CType(resources.GetObject("ButtonImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'GenericSearchField
        '
        Me.Controls.Add(Me.FieldNameComboBox)
        Me.Controls.Add(Me.AddRemoveButton)
        Me.Controls.Add(Me.txtSearchValue)
        Me.Controls.Add(Me.QueryTypeComboBox)
        Me.Name = "GenericSearchField"
        Me.Size = New System.Drawing.Size(576, 24)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddRemoveButton.Click
        If ButtonType = TypeOfButton.Add Then
            RaiseEvent AddButtonClick(Me, e)
        Else
            RaiseEvent RemoveButtonClick(Me, e)
        End If
    End Sub


    Public ReadOnly Property FieldName() As String
        Get
            Dim item As Object = Me.FieldNameComboBox.SelectedItem
            If Not item Is Nothing Then
                Return CType(Me.FieldNameComboBox.SelectedItem, ComboBoxImageItem).Value
            Else
                Return ""
            End If
        End Get
    End Property


    Public ReadOnly Property QueryType() As String
        Get
            Return Me.QueryTypeComboBox.SelectedText
        End Get
    End Property

    Public ReadOnly Property FieldValue() As String
        Get
            Return Me.txtSearchValue.Text
        End Get
    End Property




    Public ReadOnly Property SQLSearchTerm() As String
        Get

            If FieldValue.Length = 0 Then Return Nothing

            Dim SearchTerm As String = Nothing
            Dim SelectedItem As ComboBoxImageItem = CType(QueryTypeComboBox.SelectedItem, ComboBoxImageItem)
            Dim SelectedQueryType As String = SelectedItem.Value

            If (SelectedQueryType.Equals(QUERY_CONTAINS)) Then
                SearchTerm = String.Format("CONTAINS({0}, '{1}')", FieldName, PrepareContainsSearchCondition(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_BEGINSWITH)) Then
                SearchTerm = String.Format("CONTAINS({0}, '""{1}*""')", FieldName, CleanRawSearchCondition(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_ENDSWITH)) Then
                SearchTerm = String.Format("CONTAINS({0}, '""*{1}""')", FieldName, CleanRawSearchCondition(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_EQUALS)) Then
                'SearchTerm = String.Format("CONTAINS({0}, '""{1}""')", FieldName, CleanRawSearchCondition(FieldValue))
                SearchTerm = String.Format("{0} LIKE '{1}'", FieldName, StrToDB(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_NOTCONTAINS)) Then
                SearchTerm = String.Format("NOT CONTAINS({0}, '{1}')", FieldName, PrepareContainsSearchCondition(FieldValue, " OR "))
            End If

            Return SearchTerm

        End Get
    End Property


    Private Sub GenericSearchField_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
        LoadFieldNameComboBox()
        LoadQueryTypeComboBox()
    End Sub

    Private Sub LoadQueryTypeComboBox()
        QueryTypeComboBox.Items.Clear()
        With QueryTypeComboBox
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.Contains"), QUERY_CONTAINS))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.NotContains"), QUERY_NOTCONTAINS))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.BeginsWith"), QUERY_BEGINSWITH))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.EndsWith"), QUERY_ENDSWITH))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.Equals"), QUERY_EQUALS))
            .SelectedIndex = 0
        End With

    End Sub


    Private Sub LoadFieldNameComboBox()
        With FieldNameComboBox
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("UnitTitle").Replace(":", ""), "UnitTitle"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("GenreForm").Replace(":", ""), "GenreForm"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("GeogName").Replace(":", ""), "GeogName"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("PhysFacet").Replace(":", ""), "PhysFacet"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("PhysLoc").Replace(":", ""), "PhysLoc"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("MaterialSpec").Replace(":", ""), "MaterialSpec"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("LangMaterial").Replace(":", ""), "LangMaterial"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginationScrivener").Replace(":", ""), "OriginationScrivener"))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginationAuthor").Replace(":", ""), "OriginationAuthor"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginationDestination").Replace(":", ""), "OriginationDestination"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginationAuthorAddress").Replace(":", ""), "OriginationAuthorAddress"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginationNotary").Replace(":", ""), "OriginationNotary"))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("ScopeContent").Replace(":", ""), "ScopeContent"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("BiogHist").Replace(":", ""), "BiogHist"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OtherFindAid").Replace(":", ""), "OtherFindAids"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginalNumbering").Replace(":", ""), "OriginalNumbering"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Note").Replace(":", ""), "Note"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("RelatedMaterial").Replace(":", ""), "RelatedMaterial"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("PhysTech").Replace(":", ""), "PhysTech"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("AcqInfo").Replace(":", ""), "AcqInfo"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Arrangement").Replace(":", ""), "Arrangement"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("CustodHist").Replace(":", ""), "CustodHist"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("AltFormAvail").Replace(":", ""), "AltFormAvail"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Appraisal").Replace(":", ""), "Appraisal"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("AccessRestrict").Replace(":", ""), "AccessRestrict"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("LegalStatus").Replace(":", ""), "LegalStatus"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Accruals").Replace(":", ""), "Accruals"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("UseRestrict").Replace(":", ""), "UseRestrict"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OriginalsLoc").Replace(":", ""), "OriginalsLoc"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("PreferCite").Replace(":", ""), "PreferCite"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("SeparatedMaterial").Replace(":", ""), "SeparatedMaterial"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Abstract").Replace(":", ""), "Abstract"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Repository").Replace(":", ""), "Repository"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("FilePlan").Replace(":", ""), "FilePlan"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Dimensions").Replace(":", ""), "Dimensions"))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("UnitDateInitial").Replace(":", ""), "UnitDateInitial"))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("UnitDateFinal").Replace(":", ""), "UnitDateFinal"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("UnitDateBulk").Replace(":", ""), "UnitDateBulk"))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("OtherLevel").Replace(":", ""), "OtherLevel"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("ContainerType").Replace(":", ""), "ContainerType"))

            'new fields since version 3
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("PreviousLoc").Replace(":", ""), "PreviousLoc"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("UnitDateNotes").Replace(":", ""), "UnitDateNotes"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("UnitDateBulk").Replace(":", ""), "UnitDateBulk"))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("CompleteUnitId").Replace(":", ""), "CompleteUnitId"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("OtherDescriptiveData").Replace(":", ""), "OtherDescriptiveData"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("DescRules").Replace(":", ""), "DescRules"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("ProcessInfo").Replace(":", ""), "ProcessInfo"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("ProcessInfoName").Replace(":", ""), "ProcessInfoName"))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("ProcessInfoDate").Replace(":", ""), "ProcessInfoDate"))


            .Sorted = True
            .SelectedIndex = 0
        End With

    End Sub


    Public Property ButtonType() As TypeOfButton
        Get
            Return myButtonType
        End Get
        Set(ByVal Value As TypeOfButton)
            myButtonType = Value
            If myButtonType = TypeOfButton.Add Then
                AddRemoveButton.ButtonImage = ButtonImageList.Images(0)
            Else
                AddRemoveButton.ButtonImage = ButtonImageList.Images(1)
            End If
        End Set
    End Property


    Private Sub txtSearchValue_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtSearchValue.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            RaiseEvent EnterKeyPressed(sender, e)
        End If
    End Sub

    Public Sub RemoveSearchItem(ByVal ItemValue As String)
        Dim FoundComboItem As ComboBoxImageItem = Nothing
        For Each ComboBoxImageItem As ComboBoxImageItem In FieldNameComboBox.Items
            If ComboBoxImageItem.Value.Equals(ItemValue) Then
                FoundComboItem = ComboBoxImageItem
                Exit For
            End If
        Next
        If Not FoundComboItem Is Nothing Then
            FieldNameComboBox.Items.Remove(FoundComboItem)
            FieldNameComboBox.SelectedIndex = 0
        End If
    End Sub

    Private Overloads Sub txtSearchValue_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearchValue.TextChanged
        RaiseEvent InputDataChanged(Me, e)
    End Sub

    Private Sub QueryTypeComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QueryTypeComboBox.SelectedIndexChanged
        RaiseEvent InputDataChanged(Me, e)

    End Sub

    Private Sub FieldNameComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FieldNameComboBox.SelectedIndexChanged
        RaiseEvent InputDataChanged(Me, e)
    End Sub
End Class
