
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.UserControls
Imports Digitarq.Utility
Imports System.Threading

Public Class SearchResults
    Inherits System.Windows.Forms.UserControl

    Public Event Preview(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event EditClicked(ByVal sender As System.Object, ByVal e As System.EventArgs)

    Private myLazyNodes As New LazyNodeCollection
    Private SearchResultsLoaderThread As Thread


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ListView As System.Windows.Forms.ListView
    Friend WithEvents chOtherLevel As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitId As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitTitle As System.Windows.Forms.ColumnHeader
    Friend WithEvents chID As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitDateInitial As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitDateFinal As System.Windows.Forms.ColumnHeader
    Friend WithEvents OtherLevelIcons As System.Windows.Forms.ImageList
    Friend WithEvents IconsImageList As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(SearchResults))
        Me.ListView = New System.Windows.Forms.ListView
        Me.chOtherLevel = New System.Windows.Forms.ColumnHeader
        Me.chUnitId = New System.Windows.Forms.ColumnHeader
        Me.chUnitTitle = New System.Windows.Forms.ColumnHeader
        Me.chUnitDateInitial = New System.Windows.Forms.ColumnHeader
        Me.chUnitDateFinal = New System.Windows.Forms.ColumnHeader
        Me.chID = New System.Windows.Forms.ColumnHeader
        Me.OtherLevelIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.IconsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.SuspendLayout()
        '
        'ListView
        '
        Me.ListView.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.ListView.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chOtherLevel, Me.chUnitId, Me.chUnitTitle, Me.chUnitDateInitial, Me.chUnitDateFinal, Me.chID})
        Me.ListView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ListView.FullRowSelect = True
        Me.ListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.ListView.LargeImageList = Me.OtherLevelIcons
        Me.ListView.Location = New System.Drawing.Point(0, 0)
        Me.ListView.MultiSelect = False
        Me.ListView.Name = "ListView"
        Me.ListView.Size = New System.Drawing.Size(672, 216)
        Me.ListView.SmallImageList = Me.OtherLevelIcons
        Me.ListView.TabIndex = 28
        Me.ListView.View = System.Windows.Forms.View.Details
        '
        'chOtherLevel
        '
        Me.chOtherLevel.Text = ""
        Me.chOtherLevel.Width = 20
        '
        'chUnitId
        '
        Me.chUnitId.Text = "Referncia"
        Me.chUnitId.Width = 186
        '
        'chUnitTitle
        '
        Me.chUnitTitle.Text = "Ttulo"
        Me.chUnitTitle.Width = 284
        '
        'chUnitDateInitial
        '
        Me.chUnitDateInitial.Text = "Data inicial"
        Me.chUnitDateInitial.Width = 80
        '
        'chUnitDateFinal
        '
        Me.chUnitDateFinal.Text = "Data final"
        Me.chUnitDateFinal.Width = 80
        '
        'chID
        '
        Me.chID.Text = "ID"
        Me.chID.Width = 0
        '
        'OtherLevelIcons
        '
        Me.OtherLevelIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.OtherLevelIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherLevelIcons.ImageStream = CType(resources.GetObject("OtherLevelIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherLevelIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'IconsImageList
        '
        Me.IconsImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.IconsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'SearchResults
        '
        Me.Controls.Add(Me.ListView)
        Me.Name = "SearchResults"
        Me.Size = New System.Drawing.Size(672, 216)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Public Sub Add(ByVal LazyNodes As LazyNodeCollection)
        For Each LazyNode As LazyNode In LazyNodes
            myLazyNodes.Add(LazyNode)
        Next
    End Sub


    Public Sub Add(ByVal LazyNode As LazyNode)
        myLazyNodes.Add(LazyNode)
    End Sub



    Public Property SearchResultItems() As LazyNodeCollection
        Get
            Return myLazyNodes
        End Get
        Set(ByVal Value As LazyNodeCollection)
            myLazyNodes = Value
        End Set
    End Property



    Public ReadOnly Property Count() As Integer
        Get
            Return myLazyNodes.Count
        End Get
    End Property



    Private Sub BackgroundReload()
        ListView.Items.Clear()

        Dim LazyNode As LazyNode
        Try

            For Each LazyNode In myLazyNodes
                Dim Row As New ListViewItem("", LazyNode.OtherLevelIndex)
                Row.UseItemStyleForSubItems = False

                Dim Icon As New ListViewItem.ListViewSubItem(Row, "")

                Dim UnitId As New ListViewItem.ListViewSubItem(Row, LazyNode.UnitId)
                Dim UnitTitle As New ListViewItem.ListViewSubItem(Row, LazyNode.UnitTitle)
                Dim UnitDateInitial As New ListViewItem.ListViewSubItem(Row, LazyNode.UnitDateInitial)
                Dim UnitDateFinal As New ListViewItem.ListViewSubItem(Row, LazyNode.UnitDateFinal)
                Dim ID As New ListViewItem.ListViewSubItem(Row, IntToStr(CInt(LazyNode.ID)))

                Row.SubItems.Add(UnitId)
                Row.SubItems.Add(UnitTitle)
                Row.SubItems.Add(UnitDateInitial)
                Row.SubItems.Add(UnitDateFinal)
                Row.SubItems.Add(ID)

                ListView.Items.Add(Row)
            Next
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
        End Try

    End Sub

    Public Sub LoadResults()
        If Not SearchResultsLoaderThread Is Nothing AndAlso SearchResultsLoaderThread.ThreadState = ThreadState.Running Then
            SearchResultsLoaderThread.Suspend()
            SearchResultsLoaderThread = Nothing
        End If

        If SearchResultsLoaderThread Is Nothing OrElse Not SearchResultsLoaderThread.ThreadState = ThreadState.Running Then
            SearchResultsLoaderThread = New Thread(AddressOf BackgroundReload)
        End If

        SearchResultsLoaderThread.Start()

    End Sub



    Public ReadOnly Property SelectedItemID() As Integer
        Get
            If ListView.SelectedItems.Count = 0 Then
                Return -1
            Else
                Dim item As ListViewItem.ListViewSubItem = ListView.SelectedItems(0).SubItems(5)
                Return CInt(item.Text())
            End If
        End Get
    End Property


    Private Sub ListView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView.SelectedIndexChanged
        If ListView.SelectedItems.Count = 1 Then
            RaiseEvent Preview(sender, e)
        End If
    End Sub

    Private Sub SearchResults_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView.DoubleClick
        If ListView.SelectedItems.Count = 1 Then
            RaiseEvent EditClicked(sender, e)
        End If
    End Sub
End Class
