Imports DigitArq.UserControls.CustomUserControls
Imports DigitArq.Utility
Imports DigitArq.Utility.DataCleansing


Public Class SpecificSearchField
    Inherits System.Windows.Forms.UserControl

    Public Event AddButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event EnterKeyPressed(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Event InputValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    Private myFieldName As String


    Public Shared QUERY_CONTAINS As String = "Contains"
    Public Shared QUERY_NOTCONTAINS As String = "NotContains"
    Public Shared QUERY_BEGINSWITH As String = "BeginsWith"
    Public Shared QUERY_ENDSWITH As String = "EndsWith"
    Public Shared QUERY_EQUALS As String = "Equals"

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents QueryTypeComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents txtSearchValue As System.Windows.Forms.TextBox
    Friend WithEvents lblFieldName As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtSearchValue = New System.Windows.Forms.TextBox
        Me.QueryTypeComboBox = New System.Windows.Forms.ComboBox
        Me.lblFieldName = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'txtSearchValue
        '
        Me.txtSearchValue.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtSearchValue.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSearchValue.Location = New System.Drawing.Point(253, 0)
        Me.txtSearchValue.Name = "txtSearchValue"
        Me.txtSearchValue.Size = New System.Drawing.Size(299, 20)
        Me.txtSearchValue.TabIndex = 2
        Me.txtSearchValue.Text = ""
        '
        'QueryTypeComboBox
        '
        Me.QueryTypeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.QueryTypeComboBox.Items.AddRange(New Object() {"Contm", "No contm", "Comea por", "Termina em", " igual a"})
        Me.QueryTypeComboBox.Location = New System.Drawing.Point(160, 0)
        Me.QueryTypeComboBox.Name = "QueryTypeComboBox"
        Me.QueryTypeComboBox.Size = New System.Drawing.Size(88, 21)
        Me.QueryTypeComboBox.TabIndex = 1
        '
        'lblFieldName
        '
        Me.lblFieldName.Location = New System.Drawing.Point(0, 0)
        Me.lblFieldName.Name = "lblFieldName"
        Me.lblFieldName.Size = New System.Drawing.Size(152, 20)
        Me.lblFieldName.TabIndex = 0
        Me.lblFieldName.Text = "Label1"
        '
        'SpecificSearchField
        '
        Me.Controls.Add(Me.lblFieldName)
        Me.Controls.Add(Me.txtSearchValue)
        Me.Controls.Add(Me.QueryTypeComboBox)
        Me.Name = "SpecificSearchField"
        Me.Size = New System.Drawing.Size(560, 24)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        RaiseEvent AddButtonClick(sender, e)
    End Sub


    Public Property FieldName() As String
        Get
            Return myFieldName
        End Get
        Set(ByVal Value As String)
            myFieldName = Value
            lblFieldName.Text = VisualFieldLabel(myFieldName)
        End Set
    End Property


    Public ReadOnly Property QueryType() As String
        Get
            Return Me.QueryTypeComboBox.SelectedText
        End Get
    End Property

    Public ReadOnly Property FieldValue() As String
        Get
            Return Me.txtSearchValue.Text
        End Get
    End Property



    Public ReadOnly Property SQLSearchTerm() As String
        Get
            If FieldValue.Length = 0 Then Return Nothing

            Dim SearchTerm As String = Nothing
            Dim SelectedItem As ComboBoxImageItem = CType(QueryTypeComboBox.SelectedItem, ComboBoxImageItem)
            Dim SelectedQueryType As String = SelectedItem.Value

            If (SelectedQueryType.Equals(QUERY_CONTAINS)) Then
                SearchTerm = String.Format("CONTAINS({0}, '{1}')", FieldName, PrepareContainsSearchCondition(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_BEGINSWITH)) Then
                SearchTerm = String.Format("CONTAINS({0}, '{1}*')", FieldName, CleanRawSearchCondition(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_ENDSWITH)) Then
                SearchTerm = String.Format("CONTAINS({0}, '*{1}')", FieldName, CleanRawSearchCondition(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_EQUALS)) Then
                'SearchTerm = String.Format("CONTAINS({0}, '""{1}""')", FieldName, CleanRawSearchCondition(FieldValue))
                SearchTerm = String.Format("{0} LIKE '{1}'", FieldName, StrToDB(FieldValue))
            ElseIf (SelectedQueryType.Equals(QUERY_NOTCONTAINS)) Then
                SearchTerm = String.Format("NOT CONTAINS({0}, '{1}')", FieldName, PrepareContainsSearchCondition(FieldValue, " OR "))
            End If

            Return SearchTerm
        End Get
    End Property


    Private Sub SpecificSearchField_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadQueryTypeComboBox()
    End Sub

    Private Sub LoadQueryTypeComboBox()
        QueryTypeComboBox.Items.Clear()
        With QueryTypeComboBox
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.Contains"), QUERY_CONTAINS))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.NotContains"), QUERY_NOTCONTAINS))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.BeginsWith"), QUERY_BEGINSWITH))
            '.Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.EndsWith"), QUERY_ENDSWITH))
            .Items.Add(New ComboBoxImageItem(VisualFieldLabel("Search.Equals"), QUERY_EQUALS))
            .SelectedIndex = 0
        End With

    End Sub


    Private Sub txtSearchValue_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtSearchValue.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            RaiseEvent EnterKeyPressed(sender, e)
        End If
    End Sub


    Private Sub txtSearchValue_TextChanged(ByVal sender As Object, ByVal e As EventArgs) Handles txtSearchValue.TextChanged
        RaiseEvent InputValueChanged(sender, e)
    End Sub

End Class
