Imports System.IO
Imports System.Windows.Forms
Imports System.Drawing
Imports DigitArq.UserControls.ImageButton

Public Class ImageViewer
    Inherits System.Windows.Forms.UserControl
    Implements Viewer


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub


    Public Sub New(ByVal Filename As String, ByVal Format As String)
        MyBase.New()
        myFormat = Format
        myFilename = Filename
        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    Public Sub New(ByRef File As Byte(), ByVal Format As String, Optional ByVal Filename As String = "")
        MyBase.New()
        myFile = File
        myFormat = Format
        myFilename = Filename
        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub


    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ToolbarPanel As System.Windows.Forms.Panel
    Friend WithEvents ScrollablePictureBox As ScrollablePictureBox.ScrollablePictureBox
    Friend WithEvents AdjustedSizeImageButton As ImageButton.ImageButton
    Friend WithEvents FullSizeImageButton As ImageButton.ImageButton
    Friend WithEvents ZoomInImageButton As ImageButton.ImageButton
    Friend WithEvents ZoomOutImageButton As ImageButton.ImageButton
    Friend WithEvents SaveFileDialog As System.Windows.Forms.SaveFileDialog
    Friend WithEvents SaveImageButton As ImageButton.ImageButton
    Friend WithEvents ToolTip As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ImageViewer))
        Me.ToolbarPanel = New System.Windows.Forms.Panel
        Me.SaveImageButton = New ImageButton.ImageButton
        Me.ZoomInImageButton = New ImageButton.ImageButton
        Me.ZoomOutImageButton = New ImageButton.ImageButton
        Me.FullSizeImageButton = New ImageButton.ImageButton
        Me.AdjustedSizeImageButton = New ImageButton.ImageButton
        Me.ScrollablePictureBox = New ScrollablePictureBox.ScrollablePictureBox
        Me.SaveFileDialog = New System.Windows.Forms.SaveFileDialog
        Me.ToolTip = New System.Windows.Forms.ToolTip(Me.components)
        Me.ToolbarPanel.SuspendLayout()
        Me.SuspendLayout()
        '
        'ToolbarPanel
        '
        Me.ToolbarPanel.Controls.Add(Me.SaveImageButton)
        Me.ToolbarPanel.Controls.Add(Me.ZoomInImageButton)
        Me.ToolbarPanel.Controls.Add(Me.ZoomOutImageButton)
        Me.ToolbarPanel.Controls.Add(Me.FullSizeImageButton)
        Me.ToolbarPanel.Controls.Add(Me.AdjustedSizeImageButton)
        Me.ToolbarPanel.Dock = System.Windows.Forms.DockStyle.Top
        Me.ToolbarPanel.Location = New System.Drawing.Point(0, 0)
        Me.ToolbarPanel.Name = "ToolbarPanel"
        Me.ToolbarPanel.Size = New System.Drawing.Size(620, 44)
        Me.ToolbarPanel.TabIndex = 0
        '
        'SaveImageButton
        '
        Me.SaveImageButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.SaveImageButton.BorderColor = System.Drawing.SystemColors.Control
        Me.SaveImageButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SaveImageButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SaveImageButton.ButtonImage = CType(resources.GetObject("SaveImageButton.ButtonImage"), System.Drawing.Image)
        Me.SaveImageButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SaveImageButton.ButtonShowShadow = True
        Me.SaveImageButton.ButtonText = ""
        Me.SaveImageButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.SaveImageButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SaveImageButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.SaveImageButton.Location = New System.Drawing.Point(580, 10)
        Me.SaveImageButton.Name = "SaveImageButton"
        Me.SaveImageButton.Size = New System.Drawing.Size(24, 24)
        Me.SaveImageButton.TabIndex = 6
        Me.SaveImageButton.ToolTip = "Salvar"
        '
        'ZoomInImageButton
        '
        Me.ZoomInImageButton.BorderColor = System.Drawing.SystemColors.Control
        Me.ZoomInImageButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ZoomInImageButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.ZoomInImageButton.ButtonImage = CType(resources.GetObject("ZoomInImageButton.ButtonImage"), System.Drawing.Image)
        Me.ZoomInImageButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.ZoomInImageButton.ButtonShowShadow = True
        Me.ZoomInImageButton.ButtonText = ""
        Me.ZoomInImageButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.ZoomInImageButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.ZoomInImageButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.ZoomInImageButton.Location = New System.Drawing.Point(124, 10)
        Me.ZoomInImageButton.Name = "ZoomInImageButton"
        Me.ZoomInImageButton.Size = New System.Drawing.Size(24, 24)
        Me.ZoomInImageButton.TabIndex = 4
        Me.ZoomInImageButton.ToolTip = "Aumentar"
        '
        'ZoomOutImageButton
        '
        Me.ZoomOutImageButton.BorderColor = System.Drawing.SystemColors.Control
        Me.ZoomOutImageButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ZoomOutImageButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.ZoomOutImageButton.ButtonImage = CType(resources.GetObject("ZoomOutImageButton.ButtonImage"), System.Drawing.Image)
        Me.ZoomOutImageButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.ZoomOutImageButton.ButtonShowShadow = True
        Me.ZoomOutImageButton.ButtonText = ""
        Me.ZoomOutImageButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.ZoomOutImageButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.ZoomOutImageButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.ZoomOutImageButton.Location = New System.Drawing.Point(87, 10)
        Me.ZoomOutImageButton.Name = "ZoomOutImageButton"
        Me.ZoomOutImageButton.Size = New System.Drawing.Size(24, 24)
        Me.ZoomOutImageButton.TabIndex = 3
        Me.ZoomOutImageButton.ToolTip = "Diminuir"
        '
        'FullSizeImageButton
        '
        Me.FullSizeImageButton.BorderColor = System.Drawing.SystemColors.Control
        Me.FullSizeImageButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FullSizeImageButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.FullSizeImageButton.ButtonImage = CType(resources.GetObject("FullSizeImageButton.ButtonImage"), System.Drawing.Image)
        Me.FullSizeImageButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.FullSizeImageButton.ButtonShowShadow = True
        Me.FullSizeImageButton.ButtonText = ""
        Me.FullSizeImageButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.FullSizeImageButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.FullSizeImageButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.FullSizeImageButton.Location = New System.Drawing.Point(49, 10)
        Me.FullSizeImageButton.Name = "FullSizeImageButton"
        Me.FullSizeImageButton.Size = New System.Drawing.Size(24, 24)
        Me.FullSizeImageButton.TabIndex = 2
        Me.FullSizeImageButton.ToolTip = "Ver imagem no tamanho original"
        '
        'AdjustedSizeImageButton
        '
        Me.AdjustedSizeImageButton.BorderColor = System.Drawing.SystemColors.Control
        Me.AdjustedSizeImageButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AdjustedSizeImageButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AdjustedSizeImageButton.ButtonImage = CType(resources.GetObject("AdjustedSizeImageButton.ButtonImage"), System.Drawing.Image)
        Me.AdjustedSizeImageButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AdjustedSizeImageButton.ButtonShowShadow = True
        Me.AdjustedSizeImageButton.ButtonText = ""
        Me.AdjustedSizeImageButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AdjustedSizeImageButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AdjustedSizeImageButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.AdjustedSizeImageButton.Location = New System.Drawing.Point(12, 10)
        Me.AdjustedSizeImageButton.Name = "AdjustedSizeImageButton"
        Me.AdjustedSizeImageButton.Size = New System.Drawing.Size(24, 24)
        Me.AdjustedSizeImageButton.TabIndex = 0
        Me.AdjustedSizeImageButton.ToolTip = "Ajustar imagem  largura"
        '
        'ScrollablePictureBox
        '
        Me.ScrollablePictureBox.AutoScroll = True
        Me.ScrollablePictureBox.BackColor = System.Drawing.Color.White
        Me.ScrollablePictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.ScrollablePictureBox.Cursor = System.Windows.Forms.Cursors.NoMove2D
        Me.ScrollablePictureBox.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ScrollablePictureBox.Image = Nothing
        Me.ScrollablePictureBox.Location = New System.Drawing.Point(0, 44)
        Me.ScrollablePictureBox.Name = "ScrollablePictureBox"
        Me.ScrollablePictureBox.Size = New System.Drawing.Size(620, 464)
        Me.ScrollablePictureBox.TabIndex = 1
        '
        'ImageViewer
        '
        Me.Controls.Add(Me.ScrollablePictureBox)
        Me.Controls.Add(Me.ToolbarPanel)
        Me.Name = "ImageViewer"
        Me.Size = New System.Drawing.Size(620, 508)
        Me.ToolbarPanel.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Public Shared myFormats As String() = {"TIFF", "TIF", "JPG", "JPEG", "PNG", "GIF"}
    Private myFile As Byte()
    Private myFormat As String
    Private myFilename As String

#End Region

#Region "Buttons event handlers"

    Private Sub AdjustedSizeImageButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AdjustedSizeImageButton.Click
        Me.ScrollablePictureBox.AdjustImageSize()
    End Sub

    Private Sub FullSizeImageButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FullSizeImageButton.Click
        Me.ScrollablePictureBox.OriginalImageSize()
    End Sub

    Private Sub ZoomOutImageButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomOutImageButton.Click
        Me.ScrollablePictureBox.ZoomOut()
    End Sub

    Private Sub ZoomInImageButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomInImageButton.Click
        Me.ScrollablePictureBox.ZoomIn()
    End Sub

    Private Sub SaveImageButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveImageButton.Click
        Me.SaveFileDialog.Filter = "Ficheiros TIF (*.tif,*.tiff)|*.tif;*.tiff|Ficheiros JPEG (*.jpg)|*.jpg|Todos ficheiros (*.*)|*.*"
        Select Case myFormat
            Case "TIFF", "TIF"
                Me.SaveFileDialog.FilterIndex = 1
            Case "JPEG", "JPG"
                Me.SaveFileDialog.FilterIndex = 2
            Case Else
                Me.SaveFileDialog.FilterIndex = 3
        End Select
        If Not Me.Image Is Nothing Then
            If Me.SaveFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String = Me.SaveFileDialog.FileName
                Dim FileStream As New FileStream(Filename, FileMode.Create)
                Dim BinaryWriter As BinaryWriter = New BinaryWriter(FileStream)
                BinaryWriter.Write(myFile, 0, myFile.Length)
                FileStream.Close()
                BinaryWriter.Close()
            End If
        End If
    End Sub

#End Region

#Region "Public properties and functions"

    Property Image() As System.Drawing.Image
        Get
            Return Me.ScrollablePictureBox.Image
        End Get
        Set(ByVal Value As System.Drawing.Image)
            Me.ScrollablePictureBox.Image = Value
        End Set
    End Property

    Property SaveImageButtonVisible() As Boolean
        Get
            Return Me.SaveImageButton.Visible
        End Get
        Set(ByVal Value As Boolean)
            Me.SaveImageButton.Visible = Value
        End Set
    End Property

    Public Sub AdjustImageSize()
        Me.ScrollablePictureBox.AdjustImageSize()
    End Sub

    Property Filename() As String
        Get
            Return myFilename
        End Get
        Set(ByVal Value As String)
            myFilename = Value
        End Set
    End Property

    Public ReadOnly Property Formats() As ArrayList Implements Viewer.Formats
        Get
            Return New ArrayList(myFormats)
        End Get
    End Property

    Public Function CanDisplay() As Boolean Implements Viewer.CanDisplay
        Return Formats.Contains(myFormat)
    End Function

    Public Sub Display() Implements Viewer.Display
        Dim Image As System.Drawing.Image
        Dim Stream As Stream = New MemoryStream(myFile)
        Me.Image = Image.FromStream(Stream)
        'Me.Image = Image.FromFile(myFilename, True)
        Me.AdjustImageSize()
        Stream.Close()
    End Sub

    Public Sub Close() Implements Viewer.Close

    End Sub

    Private Function GetFormat(ByVal FileName As String) As String
        Return FileName.Substring(FileName.LastIndexOf(".") + 1).ToUpper()
    End Function

#End Region

   

End Class