Imports System.IO

Public Class PDFViewer
    Inherits System.Windows.Forms.UserControl
    Implements Viewer

#Region " Windows Form Designer generated code "

    Private Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    Public Sub New(ByRef File As Byte(), ByVal Format As String)
        MyBase.New()
        myFile = File
        myFormat = Format
        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    'Friend WithEvents AxAcroPDF As AxAcroPDFLib.AxAcroPDF
    'Friend WithEvents AxAcroPDF As AxAcroPDFLib.AxAcroPDF
    Friend WithEvents AxAcroPDF As AxAcroPDFLib.AxAcroPDF
    Friend WithEvents FolderBrowserDialog1 As System.Windows.Forms.FolderBrowserDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Try
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(PDFViewer))
            Me.AxAcroPDF = New AxAcroPDFLib.AxAcroPDF
            Me.FolderBrowserDialog1 = New System.Windows.Forms.FolderBrowserDialog
            CType(Me.AxAcroPDF, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'AxAcroPDF
            '
            Me.AxAcroPDF.Dock = System.Windows.Forms.DockStyle.Fill
            Me.AxAcroPDF.Enabled = True
            Me.AxAcroPDF.Location = New System.Drawing.Point(0, 0)
            Me.AxAcroPDF.Name = "AxAcroPDF"
            Me.AxAcroPDF.OcxState = CType(resources.GetObject("AxAcroPDF.OcxState"), System.Windows.Forms.AxHost.State)
            Me.AxAcroPDF.Size = New System.Drawing.Size(496, 376)
            Me.AxAcroPDF.TabIndex = 0
            '
            'PDFViewer
            '
            Me.Controls.Add(Me.AxAcroPDF)
            Me.Name = "PDFViewer"
            Me.Size = New System.Drawing.Size(496, 376)
            CType(Me.AxAcroPDF, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)
            myInitializedComponent = True
        Catch ex As Exception
            myInitializedComponent = False
        End Try
    End Sub

#End Region

#Region "Private properties"

    Private myFormats As String() = {"PDF"}
    Private myFile As Byte()
    Private myFormat As String
    Private myFilename As String
    Private myInitializedComponent As Boolean

#End Region
    
#Region "Public properties"

    ReadOnly Property Formats() As ArrayList Implements Viewer.Formats
        Get
            Return New ArrayList(myFormats)
        End Get
    End Property

#End Region

    Private Overloads Function LoadFile(ByVal FileName As String) As Boolean
        Return Me.AxAcroPDF.LoadFile(FileName)
    End Function

    Public Function CanDisplay() As Boolean Implements Viewer.CanDisplay
        Return Formats.Contains(myFormat) 'And myInitializedComponent
    End Function

    Public Sub Display() Implements Viewer.Display
        myFilename = System.IO.Path.GetTempFileName()
        myFilename = String.Format("{0}\{1}.{2}", Path.GetDirectoryName(myFilename), Path.GetFileNameWithoutExtension(myFilename), "PDF")
        Dim TempStream As New FileStream(myFilename, FileMode.Create)
        Dim BinaryWriter As BinaryWriter = New BinaryWriter(TempStream)
        BinaryWriter.Write(myFile, 0, myFile.Length)
        TempStream.Close()
        BinaryWriter.Close()
        LoadFile(myFilename)
    End Sub

    Public Sub Close() Implements Viewer.Close
        Me.AxAcroPDF.Dispose()
        DeleteTempFile()
    End Sub

    Private Sub DeleteTempFile()
        If File.Exists(myFilename) Then
            File.Delete(myFilename)
        End If
    End Sub

    Private Sub PDFViewer_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Disposed
        Me.AxAcroPDF.Dispose()
    End Sub

End Class
