Imports AxWMPLib


Public Class VideoViewer
    Inherits System.Windows.Forms.UserControl
    Implements Viewer

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    Public Sub New(ByRef URL As String, ByVal Format As String)
        MyBase.New()
        InitializeComponent()
        myFilename = URL
        myFormat = Format
    End Sub


    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Player As AxWMPLib.AxWindowsMediaPlayer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(VideoViewer))
        Me.Player = New AxWMPLib.AxWindowsMediaPlayer
        CType(Me.Player, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Player
        '
        Me.Player.Dock = System.Windows.Forms.DockStyle.Fill
        Me.Player.Enabled = True
        Me.Player.Location = New System.Drawing.Point(0, 0)
        Me.Player.Name = "Player"
        Me.Player.OcxState = CType(resources.GetObject("Player.OcxState"), System.Windows.Forms.AxHost.State)
        Me.Player.Size = New System.Drawing.Size(568, 464)
        Me.Player.TabIndex = 3
        '
        'VideoViewer
        '
        Me.Controls.Add(Me.Player)
        Me.Name = "VideoViewer"
        Me.Size = New System.Drawing.Size(568, 464)
        CType(Me.Player, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Public Shared myFormats As String() = {"FLV", "MP3"}
    Private myFile As Byte()
    Private myFormat As String
    Private myFilename As String

#End Region

#Region "Public properties and functions"

    Property Filename() As String
        Get
            Return myFilename
        End Get
        Set(ByVal Value As String)
            myFilename = Value
        End Set
    End Property

    Public ReadOnly Property Formats() As ArrayList Implements Viewer.Formats
        Get
            Return New ArrayList(myFormats)
        End Get
    End Property

    Public Function CanDisplay() As Boolean Implements Viewer.CanDisplay
        Return Formats.Contains(myFormat)
    End Function

    Public Sub Display() Implements Viewer.Display
        Player.URL = myFilename
        Player.Ctlcontrols.play()
    End Sub

    Public Sub Close() Implements Viewer.Close
        Player.close()
    End Sub

    Private Function GetFormat(ByVal FileName As String) As String
        Return FileName.Substring(FileName.LastIndexOf(".") + 1).ToUpper()
    End Function

#End Region

End Class
