Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.IO


Public Class WordViewer
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'WordViewer
        '
        Me.Name = "WordViewer"
        Me.Size = New System.Drawing.Size(552, 424)

    End Sub

#End Region

#Region "API usage declarations"

    <DllImport("user32.dll")> _
    Public Shared Function FindWindow(ByVal strclassName As String, ByVal strWindowName As String) As Integer
    End Function

    <DllImport("user32.dll")> _
    Shared Function SetParent(ByVal hWndChild As Integer, ByVal hWndNewParent As Integer) As Integer
    End Function

    <DllImport("user32.dll", EntryPoint:="SetWindowPos")> _
      Shared Function SetWindowPos(ByVal hWnd As Integer, _
          ByVal hWndInsertAfter As Integer, _
          ByVal X As Integer, _
          ByVal Y As Integer, _
          ByVal cx As Integer, _
          ByVal cy As Integer, _
          ByVal uflags As UInt32 _
          ) As Boolean
    End Function

    <DllImport("user32.dll", EntryPoint:="MoveWindow")> _
    Shared Function MoveWindow(ByVal hWnd As Integer, ByVal X As Integer, _
        ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, _
        ByVal bRepaint As Boolean) As Boolean
    End Function

    <DllImport("user32.dll", EntryPoint:="DrawMenuBar")> _
    Shared Function DrawMenuBar(ByVal hWnd As Int32) As Int32
    End Function

    <DllImport("user32.dll", EntryPoint:="GetMenuItemCount")> _
    Shared Function GetMenuItemCount(ByVal hMenu As Int32) As Int32
    End Function

    <DllImport("user32.dll", EntryPoint:="GetSystemMenu")> _
    Shared Function GetSystemMenu(ByVal hWnd As Int32, ByVal bRevert As Boolean) As Int32
    End Function

    <DllImport("user32.dll", EntryPoint:="RemoveMenu")> _
    Shared Function RemoveMenu(ByVal hMenu As Int32, ByVal nPosition As Int32, ByVal wFlags As Int32) As Integer
    End Function

    Private Const MF_BYPOSITION As Integer = &H400
    Private Const MF_REMOVE As Integer = &H1000

    Const SWP_DRAWFRAME As Integer = &H20
    Const SWP_NOMOVE As Integer = &H2
    Const SWP_NOSIZE As Integer = &H1
    Const SWP_NOZORDER As Integer = &H4

#End Region

#Region "Private properties"

    Public WordDocument As Word.Document
    Public WordClass As Word.ApplicationClass = Nothing
    Public wordWnd As Integer = 0
    Public myFilename As String = Nothing
    Private DeactivateEvents As Boolean = False
    Private component As System.ComponentModel.Container = Nothing
    Private Formats As String() = {"DOC"}
    Private SupportedFormats As New ArrayList(Formats)

#End Region
    
#Region "Public properties and functions"

    Public Function CanDisplay(ByVal Format As String) As Boolean
        Return SupportedFormats.Contains(Format)
    End Function

    Public Sub Display(ByVal BLOB As Byte())
        Dim TempFileName As String = System.IO.Path.GetTempFileName()
        TempFileName = String.Format("{0}\{1}.{2}", Path.GetDirectoryName(TempFileName), Path.GetFileNameWithoutExtension(TempFileName), "DOC")
        Dim FileStream As New FileStream(TempFileName, FileMode.Create)
        Dim BinaryWriter As BinaryWriter = New BinaryWriter(FileStream)
        BinaryWriter.Write(BLOB, 0, BLOB.Length)
        FileStream.Close()
        BinaryWriter.Close()
        LoadDocument(TempFileName)
    End Sub

    Public Sub CloseControl()
        Try
            DeactivateEvents = True
            WordDocument.Close(Nothing, Nothing, Nothing)
            WordClass.Quit(False, Nothing, Nothing)
            DeactivateEvents = False
        Catch ex As Exception
        End Try
    End Sub

    Public Sub EnableComandBars(ByVal value As Boolean)
        Me.WordDocument.ActiveWindow.Application.CommandBars("Menu Bar").Enabled = value
    End Sub


    Public Sub LoadDocument(ByVal Filename As String)
        DeactivateEvents = True
        myFilename = Filename

        If WordClass Is Nothing Then
            WordClass = New Word.ApplicationClass
        End If

        If Not WordDocument Is Nothing Then
            Try
                WordClass.Documents.Close(Nothing, Nothing, Nothing)
            Catch ex As Exception
            End Try
        End If

        If wordWnd = 0 Then
            wordWnd = FindWindow("Opusapp", Nothing)
        End If

        If wordWnd <> 0 Then
            SetParent(wordWnd, Me.Handle.ToInt32())
            Dim file As Object = myFilename
            Dim newtemplate As Object = False
            Dim docType As Object = 0
            Dim [readOnly] As Object = True
            Dim isVisible As Object = True
            Dim missing As Object = System.Reflection.Missing.Value
            Try
                If WordClass Is Nothing Then
                    Throw New WordInstanceException
                End If
                If WordClass.Documents Is Nothing Then
                    Throw New WordInstanceException
                End If
                If Not WordClass Is Nothing And Not WordClass.Documents Is Nothing Then
                    WordDocument = WordClass.Documents.Add(file, newtemplate, docType, isVisible)
                End If
                If WordDocument Is Nothing Then
                    Throw New ValidDocumentException
                End If
            Catch ex As Exception
            End Try

            'Try
            '    WordClass.ActiveWindow.DisplayRightRuler = False
            '    WordClass.ActiveWindow.DisplayScreenTips = False
            '    WordClass.ActiveWindow.DisplayVerticalRuler = False
            '    WordClass.ActiveWindow.DisplayRightRuler = False
            '    WordClass.ActiveWindow.ActivePane.DisplayRulers = False
            '    WordClass.ActiveWindow.ActivePane.View.Type = Word.WdViewType.wdWebView
            'Catch ex As Exception
            'End Try

            Dim counter As Integer = WordClass.ActiveWindow.Application.CommandBars.Count
            For i As Integer = 1 To counter
                Try
                    WordClass.ActiveWindow.Application.CommandBars(i).Visible = False
                Catch ex As Exception
                End Try
            Next
            WordClass.ActiveWindow.Application.CommandBars("Menu Bar").Enabled = False

            Try
                WordClass.Visible = True
                WordClass.Activate()
                SetWindowPos(wordWnd, Me.Handle.ToInt32(), 0, 0, Me.Bounds.Width, Me.Bounds.Height, Convert.ToUInt32(SWP_NOZORDER Or SWP_NOMOVE Or SWP_DRAWFRAME Or SWP_NOSIZE))

            Catch ex As Exception
            End Try

            Me.Parent.Focus()
        End If
        DeactivateEvents = False
        ResizeViewer()
    End Sub

    Private Sub ResizeViewer()
        Dim borderWidth As Integer = SystemInformation.Border3DSize.Width
        Dim borderHeight As Integer = SystemInformation.Border3DSize.Height
        Dim captionHeight As Integer = SystemInformation.CaptionHeight
        Dim statusHeight As Integer = SystemInformation.ToolWindowCaptionHeight
        MoveWindow(wordWnd, -2 * borderWidth, -2 * borderHeight - captionHeight, Me.Bounds.Width + 4 * borderWidth, Me.Bounds.Height + captionHeight + 4 * borderHeight + statusHeight, True)
    End Sub

    Private Sub WordViewer_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ResizeViewer()
    End Sub

#End Region

End Class


Public Class DocumentInstanceException
    Inherits Exception
End Class

Public Class ValidDocumentException
    Inherits Exception
End Class

Public Class WordInstanceException
    Inherits Exception
End Class
