Imports System.IO
Imports System.Threading
Imports System.Text.Encoding
Imports System.Configuration
Imports DigitArq.Utility
Imports DigitArq.Data.Vault.Client
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Data.Entities.MGUP
Imports DigitArq.UserControls.Authentication
Imports DigitArq.UserControls.ImageButton
Imports DigitArq.UserControls.Viewer
Imports DigitArq.UserControls.MetadataDataGrid
Imports DigitArq.UserControls.DragDropListView
Imports DigitArq.UserControls.DigitalObjectsTree
Imports DigitArq.UserControls.ProgressDialog
Imports DigitArq.Data.Vault.Utility
Imports DigitArq.Core.Logging
Imports DigitArq.Definitions.MGOD
Imports DigitArq.Definitions.EAD


Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        AddHandler PublishedDigitalObjectsTree.TreeViewAfterSelect, AddressOf TreeView_AfterSelect
        AddHandler PublishedDigitalObjectsTree.TreeViewBeforeExpand, AddressOf TreeView_BeforeExpand
        AddHandler PublishedDigitalObjectsTree.TreeViewDoubleClick, AddressOf TreeView_DoubleClick
        AddHandler PublishedDigitalObjectsTree.TreeViewAfterLabelEdit, AddressOf TreeView_AfterLabelEdit
        AddHandler PublishedDigitalObjectsTree.TreeViewDragDrop, AddressOf TreeView_DragDrop
        AddHandler PublishedDigitalObjectsTree.InsertItems, AddressOf InsertItems
        AddHandler PublishedDigitalObjectsTree.PasteItems, AddressOf PasteItems
        AddHandler PublishedDigitalObjectsTree.MenuItemNewClick, AddressOf MenuItemNew_Click
        AddHandler PublishedDigitalObjectsTree.MenuItemRenameClick, AddressOf MenuItemRename_Click
        AddHandler PublishedDigitalObjectsTree.MenuItemDeleteItemsClick, AddressOf DeleteItems
        AddHandler PublishedDigitalObjectsTree.MenuItemDeleteDigitalObjectsClick, AddressOf DeleteDigitalObjects
        AddHandler PublishedDigitalObjectsTree.MenuItemExportAllFilesClick, AddressOf ExportAllFiles
        AddHandler PublishedDigitalObjectsTree.MenuItemExportDisseminationsClick, AddressOf ExportDisseminations
        AddHandler PublishedDigitalObjectsTree.MenuItemExportOriginalsClick, AddressOf ExportOriginals

        AddHandler UnpublishedDigitalObjectsTree.TreeViewAfterSelect, AddressOf TreeView_AfterSelect
        AddHandler UnpublishedDigitalObjectsTree.TreeViewBeforeExpand, AddressOf TreeView_BeforeExpand
        AddHandler UnpublishedDigitalObjectsTree.TreeViewDoubleClick, AddressOf TreeView_DoubleClick
        AddHandler UnpublishedDigitalObjectsTree.TreeViewAfterLabelEdit, AddressOf TreeView_AfterLabelEdit
        AddHandler UnpublishedDigitalObjectsTree.TreeViewDragDrop, AddressOf TreeView_DragDrop
        AddHandler UnpublishedDigitalObjectsTree.InsertItems, AddressOf InsertItems
        AddHandler UnpublishedDigitalObjectsTree.PasteItems, AddressOf PasteItems
        AddHandler UnpublishedDigitalObjectsTree.MenuItemNewClick, AddressOf MenuItemNew_Click
        AddHandler UnpublishedDigitalObjectsTree.MenuItemRenameClick, AddressOf MenuItemRename_Click
        AddHandler UnpublishedDigitalObjectsTree.MenuItemDeleteItemsClick, AddressOf DeleteItems
        AddHandler UnpublishedDigitalObjectsTree.MenuItemDeleteDigitalObjectsClick, AddressOf DeleteDigitalObjects
        AddHandler UnpublishedDigitalObjectsTree.MenuItemExportAllFilesClick, AddressOf ExportAllFiles
        AddHandler UnpublishedDigitalObjectsTree.MenuItemExportDisseminationsClick, AddressOf ExportDisseminations
        AddHandler UnpublishedDigitalObjectsTree.MenuItemExportOriginalsClick, AddressOf ExportOriginals

        AddHandler DragDropListView.InsertItems, AddressOf InsertItems
        AddHandler DragDropListView.MenuItemDeleteItemsClick, AddressOf DeleteItems
        AddHandler DragDropListView.PasteItems, AddressOf PasteItems
        AddHandler DragDropListView.ListViewDoubleClick, AddressOf ListView_DoubleClick
        AddHandler DragDropListView.SaveButtonClick, AddressOf SaveFilesButton_Click
        AddHandler DragDropListView.AssociationButtonClick, AddressOf AssociationButton_Click

        AddHandler MetadataDataGrid.InsertProperty, AddressOf InsertProperty
        AddHandler MetadataDataGrid.DeleteProperty, AddressOf DeleteProperty
        AddHandler MetadataDataGrid.UpdateProperty, AddressOf UpdateProperty

        Me.InfoGeralGroupBox.Width = Me.MetadataPanel.Width * 0.9
        Me.DatesGroupBox.Width = Me.MetadataPanel.Width * 0.9
        Me.EntitiesGroupBox.Width = Me.MetadataPanel.Width * 0.9
        Me.PreservationGroupBox.Width = Me.MetadataPanel.Width * 0.9
        Me.PreservationGroupBox.Width = Me.PreservationPanel.Width * 0.9

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents miProjects As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents miClose As System.Windows.Forms.MenuItem
    Friend WithEvents miDigitalizationProfiles As System.Windows.Forms.MenuItem
    Friend WithEvents miTechnologicalPlatform As System.Windows.Forms.MenuItem
    Friend WithEvents miRevisionInterval As System.Windows.Forms.MenuItem
    Friend WithEvents miFilesRename As System.Windows.Forms.MenuItem
    Friend WithEvents miPOD As System.Windows.Forms.MenuItem
    Friend WithEvents miReports As System.Windows.Forms.MenuItem
    Friend WithEvents miReportDigitalizationProfiles As System.Windows.Forms.MenuItem
    Friend WithEvents miReportReformattingNorms As System.Windows.Forms.MenuItem
    Friend WithEvents miReportReformattingMethods As System.Windows.Forms.MenuItem
    Friend WithEvents miReportMetaOD As System.Windows.Forms.MenuItem
    Friend WithEvents miReportPreservationInfDO As System.Windows.Forms.MenuItem
    Friend WithEvents miReportImagesDO As System.Windows.Forms.MenuItem
    Friend WithEvents miReportRevisionDO As System.Windows.Forms.MenuItem
    Friend WithEvents miUIDigitalization As System.Windows.Forms.MenuItem
    Friend WithEvents miHelp As System.Windows.Forms.MenuItem
    Friend WithEvents About As System.Windows.Forms.MenuItem
    Friend WithEvents sbMain As System.Windows.Forms.StatusBar
    Friend WithEvents pnlMain As System.Windows.Forms.Panel
    Friend WithEvents miPreferences As System.Windows.Forms.MenuItem
    Friend WithEvents miTools As System.Windows.Forms.MenuItem
    Friend WithEvents pnlTvwContainer As System.Windows.Forms.Panel
    Friend WithEvents OpenFileDialog As System.Windows.Forms.OpenFileDialog
    Friend WithEvents MainMenu As System.Windows.Forms.MainMenu
    Friend WithEvents LeftSplitter As System.Windows.Forms.Splitter
    Friend WithEvents FolderBrowserDialog As System.Windows.Forms.FolderBrowserDialog
    Friend WithEvents TabControlDigitalObjects As System.Windows.Forms.TabControl
    Friend WithEvents miControlledVocabularies As System.Windows.Forms.MenuItem
    Friend WithEvents miSaveDigitalObjectsAs As System.Windows.Forms.MenuItem
    Friend WithEvents miDisseminationSettings As System.Windows.Forms.MenuItem
    Friend WithEvents pnlToolBarTvw As System.Windows.Forms.Panel
    Friend WithEvents UnpublishButton As ImageButton
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents PublishButton As ImageButton
    Friend WithEvents TabControl As System.Windows.Forms.TabControl
    Friend WithEvents tpPreview As System.Windows.Forms.TabPage
    Friend WithEvents PreviewPanel As System.Windows.Forms.Panel
    Friend WithEvents ImageViewer As ImageViewer
    Friend WithEvents RigthSplitter As System.Windows.Forms.Splitter
    Friend WithEvents TechnicalMetadataPanel As System.Windows.Forms.Panel
    Friend WithEvents FooterPreviewPanel As System.Windows.Forms.Panel
    Friend WithEvents tpMetadata As System.Windows.Forms.TabPage
    Friend WithEvents FooterMetadataPanel As System.Windows.Forms.Panel
    Friend WithEvents tpPreservationMetadata As System.Windows.Forms.TabPage
    Friend WithEvents FooterPreservationPanel As System.Windows.Forms.Panel
    Friend WithEvents tpAddFiles As System.Windows.Forms.TabPage
    Friend WithEvents FilesPanel As System.Windows.Forms.Panel
    Friend WithEvents DragDropListView As DragDropListView
    Friend WithEvents MetadataPanel As System.Windows.Forms.Panel
    Friend WithEvents txtArchivingProfile As MGOD.ColorTextBox
    Friend WithEvents txtExternalDescriptiveInfo As MGOD.ColorTextBox
    Friend WithEvents txtPreservationOriginalInformation As MGOD.ColorTextBox
    Friend WithEvents txtArchiveDateTime As MGOD.DateTextBox
    Friend WithEvents txtCreationDateTime As MGOD.DateTextBox
    Friend WithEvents lblRevisionDateTime As System.Windows.Forms.Label
    Friend WithEvents txtDepositDateTime As MGOD.DateTextBox
    Friend WithEvents txtResponsabilityEntity As MGOD.ColorTextBox
    Friend WithEvents txtCaptureEntityCorporate As MGOD.ColorTextBox
    Friend WithEvents PreservationPanel As System.Windows.Forms.Panel
    Friend WithEvents btnHistorical As System.Windows.Forms.Button
    Friend WithEvents btnChooseReformattingNorms As System.Windows.Forms.Button
    Friend WithEvents btnChooseReformattingMethod As System.Windows.Forms.Button
    Friend WithEvents lbxReformattingNormsChoosen As System.Windows.Forms.ListBox
    Friend WithEvents txtReformattingMethod As MGOD.ColorTextBox
    Friend WithEvents txtParameters As MGOD.ColorTextBox
    Friend WithEvents txtInputFormat As MGOD.ColorTextBox
    Friend WithEvents txtRenderEngine As MGOD.ColorTextBox
    Friend WithEvents txtPlatform As MGOD.ColorTextBox
    Friend WithEvents txtTransformer As MGOD.ColorTextBox
    Friend WithEvents lblTransformerObject As System.Windows.Forms.Label
    Friend WithEvents lblInputFormat As System.Windows.Forms.Label
    Friend WithEvents lblRenderEngine As System.Windows.Forms.Label
    Friend WithEvents lblParameters As System.Windows.Forms.Label
    Friend WithEvents lblPlatform As System.Windows.Forms.Label
    Friend WithEvents SearchDigitalObjectButton As ImageButton
    Friend WithEvents AddDigitalObjectButton As ImageButton
    Friend WithEvents RemoveDigitalObjectButton As ImageButton
    Friend WithEvents SavePreservationButton As ImageButton
    Friend WithEvents SaveMetadataButton As ImageButton
    Friend WithEvents AddUnpublishedDigitalObjectButton As ImageButton
    Friend WithEvents RemoveUnpublishedDigitalObjectButton As ImageButton
    Friend WithEvents SearchUnpublishedDigitalObjectButton As ImageButton
    Friend WithEvents PublishedDigitalObjectsTabPage As System.Windows.Forms.TabPage
    Friend WithEvents UnpublishedDigitalObjectsTabPage As System.Windows.Forms.TabPage
    Friend WithEvents SavePreviewButton As ImageButton
    Friend WithEvents DatesGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents miViewOriginal As System.Windows.Forms.MenuItem
    Friend WithEvents miViewDissemination As System.Windows.Forms.MenuItem
    Friend WithEvents miViewThumbnail As System.Windows.Forms.MenuItem
    Friend WithEvents miViewTechnicalMatadata As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents lblReformattingNorms As System.Windows.Forms.Label
    Friend WithEvents lblReformattingMethod As System.Windows.Forms.Label
    Friend WithEvents DigitalObjectsImageList As System.Windows.Forms.ImageList
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    Friend WithEvents TvwDigitalObjectsImageList As System.Windows.Forms.ImageList
    Friend WithEvents ViewMenuItem As System.Windows.Forms.MenuItem
    Friend WithEvents ExternalDescriptiveInfoLabel As System.Windows.Forms.Label
    Friend WithEvents PreservationOriginalInformationLabel As System.Windows.Forms.Label
    Friend WithEvents ArchivingProfileLabel As System.Windows.Forms.Label
    Friend WithEvents RevisionDateTimeLabel As System.Windows.Forms.Label
    Friend WithEvents DepositDateTimeLabel As System.Windows.Forms.Label
    Friend WithEvents CreationDateTimeLabel As System.Windows.Forms.Label
    Friend WithEvents ArchiveDateTimeLabel As System.Windows.Forms.Label
    Friend WithEvents ResponsabilityEntityLabel As System.Windows.Forms.Label
    Friend WithEvents CaptureEntityCorporateLabel As System.Windows.Forms.Label
    Friend WithEvents PreservationGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents EntitiesGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents InfoGeralGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents txtName As MGOD.ColorTextBox
    Friend WithEvents txtOriginalName As MGOD.ColorTextBox
    Friend WithEvents tvwDescriptionInfo As System.Windows.Forms.TreeView
    Friend WithEvents ReferencesLabel As System.Windows.Forms.Label
    Friend WithEvents OriginalNameLabel As System.Windows.Forms.Label
    Friend WithEvents ckbActive As System.Windows.Forms.CheckBox
    Friend WithEvents lblUsername As System.Windows.Forms.Label
    Friend WithEvents UsernameLabel As System.Windows.Forms.Label
    Friend WithEvents txtTopographicalQuota As MGOD.ColorTextBox
    Friend WithEvents NameLabel As System.Windows.Forms.Label
    Friend WithEvents txtArchiveID As MGOD.ColorTextBox
    Friend WithEvents ArchiveIDLabel As System.Windows.Forms.Label
    Friend WithEvents TopographicalQuotaLabel As System.Windows.Forms.Label
    Friend WithEvents lblNumberOfFiles As System.Windows.Forms.Label
    Friend WithEvents NumberOfFilesLabel As System.Windows.Forms.Label
    Friend WithEvents InfoPreservationGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents miOpenProject As System.Windows.Forms.MenuItem
    Friend WithEvents miNewProject As System.Windows.Forms.MenuItem
    Friend WithEvents ListViewImageList As System.Windows.Forms.ImageList
    Friend WithEvents miGeneDisseminations As System.Windows.Forms.MenuItem
    Friend WithEvents FileMetadataPanel As System.Windows.Forms.Panel
    Friend WithEvents FilePropertiesPanel As System.Windows.Forms.Panel
    Friend WithEvents MetadataDataGrid As MetadataDataGrid
    Friend WithEvents FileMetadataDataGrid As MetadataDataGrid
    Friend WithEvents PublishedDigitalObjectsTree As DigitalObjectsTree
    Friend WithEvents UnpublishedDigitalObjectsTree As DigitalObjectsTree
    Friend WithEvents miAskBeforeSave As System.Windows.Forms.MenuItem
    Friend WithEvents AssociationMetadataButton As ImageButton
    Friend WithEvents AssociationPreservationButton As ImageButton
    Friend WithEvents AssociationPreviewButton As ImageButton
    Friend WithEvents tpMessage As System.Windows.Forms.TabPage
    Friend WithEvents lblMessage As System.Windows.Forms.Label
    Friend WithEvents lblMessageTitle As System.Windows.Forms.Label
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents miCut As System.Windows.Forms.MenuItem
    Friend WithEvents miCopy As System.Windows.Forms.MenuItem
    Friend WithEvents miPaste As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem7 As System.Windows.Forms.MenuItem
    Friend WithEvents miFind As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents miDelete As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents miKeepFileStructure As System.Windows.Forms.MenuItem
    Friend WithEvents miDeleteDisseminations As System.Windows.Forms.MenuItem
    Friend WithEvents OtherLevelIcons As System.Windows.Forms.ImageList
    Friend WithEvents miSelectAllDigitalObjects As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem8 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents miLogin As System.Windows.Forms.MenuItem
    Friend WithEvents CaptureEntityIndividualLabel As System.Windows.Forms.Label
    Friend WithEvents txtCaptureEntityIndividual As MGOD.ColorTextBox
    Friend WithEvents MenuItem9 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem12 As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderByName As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderByDate As System.Windows.Forms.MenuItem

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(MainForm))
        Me.DigitalObjectsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.TvwDigitalObjectsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.MainMenu = New System.Windows.Forms.MainMenu
        Me.miProjects = New System.Windows.Forms.MenuItem
        Me.miNewProject = New System.Windows.Forms.MenuItem
        Me.miOpenProject = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.miLogin = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.miClose = New System.Windows.Forms.MenuItem
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.miCut = New System.Windows.Forms.MenuItem
        Me.miCopy = New System.Windows.Forms.MenuItem
        Me.miPaste = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.miDelete = New System.Windows.Forms.MenuItem
        Me.miDeleteDisseminations = New System.Windows.Forms.MenuItem
        Me.MenuItem8 = New System.Windows.Forms.MenuItem
        Me.miSelectAllDigitalObjects = New System.Windows.Forms.MenuItem
        Me.MenuItem7 = New System.Windows.Forms.MenuItem
        Me.miFind = New System.Windows.Forms.MenuItem
        Me.miPreferences = New System.Windows.Forms.MenuItem
        Me.miDigitalizationProfiles = New System.Windows.Forms.MenuItem
        Me.miTechnologicalPlatform = New System.Windows.Forms.MenuItem
        Me.miRevisionInterval = New System.Windows.Forms.MenuItem
        Me.miControlledVocabularies = New System.Windows.Forms.MenuItem
        Me.miSaveDigitalObjectsAs = New System.Windows.Forms.MenuItem
        Me.miDisseminationSettings = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.miKeepFileStructure = New System.Windows.Forms.MenuItem
        Me.ViewMenuItem = New System.Windows.Forms.MenuItem
        Me.miViewOriginal = New System.Windows.Forms.MenuItem
        Me.miViewDissemination = New System.Windows.Forms.MenuItem
        Me.miViewThumbnail = New System.Windows.Forms.MenuItem
        Me.MenuItem12 = New System.Windows.Forms.MenuItem
        Me.MenuItem9 = New System.Windows.Forms.MenuItem
        Me.miOrderByName = New System.Windows.Forms.MenuItem
        Me.miOrderByDate = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.miViewTechnicalMatadata = New System.Windows.Forms.MenuItem
        Me.miAskBeforeSave = New System.Windows.Forms.MenuItem
        Me.miTools = New System.Windows.Forms.MenuItem
        Me.miFilesRename = New System.Windows.Forms.MenuItem
        Me.miPOD = New System.Windows.Forms.MenuItem
        Me.miGeneDisseminations = New System.Windows.Forms.MenuItem
        Me.miReports = New System.Windows.Forms.MenuItem
        Me.miReportDigitalizationProfiles = New System.Windows.Forms.MenuItem
        Me.miReportReformattingNorms = New System.Windows.Forms.MenuItem
        Me.miReportReformattingMethods = New System.Windows.Forms.MenuItem
        Me.miReportMetaOD = New System.Windows.Forms.MenuItem
        Me.miReportPreservationInfDO = New System.Windows.Forms.MenuItem
        Me.miReportImagesDO = New System.Windows.Forms.MenuItem
        Me.miReportRevisionDO = New System.Windows.Forms.MenuItem
        Me.miUIDigitalization = New System.Windows.Forms.MenuItem
        Me.miHelp = New System.Windows.Forms.MenuItem
        Me.About = New System.Windows.Forms.MenuItem
        Me.sbMain = New System.Windows.Forms.StatusBar
        Me.pnlMain = New System.Windows.Forms.Panel
        Me.TabControl = New System.Windows.Forms.TabControl
        Me.tpMetadata = New System.Windows.Forms.TabPage
        Me.MetadataPanel = New System.Windows.Forms.Panel
        Me.InfoGeralGroupBox = New System.Windows.Forms.GroupBox
        Me.txtName = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtOriginalName = New DigitArq.Applications.MGOD.ColorTextBox
        Me.tvwDescriptionInfo = New System.Windows.Forms.TreeView
        Me.OtherLevelIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.ReferencesLabel = New System.Windows.Forms.Label
        Me.OriginalNameLabel = New System.Windows.Forms.Label
        Me.ckbActive = New System.Windows.Forms.CheckBox
        Me.lblUsername = New System.Windows.Forms.Label
        Me.UsernameLabel = New System.Windows.Forms.Label
        Me.txtTopographicalQuota = New DigitArq.Applications.MGOD.ColorTextBox
        Me.NameLabel = New System.Windows.Forms.Label
        Me.txtArchiveID = New DigitArq.Applications.MGOD.ColorTextBox
        Me.ArchiveIDLabel = New System.Windows.Forms.Label
        Me.TopographicalQuotaLabel = New System.Windows.Forms.Label
        Me.lblNumberOfFiles = New System.Windows.Forms.Label
        Me.NumberOfFilesLabel = New System.Windows.Forms.Label
        Me.PreservationGroupBox = New System.Windows.Forms.GroupBox
        Me.txtArchivingProfile = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtExternalDescriptiveInfo = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtPreservationOriginalInformation = New DigitArq.Applications.MGOD.ColorTextBox
        Me.ExternalDescriptiveInfoLabel = New System.Windows.Forms.Label
        Me.PreservationOriginalInformationLabel = New System.Windows.Forms.Label
        Me.ArchivingProfileLabel = New System.Windows.Forms.Label
        Me.DatesGroupBox = New System.Windows.Forms.GroupBox
        Me.txtArchiveDateTime = New DigitArq.Applications.MGOD.DateTextBox
        Me.txtCreationDateTime = New DigitArq.Applications.MGOD.DateTextBox
        Me.lblRevisionDateTime = New System.Windows.Forms.Label
        Me.RevisionDateTimeLabel = New System.Windows.Forms.Label
        Me.DepositDateTimeLabel = New System.Windows.Forms.Label
        Me.CreationDateTimeLabel = New System.Windows.Forms.Label
        Me.ArchiveDateTimeLabel = New System.Windows.Forms.Label
        Me.txtDepositDateTime = New DigitArq.Applications.MGOD.DateTextBox
        Me.EntitiesGroupBox = New System.Windows.Forms.GroupBox
        Me.CaptureEntityIndividualLabel = New System.Windows.Forms.Label
        Me.txtCaptureEntityIndividual = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtResponsabilityEntity = New DigitArq.Applications.MGOD.ColorTextBox
        Me.ResponsabilityEntityLabel = New System.Windows.Forms.Label
        Me.CaptureEntityCorporateLabel = New System.Windows.Forms.Label
        Me.txtCaptureEntityCorporate = New DigitArq.Applications.MGOD.ColorTextBox
        Me.FooterMetadataPanel = New System.Windows.Forms.Panel
        Me.AssociationMetadataButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.SaveMetadataButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.tpPreview = New System.Windows.Forms.TabPage
        Me.PreviewPanel = New System.Windows.Forms.Panel
        Me.ImageViewer = New DigitArq.UserControls.Viewer.ImageViewer
        Me.RigthSplitter = New System.Windows.Forms.Splitter
        Me.TechnicalMetadataPanel = New System.Windows.Forms.Panel
        Me.FilePropertiesPanel = New System.Windows.Forms.Panel
        Me.MetadataDataGrid = New DigitArq.UserControls.MetadataDataGrid.MetadataDataGrid
        Me.FileMetadataPanel = New System.Windows.Forms.Panel
        Me.FileMetadataDataGrid = New DigitArq.UserControls.MetadataDataGrid.MetadataDataGrid
        Me.FooterPreviewPanel = New System.Windows.Forms.Panel
        Me.AssociationPreviewButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.SavePreviewButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.tpPreservationMetadata = New System.Windows.Forms.TabPage
        Me.PreservationPanel = New System.Windows.Forms.Panel
        Me.btnHistorical = New System.Windows.Forms.Button
        Me.InfoPreservationGroupBox = New System.Windows.Forms.GroupBox
        Me.btnChooseReformattingNorms = New System.Windows.Forms.Button
        Me.btnChooseReformattingMethod = New System.Windows.Forms.Button
        Me.lbxReformattingNormsChoosen = New System.Windows.Forms.ListBox
        Me.lblReformattingNorms = New System.Windows.Forms.Label
        Me.txtReformattingMethod = New DigitArq.Applications.MGOD.ColorTextBox
        Me.lblReformattingMethod = New System.Windows.Forms.Label
        Me.txtParameters = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtInputFormat = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtRenderEngine = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtPlatform = New DigitArq.Applications.MGOD.ColorTextBox
        Me.txtTransformer = New DigitArq.Applications.MGOD.ColorTextBox
        Me.lblTransformerObject = New System.Windows.Forms.Label
        Me.lblInputFormat = New System.Windows.Forms.Label
        Me.lblRenderEngine = New System.Windows.Forms.Label
        Me.lblParameters = New System.Windows.Forms.Label
        Me.lblPlatform = New System.Windows.Forms.Label
        Me.FooterPreservationPanel = New System.Windows.Forms.Panel
        Me.AssociationPreservationButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.SavePreservationButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.tpAddFiles = New System.Windows.Forms.TabPage
        Me.FilesPanel = New System.Windows.Forms.Panel
        Me.DragDropListView = New DigitArq.UserControls.DragDropListView.DragDropListView
        Me.tpMessage = New System.Windows.Forms.TabPage
        Me.lblMessage = New System.Windows.Forms.Label
        Me.lblMessageTitle = New System.Windows.Forms.Label
        Me.LeftSplitter = New System.Windows.Forms.Splitter
        Me.pnlTvwContainer = New System.Windows.Forms.Panel
        Me.TabControlDigitalObjects = New System.Windows.Forms.TabControl
        Me.PublishedDigitalObjectsTabPage = New System.Windows.Forms.TabPage
        Me.PublishedDigitalObjectsTree = New DigitArq.UserControls.DigitalObjectsTree.DigitalObjectsTree
        Me.pnlToolBarTvw = New System.Windows.Forms.Panel
        Me.UnpublishButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.SearchDigitalObjectButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.AddDigitalObjectButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.RemoveDigitalObjectButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.UnpublishedDigitalObjectsTabPage = New System.Windows.Forms.TabPage
        Me.UnpublishedDigitalObjectsTree = New DigitArq.UserControls.DigitalObjectsTree.DigitalObjectsTree
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.PublishButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.SearchUnpublishedDigitalObjectButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.AddUnpublishedDigitalObjectButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.RemoveUnpublishedDigitalObjectButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.OpenFileDialog = New System.Windows.Forms.OpenFileDialog
        Me.FolderBrowserDialog = New System.Windows.Forms.FolderBrowserDialog
        Me.ListViewImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.pnlMain.SuspendLayout()
        Me.TabControl.SuspendLayout()
        Me.tpMetadata.SuspendLayout()
        Me.MetadataPanel.SuspendLayout()
        Me.InfoGeralGroupBox.SuspendLayout()
        Me.PreservationGroupBox.SuspendLayout()
        Me.DatesGroupBox.SuspendLayout()
        Me.EntitiesGroupBox.SuspendLayout()
        Me.FooterMetadataPanel.SuspendLayout()
        Me.tpPreview.SuspendLayout()
        Me.PreviewPanel.SuspendLayout()
        Me.TechnicalMetadataPanel.SuspendLayout()
        Me.FilePropertiesPanel.SuspendLayout()
        Me.FileMetadataPanel.SuspendLayout()
        Me.FooterPreviewPanel.SuspendLayout()
        Me.tpPreservationMetadata.SuspendLayout()
        Me.PreservationPanel.SuspendLayout()
        Me.InfoPreservationGroupBox.SuspendLayout()
        Me.FooterPreservationPanel.SuspendLayout()
        Me.tpAddFiles.SuspendLayout()
        Me.FilesPanel.SuspendLayout()
        Me.tpMessage.SuspendLayout()
        Me.pnlTvwContainer.SuspendLayout()
        Me.TabControlDigitalObjects.SuspendLayout()
        Me.PublishedDigitalObjectsTabPage.SuspendLayout()
        Me.pnlToolBarTvw.SuspendLayout()
        Me.UnpublishedDigitalObjectsTabPage.SuspendLayout()
        Me.Panel2.SuspendLayout()
        Me.SuspendLayout()
        '
        'DigitalObjectsImageList
        '
        Me.DigitalObjectsImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.DigitalObjectsImageList.ImageStream = CType(resources.GetObject("DigitalObjectsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.DigitalObjectsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'TvwDigitalObjectsImageList
        '
        Me.TvwDigitalObjectsImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.TvwDigitalObjectsImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.TvwDigitalObjectsImageList.ImageStream = CType(resources.GetObject("TvwDigitalObjectsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.TvwDigitalObjectsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'MainMenu
        '
        Me.MainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miProjects, Me.MenuItem1, Me.miPreferences, Me.ViewMenuItem, Me.miTools, Me.miReports, Me.miHelp})
        '
        'miProjects
        '
        Me.miProjects.Index = 0
        Me.miProjects.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miNewProject, Me.miOpenProject, Me.MenuItem2, Me.miLogin, Me.MenuItem6, Me.miClose})
        Me.miProjects.Text = "&Perfis"
        '
        'miNewProject
        '
        Me.miNewProject.Index = 0
        Me.miNewProject.Text = "&Novo..."
        '
        'miOpenProject
        '
        Me.miOpenProject.Index = 1
        Me.miOpenProject.Text = "&Abrir..."
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 2
        Me.MenuItem2.Text = "-"
        '
        'miLogin
        '
        Me.miLogin.Index = 3
        Me.miLogin.Text = "Alterar utilizador..."
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 4
        Me.MenuItem6.Text = "-"
        '
        'miClose
        '
        Me.miClose.Index = 5
        Me.miClose.Text = "&Sair"
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 1
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miCut, Me.miCopy, Me.miPaste, Me.MenuItem5, Me.miDelete, Me.miDeleteDisseminations, Me.MenuItem8, Me.miSelectAllDigitalObjects, Me.MenuItem7, Me.miFind})
        Me.MenuItem1.Text = "&Editar"
        '
        'miCut
        '
        Me.miCut.Enabled = False
        Me.miCut.Index = 0
        Me.miCut.Text = "Cor&tar"
        '
        'miCopy
        '
        Me.miCopy.Enabled = False
        Me.miCopy.Index = 1
        Me.miCopy.Text = "&Copiar"
        '
        'miPaste
        '
        Me.miPaste.Enabled = False
        Me.miPaste.Index = 2
        Me.miPaste.Text = "C&olar"
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 3
        Me.MenuItem5.Text = "-"
        '
        'miDelete
        '
        Me.miDelete.Index = 4
        Me.miDelete.Text = "&Eliminar"
        '
        'miDeleteDisseminations
        '
        Me.miDeleteDisseminations.Index = 5
        Me.miDeleteDisseminations.Text = "Eliminar &derivada(s)"
        '
        'MenuItem8
        '
        Me.MenuItem8.Index = 6
        Me.MenuItem8.Text = "-"
        '
        'miSelectAllDigitalObjects
        '
        Me.miSelectAllDigitalObjects.Index = 7
        Me.miSelectAllDigitalObjects.Text = "&Seleccionar todos objectos digitais"
        '
        'MenuItem7
        '
        Me.MenuItem7.Index = 8
        Me.MenuItem7.Text = "-"
        '
        'miFind
        '
        Me.miFind.Index = 9
        Me.miFind.Text = "&Procurar..."
        '
        'miPreferences
        '
        Me.miPreferences.Index = 2
        Me.miPreferences.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miDigitalizationProfiles, Me.miTechnologicalPlatform, Me.miRevisionInterval, Me.miControlledVocabularies, Me.miSaveDigitalObjectsAs, Me.miDisseminationSettings, Me.MenuItem3, Me.miKeepFileStructure})
        Me.miPreferences.Text = "Pr&eferncias"
        '
        'miDigitalizationProfiles
        '
        Me.miDigitalizationProfiles.Index = 0
        Me.miDigitalizationProfiles.Text = "&Perfis de digitalizao..."
        '
        'miTechnologicalPlatform
        '
        Me.miTechnologicalPlatform.Index = 1
        Me.miTechnologicalPlatform.Text = "Plataforma &tecnolgica..."
        '
        'miRevisionInterval
        '
        Me.miRevisionInterval.Index = 2
        Me.miRevisionInterval.Text = "&Intervalo de reviso..."
        '
        'miControlledVocabularies
        '
        Me.miControlledVocabularies.Index = 3
        Me.miControlledVocabularies.Text = "&Vocabulrios controlados..."
        '
        'miSaveDigitalObjectsAs
        '
        Me.miSaveDigitalObjectsAs.Index = 4
        Me.miSaveDigitalObjectsAs.Text = "&Armazenamento de objectos digitais..."
        '
        'miDisseminationSettings
        '
        Me.miDisseminationSettings.Index = 5
        Me.miDisseminationSettings.Text = "&Definies das derivadas..."
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 6
        Me.MenuItem3.Text = "-"
        '
        'miKeepFileStructure
        '
        Me.miKeepFileStructure.Checked = True
        Me.miKeepFileStructure.Index = 7
        Me.miKeepFileStructure.Text = "Manter estrutura de ficheiros a importar"
        '
        'ViewMenuItem
        '
        Me.ViewMenuItem.Index = 3
        Me.ViewMenuItem.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miViewOriginal, Me.miViewDissemination, Me.miViewThumbnail, Me.MenuItem12, Me.MenuItem9, Me.MenuItem4, Me.miViewTechnicalMatadata, Me.miAskBeforeSave})
        Me.ViewMenuItem.Text = "&Ver"
        '
        'miViewOriginal
        '
        Me.miViewOriginal.Index = 0
        Me.miViewOriginal.Text = "&Original"
        '
        'miViewDissemination
        '
        Me.miViewDissemination.Checked = True
        Me.miViewDissemination.Index = 1
        Me.miViewDissemination.Text = "&Derivada"
        '
        'miViewThumbnail
        '
        Me.miViewThumbnail.Index = 2
        Me.miViewThumbnail.Text = "&Miniatura"
        '
        'MenuItem12
        '
        Me.MenuItem12.Index = 3
        Me.MenuItem12.Text = "-"
        '
        'MenuItem9
        '
        Me.MenuItem9.Index = 4
        Me.MenuItem9.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miOrderByName, Me.miOrderByDate})
        Me.MenuItem9.Text = "O&rdenar por"
        '
        'miOrderByName
        '
        Me.miOrderByName.Checked = True
        Me.miOrderByName.Index = 0
        Me.miOrderByName.Text = "&Nome"
        '
        'miOrderByDate
        '
        Me.miOrderByDate.Index = 1
        Me.miOrderByDate.Text = "&Data de criao"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 5
        Me.MenuItem4.Text = "-"
        '
        'miViewTechnicalMatadata
        '
        Me.miViewTechnicalMatadata.Checked = True
        Me.miViewTechnicalMatadata.Index = 6
        Me.miViewTechnicalMatadata.Text = "&Painel de metainformao"
        '
        'miAskBeforeSave
        '
        Me.miAskBeforeSave.Checked = True
        Me.miAskBeforeSave.Index = 7
        Me.miAskBeforeSave.Text = "&Confirmar gravao"
        '
        'miTools
        '
        Me.miTools.Index = 4
        Me.miTools.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miFilesRename, Me.miPOD, Me.miGeneDisseminations})
        Me.miTools.Text = "&Ferramentas"
        '
        'miFilesRename
        '
        Me.miFilesRename.Index = 0
        Me.miFilesRename.Text = "&Renomeador de ficheiros..."
        '
        'miPOD
        '
        Me.miPOD.Index = 1
        Me.miPOD.Text = "&Associao de descries..."
        '
        'miGeneDisseminations
        '
        Me.miGeneDisseminations.Index = 2
        Me.miGeneDisseminations.Text = "&Gerar derivadas a partir dos originais..."
        '
        'miReports
        '
        Me.miReports.Index = 5
        Me.miReports.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miReportDigitalizationProfiles, Me.miReportReformattingNorms, Me.miReportReformattingMethods, Me.miReportMetaOD, Me.miReportPreservationInfDO, Me.miReportImagesDO, Me.miReportRevisionDO, Me.miUIDigitalization})
        Me.miReports.Text = "&Relatrios"
        '
        'miReportDigitalizationProfiles
        '
        Me.miReportDigitalizationProfiles.Index = 0
        Me.miReportDigitalizationProfiles.Text = "&Perfis de digitalizao..."
        '
        'miReportReformattingNorms
        '
        Me.miReportReformattingNorms.Index = 1
        Me.miReportReformattingNorms.Text = "&Normas de preservao..."
        '
        'miReportReformattingMethods
        '
        Me.miReportReformattingMethods.Index = 2
        Me.miReportReformattingMethods.Text = "&Mtodos de preservao..."
        '
        'miReportMetaOD
        '
        Me.miReportMetaOD.Index = 3
        Me.miReportMetaOD.Text = "M&etainformao dos objectos digitais..."
        '
        'miReportPreservationInfDO
        '
        Me.miReportPreservationInfDO.Index = 4
        Me.miReportPreservationInfDO.Text = "&Informao de preservao dos objectos digitais..."
        '
        'miReportImagesDO
        '
        Me.miReportImagesDO.Index = 5
        Me.miReportImagesDO.Text = "Documentos dos objectos digitais..."
        Me.miReportImagesDO.Visible = False
        '
        'miReportRevisionDO
        '
        Me.miReportRevisionDO.Index = 6
        Me.miReportRevisionDO.Text = "&Reviso de objectos digitais..."
        '
        'miUIDigitalization
        '
        Me.miUIDigitalization.Index = 7
        Me.miUIDigitalization.Text = "&Unidades de instalao digitalizadas por fundo..."
        '
        'miHelp
        '
        Me.miHelp.Index = 6
        Me.miHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.About})
        Me.miHelp.Text = "&Ajuda"
        Me.miHelp.Visible = False
        '
        'About
        '
        Me.About.Index = 0
        Me.About.Text = "&About"
        '
        'sbMain
        '
        Me.sbMain.Location = New System.Drawing.Point(0, 651)
        Me.sbMain.Name = "sbMain"
        Me.sbMain.Size = New System.Drawing.Size(932, 22)
        Me.sbMain.TabIndex = 113
        '
        'pnlMain
        '
        Me.pnlMain.Controls.Add(Me.TabControl)
        Me.pnlMain.Controls.Add(Me.LeftSplitter)
        Me.pnlMain.Controls.Add(Me.pnlTvwContainer)
        Me.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill
        Me.pnlMain.DockPadding.All = 6
        Me.pnlMain.Location = New System.Drawing.Point(0, 0)
        Me.pnlMain.Name = "pnlMain"
        Me.pnlMain.Size = New System.Drawing.Size(932, 651)
        Me.pnlMain.TabIndex = 114
        '
        'TabControl
        '
        Me.TabControl.Controls.Add(Me.tpMetadata)
        Me.TabControl.Controls.Add(Me.tpPreview)
        Me.TabControl.Controls.Add(Me.tpPreservationMetadata)
        Me.TabControl.Controls.Add(Me.tpAddFiles)
        Me.TabControl.Controls.Add(Me.tpMessage)
        Me.TabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TabControl.Location = New System.Drawing.Point(209, 6)
        Me.TabControl.Name = "TabControl"
        Me.TabControl.SelectedIndex = 0
        Me.TabControl.Size = New System.Drawing.Size(717, 639)
        Me.TabControl.TabIndex = 119
        '
        'tpMetadata
        '
        Me.tpMetadata.AutoScroll = True
        Me.tpMetadata.BackColor = System.Drawing.Color.WhiteSmoke
        Me.tpMetadata.Controls.Add(Me.MetadataPanel)
        Me.tpMetadata.Controls.Add(Me.FooterMetadataPanel)
        Me.tpMetadata.Location = New System.Drawing.Point(4, 22)
        Me.tpMetadata.Name = "tpMetadata"
        Me.tpMetadata.Size = New System.Drawing.Size(709, 613)
        Me.tpMetadata.TabIndex = 1
        Me.tpMetadata.Text = "Metainformao"
        Me.tpMetadata.Visible = False
        '
        'MetadataPanel
        '
        Me.MetadataPanel.AutoScroll = True
        Me.MetadataPanel.BackColor = System.Drawing.Color.White
        Me.MetadataPanel.Controls.Add(Me.InfoGeralGroupBox)
        Me.MetadataPanel.Controls.Add(Me.PreservationGroupBox)
        Me.MetadataPanel.Controls.Add(Me.DatesGroupBox)
        Me.MetadataPanel.Controls.Add(Me.EntitiesGroupBox)
        Me.MetadataPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.MetadataPanel.Location = New System.Drawing.Point(0, 0)
        Me.MetadataPanel.Name = "MetadataPanel"
        Me.MetadataPanel.Size = New System.Drawing.Size(709, 567)
        Me.MetadataPanel.TabIndex = 136
        '
        'InfoGeralGroupBox
        '
        Me.InfoGeralGroupBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.InfoGeralGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.InfoGeralGroupBox.Controls.Add(Me.txtName)
        Me.InfoGeralGroupBox.Controls.Add(Me.txtOriginalName)
        Me.InfoGeralGroupBox.Controls.Add(Me.tvwDescriptionInfo)
        Me.InfoGeralGroupBox.Controls.Add(Me.ReferencesLabel)
        Me.InfoGeralGroupBox.Controls.Add(Me.OriginalNameLabel)
        Me.InfoGeralGroupBox.Controls.Add(Me.ckbActive)
        Me.InfoGeralGroupBox.Controls.Add(Me.lblUsername)
        Me.InfoGeralGroupBox.Controls.Add(Me.UsernameLabel)
        Me.InfoGeralGroupBox.Controls.Add(Me.txtTopographicalQuota)
        Me.InfoGeralGroupBox.Controls.Add(Me.NameLabel)
        Me.InfoGeralGroupBox.Controls.Add(Me.txtArchiveID)
        Me.InfoGeralGroupBox.Controls.Add(Me.ArchiveIDLabel)
        Me.InfoGeralGroupBox.Controls.Add(Me.TopographicalQuotaLabel)
        Me.InfoGeralGroupBox.Controls.Add(Me.lblNumberOfFiles)
        Me.InfoGeralGroupBox.Controls.Add(Me.NumberOfFilesLabel)
        Me.InfoGeralGroupBox.Location = New System.Drawing.Point(16, 17)
        Me.InfoGeralGroupBox.Name = "InfoGeralGroupBox"
        Me.InfoGeralGroupBox.Size = New System.Drawing.Size(485, 235)
        Me.InfoGeralGroupBox.TabIndex = 140
        Me.InfoGeralGroupBox.TabStop = False
        Me.InfoGeralGroupBox.Text = "Informao geral"
        '
        'txtName
        '
        Me.txtName.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtName.BackColor = System.Drawing.Color.White
        Me.txtName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtName.Location = New System.Drawing.Point(140, 22)
        Me.txtName.Name = "txtName"
        Me.txtName.Size = New System.Drawing.Size(299, 20)
        Me.txtName.TabIndex = 1
        Me.txtName.Text = ""
        '
        'txtOriginalName
        '
        Me.txtOriginalName.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtOriginalName.BackColor = System.Drawing.Color.White
        Me.txtOriginalName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtOriginalName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtOriginalName.Location = New System.Drawing.Point(140, 47)
        Me.txtOriginalName.Name = "txtOriginalName"
        Me.txtOriginalName.Size = New System.Drawing.Size(299, 20)
        Me.txtOriginalName.TabIndex = 2
        Me.txtOriginalName.Text = ""
        '
        'tvwDescriptionInfo
        '
        Me.tvwDescriptionInfo.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tvwDescriptionInfo.BackColor = System.Drawing.Color.WhiteSmoke
        Me.tvwDescriptionInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.tvwDescriptionInfo.ImageIndex = 1
        Me.tvwDescriptionInfo.ImageList = Me.OtherLevelIcons
        Me.tvwDescriptionInfo.Location = New System.Drawing.Point(140, 72)
        Me.tvwDescriptionInfo.Name = "tvwDescriptionInfo"
        Me.tvwDescriptionInfo.SelectedImageIndex = 1
        Me.tvwDescriptionInfo.Size = New System.Drawing.Size(299, 48)
        Me.tvwDescriptionInfo.TabIndex = 128
        '
        'OtherLevelIcons
        '
        Me.OtherLevelIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.OtherLevelIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherLevelIcons.ImageStream = CType(resources.GetObject("OtherLevelIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherLevelIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'ReferencesLabel
        '
        Me.ReferencesLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ReferencesLabel.ForeColor = System.Drawing.Color.Black
        Me.ReferencesLabel.Location = New System.Drawing.Point(20, 72)
        Me.ReferencesLabel.Name = "ReferencesLabel"
        Me.ReferencesLabel.Size = New System.Drawing.Size(113, 48)
        Me.ReferencesLabel.TabIndex = 127
        Me.ReferencesLabel.Text = "Referncias das desc. arquivsticas"
        Me.ReferencesLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'OriginalNameLabel
        '
        Me.OriginalNameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.OriginalNameLabel.ForeColor = System.Drawing.Color.Black
        Me.OriginalNameLabel.Location = New System.Drawing.Point(20, 47)
        Me.OriginalNameLabel.Name = "OriginalNameLabel"
        Me.OriginalNameLabel.Size = New System.Drawing.Size(113, 20)
        Me.OriginalNameLabel.TabIndex = 125
        Me.OriginalNameLabel.Text = "Nome original"
        Me.OriginalNameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'ckbActive
        '
        Me.ckbActive.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ckbActive.Enabled = False
        Me.ckbActive.Font = New System.Drawing.Font("Microsoft Sans Serif", 7.8!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ckbActive.Location = New System.Drawing.Point(359, 208)
        Me.ckbActive.Name = "ckbActive"
        Me.ckbActive.Size = New System.Drawing.Size(80, 20)
        Me.ckbActive.TabIndex = 4
        Me.ckbActive.Text = "Publicado"
        '
        'lblUsername
        '
        Me.lblUsername.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblUsername.BackColor = System.Drawing.Color.WhiteSmoke
        Me.lblUsername.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblUsername.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblUsername.Location = New System.Drawing.Point(140, 175)
        Me.lblUsername.Name = "lblUsername"
        Me.lblUsername.Size = New System.Drawing.Size(299, 20)
        Me.lblUsername.TabIndex = 121
        Me.lblUsername.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'UsernameLabel
        '
        Me.UsernameLabel.BackColor = System.Drawing.Color.Transparent
        Me.UsernameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.UsernameLabel.Location = New System.Drawing.Point(20, 175)
        Me.UsernameLabel.Name = "UsernameLabel"
        Me.UsernameLabel.Size = New System.Drawing.Size(113, 20)
        Me.UsernameLabel.TabIndex = 120
        Me.UsernameLabel.Text = "Indivduo produtor"
        Me.UsernameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtTopographicalQuota
        '
        Me.txtTopographicalQuota.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtTopographicalQuota.BackColor = System.Drawing.Color.White
        Me.txtTopographicalQuota.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtTopographicalQuota.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtTopographicalQuota.Location = New System.Drawing.Point(140, 150)
        Me.txtTopographicalQuota.Name = "txtTopographicalQuota"
        Me.txtTopographicalQuota.Size = New System.Drawing.Size(299, 20)
        Me.txtTopographicalQuota.TabIndex = 4
        Me.txtTopographicalQuota.Text = ""
        '
        'NameLabel
        '
        Me.NameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.NameLabel.ForeColor = System.Drawing.Color.Red
        Me.NameLabel.Location = New System.Drawing.Point(20, 22)
        Me.NameLabel.Name = "NameLabel"
        Me.NameLabel.Size = New System.Drawing.Size(113, 20)
        Me.NameLabel.TabIndex = 117
        Me.NameLabel.Text = "Nome"
        Me.NameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtArchiveID
        '
        Me.txtArchiveID.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtArchiveID.BackColor = System.Drawing.Color.White
        Me.txtArchiveID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtArchiveID.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtArchiveID.Location = New System.Drawing.Point(140, 125)
        Me.txtArchiveID.Name = "txtArchiveID"
        Me.txtArchiveID.Size = New System.Drawing.Size(299, 20)
        Me.txtArchiveID.TabIndex = 3
        Me.txtArchiveID.Text = ""
        '
        'ArchiveIDLabel
        '
        Me.ArchiveIDLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ArchiveIDLabel.Location = New System.Drawing.Point(20, 125)
        Me.ArchiveIDLabel.Name = "ArchiveIDLabel"
        Me.ArchiveIDLabel.Size = New System.Drawing.Size(113, 20)
        Me.ArchiveIDLabel.TabIndex = 82
        Me.ArchiveIDLabel.Text = "Identificao suporte"
        Me.ArchiveIDLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'TopographicalQuotaLabel
        '
        Me.TopographicalQuotaLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TopographicalQuotaLabel.Location = New System.Drawing.Point(20, 150)
        Me.TopographicalQuotaLabel.Name = "TopographicalQuotaLabel"
        Me.TopographicalQuotaLabel.Size = New System.Drawing.Size(113, 20)
        Me.TopographicalQuotaLabel.TabIndex = 83
        Me.TopographicalQuotaLabel.Text = "Cota topogrfica"
        Me.TopographicalQuotaLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblNumberOfFiles
        '
        Me.lblNumberOfFiles.BackColor = System.Drawing.Color.WhiteSmoke
        Me.lblNumberOfFiles.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblNumberOfFiles.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNumberOfFiles.Location = New System.Drawing.Point(140, 208)
        Me.lblNumberOfFiles.Name = "lblNumberOfFiles"
        Me.lblNumberOfFiles.Size = New System.Drawing.Size(70, 20)
        Me.lblNumberOfFiles.TabIndex = 101
        Me.lblNumberOfFiles.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'NumberOfFilesLabel
        '
        Me.NumberOfFilesLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.NumberOfFilesLabel.Location = New System.Drawing.Point(20, 208)
        Me.NumberOfFilesLabel.Name = "NumberOfFilesLabel"
        Me.NumberOfFilesLabel.Size = New System.Drawing.Size(113, 20)
        Me.NumberOfFilesLabel.TabIndex = 88
        Me.NumberOfFilesLabel.Text = "N documentos"
        Me.NumberOfFilesLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'PreservationGroupBox
        '
        Me.PreservationGroupBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.PreservationGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.PreservationGroupBox.Controls.Add(Me.txtArchivingProfile)
        Me.PreservationGroupBox.Controls.Add(Me.txtExternalDescriptiveInfo)
        Me.PreservationGroupBox.Controls.Add(Me.txtPreservationOriginalInformation)
        Me.PreservationGroupBox.Controls.Add(Me.ExternalDescriptiveInfoLabel)
        Me.PreservationGroupBox.Controls.Add(Me.PreservationOriginalInformationLabel)
        Me.PreservationGroupBox.Controls.Add(Me.ArchivingProfileLabel)
        Me.PreservationGroupBox.Location = New System.Drawing.Point(16, 448)
        Me.PreservationGroupBox.Name = "PreservationGroupBox"
        Me.PreservationGroupBox.Size = New System.Drawing.Size(485, 208)
        Me.PreservationGroupBox.TabIndex = 138
        Me.PreservationGroupBox.TabStop = False
        Me.PreservationGroupBox.Text = "Informao preservao"
        '
        'txtArchivingProfile
        '
        Me.txtArchivingProfile.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtArchivingProfile.BackColor = System.Drawing.Color.White
        Me.txtArchivingProfile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtArchivingProfile.Location = New System.Drawing.Point(140, 140)
        Me.txtArchivingProfile.Multiline = True
        Me.txtArchivingProfile.Name = "txtArchivingProfile"
        Me.txtArchivingProfile.Size = New System.Drawing.Size(299, 54)
        Me.txtArchivingProfile.TabIndex = 12
        Me.txtArchivingProfile.Text = ""
        '
        'txtExternalDescriptiveInfo
        '
        Me.txtExternalDescriptiveInfo.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtExternalDescriptiveInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtExternalDescriptiveInfo.Location = New System.Drawing.Point(140, 81)
        Me.txtExternalDescriptiveInfo.Multiline = True
        Me.txtExternalDescriptiveInfo.Name = "txtExternalDescriptiveInfo"
        Me.txtExternalDescriptiveInfo.Size = New System.Drawing.Size(299, 54)
        Me.txtExternalDescriptiveInfo.TabIndex = 11
        Me.txtExternalDescriptiveInfo.Text = ""
        '
        'txtPreservationOriginalInformation
        '
        Me.txtPreservationOriginalInformation.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtPreservationOriginalInformation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtPreservationOriginalInformation.Location = New System.Drawing.Point(140, 22)
        Me.txtPreservationOriginalInformation.Multiline = True
        Me.txtPreservationOriginalInformation.Name = "txtPreservationOriginalInformation"
        Me.txtPreservationOriginalInformation.Size = New System.Drawing.Size(299, 54)
        Me.txtPreservationOriginalInformation.TabIndex = 10
        Me.txtPreservationOriginalInformation.Text = ""
        '
        'ExternalDescriptiveInfoLabel
        '
        Me.ExternalDescriptiveInfoLabel.BackColor = System.Drawing.Color.Transparent
        Me.ExternalDescriptiveInfoLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ExternalDescriptiveInfoLabel.Location = New System.Drawing.Point(20, 81)
        Me.ExternalDescriptiveInfoLabel.Name = "ExternalDescriptiveInfoLabel"
        Me.ExternalDescriptiveInfoLabel.Size = New System.Drawing.Size(113, 28)
        Me.ExternalDescriptiveInfoLabel.TabIndex = 92
        Me.ExternalDescriptiveInfoLabel.Text = "Informao descritiva externa"
        Me.ExternalDescriptiveInfoLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'PreservationOriginalInformationLabel
        '
        Me.PreservationOriginalInformationLabel.BackColor = System.Drawing.Color.Transparent
        Me.PreservationOriginalInformationLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.PreservationOriginalInformationLabel.Location = New System.Drawing.Point(20, 22)
        Me.PreservationOriginalInformationLabel.Name = "PreservationOriginalInformationLabel"
        Me.PreservationOriginalInformationLabel.Size = New System.Drawing.Size(113, 28)
        Me.PreservationOriginalInformationLabel.TabIndex = 91
        Me.PreservationOriginalInformationLabel.Text = "Preservao do objecto digital original"
        Me.PreservationOriginalInformationLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'ArchivingProfileLabel
        '
        Me.ArchivingProfileLabel.BackColor = System.Drawing.Color.Transparent
        Me.ArchivingProfileLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ArchivingProfileLabel.Location = New System.Drawing.Point(20, 140)
        Me.ArchivingProfileLabel.Name = "ArchivingProfileLabel"
        Me.ArchivingProfileLabel.Size = New System.Drawing.Size(113, 28)
        Me.ArchivingProfileLabel.TabIndex = 93
        Me.ArchivingProfileLabel.Text = "Documentao de apoio"
        Me.ArchivingProfileLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'DatesGroupBox
        '
        Me.DatesGroupBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.DatesGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.DatesGroupBox.Controls.Add(Me.txtArchiveDateTime)
        Me.DatesGroupBox.Controls.Add(Me.txtCreationDateTime)
        Me.DatesGroupBox.Controls.Add(Me.lblRevisionDateTime)
        Me.DatesGroupBox.Controls.Add(Me.RevisionDateTimeLabel)
        Me.DatesGroupBox.Controls.Add(Me.DepositDateTimeLabel)
        Me.DatesGroupBox.Controls.Add(Me.CreationDateTimeLabel)
        Me.DatesGroupBox.Controls.Add(Me.ArchiveDateTimeLabel)
        Me.DatesGroupBox.Controls.Add(Me.txtDepositDateTime)
        Me.DatesGroupBox.Location = New System.Drawing.Point(16, 256)
        Me.DatesGroupBox.Name = "DatesGroupBox"
        Me.DatesGroupBox.Size = New System.Drawing.Size(485, 80)
        Me.DatesGroupBox.TabIndex = 136
        Me.DatesGroupBox.TabStop = False
        Me.DatesGroupBox.Text = "Datas"
        '
        'txtArchiveDateTime
        '
        Me.txtArchiveDateTime.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtArchiveDateTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtArchiveDateTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtArchiveDateTime.Location = New System.Drawing.Point(369, 22)
        Me.txtArchiveDateTime.Mask = "####-##-##"
        Me.txtArchiveDateTime.MaxLength = 10
        Me.txtArchiveDateTime.Name = "txtArchiveDateTime"
        Me.txtArchiveDateTime.Size = New System.Drawing.Size(70, 20)
        Me.txtArchiveDateTime.TabIndex = 6
        Me.txtArchiveDateTime.Text = ""
        '
        'txtCreationDateTime
        '
        Me.txtCreationDateTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtCreationDateTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtCreationDateTime.Location = New System.Drawing.Point(140, 22)
        Me.txtCreationDateTime.Mask = "####-##-##"
        Me.txtCreationDateTime.MaxLength = 10
        Me.txtCreationDateTime.Name = "txtCreationDateTime"
        Me.txtCreationDateTime.Size = New System.Drawing.Size(70, 20)
        Me.txtCreationDateTime.TabIndex = 5
        Me.txtCreationDateTime.Text = ""
        '
        'lblRevisionDateTime
        '
        Me.lblRevisionDateTime.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblRevisionDateTime.BackColor = System.Drawing.Color.WhiteSmoke
        Me.lblRevisionDateTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRevisionDateTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 7.8!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRevisionDateTime.Location = New System.Drawing.Point(369, 48)
        Me.lblRevisionDateTime.Name = "lblRevisionDateTime"
        Me.lblRevisionDateTime.Size = New System.Drawing.Size(70, 20)
        Me.lblRevisionDateTime.TabIndex = 125
        Me.lblRevisionDateTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'RevisionDateTimeLabel
        '
        Me.RevisionDateTimeLabel.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.RevisionDateTimeLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.RevisionDateTimeLabel.Location = New System.Drawing.Point(275, 48)
        Me.RevisionDateTimeLabel.Name = "RevisionDateTimeLabel"
        Me.RevisionDateTimeLabel.Size = New System.Drawing.Size(93, 20)
        Me.RevisionDateTimeLabel.TabIndex = 124
        Me.RevisionDateTimeLabel.Text = "Data reviso"
        Me.RevisionDateTimeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'DepositDateTimeLabel
        '
        Me.DepositDateTimeLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DepositDateTimeLabel.Location = New System.Drawing.Point(20, 48)
        Me.DepositDateTimeLabel.Name = "DepositDateTimeLabel"
        Me.DepositDateTimeLabel.Size = New System.Drawing.Size(113, 20)
        Me.DepositDateTimeLabel.TabIndex = 120
        Me.DepositDateTimeLabel.Text = "Data depsito"
        Me.DepositDateTimeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'CreationDateTimeLabel
        '
        Me.CreationDateTimeLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CreationDateTimeLabel.ForeColor = System.Drawing.Color.Red
        Me.CreationDateTimeLabel.Location = New System.Drawing.Point(20, 22)
        Me.CreationDateTimeLabel.Name = "CreationDateTimeLabel"
        Me.CreationDateTimeLabel.Size = New System.Drawing.Size(113, 20)
        Me.CreationDateTimeLabel.TabIndex = 85
        Me.CreationDateTimeLabel.Text = "Data criao"
        Me.CreationDateTimeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'ArchiveDateTimeLabel
        '
        Me.ArchiveDateTimeLabel.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ArchiveDateTimeLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ArchiveDateTimeLabel.ForeColor = System.Drawing.Color.Red
        Me.ArchiveDateTimeLabel.Location = New System.Drawing.Point(275, 22)
        Me.ArchiveDateTimeLabel.Name = "ArchiveDateTimeLabel"
        Me.ArchiveDateTimeLabel.Size = New System.Drawing.Size(93, 20)
        Me.ArchiveDateTimeLabel.TabIndex = 87
        Me.ArchiveDateTimeLabel.Text = "Data integrao"
        Me.ArchiveDateTimeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtDepositDateTime
        '
        Me.txtDepositDateTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDepositDateTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDepositDateTime.Location = New System.Drawing.Point(140, 48)
        Me.txtDepositDateTime.Mask = "####-##-##"
        Me.txtDepositDateTime.MaxLength = 10
        Me.txtDepositDateTime.Name = "txtDepositDateTime"
        Me.txtDepositDateTime.Size = New System.Drawing.Size(70, 20)
        Me.txtDepositDateTime.TabIndex = 7
        Me.txtDepositDateTime.Text = ""
        '
        'EntitiesGroupBox
        '
        Me.EntitiesGroupBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.EntitiesGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.EntitiesGroupBox.Controls.Add(Me.CaptureEntityIndividualLabel)
        Me.EntitiesGroupBox.Controls.Add(Me.txtCaptureEntityIndividual)
        Me.EntitiesGroupBox.Controls.Add(Me.txtResponsabilityEntity)
        Me.EntitiesGroupBox.Controls.Add(Me.ResponsabilityEntityLabel)
        Me.EntitiesGroupBox.Controls.Add(Me.CaptureEntityCorporateLabel)
        Me.EntitiesGroupBox.Controls.Add(Me.txtCaptureEntityCorporate)
        Me.EntitiesGroupBox.Location = New System.Drawing.Point(16, 340)
        Me.EntitiesGroupBox.Name = "EntitiesGroupBox"
        Me.EntitiesGroupBox.Size = New System.Drawing.Size(485, 104)
        Me.EntitiesGroupBox.TabIndex = 135
        Me.EntitiesGroupBox.TabStop = False
        Me.EntitiesGroupBox.Text = "Entidades"
        '
        'CaptureEntityIndividualLabel
        '
        Me.CaptureEntityIndividualLabel.BackColor = System.Drawing.Color.Transparent
        Me.CaptureEntityIndividualLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CaptureEntityIndividualLabel.Location = New System.Drawing.Point(20, 74)
        Me.CaptureEntityIndividualLabel.Name = "CaptureEntityIndividualLabel"
        Me.CaptureEntityIndividualLabel.Size = New System.Drawing.Size(113, 20)
        Me.CaptureEntityIndividualLabel.TabIndex = 112
        Me.CaptureEntityIndividualLabel.Text = "Nome operador"
        Me.CaptureEntityIndividualLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtCaptureEntityIndividual
        '
        Me.txtCaptureEntityIndividual.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtCaptureEntityIndividual.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtCaptureEntityIndividual.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtCaptureEntityIndividual.Location = New System.Drawing.Point(140, 74)
        Me.txtCaptureEntityIndividual.Name = "txtCaptureEntityIndividual"
        Me.txtCaptureEntityIndividual.Size = New System.Drawing.Size(299, 20)
        Me.txtCaptureEntityIndividual.TabIndex = 111
        Me.txtCaptureEntityIndividual.Text = ""
        '
        'txtResponsabilityEntity
        '
        Me.txtResponsabilityEntity.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtResponsabilityEntity.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtResponsabilityEntity.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtResponsabilityEntity.Location = New System.Drawing.Point(140, 22)
        Me.txtResponsabilityEntity.Name = "txtResponsabilityEntity"
        Me.txtResponsabilityEntity.Size = New System.Drawing.Size(299, 20)
        Me.txtResponsabilityEntity.TabIndex = 8
        Me.txtResponsabilityEntity.Text = ""
        '
        'ResponsabilityEntityLabel
        '
        Me.ResponsabilityEntityLabel.BackColor = System.Drawing.Color.Transparent
        Me.ResponsabilityEntityLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ResponsabilityEntityLabel.Location = New System.Drawing.Point(20, 22)
        Me.ResponsabilityEntityLabel.Name = "ResponsabilityEntityLabel"
        Me.ResponsabilityEntityLabel.Size = New System.Drawing.Size(113, 20)
        Me.ResponsabilityEntityLabel.TabIndex = 110
        Me.ResponsabilityEntityLabel.Text = "Entidade responsvel"
        Me.ResponsabilityEntityLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'CaptureEntityCorporateLabel
        '
        Me.CaptureEntityCorporateLabel.BackColor = System.Drawing.Color.Transparent
        Me.CaptureEntityCorporateLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CaptureEntityCorporateLabel.Location = New System.Drawing.Point(20, 48)
        Me.CaptureEntityCorporateLabel.Name = "CaptureEntityCorporateLabel"
        Me.CaptureEntityCorporateLabel.Size = New System.Drawing.Size(113, 20)
        Me.CaptureEntityCorporateLabel.TabIndex = 108
        Me.CaptureEntityCorporateLabel.Text = "Entidade produtora"
        Me.CaptureEntityCorporateLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtCaptureEntityCorporate
        '
        Me.txtCaptureEntityCorporate.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtCaptureEntityCorporate.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtCaptureEntityCorporate.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtCaptureEntityCorporate.Location = New System.Drawing.Point(140, 48)
        Me.txtCaptureEntityCorporate.Name = "txtCaptureEntityCorporate"
        Me.txtCaptureEntityCorporate.Size = New System.Drawing.Size(299, 20)
        Me.txtCaptureEntityCorporate.TabIndex = 9
        Me.txtCaptureEntityCorporate.Text = ""
        '
        'FooterMetadataPanel
        '
        Me.FooterMetadataPanel.BackColor = System.Drawing.SystemColors.Control
        Me.FooterMetadataPanel.Controls.Add(Me.AssociationMetadataButton)
        Me.FooterMetadataPanel.Controls.Add(Me.SaveMetadataButton)
        Me.FooterMetadataPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterMetadataPanel.Location = New System.Drawing.Point(0, 567)
        Me.FooterMetadataPanel.Name = "FooterMetadataPanel"
        Me.FooterMetadataPanel.Size = New System.Drawing.Size(709, 46)
        Me.FooterMetadataPanel.TabIndex = 135
        '
        'AssociationMetadataButton
        '
        Me.AssociationMetadataButton.BorderColor = System.Drawing.SystemColors.Control
        Me.AssociationMetadataButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AssociationMetadataButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AssociationMetadataButton.ButtonImage = CType(resources.GetObject("AssociationMetadataButton.ButtonImage"), System.Drawing.Image)
        Me.AssociationMetadataButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AssociationMetadataButton.ButtonShowShadow = True
        Me.AssociationMetadataButton.ButtonText = ""
        Me.AssociationMetadataButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AssociationMetadataButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AssociationMetadataButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.AssociationMetadataButton.Location = New System.Drawing.Point(64, 2)
        Me.AssociationMetadataButton.Name = "AssociationMetadataButton"
        Me.AssociationMetadataButton.Size = New System.Drawing.Size(42, 42)
        Me.AssociationMetadataButton.TabIndex = 8
        Me.AssociationMetadataButton.ToolTip = "Associar objectos digitais a descries"
        '
        'SaveMetadataButton
        '
        Me.SaveMetadataButton.BorderColor = System.Drawing.SystemColors.Control
        Me.SaveMetadataButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SaveMetadataButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SaveMetadataButton.ButtonImage = CType(resources.GetObject("SaveMetadataButton.ButtonImage"), System.Drawing.Image)
        Me.SaveMetadataButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SaveMetadataButton.ButtonShowShadow = True
        Me.SaveMetadataButton.ButtonText = ""
        Me.SaveMetadataButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.SaveMetadataButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SaveMetadataButton.Enabled = False
        Me.SaveMetadataButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.SaveMetadataButton.Location = New System.Drawing.Point(16, 2)
        Me.SaveMetadataButton.Name = "SaveMetadataButton"
        Me.SaveMetadataButton.Size = New System.Drawing.Size(42, 42)
        Me.SaveMetadataButton.TabIndex = 7
        Me.SaveMetadataButton.ToolTip = "Gravar"
        '
        'tpPreview
        '
        Me.tpPreview.Controls.Add(Me.PreviewPanel)
        Me.tpPreview.Controls.Add(Me.RigthSplitter)
        Me.tpPreview.Controls.Add(Me.TechnicalMetadataPanel)
        Me.tpPreview.Controls.Add(Me.FooterPreviewPanel)
        Me.tpPreview.Location = New System.Drawing.Point(4, 22)
        Me.tpPreview.Name = "tpPreview"
        Me.tpPreview.Size = New System.Drawing.Size(709, 613)
        Me.tpPreview.TabIndex = 0
        Me.tpPreview.Text = "Pr-visualizar"
        '
        'PreviewPanel
        '
        Me.PreviewPanel.Controls.Add(Me.ImageViewer)
        Me.PreviewPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.PreviewPanel.Location = New System.Drawing.Point(0, 0)
        Me.PreviewPanel.Name = "PreviewPanel"
        Me.PreviewPanel.Size = New System.Drawing.Size(456, 567)
        Me.PreviewPanel.TabIndex = 117
        '
        'ImageViewer
        '
        Me.ImageViewer.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ImageViewer.Filename = Nothing
        Me.ImageViewer.Image = Nothing
        Me.ImageViewer.Location = New System.Drawing.Point(0, 0)
        Me.ImageViewer.Name = "ImageViewer"
        Me.ImageViewer.SaveImageButtonVisible = False
        Me.ImageViewer.Size = New System.Drawing.Size(456, 567)
        Me.ImageViewer.TabIndex = 0
        '
        'RigthSplitter
        '
        Me.RigthSplitter.Dock = System.Windows.Forms.DockStyle.Right
        Me.RigthSplitter.Location = New System.Drawing.Point(456, 0)
        Me.RigthSplitter.MinSize = 250
        Me.RigthSplitter.Name = "RigthSplitter"
        Me.RigthSplitter.Size = New System.Drawing.Size(3, 567)
        Me.RigthSplitter.TabIndex = 116
        Me.RigthSplitter.TabStop = False
        '
        'TechnicalMetadataPanel
        '
        Me.TechnicalMetadataPanel.BackColor = System.Drawing.SystemColors.Control
        Me.TechnicalMetadataPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TechnicalMetadataPanel.Controls.Add(Me.FilePropertiesPanel)
        Me.TechnicalMetadataPanel.Controls.Add(Me.FileMetadataPanel)
        Me.TechnicalMetadataPanel.Dock = System.Windows.Forms.DockStyle.Right
        Me.TechnicalMetadataPanel.Location = New System.Drawing.Point(459, 0)
        Me.TechnicalMetadataPanel.Name = "TechnicalMetadataPanel"
        Me.TechnicalMetadataPanel.Size = New System.Drawing.Size(250, 567)
        Me.TechnicalMetadataPanel.TabIndex = 115
        '
        'FilePropertiesPanel
        '
        Me.FilePropertiesPanel.Controls.Add(Me.MetadataDataGrid)
        Me.FilePropertiesPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FilePropertiesPanel.Location = New System.Drawing.Point(0, 100)
        Me.FilePropertiesPanel.Name = "FilePropertiesPanel"
        Me.FilePropertiesPanel.Size = New System.Drawing.Size(248, 465)
        Me.FilePropertiesPanel.TabIndex = 1
        '
        'MetadataDataGrid
        '
        Me.MetadataDataGrid.BackColor = System.Drawing.Color.White
        Me.MetadataDataGrid.BackColorReadOnly = System.Drawing.Color.WhiteSmoke
        Me.MetadataDataGrid.Dock = System.Windows.Forms.DockStyle.Fill
        Me.MetadataDataGrid.LeftHeaderText = "Propriedade"
        Me.MetadataDataGrid.Location = New System.Drawing.Point(0, 0)
        Me.MetadataDataGrid.Name = "MetadataDataGrid"
        Me.MetadataDataGrid.RightHeaderText = "Valor"
        Me.MetadataDataGrid.Size = New System.Drawing.Size(248, 465)
        Me.MetadataDataGrid.TabIndex = 0
        '
        'FileMetadataPanel
        '
        Me.FileMetadataPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.FileMetadataPanel.Controls.Add(Me.FileMetadataDataGrid)
        Me.FileMetadataPanel.Dock = System.Windows.Forms.DockStyle.Top
        Me.FileMetadataPanel.Location = New System.Drawing.Point(0, 0)
        Me.FileMetadataPanel.Name = "FileMetadataPanel"
        Me.FileMetadataPanel.Size = New System.Drawing.Size(248, 100)
        Me.FileMetadataPanel.TabIndex = 0
        '
        'FileMetadataDataGrid
        '
        Me.FileMetadataDataGrid.AllowAddNewProperty = False
        Me.FileMetadataDataGrid.BackColor = System.Drawing.Color.FromArgb(CType(230, Byte), CType(255, Byte), CType(230, Byte))
        Me.FileMetadataDataGrid.BackColorReadOnly = System.Drawing.Color.FromArgb(CType(230, Byte), CType(255, Byte), CType(230, Byte))
        Me.FileMetadataDataGrid.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FileMetadataDataGrid.LeftHeaderText = "Propriedade"
        Me.FileMetadataDataGrid.Location = New System.Drawing.Point(0, 0)
        Me.FileMetadataDataGrid.Name = "FileMetadataDataGrid"
        Me.FileMetadataDataGrid.RightHeaderText = "Valor"
        Me.FileMetadataDataGrid.Size = New System.Drawing.Size(248, 100)
        Me.FileMetadataDataGrid.TabIndex = 0
        '
        'FooterPreviewPanel
        '
        Me.FooterPreviewPanel.Controls.Add(Me.AssociationPreviewButton)
        Me.FooterPreviewPanel.Controls.Add(Me.SavePreviewButton)
        Me.FooterPreviewPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterPreviewPanel.Location = New System.Drawing.Point(0, 567)
        Me.FooterPreviewPanel.Name = "FooterPreviewPanel"
        Me.FooterPreviewPanel.Size = New System.Drawing.Size(709, 46)
        Me.FooterPreviewPanel.TabIndex = 0
        '
        'AssociationPreviewButton
        '
        Me.AssociationPreviewButton.BorderColor = System.Drawing.SystemColors.Control
        Me.AssociationPreviewButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AssociationPreviewButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AssociationPreviewButton.ButtonImage = CType(resources.GetObject("AssociationPreviewButton.ButtonImage"), System.Drawing.Image)
        Me.AssociationPreviewButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AssociationPreviewButton.ButtonShowShadow = True
        Me.AssociationPreviewButton.ButtonText = ""
        Me.AssociationPreviewButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AssociationPreviewButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AssociationPreviewButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.AssociationPreviewButton.Location = New System.Drawing.Point(64, 2)
        Me.AssociationPreviewButton.Name = "AssociationPreviewButton"
        Me.AssociationPreviewButton.Size = New System.Drawing.Size(42, 42)
        Me.AssociationPreviewButton.TabIndex = 9
        Me.AssociationPreviewButton.ToolTip = "Associar objectos digitais a descries"
        '
        'SavePreviewButton
        '
        Me.SavePreviewButton.BorderColor = System.Drawing.SystemColors.Control
        Me.SavePreviewButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SavePreviewButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SavePreviewButton.ButtonImage = CType(resources.GetObject("SavePreviewButton.ButtonImage"), System.Drawing.Image)
        Me.SavePreviewButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SavePreviewButton.ButtonShowShadow = True
        Me.SavePreviewButton.ButtonText = ""
        Me.SavePreviewButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.SavePreviewButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SavePreviewButton.Enabled = False
        Me.SavePreviewButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.SavePreviewButton.Location = New System.Drawing.Point(16, 2)
        Me.SavePreviewButton.Name = "SavePreviewButton"
        Me.SavePreviewButton.Size = New System.Drawing.Size(42, 42)
        Me.SavePreviewButton.TabIndex = 6
        Me.SavePreviewButton.ToolTip = "Gravar"
        '
        'tpPreservationMetadata
        '
        Me.tpPreservationMetadata.BackColor = System.Drawing.Color.WhiteSmoke
        Me.tpPreservationMetadata.Controls.Add(Me.PreservationPanel)
        Me.tpPreservationMetadata.Controls.Add(Me.FooterPreservationPanel)
        Me.tpPreservationMetadata.Location = New System.Drawing.Point(4, 22)
        Me.tpPreservationMetadata.Name = "tpPreservationMetadata"
        Me.tpPreservationMetadata.Size = New System.Drawing.Size(709, 613)
        Me.tpPreservationMetadata.TabIndex = 2
        Me.tpPreservationMetadata.Text = "Informao preservao"
        Me.tpPreservationMetadata.Visible = False
        '
        'PreservationPanel
        '
        Me.PreservationPanel.BackColor = System.Drawing.Color.White
        Me.PreservationPanel.Controls.Add(Me.btnHistorical)
        Me.PreservationPanel.Controls.Add(Me.InfoPreservationGroupBox)
        Me.PreservationPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.PreservationPanel.Location = New System.Drawing.Point(0, 0)
        Me.PreservationPanel.Name = "PreservationPanel"
        Me.PreservationPanel.Size = New System.Drawing.Size(709, 567)
        Me.PreservationPanel.TabIndex = 140
        '
        'btnHistorical
        '
        Me.btnHistorical.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnHistorical.BackColor = System.Drawing.Color.White
        Me.btnHistorical.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnHistorical.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnHistorical.ImageAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.btnHistorical.Location = New System.Drawing.Point(578, 332)
        Me.btnHistorical.Name = "btnHistorical"
        Me.btnHistorical.Size = New System.Drawing.Size(88, 25)
        Me.btnHistorical.TabIndex = 62
        Me.btnHistorical.Text = "Histrico"
        '
        'InfoPreservationGroupBox
        '
        Me.InfoPreservationGroupBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.InfoPreservationGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.InfoPreservationGroupBox.Controls.Add(Me.btnChooseReformattingNorms)
        Me.InfoPreservationGroupBox.Controls.Add(Me.btnChooseReformattingMethod)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lbxReformattingNormsChoosen)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblReformattingNorms)
        Me.InfoPreservationGroupBox.Controls.Add(Me.txtReformattingMethod)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblReformattingMethod)
        Me.InfoPreservationGroupBox.Controls.Add(Me.txtParameters)
        Me.InfoPreservationGroupBox.Controls.Add(Me.txtInputFormat)
        Me.InfoPreservationGroupBox.Controls.Add(Me.txtRenderEngine)
        Me.InfoPreservationGroupBox.Controls.Add(Me.txtPlatform)
        Me.InfoPreservationGroupBox.Controls.Add(Me.txtTransformer)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblTransformerObject)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblInputFormat)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblRenderEngine)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblParameters)
        Me.InfoPreservationGroupBox.Controls.Add(Me.lblPlatform)
        Me.InfoPreservationGroupBox.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.InfoPreservationGroupBox.Location = New System.Drawing.Point(16, 16)
        Me.InfoPreservationGroupBox.Name = "InfoPreservationGroupBox"
        Me.InfoPreservationGroupBox.Size = New System.Drawing.Size(650, 304)
        Me.InfoPreservationGroupBox.TabIndex = 61
        Me.InfoPreservationGroupBox.TabStop = False
        Me.InfoPreservationGroupBox.Text = "Estrutura de reformatao do objecto digital"
        '
        'btnChooseReformattingNorms
        '
        Me.btnChooseReformattingNorms.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnChooseReformattingNorms.BackColor = System.Drawing.Color.White
        Me.btnChooseReformattingNorms.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnChooseReformattingNorms.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnChooseReformattingNorms.Location = New System.Drawing.Point(599, 214)
        Me.btnChooseReformattingNorms.Name = "btnChooseReformattingNorms"
        Me.btnChooseReformattingNorms.Size = New System.Drawing.Size(24, 20)
        Me.btnChooseReformattingNorms.TabIndex = 58
        Me.btnChooseReformattingNorms.Text = "..."
        '
        'btnChooseReformattingMethod
        '
        Me.btnChooseReformattingMethod.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnChooseReformattingMethod.BackColor = System.Drawing.Color.White
        Me.btnChooseReformattingMethod.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnChooseReformattingMethod.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnChooseReformattingMethod.Location = New System.Drawing.Point(599, 185)
        Me.btnChooseReformattingMethod.Name = "btnChooseReformattingMethod"
        Me.btnChooseReformattingMethod.Size = New System.Drawing.Size(24, 20)
        Me.btnChooseReformattingMethod.TabIndex = 56
        Me.btnChooseReformattingMethod.Text = "..."
        '
        'lbxReformattingNormsChoosen
        '
        Me.lbxReformattingNormsChoosen.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lbxReformattingNormsChoosen.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lbxReformattingNormsChoosen.Location = New System.Drawing.Point(144, 214)
        Me.lbxReformattingNormsChoosen.Name = "lbxReformattingNormsChoosen"
        Me.lbxReformattingNormsChoosen.Size = New System.Drawing.Size(448, 80)
        Me.lbxReformattingNormsChoosen.TabIndex = 57
        '
        'lblReformattingNorms
        '
        Me.lblReformattingNorms.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblReformattingNorms.Location = New System.Drawing.Point(8, 214)
        Me.lblReformattingNorms.Name = "lblReformattingNorms"
        Me.lblReformattingNorms.Size = New System.Drawing.Size(136, 21)
        Me.lblReformattingNorms.TabIndex = 104
        Me.lblReformattingNorms.Text = "Normas de reformatao"
        Me.lblReformattingNorms.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtReformattingMethod
        '
        Me.txtReformattingMethod.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtReformattingMethod.BackColor = System.Drawing.Color.White
        Me.txtReformattingMethod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtReformattingMethod.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtReformattingMethod.Location = New System.Drawing.Point(144, 185)
        Me.txtReformattingMethod.Name = "txtReformattingMethod"
        Me.txtReformattingMethod.ReadOnly = True
        Me.txtReformattingMethod.Size = New System.Drawing.Size(448, 20)
        Me.txtReformattingMethod.TabIndex = 55
        Me.txtReformattingMethod.Text = ""
        '
        'lblReformattingMethod
        '
        Me.lblReformattingMethod.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblReformattingMethod.Location = New System.Drawing.Point(7, 185)
        Me.lblReformattingMethod.Name = "lblReformattingMethod"
        Me.lblReformattingMethod.Size = New System.Drawing.Size(136, 21)
        Me.lblReformattingMethod.TabIndex = 102
        Me.lblReformattingMethod.Text = "Mtodo de reformatao"
        Me.lblReformattingMethod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtParameters
        '
        Me.txtParameters.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtParameters.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtParameters.Location = New System.Drawing.Point(144, 144)
        Me.txtParameters.Multiline = True
        Me.txtParameters.Name = "txtParameters"
        Me.txtParameters.Size = New System.Drawing.Size(448, 32)
        Me.txtParameters.TabIndex = 54
        Me.txtParameters.Text = ""
        '
        'txtInputFormat
        '
        Me.txtInputFormat.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtInputFormat.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtInputFormat.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtInputFormat.Location = New System.Drawing.Point(144, 115)
        Me.txtInputFormat.Name = "txtInputFormat"
        Me.txtInputFormat.Size = New System.Drawing.Size(448, 20)
        Me.txtInputFormat.TabIndex = 53
        Me.txtInputFormat.Text = ""
        '
        'txtRenderEngine
        '
        Me.txtRenderEngine.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtRenderEngine.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtRenderEngine.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtRenderEngine.Location = New System.Drawing.Point(144, 86)
        Me.txtRenderEngine.Name = "txtRenderEngine"
        Me.txtRenderEngine.Size = New System.Drawing.Size(448, 20)
        Me.txtRenderEngine.TabIndex = 52
        Me.txtRenderEngine.Text = ""
        '
        'txtPlatform
        '
        Me.txtPlatform.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtPlatform.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtPlatform.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtPlatform.Location = New System.Drawing.Point(144, 57)
        Me.txtPlatform.Name = "txtPlatform"
        Me.txtPlatform.Size = New System.Drawing.Size(448, 20)
        Me.txtPlatform.TabIndex = 51
        Me.txtPlatform.Text = ""
        '
        'txtTransformer
        '
        Me.txtTransformer.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtTransformer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtTransformer.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtTransformer.Location = New System.Drawing.Point(144, 28)
        Me.txtTransformer.Name = "txtTransformer"
        Me.txtTransformer.Size = New System.Drawing.Size(448, 20)
        Me.txtTransformer.TabIndex = 50
        Me.txtTransformer.Text = ""
        '
        'lblTransformerObject
        '
        Me.lblTransformerObject.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTransformerObject.ForeColor = System.Drawing.Color.Red
        Me.lblTransformerObject.Location = New System.Drawing.Point(7, 28)
        Me.lblTransformerObject.Name = "lblTransformerObject"
        Me.lblTransformerObject.Size = New System.Drawing.Size(136, 21)
        Me.lblTransformerObject.TabIndex = 37
        Me.lblTransformerObject.Text = "Transformador"
        Me.lblTransformerObject.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblInputFormat
        '
        Me.lblInputFormat.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblInputFormat.Location = New System.Drawing.Point(7, 115)
        Me.lblInputFormat.Name = "lblInputFormat"
        Me.lblInputFormat.Size = New System.Drawing.Size(136, 21)
        Me.lblInputFormat.TabIndex = 47
        Me.lblInputFormat.Text = "Formato de entrada"
        Me.lblInputFormat.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblRenderEngine
        '
        Me.lblRenderEngine.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRenderEngine.Location = New System.Drawing.Point(7, 86)
        Me.lblRenderEngine.Name = "lblRenderEngine"
        Me.lblRenderEngine.Size = New System.Drawing.Size(136, 21)
        Me.lblRenderEngine.TabIndex = 45
        Me.lblRenderEngine.Text = "Dispositivo visualizao"
        Me.lblRenderEngine.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblParameters
        '
        Me.lblParameters.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblParameters.Location = New System.Drawing.Point(7, 144)
        Me.lblParameters.Name = "lblParameters"
        Me.lblParameters.Size = New System.Drawing.Size(136, 21)
        Me.lblParameters.TabIndex = 43
        Me.lblParameters.Text = "Parmetros"
        Me.lblParameters.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblPlatform
        '
        Me.lblPlatform.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPlatform.Location = New System.Drawing.Point(7, 57)
        Me.lblPlatform.Name = "lblPlatform"
        Me.lblPlatform.Size = New System.Drawing.Size(136, 21)
        Me.lblPlatform.TabIndex = 41
        Me.lblPlatform.Text = "Plataforma"
        Me.lblPlatform.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'FooterPreservationPanel
        '
        Me.FooterPreservationPanel.BackColor = System.Drawing.SystemColors.Control
        Me.FooterPreservationPanel.Controls.Add(Me.AssociationPreservationButton)
        Me.FooterPreservationPanel.Controls.Add(Me.SavePreservationButton)
        Me.FooterPreservationPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterPreservationPanel.Location = New System.Drawing.Point(0, 567)
        Me.FooterPreservationPanel.Name = "FooterPreservationPanel"
        Me.FooterPreservationPanel.Size = New System.Drawing.Size(709, 46)
        Me.FooterPreservationPanel.TabIndex = 139
        '
        'AssociationPreservationButton
        '
        Me.AssociationPreservationButton.BorderColor = System.Drawing.SystemColors.Control
        Me.AssociationPreservationButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AssociationPreservationButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AssociationPreservationButton.ButtonImage = CType(resources.GetObject("AssociationPreservationButton.ButtonImage"), System.Drawing.Image)
        Me.AssociationPreservationButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AssociationPreservationButton.ButtonShowShadow = True
        Me.AssociationPreservationButton.ButtonText = ""
        Me.AssociationPreservationButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AssociationPreservationButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AssociationPreservationButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.AssociationPreservationButton.Location = New System.Drawing.Point(64, 2)
        Me.AssociationPreservationButton.Name = "AssociationPreservationButton"
        Me.AssociationPreservationButton.Size = New System.Drawing.Size(42, 42)
        Me.AssociationPreservationButton.TabIndex = 9
        Me.AssociationPreservationButton.ToolTip = "Associar objectos digitais a descries"
        '
        'SavePreservationButton
        '
        Me.SavePreservationButton.BorderColor = System.Drawing.SystemColors.Control
        Me.SavePreservationButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SavePreservationButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SavePreservationButton.ButtonImage = CType(resources.GetObject("SavePreservationButton.ButtonImage"), System.Drawing.Image)
        Me.SavePreservationButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SavePreservationButton.ButtonShowShadow = True
        Me.SavePreservationButton.ButtonText = ""
        Me.SavePreservationButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.SavePreservationButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SavePreservationButton.Enabled = False
        Me.SavePreservationButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.SavePreservationButton.Location = New System.Drawing.Point(16, 2)
        Me.SavePreservationButton.Name = "SavePreservationButton"
        Me.SavePreservationButton.Size = New System.Drawing.Size(42, 42)
        Me.SavePreservationButton.TabIndex = 7
        Me.SavePreservationButton.ToolTip = "Gravar"
        '
        'tpAddFiles
        '
        Me.tpAddFiles.Controls.Add(Me.FilesPanel)
        Me.tpAddFiles.Location = New System.Drawing.Point(4, 22)
        Me.tpAddFiles.Name = "tpAddFiles"
        Me.tpAddFiles.Size = New System.Drawing.Size(709, 613)
        Me.tpAddFiles.TabIndex = 3
        Me.tpAddFiles.Text = "Documentos"
        Me.tpAddFiles.Visible = False
        '
        'FilesPanel
        '
        Me.FilesPanel.Controls.Add(Me.DragDropListView)
        Me.FilesPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FilesPanel.Location = New System.Drawing.Point(0, 0)
        Me.FilesPanel.Name = "FilesPanel"
        Me.FilesPanel.Size = New System.Drawing.Size(709, 613)
        Me.FilesPanel.TabIndex = 137
        '
        'DragDropListView
        '
        Me.DragDropListView.CollumnHeaderText = ""
        Me.DragDropListView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DragDropListView.Location = New System.Drawing.Point(0, 0)
        Me.DragDropListView.Name = "DragDropListView"
        Me.DragDropListView.SaveButtonEnabled = False
        Me.DragDropListView.Size = New System.Drawing.Size(709, 613)
        Me.DragDropListView.TabIndex = 1
        Me.DragDropListView.UserLogon = Nothing
        Me.DragDropListView.View = System.Windows.Forms.View.LargeIcon
        '
        'tpMessage
        '
        Me.tpMessage.BackColor = System.Drawing.Color.White
        Me.tpMessage.Controls.Add(Me.lblMessage)
        Me.tpMessage.Controls.Add(Me.lblMessageTitle)
        Me.tpMessage.Location = New System.Drawing.Point(4, 22)
        Me.tpMessage.Name = "tpMessage"
        Me.tpMessage.Size = New System.Drawing.Size(709, 613)
        Me.tpMessage.TabIndex = 4
        '
        'lblMessage
        '
        Me.lblMessage.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblMessage.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMessage.Location = New System.Drawing.Point(42, 248)
        Me.lblMessage.Name = "lblMessage"
        Me.lblMessage.Size = New System.Drawing.Size(624, 140)
        Me.lblMessage.TabIndex = 1
        Me.lblMessage.Text = "O documento que tentou visualizar no se encontra disponvel devido a restries " & _
        "de acesso ou por no se encontrar no local especificado. Por favor, tente outra " & _
        "opo de visualizao (e.g. original, derivada ou miniatura)."
        Me.lblMessage.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'lblMessageTitle
        '
        Me.lblMessageTitle.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblMessageTitle.Font = New System.Drawing.Font("Arial", 27.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMessageTitle.Location = New System.Drawing.Point(40, 100)
        Me.lblMessageTitle.Name = "lblMessageTitle"
        Me.lblMessageTitle.Size = New System.Drawing.Size(624, 116)
        Me.lblMessageTitle.TabIndex = 0
        Me.lblMessageTitle.Text = "Documento indisponvel"
        Me.lblMessageTitle.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'LeftSplitter
        '
        Me.LeftSplitter.Location = New System.Drawing.Point(206, 6)
        Me.LeftSplitter.MinSize = 200
        Me.LeftSplitter.Name = "LeftSplitter"
        Me.LeftSplitter.Size = New System.Drawing.Size(3, 639)
        Me.LeftSplitter.TabIndex = 113
        Me.LeftSplitter.TabStop = False
        '
        'pnlTvwContainer
        '
        Me.pnlTvwContainer.Controls.Add(Me.TabControlDigitalObjects)
        Me.pnlTvwContainer.Dock = System.Windows.Forms.DockStyle.Left
        Me.pnlTvwContainer.Location = New System.Drawing.Point(6, 6)
        Me.pnlTvwContainer.Name = "pnlTvwContainer"
        Me.pnlTvwContainer.Size = New System.Drawing.Size(200, 639)
        Me.pnlTvwContainer.TabIndex = 115
        '
        'TabControlDigitalObjects
        '
        Me.TabControlDigitalObjects.Controls.Add(Me.PublishedDigitalObjectsTabPage)
        Me.TabControlDigitalObjects.Controls.Add(Me.UnpublishedDigitalObjectsTabPage)
        Me.TabControlDigitalObjects.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TabControlDigitalObjects.Location = New System.Drawing.Point(0, 0)
        Me.TabControlDigitalObjects.Name = "TabControlDigitalObjects"
        Me.TabControlDigitalObjects.SelectedIndex = 0
        Me.TabControlDigitalObjects.Size = New System.Drawing.Size(200, 639)
        Me.TabControlDigitalObjects.TabIndex = 1
        '
        'PublishedDigitalObjectsTabPage
        '
        Me.PublishedDigitalObjectsTabPage.Controls.Add(Me.PublishedDigitalObjectsTree)
        Me.PublishedDigitalObjectsTabPage.Controls.Add(Me.pnlToolBarTvw)
        Me.PublishedDigitalObjectsTabPage.Location = New System.Drawing.Point(4, 22)
        Me.PublishedDigitalObjectsTabPage.Name = "PublishedDigitalObjectsTabPage"
        Me.PublishedDigitalObjectsTabPage.Size = New System.Drawing.Size(192, 613)
        Me.PublishedDigitalObjectsTabPage.TabIndex = 0
        Me.PublishedDigitalObjectsTabPage.Text = "Publicados"
        '
        'PublishedDigitalObjectsTree
        '
        Me.PublishedDigitalObjectsTree.CheckBoxes = False
        Me.PublishedDigitalObjectsTree.Dock = System.Windows.Forms.DockStyle.Fill
        Me.PublishedDigitalObjectsTree.ImageIndex = 0
        Me.PublishedDigitalObjectsTree.LastSelectedNode = Nothing
        Me.PublishedDigitalObjectsTree.Location = New System.Drawing.Point(0, 0)
        Me.PublishedDigitalObjectsTree.Name = "PublishedDigitalObjectsTree"
        Me.PublishedDigitalObjectsTree.NodeDrag = Nothing
        Me.PublishedDigitalObjectsTree.Operation = DigitArq.UserControls.DigitalObjectsTree.DigitalObjectsTree.eOperation.NONE
        Me.PublishedDigitalObjectsTree.SelectedNode = Nothing
        Me.PublishedDigitalObjectsTree.Size = New System.Drawing.Size(192, 567)
        Me.PublishedDigitalObjectsTree.TabIndex = 5
        Me.PublishedDigitalObjectsTree.UserLogon = Nothing
        '
        'pnlToolBarTvw
        '
        Me.pnlToolBarTvw.Controls.Add(Me.UnpublishButton)
        Me.pnlToolBarTvw.Controls.Add(Me.SearchDigitalObjectButton)
        Me.pnlToolBarTvw.Controls.Add(Me.AddDigitalObjectButton)
        Me.pnlToolBarTvw.Controls.Add(Me.RemoveDigitalObjectButton)
        Me.pnlToolBarTvw.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.pnlToolBarTvw.Location = New System.Drawing.Point(0, 567)
        Me.pnlToolBarTvw.Name = "pnlToolBarTvw"
        Me.pnlToolBarTvw.Size = New System.Drawing.Size(192, 46)
        Me.pnlToolBarTvw.TabIndex = 4
        '
        'UnpublishButton
        '
        Me.UnpublishButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.UnpublishButton.BorderColor = System.Drawing.SystemColors.Control
        Me.UnpublishButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.UnpublishButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.UnpublishButton.ButtonImage = CType(resources.GetObject("UnpublishButton.ButtonImage"), System.Drawing.Image)
        Me.UnpublishButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.UnpublishButton.ButtonShowShadow = True
        Me.UnpublishButton.ButtonText = ""
        Me.UnpublishButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.UnpublishButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.UnpublishButton.Enabled = False
        Me.UnpublishButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.UnpublishButton.Location = New System.Drawing.Point(148, 2)
        Me.UnpublishButton.Name = "UnpublishButton"
        Me.UnpublishButton.Size = New System.Drawing.Size(42, 42)
        Me.UnpublishButton.TabIndex = 5
        Me.UnpublishButton.ToolTip = "Retirar da Web"
        '
        'SearchDigitalObjectButton
        '
        Me.SearchDigitalObjectButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.SearchDigitalObjectButton.BorderColor = System.Drawing.SystemColors.Control
        Me.SearchDigitalObjectButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SearchDigitalObjectButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SearchDigitalObjectButton.ButtonImage = CType(resources.GetObject("SearchDigitalObjectButton.ButtonImage"), System.Drawing.Image)
        Me.SearchDigitalObjectButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SearchDigitalObjectButton.ButtonShowShadow = True
        Me.SearchDigitalObjectButton.ButtonText = ""
        Me.SearchDigitalObjectButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.SearchDigitalObjectButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SearchDigitalObjectButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.SearchDigitalObjectButton.Location = New System.Drawing.Point(100, 2)
        Me.SearchDigitalObjectButton.Name = "SearchDigitalObjectButton"
        Me.SearchDigitalObjectButton.Size = New System.Drawing.Size(42, 42)
        Me.SearchDigitalObjectButton.TabIndex = 4
        Me.SearchDigitalObjectButton.ToolTip = "Pesquisar objectos digitais"
        '
        'AddDigitalObjectButton
        '
        Me.AddDigitalObjectButton.BorderColor = System.Drawing.SystemColors.Control
        Me.AddDigitalObjectButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AddDigitalObjectButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AddDigitalObjectButton.ButtonImage = CType(resources.GetObject("AddDigitalObjectButton.ButtonImage"), System.Drawing.Image)
        Me.AddDigitalObjectButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AddDigitalObjectButton.ButtonShowShadow = True
        Me.AddDigitalObjectButton.ButtonText = ""
        Me.AddDigitalObjectButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AddDigitalObjectButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AddDigitalObjectButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.AddDigitalObjectButton.Location = New System.Drawing.Point(4, 2)
        Me.AddDigitalObjectButton.Name = "AddDigitalObjectButton"
        Me.AddDigitalObjectButton.Size = New System.Drawing.Size(42, 42)
        Me.AddDigitalObjectButton.TabIndex = 3
        Me.AddDigitalObjectButton.ToolTip = "Adicionar objecto digital"
        '
        'RemoveDigitalObjectButton
        '
        Me.RemoveDigitalObjectButton.BorderColor = System.Drawing.SystemColors.Control
        Me.RemoveDigitalObjectButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.RemoveDigitalObjectButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.RemoveDigitalObjectButton.ButtonImage = CType(resources.GetObject("RemoveDigitalObjectButton.ButtonImage"), System.Drawing.Image)
        Me.RemoveDigitalObjectButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.RemoveDigitalObjectButton.ButtonShowShadow = True
        Me.RemoveDigitalObjectButton.ButtonText = ""
        Me.RemoveDigitalObjectButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.RemoveDigitalObjectButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.RemoveDigitalObjectButton.Enabled = False
        Me.RemoveDigitalObjectButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.RemoveDigitalObjectButton.Location = New System.Drawing.Point(52, 2)
        Me.RemoveDigitalObjectButton.Name = "RemoveDigitalObjectButton"
        Me.RemoveDigitalObjectButton.Size = New System.Drawing.Size(42, 42)
        Me.RemoveDigitalObjectButton.TabIndex = 2
        Me.RemoveDigitalObjectButton.ToolTip = "Remover objectos digitais"
        '
        'UnpublishedDigitalObjectsTabPage
        '
        Me.UnpublishedDigitalObjectsTabPage.Controls.Add(Me.UnpublishedDigitalObjectsTree)
        Me.UnpublishedDigitalObjectsTabPage.Controls.Add(Me.Panel2)
        Me.UnpublishedDigitalObjectsTabPage.Location = New System.Drawing.Point(4, 22)
        Me.UnpublishedDigitalObjectsTabPage.Name = "UnpublishedDigitalObjectsTabPage"
        Me.UnpublishedDigitalObjectsTabPage.Size = New System.Drawing.Size(192, 613)
        Me.UnpublishedDigitalObjectsTabPage.TabIndex = 1
        Me.UnpublishedDigitalObjectsTabPage.Text = "No publicados"
        '
        'UnpublishedDigitalObjectsTree
        '
        Me.UnpublishedDigitalObjectsTree.CheckBoxes = False
        Me.UnpublishedDigitalObjectsTree.Dock = System.Windows.Forms.DockStyle.Fill
        Me.UnpublishedDigitalObjectsTree.ImageIndex = 0
        Me.UnpublishedDigitalObjectsTree.LastSelectedNode = Nothing
        Me.UnpublishedDigitalObjectsTree.Location = New System.Drawing.Point(0, 0)
        Me.UnpublishedDigitalObjectsTree.Name = "UnpublishedDigitalObjectsTree"
        Me.UnpublishedDigitalObjectsTree.NodeDrag = Nothing
        Me.UnpublishedDigitalObjectsTree.Operation = DigitArq.UserControls.DigitalObjectsTree.DigitalObjectsTree.eOperation.NONE
        Me.UnpublishedDigitalObjectsTree.SelectedNode = Nothing
        Me.UnpublishedDigitalObjectsTree.Size = New System.Drawing.Size(192, 567)
        Me.UnpublishedDigitalObjectsTree.TabIndex = 6
        Me.UnpublishedDigitalObjectsTree.UserLogon = Nothing
        '
        'Panel2
        '
        Me.Panel2.Controls.Add(Me.PublishButton)
        Me.Panel2.Controls.Add(Me.SearchUnpublishedDigitalObjectButton)
        Me.Panel2.Controls.Add(Me.AddUnpublishedDigitalObjectButton)
        Me.Panel2.Controls.Add(Me.RemoveUnpublishedDigitalObjectButton)
        Me.Panel2.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Panel2.Location = New System.Drawing.Point(0, 567)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(192, 46)
        Me.Panel2.TabIndex = 5
        '
        'PublishButton
        '
        Me.PublishButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.PublishButton.BorderColor = System.Drawing.SystemColors.Control
        Me.PublishButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.PublishButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.PublishButton.ButtonImage = CType(resources.GetObject("PublishButton.ButtonImage"), System.Drawing.Image)
        Me.PublishButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.PublishButton.ButtonShowShadow = True
        Me.PublishButton.ButtonText = ""
        Me.PublishButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.PublishButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.PublishButton.Enabled = False
        Me.PublishButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.PublishButton.Location = New System.Drawing.Point(148, 2)
        Me.PublishButton.Name = "PublishButton"
        Me.PublishButton.Size = New System.Drawing.Size(42, 42)
        Me.PublishButton.TabIndex = 5
        Me.PublishButton.ToolTip = "Publicar na Web"
        '
        'SearchUnpublishedDigitalObjectButton
        '
        Me.SearchUnpublishedDigitalObjectButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.SearchUnpublishedDigitalObjectButton.BorderColor = System.Drawing.SystemColors.Control
        Me.SearchUnpublishedDigitalObjectButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SearchUnpublishedDigitalObjectButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SearchUnpublishedDigitalObjectButton.ButtonImage = CType(resources.GetObject("SearchUnpublishedDigitalObjectButton.ButtonImage"), System.Drawing.Image)
        Me.SearchUnpublishedDigitalObjectButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SearchUnpublishedDigitalObjectButton.ButtonShowShadow = True
        Me.SearchUnpublishedDigitalObjectButton.ButtonText = ""
        Me.SearchUnpublishedDigitalObjectButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.SearchUnpublishedDigitalObjectButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SearchUnpublishedDigitalObjectButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.SearchUnpublishedDigitalObjectButton.Location = New System.Drawing.Point(100, 2)
        Me.SearchUnpublishedDigitalObjectButton.Name = "SearchUnpublishedDigitalObjectButton"
        Me.SearchUnpublishedDigitalObjectButton.Size = New System.Drawing.Size(42, 42)
        Me.SearchUnpublishedDigitalObjectButton.TabIndex = 4
        Me.SearchUnpublishedDigitalObjectButton.ToolTip = "Pesquisar objectos digitais"
        '
        'AddUnpublishedDigitalObjectButton
        '
        Me.AddUnpublishedDigitalObjectButton.BorderColor = System.Drawing.SystemColors.Control
        Me.AddUnpublishedDigitalObjectButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AddUnpublishedDigitalObjectButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AddUnpublishedDigitalObjectButton.ButtonImage = CType(resources.GetObject("AddUnpublishedDigitalObjectButton.ButtonImage"), System.Drawing.Image)
        Me.AddUnpublishedDigitalObjectButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AddUnpublishedDigitalObjectButton.ButtonShowShadow = True
        Me.AddUnpublishedDigitalObjectButton.ButtonText = ""
        Me.AddUnpublishedDigitalObjectButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AddUnpublishedDigitalObjectButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AddUnpublishedDigitalObjectButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.AddUnpublishedDigitalObjectButton.Location = New System.Drawing.Point(4, 2)
        Me.AddUnpublishedDigitalObjectButton.Name = "AddUnpublishedDigitalObjectButton"
        Me.AddUnpublishedDigitalObjectButton.Size = New System.Drawing.Size(42, 42)
        Me.AddUnpublishedDigitalObjectButton.TabIndex = 3
        Me.AddUnpublishedDigitalObjectButton.ToolTip = "Adicionar objecto digital"
        '
        'RemoveUnpublishedDigitalObjectButton
        '
        Me.RemoveUnpublishedDigitalObjectButton.BorderColor = System.Drawing.SystemColors.Control
        Me.RemoveUnpublishedDigitalObjectButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.RemoveUnpublishedDigitalObjectButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.RemoveUnpublishedDigitalObjectButton.ButtonImage = CType(resources.GetObject("RemoveUnpublishedDigitalObjectButton.ButtonImage"), System.Drawing.Image)
        Me.RemoveUnpublishedDigitalObjectButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.RemoveUnpublishedDigitalObjectButton.ButtonShowShadow = True
        Me.RemoveUnpublishedDigitalObjectButton.ButtonText = ""
        Me.RemoveUnpublishedDigitalObjectButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.RemoveUnpublishedDigitalObjectButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.RemoveUnpublishedDigitalObjectButton.Enabled = False
        Me.RemoveUnpublishedDigitalObjectButton.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.RemoveUnpublishedDigitalObjectButton.Location = New System.Drawing.Point(52, 2)
        Me.RemoveUnpublishedDigitalObjectButton.Name = "RemoveUnpublishedDigitalObjectButton"
        Me.RemoveUnpublishedDigitalObjectButton.Size = New System.Drawing.Size(42, 42)
        Me.RemoveUnpublishedDigitalObjectButton.TabIndex = 2
        Me.RemoveUnpublishedDigitalObjectButton.ToolTip = "Remover objectos digitais"
        '
        'ListViewImageList
        '
        Me.ListViewImageList.ImageSize = New System.Drawing.Size(100, 100)
        Me.ListViewImageList.ImageStream = CType(resources.GetObject("ListViewImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ListViewImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(932, 673)
        Me.Controls.Add(Me.pnlMain)
        Me.Controls.Add(Me.sbMain)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.IsMdiContainer = True
        Me.Menu = Me.MainMenu
        Me.MinimumSize = New System.Drawing.Size(900, 700)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Modulo de Gesto de Objectos Digitais"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.pnlMain.ResumeLayout(False)
        Me.TabControl.ResumeLayout(False)
        Me.tpMetadata.ResumeLayout(False)
        Me.MetadataPanel.ResumeLayout(False)
        Me.InfoGeralGroupBox.ResumeLayout(False)
        Me.PreservationGroupBox.ResumeLayout(False)
        Me.DatesGroupBox.ResumeLayout(False)
        Me.EntitiesGroupBox.ResumeLayout(False)
        Me.FooterMetadataPanel.ResumeLayout(False)
        Me.tpPreview.ResumeLayout(False)
        Me.PreviewPanel.ResumeLayout(False)
        Me.TechnicalMetadataPanel.ResumeLayout(False)
        Me.FilePropertiesPanel.ResumeLayout(False)
        Me.FileMetadataPanel.ResumeLayout(False)
        Me.FooterPreviewPanel.ResumeLayout(False)
        Me.tpPreservationMetadata.ResumeLayout(False)
        Me.PreservationPanel.ResumeLayout(False)
        Me.InfoPreservationGroupBox.ResumeLayout(False)
        Me.FooterPreservationPanel.ResumeLayout(False)
        Me.tpAddFiles.ResumeLayout(False)
        Me.FilesPanel.ResumeLayout(False)
        Me.tpMessage.ResumeLayout(False)
        Me.pnlTvwContainer.ResumeLayout(False)
        Me.TabControlDigitalObjects.ResumeLayout(False)
        Me.PublishedDigitalObjectsTabPage.ResumeLayout(False)
        Me.pnlToolBarTvw.ResumeLayout(False)
        Me.UnpublishedDigitalObjectsTabPage.ResumeLayout(False)
        Me.Panel2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region


#Region "Private properties"

    Private myProjectID As Int64
    Private myProjectName As String

    Private myDigitalObjectID As Int64
    Private myDOName As String
    Private mySelectedNode As TreeNode = Nothing
    Private myLastSelectedNode As TreeNode = Nothing
    Private myRootNode As TreeNode = Nothing

    Private Database As New SqlCommands(USER_LOGON)
    Private IsLoaded As Boolean = False
    Private IsEdited As Boolean

    Private configReader As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader

    Private FormatsArray() As String = {"TIFF", "TIF", "JPEG", "JPG", "PNG", "GIF", "PDF", "DOC", "FLV", "MP3"}
    Private Formats As New ArrayList(FormatsArray)

    Private myImageViewer As ImageViewer
    Private myPDFViewer As PDFViewer
    Private myWordViewer As WordViewer
    Private myVideoViewer As VideoViewer
    
    Private myProgressDialog As ProgressDialog

    Private myDOFileView As DOFile.Type = DOFile.Type.Dissemination

    Private myFiles() As String

    Private myOrderBy As String = DIGITAL_OBJECT_NAME

    Public Enum Operation
        NONE
        COPY
        CUT
    End Enum
    Private myOperation As Operation = Operation.NONE

    Private Enum Export
        ALL
        DISSEMINATIONS
        ORIGINALS
    End Enum

    Private MGUP As New SQLDataBase

#End Region

#Region "Constants"

    Const NEW_NODE_NAME = "Novo"
    Const ADMINISTRATOR = "Administrador"
    Const APPLICATION_CODE = "MGOD"
    Const DIGITAL_OBJECT_NAME = "Name"
    Const DIGITAL_OBJECT_ID = "DigitalObjectID"

#End Region

#Region "Properties"

    Private Property ProjectID() As Int64
        Get
            Return myProjectID
        End Get
        Set(ByVal Value As Int64)
            myProjectID = Value
        End Set
    End Property

    Private Property ProjectName() As String
        Get
            Return myProjectName
        End Get
        Set(ByVal Value As String)
            myProjectName = Value
        End Set
    End Property

    Private ReadOnly Property DigitalObject() As DigitalObject
        Get
            Dim DObject As New DigitalObject
            DObject.DigitalObjectID = Me.DigitalObjectID
            DObject.ProjectID = Me.ProjectID
            DObject.Name = Me.DigitalObjectName
            DObject.OriginalName = Me.OriginalName
            DObject.ArchiveID = Me.ArchiveID
            DObject.ArchivingProfile = Me.ArchivingProfile
            DObject.ResponsabilityEntity = Me.ResponsabilityEntity
            DObject.CaptureEntityCorporate = Me.CaptureEntityCorporate
            DObject.CaptureEntityIndividual = Me.CaptureEntityIndividual
            DObject.CreationDateTime = Me.CreationDateTime
            DObject.ArchiveDateTime = Me.ArchiveDateTime
            DObject.DepositDateTime = Me.DepositDateTime
            DObject.RevisionDateTime = Me.RevisionDateTime
            DObject.ExternalDescriptiveInformation = Me.ExternalDescriptiveInformation
            DObject.PreservationOriginalInformation = Me.PreservationOriginalInformation
            DObject.TopographicalQuota = Me.TopographicalQuota
            DObject.UserName = Me.Username
            DObject.Active = Me.Active

            Return DObject
        End Get
    End Property

    Private Property DigitalObjectID() As Int64
        Get
            Return myDigitalObjectID
        End Get
        Set(ByVal Value As Int64)
            myDigitalObjectID = Value
        End Set
    End Property

    Private Property DigitalObjectName() As String
        Get
            Return Me.txtName.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtName.Text = Value
        End Set
    End Property

    Private Property OriginalName() As String
        Get
            Return Me.txtOriginalName.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtOriginalName.Text = Value
        End Set
    End Property

    Private Property Active() As Boolean
        Get
            Return Me.ckbActive.Checked
        End Get
        Set(ByVal Value As Boolean)
            Me.ckbActive.Checked = Value
        End Set
    End Property

    Private Property ArchiveID() As String
        Get
            Return Me.txtArchiveID.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtArchiveID.Text = Value
        End Set
    End Property

    Private Property TopographicalQuota() As String
        Get
            Return Me.txtTopographicalQuota.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtTopographicalQuota.Text = Value
        End Set
    End Property

    Private Property Username() As String
        Get
            Return Me.lblUsername.Text
        End Get
        Set(ByVal Value As String)
            Me.lblUsername.Text = Value
        End Set
    End Property

    Private Property CreationDateTime() As String
        Get
            Return Me.txtCreationDateTime.Text
        End Get
        Set(ByVal Value As String)
            Me.txtCreationDateTime.Text = Value
        End Set
    End Property

    Private Property ArchiveDateTime() As String
        Get
            Return Me.txtArchiveDateTime.Text
        End Get
        Set(ByVal Value As String)
            Me.txtArchiveDateTime.Text = Value
        End Set
    End Property

    Private Property DepositDateTime() As String
        Get
            Return Me.txtDepositDateTime.Text
        End Get
        Set(ByVal Value As String)
            Me.txtDepositDateTime.Text = Value
        End Set
    End Property

    Private Property RevisionDateTime() As String
        Get
            Return Me.lblRevisionDateTime.Text
        End Get
        Set(ByVal Value As String)
            Me.lblRevisionDateTime.Text = Value
        End Set
    End Property

    Private Property QuantityOfTerminalObjects() As String
        Get
            Return Me.lblNumberOfFiles.Text
        End Get
        Set(ByVal Value As String)
            Me.lblNumberOfFiles.Text = Value
        End Set
    End Property

    Private Property CaptureEntityCorporate() As String
        Get
            Return Me.txtCaptureEntityCorporate.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtCaptureEntityCorporate.Text = Value
        End Set
    End Property

    Private Property CaptureEntityIndividual() As String
        Get
            Return Me.txtCaptureEntityIndividual.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtCaptureEntityIndividual.Text = Value
        End Set
    End Property

    Private Property ResponsabilityEntity() As String
        Get
            Return Me.txtResponsabilityEntity.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtResponsabilityEntity.Text = Value
        End Set
    End Property

    Private Property PreservationOriginalInformation() As String
        Get
            Return Me.txtPreservationOriginalInformation.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtPreservationOriginalInformation.Text = Value
        End Set
    End Property

    Private Property ExternalDescriptiveInformation() As String
        Get
            Return Me.txtExternalDescriptiveInfo.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtExternalDescriptiveInfo.Text = Value
        End Set
    End Property

    Private Property ArchivingProfile() As String
        Get
            Return Me.txtArchivingProfile.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtArchivingProfile.Text = Value
        End Set
    End Property


    '======= PRESERVATION METADATA =========
    Private Property Transformer() As String
        Get
            Return Me.txtTransformer.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtTransformer.Text = Value
        End Set
    End Property

    Private Property Platform() As String
        Get
            Return Me.txtPlatform.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtPlatform.Text = Value
        End Set
    End Property

    Private Property RenderEngine() As String
        Get
            Return Me.txtRenderEngine.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtRenderEngine.Text = Value
        End Set
    End Property

    Private Property InputFormat() As String
        Get
            Return Me.txtInputFormat.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtInputFormat.Text = Value
        End Set
    End Property

    Private Property Parameters() As String
        Get
            Return Me.txtParameters.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtParameters.Text = Value
        End Set
    End Property

    Private Property ReformattingMethodID() As Integer
        Get
            Return Me.txtReformattingMethod.Tag
        End Get
        Set(ByVal Value As Integer)
            Me.txtReformattingMethod.Tag = Value
        End Set
    End Property


    Private Property SaveButtonEnabled() As Boolean
        Get
            Return Me.SaveMetadataButton.Enabled
        End Get
        Set(ByVal Value As Boolean)
            Me.SaveMetadataButton.Enabled = Value
            Me.SavePreservationButton.Enabled = Value
            Me.SavePreviewButton.Enabled = Value
            Me.DragDropListView.SaveButtonEnabled = Value
        End Set
    End Property

    Private Property SelectedNode() As TreeNode
        Get
            Return mySelectedNode
        End Get
        Set(ByVal Value As TreeNode)
            mySelectedNode = Value
        End Set
    End Property

    Private Property LastSelectedNode() As TreeNode
        Get
            Return myLastSelectedNode
        End Get
        Set(ByVal Value As TreeNode)
            myLastSelectedNode = Value
        End Set
    End Property

    Private Property RootNode() As TreeNode
        Get
            Return GetRootNode(Me.SelectedNode)
        End Get
        Set(ByVal Value As TreeNode)
            myRootNode = Value
        End Set
    End Property

    Private Property FileView() As DOFile.Type
        Get
            Return myDOFileView
        End Get
        Set(ByVal Value As DOFile.Type)
            myDOFileView = Value
        End Set
    End Property

    Property OrderBy() As String
        Get
            Return myOrderBy
        End Get
        Set(ByVal Value As String)
            myOrderBY = Value
        End Set
    End Property

#End Region

#Region "Form event handlers"

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim ProjectsForm As New ProjectsForm
        ProjectsForm.ShowDialog()

        If ProjectsForm.DialogResult = DialogResult.OK Then
            myProjectID = ProjectsForm.ProjectID
            myProjectName = ProjectsForm.ProjectName

            Me.Text = General.GetFormTitle("[" & USER_LOGON & "]")

            RemoveAllTabPages()
            LoadDigitalObjects(myProjectID)
            LoadConfiguration()
        End If
    End Sub

    Private Sub MainForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        ConfirmSave()
        SaveConfiguration()
    End Sub

#End Region

#Region "Menus"

#Region "miProjects"

    Private Sub miOpenProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOpenProject.Click
        Me.Cursor = Cursors.WaitCursor

        Dim ProjectsForm As New ProjectsForm
        ProjectsForm.ProfileOpened = True
        ProjectsForm.ShowDialog()
        Me.Cursor = Cursors.Default

        If ProjectsForm.DialogResult = DialogResult.OK Then
            myProjectID = ProjectsForm.ProjectID
            myProjectName = ProjectsForm.ProjectName

            LoadDigitalObjects(myProjectID)
        End If
    End Sub

    Private Sub miNewProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miNewProject.Click
        Me.Cursor = Cursors.WaitCursor

        Dim NewProjectForm As New NewProjectForm
        Dim DialogResult As DialogResult = NewProjectForm.ShowDialog()

        If DialogResult = DialogResult.OK Then
            myProjectID = NewProjectForm.ProjectID
            myProjectName = NewProjectForm.ProjectName
            LoadDigitalObjects(myProjectID)
        End If

        Me.Cursor = Cursors.Default
    End Sub

    Private Sub miLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miLogin.Click
        ConfirmSave()
        Dim frmLogin As New LoginForm
        If frmLogin.ShowDialog() = DialogResult.OK Then
            USER_LOGON = frmLogin.Username
            Logger.Append(USER_LOGON, Logger.LogInOut, String.Format(LogMessage("Log.Login"), USER_LOGON, Date.Now.ToString))
            Me.PublishedDigitalObjectsTree.UserLogon = USER_LOGON
            Me.UnpublishedDigitalObjectsTree.UserLogon = USER_LOGON
            Format()
        End If
        Me.Text = General.GetFormTitle("[" & USER_LOGON & "]")
    End Sub

    Private Sub miClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miClose.Click
        ConfirmSave()
        Me.Close()
    End Sub

#End Region

#Region "miEdit"

    Private Sub miCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCut.Click
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.MenuItemCut_Click(sender, e)
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.MenuItemCut_Click(sender, e)
        End If
        Me.miPaste.Enabled = True
    End Sub

    Private Sub miCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCopy.Click
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.MenuItemCopy_Click(sender, e)
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.MenuItemCopy_Click(sender, e)
        End If
        Me.miPaste.Enabled = True
    End Sub

    Private Sub miPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miPaste.Click
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.MenuItemPaste_Click(sender, e)
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.MenuItemPaste_Click(sender, e)
        End If
    End Sub

    Private Sub miDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDelete.Click
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.MenuItemDelete_Click(sender, e)
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.MenuItemDelete_Click(sender, e)
        End If
    End Sub

    Private Sub miDeleteDisseminations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDeleteDisseminations.Click
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.MenuItemDeleteDisseminations_Click(sender, e)
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.MenuItemDeleteDisseminations_Click(sender, e)
        End If
    End Sub

    Private Sub miSelectAllDigitalObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miSelectAllDigitalObjects.Click
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.SelectAllDigitalObjects()
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.SelectAllDigitalObjects()
        End If
    End Sub

    Private Sub miFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miFind.Click
        Dim FindDOForm As New FindDOForm(myProjectID, True)
        FindDOForm.ShowDialog(Me)
    End Sub

#End Region

#Region "miPreferences"

    Private Sub miDigitalizationProfiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDigitalizationProfiles.Click
        Dim formDP As New DigitalizationProfilesForm
        formDP.ShowDialog(Me)
    End Sub

    Private Sub miTechnologicalPlatform_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miTechnologicalPlatform.Click
        Dim formTP As New TechnologicalPlataformForm
        formTP.ShowDialog(Me)
    End Sub

    'Private Sub miLampTypes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miLampTypes.Click
    '    Dim formLP As New LampTypeForm
    '    formLP.ShowDialog(Me)
    'End Sub

    Private Sub miRevisionInterval_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miRevisionInterval.Click
        Dim form As New RevisionIntervalForm
        form.ShowDialog(Me)
    End Sub

    'Private Sub miMeteringModes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miMeteringModes.Click
    '    Dim form As New MeteringModesForm
    '    form.ShowDialog(Me)
    'End Sub

    'Private Sub miAutoFocus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miAutoFocus.Click
    '    Dim form As New AutoFocusForm
    '    form.ShowDialog(Me)
    'End Sub

    Private Sub miControlledVocabularies_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miControlledVocabularies.Click
        Dim form As New ControlledVocabulariesForm
        form.ShowDialog(Me)
    End Sub

    Private Sub miSaveDigitalObjectsAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miSaveDigitalObjectsAs.Click
        Dim form As New DigitalObjectsStorageForm
        form.ShowDialog(Me)
    End Sub

    Private Sub miDisseminationSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDisseminationSettings.Click
        Dim form As New DisseminationSettingsForm
        form.ShowDialog(Me)
    End Sub

    Private Sub miKeepFileStructure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miKeepFileStructure.Click
        If Me.miKeepFileStructure.Checked Then
            Me.miKeepFileStructure.Checked = False
        Else
            Me.miKeepFileStructure.Checked = True
        End If
    End Sub

#End Region

#Region "miView"

    Private Sub miViewOriginal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewOriginal.Click
        Me.miViewOriginal.Checked = True
        Me.miViewDissemination.Checked = False
        Me.miViewThumbnail.Checked = False
        FileView = DOFile.Type.Original
        If IsInteger(Me.SelectedNode.Tag) Then
            LoadFile(Me.SelectedNode.Tag, FileView, False)
        End If
    End Sub

    Private Sub miViewDissemination_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewDissemination.Click
        Me.miViewDissemination.Checked = True
        Me.miViewOriginal.Checked = False
        Me.miViewThumbnail.Checked = False
        FileView = DOFile.Type.Dissemination
        If IsInteger(Me.SelectedNode.Tag) Then
            LoadFile(Me.SelectedNode.Tag, FileView, False)
        End If
    End Sub

    Private Sub miViewThumbnail_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewThumbnail.Click
        Me.miViewThumbnail.Checked = True
        Me.miViewOriginal.Checked = False
        Me.miViewDissemination.Checked = False
        FileView = DOFile.Type.Thumbnail
        If IsInteger(Me.SelectedNode.Tag) Then
            LoadFile(Me.SelectedNode.Tag, FileView, False)
        End If
    End Sub

    Private Sub miOrderByName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderByName.Click
        'If Not Me.miOrderByName.Checked Then
        Me.miOrderByName.Checked = True
        Me.miOrderByDate.Checked = False
        Me.OrderBy = DIGITAL_OBJECT_NAME
        LoadDigitalObjects(myProjectID)
        'End If
    End Sub

    Private Sub miOrderByDate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderByDate.Click
        'If Not Me.miOrderByDate.Checked Then
        Me.miOrderByDate.Checked = True
        Me.miOrderByName.Checked = False
        Me.OrderBy = DIGITAL_OBJECT_ID
        LoadDigitalObjects(myProjectID)
        'End If
    End Sub

    Private Sub miViewTechnicalMatadata_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewTechnicalMatadata.Click
        If Me.miViewTechnicalMatadata.Checked Then
            Me.TechnicalMetadataPanel.Hide()
            Me.miViewTechnicalMatadata.Checked = False
        Else
            Me.TechnicalMetadataPanel.Show()
            Me.miViewTechnicalMatadata.Checked = True
        End If
    End Sub

    Private Sub miAskBeforeSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miAskBeforeSave.Click
        If Me.miAskBeforeSave.Checked Then
            Me.miAskBeforeSave.Checked = False
        Else
            Me.miAskBeforeSave.Checked = True
        End If
    End Sub

#End Region

#Region "miTools"

    Private Sub miFilesRename_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miFilesRename.Click
        Dim tv As New FilesRenameForm
        tv.ShowDialog(Me)
    End Sub

    Private Sub miPOD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miPOD.Click
        OpenAssociationForm()
    End Sub

    Private Sub miGeneDisseminations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miGeneDisseminations.Click
        If Me.SelectedNode Is Nothing Then Return

        Cursor.Current = Cursors.WaitCursor
        Me.Enabled = False

        myProgressDialog = New ProgressDialog(True, 1)
        myProgressDialog.Run(New ThreadStart(AddressOf RewriteItems), InfoMessage("Files.RewriteItems.Title"), 0, CountItems(Me.SelectedNode, 0))

        Cursor.Current = Cursors.Default
        Me.Enabled = True

        If Me.TabControl.SelectedTab Is Me.tpAddFiles Then
            LoadListView(Me.SelectedNode)
        End If
    End Sub

#End Region

#Region "miReports"

    Private Sub miReportDigitalizationProfiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportDigitalizationProfiles.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As DigitalizationProfilesData = RepDSBuilder.GenerateDPReportData

        Dim Report As New DigitalizationProfilesReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miReportReformattingNorms_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportReformattingNorms.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As ReformattingNormsData = RepDSBuilder.GenerateReformattingNormsReportData

        Dim Report As New ReformattingNormsReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miReportReformattingMethods_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportReformattingMethods.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As ReformattingMethodsData = RepDSBuilder.GenerateReformattingMethodsReportData

        Dim Report As New ReformattingMethodsReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miReportMetaOD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportMetaOD.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As DigitalObjectsData = RepDSBuilder.GenerateMIDigitalObjectsReportData(Database.SelectDigitalObjects(Me.ProjectID, "DigitalObjectID"))

        Dim Report As New MIDigitalObjectsReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miReportPreservationInfDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportPreservationInfDO.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As PreservationInfoData = RepDSBuilder.GeneratePreservationInfoReportData(Database.SelectDigitalObjects(Me.ProjectID, "DigitalObjectID"))

        Dim Report As New PreservationInformationReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miReportImagesDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportImagesDO.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As DOImagesData = RepDSBuilder.GenerateMIImagesReportData(Database.SelectDigitalObjects(Me.ProjectID, "DigitalObjectID"))

        Dim Report As New MIDOFilesReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miReportRevisionDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportRevisionDO.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As DORevisionData = RepDSBuilder.GenerateDORevisionReportData(Database.SelectDigitalObjects(Me.ProjectID, "DigitalObjectID"))

        Dim Report As New DORevisionReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

    Private Sub miUIDigitalization_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miUIDigitalization.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As UIDigitalizationData = RepDSBuilder.GenerateUIDigitalizationReportData

        Dim Report As New UIDigitalizationReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

#End Region

#End Region

#Region "Load Data"

    Private Sub LoadConfiguration()
        Try
            Dim myProgramState As New ProgramState
            FileView = myProgramState.FileView
            Select Case FileView
                Case DOFile.Type.Original
                    Me.miViewOriginal.Checked = True
                    Me.miViewDissemination.Checked = False
                    Me.miViewThumbnail.Checked = False
                Case DOFile.Type.Dissemination
                    Me.miViewOriginal.Checked = False
                    Me.miViewDissemination.Checked = True
                    Me.miViewThumbnail.Checked = False
                Case DOFile.Type.Thumbnail
                    Me.miViewOriginal.Checked = False
                    Me.miViewDissemination.Checked = False
                    Me.miViewThumbnail.Checked = True
            End Select
            Me.miAskBeforeSave.Checked = DBToBool(myProgramState.AskBeforeSave)
            Me.miViewTechnicalMatadata.Checked = DBToBool(myProgramState.MetadataPanelVisible)
            If Not Me.miViewTechnicalMatadata.Checked Then
                Me.TechnicalMetadataPanel.Hide()
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub SaveConfiguration()
        Dim myProgramState As New ProgramState
        Select Case FileView
            Case DOFile.Type.Original
                myProgramState.FileView = DOFile.Type.Original
            Case DOFile.Type.Dissemination
                myProgramState.FileView = DOFile.Type.Dissemination
            Case DOFile.Type.Thumbnail
                myProgramState.FileView = DOFile.Type.Thumbnail
        End Select

        myProgramState.AskBeforeSave = BoolToDB(Me.miAskBeforeSave.Checked)
        myProgramState.MetadataPanelVisible = BoolToDB(Me.miViewTechnicalMatadata.Checked)
        myProgramState.Save()
    End Sub

    Public Sub LoadDigitalObjects(ByVal ProjectID As Integer, Optional ByVal DigitalObjectCollection As DigitalObjectCollection = Nothing, Optional ByVal Published As Boolean = True)
        If DigitalObjectCollection Is Nothing Then
            Dim PublishedDigitalObjectCollection As DigitalObjectCollection = Database.SelectDigitalObjects(ProjectID, True, Me.OrderBy)
            Me.PublishedDigitalObjectsTree.Nodes.Clear()
            Me.PublishedDigitalObjectsTree.PopulateTreeView(PublishedDigitalObjectCollection)

            Dim UnpublishedDigitalDigitalObjectCollection As DigitalObjectCollection = Database.SelectDigitalObjects(ProjectID, False, Me.OrderBy)
            Me.UnpublishedDigitalObjectsTree.Nodes.Clear()
            Me.UnpublishedDigitalObjectsTree.PopulateTreeView(UnpublishedDigitalDigitalObjectCollection)
        Else
            If Published Then
                Me.PublishedDigitalObjectsTree.Nodes.Clear()
                Me.PublishedDigitalObjectsTree.PopulateTreeView(DigitalObjectCollection)
            Else
                Me.UnpublishedDigitalObjectsTree.Nodes.Clear()
                Me.UnpublishedDigitalObjectsTree.PopulateTreeView(DigitalObjectCollection)
            End If
        End If
        CheckProjectIsEmpty()
        If Me.PublishedDigitalObjectsTree.Tree.GetNodeCount(False) > 0 Then
            Me.TabControlDigitalObjects.SelectedTab = Me.PublishedDigitalObjectsTabPage
            Me.PublishedDigitalObjectsTree.SelectedNode = Me.PublishedDigitalObjectsTree.Nodes(0)
            Me.PublishedDigitalObjectsTabPage.Show()
        ElseIf Me.UnpublishedDigitalObjectsTree.Tree.GetNodeCount(False) > 0 Then
            Me.TabControlDigitalObjects.SelectedTab = Me.UnpublishedDigitalObjectsTabPage
            Me.UnpublishedDigitalObjectsTree.SelectedNode = Me.UnpublishedDigitalObjectsTree.Nodes(0)
            Me.UnpublishedDigitalObjectsTabPage.Show()
        Else
        End If
        Me.PublishedDigitalObjectsTree.UserLogon = USER_LOGON
        Me.UnpublishedDigitalObjectsTree.UserLogon = USER_LOGON
    End Sub

    Private Sub SetDigitalObjectMetadata(ByVal DigitalObjectID As Int64)
        Dim DigitalObject As DigitalObject = Database.SelectDigitalObject(DigitalObjectID)
        Me.Active = DigitalObject.Active
        Me.DigitalObjectName = DigitalObject.Name
        Me.OriginalName = DigitalObject.OriginalName
        Me.ArchiveID = DigitalObject.ArchiveID
        Me.TopographicalQuota = DigitalObject.TopographicalQuota
        Me.Username = DigitalObject.UserName
        Me.CreationDateTime = DigitalObject.CreationDateTime
        Me.ArchiveDateTime = DigitalObject.ArchiveDateTime
        Me.DepositDateTime = DigitalObject.DepositDateTime
        Me.RevisionDateTime = DigitalObject.RevisionDateTime
        Me.QuantityOfTerminalObjects = Database.SelectCountFiles(DigitalObjectID)
        Me.CaptureEntityCorporate = DigitalObject.CaptureEntityCorporate
        Me.CaptureEntityIndividual = DigitalObject.CaptureEntityIndividual
        Me.ResponsabilityEntity = DigitalObject.ResponsabilityEntity
        Me.PreservationOriginalInformation = DigitalObject.PreservationOriginalInformation
        Me.ExternalDescriptiveInformation = DigitalObject.ExternalDescriptiveInformation
        Me.ArchivingProfile = DigitalObject.ArchivingProfile

        LoadDescriptionInfo(DigitalObjectID)
    End Sub

    Private Sub LoadDescriptionInfo(ByVal DigitalObjectID As Int64)
        Dim tnNew As TreeNode
        Dim i, count As Integer

        Dim DaoGrpCollection As DaoGrpCollection = Database.SelectDigitalObjectAssociations(DigitalObjectID)

        Me.tvwDescriptionInfo.Nodes.Clear()
        For Each DaoGrp As DaoGrp In DaoGrpCollection
            tnNew = New TreeNode(DaoGrp.CompleteUnitID)
            With tnNew
                .Tag = DaoGrp.ComponentID
                .ImageIndex = GetOtherLevelIndex(DaoGrp.OtherLevel)
                .SelectedImageIndex = .ImageIndex
            End With
            Me.tvwDescriptionInfo.Nodes.Add(tnNew)
        Next
    End Sub

    Private Sub CheckProjectIsEmpty()
        If Database.SelectCountDigitalObjects(ProjectID) = 0 Then
            Me.SelectedNode = Nothing
            ShowMessageTabPage(InfoMessage("Projects.EmptyProject.Title"), InfoMessage("Projects.EmptyProject.Message"))
            Format()
        End If
    End Sub

#End Region

#Region "Digital objects functions"

    Private Function InsertDigitalObject(ByVal Name As String, Optional ByVal Publish As Boolean = True) As Boolean
        Dim myProgramState As New ProgramState
        Me.SelectedNode = Nothing

        Me.DigitalObjectName = Name
        Me.Username = USER_LOGON
        Me.CreationDateTime = DateToDB(Now)
        Me.ArchiveDateTime = DateToDB(Now)
        Me.RevisionDateTime = DateToDB(Now.AddYears(Database.SelectRevisionInterval()))
        Me.QuantityOfTerminalObjects = 0
        Me.Active = Publish
        Me.ArchiveID = myProgramState.LastArchiveID
        Me.TopographicalQuota = myProgramState.LastTopographicalQuota
        Me.ResponsabilityEntity = myProgramState.LastResponsabilityEntity
        Me.CaptureEntityCorporate = myProgramState.LastCaptureEntityCorporate
        Me.CaptureEntityIndividual = myProgramState.LastCaptureEntityIndividual

        Dim DigitalObjectID As Int64 = Database.InsertDigitalObject(Me.DigitalObject)
        If DigitalObjectID Then
            Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.InsertDigitalObject"), Me.DigitalObjectName, Me.ProjectName))
            AddDigitalObjectTreeNode(DigitalObjectID, Name)
            Me.SaveButtonEnabled = False
            ShowDigitalObjectTabPages(Me.tpAddFiles)
            Return True
        End If
    End Function

    Private Sub AddDigitalObjectTreeNode(ByVal DigitalObjectID As Int64, ByVal Name As String)
        Dim NewTreeNode As New TreeNode
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            With NewTreeNode
                .Text = Name
                .Tag = DigitalObjectID
                .ImageIndex = ImageIndex.PUBLISHED_DIGITALOBJECT
            End With
            Me.PublishedDigitalObjectsTree.Nodes.Insert(0, NewTreeNode)
            SaveStructure(NewTreeNode)
            Me.SelectedNode = NewTreeNode
            Me.PublishedDigitalObjectsTree.SelectedNode = NewTreeNode
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            With NewTreeNode
                .Text = Name
                .Tag = DigitalObjectID
                .ImageIndex = ImageIndex.UNPUBLISHED_DIGITALOBJECT
            End With
            Me.UnpublishedDigitalObjectsTree.Nodes.Insert(0, NewTreeNode)
            SaveStructure(NewTreeNode)
            Me.SelectedNode = NewTreeNode
            Me.UnpublishedDigitalObjectsTree.SelectedNode = NewTreeNode
        End If
    End Sub

    Private Function UpdateDigitalObject(ByVal DigitalObjectID As Int64) As Boolean
        Dim myProgramState As New ProgramState

        Me.DigitalObjectID = DigitalObjectID
        If Database.UpdateDigitalObject(Me.DigitalObject) Then
            Logger.Append(USER_LOGON, Logger.EditNode, String.Format(LogMessage("Log.UpdateDigitalObject"), Me.DigitalObjectName))

            myProgramState.LastArchiveID = ArchiveID
            myProgramState.LastResponsabilityEntity = ResponsabilityEntity
            myProgramState.LastCaptureEntityCorporate = CaptureEntityCorporate
            myProgramState.LastCaptureEntityIndividual = CaptureEntityIndividual
            myProgramState.LastTopographicalQuota = TopographicalQuota
            myProgramState.Save()
        End If
    End Function

    Private Sub DeleteDigitalObjects(ByVal DigitalObjectNodes As ArrayList, ByVal DeleteDisseminationsOnly As Boolean)
        Dim DeleteOriginalFiles As Boolean
        Dim UserProfile As String = (New SQLDataBase).getProfile(USER_LOGON, ConfigurationSettings.AppSettings("Application.Code")).Profile
        Dim AdminProfile As String = ConfigurationSettings.AppSettings("Profile.Administrator")
        If (Not DeleteDisseminationsOnly) AndAlso UserProfile = AdminProfile Then
            Dim MsgBoxResult As MsgBoxResult = MsgBox("Deseja eliminar, alm das derivadas, todos os documentos originais associados ao objecto digital?", MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNoCancel Or MsgBoxStyle.DefaultButton2)
            Select Case MsgBoxResult
                Case MsgBoxResult.Cancel
                    Return
                Case MsgBoxResult.Yes
                    DeleteOriginalFiles = True
                Case MsgBoxResult.No
                    DeleteOriginalFiles = False
            End Select
        Else
            DeleteOriginalFiles = False
        End If

        For Each TreeNode As TreeNode In DigitalObjectNodes
            Dim Message As String
            Dim MessageTitle As String
            If DeleteOriginalFiles Then
                MessageTitle = InfoMessage("DigitalObjects.Delete.ConfirmTitle")
                Message = InfoMessage("DigitalObjects.Delete.Confirm")
            Else
                MessageTitle = InfoMessage("DigitalObjects.DeleteDisseminations.ConfirmTitle")
                Message = InfoMessage("DigitalObjects.DeleteDisseminations.Confirm")
            End If
            If MessageBox.Show(String.Format(Message, TreeNode.Text), MessageTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.Yes Then
                Me.Cursor = Cursors.WaitCursor
                Me.Enabled = False

                Dim DigitalObjectID As Int64 = TreeNode.Tag
                Dim DOFileCollection As DOFileCollection = Database.SelectFiles(DigitalObjectID)
                For Each DOFile As DOFile In DOFileCollection
                    DeleteFile(DOFile, DeleteOriginalFiles)
                Next

                If Not DeleteDisseminationsOnly Then
                    Database.DeleteDigitalObject(DigitalObjectID)
                    Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteDigitalObject"), DigitalObject.Name))
                    TreeNode.Remove()
                Else
                    SaveStructure(GetRootNode(TreeNode))
                End If

                Me.Cursor = Cursors.Default
                Me.Enabled = True
            End If
        Next
        CheckProjectIsEmpty()
    End Sub

    Private Function GetNewDigitalObjectName() As String
        Return String.Format("{0}OD{1}", Me.ProjectName, Database.SelectCountDigitalObjects(Me.ProjectID) + 1)
    End Function

#End Region

#Region "Preservation metadata"

    Private Sub btnChooseReformattingMethod_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChooseReformattingMethod.Click
        Dim ReformattingMethodForm As New ReformattingMethodsForm
        ReformattingMethodForm.ShowDialog(Me)
    End Sub

    Private Sub btnChooseReformattingNorms_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChooseReformattingNorms.Click
        Dim ReformattingNormsForm As New ReformattingNormsForm
        ReformattingNormsForm.ShowDialog(Me)
    End Sub

    Private Sub btnHistorical_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHistorical.Click
        If Me.SelectedNode Is Nothing Then Return
        Dim HistoricalPreservationForm As New HistoricalPreservationForm(Me.SelectedNode.Tag)
        HistoricalPreservationForm.ShowDialog(Me)
    End Sub

    Private Sub SavePreservationAction()
        Dim i As Integer
        Dim ReformattingNorms As New ArrayList

        Dim RevisionValue As Integer = Database.SelectRevisionInterval()
        Dim RevisionNextDateTime As String = DateToDB(Now.AddYears(RevisionValue))

        For i = 0 To Me.lbxReformattingNormsChoosen.Items.Count - 1
            Me.lbxReformattingNormsChoosen.SelectedIndex = i
            ReformattingNorms.Add(Me.lbxReformattingNormsChoosen.SelectedValue)
            Me.lbxReformattingNormsChoosen.SetSelected(i, False)
        Next
        Dim ret1 As Integer = Database.InsertPrervationAction(RevisionNextDateTime, DateToDB(Now), _
        Me.Transformer, Me.Platform, Me.RenderEngine, Me.InputFormat, Me.Parameters, Me.ReformattingMethodID, ReformattingNorms, Me.RootNode.Tag)
        Dim ret2 As Boolean = Database.UpdateRevisionDateTime(Me.RootNode.Tag, RevisionNextDateTime)
        If ret1 And ret2 Then
            ClearPreservationInfo()
            Logger.Append(USER_LOGON, Logger.AppendNode, "New Preservation Action was associated to DO " & Me.RootNode.Text & ".")
            MsgBox(InfoMessage("PreservationAction.NewValue") & vbNewLine & "Prxima data de reviso: " & RevisionNextDateTime, MsgBoxStyle.Information, InfoMessage("PreservationAction.Title"))
        End If
    End Sub

    Private Sub ClearPreservationInfo()
        Me.Transformer = ""
        Me.Platform = ""
        Me.RenderEngine = ""
        Me.InputFormat = ""
        Me.Parameters = ""
        Me.ReformattingMethodID = Nothing
        Me.lbxReformattingNormsChoosen.DataSource = Nothing
        Me.lbxReformattingNormsChoosen.Items.Clear()
    End Sub

#End Region

#Region "TreeView Event Handlers"

    Private Sub TreeView_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs)
        If Not Me.SelectedNode Is Nothing Then
            Me.LastSelectedNode = Me.SelectedNode
        End If
        If Not Me.LastSelectedNode Is e.Node Then
            ConfirmSave()
        End If
        Me.SelectedNode = e.Node
        Dim Enabled As Boolean = SaveButtonEnabled

        Select Case e.Node.ImageIndex
            Case ImageIndex.PUBLISHED_DIGITALOBJECT, ImageIndex.UNPUBLISHED_DIGITALOBJECT, ImageIndex.WARNING_DIGITALOBJECT
                ShowDigitalObjectTabPages()
                Format()
                SetDigitalObjectMetadata(e.Node.Tag)
                If Me.TabControl.SelectedTab Is Me.tpAddFiles Then
                    LoadListView(e.Node)
                End If

            Case ImageIndex.FILE_WITH_DISSEMINATION, ImageIndex.FILE_WITHOUT_DISSEMINATION, ImageIndex.CORRUPTED_FILE
                ShowPreviewTabPage()
                Format()
                LoadFile(e.Node.Tag, FileView)

            Case ImageIndex.NODE
                ShowFilesTabPage()
                Format()
                LoadListView(e.Node)
        End Select
        SaveButtonEnabled = Enabled
    End Sub

    Private Sub TreeView_BeforeExpand(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs)
        If (e.Node.Nodes.Item(0).Text = "__DUMMY__") Then
            Cursor.Current = Cursors.WaitCursor
            e.Node.Nodes.RemoveAt(0) 'remove dummy
        End If
        If e.Node.Parent Is Nothing AndAlso Not e.Node.IsExpanded AndAlso Not IsEdited Then
            Dim DOStructure As String = Database.GetDOStructure(e.Node.Tag)
            DigitalObjectsTree.LoadTreeViewFromXML(DOStructure, e.Node)
        End If
    End Sub

    Private Sub TreeView_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim tn As TreeNode = Me.SelectedNode

        If tn Is Nothing Then Return
        Select Case tn.ImageIndex
            Case ImageIndex.WARNING_DIGITALOBJECT
                Me.TabControl.SelectedTab = Me.tpMetadata
                Me.tpMetadata.Show()
            Case ImageIndex.PUBLISHED_DIGITALOBJECT
                If MsgBox(InfoMessage("DigitalObjects.Offline"), MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                    Dim TreeNodes As New ArrayList
                    TreeNodes.Add(tn)
                    PublishDigitalObject(TreeNodes, False)
                End If
            Case ImageIndex.UNPUBLISHED_DIGITALOBJECT
                If MsgBox(InfoMessage("DigitalObjects.Online"), MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                    Dim TreeNodes As New ArrayList
                    TreeNodes.Add(tn)
                    PublishDigitalObject(TreeNodes, True)
                End If
        End Select
    End Sub

    Private Sub TreeView_AfterLabelEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs)
        Try
            If Not (e.Label Is Nothing) Then
                If e.Label.Length > 0 Then
                    e.Node.EndEdit(False)
                    e.Node.Text = e.Label
                    If e.Node.Parent Is Nothing Then
                        Me.DigitalObjectName = e.Node.Text
                        UpdateDigitalObject(Me.SelectedNode.Tag)
                        Me.SaveButtonEnabled = False
                    Else
                        Dim DoFile As DoFile = Database.SelectDOFile(e.Node.Tag)
                        If DoFile Is Nothing Then Return
                        DoFile.Name = e.Node.Text
                        Database.UpdateDOFile(DoFile)
                    End If
                    SaveStructure(GetRootNode(e.Node))
                Else
                    'Cancel the label edit action and place the node in edit mode again. 
                    e.CancelEdit = True
                    e.Node.BeginEdit()
                End If
            End If
        Catch ex As Exception
        End Try
    End Sub

#Region "Drag and drop"

    Private Sub TreeView_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        Dim DestTreeNode As TreeNode
        Dim SourceTreeNode As TreeNode
        Dim Publish As Boolean

        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            SourceTreeNode = Me.PublishedDigitalObjectsTree.NodeDrag
            Dim pt As Point = Me.PublishedDigitalObjectsTree.PointToClient(New Point(e.X, e.Y))
            DestTreeNode = Me.PublishedDigitalObjectsTree.GetNodeAt(pt)
            Publish = True
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            SourceTreeNode = Me.UnpublishedDigitalObjectsTree.NodeDrag
            Dim pt As Point = Me.UnpublishedDigitalObjectsTree.PointToClient(New Point(e.X, e.Y))
            DestTreeNode = Me.UnpublishedDigitalObjectsTree.GetNodeAt(pt)
            Publish = False
        End If

        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            Dim Files As String() = e.Data.GetData(DataFormats.FileDrop)
            If DestTreeNode Is Nothing Then
                DragDropExternalItemsToTreeView(Files, Publish)
            Else
                Me.SelectedNode = DestTreeNode
                DragDropExternalItemsToTreeNode(Files, DestTreeNode)
            End If
        ElseIf e.Data.GetDataPresent("System.Windows.Forms.TreeNode", True) Then
            If SourceTreeNode Is Nothing Or DestTreeNode Is Nothing Then Return
            If IsAscendant(DestTreeNode, SourceTreeNode) Then Return
            Dim RootSourceTreeNode As TreeNode = GetRootNode(SourceTreeNode)
            Dim RootDestTreeNode As TreeNode = GetRootNode(DestTreeNode)
            If Not RootSourceTreeNode Is RootDestTreeNode Then Return
            If Not IsDOFile(SourceTreeNode) And IsDOFile(DestTreeNode) Then Return

            If IsDOFile(SourceTreeNode) And IsDOFile(DestTreeNode) Then
                ReorderTreeNodes(SourceTreeNode, DestTreeNode)
                SaveStructure(GetRootNode(SourceTreeNode))
            ElseIf Not IsDigitalObject(SourceTreeNode) Then
                DestTreeNode.Nodes.Add(CType(SourceTreeNode.Clone, TreeNode))
                DestTreeNode.Expand()
                SourceTreeNode.Remove()
                SaveStructure(RootSourceTreeNode)
            End If
        End If
    End Sub

    Private Sub DragDropExternalItemsToTreeView(ByVal PathItems As String(), ByVal Publish As Boolean)
        For Each PathItem As String In PathItems
            Dim IsFolder As Boolean = Directory.Exists(PathItem)
            If IsFolder Then
                If Me.miKeepFileStructure.Checked Then
                    InsertDigitalObject(GetDirectoryName(PathItem), Publish)
                    InsertItems(Directory.GetFiles(PathItem))
                    InsertItems(Directory.GetDirectories(PathItem))
                Else
                    Dim SheetDirectories As New ArrayList
                    GetSheetDirectories(PathItem, SheetDirectories)
                    For Each SheetDirectory As String In SheetDirectories
                        InsertDigitalObject(GetDigitalObjectNameFromPath(PathItem, SheetDirectory), Publish)
                        InsertItems(Directory.GetFiles(SheetDirectory))
                    Next
                End If
            End If
        Next
    End Sub

    Private Sub GetSheetDirectories(ByVal PathItem As String, ByVal Directories As ArrayList)
        If Directories Is Nothing Then Directories = New ArrayList
        If Directory.GetFiles(PathItem).Length > 0 Then Directories.Add(PathItem)
        For Each Folder As String In Directory.GetDirectories(PathItem)
            GetSheetDirectories(Folder, Directories)
        Next
    End Sub

    Private Function GetDigitalObjectNameFromPath(ByVal PathRoot As String, ByVal PathLeaf As String) As String
        Dim StartIndex As String = PathRoot.LastIndexOf(Path.DirectorySeparatorChar) + 1
        Return PathLeaf.Substring(StartIndex).Replace(Path.DirectorySeparatorChar, "-")
    End Function

    Private Sub DragDropExternalItemsToTreeNode(ByVal PathItems As String(), ByVal DestTreeNode As TreeNode)
        InsertItems(PathItems)
    End Sub

    Private Sub ReorderTreeNodes(ByVal SourceTreeNode As TreeNode, ByVal DestTreeNode As TreeNode)
        Dim OrderNext As Boolean
        If DestTreeNode.Index < SourceTreeNode.Index Then
            OrderNext = True
        Else
            OrderNext = False
        End If

        Dim tn As TreeNode
        tn = DestTreeNode
        Dim col As New Collection
        Do Until tn Is SourceTreeNode
            Dim a(2) As String
            a(0) = tn.Tag
            a(1) = tn.Text
            col.Add(a)
            If OrderNext Then
                tn = tn.NextNode
            Else
                tn = tn.PrevNode
            End If
        Loop

        tn = DestTreeNode
        DestTreeNode.Tag = SourceTreeNode.Tag
        DestTreeNode.Text = SourceTreeNode.Text
        Dim i As Integer = 1
        Do Until tn Is SourceTreeNode
            If OrderNext Then
                tn.NextNode.Tag = col.Item(i)(0)
                tn.NextNode.Text = col.Item(i)(1)
                tn = tn.NextNode
            Else
                tn.PrevNode.Tag = col.Item(i)(0)
                tn.PrevNode.Text = col.Item(i)(1)
                tn = tn.PrevNode
            End If
            i = i + 1
        Loop
    End Sub

#End Region

#End Region

#Region "MenuItems event handlers"

#Region "Add items"

    Private Sub InsertItems(ByVal Files() As String)
        Files.Sort(Files)
        myFiles = Files
        Dim Count As Integer

        For Each FilePath As String In Files
            Count += CountItems(FilePath, 0)
        Next

        Cursor.Current = Cursors.WaitCursor
        Me.Enabled = False

        myProgressDialog = New ProgressDialog(True, 1)
        myProgressDialog.Run(New ThreadStart(AddressOf InsertItems), InfoMessage("Files.Insert.Title"), 0, Count)

        Cursor.Current = Cursors.Default
        Me.Enabled = True

        If Me.TabControl.SelectedTab Is Me.tpAddFiles Then
            LoadListView(Me.SelectedNode)
        End If
    End Sub

    Private Function CountItems(ByVal FilePath As String, ByVal Count As Integer) As Integer
        Dim isFolder As Boolean = Directory.Exists(FilePath)
        Dim isFile As Boolean = file.Exists(FilePath)
        If isFile Then
            Count += 1
        ElseIf isFolder Then
            For Each file As String In Directory.GetFiles(FilePath)
                If Formats.Contains(GetFormat(file)) Then
                    Count += 1
                End If
            Next
            For Each folder As String In Directory.GetDirectories(FilePath)
                Count = CountItems(folder, Count)
            Next
        End If
        Return Count
    End Function

    Private Sub InsertItems()
        Me.SelectedNode.Expand()
        For Each FilePath As String In myFiles
            If myProgressDialog.Cancel = True Then Exit For
            SaveItem(FilePath, Me.SelectedNode)
        Next
        SaveStructure(Me.RootNode)
        SaveButtonEnabled = False
    End Sub

    Private Delegate Function AddToTreeView(ByVal TreeNode As TreeNode) As Integer

    Private Function SaveItem(ByVal FilePath As String, ByVal ParentTreeNode As TreeNode) As Integer
        Dim isFolder As Boolean = Directory.Exists(FilePath)
        Dim isFile As Boolean = file.Exists(FilePath)

        Dim NewNode As New TreeNode
        With NewNode
            If isFolder Then
                .Text = GetDirectoryName(FilePath)
                .Tag = FilePath
                .ImageIndex = ImageIndex.NODE
            ElseIf isFile Then
                .Text = GetFilename(FilePath)
                .Tag = FilePath
                .ImageIndex = ImageIndex.TEMP_FILE
            End If
        End With
        If isFolder Or Formats.Contains(GetFormat(FilePath)) Then
            Me.PublishedDigitalObjectsTree.Tree.Invoke(New AddToTreeView(AddressOf ParentTreeNode.Nodes.Add), New Object() {NewNode})
            StoreFile(NewNode)
        End If

        If isFolder Then
            For Each file As String In Directory.GetFiles(FilePath)
                SaveItem(file, NewNode)
            Next
            For Each folder As String In Directory.GetDirectories(FilePath)
                SaveItem(folder, NewNode)
            Next
        End If
    End Function

#End Region

#Region "Rewrite Items"

    Private Sub RewriteItems()
        Dim TreeNodes As ArrayList
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            For Each TreeNode As TreeNode In Me.PublishedDigitalObjectsTree.SelectedNodes
                RewriteItems(TreeNode)
                SaveStructure(GetRootNode(TreeNode))
            Next
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            For Each TreeNode As TreeNode In Me.UnpublishedDigitalObjectsTree.SelectedNodes
                RewriteItems(TreeNode)
                SaveStructure(GetRootNode(TreeNode))
            Next
        End If
        SaveButtonEnabled = False
    End Sub

    Private Function RewriteItems(ByVal tn As TreeNode) As Boolean
        If tn Is Nothing Then Return False
        If IsDOFile(tn) Then UpdateDissemination(tn)
        If tn.GetNodeCount(False) > 0 Then
            tn = tn.Nodes(0)
            Do Until tn Is Nothing
                If myProgressDialog.Cancel Then Exit Function
                If tn.GetNodeCount(False) > 0 Then
                    RewriteItems(tn)
                Else
                    If IsDOFile(tn) Then UpdateDissemination(tn)
                End If
                tn = tn.NextNode
            Loop
        End If
    End Function

    Private Sub UpdateDissemination(ByVal TreeNode As TreeNode)
        Try
            Dim DOfile As DOfile = Database.SelectDOFile(TreeNode.Tag)
            DeleteDissemination(DOfile)
            DeleteThumbnail(DOfile)

            Dim OriginalFile As Byte() = GetFileFromURL(DOfile.OriginalURL)
            Dim OriginalStream As Stream = New ByteArrayStream(OriginalFile)

            If Not OriginalStream Is Nothing Then
                DOfile = StoreDisseminationFile(DOfile, OriginalStream)
                DOfile = StoreThumbnailFile(DOfile, OriginalStream)
                Database.UpdateDOFile(DOfile)
                TreeNode.ImageIndex = ImageIndex.FILE_WITH_DISSEMINATION
            End If
            OriginalStream.Close()
        Catch ex As VaultFileSizeException
            TreeNode.ImageIndex = ImageIndex.CORRUPTED_FILE
        Catch ex As VaultException
            TreeNode.ImageIndex = ImageIndex.CORRUPTED_FILE
        Catch ex As Exception
            TreeNode.ImageIndex = ImageIndex.CORRUPTED_FILE
        End Try
        myProgressDialog.Increment()
    End Sub

    Private Function CountItems(ByVal TreeNode As TreeNode, ByVal Count As Integer) As Integer
        If TreeNode.GetNodeCount(False) > 0 Then
            TreeNode = TreeNode.Nodes(0)
            Do Until TreeNode Is Nothing
                Count = CountItems(TreeNode, Count)
                TreeNode = TreeNode.NextNode
            Loop
        ElseIf IsDOFile(TreeNode) Then
            Count += 1
        End If
        Return Count
    End Function

#End Region

#Region "New item"

    Private Sub MenuItemNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Me.SelectedNode Is Nothing Then Return
        Me.SelectedNode.Expand()
        Dim NewTreeNode As TreeNode = SelectedNode.Nodes.Add(NEW_NODE_NAME)
        NewTreeNode.BeginEdit()
        NewTreeNode.ImageIndex = ImageIndex.NODE
        NewTreeNode.Tag = ""
        SaveStructure(Me.RootNode)
        'Me.DigitalObjectsTree.SelectedNode = NewTreeNode
    End Sub

#End Region

#Region "Rename item"

    Private Sub MenuItemRename_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim tn As TreeNode = Me.SelectedNode
        tn.BeginEdit()
    End Sub

#End Region

#Region "Delete item"

    Private Sub DeleteItems(ByVal TreeNodes As ArrayList, Optional ByVal DeleteOriginalFiles As Boolean = False)
        Me.Cursor = Cursors.WaitCursor
        Me.Enabled = False

        If TreeNodes Is Nothing Then Return
        Dim RootNode As TreeNode = Me.RootNode
        Dim Message As String
        If DeleteOriginalFiles Then
            Message = InfoMessage("Files.DeleteSelectedFiles")
        Else
            Message = InfoMessage("Files.DeleteDisseminationSelectedFiles")
        End If
        If MsgBox(String.Format(Message, RootNode.Text), _
                    MessageBoxButtons.YesNo Or _
                    MessageBoxIcon.Warning Or _
                    MessageBoxDefaultButton.Button2) = MsgBoxResult.Yes Then
            For Each TreeNode As TreeNode In TreeNodes
                DeleteChildNodes(TreeNode, DeleteOriginalFiles)
            Next
            SaveStructure(RootNode)
        End If
        If Me.TabControl.SelectedTab Is Me.tpAddFiles Then
            LoadListView(Me.SelectedNode)
        End If

        Me.Cursor = Cursors.Default
        Me.Enabled = True
    End Sub

    Private Sub DeleteChildNodes(ByVal TreeNode As TreeNode, Optional ByVal DeleteOriginalFiles As Boolean = False)
        Try
            If TreeNode Is Nothing Then Return
            If TreeNode.GetNodeCount(True) > 0 Then
                For Each tn As TreeNode In TreeNode.Nodes
                    Call DeleteChildNodes(tn, DeleteOriginalFiles)
                Next
                If DeleteOriginalFiles Then TreeNode.Remove()
            ElseIf IsDOFile(TreeNode) Then
                Dim DOFile As DOFile = Database.SelectDOFile(TreeNode.Tag)
                If DeleteOriginalFiles Then
                    DeleteFile(DOFile, True)
                    TreeNode.Remove()
                Else
                    DeleteFile(DOFile, False)
                    TreeNode.ImageIndex = ImageIndex.FILE_WITHOUT_DISSEMINATION
                End If
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Function DeleteFile(ByVal DOFile As DOFile, ByVal DeleteOriginalFiles As Boolean) As Boolean
        If DeleteOriginalFiles Then
            If Database.CountFilesWithSameOriginalURL(DOFile.OriginalURL) = 1 Then
                DeleteOriginal(DOFile)
                DeleteDissemination(DOFile)
                DeleteThumbnail(DOFile)
            End If
            Database.DeleteFile(DOFile.ID)
            Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteFile"), DOFile.Name))
        Else
            If Database.CountFilesWithSameDisseminationURL(DOFile.DisseminationURL) = 1 Then
                DeleteDissemination(DOFile)
                DeleteThumbnail(DOFile)
            End If
            DOFile.HasDissemination = False
            DOFile.DisseminationURL = ""
            DOFile.ThumbnailURL = ""
            Database.UpdateDOFile(DOFile)
            Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteDisseminationFile"), DOFile.Name))
        End If
    End Function

    Private Function DeleteOriginal(ByVal DOfile As DOFile) As Boolean
        If DOfile.OriginalURL.StartsWith(FILE_STORAGE) Then
            Try
                Dim FileName As String = DOfile.OriginalURL.Substring(FILE_STORAGE.Length)
                If File.Exists(FileName) Then
                    File.Delete(FileName)
                End If
            Catch ex As Exception
                MsgBoxException(ex)
            End Try
        ElseIf DOfile.OriginalURL.StartsWith(OBJECTVAULT_STORAGE) Then
            Try
                Dim ID As String = DOfile.OriginalURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return Vault.Delete(ID)
            Catch ex As Exception
                'Database.MsgBoxException(ex)
            End Try
        ElseIf DOfile.OriginalURL.StartsWith(SQLSERVER_STORAGE) Then
            Dim ID As String = DOfile.OriginalURL.Substring(SQLSERVER_STORAGE.Length)
            Return Database.DeleteBLOB(ID)
        End If
    End Function

    Private Function DeleteDissemination(ByVal DOfile As DOFile) As Boolean
        If DOfile.DisseminationURL.StartsWith(FILE_STORAGE) Then
            Dim FileName As String = DOfile.DisseminationURL.Substring(FILE_STORAGE.Length)
            If File.Exists(FileName) Then
                File.Delete(FileName)
            End If
        ElseIf DOfile.DisseminationURL.StartsWith(OBJECTVAULT_STORAGE) Then
            Try
                Dim ID As String = DOfile.DisseminationURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return Vault.Delete(ID)
            Catch ex As Exception
                'Database.MsgBoxException(ex)
            End Try
        ElseIf DOfile.DisseminationURL.StartsWith(SQLSERVER_STORAGE) Then
            Dim ID As String = DOfile.DisseminationURL.Substring(SQLSERVER_STORAGE.Length)
            Return Database.DeleteBLOB(ID)
        End If
    End Function

    Private Function DeleteThumbnail(ByVal DOfile As DOFile) As Boolean
        If DOfile.ThumbnailURL.StartsWith(FILE_STORAGE) Then
            Dim FileName As String = DOfile.ThumbnailURL.Substring(FILE_STORAGE.Length)
            If File.Exists(FileName) Then
                File.Delete(FileName)
            End If
        ElseIf DOfile.ThumbnailURL.StartsWith(OBJECTVAULT_STORAGE) Then
            Try
                Dim ID As String = DOfile.ThumbnailURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return Vault.Delete(ID)
            Catch ex As Exception
                'Database.MsgBoxException(ex)
            End Try
        ElseIf DOfile.ThumbnailURL.StartsWith(SQLSERVER_STORAGE) Then
            Dim ID As String = DOfile.ThumbnailURL.Substring(SQLSERVER_STORAGE.Length)
            Return Database.DeleteBLOB(ID)
        End If
    End Function

#End Region

#Region "Paste items"

    Private Sub PasteItems(ByVal Nodes As ArrayList, ByVal Op As Integer)
        Try
            If Op = Operation.NONE Then Return
            Dim DestTreeNode As TreeNode = Me.SelectedNode
            If DestTreeNode Is Nothing Or Nodes Is Nothing Then Return
            Dim SourceDigitalObjectTreeNode As TreeNode = GetRootNode(Nodes(0))
            Dim DestDigitalObjectTreeNode As TreeNode = GetRootNode(DestTreeNode)
            DestTreeNode.Expand()
            For Each tn As TreeNode In Nodes
                If IsAscendant(DestTreeNode, tn) Then Return
                AddTreeNode(tn, DestTreeNode, Op)
                If Op = Operation.CUT Then tn.Remove()
            Next
            SaveStructure(SourceDigitalObjectTreeNode)
            SaveStructure(DestDigitalObjectTreeNode)
            If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
                Me.PublishedDigitalObjectsTree.SelectedNode = DestTreeNode
            ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
                Me.UnpublishedDigitalObjectsTree.SelectedNode = DestTreeNode
            End If
            If Me.TabControl.SelectedTab Is Me.tpAddFiles Then
                LoadListView(DestTreeNode)
            End If
        Catch ex As Exception
            MsgBoxException(ex)
        End Try
    End Sub

    Private Sub AddTreeNode(ByVal TreeNode As TreeNode, ByVal DestTreeNode As TreeNode, ByVal Op As Operation)
        If TreeNode Is Nothing Or DestTreeNode Is Nothing Then Return
        If IsFolder(TreeNode) Then
            Dim tn As TreeNode = TreeNode.Clone
            DestTreeNode.Nodes.Add(tn)
            tn.Nodes.Clear()
            For Each ChildNode As TreeNode In TreeNode.Nodes
                AddTreeNode(ChildNode, tn, Op)
            Next
        ElseIf IsDOFile(TreeNode) Then
            Dim DOFile As DOFile = Database.SelectDOFile(TreeNode.Tag)
            DOFile.DigitalObjectID = GetRootNode(DestTreeNode).Tag
            If DOFile Is Nothing Then Return
            Dim tn As TreeNode = TreeNode.Clone
            DestTreeNode.Nodes.Add(tn)
            Select Case Op
                Case Operation.COPY
                    tn.Tag = Database.InsertFile(DOFile)
                Case Operation.CUT
                    Database.UpdateDOFile(DOFile)
            End Select
        End If
    End Sub

#End Region

#Region "Export items"

    Private Sub ExportAllFiles(ByVal TreeNodes As ArrayList)
        If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
            For Each TreeNode As TreeNode In TreeNodes
                ExportFiles(TreeNode, Me.FolderBrowserDialog.SelectedPath, Export.ALL)
            Next
        End If
    End Sub

    Private Sub ExportDisseminations(ByVal TreeNodes As ArrayList)
        If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
            For Each TreeNode As TreeNode In TreeNodes
                ExportFiles(TreeNode, Me.FolderBrowserDialog.SelectedPath, Export.DISSEMINATIONS)
            Next
        End If
    End Sub

    Private Sub ExportOriginals(ByVal TreeNodes As ArrayList)
        If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
            For Each TreeNode As TreeNode In TreeNodes
                ExportFiles(TreeNode, Me.FolderBrowserDialog.SelectedPath, Export.ORIGINALS)
            Next
        End If
    End Sub

    Private Function ExportFiles(ByVal tn As TreeNode, ByVal DirectoryName As String, ByVal Export As Export) As Boolean
        Me.Cursor = Cursors.WaitCursor
        If tn Is Nothing Then Return False
        If IsDOFile(tn) Then ExportFile(tn, DirectoryName, Export)
        If tn.GetNodeCount(False) > 0 Then
            tn = tn.Nodes(0)
            Do Until tn Is Nothing
                If tn.GetNodeCount(False) > 0 Then
                    ExportFiles(tn, DirectoryName, Export)
                Else
                    If IsDOFile(tn) Then ExportFile(tn, DirectoryName, Export)
                End If
                tn = tn.NextNode
            Loop
        End If
        Me.Cursor = Cursors.Default
    End Function

    Private Sub ExportFile(ByVal TreeNode As TreeNode, ByVal DirectoryName As String, ByVal Export As Export)
        Dim DOFile As DOFile = Database.SelectDOFile(TreeNode.Tag)
        Select Case Export
            Case Export.ALL
                ExportOriginal(DOFile, DirectoryName)
                ExportDissemination(DOFile, DirectoryName)
                ExportThumbnail(DOFile, DirectoryName)
            Case Export.DISSEMINATIONS
                ExportDissemination(DOFile, DirectoryName)
                ExportThumbnail(DOFile, DirectoryName)
            Case Export.ORIGINALS
                ExportOriginal(DOFile, DirectoryName)
        End Select
    End Sub

    Private Sub ExportOriginal(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Try
            Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, InfoMessage("Files.Originals")))
            DirectoryName = DirectoryInfo.FullName
            Dim DestFileName As String = String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, DOFile.Name)
            If DOFile.OriginalURL.StartsWith(FILE_STORAGE) Then
                Dim SourceFileName As String = DOFile.OriginalURL.Substring(FILE_STORAGE.Length)
                file.Copy(SourceFileName, DestFileName)

            ElseIf DOFile.OriginalURL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As String = DOFile.OriginalURL.Substring(SQLSERVER_STORAGE.Length)
                Dim File As Byte() = Database.SelectBLOB(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            ElseIf DOFile.OriginalURL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = DOFile.OriginalURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim File As Byte() = vault.Retrieve(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ExportDissemination(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Try
            Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, InfoMessage("Files.Disseminations")))
            DirectoryName = DirectoryInfo.FullName
            Dim DestFileName As String
            If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                DestFileName = String.Format("{0}{1}{2}.{3}", DirectoryName, Path.DirectorySeparatorChar, Path.GetFileNameWithoutExtension(DOFile.Name), "JPG")
            Else
                DestFileName = String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, DOFile.Name)
            End If
            If DOFile.DisseminationURL.StartsWith(FILE_STORAGE) Then
                Dim SourceFileName As String = DOFile.DisseminationURL.Substring(FILE_STORAGE.Length)
                File.Copy(SourceFileName, DestFileName)

            ElseIf DOFile.DisseminationURL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As String = DOFile.DisseminationURL.Substring(SQLSERVER_STORAGE.Length)
                Dim File As Byte() = Database.SelectBLOB(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            ElseIf DOFile.DisseminationURL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = DOFile.DisseminationURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim File As Byte() = vault.Retrieve(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ExportThumbnail(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Try
            Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, InfoMessage("Files.Thumbnails")))
            DirectoryName = DirectoryInfo.FullName
            Dim DestFileName As String
            If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                DestFileName = String.Format("{0}{1}{2}.{3}", DirectoryName, Path.DirectorySeparatorChar, Path.GetFileNameWithoutExtension(DOFile.Name), "JPG")
            Else
                DestFileName = String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, DOFile.Name)
            End If
            If DOFile.ThumbnailURL.StartsWith(FILE_STORAGE) Then
                Dim SourceFileName As String = DOFile.ThumbnailURL.Substring(FILE_STORAGE.Length)
                File.Copy(SourceFileName, DestFileName)

            ElseIf DOFile.ThumbnailURL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As String = DOFile.ThumbnailURL.Substring(SQLSERVER_STORAGE.Length)
                Dim File As Byte() = Database.SelectBLOB(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            ElseIf DOFile.ThumbnailURL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = DOFile.ThumbnailURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim File As Byte() = vault.Retrieve(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            End If
        Catch ex As Exception
        End Try
    End Sub

#End Region


#End Region

#Region "ListView Event Handlers"

    Private Sub ListView_DoubleClick(ByVal tn As TreeNode)
        IsEdited = True
        If Me.TabControlDigitalObjects.SelectedTab Is Me.PublishedDigitalObjectsTabPage Then
            Me.PublishedDigitalObjectsTree.SelectedNode = tn
        ElseIf Me.TabControlDigitalObjects.SelectedTab Is Me.UnpublishedDigitalObjectsTabPage Then
            Me.UnpublishedDigitalObjectsTree.SelectedNode = tn
        End If
        tn.Expand()
        IsEdited = False
    End Sub

    Private Sub LoadListView(ByVal tn As TreeNode)
        Dim ExitLoop As Integer = 50
        Me.DragDropListView.Clear()
        If tn Is Nothing Then Return
        If tn.GetNodeCount(False) > 0 Then
            'tn.Expand()
            If tn.Parent Is Nothing And Not tn.IsExpanded Then
                Dim DOStructure As String = Database.GetDOStructure(tn.Tag)
                DigitalObjectsTree.LoadTreeViewFromXML(DOStructure, tn)
            End If
            Dim ImageList As ImageList = GetLargeImageList(tn, ExitLoop)
            If ImageList Is Nothing Then Return
            Me.DragDropListView.LImageList = ImageList

            tn = tn.Nodes(0)
            Do Until tn Is Nothing
                Me.DragDropListView.AddListViewItem(tn)

                tn = tn.NextNode
                ExitLoop -= 1
                If ExitLoop = 0 Then Exit Do
            Loop
        End If
        If Me.DragDropListView.ItemsCount = 0 Then
            Me.DragDropListView.SetListViewBackgroundImage(AppDomain.CurrentDomain.BaseDirectory & "..\resources\ListViewBackground.png")
        Else
            Me.DragDropListView.SetListViewBackgroundImage("")
        End If
        Me.DragDropListView.UserLogon = USER_LOGON
    End Sub

#End Region

#Region "TabControl event handlers"

    Private Sub TabControl_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl.SelectedIndexChanged
        If Me.SelectedNode Is Nothing Then Return
        If Me.TabControl.SelectedTab Is Me.tpAddFiles Then
            LoadListView(Me.SelectedNode)
        End If
    End Sub

#End Region

#Region "MetadataDataGrid Event Handlers"

    Private Sub InsertProperty()
        Me.SaveButtonEnabled = True
    End Sub

    Private Sub UpdateProperty()
        Me.SaveButtonEnabled = True
    End Sub

    Private Sub DeleteProperty(ByVal Index As Integer)
        Me.SaveButtonEnabled = True
    End Sub

#End Region

#Region "Some auxiliary functions"

    Private Function GetRootNode(ByVal TreeNode As TreeNode) As TreeNode
        While Not TreeNode.Parent Is Nothing
            TreeNode = TreeNode.Parent
        End While
        Return TreeNode
    End Function

    Private Function IsAscendant(ByVal Child As TreeNode, ByVal Parent As TreeNode) As Boolean
        If Child Is Parent Then Return True
        While Not Child.Parent Is Nothing
            Child = Child.Parent
            If Child Is Parent Then Return True
        End While
        Return False
    End Function

    Private Sub SaveStructure(ByVal RootTreeNode As TreeNode)
        Dim XML As String = DigitalObjectsTree.LoadXMLFromTreeView(RootTreeNode)
        Database.UpdateDOStructure(RootTreeNode.Tag, XML)
    End Sub

    Public Function BytesToKB(ByVal intSize As Long) As String
        Dim Result As Double = intSize / 1024
        If Result < 1 Then Return String.Format("{0:#.00}", Result)
        Return Math.Round(Result)
    End Function

    Private Sub ShowDigitalObjectTabPages(Optional ByVal TabPage As TabPage = Nothing)
        If Not Me.SelectedNode Is Nothing AndAlso Not Me.LastSelectedNode Is Nothing AndAlso TabPage Is Nothing Then
            If Me.SelectedNode.ImageIndex = Me.LastSelectedNode.ImageIndex Then Return
        End If
        RemoveAllTabPages()
        Me.TabControl.TabPages.Add(Me.tpMetadata)
        Me.TabControl.TabPages.Add(Me.tpPreservationMetadata)
        Me.TabControl.TabPages.Add(Me.tpAddFiles)
        If Not TabPage Is Nothing Then
            Me.TabControl.SelectedTab = TabPage
            TabPage.Show()
        End If
    End Sub

    Private Sub ShowPreviewTabPage()
        If Not Me.SelectedNode Is Nothing And Not Me.LastSelectedNode Is Nothing Then
            If Me.SelectedNode.ImageIndex = Me.LastSelectedNode.ImageIndex Then Return
        End If
        RemoveAllTabPages()
        Me.TabControl.TabPages.Add(Me.tpPreview)
    End Sub

    Private Sub ShowFilesTabPage()
        If Not Me.SelectedNode Is Nothing And Not Me.LastSelectedNode Is Nothing Then
            If Me.SelectedNode.ImageIndex = Me.LastSelectedNode.ImageIndex Then Return
        End If
        RemoveAllTabPages()
        Me.TabControl.TabPages.Add(Me.tpAddFiles)
    End Sub

    Private Sub ShowMessageTabPage(ByVal MessageTitle As String, ByVal Message As String)
        If Not Me.SelectedNode Is Nothing And Not Me.LastSelectedNode Is Nothing Then
            If Me.SelectedNode.ImageIndex = Me.LastSelectedNode.ImageIndex Then Return
        End If
        RemoveAllTabPages()
        Me.TabControl.TabPages.Add(Me.tpMessage)
        Me.lblMessageTitle.Text = MessageTitle
        Me.lblMessage.Text = Message
    End Sub

    Private Sub RemoveAllTabPages()
        Me.TabControl.TabPages.Remove(Me.tpMetadata)
        Me.TabControl.TabPages.Remove(Me.tpPreservationMetadata)
        Me.TabControl.TabPages.Remove(Me.tpPreview)
        Me.TabControl.TabPages.Remove(Me.tpAddFiles)
        Me.TabControl.TabPages.Remove(Me.tpMessage)
    End Sub

    Private Sub Format()
        Dim UserProfile As String = (New SQLDataBase).getProfile(USER_LOGON, ConfigurationSettings.AppSettings("Application.Code")).Profile
        Dim AdminProfile As String = ConfigurationSettings.AppSettings("Profile.Administrator")

        Dim IData As IDataObject = Clipboard.GetDataObject()
        If Me.SelectedNode Is Nothing Then
            Me.RemoveDigitalObjectButton.Enabled = True
            Me.RemoveUnpublishedDigitalObjectButton.Enabled = True
            Me.PublishButton.Enabled = True
            Me.UnpublishButton.Enabled = True
            Me.miCopy.Enabled = False
            Me.miCut.Enabled = False
            Me.miPaste.Enabled = True
        ElseIf IsDigitalObject(Me.SelectedNode) Then
            Me.RemoveDigitalObjectButton.Enabled = True
            Me.UnpublishButton.Enabled = True
            Me.RemoveUnpublishedDigitalObjectButton.Enabled = True
            Me.PublishButton.Enabled = True
            Me.miDelete.Enabled = UserProfile = AdminProfile
            Me.miCopy.Enabled = False
            Me.miCut.Enabled = False
            If Me.PublishedDigitalObjectsTree.Operation <> Operation.NONE Or Me.UnpublishedDigitalObjectsTree.Operation <> Operation.NONE Then
                Me.miPaste.Enabled = True
            Else
                Me.miPaste.Enabled = False
            End If
            Me.miViewOriginal.Enabled = UserProfile = AdminProfile
        ElseIf IsFolder(Me.SelectedNode) Then
            Me.RemoveDigitalObjectButton.Enabled = False
            Me.UnpublishButton.Enabled = False
            Me.RemoveUnpublishedDigitalObjectButton.Enabled = False
            Me.PublishButton.Enabled = False
            Me.miDelete.Enabled = UserProfile = AdminProfile
            Me.miCopy.Enabled = True
            Me.miCut.Enabled = True
            If Me.PublishedDigitalObjectsTree.Operation <> Operation.NONE Or Me.UnpublishedDigitalObjectsTree.Operation <> Operation.NONE Then
                Me.miPaste.Enabled = True
            Else
                Me.miPaste.Enabled = False
            End If
            Me.miViewOriginal.Enabled = UserProfile = AdminProfile
        ElseIf IsDOFile(Me.SelectedNode) Then
            Me.RemoveDigitalObjectButton.Enabled = False
            Me.UnpublishButton.Enabled = False
            Me.RemoveUnpublishedDigitalObjectButton.Enabled = False
            Me.PublishButton.Enabled = False
            Me.miDelete.Enabled = UserProfile = AdminProfile
            Me.miCopy.Enabled = True
            Me.miCut.Enabled = True
            Me.miPaste.Enabled = False
            Me.miViewOriginal.Enabled = UserProfile = AdminProfile
        End If
    End Sub

    Private Sub ClearFields()
        Me.Name = ""
        Me.OriginalName = ""
        Me.tvwDescriptionInfo.Nodes.Clear()
        Me.ArchiveID = ""
        Me.TopographicalQuota = ""
        Me.CreationDateTime = ""
        Me.ArchiveDateTime = ""
        Me.DepositDateTime = ""
        Me.RevisionDateTime = ""
        Me.QuantityOfTerminalObjects = ""
        Me.CaptureEntityCorporate = ""
        Me.CaptureEntityIndividual = ""
        Me.ResponsabilityEntity = ""
        Me.PreservationOriginalInformation = ""
        Me.ExternalDescriptiveInformation = ""
        Me.ArchivingProfile = ""
    End Sub

    Private Function GetFormat(ByVal FileName As String) As String
        Return FileName.Substring(FileName.LastIndexOf(".") + 1).ToUpper()
    End Function

    Private Function GetFilename(ByVal FilePath As String) As String
        Return Path.GetFileName(FilePath)
    End Function

    Private Function GetDirectoryName(ByVal DirectoryPath As String) As String
        Return DirectoryPath.Substring(DirectoryPath.LastIndexOf(Path.DirectorySeparatorChar) + 1)
    End Function

    Private Function IsDOFile(ByVal TreeNode As TreeNode) As Boolean
        Return TreeNode.ImageIndex = ImageIndex.FILE_WITH_DISSEMINATION OrElse _
            TreeNode.ImageIndex = ImageIndex.FILE_WITHOUT_DISSEMINATION OrElse _
            TreeNode.ImageIndex = ImageIndex.CORRUPTED_FILE
    End Function

    Private Function IsFolder(ByVal TreeNode As TreeNode) As Boolean
        Return TreeNode.ImageIndex = ImageIndex.NODE
    End Function

    Private Function IsDigitalObject(ByVal TreeNode As TreeNode) As Boolean
        Return TreeNode.ImageIndex = ImageIndex.PUBLISHED_DIGITALOBJECT OrElse _
            TreeNode.ImageIndex = ImageIndex.UNPUBLISHED_DIGITALOBJECT OrElse _
            TreeNode.ImageIndex = ImageIndex.WARNING_DIGITALOBJECT
    End Function

    Private Sub ShowHideMenuItems()
        If Me.TabControl.SelectedTab Is Me.tpMetadata Then
            Me.miViewOriginal.Enabled = False
            Me.miViewDissemination.Enabled = False
            Me.miViewThumbnail.Enabled = False
            Me.miViewTechnicalMatadata.Enabled = False
        ElseIf Me.TabControl.SelectedTab Is Me.tpPreservationMetadata Then
            Me.miViewOriginal.Enabled = False
            Me.miViewDissemination.Enabled = False
            Me.miViewThumbnail.Enabled = False
            Me.miViewTechnicalMatadata.Enabled = False
        ElseIf Me.TabControl.SelectedTab Is Me.tpPreview Then
            Me.miViewOriginal.Enabled = True
            Me.miViewDissemination.Enabled = True
            Me.miViewThumbnail.Enabled = True
            Me.miViewTechnicalMatadata.Enabled = True
        ElseIf Me.TabControl.SelectedTab Is Me.tpAddFiles Then
            Me.miViewOriginal.Enabled = False
            Me.miViewDissemination.Enabled = False
            Me.miViewThumbnail.Enabled = False
            Me.miViewTechnicalMatadata.Enabled = False
        End If
    End Sub

#End Region

#Region "Textboxs Event Handlers"

    'Private Sub txtName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtName.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtOriginalName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtOriginalName.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtArchiveID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtArchiveID.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtTopographicalQuota_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTopographicalQuota.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtCreationDateTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCreationDateTime.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtArchiveDateTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtArchiveDateTime.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtDepositDateTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDepositDateTime.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtCaptureEntityCorporate_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCaptureEntityCorporate.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtResponsabilityEntity_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtResponsabilityEntity.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtPreservationOriginalInformation_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPreservationOriginalInformation.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    'Private Sub txtExternalDescriptiveInfo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtExternalDescriptiveInfo.TextChanged
    '    SaveButtonEnabled = False
    'End Sub

    'Private Sub txtArchivingProfile_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtArchivingProfile.TextChanged
    '    SaveButtonEnabled = True
    'End Sub

    Private Sub txtName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtName.TextChanged
        SaveButtonEnabled = True
        If Me.SelectedNode Is Nothing Then Return
        Me.SelectedNode.Text = Me.DigitalObjectName
    End Sub

    Private Sub txtOriginalName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtOriginalName.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtArchiveID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtArchiveID.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtTopographicalQuota_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTopographicalQuota.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtCreationDateTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCreationDateTime.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtArchiveDateTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtArchiveDateTime.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtDepositDateTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDepositDateTime.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtCaptureEntityCorporate_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCaptureEntityCorporate.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtResponsabilityEntity_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtResponsabilityEntity.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtCaptureEntityIndividual_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCaptureEntityIndividual.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtPreservationOriginalInformation_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPreservationOriginalInformation.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtExternalDescriptiveInfo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtExternalDescriptiveInfo.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtArchivingProfile_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtArchivingProfile.TextChanged
        SaveButtonEnabled = True
    End Sub

    Private Sub txtTransformer_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtTransformer.TextChanged
        SaveButtonEnabled = True
    End Sub

#End Region

#Region "Buttons Event Handlers"

    Private Sub AddDigitalObjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddDigitalObjectButton.Click
        ShowDigitalObjectTabPages(Me.tpMetadata)

        ClearFields()
        InsertDigitalObject(GetNewDigitalObjectName, True)
    End Sub

    Private Sub AddUnpublishedDigitalObjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddUnpublishedDigitalObjectButton.Click
        ShowDigitalObjectTabPages(Me.tpMetadata)

        ClearFields()
        InsertDigitalObject(GetNewDigitalObjectName, False)
    End Sub

    Private Sub RemoveDigitalObjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveDigitalObjectButton.Click
        If Me.PublishedDigitalObjectsTree.SelectedNodes.Count = 0 Then Return
        Dim TreeNodes As New ArrayList
        For Each TreeNode As TreeNode In Me.PublishedDigitalObjectsTree.SelectedNodes
            TreeNodes.Add(TreeNode)
        Next
        DeleteDigitalObjects(TreeNodes, False)
    End Sub

    Private Sub RemoveUnpublishedDigitalObjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveUnpublishedDigitalObjectButton.Click
        If Me.UnpublishedDigitalObjectsTree.SelectedNodes.Count = 0 Then Return
        Dim TreeNodes As New ArrayList
        For Each TreeNode As TreeNode In Me.UnpublishedDigitalObjectsTree.SelectedNodes
            TreeNodes.Add(TreeNode)
        Next
        DeleteDigitalObjects(TreeNodes, False)
    End Sub

    Private Sub SearchUnpublishedDigitalObjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchUnpublishedDigitalObjectButton.Click
        Dim FindDOForm As New FindDOForm(myProjectID, False)
        FindDOForm.ShowDialog(Me)
    End Sub

    Private Sub SearchDigitalObjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchDigitalObjectButton.Click
        Dim FindDOForm As New FindDOForm(myProjectID, True)
        FindDOForm.ShowDialog(Me)
    End Sub

    Private Sub PublishButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PublishButton.Click
        If Me.UnpublishedDigitalObjectsTree.SelectedNodes.Count = 0 Then Return
        PublishDigitalObject(Me.UnpublishedDigitalObjectsTree.SelectedNodes, True)
        Me.UnpublishedDigitalObjectsTree.SelectedNodes.Clear()
    End Sub

    Private Sub UnpublishButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UnpublishButton.Click
        If Me.PublishedDigitalObjectsTree.SelectedNodes.Count = 0 Then Return
        PublishDigitalObject(Me.PublishedDigitalObjectsTree.SelectedNodes, False)
        Me.PublishedDigitalObjectsTree.SelectedNodes.Clear()
    End Sub

    Private Sub PublishDigitalObject(ByVal TreeNodes As ArrayList, ByVal Publish As Boolean)
        If Publish Then
            For Each TreeNode As TreeNode In TreeNodes
                Database.SetActive(GetRootNode(TreeNode).Tag, 1)
            Next
            LoadDigitalObjects(Me.ProjectID)
            Me.TabControlDigitalObjects.SelectedTab = Me.PublishedDigitalObjectsTabPage
            Me.PublishedDigitalObjectsTabPage.Show()
        Else
            For Each TreeNode As TreeNode In TreeNodes
                Database.SetActive(GetRootNode(TreeNode).Tag, 0)
            Next
            LoadDigitalObjects(Me.ProjectID)
            Me.TabControlDigitalObjects.SelectedTab = Me.UnpublishedDigitalObjectsTabPage
            Me.UnpublishedDigitalObjectsTabPage.Show()
        End If
    End Sub

#End Region

#Region "Association"

    Private Sub AssociationMetadataButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AssociationMetadataButton.Click
        OpenAssociationForm()
    End Sub

    Private Sub AssociationPreservationButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AssociationPreservationButton.Click
        OpenAssociationForm()
    End Sub

    Private Sub AssociationPreviewButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AssociationPreviewButton.Click
        OpenAssociationForm()
    End Sub

    Private Sub AssociationButton_Click()
        OpenAssociationForm()
    End Sub

    Private Sub OpenAssociationForm()
        If Not Me.SelectedNode Is Nothing Then
            Dim PODForm As New MPOD.AssociationForm(USER_LOGON, ProjectID, GetRootNode(Me.SelectedNode).Tag)
            PODForm.Show()
        Else
            Dim PODForm As New MPOD.AssociationForm
            PODForm.Show()
        End If
    End Sub

#End Region

#Region "Save"

    Private Sub ConfirmSave()
        If Me.SaveButtonEnabled Then
            If Not Me.miAskBeforeSave.Checked OrElse MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.Yes Then
                Me.SelectedNode = Me.LastSelectedNode
                Save()
            End If
        End If
    End Sub

    Private Sub SaveFilesButton_Click()
        Save()
    End Sub

    Private Sub SaveMetadataButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveMetadataButton.Click
        Save()
    End Sub

    Private Sub SavePreservationButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SavePreservationButton.Click
        Save()
    End Sub

    Private Overloads Sub SavePreviewButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SavePreviewButton.Click
        Save()
    End Sub

    Private Sub Save()
        If IsDigitalObject(Me.SelectedNode) Then
            If Not CheckBeforeSave() Then
                Me.SaveButtonEnabled = False
                Return
            End If
            UpdateDigitalObject(Me.SelectedNode.Tag)
            If Not Me.Transformer.Equals("") Then
                SavePreservationAction()
            End If
        ElseIf IsDOFile(Me.SelectedNode) Then
            Database.InsertProperties(Me.SelectedNode.Tag, Me.MetadataDataGrid.GetProperties)
        End If
        Me.SaveButtonEnabled = False
    End Sub

    Private Function CheckBeforeSave() As Boolean
        If Me.DigitalObjectName.Length = 0 Then
            MsgBox(InfoMessage("DigitalObjects.InvalidDigitalObjectName"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            Me.txtName.Focus()
            Return False
        End If
        If Not IsDate(CreationDateTime) Then
            MsgBox(InfoMessage("DigitalObjects.InvalidCreationDateTime"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            Me.txtCreationDateTime.Focus()
            Return False
        End If
        If Not IsDate(ArchiveDateTime) Then
            MsgBox(InfoMessage("DigitalObjects.InvalidArchiveDateTime"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            Me.txtArchiveDateTime.Focus()
            Return False
        End If
        If CDate(CreationDateTime) > CDate(ArchiveDateTime) Then
            MsgBox(InfoMessage("DigitalObjects.WrongCreationDateTime"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            Me.txtArchiveDateTime.Focus()
            Return False
        End If
        If Me.DepositDateTime.Length > 0 Then
            If Not IsDate(DepositDateTime) Then
                MsgBox(InfoMessage("DigitalObjects.InvalidDepositDateTime"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
                Me.txtDepositDateTime.Focus()
                Return False
            End If
        End If
        If DepositDateTime.Length > 0 Then
            If CDate(CreationDateTime) > CDate(DepositDateTime) Then
                MsgBox(InfoMessage("DigitalObjects.WrongDepositDateTime"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
                Me.txtDepositDateTime.Focus()
                Return False
            End If
        End If
        If (Me.Transformer.Length = 0) AndAlso (Me.Platform.Length > 0 Or Me.RenderEngine.Length > 0 Or Me.InputFormat.Length > 0 Or _
            Me.Parameters.Length > 0 Or Me.txtReformattingMethod.Text.Length > 0 Or Me.lbxReformattingNormsChoosen.Items.Count > 0) Then
            MsgBox(InfoMessage("DigitalObjects.TransformerMissing"), MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            Me.txtDepositDateTime.Focus()
            Return False
        End If

        Return True
    End Function

#Region "Save file"

    Private Function StoreFile(ByVal tn As TreeNode) As Boolean
        Dim myProgramState As New ProgramState
        Dim Success As Boolean
        Dim FilePath As String = tn.Tag
        Try
            'If Not Path.GetFileNameWithoutExtension(FilePath).Equals(Path.GetFileNameWithoutExtension(FilePath).Replace(".", "")) Then Return False
            Dim GeneDissemination As Boolean = DBToBool(myProgramState.GeneDissemination)
            If File.Exists(FilePath) Then
                Dim DOfile As DOfile = InsertFileMetadata(FilePath, Me.RootNode.Tag, USER_LOGON)
                InsertFileProperties(DOfile, FilePath)
                StoreFile(DOfile, FilePath, GeneDissemination)

                tn.Tag = DOfile.ID
                If GeneDissemination Then
                    tn.ImageIndex = ImageIndex.FILE_WITH_DISSEMINATION
                Else
                    tn.ImageIndex = ImageIndex.FILE_WITHOUT_DISSEMINATION
                End If
            End If
            myProgressDialog.Increment()
        Catch ex As VaultFileSizeException
            Debug.WriteLine(FilePath & vbNewLine & ex.StackTrace)
            tn.ImageIndex = ImageIndex.CORRUPTED_FILE
        Catch ex As VaultException
            Debug.WriteLine(FilePath & vbNewLine & ex.StackTrace)
            tn.ImageIndex = ImageIndex.CORRUPTED_FILE
        Catch ex As Exception
            MsgBox(ex.ToString)
            Debug.WriteLine(FilePath & vbNewLine & ex.StackTrace)
            tn.ImageIndex = ImageIndex.CORRUPTED_FILE
        End Try
    End Function

    Private Function InsertFileMetadata(ByVal FilePath As String, ByVal DigitalObjectID As Int64, ByVal User As String) As DOFile
        myProgressDialog.Message = String.Format(InfoMessage("Files.InsertFile"), GetFilename(FilePath))
        Dim DOFile As New DOFile(FilePath, DigitalObjectID, User)
        DOFile.ID = Database.InsertFile(DOFile)
        Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.InsertFile"), DOFile.Name, Me.DigitalObjectName))
        Return DOFile
    End Function

    Private Sub InsertFileProperties(ByVal DOFile As DOFile, ByVal FilePath As String)
        Dim OriginalFileStream As New FileStream(FilePath, FileMode.Open, FileAccess.Read, FileShare.Read)
        If EXIFExtractor.CanExtractProperties(DOFile.Format) Then
            myProgressDialog.Message = String.Format(InfoMessage("Files.InsertFileMetadata"), DOFile.Name)

            Dim TechnologicalPlatform As TechnologicalPlatform = Database.SelectProjectTechnologicalPlatform(ProjectID)
            Dim DigitalizationProfile As DigitalizationProfile = Database.SelectProjectDigitalizationProfile(ProjectID)

            Dim ControlledVocabularies As Hashtable = GetControlledVocabularies(ProjectID)
            Dim Properties As Hashtable = GetExifProperties(OriginalFileStream, TechnologicalPlatform, DigitalizationProfile, ControlledVocabularies)

            Database.InsertProperties(DOFile.ID, Properties)
        End If
        OriginalFileStream.Close()
    End Sub

#Region "Get EXIF properties"

    Private Function GetExifProperties(ByVal InputStream As Stream, _
                        ByVal TechnologicalPlatform As TechnologicalPlatform, _
                        ByVal DigitalizationProfile As DigitalizationProfile, _
                        ByVal ControlledVocabulary As Hashtable) As Hashtable

        Dim Image As System.Drawing.Image = System.Drawing.Image.FromStream(InputStream, True)
        Dim ExifProperties As Hashtable = EXIFExtractor.GetExifProperties(Image)


        Dim Properties As New Hashtable

        Properties.Add(GetConfig("File.Properties.Resolution"), Image.HorizontalResolution)
        Properties.Add(GetConfig("File.Properties.Width"), Image.Width)
        Properties.Add(GetConfig("File.Properties.Height"), Image.Height)

        If Not DigitalizationProfile Is Nothing Then
            Properties.Add(GetConfig("File.Properties.BitDepth"), DigitalizationProfile.BitDepth)
            Properties.Add(GetConfig("File.Properties.Compression"), DigitalizationProfile.Compression)
            Properties.Add(GetConfig("File.Properties.Brightness"), DigitalizationProfile.Brightness)
            Properties.Add(GetConfig("File.Properties.Contrast"), DigitalizationProfile.Contrast)
            Properties.Add(GetConfig("File.Properties.Sharpness"), DigitalizationProfile.Sharpness)
            Properties.Add(GetConfig("File.Properties.Blur"), DigitalizationProfile.Blur)
            Properties.Add(GetConfig("File.Properties.Orientation"), DigitalizationProfile.Orientation)
        End If
        If Not EXIFExtractor.BitsPerPixel(Image).Equals("") Then
            If Properties.ContainsKey(GetConfig("File.Properties.BitDepth")) Then
                Properties.Item(GetConfig("File.Properties.BitDepth")) = EXIFExtractor.BitsPerPixel(Image)
            Else
                Properties.Add(GetConfig("File.Properties.BitDepth"), EXIFExtractor.BitsPerPixel(Image))
            End If
        End If

        If Not EXIFExtractor.Compression(Image, EXIFExtractor.GetPropertyValue(ExifProperties, "Compression", "")).Equals("") Then
            If Properties.ContainsKey(GetConfig("File.Properties.Compression")) Then
                Properties.Item(GetConfig("File.Properties.Compression")) = EXIFExtractor.Compression(Image, EXIFExtractor.GetPropertyValue(ExifProperties, "Compression", ""))
            Else
                Properties.Add(GetConfig("File.Properties.Compression"), EXIFExtractor.Compression(Image, EXIFExtractor.GetPropertyValue(ExifProperties, "Compression", "")))
            End If
        End If

        Properties.Add(GetConfig("File.Properties.DateTime"), EXIFExtractor.CompleteDateToDB(EXIFExtractor.GetPropertyValue(ExifProperties, "Date Time", "")))
        Properties.Add(GetConfig("File.Properties.ColorSpace"), EXIFExtractor.ColorSpace(Image))
        Properties.Add(GetConfig("File.Properties.F-Number"), EXIFExtractor.GetPropertyValue(ExifProperties, "F-Number", ""))
        Properties.Add(GetConfig("File.Properties.ExposureTime"), EXIFExtractor.GetPropertyValue(ExifProperties, "Exposure Time", ""))
        Properties.Add(GetConfig("File.Properties.FocalLength"), EXIFExtractor.GetPropertyValue(ExifProperties, "FocalLength", ""))
        Properties.Add(GetConfig("File.Properties.MeteringMode"), ControlledVocabulary.Item("Forma medio"))
        Properties.Add(GetConfig("File.Properties.FocusType"), ControlledVocabulary.Item("Tipo focagem"))

        If Not TechnologicalPlatform Is Nothing Then
            Properties.Add(GetConfig("TechnologicalPlatform.Name"), TechnologicalPlatform.Name)
            Properties.Add(GetConfig("TechnologicalPlatform.DeviceSource"), TechnologicalPlatform.DeviceSource)
            Properties.Add(GetConfig("TechnologicalPlatform.Manufacturer"), TechnologicalPlatform.Manufacturer)
            Properties.Add(GetConfig("TechnologicalPlatform.Software"), TechnologicalPlatform.Software)
            Properties.Add(GetConfig("TechnologicalPlatform.SoftwareVersion"), TechnologicalPlatform.SoftwareVersion)
            Properties.Add(GetConfig("TechnologicalPlatform.OperatingSystem"), TechnologicalPlatform.OperatingSystem)
            Properties.Add(GetConfig("TechnologicalPlatform.OperatingSystemVersion"), TechnologicalPlatform.OperatingSystemVersion)
            Properties.Add(GetConfig("TechnologicalPlatform.Illuminance"), TechnologicalPlatform.Illuminance)
            Properties.Add(GetConfig("TechnologicalPlatform.FontType"), TechnologicalPlatform.FontType)
            Properties.Add(GetConfig("TechnologicalPlatform.ProcessingActions"), TechnologicalPlatform.ProcessingActions)
            Properties.Add(GetConfig("TechnologicalPlatform.ProcessingSoftwareName"), TechnologicalPlatform.ProcessingSoftwareName)
            Properties.Add(GetConfig("TechnologicalPlatform.ProcessingSoftwareVersion"), TechnologicalPlatform.ProcessingSoftwareVersion)
            Properties.Add(GetConfig("TechnologicalPlatform.ProcessingOSName"), TechnologicalPlatform.ProcessingOSName)
            Properties.Add(GetConfig("TechnologicalPlatform.ProcessingOSVersion"), TechnologicalPlatform.ProcessingOSVersion)
            Properties.Add(GetConfig("TechnologicalPlatform.ColorManager"), TechnologicalPlatform.ColorManager)
        End If
        Image.Dispose()
        Return Properties
    End Function

#End Region

    Private Function GetControlledVocabularies(ByVal ProjectID As Integer) As Hashtable
        Dim ControlledVocabularies As New Hashtable
        Dim ControlledVocabularyCollection As ControlledVocabularyCollection = Database.SelectControlledVocabularies

        For Each ControlledVocabulary As ControlledVocabulary In ControlledVocabularyCollection
            ControlledVocabularies.Add(ControlledVocabulary.Name, Database.SelectVocabularyValue(ProjectID, ControlledVocabulary.ID))
        Next

        Return ControlledVocabularies
    End Function

    Private Function StoreFile(ByVal DOFile As DOFile, ByVal FilePath As String, ByVal GeneDissemination As Boolean) As Boolean

        Dim OriginalFileStream As New FileStream(FilePath, FileMode.Open, FileAccess.Read, FileShare.Read)
        DOFile = StoreOriginalFile(DOFile, OriginalFileStream, FilePath)

        If GeneDissemination Then
            DOFile = StoreDisseminationFile(DOFile, OriginalFileStream)
            DOFile = StoreThumbnailFile(DOFile, OriginalFileStream)
        End If
        OriginalFileStream.Close()
        Database.UpdateDOFile(DOFile)
    End Function

    Private Function StoreOriginalFile(ByVal DOFile As DOFile, ByVal OriginalStream As Stream, ByVal FilePath As String) As DOFile
        Dim ProgramState As New ProgramState

        myProgressDialog.Message = String.Format(InfoMessage("Files.InsertOriginal"), DOFile.Name)
        Select Case ProgramState.OriginalStorage
            Case ProgramState.StorageForm.Database

                Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, FileProcessing.WriteStreamToBynary(OriginalStream))
                DOFile.OriginalURL = SQLSERVER_STORAGE & CStr(ID)
                Return DOFile

            Case ProgramState.StorageForm.FileSystem
                DOFile.OriginalURL = FILE_STORAGE & FilePath
                Return DOFile

            Case ProgramState.StorageForm.ObjectVault
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim CustomMetadata As New Hashtable
                CustomMetadata.Add("Date", Now.ToShortDateString)

                Dim Result As Byte() = Vault.Store(OriginalStream, DOFile.Name, CustomMetadata)

                Dim ObjectID As String = ASCII.GetString(Result)
                DOFile.OriginalURL = OBJECTVAULT_STORAGE & ObjectID
                Return DOFile
        End Select
    End Function

    Private Function StoreDisseminationFile(ByVal DOFile As DOFile, ByVal OriginalStream As Stream) As DOFile
        Dim ProgramState As New ProgramState

        myProgressDialog.Message = String.Format(InfoMessage("Files.InsertDissemination"), DOFile.Name)
        Select Case ProgramState.DisseminationStorage
            Case ProgramState.StorageForm.Database
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                    Dim OutputStream As New MemoryStream

                    FileProcessing.GenerateDisseminationImage(OriginalStream, OutputStream, ProgramState.DisseminationQuality, ProgramState.DisseminationDim, GetDimensionValue(ProgramState.DisseminationDim))
                    Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, OutputStream.ToArray)
                    OutputStream.Close()
                    DOFile.DisseminationURL = SQLSERVER_STORAGE & CStr(ID)
                    DOFile.HasDissemination = True
                    Return DOFile
                ElseIf ProgramState.OriginalStorage = ProgramState.StorageForm.FileSystem Then
                    Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, DOFile.OriginalFile)
                    DOFile.DisseminationURL = SQLSERVER_STORAGE & CStr(ID)
                    DOFile.HasDissemination = True
                    Return DOFile
                Else
                    DOFile.HasDissemination = True
                    DOFile.DisseminationURL = DOFile.OriginalURL
                    Return DOFile
                End If

            Case ProgramState.StorageForm.ObjectVault
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then

                    Dim OutputStream As New MemoryStream
                    FileProcessing.GenerateDisseminationImage(OriginalStream, OutputStream, ProgramState.DisseminationQuality, ProgramState.DisseminationDim, GetDimensionValue(ProgramState.DisseminationDim))

                    Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                    Dim CustomMetadata As New Hashtable
                    CustomMetadata.Add("Date", Now.ToShortDateString)
                    Dim Result As Byte() = Vault.Store(OutputStream, DOFile.Name, CustomMetadata)
                    OutputStream.Close()
                    Dim ObjectID As String = ASCII.GetString(Result)

                    DOFile.DisseminationURL = OBJECTVAULT_STORAGE & ObjectID
                    DOFile.HasDissemination = True
                    Return DOFile
                ElseIf ProgramState.OriginalStorage = ProgramState.StorageForm.FileSystem Then

                    Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                    Dim CustomMetadata As New Hashtable
                    CustomMetadata.Add("Date", Now.ToShortDateString)
                    Dim Result As Byte() = Vault.Store(OriginalStream, DOFile.Name, CustomMetadata)
                    Dim ObjectID As String = ASCII.GetString(Result)

                    DOFile.DisseminationURL = OBJECTVAULT_STORAGE & ObjectID
                    DOFile.HasDissemination = True
                    Return DOFile
                Else
                    DOFile.HasDissemination = True
                    DOFile.DisseminationURL = DOFile.OriginalURL
                    Return DOFile
                End If
        End Select
    End Function

    Private Function StoreThumbnailFile(ByVal DOFile As DOFile, ByVal OriginalStream As Stream) As DOFile
        Dim FileProcessing As New FileProcessing
        Dim ProgramState As New ProgramState

        myProgressDialog.Message = String.Format(InfoMessage("Files.InsertThumbnail"), DOFile.Name)
        Select Case ProgramState.DisseminationStorage
            Case ProgramState.StorageForm.Database
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                    Dim OutputStream As New MemoryStream
                    FileProcessing.GenerateThumbnailImage(OriginalStream, OutputStream, THUMBNAIL_WIDTH)
                    Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, OutputStream.ToArray)
                    OutputStream.Close()
                    DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
                    Return DOFile
                Else
                    Select Case DOFile.Format
                        Case "FLV"
                            Dim Thumb As Byte() = FileProcessing.ReadBinaryFile(System.Windows.Forms.Application.StartupPath + "\..\Images\video.gif")
                            Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, Thumb)
                            DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
                            Return DOFile
                        Case "MP3"
                            Dim Thumb As Byte() = FileProcessing.ReadBinaryFile(System.Windows.Forms.Application.StartupPath + "\..\Images\sound.gif")
                            Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, Thumb)
                            DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
                            Return DOFile
                        Case "PDF"
                            Dim Thumb As Byte() = FileProcessing.ReadBinaryFile(System.Windows.Forms.Application.StartupPath + "\..\Images\pdf.gif")
                            Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, Thumb)
                            DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
                            Return DOFile
                        Case "DOC"
                            Dim Thumb As Byte() = FileProcessing.ReadBinaryFile(System.Windows.Forms.Application.StartupPath + "\..\Images\doc.gif")
                            Dim ID As Int64 = Database.InsertBLOB(DOFile.ID, Thumb)
                            DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
                            Return DOFile
                    End Select
                End If

            Case ProgramState.StorageForm.ObjectVault
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then

                    Dim OutputStream As New MemoryStream
                    FileProcessing.GenerateThumbnailImage(OriginalStream, OutputStream, THUMBNAIL_WIDTH)

                    Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                    Dim CustomMetadata As New Hashtable
                    CustomMetadata.Add("Date", Now.ToShortDateString)
                    Dim Result As Byte() = Vault.Store(OutputStream, DOFile.Name, CustomMetadata)
                    OutputStream.Close()
                    Dim ObjectID As String = ASCII.GetString(Result)

                    DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
                    Return DOFile
                Else
                    Select Case DOFile.Format
                        Case "FLV"
                            Dim OutputStream As New MemoryStream
                            Dim ThumbStream As New FileStream(System.Windows.Forms.Application.StartupPath + "\..\Images\video.gif", FileMode.Open, FileAccess.Read, FileShare.Read)

                            Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                            Dim CustomMetadata As New Hashtable
                            CustomMetadata.Add("Date", Now.ToShortDateString)
                            Dim Result As Byte() = Vault.Store(ThumbStream, "thumb.gif", CustomMetadata)
                            OutputStream.Close()
                            Dim ObjectID As String = ASCII.GetString(Result)

                            DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
                            Return DOFile
                        Case "MP3"
                            Dim OutputStream As New MemoryStream
                            Dim ThumbStream As New FileStream(System.Windows.Forms.Application.StartupPath + "\..\Images\sound.gif", FileMode.Open, FileAccess.Read, FileShare.Read)
                            Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                            Dim CustomMetadata As New Hashtable
                            CustomMetadata.Add("Date", Now.ToShortDateString)
                            Dim Result As Byte() = Vault.Store(ThumbStream, "thumb.gif", CustomMetadata)
                            OutputStream.Close()
                            Dim ObjectID As String = ASCII.GetString(Result)

                            DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
                            Return DOFile
                        Case "PDF"
                            Dim OutputStream As New MemoryStream
                            Dim ThumbStream As New FileStream(System.Windows.Forms.Application.StartupPath + "\..\Images\pdf.gif", FileMode.Open, FileAccess.Read, FileShare.Read)
                            Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                            Dim CustomMetadata As New Hashtable
                            CustomMetadata.Add("Date", Now.ToShortDateString)
                            Dim Result As Byte() = Vault.Store(ThumbStream, "thumb.gif", CustomMetadata)
                            OutputStream.Close()
                            Dim ObjectID As String = ASCII.GetString(Result)

                            DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
                            Return DOFile
                        Case "DOC"
                            Dim OutputStream As New MemoryStream
                            Dim ThumbStream As New FileStream(System.Windows.Forms.Application.StartupPath + "\..\Images\doc.gif", FileMode.Open, FileAccess.Read, FileShare.Read)
                            Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                            Dim CustomMetadata As New Hashtable
                            CustomMetadata.Add("Date", Now.ToShortDateString)
                            Dim Result As Byte() = Vault.Store(ThumbStream, "thumb.gif", CustomMetadata)
                            OutputStream.Close()
                            Dim ObjectID As String = ASCII.GetString(Result)

                            DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
                            Return DOFile
                    End Select
                End If
        End Select
    End Function


#End Region


    Private Function GetFileFromURL(ByVal URL As String) As Byte()
        Try
            If URL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As Int64 = URL.Substring(SQLSERVER_STORAGE.Length)
                Return Database.SelectBLOB(ID)

            ElseIf URL.StartsWith(FILE_STORAGE) Then
                Dim FilePath As String = URL.Substring(FILE_STORAGE.Length)
                Return FileProcessing.ReadBinaryFile(FilePath)

            ElseIf URL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = URL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return vault.Retrieve(ID)
            End If
        Catch ex As Exception
            MessageBox.Show(String.Format(InfoMessage("GeneDisseminations.OriginalFileNotAvailable"), URL), _
                            InfoMessage("GeneDisseminations.OriginalFileNotAvailable.Title"), MessageBoxButtons.OK, _
                            MessageBoxIcon.Warning)
        End Try
    End Function

    Private Function GetDimensionValue(ByVal Dimension As ProgramState.DisseminationDimension) As Integer
        Dim myProgramState As New ProgramState
        Select Case Dimension
            Case ProgramState.DisseminationDimension.Width
                Return myProgramState.DisseminationWidth
            Case ProgramState.DisseminationDimension.Height
                Return myProgramState.DisseminationHeight
            Case ProgramState.DisseminationDimension.Resolution
                Return myProgramState.DisseminationResolution
        End Select
    End Function

#End Region

#Region "Select"

    Private Sub LoadFile(ByVal FileID As Int64, ByVal Type As DOFile.Type, Optional ByVal LoadMetadata As Boolean = True)
        Try
            Dim DOFile As DOFile = Database.SelectDOFile(FileID)
            Select Case Type
                Case DOFile.Type.Original
                    LoadViewer(DOFile.OriginalURL, DOFile.Format)

                Case DOFile.Type.Dissemination
                    LoadViewer(DOFile.DisseminationURL, DOFile.Format)

                Case DOFile.Type.Thumbnail
                    LoadViewer(DOFile.ThumbnailURL, DOFile.Format)

            End Select
            If LoadMetadata Then
                LoadFileProperties(DOFile.ID, DOFile.Format.ToUpper)
                LoadFileMetadata(DOFile)
            End If
        Catch ex As Exception
            ShowImageNotAvailable()
            Return
        End Try
    End Sub

    Private Sub LoadFileProperties(ByVal FileID As Int64, ByVal Format As String)
        Dim Properties As Hashtable = Database.SelectProperties(FileID)
        Me.MetadataDataGrid.Clear()
        Dim Metadata As New Metadata(Me.MetadataDataGrid, Properties, Format, ProjectID)
    End Sub

    Private Sub LoadFileMetadata(ByVal DOFile As DOFile)
        Me.FileMetadataDataGrid.Clear()
        Me.FileMetadataDataGrid.AddSingleValueProperty(GetConfig("File.Properties.Name"), DOFile.Name, True, True)
        Me.FileMetadataDataGrid.AddSingleValueProperty(GetConfig("File.Properties.Format"), DOFile.Format, True, True)
        Me.FileMetadataDataGrid.AddSingleValueProperty(GetConfig("File.Properties.Length"), DOFile.Length, True, True)
        Me.FileMetadataDataGrid.AddSingleValueProperty(GetConfig("File.Properties.CreationDateTime"), DOFile.CreationDateTime, True, True)
        Me.FileMetadataDataGrid.AddSingleValueProperty(GetConfig("File.Properties.OriginalURL"), DOFile.OriginalURL, True, True)
        Me.FileMetadataDataGrid.AddSingleValueProperty(GetConfig("File.Properties.DisseminationURL"), DOFile.DisseminationURL, True, True)
        Me.FileMetadataPanel.Height = Me.FileMetadataDataGrid.ContainerHeigth
    End Sub

    Private Sub LoadViewer(ByVal URL As String, ByVal Format As String)
        Dim BLOB As Byte()
        Try
            If URL.Equals("") Then
                ShowImageNotAvailable()
                Return

            ElseIf URL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As Int64 = URL.Substring(SQLSERVER_STORAGE.Length)
                BLOB = Database.SelectBLOB(ID)

            ElseIf URL.StartsWith(FILE_STORAGE) Then
                Dim Filename As String = URL.Substring(FILE_STORAGE.Length)
                BLOB = FileProcessing.ReadBinaryFile(Filename)

            ElseIf File.Exists(URL) Then
                BLOB = FileProcessing.ReadBinaryFile(URL)

            ElseIf URL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = URL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                If Format.Equals("FLV") Or Format.Equals("MP3") Then
                    URL = String.Format("{0}?GET={1}", OBJECT_VAULT_SERVER_ADDRESS, ID)
                Else
                    BLOB = vault.Retrieve(ID)
                End If

            Else
                Return
            End If

            If Not myImageViewer Is Nothing Then
                myImageViewer.Close()
            End If
            If Not myPDFViewer Is Nothing Then
                myPDFViewer.Close()
            End If
            If Not myWordViewer Is Nothing Then
                myWordViewer.Close()
            End If
            If Not myVideoViewer Is Nothing Then
                myVideoViewer.Close()
            End If

            myImageViewer = New ImageViewer(BLOB, Format)
            myPDFViewer = New PDFViewer(BLOB, Format)
            myWordViewer = New WordViewer(BLOB, Format)
            myVideoViewer = New VideoViewer(URL, Format)

            If myImageViewer.CanDisplay() Then
                Me.PreviewPanel.Controls.Clear()
                myImageViewer.Dock = DockStyle.Fill
                Me.PreviewPanel.Controls.Add(myImageViewer)
                myImageViewer.Display()
            ElseIf myPDFViewer.CanDisplay() Then
                Me.PreviewPanel.Controls.Clear()
                myPDFViewer.Dock = DockStyle.Fill
                Me.PreviewPanel.Controls.Add(myPDFViewer)
                myPDFViewer.Display()
            ElseIf myWordViewer.CanDisplay() Then
                Me.PreviewPanel.Controls.Clear()
                myWordViewer.Dock = DockStyle.Fill
                Me.PreviewPanel.Controls.Add(myWordViewer)
                myWordViewer.Display()
            ElseIf myVideoViewer.CanDisplay() Then
                Me.PreviewPanel.Controls.Clear()
                myVideoViewer.Dock = DockStyle.Fill
                Me.PreviewPanel.Controls.Add(myVideoViewer)
                myVideoViewer.Display()
            Else
                ShowImageNotAvailable()
            End If
        Catch ex As Exception
            'MsgBox(ex.ToString)
            ShowImageNotAvailable()
        End Try
    End Sub

    Private Sub ShowImageNotAvailable()
        Dim BLOB As Byte() = FileProcessing.ReadBinaryFile(AppDomain.CurrentDomain.BaseDirectory & IMAGE_NOT_AVAILABLE_PATH)
        myImageViewer = New ImageViewer(BLOB, "")
        Me.PreviewPanel.Controls.Clear()
        myImageViewer.Dock = DockStyle.Fill
        Me.PreviewPanel.Controls.Add(myImageViewer)
        myImageViewer.Display()
    End Sub

    Private Function GetLargeImageList(ByVal tn As TreeNode, ByVal ExitLoop As Integer) As ImageList
        Dim Image As System.Drawing.Image
        Dim LargeImageList As New ImageList
        LargeImageList.ImageSize = Me.ListViewImageList.ImageSize
        tn = tn.Nodes(0)
        Do Until tn Is Nothing
            Try
                If IsFolder(tn) Then
                    Image = Me.ListViewImageList.Images(0)
                ElseIf IsDOFile(tn) Then
                    Dim DOFile As DOFile = Database.SelectDOFile(tn.Tag)
                    If DOFile.ThumbnailURL.StartsWith(SQLSERVER_STORAGE) Then
                        Dim ID As Int64 = DOFile.ThumbnailURL.Substring(SQLSERVER_STORAGE.Length)
                        Dim BLOB As Byte() = Database.SelectBLOB(ID)
                        Dim Stream As Stream = New MemoryStream(BLOB)
                        Image = PreserveAspectRatio(100, 100, Image.FromStream(Stream))

                    ElseIf DOFile.ThumbnailURL.StartsWith(OBJECTVAULT_STORAGE) Then
                        Dim ID As String = DOFile.ThumbnailURL.Substring(OBJECTVAULT_STORAGE.Length)
                        Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                        Dim BLOB As Byte() = vault.Retrieve(ID)
                        Dim Stream As Stream = New MemoryStream(BLOB)
                        Image = PreserveAspectRatio(100, 100, Image.FromStream(Stream))
                    End If
                    Else
                        Image = Me.ListViewImageList.Images(1)
                    End If
            Catch ex As Exception
                Image = Me.ListViewImageList.Images(1)
            End Try
            If Not Image Is Nothing Then
                LargeImageList.Images.Add(Image)
            End If
            tn = tn.NextNode
            ExitLoop -= 1
            If ExitLoop = 0 Then Exit Do
        Loop
        Return LargeImageList
    End Function


    ' Adds padding to the image to fill keep the aspect ratio
    Function PreserveAspectRatio(ByVal Width As Integer, ByVal Height As Integer, ByVal Image As System.Drawing.Image)
        Dim bmpImage As New Bitmap(Width, Height)
        Dim xoffset As Integer = 0
        Dim yoffset As Integer = 0
        If Image.Width < 100 AndAlso Image.Height < 100 Then
            yoffset = (Height - Image.Height) / 2
            xoffset = (Width - Image.Width) / 2
        End If
        If (Image.Width > Image.Height) Then
            yoffset = (Height - Image.Height) / 2
        Else
            xoffset = (Width - Image.Width) / 2
        End If

        Dim g As Graphics = Graphics.FromImage(bmpImage)
        g.DrawImage(Image, xoffset, yoffset, Width - xoffset * 2, Height - yoffset * 2)
        Return bmpImage
    End Function

#End Region

End Class
