
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Namespace MDA

    Public Class GeneFind
        Implements Gene

        Private myUnitId As String
        Private myUnitTitle As String
        Private myUnitDateInitial As String
        Private myUnitDateFinal As String


        Public Sub New(ByVal UnitId As String, ByVal UnitTitle As String, _
                       ByVal UnitDateInitial As String, ByVal UnitDateFinal As String)
            myUnitId = UnitId
            myUnitTitle = UnitTitle
            myUnitDateInitial = UnitDateInitial
            myUnitDateFinal = UnitDateFinal
        End Sub


        Public Function Apply(ByVal obj As LazyNode, ByVal ChildrenResults As Collection) As Object Implements Gene.Apply
            Dim Result As New LazyNodeCollection

            If myUnitId.Length = 0 And _
               myUnitTitle.Length = 0 And _
               myUnitDateInitial.Length = 0 And _
               myUnitDateFinal.Length = 0 _
               Then
                Return Result
            End If

            If Contains(obj.UnitId, myUnitId, True) AndAlso _
               Contains(obj.UnitTitle, myUnitTitle, True) AndAlso _
               Contains(obj.UnitDateInitial, myUnitDateInitial, True) AndAlso _
               Contains(obj.UnitDateFinal, myUnitDateFinal, True) _
            Then
                Result.Add(obj)
            End If


            Dim col As LazyNodeCollection
            For Each col In ChildrenResults
                Dim Node As LazyNode
                For Each Node In col
                    Result.Add(Node)
                Next
            Next
            Return Result
        End Function


        Private Function Contains(ByVal StrToSearch As String, ByVal WhatToSearch As String, ByVal NeutralValue As Boolean) As Boolean
            If WhatToSearch.Length = 0 Then Return NeutralValue
            Return StrToSearch.ToLower.IndexOf(WhatToSearch.ToLower) >= 0
        End Function

    End Class
End Namespace
