
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Definitions
Imports DigitArq.Utility
Imports DigitArq.UserControls
Imports DigitArq.Data.Entities.MDA

Public Class GeneInstalationUnitsList
    Inherits StopableGene

    Private myProgressDialog As ProgressDialog.ProgressDialog

    Public Sub New(ByVal ProgressDialog As ProgressDialog.ProgressDialog)
        myProgressDialog = ProgressDialog
    End Sub



    Public Overrides Function Apply(ByVal obj As LazyNode, ByVal ChildrenResults As Microsoft.VisualBasic.Collection) As Object
        Dim Result As New Hashtable
        Dim ChildInstalationUnits As LazyNodeCollection
        Dim InstalationUnit As LazyNode

        ChildInstalationUnits = GetChildInstalationUnits(obj)

        For Each InstalationUnit In ChildInstalationUnits
            Result = AppendToHashtable(Result, InstalationUnit, obj)
        Next

        Dim ChildResult As Hashtable
        For Each ChildResult In ChildrenResults
            Dim Key As LazyNode
            For Each Key In ChildResult.Keys
                Result = AppendToHashtable(Result, Key, CType(ChildResult.Item(Key), LazyNodeCollection))
            Next
        Next

        If Not myProgressDialog Is Nothing Then
            myProgressDialog.Message = String.Format(InfoMessage("CollectingData.ProgressBar.Progression"), obj.UnitId)
            myProgressDialog.Increment()
            Me.StopCatamorfism = myProgressDialog.Cancel

        End If

        Return Result
    End Function



    Private Function AppendToHashtable(ByVal Hash As Hashtable, ByVal Key As LazyNode, ByVal Value As LazyNode) As Hashtable
        Dim KeyNode As LazyNode = GetKeyNode(Hash.Keys, Key)
        If Not KeyNode Is Nothing Then
            Dim ParentsList As LazyNodeCollection = Hash.Item(KeyNode)
            ParentsList.Add(Value)
            'Hash.Add(KeyNode, ParentsList) ' Esta linha poder ser omitida?!!?!?
        Else
            Dim ParentsList As New LazyNodeCollection
            ParentsList.Add(Value)
            Hash.Add(Key, ParentsList)
        End If

        Debug.WriteLine("ADDED TO HASHTABLE " & Key.UnitId & " " & Value.UnitId)
        Return Hash
    End Function


    Private Function GetKeyNode(ByVal Nodes As ICollection, ByVal NodeToSearch As LazyNode) As LazyNode
        Dim Node As LazyNode
        For Each Node In Nodes
            If Node.OtherLevel.Equals(NodeToSearch.OtherLevel) AndAlso Node.UnitId.Equals(NodeToSearch.UnitId) Then Return Node
        Next
        Return Nothing
    End Function


    Private Function AppendToHashtable(ByVal Hash As Hashtable, ByVal Key As LazyNode, ByVal Values As LazyNodeCollection) As Hashtable
        Dim Node As LazyNode
        For Each Node In Values
            Hash = AppendToHashtable(Hash, Key, Node)
        Next
        Return Hash
    End Function



    Private Function GetChildInstalationUnits(ByVal Node As LazyNode) As LazyNodeCollection
        Dim ChildNode As LazyNode
        Dim Result As New LazyNodeCollection

        For Each ChildNode In Node.Children
            If ChildNode.OtherLevel = EAD.OTHERLEVEL_INSTALATIONUNIT Then
                Result.Add(ChildNode)
            End If
        Next
        Return Result
    End Function

End Class
