
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Text.RegularExpressions

Imports DigitArq.Utility.Config
Imports DigitArq.UserControls
Imports DigitArq.Data.Entities.MDA

Public Class GeneSearch
    Inherits StopableGene


    Private myProgressDialog As ProgressDialog.ProgressDialog
    Private myFieldName As String
    Private mySearchString As String
    Private myReplaceBy As String
    Private myRegExp As Boolean
    Private myCaseSensitive As Boolean
    Private CONTROLACCESS_FIELD_NAME As String = "ControlAccess"


    Public Sub New(ByVal ProgressDialog As ProgressDialog.ProgressDialog, ByVal FieldName As String, ByVal SearchString As String, ByVal CaseSensitive As Boolean, ByVal RegExp As Boolean)
        myProgressDialog = ProgressDialog
        myFieldName = FieldName
        mySearchString = SearchString
        myRegExp = RegExp
        myCaseSensitive = CaseSensitive
    End Sub


    Public Overrides Function Apply(ByVal obj As LazyNode, ByVal ChildrenResults As Collection) As Object
        Dim Ret As New LazyNodeCollection

        For Each col As LazyNodeCollection In ChildrenResults
            For Each Node As LazyNode In col
                Ret.Add(Node)
            Next
        Next

        If Me.StopCatamorfism Then Return Ret

        If Not myProgressDialog Is Nothing Then
            myProgressDialog.Message = String.Format(InfoMessage("Search.Progression"), obj.UnitId)
            myProgressDialog.Increment()
            Me.StopCatamorfism = myProgressDialog.Cancel
        End If

        'updated by lmferros
        If myFieldName = CONTROLACCESS_FIELD_NAME Then
            For Each cai As ControlAccessItem In obj.ControlAccess
                If isMatch(mySearchString, cai.Item, Not myCaseSensitive, myRegExp) Then
                    Ret.Add(obj)
                End If
            Next
        Else
            Dim SearchIn As String = CallByName(obj, myFieldName, CallType.Get)
            If isMatch(mySearchString, SearchIn, Not myCaseSensitive, myRegExp) Then
                Ret.Add(obj)
            End If
        End If

        Return Ret
    End Function


    Private Function isMatch(ByVal WhatToSearch As String, ByVal SearchIn As String, Optional ByVal IgnoreCase As Boolean = False, Optional ByVal RegExp As Boolean = False) As Boolean
        Dim myRegOptions As RegexOptions = RegexOptions.Multiline

        If IgnoreCase Then myRegOptions = myRegOptions Or RegexOptions.IgnoreCase
        If Not RegExp Then WhatToSearch = Regex.Escape(WhatToSearch)

        Return Regex.IsMatch(SearchIn, WhatToSearch, myRegOptions)
    End Function


End Class
